// ----------------------------------------------------------------------------
// 
// 		cwCu		`vO
// 
// 				Ver 3.11b
// 
// ----------------------------------------------------------------------------

// cwCu쐬p`
#define __DX_MAKE

// CN[h----------------------------------------------------------------
#include "DxGraphics.h"
#include "DxLib.h"
#include "DxStatic.h"
#include "DxFile.h"
#include "DxSound.h"
#include "DxGraphicsBase.h"
#include "DxGraphicsAPI.h"
#include "DxMask.h"
#include "DxMemImg.h"
#include "DxMath.h"
#include "DxFont.h"
#include "DxLog.h"
#include "DxASyncLoad.h"
#include "DxPixelShader.h"
#include "DxVertexShader.h"
#include "DxUseCLib.h"

#include "DxModel.h"

#include "DxBaseImage.h"
#include "DxMovie.h"
#include "DxInput.h"
#include "DxBaseFunc.h"
#include "DxSystem.h"
#include "DxMemory.h"

#ifdef __WINDOWS__
#include "Windows/DxWindow.h"
#endif // __WINDOWS__


namespace DxLib
{

// }N` -----------------------------------------------------------------

// RGBlPxőRGBlɕϊ邽߂̃{[eNX`̃TCY
#define RGBTOVMAXRGB_TEX_SIZE	(128)

// eNX`sNZtH[}bg̃rbgfvXCfbNX`
#define TEX_BITDEPTH_16				(0)
#define TEX_BITDEPTH_32 			(1)
#define PIXELBYTE( x )				( x == TEX_BITDEPTH_16 ? 2 : 4 )

// pbg摜̗L`FbN
#define PALETTEIMAGECHK( HAND, MEMIMG )														\
{																							\
	IMAGEDATA2 *Image2 ;																	\
																							\
	if( GRAPHCHK( ( HAND ), Image2 ) )														\
		return -1 ;																			\
	if( Image2->Orig->FormatDesc.TextureFlag ) return -1 ;									\
	MEMIMG = &Image2->Soft.MemImg;															\
	if( MEMIMG->Base->UsePalette == 0 ) return -1;											\
}


// OtBbNnh̗L`FbN
#define GRAPHCHKFULL( HAND, GPOINT )			HANDLECHKFULL(       DX_HANDLETYPE_GRAPH, HAND, *( ( HANDLEINFO ** )&GPOINT ) )
#define GRAPHCHKFULL_ASYNC( HAND, GPOINT )		HANDLECHKFULL_ASYNC( DX_HANDLETYPE_GRAPH, HAND, *( ( HANDLEINFO ** )&GPOINT ) )
#define GRAPHCHK( HAND, GPOINT )				HANDLECHK(           DX_HANDLETYPE_GRAPH, HAND, *( ( HANDLEINFO ** )&GPOINT ) )
#define GRAPHCHK_ASYNC( HAND, GPOINT )			HANDLECHK_ASYNC(     DX_HANDLETYPE_GRAPH, HAND, *( ( HANDLEINFO ** )&GPOINT ) )

// VF[_[nh̗L`FbN
#define SHADERCHK( HAND, SPOINT )				HANDLECHK(       DX_HANDLETYPE_SHADER, HAND, *( ( HANDLEINFO ** )&SPOINT ) )
#define SHADERCHK_ASYNC( HAND, SPOINT )			HANDLECHK_ASYNC( DX_HANDLETYPE_SHADER, HAND, *( ( HANDLEINFO ** )&SPOINT ) )

// _obt@nh̗L`FbN
#define VERTEXBUFFERCHK( HAND, SPOINT )			HANDLECHK(       DX_HANDLETYPE_VERTEX_BUFFER, HAND, *( ( HANDLEINFO ** )&SPOINT ) )
#define VERTEXBUFFERCHK_ASYNC( HAND, SPOINT )	HANDLECHK_ASYNC( DX_HANDLETYPE_VERTEX_BUFFER, HAND, *( ( HANDLEINFO ** )&SPOINT ) )

// CfbNXobt@nh̗L`FbN
#define INDEXBUFFERCHK( HAND, SPOINT )			HANDLECHK(       DX_HANDLETYPE_INDEX_BUFFER, HAND, *( ( HANDLEINFO ** )&SPOINT ) )
#define INDEXBUFFERCHK_ASYNC( HAND, SPOINT )	HANDLECHK_ASYNC( DX_HANDLETYPE_INDEX_BUFFER, HAND, *( ( HANDLEINFO ** )&SPOINT ) )

// DrawPreparation ĂԒ^
#define DRAWPREP_TEX( ORIG, TEX, FLAG )											\
	if( (ORIG)->FormatDesc.AlphaChFlag   ) FLAG |= DRAWPREP_TEXALPHACH ;		\
	if( (ORIG)->FormatDesc.AlphaTestFlag ) FLAG |= DRAWPREP_TEXALPHATEST ;		\
	if( GRH.DrawPrepAlwaysFlag != FALSE ||										\
		GRH.DrawPrepTexture    != (TEX) ||										\
		GRH.DrawPrepParamFlag  != FLAG )										\
		DrawPreparation( (TEX), FLAG ) ;										\
	if( GRH.UseAlphaChDrawShader )												\
	{																			\
		AlphaChDraw_Pre( &GRH.DrawRect ) ;										\
	}

#define DRAWPREP_NOTEX( FLAG )													\
	if( GRH.DrawPrepAlwaysFlag != FALSE ||										\
		GRH.DrawPrepTexture    != NULL ||										\
		GRH.DrawPrepParamFlag  != FLAG )										\
		DrawPreparation( NULL, FLAG ) ;											\
	if( GRH.UseAlphaChDrawShader )												\
	{																			\
		AlphaChDraw_Pre( &GRH.DrawRect ) ;										\
	}

// FVF̕ύX
#define SETFVF( type )	\
	if( GRH.SetFVF != ( type ) )\
	{\
		GraphicsDevice_SetFVF( ( type ) ) ;\
		GRH.SetFVF = ( type ) ;\
		GRH.SetVD = NULL;\
	}

// v~eBu̐Zo
#define GETPRIMNUM( primtype, vertnum )	\
	( ( (primtype) == D_D3DPT_TRIANGLELIST  ) ? (vertnum) / 3 :\
    ( ( (primtype) == D_D3DPT_LINELIST      ) ? (vertnum) / 2 :\
	( ( (primtype) == D_D3DPT_TRIANGLEFAN   ) ? (vertnum) - 2 :\
	( ( (primtype) == D_D3DPT_TRIANGLESTRIP ) ? (vertnum) - 2 :\
	( ( (primtype) == D_D3DPT_LINESTRIP     ) ? (vertnum) - 1 :\
	( ( (primtype) == D_D3DPT_POINTLIST     ) ? (vertnum)     : 0 ) ) ) ) ) )

#define RENDERVERTEX( NextUse3DVertex )	\
	{\
/*		if( GRH.Vertex3DNum != 0 )\
		{\
			SETFVF( VERTEXFVF_3D )\
			SetTransformToWorldHardware( &GlobalIdentMatrix ) ;\
			GraphicsDevice_DrawPrimitiveUP(\
				D_D3DPT_TRIANGLELIST,\
				GRH.Vertex3DNum / 3,\
				GRH.Tex3DVertexBuffer,\
				sizeof( VERTEX_3D ) ) ;\
			SetTransformToWorldHardware( &GBASE.WorldMatrix ) ;\
			GRH.Vertex3DNum = 0 ;\
			GRH.Vertex3DBufferNextAddress = GRH.Tex3DVertexBuffer ;\
		}*/\
\
		if( GRH.VertexNum != 0 )\
		{\
			SETFVF( D3DDev_VertexType[ GRH.Use3DVertex ][ GRH.VertexType ] )\
			if( GRH.Use3DVertex )\
			{\
				SetTransformToWorldHardware( &GlobalIdentMatrix ) ;\
			}\
			GraphicsDevice_DrawPrimitiveUP(\
				GRH.PrimitiveType,\
				GETPRIMNUM( GRH.PrimitiveType, GRH.VertexNum ),\
				GRH.VertexBufferPoint[ GRH.Use3DVertex ][ GRH.VertexType ],\
				D3DDev_VertexSize[ GRH.Use3DVertex ][ GRH.VertexType ] ) ;\
			if( GRH.Use3DVertex )\
			{\
				SetTransformToWorldHardware( &GBASE.WorldMatrix ) ;\
			}\
		}\
		GRH.VertexNum = 0 ;\
		GRH.VertexBufferNextAddress = GRH.VertexBufferPoint[ NextUse3DVertex ][ GRH.VertexType ] ;\
	}

#define GETVERTEX_QUAD( p )		\
	if(\
		  GRH.Use3DVertex != 0 ||\
		  GRH.PrimitiveType != D_D3DPT_TRIANGLELIST ||\
		  GRH.VertexNum + 6 >= D3DDev_VertexBuffer_MaxVertexNum[ GRH.Use3DVertex ][ GRH.VertexType ] /* { > ǁAGeForce 9800 GT ̕sΉ̂ >= ɂ */\
	  )\
	{\
		RENDERVERTEX( 0 )\
		GRH.Use3DVertex = 0 ;\
		GRH.PrimitiveType = D_D3DPT_TRIANGLELIST ;\
	}\
	*((DWORD_PTR *)&p) = (DWORD_PTR)GRH.VertexBufferNextAddress ;

#define GETVERTEX_BILLBOARD( p )		\
	if(\
		  GRH.Use3DVertex != 1 ||\
		  GRH.PrimitiveType != D_D3DPT_TRIANGLELIST ||\
		  GRH.VertexNum + 6 >= D3DDev_VertexBuffer_MaxVertexNum[ GRH.Use3DVertex ][ GRH.VertexType ] /* { > ǁAGeForce 9800 GT ̕sΉ̂ >= ɂ */\
	  )\
	{\
		RENDERVERTEX( 1 )\
		GRH.Use3DVertex = 1 ;\
		GRH.PrimitiveType = D_D3DPT_TRIANGLELIST ;\
	}\
	*((DWORD_PTR *)&p) = (DWORD_PTR)GRH.VertexBufferNextAddress ;

#define GETVERTEX_TRIANGLE( p )		\
	if(\
		  GRH.Use3DVertex != 0 ||\
		  GRH.PrimitiveType != D_D3DPT_TRIANGLELIST ||\
		  GRH.VertexNum + 3 >= D3DDev_VertexBuffer_MaxVertexNum[ GRH.Use3DVertex ][ GRH.VertexType ] /* { > ǁAGeForce 9800 GT ̕sΉ̂ >= ɂ */\
	  )\
	{\
		RENDERVERTEX( 0 )\
		GRH.Use3DVertex = 0 ;\
		GRH.PrimitiveType = D_D3DPT_TRIANGLELIST ;\
	}\
	*((DWORD_PTR *)&p) = (DWORD_PTR)GRH.VertexBufferNextAddress ;

#define GETVERTEX_TRIANGLE3D( p )		\
	if(\
		  GRH.Use3DVertex != 1 ||\
		  GRH.PrimitiveType != D_D3DPT_TRIANGLELIST ||\
		  GRH.VertexNum + 3 >= D3DDev_VertexBuffer_MaxVertexNum[ GRH.Use3DVertex ][ GRH.VertexType ] /* { > ǁAGeForce 9800 GT ̕sΉ̂ >= ɂ */\
	  )\
	{\
		RENDERVERTEX( 1 )\
		GRH.Use3DVertex = 1 ;\
		GRH.PrimitiveType = D_D3DPT_TRIANGLELIST ;\
	}\
	*((DWORD_PTR *)&p) = (DWORD_PTR)GRH.VertexBufferNextAddress ;

#define GETVERTEX_LINEBOX( p )		\
	if(\
		  GRH.Use3DVertex != 0 ||\
		  GRH.PrimitiveType != D_D3DPT_TRIANGLELIST ||\
		  GRH.VertexNum + 24 >= D3DDev_VertexBuffer_MaxVertexNum[ GRH.Use3DVertex ][ GRH.VertexType ] /* { > ǁAGeForce 9800 GT ̕sΉ̂ >= ɂ */\
	  )\
	{\
		RENDERVERTEX( 0 )\
		GRH.Use3DVertex = 0 ;\
		GRH.PrimitiveType = D_D3DPT_TRIANGLELIST ;\
	}\
	*((DWORD_PTR *)&p) = (DWORD_PTR)GRH.VertexBufferNextAddress ;

#define GETVERTEX_LINETRIANGLE( p )		\
	if(\
		  GRH.Use3DVertex != 0 ||\
		  GRH.PrimitiveType != D_D3DPT_LINELIST ||\
		  GRH.VertexNum + 6 >= D3DDev_VertexBuffer_MaxVertexNum[ GRH.Use3DVertex ][ GRH.VertexType ] /* { > ǁAGeForce 9800 GT ̕sΉ̂ >= ɂ */\
	  )\
	{\
		RENDERVERTEX( 0 )\
		GRH.Use3DVertex = 0 ;\
		GRH.PrimitiveType = D_D3DPT_LINELIST ;\
	}\
	*((DWORD_PTR *)&p) = (DWORD_PTR)GRH.VertexBufferNextAddress ;

#define GETVERTEX_LINETRIANGLE3D( p )		\
	if(\
		  GRH.Use3DVertex != 1 ||\
		  GRH.PrimitiveType != D_D3DPT_LINELIST ||\
		  GRH.VertexNum + 6 >= D3DDev_VertexBuffer_MaxVertexNum[ GRH.Use3DVertex ][ GRH.VertexType ] /* { > ǁAGeForce 9800 GT ̕sΉ̂ >= ɂ */\
	  )\
	{\
		RENDERVERTEX( 1 )\
		GRH.Use3DVertex = 1 ;\
		GRH.PrimitiveType = D_D3DPT_LINELIST ;\
	}\
	*((DWORD_PTR *)&p) = (DWORD_PTR)GRH.VertexBufferNextAddress ;

#define GETVERTEX_LINE( p )		\
	if(\
		  GRH.Use3DVertex == 1 ||\
		  GRH.PrimitiveType != D_D3DPT_LINELIST ||\
		  GRH.VertexNum + 2 >= D3DDev_VertexBuffer_MaxVertexNum[ GRH.Use3DVertex ][ GRH.VertexType ] /* { > ǁAGeForce 9800 GT ̕sΉ̂ >= ɂ */\
	  )\
	{\
		RENDERVERTEX( 0 )\
		GRH.Use3DVertex = 0 ;\
		GRH.PrimitiveType = D_D3DPT_LINELIST ;\
	}\
	*((DWORD_PTR *)&p) = (DWORD_PTR)GRH.VertexBufferNextAddress ;


#define GETVERTEX_LINE3D( p )		\
	if(\
		  GRH.Use3DVertex != 1 ||\
		  GRH.PrimitiveType != D_D3DPT_LINELIST ||\
		  GRH.VertexNum + 2 >= D3DDev_VertexBuffer_MaxVertexNum[ GRH.Use3DVertex ][ GRH.VertexType ] /* { > ǁAGeForce 9800 GT ̕sΉ̂ >= ɂ */\
	  )\
	{\
		RENDERVERTEX( 1 )\
		GRH.Use3DVertex = 1 ;\
		GRH.PrimitiveType = D_D3DPT_LINELIST ;\
	}\
	*((DWORD_PTR *)&p) = (DWORD_PTR)GRH.VertexBufferNextAddress ;


#define GETVERTEX_POINT( p )		\
	if(\
		  GRH.Use3DVertex != 0 ||\
		  GRH.PrimitiveType != D_D3DPT_POINTLIST ||\
		  GRH.VertexNum + 1 >= D3DDev_VertexBuffer_MaxVertexNum[ GRH.Use3DVertex ][ GRH.VertexType ] /* { > ǁAGeForce 9800 GT ̕sΉ̂ >= ɂ */\
	  )\
	{\
		RENDERVERTEX( 0 )\
		GRH.Use3DVertex = 0 ;\
		GRH.PrimitiveType = D_D3DPT_POINTLIST ;\
	}\
	*((DWORD_PTR *)&p) = (DWORD_PTR)GRH.VertexBufferNextAddress ;

#define GETVERTEX_POINT3D( p )		\
	if(\
		  GRH.Use3DVertex != 1 ||\
		  GRH.PrimitiveType != D_D3DPT_POINTLIST ||\
		  GRH.VertexNum + 1 >= D3DDev_VertexBuffer_MaxVertexNum[ GRH.Use3DVertex ][ GRH.VertexType ] /* { > ǁAGeForce 9800 GT ̕sΉ̂ >= ɂ */\
	  )\
	{\
		RENDERVERTEX( 1 )\
		GRH.Use3DVertex = 1 ;\
		GRH.PrimitiveType = D_D3DPT_POINTLIST ;\
	}\
	*((DWORD_PTR *)&p) = (DWORD_PTR)GRH.VertexBufferNextAddress ;

#define ADD4VERTEX_POINT		\
		GRH.VertexBufferNextAddress += sizeof( VERTEX_NOTEX_2D ) ;	\
		GRH.VertexNum ++ ;

#define ADD4VERTEX_POINT3D		\
		GRH.VertexBufferNextAddress += sizeof( VERTEX_NOTEX_3D ) ;	\
		GRH.VertexNum ++ ;
/*
#define ADD4VERTEX_LINEBOX			\
		GRH.VertexBufferNextAddress += sizeof( VERTEX_NOTEX_2D ) * 8 ;	\
		GRH.VertexNum += 8 ;
*/
#define ADD4VERTEX_LINEBOX			\
		GRH.VertexBufferNextAddress += sizeof( VERTEX_NOTEX_2D ) * 24 ;	\
		GRH.VertexNum += 24 ;

#define ADD4VERTEX_LINETRIANGLE		\
		GRH.VertexBufferNextAddress += sizeof( VERTEX_NOTEX_2D ) * 6 ;	\
		GRH.VertexNum += 6 ;

#define ADD4VERTEX_LINETRIANGLE3D		\
		GRH.VertexBufferNextAddress += sizeof( VERTEX_NOTEX_3D ) * 6 ;	\
		GRH.VertexNum += 6 ;

#define ADD4VERTEX_LINE			\
		GRH.VertexBufferNextAddress += sizeof( VERTEX_NOTEX_2D ) * 2 ;	\
		GRH.VertexNum += 2 ;

#define ADD4VERTEX_LINE3D		\
		GRH.VertexBufferNextAddress += sizeof( VERTEX_NOTEX_3D ) * 2 ;	\
		GRH.VertexNum += 2 ;

#define ADD4VERTEX_NOTEX		\
		GRH.VertexBufferNextAddress += sizeof( VERTEX_NOTEX_2D ) * 6 ;	\
		GRH.VertexNum += 6 ;

#define ADD4VERTEX_TEX			\
		GRH.VertexBufferNextAddress += sizeof( VERTEX_2D ) * 6 ;	\
		GRH.VertexNum += 6 ;

#define ADD4VERTEX_BLENDTEX		\
		GRH.VertexBufferNextAddress += sizeof( VERTEX_BLENDTEX_2D ) * 6 ;	\
		GRH.VertexNum += 6 ;

#define ADD3VERTEX_NOTEX		\
		GRH.VertexBufferNextAddress += sizeof( VERTEX_NOTEX_2D ) * 3 ;	\
		GRH.VertexNum += 3 ;

#define ADD3VERTEX_NOTEX3D		\
		GRH.VertexBufferNextAddress += sizeof( VERTEX_NOTEX_3D ) * 3 ;	\
		GRH.VertexNum += 3 ;

#define ADD4VERTEX_BILLBOARD		\
		GRH.VertexBufferNextAddress += sizeof( VERTEX_3D ) * 6 ;	\
		GRH.VertexNum += 6 ;

// eNX`[̕L̍őTCYƍŏTCY
#define MAX_TEXTURE_SIZE			(2048)
#define MIN_TEXTURE_SIZE			(1)

// eNX`[sŏTCY
#define DIVTEXTURE_MINSIZE			(32)

// foCX̍őEŏ̃eNX`TCY擾
// łȂɐݒ肷TCY
#define DEFAULT_MAXTEXTURE_SIZE		(256)
#define DEFAULT_MINTEXTURE_SIZE		(8)

// ǗeNX`ւ̃f[^]pVXezueNX`̓tH[}bg̍ő吔
#define SYSMEMTEXTURE_ONE_FORMAT_NUM	(16)

// _obt@Ɋi[ł钸_̍ő吔̃e[u[ 0:Qc_  1:Rc_ ]
static const int D3DDev_VertexBuffer_MaxVertexNum[ 2 ][ VERTEXTYPE_NUM ] =
{
	D3DDEV_NOTEX_VERTMAXNUM,
	D3DDEV_TEX_VERTMAXNUM, 
	D3DDEV_BLENDTEX_VERTMAXNUM,

	D3DDEV_NOTEX_3D_VERTMAXNUM,
	D3DDEV_TEX_3D_VERTMAXNUM, 
} ;

// _\̒`̃e[u[ 0:Qc_  1:Rc_ ]
static const DWORD D3DDev_VertexType[ 2 ][ VERTEXTYPE_NUM ] =
{
	VERTEXFVF_NOTEX_2D,
	VERTEXFVF_2D,
	VERTEXFVF_BLENDTEX_2D,

	VERTEXFVF_NOTEX_3D,
	VERTEXFVF_3D
} ;

// _̃TCỸe[u[ 0:Qc_  1:Rc_ ]
static const int D3DDev_VertexSize[ 2 ][ VERTEXTYPE_NUM ] =
{
	sizeof( VERTEX_NOTEX_2D ),
	sizeof( VERTEX_2D ),
	sizeof( VERTEX_BLENDTEX_2D ),

	sizeof( VERTEX_NOTEX_3D ),
	sizeof( VERTEX_3D ),
} ;

static MATRIX GlobalIdentMatrix =
{
	1.0f, 0.0f, 0.0f, 0.0f,
	0.0f, 1.0f, 0.0f, 0.0f,
	0.0f, 0.0f, 1.0f, 0.0f,
	0.0f, 0.0f, 0.0f, 1.0f
} ;

// 8x8  tgaeNX`
static BYTE WhiteTga8x8TextureFileImage[ 84 ] = 
{
	0x00, 0x00, 0x0A, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x00, 0x08, 0x00,
	0x20, 0x08, 0x87, 0xFF, 0xFF, 0xFF, 0xFF, 0x87, 0xFF, 0xFF, 0xFF, 0xFF, 0x87, 0xFF, 0xFF, 0xFF,
	0xFF, 0x87, 0xFF, 0xFF, 0xFF, 0xFF, 0x87, 0xFF, 0xFF, 0xFF, 0xFF, 0x87, 0xFF, 0xFF, 0xFF, 0xFF,
	0x87, 0xFF, 0xFF, 0xFF, 0xFF, 0x87, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x54, 0x52, 0x55, 0x45, 0x56, 0x49, 0x53, 0x49, 0x4F, 0x4E, 0x2D, 0x58, 0x46, 0x49,
	0x4C, 0x45, 0x2E, 0x00
} ;

// VF[_[oCiz
extern BYTE DxShaderCodeBin_Model[] ;
extern BYTE DxShaderCodeBin_Filter[] ;
extern BYTE DxShaderCodeBin_Base[] ;
extern BYTE DxShaderCodeBin_RgbaMix[] ;

// \̐錾 -----------------------------------------------------------------

// CuOɗpӂVF[_[R[h֐p̃Cu̐ݒꎞIɑޔ邽߂Ɏg\
struct LIBSHADER_DRAWPARAMTEMP
{
	DX_DIRECT3DSURFACE9 *TargetSurface[ DX_RENDERTARGET_COUNT ] ;
	DX_DIRECT3DSURFACE9 *DepthStencilSurfaece ;
	int BlendMode, BlendParam ;
	int AlphaTestMode, AlphaTestParam ;
	int UseZBufferFlag3D ;
	int DrawMode ;
	int FogEnable ;
	int LightEnable ;

	int UserSetVertexShaderHandle ;
	int UserSetPixelShaderHandle ;
	int UserSetTextureGraphHandle[ 8 ] ;
	int TextureNum ;
} ;

// f[^` -----------------------------------------------------------------

GRAPHICSMANAGE2 GraphicsManage2 ;

// ֐錾 -------------------------------------------------------------------

extern int CreateSubBackBufferSurface() ;										// ScreenCopy  GetDrawScreen 邽߂Ɏgpe|obt@̍쐬( 0:  -1:s )

static int ShaderCodeSetup() ;													// VF[_[R[h̃ZbgAbvs
static int ShaderCodeTerminate() ;												// VF[_[R[ȟns
static int MemLoadShaderCode( const char *ShaderName, bool IsVertexShader ) ;	// w薼̎OpӃVF[_[ǂݍ

static int DeleteDeviceLostDeleteGraph( void ) ;								// foCXXgɍ폜tOĂOtBbN폜
static int SetupSubBackBuffer() ;												// TuobNobt@gp鏀s( 0:  -1:s )
static int ListUpTexSize( int Size, short *SizeList, int NotDivFlag, int Pow2Flag, int MaxTextureSize ) ;		// w̃eNX`[TCY肭
static int InitializeDerivationGraphHandle( int GrHandle, int SrcX, int SrcY, int Width, int Height, int SrcGrHandle, int ASyncThread = FALSE ) ;			// w蕔𔲂oOtBbNnh
static int InitializeGraphDrawInfo( int GrHandle, int ASyncThread = FALSE ) ;			// OtBbNnh̕`
static int CreateOrigTexture( IMAGEDATA2_ORIG *Orig, int ASyncThread = FALSE ) ;		// IWi摜񒆂̃eNX`쐬( 0:  -1:s )
static int ReleaseOrigTexture( IMAGEDATA2_ORIG *Orig ) ;						// IWi摜񒆂̃eNX`
static int CreateOrigZBuffer( IMAGEDATA2_ORIG *Orig ) ;							// IWi摜񒆂̂yobt@쐬
static int ReleaseOrigZBuffer( IMAGEDATA2_ORIG *Orig ) ;						// IWi摜񒆂̂yobt@J
static int CreateDirect3DVertexBufferObject( VERTEXBUFFERHANDLEDATA *VertexBuffer ) ;	// _obt@nhp Direct3DVertexBuffer9 IuWFNg쐬
static int ReleaseDirect3DVertexBufferObject( VERTEXBUFFERHANDLEDATA *VertexBuffer ) ;	// _obt@nhp Direct3DVertexBuffer9 IuWFNg
static int CreateDirect3DIndexBufferObject( INDEXBUFFERHANDLEDATA *IndexBuffer ) ;		// CfbNXobt@nhp Direct3DIndexBuffer9 IuWFNg쐬
static int ReleaseDirect3DIndexBufferObject( INDEXBUFFERHANDLEDATA *IndexBuffer ) ;		// CfbNXobt@nhp Direct3DIndexBuffer9 IuWFNg
static int ReleaseOrigDirectXObjectAll() ;										// OtBbNnhׂĂ DirectX IuWFNg
static int AllocOrigDirectXObjectAll() ;										// OtBbNnhׂĂ DirectX IuWFNg擾
static  D_D3DVERTEXELEMENT9	MakeVertexElement9( BYTE Stream, BYTE Offset, BYTE Type, BYTE Method, BYTE Usage, BYTE UsageIndex ) ;
static int CheckMultiSampleParam( D_D3DFORMAT Format, D_D3DMULTISAMPLE_TYPE *Samples, DWORD *Quality, int SamplesFailedBreak, int ASyncThread = FALSE ) ;	// }`Tv_ÕTvƃNIeB`FbN
static int GetSysMemTexture( int CubeMap, int Width, int Height, int MipMapCount, int Format, int ASyncThread ) ;					// ǗeNX`ւ̓]p̃VXeeNX`擾
static int GetSysMemTextureFromOrig( IMAGEDATA2_ORIG *Orig, IMAGEDATA2_ORIG_HARD_TEX *OrigTex, int ASyncThread = FALSE ) ;	// IMAGEDATA2_ORIG  IMAGEDATA2_ORIG_HARD_TEX ̏ GetSysMemTexture gp
static int CreateSysMemTextureDirect3D9Texture( IMAGEDATA2_SYSMEMTEXTURE *MemTex ) ;					// \̂̃f[^ɓ]p̃VXeeNX`쐬
static int ReleaseSysMemTexture( int Index, int ASyncThread = FALSE ) ;					// ǗeNX`ւ̓]p̃VXeeNX`̎擾
static int ReleaseSysMemTextureAll( void ) ;											// ǗeNX`ւ̓]p̃VXeeNX`ׂĉ
static int UpdateDrawTexture( IMAGEDATA2_ORIG_HARD_TEX *OrigTex, int TargetSurface ) ;	// `peNX`ƕ`peNX`ĂꍇɁA`peNX`ɕ`peNX`̓e𔽉f
static int CheckMultiSampleDrawValidGraph( int GrHandle ) ;								// lr``gp`\摜ǂ𒲂ׂ( TRUE:MSAA摜  FALSE:MSAA摜ł͂Ȃ )
static int SetupFormatDesc( IMAGEFORMATDESC *Format, SETUP_GRAPHHANDLE_GPARAM *GParam, int Width, int Height, int AlphaValidFlag, int UsePaletteFlag, int BaseFormat, int MipMapCount ) ; // OtBbNnhɉ摜f[^]邽߂̊֐
static int RefreshAlphaChDrawMode( void ) ;												// `ɐlނǂ̃tOXV

static int BltBmpOrBaseImageToGraph3(
	const COLORDATA	*BmpColorData,
	      HBITMAP	RgbBmp,
	      HBITMAP	AlphaBmp,
	const RECT		*SrcRect,
	      int		DestX,
	      int		DestY,
	      int		GrHandle,
	      int		BmpFlag,
	const BASEIMAGE	*RgbImage,
	const BASEIMAGE	*AlphaImage,
	      int		RedIsAlphaFlag = FALSE,
	      int		UseTransColorConvAlpha = TRUE,
	      int		TargetOrig = FALSE,
	      int		ASyncThread = FALSE
) ;
static int BltBmpOrBaseImageToGraph3_MipMapBlt(
	IMAGEDATA2_ORIG			*Orig,
	const RECT				*SrcRect,
	const RECT				*DestRect,
	DX_DIRECT3DBASETEXTURE9	*UseTex,
	int						TexWidth,
	int						TexHeight,
	const BASEIMAGE			*RgbImage,
	const BASEIMAGE			*AlphaImage,
	const COLORDATA			*DestColor,
	int						RedIsAlphaFlag,
	int						UseTransColorConvAlpha,
	int						ASyncThread = FALSE
) ;
static int BltBmpOrBaseImageToGraph3_NoMipMapBlt(
	IMAGEDATA2_ORIG			*Orig,
	const RECT				*SrcRect,
	const RECT				*DestRect,
	DX_DIRECT3DBASETEXTURE9	*UseTex,
	int						TexWidth,
	int						TexHeight,
	int						TexUseWidth,
	int						TexUseHeight,
	const BASEIMAGE			*RgbImage,
	const BASEIMAGE			*AlphaImage,
	const COLORDATA			*DestColor,
	int						RedIsAlphaFlag,
	int						UseTransColorConvAlpha,
	int						ASyncThread = FALSE
) ;

#ifndef DX_NON_MOVIE

static void UpdateGraphMovie( MOVIEGRAPH *Movie, DWORD_PTR GrHandle ) ;				// [r[摜XV

#endif


// `\摜obNobt@ẅ̃OtBbN擾
extern	int GetDrawScreenGraphBase( int TargetScreen, int TargetScreenSurface, int x1, int y1, int x2, int y2, int destX, int destY, int GrHandle ) ;

// \tgEGA_On֐
static int	InitializeSoftware() ;							// \tgEGA_Ȍs
static int	TerminateSoftware() ;							// \tgEGA_Ǒns

// n[hEGAANZ[^n֐
			static int  InitializeHardware() ;														// n[hEGAANZ[^֌W̏
			static int	ReInitializeHardware() ;													// ꎞIɃn[hEGAjۂɁAjȌԂo߂̊֐
			static int  SetBaseHardwareState() ;													// cRcc{ݒ
			static int  RefreshBlendStateHardware( DIRECT3DBLENDINFO *pUserInfo = NULL, int TextureStageIsTextureAndTextureCoordOnlyFlag = FALSE, int TextureIsGraphHandleFlag = TRUE ) ;	// uhݒXV(Direct3D ɔf)
			static int  SetDrawModeHardware( int DrawMode ) ;										// `惂[h̃Zbg
			static int  SetMaxAnisotropyHardware( int MaxAnisotropy ) ;								// őٕ̃Zbg
			static int  SetDrawBlendModeHardware( int BlendMode, int AlphaTestValidFlag, int AlphaChannelValidFlag ) ;	// `uh[h̐ݒ
			static int	SetIgnoreDrawGraphColorHardware( int EnableFlag ) ;							// `掞̉摜̐F𖳎邩ǂݒ肷
			static int  SetDrawAlphaTestHardware( int TestMode, int TestParam ) ;					// At@eXg̐ݒ
//			static int  SetRenderTargetHardware( DX_DIRECT3DSURFACE9 * TargetSurface, int TargetIndex = 0 ) ;	// `Ώۂ̕ύX
			static int  SetUseZBufferHardware( int Flag ) ;											// yobt@̗L̃Zbg
			static int  SetWriteZBufferHardware( int Flag ) ;										// yobt@݂̗̏LZbg
			static int  SetZBufferCmpTypeHardware( int CmpType ) ;									// yl̔r^CvZbg
			static int  SetZBiasHardware( int Bias ) ;												// yoCAXZbg
			static int	SetFillModeHardware( int FillMode ) ;										// tB[hZbg
__inline	static int  SetTextureHardware( DX_DIRECT3DTEXTURE9 *RenderTexture ) ;					// eNX`Zbg 
__inline	static int  SetBlendTextureHardware( DX_DIRECT3DTEXTURE9 *BlendTexture, int TexWidth = -1, int TexHeight = -1 ) ;	// uheNX`Zbg 
__inline	static int  SetBlendTextureParamHardware( int BlendType, int *Param ) ;					// uheNX`̃p[^Zbg
			static int  SetUseDiffuseAlphaColorFlagHardware( int UseFlag ) ;						// fBt[YJ[̃lgp邩ǂtOZbg
			static int  SetUseDiffuseRGBColorFlagHardware( int UseFlag ) ;							// fBt[YJ[̂qfalgp邩ǂtOZbg
			static void RefreshRenderStateHardware() ;												// `ݒtbV
			static int  SetTransformToWorldHardware( const MATRIX *Matrix ) ;						// [hϊpsZbg
			static int  SetTransformToViewHardware( const MATRIX *Matrix ) ;						// r[ϊpsZbg
			static int  SetTransformToProjectionHardware( const MATRIX *Matrix ) ;					// eϊpsZbg
			static int  SetLightHardware( int LightNumber, LIGHT *Light ) ;							// Cg̃Zbg
			static int  SetLightEnableHardware( int LightNumber, int EnableState ) ;				// Cg̗LAύX
			static int  SetMaterialHardware( MATERIAL *Material ) ;									// }eÃZbg
			static int	SetUseSpecularHardware( int UseFlag ) ;										// XyLgp邩ǂZbg
			static int	SetMaterialUseVertexDiffuseColorHardware( int UseFlag ) ;					// _̃fBt[YJ[}eÃfBt[YJ[ƂĎgp邩ǂݒ肷
			static int	SetMaterialUseVertexSpecularColorHardware( int UseFlag ) ;					// _̃XyLJ[}eÃXyLJ[ƂĎgp邩ǂݒ肷
			static int  SetUseCullingHardware( int State ) ;										// JO̗LZbg 
			static int  SetAmbientColorHardware( int Color ) ;										// ArGgJ[̃Zbg
			static int  SetShadeModeHardware( int ShadeMode ) ;										// VF[fBO[h̃Zbg
			static int  SetTextureAddressHardware( int AddressMode, int Stage = -1 ) ;				// eNX`[̃AhbVO[hZbg
			static int  SetTextureAddressUHardware( int AddressMode, int Stage = -1 ) ;				// eNX`[̃AhbVO[hZbg
			static int  SetTextureAddressVHardware( int AddressMode, int Stage = -1 ) ;				// eNX`[̃AhbVO[hZbg
			static int  SetTextureAddressWHardware( int AddressMode, int Stage = -1 ) ;				// eNX`[̃AhbVO[hZbg
			static int	SetTextureAddressTransformMatrixHardware( int Use, MATRIX *Matrix, int Stage = -1 ) ;	// eNX`WϊsZbg
			static int	SetFogEnableHardware( int Flag ) ;											// tHOLɂ邩ǂݒ肷( TRUE:L  FALSE: )
			static int	SetFogModeHardware( int Mode /* DX_FOGMODE_NONE  */ ) ;					// tHO[hݒ肷
			static int	SetFogColorHardware( DWORD Color ) ;										// tHOJ[ύX
			static int	SetFogStartEndHardware( float Start, float End ) ;							// tHOn܂鋗ƏI鋗ݒ肷( 0.0f ` 1.0f )
			static int	SetFogDensityHardware( float Density ) ;									// tHO̖xݒ肷( 0.0f ` 1.0f )
			static int  SetUseLightFlagHardware( int LightFlag ) ;									// Cg̗LtOZbg
			static int  SetPlaneVertexHardware( VERTEX_2D *GraphVert, int xnum, int ynum ) ;		// QzIɔzuꂽ_f[^𒸓_obt@ɒǉ
			static int  SetViewportHardware( D_D3DVIEWPORT9 *Viewport ) ;							// r[|[gZbg
			extern int	SetViewportHardwareEasy( int x1, int y1, int x2, int y2 ) ;					// r[|[gZbg( ȈՔ )
			static int	SetScissorRectHardware( RECT *Rect ) ;										// VU[`ݒ肷
			static int	SetScissorTestEnableHardware( int Enable ) ;								// VU[`Lɂ邩ǂݒ
			static int	SetEdgeFontDrawFlagHardware( int EdgeFontFlag ) ;							// ttHg`sǂݒ
            //extern int	RenderVertexHardware() ;													// _obt@ɗ܂_f[^_O
			static void FASTCALL DrawPreparation( DX_DIRECT3DTEXTURE9 *Texture = NULL, int ParamFlag = 0 ) ;	// `揀s
			static void RefreshAmbientAndEmissiveParam() ;											// ArGgCgƃG~bVuJ[|킹p[^XV
			static void RefreshUseShaderIndex() ;													// gpVF[_[̃CfbNX̒lXV

__inline	static DWORD GetDiffuseColor( void )															// ݂̃fBt[YJ[𓾂
			{
				return  ( GBASE.DrawBright.Red   << 16 ) |
						( GBASE.DrawBright.Green << 8  ) |
						( GBASE.DrawBright.Blue        ) |
						( ( ( GBASE.BlendMode != DX_BLENDMODE_NOBLEND || GBASE.UseNoBlendModeParam ) ? GBASE.BlendParam : 255 ) << 24 ) ;
			}
__inline static int CheckBlendGraphSize( IMAGEDATA2 *GraphData ) ;											// uh摜Ƃ̑傫`FbN
__inline static void _VectorTransformToBillboard( VECTOR *Vector, VECTOR *Position ) ;						// r{[hp̍svZ

static void DefaultRestoreGraphFunction( void ) ;		// ftHg̃OtBbN֐

#ifndef DX_NON_FILTER

// Opӂ̃VF[_[p
static void LibShader_PushBaseDrawParam( LIBSHADER_DRAWPARAMTEMP *DrawParamTemp ) ;
static void LibShader_PopBaseDrawParam( LIBSHADER_DRAWPARAMTEMP *DrawParamTemp ) ;
static void LibShader_PushShaderParam( LIBSHADER_DRAWPARAMTEMP *DrawParamTemp, int TextureNum ) ;
static void LibShader_PopShaderParam( LIBSHADER_DRAWPARAMTEMP *DrawParamTemp ) ;

struct GRAPHFILTER_INFO
{
	int IsBlend ;
	int FilterOrBlendType ;
	int SrcGrHandle ;
	int BlendGrHandle ;
	int DestGrHandle ;
	float BlendRatio ;
	int Pass ;
	int SrcX1 ;
	int SrcY1 ;
	int SrcX2 ;
	int SrcY2 ;
	int BlendX ;
	int BlendY ;
	int BlendPosEnable ;
	int DestX ;
	int DestY ;

	int DestWidth ;
	int DestHeight ;
	BASEIMAGE SrcImage ;
	BASEIMAGE BlendImage ;
	BASEIMAGE DestImage ;
} ;
static int	GraphFilterDestGraphSetup( GRAPHFILTER_INFO *Info, int PassNum, int UseWorkScreen, int *UseSrcGrHandle, int *UseDestGrHandle ) ;
static int	GraphFilterDestGraphUpdate( GRAPHFILTER_INFO *Info, int UseWorkScreen, int UseDestGrHandle, int FilterResult ) ;
static int	GraphFilter_BasePolygonDraw( GRAPHFILTER_INFO *Info, int ScaleDivNum = 1 ) ;
static int	GraphFilter_GetSoftImage( int GrHandle, BASEIMAGE *BaseImage, RECT *GetRect = NULL ) ;
static int	GraphFilter_SoftImageSetup( GRAPHFILTER_INFO *Info, int DestDiscard = TRUE, int DestWidth = -1, int DestHeight = -1 ) ;
static int	GraphFilter_SoftImageTerminate( GRAPHFILTER_INFO *Info ) ;

static int GraphFilterPassNum_Table[DX_GRAPH_FILTER_NUM] =
{
		1,		// DX_GRAPH_FILTER_MONO
		2,		// DX_GRAPH_FILTER_GAUSS
		1,		// DX_GRAPH_FILTER_DOWN_SCALE
		1,		// DX_GRAPH_FILTER_BRIGHT_CLIP
		2,		// DX_GRAPH_FILTER_HSB
		1,		// DX_GRAPH_FILTER_INVERT
		1,		// DX_GRAPH_FILTER_LEVEL
		1,		// DX_GRAPH_FILTER_TWO_COLOR
		1,		// DX_GRAPH_FILTER_GRADIENT_MAP
		1,		// DX_GRAPH_FILTER_PREMUL_ALPHA
		1,		// DX_GRAPH_FILTER_INTERP_ALPHA
};
static int GraphFilterUseWorkScreen_Table[DX_GRAPH_FILTER_NUM] =
{
		0,		// DX_GRAPH_FILTER_MONO
		1,		// DX_GRAPH_FILTER_GAUSS
		0,		// DX_GRAPH_FILTER_DOWN_SCALE
		0,		// DX_GRAPH_FILTER_BRIGHT_CLIP
		0,		// DX_GRAPH_FILTER_HSB
		0,		// DX_GRAPH_FILTER_INVERT
		0,		// DX_GRAPH_FILTER_LEVEL
		0,		// DX_GRAPH_FILTER_TWOCOLOR
		0,		// DX_GRAPH_FILTER_GRADIENT_MAP
		0,		// DX_GRAPH_FILTER_PREMUL_ALPHA
		0,		// DX_GRAPH_FILTER_INTERP_ALPHA
};
static int	GraphFilter_Mono(        GRAPHFILTER_INFO *Info, float Cb, float Cr ) ;
static int	GraphFilter_Gauss(       GRAPHFILTER_INFO *Info, int PixelWidth, float Param ) ;
static int	GraphFilter_Down_Scale(  GRAPHFILTER_INFO *Info, int DivNum ) ;
static int	GraphFilter_Bright_Clip( GRAPHFILTER_INFO *Info, int CmpType, float CmpParam, int ClipFillFlag, COLOR_F *ClipFillColor ) ;
static int	GraphFilter_HSB(         GRAPHFILTER_INFO *Info, int HueType, float Hue, float Saturation, float Bright ) ;
static int	GraphFilter_Invert(      GRAPHFILTER_INFO *Info ) ;
static int	GraphFilter_Level(       GRAPHFILTER_INFO *Info, float Min, float Max, float Gamma, float AfterMin, float AfterMax ) ;
static int	GraphFilter_TwoColor(    GRAPHFILTER_INFO *Info, float Threshold, COLOR_F *LowColor, COLOR_F *HighColor ) ;
static int	GraphFilter_GradientMap( GRAPHFILTER_INFO *Info, int MapGrHandle, int Reverse ) ;
static int	GraphFilter_PremulAlpha( GRAPHFILTER_INFO *Info ) ;
static int	GraphFilter_InterpAlpha( GRAPHFILTER_INFO *Info ) ;

static int GraphBlendPassNum_Table[DX_GRAPH_BLEND_NUM] =
{
		1,		// DX_GRAPH_BLEND_NORMAL
		1,		// DX_GRAPH_BLEND_RGBA_SELECT_MIX
		1,		// DX_GRAPH_BLEND_MULTIPLE
		1,		// DX_GRAPH_BLEND_DIFFERENCE
		1,		// DX_GRAPH_BLEND_ADD
		1,		// DX_GRAPH_BLEND_SCREEN
		1,		// DX_GRAPH_BLEND_OVERLAY
		1,		// DX_GRAPH_BLEND_DODGE
		1,		// DX_GRAPH_BLEND_BURN
		1,		// DX_GRAPH_BLEND_DARKEN
		1,		// DX_GRAPH_BLEND_LIGHTEN
		1,		// DX_GRAPH_BLEND_SOFTLIGHT
		1,		// DX_GRAPH_BLEND_HARDLIGHT
		1,		// DX_GRAPH_BLEND_EXCLUSION
		1,		// DX_GRAPH_BLEND_NORMAL_ALPHACH
		1,		// DX_GRAPH_BLEND_ADD_ALPHACH
		1,		// DX_GRAPH_BLEND_MULTIPLE_A_ONLY
};
static int GraphBlendUseWorkScreen_Table[DX_GRAPH_BLEND_NUM] =
{
		0,		// DX_GRAPH_BLEND_NORMAL
		0,		// DX_GRAPH_BLEND_RGBA_SELECT_MIX
		0,		// DX_GRAPH_BLEND_MULTIPLE
		0,		// DX_GRAPH_BLEND_DIFFERENCE
		0,		// DX_GRAPH_BLEND_ADD
		0,		// DX_GRAPH_BLEND_SCREEN
		0,		// DX_GRAPH_BLEND_OVERLAY
		0,		// DX_GRAPH_BLEND_DODGE
		0,		// DX_GRAPH_BLEND_BURN
		0,		// DX_GRAPH_BLEND_DARKEN
		0,		// DX_GRAPH_BLEND_LIGHTEN
		0,		// DX_GRAPH_BLEND_SOFTLIGHT
		0,		// DX_GRAPH_BLEND_HARDLIGHT
		0,		// DX_GRAPH_BLEND_EXCLUSION
		0,		// DX_GRAPH_BLEND_NORMAL_ALPHACH
		0,		// DX_GRAPH_BLEND_ADD_ALPHACH
		0,		// DX_GRAPH_BLEND_MULTIPLE_A_ONLY
};
static int	GraphBlend_Basic(           GRAPHFILTER_INFO *Info ) ;
static int	GraphBlend_RGBA_Select_Mix( GRAPHFILTER_INFO *Info, int SelectR, int SelectG, int SelectB, int SelectA ) ;

#endif // DX_NON_FILTER

static int	GetCircle_ThicknessDrawPosition( int x, int y, int r, int Thickness, short ( *CirclePos )[ 5 ] ) ;			// ̕t~̕`p_擾֐
static int	GetOval_ThicknessDrawPosition( int x, int y, int rx, int ry, int Thickness, short ( *CirclePos )[ 5 ] ) ;	// ̕tȉ~̕`p_擾֐

// 򂪕Kvȕ`n֐
static int	DrawBillboard3DHardware( VECTOR Pos, float cx, float cy, float Size, float Angle, IMAGEDATA2 *Image2, IMAGEDATA2 *BlendImage2, int TransFlag, int TurnFlag, int DrawFlag = TRUE, RECT *DrawArea = NULL ) ;	// n[hEGAANZ[^gp DrawBillboard3DHardware
static int	DrawModiBillboard3DHardware( VECTOR Pos, float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, IMAGEDATA2 *Image2, IMAGEDATA2 *BlendImage2, int TransFlag, int DrawFlag = TRUE, RECT *DrawArea = NULL ) ;	// n[hEGAANZ[^gp DrawModiBillboard3DHardware
static int  DrawGraphHardware( int x, int y, float xf, float yf, IMAGEDATA2 *Image2, IMAGEDATA2 *BlendImage2, int TransFlag, int IntFlag ) ;							// n[hEGAANZ[^gp DrawGraph
static int  DrawExtendGraphHardware( int x1, int y1, int x2, int y2, float x1f, float y1f, float x2f, float y2f, IMAGEDATA2 *Image2, IMAGEDATA2 *BlendImage2, int TransFlag, int IntFlag ) ;		// n[hEGAANZ[^gp DrawExtendGraph
static int  DrawRotaGraphHardware( int x, int y, float xf, float yf, double ExRate, double Angle, IMAGEDATA2 *Image2, IMAGEDATA2 *BlendImage2, int TransFlag, int TurnFlag, int IntFlag ) ;	// n[hEGAANZ[^gp DrawRotaGraph
static int  DrawModiGraphBase( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, int GrHandle, int TransFlag, bool SimpleDrawFlag ) ;
static int	DrawModiGraphFBase( float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, int GrHandle, int TransFlag, bool SimpleDrawFlag ) ;
static int  DrawModiGraphHardware( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, IMAGEDATA2 *Image2, IMAGEDATA2 *BlendImage2, int TransFlag, bool SimpleDrawFlag ) ;	// n[hEGAANZ[^gp DrawModiGraph
static int  DrawModiGraphFHardware( float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, IMAGEDATA2 *Image2, IMAGEDATA2 *BlendImage2, int TransFlag, bool SimpleDrawFlag ) ;	// n[hEGAANZ[^gp DrawModiGraphF
static void DrawModiTexHardware( float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, IMAGEDATA2_HARD_DRAW *DrawTex, bool SimpleDrawFlag ) ;		// eNX`ό`ĕ`悷
static int  DrawFillBoxHardware( int x1, int y1, int x2, int y2, int Color ) ;																// n[hEGAANZ[^gp DrawFillBox
static int  DrawLineBoxHardware( int x1, int y1, int x2, int y2, int Color ) ;																// n[hEGAANZ[^gp DrawLineBox
static int	DrawChipMapHardware( int Sx, int Sy, int XNum, int YNum, const int *MapData, int MapDataPitch, int ChipTypeNum, const int *ChipGrHandle, int TransFlag ) ;	// n[hEGAANZ[^gp DrawChipMap
static int	DrawTileHardware( int x1, int y1, int x2, int y2, int Tx, int Ty, double ExtRate, double Angle, IMAGEDATA2 *Image2, IMAGEDATA2 *BlendImage2, int TransFlag ) ;	// n[hEGAANZ[^gp DrawTile
static int	DrawPrimitiveHardware( const VERTEX_3D *Vertex, int VertexNum, int PrimitiveType, IMAGEDATA2 *Image2, int TransFlag ) ;
static int	DrawIndexedPrimitiveHardware( const VERTEX_3D *Vertex, int VertexNum, const WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA2 *Image2, int TransFlag ) ;
static int	DrawPrimitiveLightHardware( const VERTEX3D *Vertex, int VertexNum, int PrimitiveType, IMAGEDATA2 *Image2, int TransFlag ) ;
static int	DrawIndexedPrimitiveLightHardware( const VERTEX3D *Vertex, int VertexNum, const WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA2 *Image2, int TransFlag ) ;
static int	DrawPrimitiveLight_UseVertexBufferHardware( VERTEXBUFFERHANDLEDATA *VertexBuffer, int PrimitiveType, int StartVertex, int UseVertexNum, IMAGEDATA2 *Image2, int TransFlag ) ;
static int	DrawIndexedPrimitiveLight_UseVertexBufferHardware( VERTEXBUFFERHANDLEDATA *VertexBuffer, INDEXBUFFERHANDLEDATA *IndexBuffer, int PrimitiveType, int BaseVertex, int StartVertex, int UseVertexNum, int StartIndex, int UseIndexNum, IMAGEDATA2 *Image2, int TransFlag ) ;
static int	DrawPrimitive2DHardware( VERTEX_2D *Vertex, int VertexNum, int PrimitiveType, IMAGEDATA2 *Image2, int TransFlag, int BillboardFlag, int Is3D, int TurnFlag, int TextureNo ) ;
static int	DrawIndexedPrimitive2DHardware( VERTEX_2D *Vertex, int VertexNum, WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA2 *Image2, int TransFlag ) ;
static int	DrawPrimitive2DUserHardware( const VERTEX2D *Vertex, int VertexNum, int PrimitiveType, IMAGEDATA2 *Image2, int TransFlag, int Is3D, int TurnFlag, int TextureNo ) ;
static int	DrawPrimitive2DUserHardware_Billboard( VERTEX2D *Vertex, int VertexNum, int PrimitiveType, IMAGEDATA2 *Image2, int TransFlag, int Is3D, int TurnFlag, int TextureNo ) ;
static int	DrawIndexedPrimitive2DUserHardware( const VERTEX2D *Vertex, int VertexNum, const WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA2 *Image2, int TransFlag ) ;
static int	DrawLineHardware( int x1, int y1, int x2, int y2, int Color ) ;																			// n[hEGAANZ[^gp DrawLine
static int	DrawLine3DHardware( VECTOR Pos1, VECTOR Pos2, int Color, int DrawFlag = TRUE, RECT *DrawArea = NULL ) ;									// n[hEGAANZ[^gp DrawLine3D
static int	DrawCircle_ThicknessHardware( int x, int y, int r, int Color, int Thickness ) ;															// n[hEGAANZ[^gp DrawCircle( w肠 )
static int	DrawOval_ThicknessHardware( int x, int y, int rx, int ry, int Color, int Thickness ) ;													// n[hEGAANZ[^gp DrawOval( w肠 )
static int	DrawCircleHardware( int x, int y, int r, int Color, int FillFlag ) ;																	// n[hEGAANZ[^gp DrawCircle
static int	DrawOvalHardware( int x, int y, int rx, int ry, int Color, int FillFlag ) ;																// n[hEGAANZ[^gp DrawOval
static int	DrawTriangleHardware( int x1, int y1, int x2, int y2, int x3, int y3, int Color, int FillFlag ) ;										// n[hEGAANZ[^gp DrawTriangle
static int	DrawTriangle3DHardware( VECTOR Pos1, VECTOR Pos2, VECTOR Pos3, int Color, int FillFlag, int DrawFlag = TRUE, RECT *DrawArea = NULL ) ;	// n[hEGAANZ[^gp DrawTriangle3D
static int	DrawQuadrangleHardware( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, int Color, int FillFlag ) ;						// n[hEGAANZ[^gp DrawQuadrangle
static int	DrawPixelHardware( int x, int y, int Color ) ;																							// n[hEGAANZ[^gp DrawPixel
static int	DrawPixel3DHardware( VECTOR Pos, int Color, int DrawFlag = TRUE, RECT *DrawArea = NULL ) ;												// n[hEGAANZ[^gp DrawPixel3D
static int	DrawPixelSetHardware( const POINTDATA *PointData, int Num ) ;																					// n[hEGAANZ[^gp DrawPixelSet
static int	DrawLineSetHardware( const LINEDATA *LineData, int Num ) ;																					// n[hEGAANZ[^gp DrawLineSet

static int  DrawGraphSoftware( int x, int y, IMAGEDATA2 *Image2, int TransFlag ) ;									// \tgEGA_O DrawGraph
static int  DrawExtendGraphSoftware( int x1, int y1, int x2, int y2, IMAGEDATA2 *Image2, int TransFlag ) ;		// \tgEGA_O DrawExtendGraph
static int  DrawRotaGraphSoftware( float x, float y, double ExRate, double Angle, IMAGEDATA2 *Image2, int TransFlag, int TurnFlag ) ;	// \tgEGA_O DrawRotaGraph
static int	DrawPolySoftware( DX_POINTDATA *p, IMAGEDATA2 *Image2, int TransFlag, int Color ) ;
static int  DrawModiGraphSoftware( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, IMAGEDATA2 *Image2, int TransFlag ) ;	// \tgEGA_O DrawModiGraph
static int  DrawModiGraphFSoftware( float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, IMAGEDATA2 *Image2, int TransFlag ) ;	// \tgEGA_O DrawModiGraphF
static int  DrawFillBoxSoftware( int x1, int y1, int x2, int y2, int Color ) ;																// \tgEGA_O DrawFillBox
static int  DrawLineBoxSoftware( int x1, int y1, int x2, int y2, int Color ) ;																// \tgEGA_O DrawLineBox
static int	DrawChipMapSoftware( int Sx, int Sy, int XNum, int YNum, const int *MapData, int MapDataPitch, int ChipTypeNum, const int *ChipGrHandle, int TransFlag ) ;	// \tgEGA_O DrawChipMap
static int	DrawTileSoftware( int x1, int y1, int x2, int y2, int Tx, int Ty, double ExtRate, double Angle, IMAGEDATA2 *Image2, int TransFlag ) ;	// \tgEGA_O DrawTile
static int	DrawPrimitiveSoftware( VERTEX_3D *Vertex, int VertexNum, int PrimitiveType, IMAGEDATA2 *Image2, int TransFlag ) ;
static int	DrawIndexedPrimitiveSoftware( VERTEX_3D *Vertex, int VertexNum, WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA2 *Image2, int TransFlag ) ;
static int	DrawPrimitive2DSoftware( VERTEX_2D *Vertex, int VertexNum, int PrimitiveType, IMAGEDATA2 *Image2, int TransFlag ) ;
static int	DrawIndexedPrimitive2DSoftware( VERTEX_2D *Vertex, int VertexNum, WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA2 *Image2, int TransFlag ) ;
static int	DrawLineSoftware( int x1, int y1, int x2, int y2, int Color ) ;																	// \tgEGA_O DrawLine
static int	DrawCircle_ThicknessSoftware( int x, int y, int r, int Color, int Thickness ) ;													// \tgEGA_O DrawCircle( w肠 )
static int	DrawOval_ThicknessSoftware( int x, int y, int rx, int ry, int Color, int Thickness ) ;											// \tgEGA_O DrawOval( w肠 )
static int	DrawCircleSoftware( int x, int y, int r, int Color, int FillFlag ) ;															// \tgEGA_O DrawCircle
static int	DrawOvalSoftware( int x, int y, int rx, int ry, int Color, int FillFlag ) ;														// \tgEGA_O DrawOval
static int	DrawTriangleSoftware( int x1, int y1, int x2, int y2, int x3, int y3, int Color, int FillFlag ) ;								// \tgEGA_O DrawTriangle
static int	DrawQuadrangleSoftware( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, int Color, int FillFlag ) ;				// \tgEGA_O DrawQuadrangle
static int	DrawPixelSoftware( int x, int y, int Color ) ;																					// \tgEGA_O DrawPixel
static int	DrawPixelSetSoftware( const POINTDATA *PointData, int Num ) ;																			// \tgEGA_O DrawPixelSet
static int	DrawLineSetSoftware( const LINEDATA *LineData, int Num ) ;																			// \tgEGA_O DrawLineSet


// vO -----------------------------------------------------------------

// r{[hp̍svZ
__inline static void _VectorTransformToBillboard( VECTOR *Vector, VECTOR *Position )
{
	VECTOR invec = *Vector ;
	Vector->x = invec.x * GBASE.BillboardMatrix.m[0][0] + invec.y * GBASE.BillboardMatrix.m[1][0] + Position->x ;
	Vector->y = invec.x * GBASE.BillboardMatrix.m[0][1] + invec.y * GBASE.BillboardMatrix.m[1][1] + Position->y ;
	Vector->z = invec.x * GBASE.BillboardMatrix.m[0][2] + invec.y * GBASE.BillboardMatrix.m[1][2] + Position->z ;
}

// uh摜Ƃ̑傫`FbN
__inline static int CheckBlendGraphSize( IMAGEDATA2 *GraphData )
{
	IMAGEDATA2 *BlendData ;

	if( GRAPHCHK( GBASE.BlendGraph, BlendData ) )
		return -1 ;

	// uh摜傫AEg
	return ( ( BlendData->Width  - GraphData->Width  ) |
		     ( BlendData->Height - GraphData->Height ) ) & 0x80000000 ? -1 : 0 ;
}

static int BltBmpOrBaseImageToGraph3_MipMapBlt(
	IMAGEDATA2_ORIG			*Orig,
	const RECT				*SrcRect,
	const RECT				*DestRect,
	DX_DIRECT3DBASETEXTURE9	*UseTex,
	int						TexWidth,
	int						TexHeight,
	const BASEIMAGE			*RgbImage,
	const BASEIMAGE			*AlphaImage,
	const COLORDATA			*DestColor,
	int						RedIsAlphaFlag,
	int						UseTransColorConvAlpha,
	int						ASyncThread
)
{
	int AlphaImageSize, ImageSize, ImageW, ImageH, ImagePitch ;
	void *Image1, *Image2, *ImageD, *ImageS, *ImageBuffer ;
	int ImageDW, ImageDH, ImageSW, ImageSH ;
	int ImageNum ;
	RECT DestRectT, SrcRectT ;
	D_D3DLOCKED_RECT LockRect ;
	POINT DestPoint ;
	int i, j, ts ;

	DestPoint.x = 0 ;
	DestPoint.y = 0 ;

	ImageNum = Orig->FormatDesc.CubeMapTextureFlag ? CUBEMAP_SURFACE_NUM : 1 ;

	// ]悪eNX`ŜŁADXTtH[}bgœ]DXTtH[}bg̏ꍇ͒Pȃ]s
	if( DestRect->left == 0 && DestRect->right  == TexWidth  &&
		DestRect->top  == 0 && DestRect->bottom == TexHeight &&
		RgbImage->MipMapCount >= Orig->Hard.MipMapCount &&
		( ( RgbImage->ColorData.Format == DX_BASEIMAGE_FORMAT_DXT1 && GRH.TextureFormat[ Orig->ColorFormat ] == D_D3DFMT_DXT1 ) ||
		  ( RgbImage->ColorData.Format == DX_BASEIMAGE_FORMAT_DXT2 && GRH.TextureFormat[ Orig->ColorFormat ] == D_D3DFMT_DXT2 ) ||
		  ( RgbImage->ColorData.Format == DX_BASEIMAGE_FORMAT_DXT3 && GRH.TextureFormat[ Orig->ColorFormat ] == D_D3DFMT_DXT3 ) ||
		  ( RgbImage->ColorData.Format == DX_BASEIMAGE_FORMAT_DXT4 && GRH.TextureFormat[ Orig->ColorFormat ] == D_D3DFMT_DXT4 ) ||
		  ( RgbImage->ColorData.Format == DX_BASEIMAGE_FORMAT_DXT5 && GRH.TextureFormat[ Orig->ColorFormat ] == D_D3DFMT_DXT5 ) ) )
	{
		if( Orig->FormatDesc.CubeMapTextureFlag )
		{
			ImageBuffer = RgbImage->GraphData ;
			for( i = 0 ; i < CUBEMAP_SURFACE_NUM ; i ++ )
			{
				ImageSize = RgbImage->Width * RgbImage->Height * RgbImage->ColorData.ColorBitDepth / 8 ;
				for( j = 0 ; j < Orig->Hard.MipMapCount ; j ++ )
				{
					// eNX`bN
					if( GraphicsCubeTexture_LockRect_ASync( ( DX_DIRECT3DCUBETEXTURE9 * )UseTex, ( D_D3DCUBEMAP_FACES )i, j, &LockRect, NULL, 0, ASyncThread ) != D_D3D_OK )
					{
						DXST_ERRORLOG_ADD( _T( "L[u}bv~bv}bveNX`̃bNɎs܂\n" ) ) ;
						return -1 ;
					}

					// eNX`ɓ]
					_MEMCPY( LockRect.pBits, ImageBuffer, ImageSize ) ;

					// bN
					GraphicsCubeTexture_UnlockRect_ASync( ( DX_DIRECT3DCUBETEXTURE9 * )UseTex, ( D_D3DCUBEMAP_FACES )i, j, ASyncThread ) ;

					// ]AhXi߂
					ImageBuffer = ( BYTE * )ImageBuffer + ImageSize ;
					ImageSize /= 4 ;
					if( ImageSize < 8 )
						ImageSize = 8 ;
				}
			}
		}
		else
		{
			ImageSize = RgbImage->Width * RgbImage->Height * RgbImage->ColorData.ColorBitDepth / 8 ;
			ImageBuffer = RgbImage->GraphData ;
			for( j = 0 ; j < Orig->Hard.MipMapCount ; j ++ )
			{
				// eNX`bN
				if( GraphicsTexture_LockRect_ASync( ( DX_DIRECT3DTEXTURE9 * )UseTex, j, &LockRect, NULL, 0, ASyncThread ) != D_D3D_OK )
				{
					DXST_ERRORLOG_ADD( _T( "~bv}bveNX`̃bNɎs܂\n" ) ) ;
					return -1 ;
				}

				// eNX`ɓ]
				_MEMCPY( LockRect.pBits, ImageBuffer, ImageSize ) ;

				// bN
				GraphicsTexture_UnlockRect_ASync( ( DX_DIRECT3DTEXTURE9 * )UseTex, j, ASyncThread ) ;

				// ]AhXi߂
				ImageBuffer = ( BYTE * )ImageBuffer + ImageSize ;
				ImageSize /= 4 ;
				if( ImageSize < 8 )
					ImageSize = 8 ;
			}
		}
	}
	else
	{
		// ]悪WtH[}bgł͂Ȃꍇ͓]łȂ
		if( GRH.TextureFormat[ Orig->ColorFormat ] != D_D3DFMT_DXT1 &&
			GRH.TextureFormat[ Orig->ColorFormat ] != D_D3DFMT_DXT2 &&
			GRH.TextureFormat[ Orig->ColorFormat ] != D_D3DFMT_DXT3 &&
			GRH.TextureFormat[ Orig->ColorFormat ] != D_D3DFMT_DXT4 &&
			GRH.TextureFormat[ Orig->ColorFormat ] != D_D3DFMT_DXT5 )
		{
			// ]Ƀ~bv}bv񂪂ꍇƖꍇŏ𕪊
			if( RgbImage->MipMapCount >= Orig->Hard.MipMapCount )
			{
				// ꍇ

				ImageBuffer = RgbImage->GraphData ;
				if( Orig->FormatDesc.CubeMapTextureFlag )
				{
					for( i = 0 ; i < CUBEMAP_SURFACE_NUM ; i ++ )
					{
						ImageSize = RgbImage->Width * RgbImage->Height * RgbImage->ColorData.PixelByte ;
						for( j = 0 ; j < Orig->Hard.MipMapCount ; j ++ )
						{
							// eNX`bN
							if( GraphicsCubeTexture_LockRect_ASync( ( DX_DIRECT3DCUBETEXTURE9 * )UseTex, ( D_D3DCUBEMAP_FACES )i, j, &LockRect, NULL, 0, ASyncThread ) != D_D3D_OK )
							{
								DXST_ERRORLOG_ADD( _T( "~bv}bveNX`̃bNɎs܂\n" ) ) ;
								return -1 ;
							}

							// eNX`ɓ]
							_MEMCPY( LockRect.pBits, ImageBuffer, ImageSize ) ;

							// bN
							GraphicsCubeTexture_UnlockRect_ASync( ( DX_DIRECT3DCUBETEXTURE9 * )UseTex, ( D_D3DCUBEMAP_FACES )i, j, ASyncThread ) ;

							// ]AhXi߂
							ImageBuffer = ( BYTE * )ImageBuffer + ImageSize ;
							ImageSize /= 4 ;
						}
					}
				}
				else
				{
					ImageSize = RgbImage->Width * RgbImage->Height * RgbImage->ColorData.PixelByte ;
					for( j = 0 ; j < Orig->Hard.MipMapCount ; j ++ )
					{
						// eNX`bN
						if( GraphicsTexture_LockRect_ASync( ( DX_DIRECT3DTEXTURE9 * )UseTex, j, &LockRect, NULL, 0, ASyncThread ) != D_D3D_OK )
						{
							DXST_ERRORLOG_ADD( _T( "~bv}bveNX`̃bNɎs܂\n" ) ) ;
							return -1 ;
						}

						// eNX`ɓ]
						_MEMCPY( LockRect.pBits, ImageBuffer, ImageSize ) ;

						// bN
						GraphicsTexture_UnlockRect_ASync( ( DX_DIRECT3DTEXTURE9 * )UseTex, j, ASyncThread ) ;

						// ]AhXi߂
						ImageBuffer = ( BYTE * )ImageBuffer + ImageSize ;
						ImageSize /= 4 ;
					}
				}
			}
			else
			{
				// ꍇ

				// ꎞobt@Ɋi[
				ts = DestRect->right  - DestRect->left ;
				for( ImageW = 1 ; ImageW < ts ; ImageW <<= 1 ){}
				ts = DestRect->bottom - DestRect->top  ;
				for( ImageH = 1 ; ImageH < ts ; ImageH <<= 1 ){}
				ImagePitch = DestColor->PixelByte * ImageW ;
				ImageSize = ImagePitch * ImageH ;
				ImageBuffer = DXALLOC( ImageSize * 2 ) ;
				Image1 = ImageBuffer ;
				Image2 = ( BYTE * )Image1 + ImageSize ;
				if( ImageBuffer == NULL )
				{
					DXST_ERRORLOG_ADD( _T( "eNX`֓]摜ꎞIɊi[郁̈̊mۂɎs܂\n" ) ) ;
					return -1 ;
				}

				ImageSize      = RgbImage->Pitch   * RgbImage->Height ;
				AlphaImageSize = AlphaImage->Pitch * AlphaImage->Height ;
				for( i = 0 ; i < ImageNum ; i ++ )
				{
					// ~bv}bv̐[JԂ
					ImageSW = ImageW ;
					ImageSH = ImageH ;
					ImageDW = ImageW ;
					ImageDH = ImageH ;
					for( j = 0 ; j < Orig->Hard.MipMapCount ; j ++ )
					{
						// k摜̍쐬
						if( j == 0 )
						{
							// level0 ͓̎{̏o̓tH[}bg摜쐬
							NS_GraphColorMatchBltVer2(
											   Image1,        ImagePitch,              DestColor,
								( BYTE * )RgbImage->GraphData   + ImageSize * i,      RgbImage->Pitch,   &RgbImage->ColorData,
								( BYTE * )AlphaImage->GraphData + AlphaImageSize * i, AlphaImage->Pitch, &AlphaImage->ColorData,
								DestPoint, SrcRect, FALSE,
								UseTransColorConvAlpha && ( DestColor->AlphaWidth != 0 && AlphaImage->GraphData == NULL ), Orig->TransCode,
								BASEIM.ImageShavedMode, FALSE,
								RedIsAlphaFlag, FALSE,
								FALSE ) ;
							ImageD = Image1 ;
						}
						else
						{
							if( j & 1 )
							{
								ImageS = Image1 ;
								ImageD = Image2 ;
							}
							else
							{
								ImageS = Image2 ;
								ImageD = Image1 ;
							}

							GraphHalfScaleBlt( DestColor, ImageD, ImagePitch, ImageS, ImagePitch, 0, 0, 0, 0, ImageSW, ImageSH ) ;
						}

						// ]̃bN
						DestRectT.left   = DestRect->left   >> j ;
						DestRectT.right  = DestRect->right  >> j ;
						DestRectT.top    = DestRect->top    >> j ;
						DestRectT.bottom = DestRect->bottom >> j ;
						if( DestRectT.right  == DestRectT.left ) DestRectT.right  = DestRectT.left + 1 ;
						if( DestRectT.bottom == DestRectT.top  ) DestRectT.bottom = DestRectT.top  + 1 ;
						if( Orig->FormatDesc.CubeMapTextureFlag )
						{
							if( GraphicsCubeTexture_LockRect_ASync( ( DX_DIRECT3DCUBETEXTURE9 * )UseTex, ( D_D3DCUBEMAP_FACES )i, j, &LockRect, &DestRectT, 0, ASyncThread ) != D_D3D_OK )
							{
								DXFREE( ImageBuffer ) ;
								ImageBuffer = NULL ;
								DXST_ERRORLOG_ADD( _T( "L[u}bv~bv}bveNX`̃bNɎs܂\n" ) ) ;
								return -1 ;
							}
						}
						else
						{
							if( GraphicsTexture_LockRect_ASync( ( DX_DIRECT3DTEXTURE9 * )UseTex, j, &LockRect, &DestRectT, 0, ASyncThread ) != D_D3D_OK )
							{
								DXFREE( ImageBuffer ) ;
								ImageBuffer = NULL ;
								DXST_ERRORLOG_ADD( _T( "~bv}bveNX`̃bNɎs܂\n" ) ) ;
								return -1 ;
							}
						}

						// eNX`ɓ]
						SrcRectT.left   = 0 ;
						SrcRectT.top    = 0 ;
						SrcRectT.right  = ImageDW ;
						SrcRectT.bottom = ImageDH ;
						NS_GraphColorMatchBltVer2(
							LockRect.pBits, LockRect.Pitch,  DestColor,
									ImageD,     ImagePitch,  DestColor,
									  NULL,              0,       NULL,
							DestPoint, &SrcRectT, FALSE,
							FALSE, 0, 0, FALSE, FALSE, FALSE, FALSE ) ;

						// bN
						if( Orig->FormatDesc.CubeMapTextureFlag )
						{
							GraphicsCubeTexture_UnlockRect_ASync( ( DX_DIRECT3DCUBETEXTURE9 * )UseTex, ( D_D3DCUBEMAP_FACES )i, j, ASyncThread ) ;
						}
						else
						{
							GraphicsTexture_UnlockRect_ASync( ( DX_DIRECT3DTEXTURE9 * )UseTex, j, ASyncThread ) ;
						}

						// ̃C[W̃TCYZbg
						ImageSW = ImageDW ;
						ImageSH = ImageDH ;
						ImageDW >>= 1 ;
						ImageDH >>= 1 ;
						if( ImageDW == 0 ) ImageDW = 1 ;
						if( ImageDH == 0 ) ImageDH = 1 ;
					}
				}

				// ̉
				DXFREE( ImageBuffer ) ;
			}
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "DXTtH[}bg̃eNX`ɕW`̃C[W]邱Ƃ͂ł܂\n" ) ) ;
		}
	}

	// I
	return 0 ;
}

static int BltBmpOrBaseImageToGraph3_NoMipMapBlt(
	IMAGEDATA2_ORIG			*Orig,
	const RECT				*SrcRect,
	const RECT				*DestRect,
	DX_DIRECT3DBASETEXTURE9	*UseTex,
	int						TexWidth,
	int						TexHeight,
	int						TexUseWidth,
	int						TexUseHeight,
	const BASEIMAGE			*RgbImage,
	const BASEIMAGE			*AlphaImage,
	const COLORDATA			*DestColor,
	int						RedIsAlphaFlag,
	int						UseTransColorConvAlpha,
	int						ASyncThread
)
{
	int k ;
	int i ;
	int hr ;
	POINT DestPoint ;
	RECT DestRectT ;
	int H ;
	BYTE *DestAddr ;
	BYTE *SrcRgbAddr ;
	BYTE *SrcAlphaAddr ;
	RECT TempDestRect ;
	D_D3DLOCKED_RECT LockRect ;
	int RightLineFillFlag ;
	int BottomLineFillFlag ;
	int ImageNum ;
	DWORD ImageSize ;
	DWORD AlphaImageSize ;

	DestPoint.x = 0 ;
	DestPoint.y = 0 ;

	TempDestRect = *DestRect ;
	RightLineFillFlag = FALSE ;
	BottomLineFillFlag = FALSE ;
	DestRectT = *DestRect ;
	if( TexUseWidth  < TexWidth  && TexUseWidth  == DestRectT.right )
	{
		RightLineFillFlag = TRUE ;
		DestRectT.right ++ ;
	}
	if( TexUseHeight < TexHeight && TexUseHeight == DestRectT.bottom )
	{
		BottomLineFillFlag = TRUE ;
		DestRectT.bottom ++ ;
	}

	ImageNum = Orig->FormatDesc.CubeMapTextureFlag ? CUBEMAP_SURFACE_NUM : 1 ;

//	DXST_ERRORLOGFMT_ADD(( _T( "SrcRect l:%d t:%d r:%d b:%d  DestRect l:%d t:%d r:%d b:%d" ),
//	SrcRect->left, SrcRect->top, SrcRect->right, SrcRect->bottom,
//	DestRectT.left, DestRectT.top, DestRectT.right, DestRectT.bottom )) ;

	for( i = 0 ; i < ImageNum ; i ++ )
	{
		// ]̃bN
		if( Orig->FormatDesc.CubeMapTextureFlag )
		{
			hr = GraphicsCubeTexture_LockRect_ASync( ( DX_DIRECT3DCUBETEXTURE9 * )UseTex, ( D_D3DCUBEMAP_FACES )i, 0, &LockRect, &DestRectT, 0, ASyncThread ) ;
		}
		else
		{
			hr = GraphicsTexture_LockRect_ASync( ( DX_DIRECT3DTEXTURE9 * )UseTex, 0, &LockRect, &DestRectT, 0, ASyncThread ) ;
		}
		DestRectT = TempDestRect ;
		if( hr != D_D3D_OK )
		{
			DXST_ERRORLOG_ADD( _T( "eNX`̃bNɎs܂\n" ) ) ;
			return -1  ;
		}

		// ]

		// ]悪eNX`ŜŁADXTtH[}bgœ]DXTtH[}bg̏ꍇ͒Pȃ]s
		if( DestRectT.left == 0 && DestRectT.right  == TexWidth  &&
			DestRectT.top  == 0 && DestRectT.bottom == TexHeight &&
			( ( RgbImage->ColorData.Format == DX_BASEIMAGE_FORMAT_DXT1 && GRH.TextureFormat[ Orig->ColorFormat ] == D_D3DFMT_DXT1 ) ||
			  ( RgbImage->ColorData.Format == DX_BASEIMAGE_FORMAT_DXT2 && GRH.TextureFormat[ Orig->ColorFormat ] == D_D3DFMT_DXT2 ) ||
			  ( RgbImage->ColorData.Format == DX_BASEIMAGE_FORMAT_DXT3 && GRH.TextureFormat[ Orig->ColorFormat ] == D_D3DFMT_DXT3 ) ||
			  ( RgbImage->ColorData.Format == DX_BASEIMAGE_FORMAT_DXT4 && GRH.TextureFormat[ Orig->ColorFormat ] == D_D3DFMT_DXT4 ) ||
			  ( RgbImage->ColorData.Format == DX_BASEIMAGE_FORMAT_DXT5 && GRH.TextureFormat[ Orig->ColorFormat ] == D_D3DFMT_DXT5 ) ) )
		{
			ImageSize = RgbImage->Width * RgbImage->Height * RgbImage->ColorData.ColorBitDepth / 8 ;
			_MEMCPY( LockRect.pBits, ( BYTE * )RgbImage->GraphData + ImageSize * i, ImageSize ) ;
		}
		else
		{
			// ]悪WtH[}bgł͂Ȃꍇ͓]łȂ
			if( GRH.TextureFormat[ Orig->ColorFormat ] != D_D3DFMT_DXT1 &&
				GRH.TextureFormat[ Orig->ColorFormat ] != D_D3DFMT_DXT2 &&
				GRH.TextureFormat[ Orig->ColorFormat ] != D_D3DFMT_DXT3 &&
				GRH.TextureFormat[ Orig->ColorFormat ] != D_D3DFMT_DXT4 &&
				GRH.TextureFormat[ Orig->ColorFormat ] != D_D3DFMT_DXT5 )
			{
				ImageSize      = RgbImage->Pitch   * RgbImage->Height ;
				AlphaImageSize = AlphaImage->Pitch * AlphaImage->Height ;

				SrcRgbAddr   = ( BYTE * )RgbImage->GraphData   + i * ImageSize ;
				SrcAlphaAddr = ( BYTE * )AlphaImage->GraphData + i * AlphaImageSize ;
				NS_GraphColorMatchBltVer2(
					LockRect.pBits, LockRect.Pitch,    DestColor,
					SrcRgbAddr,     RgbImage->Pitch,   &RgbImage->ColorData,
					SrcAlphaAddr,   AlphaImage->Pitch, &AlphaImage->ColorData,
					DestPoint, SrcRect, FALSE,
					UseTransColorConvAlpha && ( DestColor->AlphaWidth != 0 && AlphaImage->GraphData == NULL ), Orig->TransCode,
					BASEIM.ImageShavedMode, FALSE,
					RedIsAlphaFlag, FALSE,
					FALSE ) ;

				if( BottomLineFillFlag )
				{
					_MEMCPY( ( BYTE * )LockRect.pBits + ( TexUseHeight - DestRectT.top     ) * LockRect.Pitch,
							 ( BYTE * )LockRect.pBits + ( TexUseHeight - DestRectT.top - 1 ) * LockRect.Pitch,
							 DestColor->PixelByte * ( SrcRect->right - SrcRect->left ) ) ;
				}
				if( RightLineFillFlag )
				{
					H = SrcRect->bottom - SrcRect->top ;
					DestAddr = ( BYTE * )LockRect.pBits + ( TexUseWidth - DestRectT.left ) * DestColor->PixelByte ;
					switch( DestColor->PixelByte )
					{
					case 2 :
						for( k = 0 ; k < H ; k ++, DestAddr += LockRect.Pitch )
						{
							*( ( WORD * )DestAddr ) = *( ( WORD * )DestAddr - 1 ) ;
						}
						break ;

					case 4 :
						for( k = 0 ; k < H ; k ++, DestAddr += LockRect.Pitch )
						{
							*( ( DWORD * )DestAddr ) = *( ( DWORD * )DestAddr - 1 ) ;
						}
						break ;
					}
				}
				if( BottomLineFillFlag && RightLineFillFlag )
				{
					DestAddr = ( BYTE * )LockRect.pBits + ( TexUseHeight - DestRectT.top ) * LockRect.Pitch + ( TexUseWidth - DestRectT.left ) * DestColor->PixelByte ;
					switch( DestColor->PixelByte )
					{
					case 2 : *( ( WORD  * )DestAddr ) = *( ( WORD  * )( DestAddr - LockRect.Pitch ) - 1 ) ; break ;
					case 4 : *( ( DWORD * )DestAddr ) = *( ( DWORD * )( DestAddr - LockRect.Pitch ) - 1 ) ;	break ;
					}
				}
			}
			else
			{
				DXST_ERRORLOG_ADD( _T( "DXTtH[}bg̃eNX`ɕW`̃C[W]邱Ƃ͂ł܂\n" ) ) ;
			}
		}

		// bN
		if( Orig->FormatDesc.CubeMapTextureFlag )
		{
			GraphicsCubeTexture_UnlockRect_ASync( ( DX_DIRECT3DCUBETEXTURE9 * )UseTex, ( D_D3DCUBEMAP_FACES )i, 0, ASyncThread ) ;
		}
		else
		{
			GraphicsTexture_UnlockRect_ASync( ( DX_DIRECT3DTEXTURE9 * )UseTex, 0, ASyncThread ) ;
		}
	}

	// I
	return 0 ;
}

// ftHg̃OtBbN֐
static void DefaultRestoreGraphFunction( void )
{
	IMAGEDATA2 *Image2 ;
	IMAGEDATA2 *FileBackImage2 ;
	IMAGEDATA2 *MemBackImage2 ;
	int i ;
	int ImageDataArea ;
	BASEIMAGE FileRgbImage ;
	BASEIMAGE FileAlphaImage ;
	int FileRgbLoad ;
	int FileAlphaLoad ;
	BASEIMAGE MemRgbImage ;
	BASEIMAGE MemAlphaImage ;
	int MemRgbLoad ;
	int MemAlphaLoad ;
	int LoadHr ;

	DXST_ERRORLOG_ADD( _T( "OtBbN𕜋A܂\n" ) ) ;

	// ׂẴOtBbN
	ImageDataArea = HandleManageArray[ DX_HANDLETYPE_GRAPH ].AreaMax ;
	FileBackImage2 = NULL ;
	FileRgbLoad = FALSE ;
	FileAlphaLoad = FALSE ;
	MemBackImage2 = NULL ;
	MemRgbLoad = FALSE ;
	MemAlphaLoad = FALSE ;
	if( HandleManageArray[ DX_HANDLETYPE_GRAPH ].InitializeFlag )
	{
		for( i = HandleManageArray[ DX_HANDLETYPE_GRAPH ].AreaMin ; i <= ImageDataArea ; i ++ )
		{
			Image2 = ( IMAGEDATA2 * )HandleManageArray[ DX_HANDLETYPE_GRAPH ].Handle[ i ] ;
			if( Image2 == NULL || Image2->ReadBase == NULL ) continue ;

			// t@Cǂݍ񂾏ꍇ̓t@C摜𕜌
			if( Image2->ReadBase->FileName )
			{
				// ÕOtBbNƃpXƃt@Cꍇ͓ǂݍ݂Ȃ
				if( FileBackImage2 == NULL ||
					FileRgbLoad == FALSE ||
					FileBackImage2->ReadBase->FileName == NULL ||
					_TSTRCMP( Image2->ReadBase->FileName, FileBackImage2->ReadBase->FileName ) != 0 ||
					Image2->ReadBase->ReverseFlag != FileBackImage2->ReadBase->ReverseFlag )
				{
					// BASEIMAGE ̌n
					if( FileRgbLoad == TRUE )
					{
						NS_ReleaseGraphImage( &FileRgbImage ) ;
						FileRgbLoad = FALSE ;
					}
					if( FileAlphaLoad == TRUE )
					{
						NS_ReleaseGraphImage( &FileAlphaImage ) ;
						FileAlphaLoad = FALSE ;
					}

					// 摜t@C烍[hꍇ͉摜[h
		//			DXST_ERRORLOGFMT_ADD(( _T( "i:%d tpX:%s [hł܂ł" ), i, Image2->FilePath )) ;
		//			DXST_ERRORLOGFMT_ADD(( _T( "t@C:%s [h܂" ), Image2->FilePath->String )) ;
		//			DXST_ERRORLOGFMT_ADD(( _T( "]tO:%d  t@C:%s [h܂" ), Image2->ReadBase->ReverseFlag, Image2->ReadBase->FileName )) ;
					LoadHr = NS_CreateGraphImage_plus_Alpha(
								Image2->ReadBase->FileName,
								NULL,
								0,
								LOADIMAGE_TYPE_FILE, 
								NULL,
								0,
								LOADIMAGE_TYPE_FILE,
								&FileRgbImage,
								&FileAlphaImage,
								Image2->ReadBase->ReverseFlag ) ;
					if( LoadHr == -1 )
					{
						DXST_ERRORLOGFMT_ADD(( _T( "t@C:%s [hł܂ł" ), Image2->ReadBase->FileName )) ;
						goto R1 ;
					}

					FileRgbLoad = TRUE ;
					if( LoadHr == 0 ) FileAlphaLoad = TRUE ;
				}

				// OtBbN̓]
		//		DXST_ERRORLOGFMT_ADD(( _T( "UseFileX:%d UseFileY:%d" ), Image2->UseFileX, Image2->UseFileY )) ;
				BltBmpOrGraphImageToGraphBase(
					NULL,
					NULL,
					NULL,
					FALSE,
					&FileRgbImage,
					FileAlphaLoad == TRUE ? &FileAlphaImage : NULL,
					Image2->UseBaseX,
					Image2->UseBaseY,
					Image2->HandleInfo.Handle,
					GBASE.NotUseTransColor ? FALSE : TRUE
				) ;
		R1 :
				FileBackImage2 = Image2 ;
			}
			else
			// ǂݍ񂾏ꍇ̓摜𕜌
			if( Image2->ReadBase->MemImage )
			{
				// ÕOtBbNƃAhXꍇ͓ǂݍ݂Ȃ
				if( MemBackImage2 == NULL ||
					MemRgbLoad == FALSE ||
					Image2->ReadBase->MemImage != MemBackImage2->ReadBase->MemImage ||
					Image2->ReadBase->AlphaMemImage != MemBackImage2->ReadBase->AlphaMemImage ||
					Image2->ReadBase->ReverseFlag != MemBackImage2->ReadBase->ReverseFlag )
				{
					// BASEIMAGE ̌n
					if( MemRgbLoad == TRUE )
					{
						NS_ReleaseGraphImage( &MemRgbImage ) ;
						MemRgbLoad = FALSE ;
					}
					if( MemAlphaLoad == TRUE )
					{
						NS_ReleaseGraphImage( &MemAlphaImage ) ;
						MemAlphaLoad = FALSE ;
					}

					// 摜烍[hꍇ͉摜[h
					LoadHr = NS_CreateGraphImage_plus_Alpha(
								NULL,
								Image2->ReadBase->MemImage,
								Image2->ReadBase->MemImageSize,
								LOADIMAGE_TYPE_MEM,
								Image2->ReadBase->AlphaMemImage,
								Image2->ReadBase->AlphaMemImageSize,
								LOADIMAGE_TYPE_MEM,
								&MemRgbImage,
								&MemAlphaImage,
								Image2->ReadBase->ReverseFlag ) ;
					if( LoadHr == -1 )
					{
						DXST_ERRORLOGFMT_ADD(( _T( "̉摜f[^̃[ł܂ł" ) )) ;
						goto R2 ;
					}

					MemRgbLoad = TRUE ;
					if( LoadHr == 0 ) MemAlphaLoad = TRUE ;
				}

				// OtBbN̓]
				BltBmpOrGraphImageToGraphBase( 
					NULL,
					NULL,
					NULL,
					FALSE,
					&MemRgbImage,
					MemAlphaLoad == TRUE ? &MemAlphaImage : NULL,
					Image2->UseBaseX,
					Image2->UseBaseY,
					Image2->HandleInfo.Handle,
					GBASE.NotUseTransColor ? FALSE : TRUE
				) ;
		R2 :
				MemBackImage2 = Image2 ;
			}
			else
			// BaseImage ǂݍ񂾏ꍇ BaseImage 摜𕜌
			if( Image2->ReadBase->BaseImage )
			{
				// OtBbN̓]
				BltBmpOrGraphImageToGraphBase( 
					NULL,
					NULL,
					NULL,
					FALSE,
					Image2->ReadBase->BaseImage,
					Image2->ReadBase->AlphaBaseImage,
					Image2->UseBaseX,
					Image2->UseBaseY,
					Image2->HandleInfo.Handle,
					GBASE.NotUseTransColor ? FALSE : TRUE
				) ;
			}
		}
	}

	// GraphImage ̌n
	if( FileRgbLoad == TRUE )
	{
		NS_ReleaseGraphImage( &FileRgbImage ) ;
		FileRgbLoad = FALSE ;
	}
	if( FileAlphaLoad == TRUE )
	{
		NS_ReleaseGraphImage( &FileAlphaImage ) ;
		FileAlphaLoad = FALSE ;
	}
	if( MemRgbLoad == TRUE )
	{
		NS_ReleaseGraphImage( &MemRgbImage ) ;
		MemRgbLoad = FALSE ;
	}
	if( MemAlphaLoad == TRUE )
	{
		NS_ReleaseGraphImage( &MemAlphaImage ) ;
		MemAlphaLoad = FALSE ;
	}

	DXST_ERRORLOG_ADD( _T( "OtBbN̕A܂\n" ) ) ;
}

// OtBbNnhɉ摜f[^]邽߂̊֐
static int BltBmpOrBaseImageToGraph3(
	const COLORDATA	*BmpColorData,
	HBITMAP		RgbBmp,
	HBITMAP		AlphaBmp,
	const RECT	*SrcRect,
	int			DestX,
	int			DestY,
	int			GrHandle,
	int			BmpFlag,
	const BASEIMAGE	*RgbImage,
	const BASEIMAGE	*AlphaImage,
	int			RedIsAlphaFlag,
	int			UseTransColorConvAlpha,
	int			TargetOrig,
	int			ASyncThread
)
{
	IMAGEDATA2 *Image2 ;
	IMAGEDATA2_ORIG *Orig ;
	IMAGEDATA2_ORIG_HARD_TEX *OrigTex ;
	IMAGEDATA2_HARD_DRAW *DrawTex ;
	int i, j, Width, Height ;
	int ImageNum ;
	int UseSysMemTex = -1 ;
	POINT DestPoint ;
	RECT DestRect, MovRect ;
	COLORDATA *DestColor ;
#ifdef __WINDOWS__
	BITMAP Bmp ;
#endif // __WINDOWS__
	BASEIMAGE TempBaseRGB, TempBaseAlpha = { 0 } ;
	int RequiredReleaseBaseRGB = FALSE ;
	int RequiredReleaseBaseAlpha = FALSE ;
	D_D3DLOCKED_RECT LockRect ;
	DX_DIRECT3DBASETEXTURE9 *UseTex ;
	DX_DIRECT3DSURFACE9 *SMSurface[ CUBEMAP_SURFACE_NUM ] = { 0 } ;

	if( GRA2.InitializeFlag == FALSE ) return -1 ;

	// G[
	if( ASyncThread )
	{
		if( GRAPHCHK_ASYNC( GrHandle, Image2 ) )
			return -1 ;
	}
	else
	{
		if( GRAPHCHK( GrHandle, Image2 ) )
			return -1 ;
	}
	Orig = Image2->Orig ;

	// _`悵Ă
	RenderVertexHardware( ASyncThread ) ;

	// ]vZĂ
	Width = SrcRect->right - SrcRect->left ;
	Height = SrcRect->bottom - SrcRect->top ;
	if( Width <= 0 || Height <= 0 ) return 0 ;

	// ]̏Zbg
	TempBaseAlpha.GraphData = NULL ;
	RequiredReleaseBaseRGB = FALSE ;
	RequiredReleaseBaseAlpha = FALSE ;
	if( BmpFlag )
	{
#ifdef __WINDOWS__
		// Bitmap ̏ꍇ
		GetObject( RgbBmp, sizeof( BITMAP ), ( void * )&Bmp ) ;
		TempBaseRGB.GraphData = Bmp.bmBits ;
		TempBaseRGB.Width = Bmp.bmWidth ;
		TempBaseRGB.Height = Bmp.bmHeight ;
		TempBaseRGB.Pitch = Bmp.bmWidthBytes ;
		TempBaseRGB.Pitch = ( TempBaseRGB.Pitch + 3 ) / 4 * 4 ;
		TempBaseRGB.ColorData = *BmpColorData ;
		TempBaseRGB.MipMapCount = 0 ;
		TempBaseRGB.GraphDataCount = 0 ;

		if( AlphaBmp )
		{
			GetObject( AlphaBmp, sizeof( BITMAP ), ( void * )&Bmp ) ;
			TempBaseAlpha.GraphData = Bmp.bmBits ;
			TempBaseAlpha.Width = Bmp.bmWidth ;
			TempBaseAlpha.Height = Bmp.bmHeight ;
			TempBaseAlpha.Pitch = Bmp.bmWidthBytes ;
			TempBaseAlpha.Pitch = ( TempBaseAlpha.Pitch + 3 ) / 4 * 4 ;
			TempBaseAlpha.ColorData = *BmpColorData ;
			TempBaseAlpha.MipMapCount = 0 ;
			TempBaseAlpha.GraphDataCount = 0 ;
		}
#else // __WINDOWS__
		return -1 ;
#endif // __WINDOWS__
	}
	else
	{
		// BASEIMAGE ̏ꍇ
		TempBaseRGB.GraphData = RgbImage->GraphData ;
		TempBaseRGB.Width = RgbImage->Width ;
		TempBaseRGB.Height = RgbImage->Height ;
		TempBaseRGB.Pitch = RgbImage->Pitch ;
		TempBaseRGB.ColorData = RgbImage->ColorData ;
		TempBaseRGB.MipMapCount = RgbImage->MipMapCount ;
		TempBaseRGB.GraphDataCount = RgbImage->GraphDataCount ;

		if( AlphaImage )
		{
			TempBaseAlpha.GraphData = AlphaImage->GraphData ;
			TempBaseAlpha.Width = AlphaImage->Width ;
			TempBaseAlpha.Height = AlphaImage->Height ;
			TempBaseAlpha.Pitch = AlphaImage->Pitch ;
			TempBaseAlpha.ColorData = AlphaImage->ColorData ;
			TempBaseAlpha.MipMapCount = AlphaImage->MipMapCount ;
			TempBaseAlpha.GraphDataCount = AlphaImage->GraphDataCount ;
		}
	}

	// ]L[u}bvœ]悪L[u}bvł͂Ȃꍇ̓G[
	if( ( TempBaseRGB.GraphDataCount != 0 ) != ( Orig->FormatDesc.CubeMapTextureFlag != 0 ) )
		return -1 ;

	// C[W̐Zbg
	ImageNum = TempBaseRGB.GraphDataCount == 0 ? 1 : TempBaseRGB.GraphDataCount ;

	// BASEIMAGE  DXT ŁA]悪 DXT ł͖ꍇ͂ŕWtH[}bgɕϊ
	{
		int Flag1 = FALSE ;
		int Flag2 = FALSE ;
		int Hr1 = 0, Hr2 = 0 ;

		if( Orig->FormatDesc.TextureFlag )
		{
			if( ( TempBaseRGB.ColorData.Format == DX_BASEIMAGE_FORMAT_DXT1 && GRH.TextureFormat[ Orig->ColorFormat ] != D_D3DFMT_DXT1 ) ||
				( TempBaseRGB.ColorData.Format == DX_BASEIMAGE_FORMAT_DXT2 && GRH.TextureFormat[ Orig->ColorFormat ] != D_D3DFMT_DXT2 ) ||
				( TempBaseRGB.ColorData.Format == DX_BASEIMAGE_FORMAT_DXT3 && GRH.TextureFormat[ Orig->ColorFormat ] != D_D3DFMT_DXT3 ) ||
				( TempBaseRGB.ColorData.Format == DX_BASEIMAGE_FORMAT_DXT4 && GRH.TextureFormat[ Orig->ColorFormat ] != D_D3DFMT_DXT4 ) ||
				( TempBaseRGB.ColorData.Format == DX_BASEIMAGE_FORMAT_DXT5 && GRH.TextureFormat[ Orig->ColorFormat ] != D_D3DFMT_DXT5 ) )
			{
				Flag1 = TRUE ;
			}

			if( TempBaseAlpha.GraphData != NULL )
			{
				if( ( TempBaseAlpha.ColorData.Format == DX_BASEIMAGE_FORMAT_DXT1 && GRH.TextureFormat[ Orig->ColorFormat ] != D_D3DFMT_DXT1 ) ||
					( TempBaseAlpha.ColorData.Format == DX_BASEIMAGE_FORMAT_DXT2 && GRH.TextureFormat[ Orig->ColorFormat ] != D_D3DFMT_DXT2 ) ||
					( TempBaseAlpha.ColorData.Format == DX_BASEIMAGE_FORMAT_DXT3 && GRH.TextureFormat[ Orig->ColorFormat ] != D_D3DFMT_DXT3 ) ||
					( TempBaseAlpha.ColorData.Format == DX_BASEIMAGE_FORMAT_DXT4 && GRH.TextureFormat[ Orig->ColorFormat ] != D_D3DFMT_DXT4 ) ||
					( TempBaseAlpha.ColorData.Format == DX_BASEIMAGE_FORMAT_DXT5 && GRH.TextureFormat[ Orig->ColorFormat ] != D_D3DFMT_DXT5 ) )
				{
					Flag2 = TRUE ;
				}
			}
		}
		else
		{
			if( TempBaseRGB.ColorData.Format == DX_BASEIMAGE_FORMAT_DXT1 ||
				TempBaseRGB.ColorData.Format == DX_BASEIMAGE_FORMAT_DXT2 ||
				TempBaseRGB.ColorData.Format == DX_BASEIMAGE_FORMAT_DXT3 ||
				TempBaseRGB.ColorData.Format == DX_BASEIMAGE_FORMAT_DXT4 ||
				TempBaseRGB.ColorData.Format == DX_BASEIMAGE_FORMAT_DXT5 )
			{
				Flag1 = TRUE ;
			}

			if( TempBaseAlpha.GraphData != NULL )
			{
				if( TempBaseAlpha.ColorData.Format == DX_BASEIMAGE_FORMAT_DXT1 ||
					TempBaseAlpha.ColorData.Format == DX_BASEIMAGE_FORMAT_DXT2 ||
					TempBaseAlpha.ColorData.Format == DX_BASEIMAGE_FORMAT_DXT3 ||
					TempBaseAlpha.ColorData.Format == DX_BASEIMAGE_FORMAT_DXT4 ||
					TempBaseAlpha.ColorData.Format == DX_BASEIMAGE_FORMAT_DXT5 )
				{
					Flag2 = TRUE ;
				}
			}
		}

		if( Flag1 == TRUE )
		{
			Hr1 = ConvertNormalFormatBaseImage( &TempBaseRGB ) ;
			if( Hr1 == 0 )
			{
				RequiredReleaseBaseRGB = TRUE ;
			}
		}

		if( Flag2 == TRUE )
		{
			Hr2 = ConvertNormalFormatBaseImage( &TempBaseAlpha ) ;
			if( Hr2 == 0 )
			{
				RequiredReleaseBaseAlpha = TRUE ;
			}
		}

		if( Hr1 < 0 || Hr2 < 0 )
		{
			DXST_ERRORLOG_ADD( _T( "WC[Wp̃mۂɎs܂\n" ) ) ;
			goto ERR ;
		}
	}

	// eNX`ǂŏ𕪊
	if( Orig->FormatDesc.TextureFlag )
	{
		// eNX`̏ꍇ

		// `I点Ă
//		RenderVertexHardware() ;
//		EndScene() ;
		if( GraphicsDevice_IsValid() == 0 )
			goto ERR ;

		// eNX`̃J[擾
		DestColor = GetD3DFormatColorData( GRH.TextureFormat[ Orig->ColorFormat ] ) ;

		// ]ʒũZbg
		DestPoint.x = 0 ;
		DestPoint.y = 0 ;

		// `\摜̏ꍇ͓]摜Ɠ傫̃VXeT[tFXɓe]
		if( Orig->FormatDesc.DrawValidFlag )
		{
			for( i = 0 ; i < ImageNum ; i ++ )
			{
				if( GraphicsDevice_CreateOffscreenPlainSurface_ASync( Width, Height, GRH.TextureFormat[ Orig->ColorFormat ], D_D3DPOOL_SYSTEMMEM, &SMSurface[ i ], NULL, ASyncThread ) != D_D3D_OK )
				{
					DXST_ERRORLOG_ADD( _T( "摜]p̃VXeeNX`̍쐬Ɏs܂\n" ) ) ;
					goto ERR ;
				}

				// VXeT[tFXbN
				GraphicsSurface_LockRect_ASync( SMSurface[ i ], &LockRect, NULL, D_D3DLOCK_DISCARD, ASyncThread ) ;

				// e]
				MovRect.left   = 0 ;
				MovRect.top    = 0 ;
				MovRect.right  = Width ;
				MovRect.bottom = Height ;
				NS_GraphColorMatchBltVer2(
					LockRect.pBits,                                                                LockRect.Pitch,                DestColor,
					( BYTE * )TempBaseRGB.GraphData   + TempBaseRGB.Pitch   * TempBaseRGB.Height   * i,   TempBaseRGB.Pitch,   &TempBaseRGB.ColorData,
					( BYTE * )TempBaseAlpha.GraphData + TempBaseAlpha.Pitch * TempBaseAlpha.Height * i, TempBaseAlpha.Pitch, &TempBaseAlpha.ColorData,
					DestPoint, &MovRect, FALSE,
					UseTransColorConvAlpha && ( DestColor->AlphaWidth != 0 && TempBaseAlpha.GraphData == NULL ), Orig->TransCode,
					BASEIM.ImageShavedMode, FALSE,
					RedIsAlphaFlag, FALSE,
					FALSE ) ;

				// VXeT[tFX̃bN
				GraphicsSurface_UnlockRect_ASync( SMSurface[ i ], ASyncThread ) ;
			}
		}

		// ]ΏۂIWi摜ɑ΂Ăǂŏ𕪊
		if( TargetOrig == TRUE )
		{
			// IWi摜ɑ΂Ă̏ꍇ

			// eNX`̐JԂ
			OrigTex = Orig->Hard.Tex ;
			for( i = 0 ; i < Orig->Hard.TexNum ; i ++, OrigTex ++ )
			{
				// ͈͊O牽Ȃ
				if( OrigTex->OrigPosX >= DestX + Width  ||
					OrigTex->OrigPosY >= DestY + Height ||
					DestX >= OrigTex->OrigPosX + OrigTex->UseWidth ||
					DestY >= OrigTex->OrigPosY + OrigTex->UseHeight ) continue ;

				// bN]͈͂Ɠ]͈͂̊m
				if( OrigTex->OrigPosX > DestX )
				{
					DestRect.left = 0 ;
					MovRect.left = OrigTex->OrigPosX - DestX ;
				}
				else
				{
					DestRect.left = DestX - OrigTex->OrigPosX ;
					MovRect.left = 0 ;
				}

				if( OrigTex->OrigPosX + OrigTex->UseWidth < DestX + Width )
				{
					DestRect.right = OrigTex->UseWidth ;
					MovRect.right = ( OrigTex->OrigPosX + OrigTex->UseWidth ) - DestX ;
				}
				else
				{
					DestRect.right = ( DestX + Width ) - OrigTex->OrigPosX ;
					MovRect.right = Width ;
				}

				if( OrigTex->OrigPosY > DestY )
				{
					DestRect.top = 0 ;
					MovRect.top = OrigTex->OrigPosY - DestY ;
				}
				else
				{
					DestRect.top = DestY - OrigTex->OrigPosY ;
					MovRect.top = 0 ;
				}

				if( OrigTex->OrigPosY + OrigTex->UseHeight < DestY + Height )
				{
					DestRect.bottom = OrigTex->UseHeight ;
					MovRect.bottom = ( OrigTex->OrigPosY + OrigTex->UseHeight ) - DestY ;
				}
				else
				{
					DestRect.bottom = ( DestY + Height ) - OrigTex->OrigPosY ;
					MovRect.bottom = Height ;
				}

				// 摜̓]̈lZ
				MovRect.left   += SrcRect->left ;
				MovRect.top    += SrcRect->top ;
				MovRect.right  += SrcRect->left ;
				MovRect.bottom += SrcRect->top ;

				// `\摜ǂŏ𕪊
				if( Orig->FormatDesc.DrawValidFlag == TRUE )
				{
					// `\摜̏ꍇ

					// e]
					DestPoint.x = DestRect.left ;
					DestPoint.y = DestRect.top ;
					for( j = 0 ; j < ImageNum ; j ++ )
					{
						GraphicsDevice_UpdateSurface_ASync(
							SMSurface[ j ],			&MovRect,
							OrigTex->Surface[ j ],	&DestPoint, ASyncThread ) ;
					}
					if( OrigTex->RenderTargetSurface )
					{
						GraphicsDevice_UpdateSurface_ASync(
							SMSurface[ 0 ],					&MovRect,
							OrigTex->RenderTargetSurface,	&DestPoint, ASyncThread ) ;
					}
				}
				else
				{
					// `s\摜̏ꍇ

					DestPoint.x = 0 ;
					DestPoint.y = 0 ;

					// gpeNX`̃Zbg
					// UseTex = Orig->FormatDesc.UseManagedTextureFlag == FALSE ? OrigTex->MemTexture : OrigTex->Texture ;
					if( Orig->FormatDesc.UseManagedTextureFlag == FALSE )
					{
						for(;;)
						{
							UseSysMemTex = GetSysMemTextureFromOrig( Orig, OrigTex, ASyncThread ) ;
							if( UseSysMemTex != -1 ) break ;
							if( NS_ProcessMessage() != 0 ) break ;
							Thread_Sleep( 1 ) ;
						}
						if( UseSysMemTex == -1 )
						{
							goto ERR ;
						}
						UseTex = GRH.SysMemTexture[ UseSysMemTex ].MemTexture ;
					}
					else
					{
						UseSysMemTex = -1 ;
						UseTex = OrigTex->Texture ;
					}

					// ~bv}bvǂŏ𕪊
					if( Orig->Hard.MipMapCount > 1 )
					{
						if( BltBmpOrBaseImageToGraph3_MipMapBlt(
								Orig,
								&MovRect,
								&DestRect,
								UseTex,
								OrigTex->TexWidth,
								OrigTex->TexHeight,
								&TempBaseRGB,
								&TempBaseAlpha,
								DestColor,
								RedIsAlphaFlag,
								UseTransColorConvAlpha,
								ASyncThread ) < 0 )
							goto ERR ;
					}
					else
					{
						if( BltBmpOrBaseImageToGraph3_NoMipMapBlt(
								Orig,
								&MovRect,
								&DestRect,
								UseTex,
								OrigTex->TexWidth,
								OrigTex->TexHeight,
								OrigTex->UseWidth,
								OrigTex->UseHeight,
								&TempBaseRGB,
								&TempBaseAlpha,
								DestColor,
								RedIsAlphaFlag,
								UseTransColorConvAlpha,
								ASyncThread ) < 0 )
							goto ERR ;
					}

					// ǗeNX`ł͂Ȃꍇ͂ŎeNX`ɉeNX`̃f[^]
					if( Orig->FormatDesc.UseManagedTextureFlag == FALSE )
					{
						if( Orig->FormatDesc.CubeMapTextureFlag )
						{
							GraphicsDevice_UpdateTexture_ASync( UseTex, OrigTex->CubeTexture, ASyncThread ) ;
						}
						else
						{
							GraphicsDevice_UpdateTexture_ASync( UseTex, OrigTex->Texture, ASyncThread ) ;
						}
						ReleaseSysMemTexture( UseSysMemTex, ASyncThread ) ;
						UseSysMemTex = -1 ;
					}
				}
			}
		}
		else
		{
			// IWi摜ɑ΂Ăł͂Ȃꍇ

			// `̐JԂ
			DrawTex = Image2->Hard.Draw ;
			DestPoint.x = 0 ;
			DestPoint.y = 0 ;
			for( i = 0 ; i < Image2->Hard.DrawNum ; i ++, DrawTex ++ )
			{
				// ͈͊O牽Ȃ
				if( DrawTex->DrawPosX >= DestX + Width ||
					DrawTex->DrawPosY >= DestY + Height ||
					DestX >= DrawTex->DrawPosX + DrawTex->Width ||
					DestY >= DrawTex->DrawPosY + DrawTex->Height ) continue ;

				// bN]͈͂Ɠ]͈͂̊m
				if( DrawTex->DrawPosX > DestX )
				{
					DestRect.left = 0 ;
					MovRect.left = DrawTex->DrawPosX - DestX ;
				}
				else
				{
					DestRect.left = DestX - DrawTex->DrawPosX ;
					MovRect.left = 0 ;
				}

				if( DrawTex->DrawPosX + DrawTex->Width < DestX + Width )
				{
					DestRect.right = DrawTex->Width ;
					MovRect.right = ( DrawTex->DrawPosX + DrawTex->Width ) - DestX ;
				}
				else
				{
					DestRect.right = ( DestX + Width ) - DrawTex->DrawPosX ;
					MovRect.right = Width ;
				}

				if( DrawTex->DrawPosY > DestY )
				{
					DestRect.top = 0 ;
					MovRect.top = DrawTex->DrawPosY - DestY ;
				}
				else
				{
					DestRect.top = DestY - DrawTex->DrawPosY ;
					MovRect.top = 0 ;
				}

				if( DrawTex->DrawPosY + DrawTex->Height < DestY + Height )
				{
					DestRect.bottom = DrawTex->Height ;
					MovRect.bottom = ( DrawTex->DrawPosY + DrawTex->Height ) - DestY ;
				}
				else
				{
					DestRect.bottom = ( DestY + Height ) - DrawTex->DrawPosY ;
					MovRect.bottom = Height ;
				}

				// eNX`̎ẅlZ
				DestRect.left   += DrawTex->UsePosX ;
				DestRect.top    += DrawTex->UsePosY ;
				DestRect.right  += DrawTex->UsePosX ;
				DestRect.bottom += DrawTex->UsePosY ;

				// 摜̓]̈lZ
				MovRect.left   += SrcRect->left ;
				MovRect.top    += SrcRect->top ;
				MovRect.right  += SrcRect->left ;
				MovRect.bottom += SrcRect->top ;

				// `\摜ǂŏ𕪊
				if( Orig->FormatDesc.DrawValidFlag == TRUE )
				{
					// `\摜̏ꍇ

					// e]
					DestPoint.x = DestRect.left ;
					DestPoint.y = DestRect.top ;
					for( j = 0 ; j < ImageNum ; j ++ )
					{
						if( GraphicsDevice_UpdateSurface_ASync(
								SMSurface[ j ],             &MovRect,
								DrawTex->Tex->Surface[ j ], &DestPoint, ASyncThread ) != D_D3D_OK )
						{
							DXST_ERRORLOG_ADD( _T( "`\eNX`ւ̉摜̓]Ɏs܂\n" ) ) ;
							goto ERR ;
						}
					}
				}
				else
				{
					// `s\摜̏ꍇ

					// gpeNX`̃Zbg
//					UseTex = Orig->FormatDesc.UseManagedTextureFlag == FALSE ? DrawTex->Tex->MemTexture : DrawTex->Tex->Texture ;
					if( Orig->FormatDesc.UseManagedTextureFlag == FALSE )
					{
						for(;;)
						{
							UseSysMemTex = GetSysMemTextureFromOrig( Orig, DrawTex->Tex, ASyncThread ) ;
							if( UseSysMemTex != -1 ) break ;
							if( NS_ProcessMessage() != 0 ) break ;
							Thread_Sleep( 1 ) ;
						}
						if( UseSysMemTex == -1 )
						{
							goto ERR ;
						}
						UseTex = GRH.SysMemTexture[ UseSysMemTex ].MemTexture ;
					}
					else
					{
						UseSysMemTex = -1 ;
						UseTex = DrawTex->Tex->Texture ;
					}

					// ~bv}bvǂŏ𕪊
					if( Orig->Hard.MipMapCount > 1 )
					{
						if( BltBmpOrBaseImageToGraph3_MipMapBlt(
								Orig,
								&MovRect,
								&DestRect,
								UseTex,
								DrawTex->Tex->TexWidth,
								DrawTex->Tex->TexHeight,
								&TempBaseRGB,
								&TempBaseAlpha,
								DestColor,
								RedIsAlphaFlag,
								UseTransColorConvAlpha,
								ASyncThread ) < 0 )
							goto ERR ;
					}
					else
					{
						if( BltBmpOrBaseImageToGraph3_NoMipMapBlt(
								Orig,
								&MovRect,
								&DestRect,
								UseTex,
								DrawTex->Tex->TexWidth,
								DrawTex->Tex->TexHeight,
								DrawTex->Tex->UseWidth,
								DrawTex->Tex->UseHeight,
								&TempBaseRGB,
								&TempBaseAlpha,
								DestColor,
								RedIsAlphaFlag,
								UseTransColorConvAlpha,
								ASyncThread ) < 0 )
							goto ERR ;
					}

					// ǗeNX`ł͂Ȃꍇ͂ŎeNX`ɉeNX`̃f[^]
					if( Orig->FormatDesc.UseManagedTextureFlag == FALSE )
					{
						if( Orig->FormatDesc.CubeMapTextureFlag )
						{
							GraphicsDevice_UpdateTexture_ASync( UseTex, DrawTex->Tex->CubeTexture, ASyncThread ) ;
						}
						else
						{
							GraphicsDevice_UpdateTexture_ASync( UseTex, DrawTex->Tex->Texture, ASyncThread ) ;
						}
						ReleaseSysMemTexture( UseSysMemTex, ASyncThread ) ;
						UseSysMemTex = -1 ;
					}
				}
			}
		}
	}
	else
	{
		// eNX`ł͂Ȃꍇ

		// MEMIMG ̓]֐g߂̏s

		// IWi摜Ώۂǂŏ𕪊
		if( TargetOrig == TRUE )
		{
			// IWi摜Ώۂ̏ꍇ

			// TCY̕␳
			if( DestX + Width  > ( int )Orig->Soft.MemImg.Width  ) Width  = Orig->Soft.MemImg.Width  - DestX ;
			if( DestY + Height > ( int )Orig->Soft.MemImg.Height ) Height = Orig->Soft.MemImg.Height - DestY ;
			if( Width <= 0 || Height <= 0 )
				goto ERR ;

			// 摜̓]
			BltBaseImageToMemImg(
				&TempBaseRGB, TempBaseAlpha.GraphData == NULL ? NULL : &TempBaseAlpha, &Orig->Soft.MemImg,
				SrcRect->left, SrcRect->top,
				Width, Height,
				DestX, DestY, UseTransColorConvAlpha ) ;
		}
		else
		{
			// IWi摜Ώۂł͂Ȃꍇ

			// TCY̕␳
			if( DestX + Width  > Image2->Width  ) Width  = Image2->Width  - DestX ;
			if( DestY + Height > Image2->Height ) Height = Image2->Height - DestY ;
			if( Width <= 0 || Height <= 0 ) 
				goto ERR ;

			// 摜̓]
			BltBaseImageToMemImg(
				&TempBaseRGB, TempBaseAlpha.GraphData == NULL ? NULL : &TempBaseAlpha, &Orig->Soft.MemImg,
				SrcRect->left, SrcRect->top,
				Width, Height,
				Image2->UseOrigX + DestX, Image2->UseOrigY + DestY, UseTransColorConvAlpha ) ;
		}

		// pbg摜̏ꍇ͓ߐFR[h𒲐
		if( Orig->FormatDesc.UsePaletteFlag == TRUE && Orig->Soft.MemImg.Base->Palette )
		{
			int i ;
			DWORD TransCode ;

			// ߐF̎擾
			TransCode = NS_GetColor3( 
					GetMemImgColorData( Orig->FormatDesc.ColorBitDepth == 16 ? 0 : 1, Orig->FormatDesc.AlphaChFlag, FALSE ),
					( GBASE.TransColor >> 16 ) & 0xff,
					( GBASE.TransColor >> 8  ) & 0xff,
					( GBASE.TransColor >> 0  ) & 0xff,
					0xff ) ;

			// w̃J[pbg̒ɂ炻𓧉ߐFɂ
			if( Orig->Soft.MemImg.Base->ColorType == 1 )
			{
				TransCode &= 0xffffff;
				for( i = 0 ; i < 256 ; i ++ )
					if( ( Orig->Soft.MemImg.Base->Palette[i] & 0xffffff ) == TransCode ) break ;
			}
			else
			{
				TransCode &= 0xffff;
				for( i = 0 ; i < 256 ; i ++ )
					if( ((WORD *)Orig->Soft.MemImg.Base->Palette)[i] == TransCode ) break ;
			}
			if( i == 256 ) i = 0 ;
			Orig->Soft.MemImg.Base->TransColor = i ;
		}
	}

	if( RequiredReleaseBaseRGB )
	{
		ReleaseBaseImage( &TempBaseRGB ) ;
	}

	if( RequiredReleaseBaseAlpha )
	{
		ReleaseBaseImage( &TempBaseAlpha ) ;
	}

	for( i = 0 ; i < CUBEMAP_SURFACE_NUM ; i ++ )
	{
		if( SMSurface[ i ] != NULL )
		{
			Graphics_ObjectRelease_ASync( SMSurface[ i ], ASyncThread ) ;
			SMSurface[ i ] = NULL ;
		}
	}

	if( UseSysMemTex != -1 )
	{
		ReleaseSysMemTexture( UseSysMemTex, ASyncThread ) ;
		UseSysMemTex = -1 ;
	}

	// I
	return 0 ;

	// G[I
ERR :

	if( RequiredReleaseBaseRGB )
	{
		ReleaseBaseImage( &TempBaseRGB ) ;
	}

	if( RequiredReleaseBaseAlpha )
	{
		ReleaseBaseImage( &TempBaseAlpha ) ;
	}

	for( i = 0 ; i < CUBEMAP_SURFACE_NUM ; i ++ )
	{
		if( SMSurface[ i ] != NULL )
		{
			Graphics_ObjectRelease_ASync( SMSurface[ i ], ASyncThread ) ;
			SMSurface[ i ] = NULL ;
		}
	}

	if( UseSysMemTex != -1 )
	{
		ReleaseSysMemTexture( UseSysMemTex, ASyncThread ) ;
		UseSysMemTex = -1 ;
	}

	return -1 ;
}



// \tgEGA_Ȍs
static int InitializeSoftware()
{
	// Cʗp MEMIMG ̍쐬
	if( MakeMemImgScreen( &GRS.MainBufferMemImg, GRA2.MainScreenSizeX, GRA2.MainScreenSizeY,
							GRA2.MainScreenColorBitDepth == 16 ? 0 : 1 ) < 0 )
		return DxLib_Error( DXSTRING( _T( "vC}T[tFXp MEMIMG ̍쐬Ɏs܂\n" ) ) ) ;

	// tHg̔`pAt@摜̍쐬
	_MEMSET( &GRS.FontScreenMemImgAlpha, 0, sizeof( MEMIMG ) ) ;
	_MEMSET( &GRS.FontScreenMemImgNormal, 0, sizeof( MEMIMG ) ) ;
	InitializeMemImg(
		&GRS.FontScreenMemImgNormal,
		GRA2.MainScreenSizeX,
		GRA2.MainScreenSizeY,
		-1,
		0,
		GRA2.MainScreenColorBitDepth == 16 ? 0 : 1,
		FALSE, FALSE, FALSE, NULL ) ;
	InitializeMemImg(
		&GRS.FontScreenMemImgAlpha,
		GRA2.MainScreenSizeX,
		GRA2.MainScreenSizeY,
		-1,
		0,
		GRA2.MainScreenColorBitDepth == 16 ? 0 : 1,
		FALSE, TRUE, FALSE, NULL ) ;

	// obt@̃NA
	ClearMemImg( &GRS.MainBufferMemImg, NULL, NS_GetColor3( GRS.MainBufferMemImg.Base->ColorDataP, GRA2.BackgroundRed, GRA2.BackgroundGreen, GRA2.BackgroundBlue, 0 ) ) ;

	// `Ώۂ̃Zbg
	GRS.TargetMemImg = &GRS.MainBufferMemImg ;

	// I
	return 0 ;
}

// \tgEGA_Ǒns
static int	TerminateSoftware()
{
	// Cobt@̉
	TerminateMemImg( &GRS.MainBufferMemImg ) ;

	// tHg̔`pAt@摜̉
	TerminateMemImg( &GRS.FontScreenMemImgNormal ) ;
	TerminateMemImg( &GRS.FontScreenMemImgAlpha ) ;

	// I
	return 0 ;
}












// rMV[s
extern void BeginScene( void )
{
	if( Graphics_IsValid() == 0 || GRH.BeginSceneFlag == TRUE ) return ;

	GraphicsDevice_BeginScene() ;
	GRH.BeginSceneFlag = TRUE ;

	GRH.DrawPrepFormat    = NULL ;
	GRH.DrawPrepTexture   = NULL ;
	GRH.DrawPrepParamFlag = 0 ;
}

// GhV[s
extern void EndScene( void )
{
	if( Graphics_IsValid() == 0 || GRH.BeginSceneFlag == FALSE ) return ;

	GraphicsDevice_EndScene() ;
	GRH.BeginSceneFlag = FALSE ;
}

// tH[}bgZbgAbv
static int SetupFormatDesc( 
	IMAGEFORMATDESC *Format,
	SETUP_GRAPHHANDLE_GPARAM *GParam,
	int Width,
	int Height,
	int AlphaValidFlag,
	int UsePaletteFlag,
	int BaseFormat,
	int MipMapCount
)
{
	// tH[}bg
	_MEMSET( Format, 0, sizeof( *Format ) ) ;

	// eNX`tH[}bgǂZbg
	Format->TextureFlag = ( unsigned char )GRA2.ValidHardWare ;

	// DirectX ǗeNX`ɂȂǂZbg
	Format->UseManagedTextureFlag = ( unsigned char )GParam->UseManagedTextureFlag ;

	// L[u}bvǂZbg
	Format->CubeMapTextureFlag = ( unsigned char )GParam->CubeMapTextureCreateFlag ;

	// {tH[}bg̃Zbg
	Format->BaseFormat = ( unsigned char )BaseFormat ;

	// ~bv}bv̐ۑ
	if( MipMapCount != -1 )
	{
		Format->MipMapCount = ( unsigned char )MipMapCount ;
	}
	else
	{
		if( GParam->MipMapCount == -1 )
		{
			int tx, ty ;

			tx = Width ;
			ty = Height ;
			Format->MipMapCount = 1 ;
			for(;;)
			{
				if( tx == 1 && ty == 1 ) break ;
				Format->MipMapCount ++ ;
				tx /= 2 ;
				ty /= 2 ;
				if( tx == 0 ) tx = 1 ;
				if( ty == 0 ) ty = 1 ;
			}
		}
		else
		{
			Format->MipMapCount = GParam->MipMapCount == 0 ? 1 : ( unsigned char )GParam->MipMapCount ;
		}
	}

	// `\摜ǂŏ𕪊
	if( GParam->DrawValidImageCreateFlag == TRUE )
	{
		// `\ȏꍇ̓At@eXgAuhOtBbN͖ŁA
		// At@`lǂ GBASE.DrawValidAlphaImageCreateFlag ̒lɏ]
		// {tH[}bg͋I DX_BASEIMAGE_FORMAT_NORMAL
		Format->DrawValidFlag = TRUE ;
		Format->AlphaChFlag = ( unsigned char )GParam->DrawValidAlphaImageCreateFlag ;
		Format->AlphaTestFlag = FALSE ;		// `\ȏꍇ̓At@eXg͖
		Format->BlendGraphFlag = FALSE ;		// `\ȏꍇ̓uh摜
		Format->UseManagedTextureFlag = FALSE ;
		Format->MipMapCount = 1 ;
		Format->MSSamples = ( unsigned char )GParam->DrawValidMSSamples ;
		Format->MSQuality = ( unsigned char )GParam->DrawValidMSQuality ;
	}
	else
	{
		// `\w肪ꍇ̓At@`lt邩ǂ͈
		// At@eXgt邩ǂ GBASE.AlphaTestImageCreateFlag 
		// uh摜ɂ邩ǂ GBASE.BlendImageCreateFlag ɏ]
		Format->DrawValidFlag = FALSE ;
		Format->AlphaChFlag = ( unsigned char )AlphaValidFlag ;
		Format->AlphaTestFlag = ( unsigned char )GParam->AlphaTestImageCreateFlag ;
		Format->BlendGraphFlag = ( unsigned char )GParam->BlendImageCreateFlag ;
	}

	// eNX`ǂŏ𕪊
	if( Format->TextureFlag == TRUE )
	{
		// eNX`̏ꍇ

		// J[rbg[x̌
		Format->ColorBitDepth = ( unsigned char )( GParam->CreateImageColorBitDepth == 0 ? ( AlphaValidFlag == TRUE ? 32 : GRA2.MainScreenColorBitDepth ) : GParam->CreateImageColorBitDepth ) ;
		Format->ChannelNum = 0 ;
		Format->ChannelBitDepth = 0 ;
		Format->FloatTypeFlag = FALSE ;
		Format->SystemMemFlag = FALSE ;

		// At@`l̏ꍇ̓At@eXg͖
		if( Format->AlphaChFlag )
			Format->AlphaTestFlag = FALSE ;

		// uh摜̏ꍇ̓tH[}bg͌Œ肳
		if( Format->BlendGraphFlag == TRUE )
		{
			Format->ColorBitDepth = 32 ;
			Format->AlphaTestFlag = FALSE ;
			Format->AlphaChFlag   = TRUE ;
			Format->DrawValidFlag = FALSE ;
		}
		else
		// `\摜̏ꍇ̓`lƃ`lӂ̃rbgA_^ǂݒ肷
		if( GParam->DrawValidImageCreateFlag == TRUE )
		{
			Format->ChannelNum      = ( unsigned char )GParam->CreateDrawValidGraphChannelNum ;
			Format->ChannelBitDepth = ( unsigned char )GParam->CreateImageChannelBitDepth ;
			Format->FloatTypeFlag   = ( unsigned char )GParam->DrawValidFloatTypeGraphCreateFlag ;
		}
	}
	else
	{
		// eNX`ł͂Ȃꍇ
		Format->BaseFormat = DX_BASEIMAGE_FORMAT_NORMAL ;
		Format->ColorBitDepth = ( unsigned char )( GParam->CreateImageColorBitDepth == 0 ? GRA2.MainScreenColorBitDepth : GParam->CreateImageColorBitDepth ) ;
		Format->ChannelNum = 0 ;
		Format->ChannelBitDepth = 0 ;
		Format->FloatTypeFlag = FALSE ;
		Format->SystemMemFlag = TRUE ;
		Format->CubeMapTextureFlag = FALSE ;
		Format->UsePaletteFlag = ( unsigned char )UsePaletteFlag ;
		Format->UseManagedTextureFlag = FALSE ;		// DirectX ̊Ǘ
		Format->AlphaTestFlag = FALSE ;				// At@eXg͖
		Format->DrawValidFlag = Format->BlendGraphFlag ? FALSE : TRUE ;	// ʂ̉摜̏ꍇ̓uh摜ł͂ȂΕ`\
		Format->MipMapCount = 0 ;
	}

	// I
	return 0 ;
}

// `ɐlނǂ̃tOXV
static	int RefreshAlphaChDrawMode( void )
{
	IMAGEDATA2 *Image2 ;
	int i ;
	int NextFlag ;

	NextFlag = FALSE ;

	// OԈȊOɂ`悪ݒ肳Ăꍇ͒ʏ탂[h
	for( i = 1 ; i < DX_RENDERTARGET_COUNT ; i ++ )
	{
		if( GBASE.TargetScreen[ i ] != 0 )
			goto END ;
	}

	// `悪ʏʂ̏ꍇ͉Ȃ
	if( GBASE.TargetScreen[ 0 ] == DX_SCREEN_BACK ||
		GBASE.TargetScreen[ 0 ] == DX_SCREEN_FRONT ||
		GBASE.TargetScreen[ 0 ] == DX_SCREEN_WORK ||
		GBASE.TargetScreen[ 0 ] == DX_SCREEN_TEMPFRONT )
		goto END ;

	// `ƂȂĂ摜̏ꍇ͉Ȃ
	if( GRAPHCHKFULL( GBASE.TargetScreen[ 0 ], Image2 ) )
		goto END ;

	// `̉摜Ƀ`lꍇȂ
	if( Image2->Orig->FormatDesc.AlphaChFlag == FALSE )
		goto END ;
	
	// eNX`ł͂Ȃꍇ͉Ȃ
	if( Image2->Orig->FormatDesc.TextureFlag == FALSE )
		goto END ;

	// ɗƂƂ͐mȃ`ľvZsƂ
	NextFlag = TRUE ;

END :

	// eNX`̕ۑ
	if( NextFlag == TRUE )
	{
		IMAGEDATA2 *WorkImage2 ;
		int WorkTextureHandle ;

		WorkTextureHandle = GetWorkTexture( Image2->Width, Image2->Height, 0 ) ;
		if( GRAPHCHK( WorkTextureHandle, WorkImage2 ) )
			return -1 ;

		GRH.RenderTargetTexture          = WorkImage2->Orig->Hard.Tex[ 0 ].Texture ;
		GRH.RenderTargetSurface          =     Image2->Orig->Hard.Tex[ 0 ].Surface[ 0 ] ;
		GRH.RenderTargetCopySurface      = WorkImage2->Orig->Hard.Tex[ 0 ].Surface[ 0 ] ;
		GRH.RenderTargetTextureInvWidth  = 1.0f / WorkImage2->Orig->Hard.Tex[ 0 ].TexWidth ;
		GRH.RenderTargetTextureInvHeight = 1.0f / WorkImage2->Orig->Hard.Tex[ 0 ].TexHeight ;
	}
	else
	{
		GRH.RenderTargetTexture = FALSE ;
	}

	// ȑOƃtȌԂقȂꍇ̂݃uh[h̍XVs
	if( NextFlag != GBASE.AlphaChDrawMode )
	{
		// tO̕ۑ
		GBASE.AlphaChDrawMode = NextFlag ;
		GRH.ChangeBlendParamFlag = TRUE ;
		GRH.DrawPrepAlwaysFlag = TRUE ;
	}

	// I
	return 0 ;
}

// OtBbNnh
extern int SetupGraphHandle_UseGParam(
	SETUP_GRAPHHANDLE_GPARAM *GParam,
	int GrHandle,
	int Width,
	int Height,
	int /*TextureFlag*/,
	int AlphaValidFlag,
	int UsePaletteFlag,
	int BaseFormat,
	int MipMapCount,
	int ASyncThread
) 
{
	IMAGEDATA2 *Image2 ;
	IMAGEDATA2_ORIG *Orig ;
	int IsTex ;
	int DivXNum, DivYNum, DivNum ;
	short TexSizeX[ 256 ], TexSizeY[ 256 ] ;
	short TexPosX[ 256 ], TexPosY[ 256 ] ;
	short XList[ 32 ], YList[ 32 ] ;
	int XPos, YPos ;
	int AllocSize ;
	int i, j ;
	IMAGEDATA2_ORIG_HARD_TEX *OrigTex ;
	IMAGEFORMATDESC Format ;

	// AhX̎擾
	if( GRAPHCHK_ASYNC( GrHandle, Image2 ) )
		return -1 ;

	// eNX`ǂ肷
//	IsTex = TextureFlag &&						// ֐̈ŃeNX`쐬w肪
//	        GBASE.TextureImageCreateFlag &&		// O[oݒłeNX`쐬w肪
//			GRA2.ValidHardWare ;				// Rc`@\ĂꍇAeNX`
	IsTex = GRA2.ValidHardWare ;

	// tH[}bgZbg
	SetupFormatDesc( &Format, GParam, Width, Height, AlphaValidFlag, UsePaletteFlag, BaseFormat, MipMapCount ) ;

	// eNX`̏ꍇ͉ɂȂ邩ׂ
	if( IsTex )
	{
		// 쐬eNX`̃TCYXgAbv
//		DivXNum = ListUpTexSize( Width,  XList, Format.DrawValidFlag | Format.BlendGraphFlag | GParam->NotUseDivFlag, Format.DrawValidFlag == FALSE, GParam->UserMaxTextureSize ) ;
//		DivYNum = ListUpTexSize( Height, YList, Format.DrawValidFlag | Format.BlendGraphFlag | GParam->NotUseDivFlag, Format.DrawValidFlag == FALSE, GParam->UserMaxTextureSize ) ;
		// fbg傫ȂĂ̂ŁA{IɍőeNX`[TCYɎ܂͂Pōς܂悤ɏύX
		DivXNum = ListUpTexSize( Width,  XList, TRUE, Format.DrawValidFlag == FALSE, GParam->UserMaxTextureSize ) ;
		DivYNum = ListUpTexSize( Height, YList, TRUE, Format.DrawValidFlag == FALSE, GParam->UserMaxTextureSize ) ;

		// Zbg
		DivNum = DivXNum * DivYNum ;

		// ʒuƃTCYZbg
		YPos = 0 ;
		for( i = 0 ; i < DivYNum ; i ++ )
		{
			XPos = 0 ;
			for( j = 0 ; j < DivXNum ; j ++ )
			{
				TexPosX[ i * DivXNum + j ] = ( short )XPos ;
				TexPosY[ i * DivXNum + j ] = ( short )YPos ;

				TexSizeX[ i * DivXNum + j ] = XList[ j ] ;
				TexSizeY[ i * DivXNum + j ] = YList[ i ] ;

				XPos += XList[ j ] ;
			}
			YPos += YList[ i ] ;
		}

		// n[hEFAɉăeNX`𐳕`ɂ
		if( GRH.DeviceCaps.TextureCaps & D_D3DPTEXTURECAPS_SQUAREONLY )
		{
			int Size, DNum, MotoDivNum ;
			int PosX, PosY ;

			MotoDivNum = DivXNum * DivYNum ;
			for( i = 0 ; i < MotoDivNum ; i ++ )
			{
				if( TexSizeX[ i ] != TexSizeY[ i ] )
				{
					if( TexSizeX[ i ] < TexSizeY[ i ] )
					{
						Size = TexSizeX[ i ] ;
						DNum = TexSizeY[ i ] / TexSizeX[ i ] ;
						TexSizeY[ i ] = ( short )Size ;
						PosX = TexPosX[ i ] ;
						PosY = TexPosY[ i ] ;
						for( j = 0 ; j < DNum - 1 ; j ++ )
						{
							TexSizeX[ DivNum + j ] = ( short )Size ;
							TexSizeY[ DivNum + j ] = ( short )Size ;
							TexPosX[ DivNum + j ] = ( short )PosX ;
							TexPosY[ DivNum + j ] = ( short )( PosY + Size * ( j + 1 ) ) ;
						}
						DivNum += DNum - 1 ;
					}
					else
					{
						Size = TexSizeY[ i ] ;
						DNum = TexSizeX[ i ] / TexSizeY[ i ] ;
						TexSizeX[ i ] = ( short )Size ;
						PosX = TexPosX[ i ] ;
						PosY = TexPosY[ i ] ;
						for( j = 0 ; j < DNum - 1 ; j ++ )
						{
							TexSizeY[ DivNum + j ] = ( short )Size ;
							TexSizeX[ DivNum + j ] = ( short )Size ;
							TexPosY[ DivNum + j ] = ( short )PosY ;
							TexPosX[ DivNum + j ] = ( short )( PosX + Size * ( j + 1 ) ) ;
						}
						DivNum += DNum - 1 ;
					}
				}
			}
		}
	}

	// mۃ̊m
	AllocSize = sizeof( IMAGEDATA2_ORIG ) - ( ( sizeof( IMAGEDATA2_ORIG_SOFT ) > sizeof( IMAGEDATA2_ORIG_HARD ) ? sizeof( IMAGEDATA2_ORIG_SOFT ) : sizeof( IMAGEDATA2_ORIG_HARD ) ) ) ;
	if( IsTex )
	{
		AllocSize += sizeof( IMAGEDATA2_ORIG_HARD ) + ( DivNum - 4 ) * sizeof( IMAGEDATA2_ORIG_HARD_TEX ) ;
	}
	else
	{
		AllocSize += sizeof( IMAGEDATA2_ORIG_SOFT ) ;
	}

	// IWi摜\̗p̃̊m
	Image2->Orig = ( IMAGEDATA2_ORIG * )DXCALLOC( AllocSize ) ;
	if( Image2->Orig == NULL )
	{
		DXST_ERRORLOG_ADD( _T( "OtBbÑIWi摜f[^ۑp̊mۂɎs܂\n" ) ) ;
		goto ERR ;
	}
	Orig = Image2->Orig ;

	// tH[}bgZbg
	Orig->FormatDesc = Format ;

	// ߐFZbg
	Orig->TransCode = GParam->TransColor ;

	// ƍۑ
	Image2->UseOrigX = 0 ;
	Image2->UseOrigY = 0 ;
	Image2->Width = Width ;
	Image2->Height = Height ;
	Image2->Orig->Width = Width ;
	Image2->Orig->Height = Height ;

	// QƐ
	Image2->Orig->RefCount = 1 ;

	// IWi摜̏
	if( Orig->FormatDesc.TextureFlag )
	{
		// eNX`̏ꍇ

		// tH[}bǧ
		Orig->ColorFormat = NS_GetTexFormatIndex( &Orig->FormatDesc ) ;

		// eNX`ɍ킹ăeNX`񃊃Xgp̃mۂ
		Orig->Hard.TexNum = DivNum ;

		// ~bv}bv̐Zbg
//		Orig->Hard.MipMap = Orig->FormatDesc.DrawValidFlag ? FALSE : GRH.MipMapFlag ;
		if( Orig->ColorFormat == DX_GRAPHICSIMAGE_FORMAT_3D_DXT1 ||
			Orig->ColorFormat == DX_GRAPHICSIMAGE_FORMAT_3D_DXT2 ||
			Orig->ColorFormat == DX_GRAPHICSIMAGE_FORMAT_3D_DXT3 ||
			Orig->ColorFormat == DX_GRAPHICSIMAGE_FORMAT_3D_DXT4 ||
			Orig->ColorFormat == DX_GRAPHICSIMAGE_FORMAT_3D_DXT5 )
		{
			Orig->Hard.MipMapCount = 1 ;
		}
		else
		{
			Orig->Hard.MipMapCount = Format.MipMapCount ;
		}

		// 肵eNX`[TCYŃeNX`[
		OrigTex = Orig->Hard.Tex ;
		for( i = 0 ; i < DivNum ; i ++, OrigTex ++ )
		{
			OrigTex->UseWidth  = Orig->Width  - TexPosX[ i ] ;
			OrigTex->UseHeight = Orig->Height - TexPosY[ i ] ;
			if( OrigTex->UseWidth  > TexSizeX[ i ] ) OrigTex->UseWidth  = TexSizeX[ i ] ; 
			if( OrigTex->UseHeight > TexSizeY[ i ] ) OrigTex->UseHeight = TexSizeY[ i ] ;

			OrigTex->OrigPosX = TexPosX[ i ] ;
			OrigTex->OrigPosY = TexPosY[ i ] ;

			OrigTex->TexWidth  = TexSizeX[ i ] ;
			OrigTex->TexHeight = TexSizeY[ i ] ;
		}

/*
		// `\ŉ𑜓xobNobt@ȏ̏ꍇ͐p̂yobt@
		if( Orig->FormatDesc.DrawValidFlag &&
			( Orig->Hard.Tex[ 0 ].TexWidth  > GRA2.MainScreenSizeX ||
			  Orig->Hard.Tex[ 0 ].TexHeight > GRA2.MainScreenSizeY ) )
		{
			Orig->ZBufferFlag = TRUE ;
		}
*/
		// `\ȏꍇłyobt@쐬ȂtOĂȂꍇ͂yobt@
		if( Orig->FormatDesc.DrawValidFlag && GParam->DrawValidGraphCreateZBufferFlag )
		{
			Orig->ZBufferFlag = TRUE ;
			switch( GParam->CreateDrawValidGraphZBufferBitDepth )
			{
			default :
			case 16 : Orig->ZBufferBitDepthIndex = ZBUFFER_FORMAT_16BIT ; break ;
			case 24 : Orig->ZBufferBitDepthIndex = ZBUFFER_FORMAT_24BIT ; break ;
			case 32 : Orig->ZBufferBitDepthIndex = ZBUFFER_FORMAT_32BIT ; break ;
			}
		}

		// IDirect3DTexture9 ̍쐬
		if( CreateOrigTexture( Orig, ASyncThread ) == -1 )
			goto ERR ;
	}
	else
	{
		// eNX`ł͂Ȃꍇ

		// uhp摜̏ꍇƂȊOŏ𕪊
		if( Orig->FormatDesc.BlendGraphFlag == TRUE )
		{
			// C[W̍쐬
			if( InitializeMemImg( &Orig->Soft.MemImg, Orig->Width, Orig->Height, -1, 0, 2, FALSE, FALSE, FALSE ) < 0 )
			{
				DXST_ERRORLOG_ADD( _T( "uh摜pC[W̍쐬Ɏs܂\n" ) ) ;
				goto ERR ;
			}
		}
		else
		{
			DWORD TransColor ;

			// sNZtH[}bg̃CfbNXZbg
			if( Orig->FormatDesc.ColorBitDepth == 16 )
			{
				if( Orig->FormatDesc.AlphaChFlag )	Orig->ColorFormat = DX_GRAPHICSIMAGE_FORMAT_X8A8R5G6B5 ;
				else								Orig->ColorFormat = DX_GRAPHICSIMAGE_FORMAT_R5G6B5 ;
			}
			else
			{
				if( Orig->FormatDesc.AlphaChFlag )	Orig->ColorFormat = DX_GRAPHICSIMAGE_FORMAT_A8R8G8B8 ;
				else								Orig->ColorFormat = DX_GRAPHICSIMAGE_FORMAT_X8R8G8B8 ;
			}
			
			if( Orig->FormatDesc.UsePaletteFlag == TRUE )
			{
				TransColor = 0xffff ;
			}
			else
			{
				TransColor = NS_GetColor3( 
						GetMemImgColorData( Orig->FormatDesc.ColorBitDepth == 16 ? 0 : 1, Orig->FormatDesc.AlphaChFlag, FALSE ),
						( GBASE.TransColor >> 16 ) & 0xff,
						( GBASE.TransColor >> 8  ) & 0xff,
						( GBASE.TransColor >> 0  ) & 0xff,
						0xff ) ;
			}

			// C[W̍쐬
			if( InitializeMemImg(
					&Orig->Soft.MemImg,
					Orig->Width,
					Orig->Height,
					-1,
					TransColor,
					Orig->FormatDesc.ColorBitDepth == 16 ? 0 : 1,
					Orig->FormatDesc.UsePaletteFlag,
					Orig->FormatDesc.AlphaChFlag,
					FALSE
				) < 0 )
			{
				DXST_ERRORLOG_ADD( _T( "C[W̍쐬Ɏs܂\n" ) ) ;
				goto ERR ;
			}
		}
	}

	// `̏
	if( InitializeGraphDrawInfo( GrHandle, ASyncThread ) < 0 )
		goto ERR ;

	// I
	return 0 ;

	// G[I
ERR :
	NS_DeleteGraph( GrHandle ) ;

	return -1 ;
}

// w蕔𔲂oOtBbNnh
static int InitializeDerivationGraphHandle( int GrHandle, int SrcX, int SrcY, int Width, int Height, int SrcGrHandle, int ASyncThread )
{
	IMAGEDATA2 *Image2, *SrcImage2 ;
	IMAGEDATA2_ORIG *Orig ;

	// AhX̎擾
	if( ASyncThread )
	{
		if( GRAPHCHK_ASYNC( GrHandle, Image2 ) ||
			GRAPHCHK_ASYNC( SrcGrHandle, SrcImage2 ) )
			return -1 ;
	}
	else
	{
		if( GRAPHCHK( GrHandle, Image2 ) )
			return -1 ;

		if( GRAPHCHK( SrcGrHandle, SrcImage2 ) )
			return -1 ;
	}
	Orig = SrcImage2->Orig ;

	// IWi摜̎QƐCNg
	Image2->Orig = Orig ;
	Orig->RefCount ++ ;

	// t@C̏Rs[
	SetGraphName( GrHandle, NULL, FALSE, SrcGrHandle, ASyncThread ) ;
	Image2->UseBaseX = SrcImage2->UseBaseX + SrcX ;
	Image2->UseBaseY = SrcImage2->UseBaseY + SrcY ;

	// IWi摜̎QƍWZbg
	Image2->UseOrigX = SrcImage2->UseOrigX + SrcX ;
	Image2->UseOrigY = SrcImage2->UseOrigY + SrcY ;

	// TCYۑ
	Image2->Width = Width ;
	Image2->Height = Height ;

	//`̏
	InitializeGraphDrawInfo( GrHandle, ASyncThread ) ;

	// I
	return 0 ;
}

// OtBbNnh̕`
static int InitializeGraphDrawInfo( int GrHandle, int ASyncThread )
{
	IMAGEDATA2 *Image2 ;
	IMAGEDATA2_ORIG *Orig ;
	IMAGEDATA2_ORIG_HARD_TEX *OrigTex ;
	IMAGEDATA2_HARD_DRAW *DrawTex ;
	int i, Num, Size, Handle ;
	bool List[ 256 ] ;
	double d ;

	// AhX̎擾
	if( ASyncThread )
	{
		if( GRAPHCHK_ASYNC( GrHandle, Image2 ) )
			return -1 ;
	}
	else
	{
		if( GRAPHCHK( GrHandle, Image2 ) )
			return -1 ;
	}
	Orig = Image2->Orig ;
	Handle = Image2->HandleInfo.Handle ;

	// {mۃ̎Zo
	Size = sizeof( IMAGEDATA2 ) - ( ( sizeof( IMAGEDATA2_SOFT ) > sizeof( IMAGEDATA2_HARD ) ? sizeof( IMAGEDATA2_SOFT ) : sizeof( IMAGEDATA2_HARD ) ) ) ;

	// eNX`ǂŏ𕪊
	if( Orig->FormatDesc.TextureFlag )
	{
		// eNX`̏ꍇ

		// _^CvvZɎgpl̏
		d = ( double )Image2->Height / ( double )Image2->Width ;

		// 摜镔̐𐔂
		OrigTex = Orig->Hard.Tex ;
		Num = 0 ;
		for( i = 0 ; i < Orig->Hard.TexNum ; i ++, OrigTex ++ )
		{
			if(
				(
				  (
				    OrigTex->OrigPosX <= Image2->UseOrigX  &&
					OrigTex->OrigPosX + OrigTex->UseWidth  > Image2->UseOrigX
				  ) ||
				  (
				    Image2->UseOrigX  <= OrigTex->OrigPosX &&
					Image2->UseOrigX  + Image2->Width      > OrigTex->OrigPosX
				  )
				) &&
				(
				  (
				    OrigTex->OrigPosY <= Image2->UseOrigY  &&
					OrigTex->OrigPosY + OrigTex->UseHeight > Image2->UseOrigY
				  ) ||
				  (
				    Image2->UseOrigY  <= OrigTex->OrigPosY &&
					Image2->UseOrigY  + Image2->Height     > OrigTex->OrigPosY
				  )
				)
			  )
			{
				Num ++ ;
				List[ i ] = true ;
			}
			else
			{
				List[ i ] = false ;
			}
		}

		// 镔Ȍꍇ̓G[
		if( Num == 0 )
		{
			DXST_ERRORLOG_ADD( _T( "eNX``̍쐬Ɏs܂\n" ) ) ;
			return -1 ;
		}

		// `i[郁̈悪Ȃꍇ͍Ċm
		if( Num > 4 )
		{
			if( ReallocHandle( Handle, Size + sizeof( IMAGEDATA2_HARD ) + ( Num - 4 ) * sizeof( IMAGEDATA2_HARD_DRAW ) ) < 0 )
			{
				DXST_ERRORLOG_ADD( _T( "摜`i[p̊mۂɎs܂\n" ) ) ;
				return -1 ;
			}
			Image2 = ( IMAGEDATA2 * )GetHandleInfo( Handle ) ;
			Orig = Image2->Orig ;
		}

		Image2->Hard.DrawNum = Num ;

		// `Zbg
		OrigTex = Orig->Hard.Tex ;
		DrawTex = Image2->Hard.Draw ;
		Num = 0 ;
		for( i = 0 ; i < Orig->Hard.TexNum ; i ++, OrigTex ++ )
		{
			if( List[ i ] == false ) continue ;

			// gpIWi摜eNX`̃AhXZbg
			DrawTex->Tex = OrigTex ;

			// IWi摜eNX`̂ǂ̕gp邩AȂǂ̏Zbg
			{
				if( OrigTex->OrigPosX > Image2->UseOrigX )
				{
					DrawTex->DrawPosX = OrigTex->OrigPosX - Image2->UseOrigX ;
					DrawTex->UsePosX  = 0 ;

					if( OrigTex->OrigPosX + OrigTex->UseWidth > Image2->UseOrigX + Image2->Width )
					{
						DrawTex->Width = Image2->UseOrigX + Image2->Width - OrigTex->OrigPosX ;
					}
					else
					{
						DrawTex->Width = OrigTex->UseWidth ;
					}
				}
				else
				{
					DrawTex->DrawPosX = 0 ;
					DrawTex->UsePosX  = Image2->UseOrigX - OrigTex->OrigPosX ;

					if( OrigTex->OrigPosX + OrigTex->UseWidth > Image2->UseOrigX + Image2->Width )
					{
						DrawTex->Width = Image2->Width ;
					}
					else
					{
						DrawTex->Width = OrigTex->OrigPosX + OrigTex->UseWidth - Image2->UseOrigX ;
					}
				}

				if( OrigTex->OrigPosY > Image2->UseOrigY )
				{
					DrawTex->DrawPosY = OrigTex->OrigPosY - Image2->UseOrigY ;
					DrawTex->UsePosY  = 0 ;

					if( OrigTex->OrigPosY + OrigTex->UseHeight > Image2->UseOrigY + Image2->Height )
					{
						DrawTex->Height = Image2->UseOrigY + Image2->Height - OrigTex->OrigPosY ;
					}
					else
					{
						DrawTex->Height = OrigTex->UseHeight ;
					}
				}
				else
				{
					DrawTex->DrawPosY = 0 ;
					DrawTex->UsePosY  = Image2->UseOrigY - OrigTex->OrigPosY ;

					if( OrigTex->OrigPosY + OrigTex->UseHeight > Image2->UseOrigY + Image2->Height )
					{
						DrawTex->Height = Image2->Height ;
					}
					else
					{
						DrawTex->Height = OrigTex->OrigPosY + OrigTex->UseHeight - Image2->UseOrigY ;
					}
				}
			}

			// Zogp񂩂璸_f[^Ɏgpl̊o
			DrawTex->Vertex[ 0 ].x = ( float )DrawTex->DrawPosX ;
			DrawTex->Vertex[ 1 ].x = ( float )( DrawTex->DrawPosX + DrawTex->Width ) ;
			DrawTex->Vertex[ 2 ].x = ( float )DrawTex->DrawPosX ;
			DrawTex->Vertex[ 3 ].x = ( float )( DrawTex->DrawPosX + DrawTex->Width ) ;

			DrawTex->Vertex[ 0 ].y = ( float )DrawTex->DrawPosY ;
			DrawTex->Vertex[ 1 ].y = ( float )DrawTex->DrawPosY ;
			DrawTex->Vertex[ 2 ].y = ( float )( DrawTex->DrawPosY + DrawTex->Height ) ;
			DrawTex->Vertex[ 3 ].y = ( float )( DrawTex->DrawPosY + DrawTex->Height ) ;

			DrawTex->Vertex[ 0 ].u = ( float )DrawTex->UsePosX / ( float )OrigTex->TexWidth ;
			DrawTex->Vertex[ 1 ].u = ( float )( DrawTex->UsePosX + DrawTex->Width ) / ( float )OrigTex->TexWidth ;
			DrawTex->Vertex[ 2 ].u = ( float )DrawTex->UsePosX / ( float )OrigTex->TexWidth ;
			DrawTex->Vertex[ 3 ].u = ( float )( DrawTex->UsePosX + DrawTex->Width ) / ( float )OrigTex->TexWidth ;

			DrawTex->Vertex[ 0 ].v = ( float )DrawTex->UsePosY / ( float )OrigTex->TexHeight ;
			DrawTex->Vertex[ 1 ].v = ( float )DrawTex->UsePosY / ( float )OrigTex->TexHeight ;
			DrawTex->Vertex[ 2 ].v = ( float )( DrawTex->UsePosY + DrawTex->Height ) / ( float )OrigTex->TexHeight ;
			DrawTex->Vertex[ 3 ].v = ( float )( DrawTex->UsePosY + DrawTex->Height ) / ( float )OrigTex->TexHeight ;

			// _^CṽZbg
			DrawTex->VertType[ 0 ] = DrawTex->Vertex[ 0 ].y <= Image2->Height - ( d * DrawTex->Vertex[ 0 ].x ) ;
			DrawTex->VertType[ 1 ] = DrawTex->Vertex[ 1 ].y <= Image2->Height - ( d * DrawTex->Vertex[ 1 ].x ) ;
			DrawTex->VertType[ 2 ] = DrawTex->Vertex[ 2 ].y <= Image2->Height - ( d * DrawTex->Vertex[ 2 ].x ) ;
			DrawTex->VertType[ 3 ] = DrawTex->Vertex[ 3 ].y <= Image2->Height - ( d * DrawTex->Vertex[ 3 ].x ) ;

			DrawTex ++ ;
		}
	}
	else
	{
		// eNX`ł͂Ȃꍇ

		// `p MEMIMG ̏
		DerivationMemImg( &Image2->Soft.MemImg, &Orig->Soft.MemImg, Image2->UseOrigX, Image2->UseOrigY, Image2->Width, Image2->Height ) ;
	}

	// I
	return 0 ;
}





// IWi摜񒆂̃eNX`쐬( 0:  -1:s )
static int CreateOrigTexture( IMAGEDATA2_ORIG *Orig, int ASyncThread )
{
	int i, j ;
	IMAGEDATA2_ORIG_HARD_TEX *OrigTex ;

	// Direct3DDevice G[
	if( GraphicsDevice_IsValid() == 0 )
		return -1 ;

	// n[hEGAgp摜ł͂Ȃꍇ͉ɏI
	if( Orig->FormatDesc.TextureFlag == FALSE ) return 0 ;

	// w̃tH[}bg쐬łȂꍇ͎s
	if( GRH.TextureFormat[ Orig->ColorFormat ] == D_D3DFMT_UNKNOWN )
	{
		DXST_ERRORLOG_ADD( _T( "w̃tH[}bgō쐬łeNX`tH[}bg܂ł\n" ) ) ;
		return -1 ;
	}

	// eNX`̏ꍇ̓eNX`̐eNX`쐬
	OrigTex = Orig->Hard.Tex ;
	for( i = 0 ; i < Orig->Hard.TexNum ; i ++, OrigTex ++ )
	{
		// ɃeNX`쐬ĂXLbv
//		if( OrigTex->Texture != NULL ) continue ;

		// Direct3D9Ex gpĂꍇ͊ǗgpȂ( łȂ )
		if( Graphics_IsExObject() != 0 )
			Orig->FormatDesc.UseManagedTextureFlag = FALSE ;

		// _O^[QbgT[tFX̍쐬
		if( Orig->FormatDesc.DrawValidFlag )
		{
			// L[u}bvł͕ʓr_[^[Qbg͍쐬Ȃ
			if( Orig->FormatDesc.CubeMapTextureFlag == FALSE )
			{
				D_D3DMULTISAMPLE_TYPE Samples = D_D3DMULTISAMPLE_NONE ;
				DWORD Quality = 0 ;

				if( Orig->FormatDesc.MSSamples != 0 )
				{
					Samples = ( D_D3DMULTISAMPLE_TYPE )Orig->FormatDesc.MSSamples ;
					Quality = ( DWORD )Orig->FormatDesc.MSQuality ;
					CheckMultiSampleParam( GRH.TextureFormat[ Orig->ColorFormat ], &Samples, &Quality, FALSE, ASyncThread ) ;
				}

				if( Orig->FormatDesc.MSSamples != 0 && OrigTex->RenderTargetSurface == NULL )
				{
					// _O^[QbgT[tFX̍쐬
					if( GraphicsDevice_CreateRenderTarget_ASync(
						OrigTex->TexWidth,							// 
						OrigTex->TexHeight,							// 
						GRH.TextureFormat[ Orig->ColorFormat ],		// tH[}bg
						Samples,									// }`TvO^Cv
						Quality,									// }`TvONIeB
						FALSE,										// bN͂łȂ
						&OrigTex->RenderTargetSurface,				// DX_DIRECT3DSURFACE9 ̃|C^󂯎AhX
						NULL,										//  NULL
						ASyncThread
						) != D_D3D_OK )
					{
						DXST_ERRORLOG_ADD( _T( "ݐpT[tFX̍쐬Ɏs܂\n" ) ) ;
						return -1 ;
					}
				}

				if( ( GRH.FSAAMultiSampleType == D_D3DMULTISAMPLE_NONE && Orig->FormatDesc.MSSamples != 0 ) ||
					( GRH.FSAAMultiSampleType != D_D3DMULTISAMPLE_NONE && Orig->FormatDesc.MSSamples == 0 ) ||
					Orig->ZBufferFlag  )
				{
					if( OrigTex->ZBuffer != NULL )
					{
						Graphics_ObjectRelease( OrigTex->ZBuffer ) ;
						OrigTex->ZBuffer = NULL ;
					}

					// _O^[Qbg[xobt@̍쐬
					if( GraphicsDevice_CreateDepthStencilSurface_ASync(
						OrigTex->TexWidth,									// 
						OrigTex->TexHeight,									// 
						GRH.ZBufferFormat[ Orig->ZBufferBitDepthIndex ],	// tH[}bg
						Samples,											// }`TvO^Cv
						Quality,											// }`TvONIeB
						FALSE,												// bN͂łȂ
						&OrigTex->ZBuffer,									// DX_DIRECT3DSURFACE9 ̃|C^󂯎AhX
						NULL,												//  NULL
						ASyncThread
						) != D_D3D_OK )
					{
						DXST_ERRORLOG_ADD( _T( "ݐp}`Tv[xT[tFX̍쐬Ɏs܂\n" ) ) ;
						return -1 ;
					}
				}
				else
				if( OrigTex->ZBuffer != NULL )
				{
					Graphics_ObjectRelease( OrigTex->ZBuffer ) ;
					OrigTex->ZBuffer = NULL ;
				}
			}
		}

		// rfIeNX`̍쐬
		if( Orig->FormatDesc.CubeMapTextureFlag )
		{
			if( OrigTex->CubeTexture == NULL )
			{
				if( GraphicsDevice_CreateCubeTexture_ASync(
					OrigTex->TexWidth,																													// GbWTCY
					Orig->Hard.MipMapCount,																												// MipMap x
					Orig->FormatDesc.DrawValidFlag ? D_D3DUSAGE_RENDERTARGET : 0,																		// tO
					GRH.TextureFormat[ Orig->ColorFormat ],																								// tH[}bg
					Orig->FormatDesc.UseManagedTextureFlag == FALSE || Orig->FormatDesc.DrawValidFlag ? D_D3DPOOL_DEFAULT : D_D3DPOOL_MANAGED,			// eNX` DirectX Ǘ邩ǂ
					&OrigTex->CubeTexture,																												// DX_DIRECT3DTEXTURE9 ̃|C^󂯎AhX
					NULL,																																//  NULL
					ASyncThread
					) != D_D3D_OK )
				{
					DXST_ERRORLOG_ADD( _T( "L[u}bveNX`̍쐬Ɏs܂\n" ) ) ;
					return -1 ;
				}
			}
		}
		else
		{
			if( OrigTex->Texture == NULL )
			{
				if( GraphicsDevice_CreateTexture_ASync(
					OrigTex->TexWidth,																													// 
					OrigTex->TexHeight,																													// 
					Orig->Hard.MipMapCount,																												// MipMap x
					Orig->FormatDesc.DrawValidFlag ? D_D3DUSAGE_RENDERTARGET : 0,																		// tO
					GRH.TextureFormat[ Orig->ColorFormat ],																								// tH[}bg
					Orig->FormatDesc.UseManagedTextureFlag == FALSE || Orig->FormatDesc.DrawValidFlag ? D_D3DPOOL_DEFAULT : D_D3DPOOL_MANAGED,			// eNX` DirectX Ǘ邩ǂ
					&OrigTex->Texture,																													// DX_DIRECT3DTEXTURE9 ̃|C^󂯎AhX
					NULL,																																//  NULL
					ASyncThread
					) != D_D3D_OK )
				{
					DXST_ERRORLOG_ADD( _T( "eNX`̍쐬Ɏs܂\n" ) ) ;
					return -1 ;
				}
			}
		}

		// `\eNX`ł͂ȂAǗeNX`ł͂Ȃꍇ̓VXeeNX`쐬
/*		if( ( Orig->FormatDesc.DrawValidFlag == FALSE && Orig->FormatDesc.UseManagedTextureFlag == FALSE ) && OrigTex->MemTexture == NULL )
		{
			if( GraphicsDevice_CreateTexture(
				OrigTex->TexWidth,							// 
				OrigTex->TexHeight,							// 
				Orig->Hard.MipMapCount,						// MipMap x
				D_D3DUSAGE_DYNAMIC,							// tO
				GRH.TextureFormat[ Orig->ColorFormat ],		// tH[}bg
				D_D3DPOOL_SYSTEMMEM,						// eNX` DirectX Ǘ邩ǂ
				&OrigTex->MemTexture,						// DX_DIRECT3DTEXTURE9 ̃|C^󂯎AhX
				NULL										//  NULL
				) != D_D3D_OK )
			{
				Graphics_ObjectRelease( OrigTex->Texture ) ;
				OrigTex->Texture = NULL ;

				DXST_ERRORLOG_ADD( _T( "eNX`̍쐬Ɏs܂\n" ) ) ;
				return -1 ;
			}
		}
*/
		// T[tFX̃AhX擾
		if( Orig->FormatDesc.CubeMapTextureFlag )
		{
			for( j = 0 ; j < CUBEMAP_SURFACE_NUM ; j ++ )
			{
				if( OrigTex->Surface[ j ] == NULL )
				{
					if( GraphicsCubeTexture_GetCubeMapSurface_ASync( OrigTex->CubeTexture, ( D_D3DCUBEMAP_FACES )j, 0, &OrigTex->Surface[ j ], ASyncThread ) != D_D3D_OK )
					{
						DXST_ERRORLOG_ADD( _T( "L[ueNX`̃T[tFXAhX̎擾Ɏs܂\n" ) ) ;
						return -1 ;
					}
				}
			}
		}
		else
		{
			if( OrigTex->Surface[ 0 ] == NULL )
			{
				if( GraphicsTexture_GetSurfaceLevel_ASync( OrigTex->Texture, 0, &OrigTex->Surface[ 0 ], ASyncThread ) != D_D3D_OK )
				{
					DXST_ERRORLOG_ADD( _T( "eNX`̃T[tFXAhX̎擾Ɏs܂\n" ) ) ;
					return -1 ;
				}
			}
		}

		// łɐ^ɓhԂ
		{
//			int j, MipCount, h ;
//			D_D3DLOCKED_RECT LockRect ;

			if( Orig->FormatDesc.DrawValidFlag )
			{
				for( j = 0 ; j < CUBEMAP_SURFACE_NUM ; j ++ )
				{
					if( OrigTex->Surface[ j ] != NULL )
					{
						GraphicsDevice_ColorFill_ASync( OrigTex->Surface[ j ], NULL, 0x00000000, ASyncThread ) ;
					}
				}
			}
/*
			else
			// DXTtH[}bg̏ꍇ̓NAȂ
			if( Orig->ColorFormat != DX_GRAPHICSIMAGE_FORMAT_3D_DXT1 &&
				Orig->ColorFormat != DX_GRAPHICSIMAGE_FORMAT_3D_DXT2 &&
				Orig->ColorFormat != DX_GRAPHICSIMAGE_FORMAT_3D_DXT3 &&
				Orig->ColorFormat != DX_GRAPHICSIMAGE_FORMAT_3D_DXT4 &&
				Orig->ColorFormat != DX_GRAPHICSIMAGE_FORMAT_3D_DXT5 )
			{
				DX_DIRECT3DTEXTURE9 *UseTex ;

				UseTex = Orig->FormatDesc.UseManagedTextureFlag == FALSE ? OrigTex->MemTexture : OrigTex->Texture ;
				h = OrigTex->TexHeight ;
				if( Orig->Hard.MipMapCount > 1 )
				{
					MipCount = Orig->Hard.MipMapCount ;
					for( j = 0 ; j < MipCount ; j ++, h >>= 1 )
					{
						if( UseTex->LockRect( j, &LockRect, NULL, 0 ) == D_D3D_OK )
						{
							_MEMSET( LockRect.pBits, 0, LockRect.Pitch * h ) ;

							UseTex->UnlockRect( j ) ;
						}
					}
				}
				else
				{
					if( UseTex->LockRect( 0, &LockRect, NULL, 0 ) == D_D3D_OK )
					{
						_MEMSET( LockRect.pBits, 0, LockRect.Pitch * h ) ;

						UseTex->UnlockRect( 0 ) ;
					}
				}

				if( Orig->FormatDesc.UseManagedTextureFlag == FALSE )
				{
					GraphicsDevice_UpdateTexture( OrigTex->MemTexture, OrigTex->Texture ) ;
				}
			}
*/
		}
	}

	// I
	return 0 ;
}

// IWi摜񒆂̃eNX`
static int ReleaseOrigTexture( IMAGEDATA2_ORIG *Orig )
{
	int i ;
	int j ;
	IMAGEDATA2_ORIG_HARD_TEX *OrigTex ;

	// n[hEGAgp摜ł͂Ȃꍇ͉ɏI
	if( Orig->FormatDesc.TextureFlag == FALSE ) return 0 ;

	// eNX`̏ꍇ̓eNX`̐eNX`쐬
	OrigTex = Orig->Hard.Tex ;
	for( i = 0 ; i < Orig->Hard.TexNum ; i ++, OrigTex ++ )
	{
		// T[tFX̉
		for( j = 0 ; j < CUBEMAP_SURFACE_NUM ; j ++ )
		{
			if( OrigTex->Surface[ j ] )
			{
				Graphics_ObjectRelease( OrigTex->Surface[ j ] ) ;
				OrigTex->Surface[ j ] = NULL ;
			}
		}
		if( OrigTex->RenderTargetSurface )
		{
			Graphics_ObjectRelease( OrigTex->RenderTargetSurface ) ;
			OrigTex->RenderTargetSurface = NULL ;
		}
		if( OrigTex->ZBuffer )
		{
			Graphics_ObjectRelease( OrigTex->ZBuffer ) ;
			OrigTex->ZBuffer = NULL ;
		}

		// eNX`̉
		if( OrigTex->Texture )
		{
			Graphics_ObjectRelease( OrigTex->Texture ) ;
			OrigTex->Texture = NULL ;
		}
		/*
		if( OrigTex->MemTexture )
		{
			Graphics_ObjectRelease( OrigTex->MemTexture ) ;
			OrigTex->MemTexture = NULL ;
		}*/
	}

	// I
	return 0 ;
}

#if 0
// IWi摜񒆂̂yobt@쐬
static int CreateOrigZBuffer( IMAGEDATA2_ORIG *Orig )
{
	int i ;
	IMAGEDATA2_ORIG_HARD_TEX *OrigTex ;

	// `\摜ł͂Ȃꍇ͉Ȃ
	if( Orig->FormatDesc.DrawValidFlag == FALSE ) return 0 ;

	// eNX`ǂŏ𕪊
	if( Orig->FormatDesc.TextureFlag == TRUE )
	{
		// eNX`̏ꍇ

		OrigTex = Orig->Hard.Tex ;
		for( i = 0 ; i < Orig->Hard.TexNum ; i ++, OrigTex ++ )
		{
			// yobt@ɍ쐬Ăꍇ͉Ȃ
			if( OrigTex->ZBuffer != NULL ) continue ;

			// eNX`̍쐬
			if( GraphicsDevice_CreateDepthStencilSurface(
				OrigTex->TexWidth,																	// 
				OrigTex->TexHeight,																	// 
				D_D3DFMT_D16,																		// tH[}bg
				GRH.MultiSampleType,																// }`TvO^Cv
				GRH.MultiSampleQuality,																// }`TvNIeB
				TRUE,																				//  Release tO
				&OrigTex->ZBuffer,																	// DX_DIRECT3DSURFACE9 ̃|C^󂯎AhX
				NULL																				//  NULL
				) != D_D3D_OK )
			{
				DXST_ERRORLOG_ADD( _T( "yobt@T[tFX̍쐬Ɏs܂\n" ) ) ;
				return -1 ;
			}
		}
	}
	else
	{
		// eNX`ł͂Ȃꍇ

		// ɂyobt@p MEMIMG 쐬Ăꍇ͉Ȃ
		if( Orig->Soft.ZBuffer == NULL )
		{
			// yobt@T[tFXpMEMIMG i[郁̈̊m
			Orig->Soft.ZBuffer = ( MEMIMG * )DXCALLOC( sizeof( MEMIMG ) ) ;
			if( Orig->Soft.ZBuffer == NULL )
			{
				DXST_ERRORLOG_ADD( _T( "yobt@pMEMIMGi[郁̈̊mۂɎs܂\n" ) ) ;
				return -1 ;
			}

			// yobt@T[tFXp MEMIMG 
			if( MakeMemImgZBuffer( Orig->Soft.ZBuffer, Orig->Width, Orig->Height ) == -1 )
			{
				DXST_ERRORLOG_ADD( _T( "yobt@pMEMIMG̏Ɏs܂\n" ) ) ;
				return -1 ;
			}
		}
	}

	// I
	return 0 ;
}

// IWi摜񒆂̂yobt@J
static int ReleaseOrigZBuffer( IMAGEDATA2_ORIG *Orig )
{
	int i ;
	IMAGEDATA2_ORIG_HARD_TEX *OrigTex ;

	// `\摜ł͂Ȃꍇ͉Ȃ
	if( Orig->FormatDesc.DrawValidFlag == FALSE ) return 0 ;

	// eNX`ǂŏ𕪊
	if( Orig->FormatDesc.TextureFlag == TRUE )
	{
		// eNX`̏ꍇ

		OrigTex = Orig->Hard.Tex ;
		for( i = 0 ; i < Orig->Hard.TexNum ; i ++, OrigTex ++ )
		{
			// yobt@̉
			if( OrigTex->ZBuffer != NULL )
			{
				Graphics_ObjectRelease( OrigTex->ZBuffer ) ;
				OrigTex->ZBuffer = NULL ;
			}
		}
	}
	else
	{
		// eNX`ł͂Ȃꍇ

		// ɂyobt@p MEMIMG Ăꍇ͉Ȃ
		if( Orig->Soft.ZBuffer != NULL )
		{
			// yobt@p MEMIMG ̌n
			TerminateMemImg( Orig->Soft.ZBuffer ) ;

			// yobt@p MEMIMG ̂̉
			DXFREE( Orig->Soft.ZBuffer ) ;
			Orig->Soft.ZBuffer = NULL ;
		}
	}

	// I
	return 0 ;
}
#endif

// _obt@nhp Direct3DVertexBuffer9 IuWFNg쐬
static int CreateDirect3DVertexBufferObject( VERTEXBUFFERHANDLEDATA *VertexBuffer )
{
	int FVF ;
	int Result ;

	// ΉĂȂ^Cv̏ꍇ̓G[
	FVF = VERTEXFVF_3D_LIGHT ;
	switch( VertexBuffer->Type )
	{
	case DX_VERTEX_TYPE_NORMAL_3D :
		FVF = VERTEXFVF_3D_LIGHT ;
		break ;
	}

	// _n[hEGAŏꍇ̂ Direct3D9VertexBuffer 쐬
	if( GRH.VertexHardwareProcess || GRH.ValidVertexShader )
	{
		// _obt@쐬
		Result = GraphicsDevice_CreateVertexBuffer_ASync( 
				VertexBuffer->UnitSize * VertexBuffer->Num,
				D_D3DUSAGE_WRITEONLY,
				FVF,
				D_D3DPOOL_DEFAULT,
				&VertexBuffer->Direct3DBuffer ) ;
		if( Result < 0 )
		{
			DXST_ERRORLOG_ADD( _T( "_obt@̍쐬Ɏs܂\n" ) ) ;
			return -1 ;
		}

		// f[^𕜋A
		NS_SetVertexBufferData( 0, VertexBuffer->Buffer, VertexBuffer->Num, VertexBuffer->HandleInfo.Handle ) ; 
	}

	// I
	return 0 ;
}

// _obt@nhp Direct3DVertexBuffer9 IuWFNg
static int ReleaseDirect3DVertexBufferObject( VERTEXBUFFERHANDLEDATA *VertexBuffer )
{
	if( VertexBuffer->Direct3DBuffer != NULL )
	{
		Graphics_ObjectRelease( VertexBuffer->Direct3DBuffer ) ;
		VertexBuffer->Direct3DBuffer = NULL ;
	}

	// I
	return 0 ;
}

// CfbNXobt@nhp Direct3DIndexBuffer9 IuWFNg쐬
static int CreateDirect3DIndexBufferObject( INDEXBUFFERHANDLEDATA *IndexBuffer )
{
	D_D3DFORMAT Format ;

	// ΉĂȂ^Cv̏ꍇ̓G[
	Format = D_D3DFMT_INDEX16 ;
	switch( IndexBuffer->Type )
	{
	case DX_INDEX_TYPE_16BIT :
		Format = D_D3DFMT_INDEX16 ;
		break ;

	case DX_INDEX_TYPE_32BIT :
		Format = D_D3DFMT_INDEX32 ;
		break ;
	}

	// _n[hEGAŏꍇ̂ Direct3D9IndexBuffer 쐬
	if( GRH.VertexHardwareProcess || GRH.ValidVertexShader )
	{
		// CfbNXobt@쐬
		if( GraphicsDevice_CreateIndexBuffer_ASync( 
				IndexBuffer->UnitSize * IndexBuffer->Num,
				D_D3DUSAGE_WRITEONLY,
				Format,
				D_D3DPOOL_DEFAULT,
				&IndexBuffer->Direct3DBuffer
			) < 0 )
		{
			DXST_ERRORLOG_ADD( _T( "CfbNXobt@̍쐬Ɏs܂\n" ) ) ;
			return -1 ;
		}

		// f[^𕜋A
		NS_SetIndexBufferData( 0, IndexBuffer->Buffer, IndexBuffer->Num, IndexBuffer->HandleInfo.Handle ) ; 
	}

	// I
	return 0 ;
}

// CfbNXobt@nhp Direct3DIndexBuffer9 IuWFNg
static int ReleaseDirect3DIndexBufferObject( INDEXBUFFERHANDLEDATA *IndexBuffer )
{
	if( IndexBuffer->Direct3DBuffer != NULL )
	{
		Graphics_ObjectRelease( IndexBuffer->Direct3DBuffer ) ;
		IndexBuffer->Direct3DBuffer = NULL ;
	}

	// I
	return 0 ;
}


// OtBbNnhׂĂ DirectX IuWFNg
static int ReleaseOrigDirectXObjectAll()
{
	int i ;
	SHADERHANDLEDATA *Shader ;
	VERTEXBUFFERHANDLEDATA *VertexBuffer ;
	INDEXBUFFERHANDLEDATA *IndexBuffer ;
	IMAGEDATA2_SYSMEMTEXTURE *MemTex ;
	IMAGEDATA2 *Image2 ;

	MemTex = GRH.SysMemTexture ;
	for( i = 0 ; i < GRH.SysMemTextureInitNum ; MemTex ++ )
	{
		if( MemTex->InitializeFlag == FALSE )
			continue ;

		i ++ ;

		if( MemTex->MemTexture != NULL )
		{
			Graphics_ObjectRelease( MemTex->MemTexture ) ;
			MemTex->MemTexture = NULL ;
		}
	}

	if( HandleManageArray[ DX_HANDLETYPE_GRAPH ].InitializeFlag )
	{
		for( i = HandleManageArray[ DX_HANDLETYPE_GRAPH ].AreaMin ; i <= HandleManageArray[ DX_HANDLETYPE_GRAPH ].AreaMax ; i ++ )
		{
			Image2 = ( IMAGEDATA2 * )HandleManageArray[ DX_HANDLETYPE_GRAPH ].Handle[ i ] ;

			if( Image2 == NULL ) continue ;
			if( Image2->Orig == NULL ) continue ;
			ReleaseOrigTexture( Image2->Orig ) ;

#ifndef DX_NON_MOVIE
			if( Image2->MovieHandle != -1 )
			{
				ReleaseMovieSurface( Image2->MovieHandle ) ;
			}
#endif
		}
	}

	if( HandleManageArray[ DX_HANDLETYPE_VERTEX_BUFFER ].InitializeFlag )
	{
		for( i = HandleManageArray[ DX_HANDLETYPE_VERTEX_BUFFER ].AreaMin ; i <= HandleManageArray[ DX_HANDLETYPE_VERTEX_BUFFER ].AreaMax ; i ++ )
		{
			VertexBuffer = ( VERTEXBUFFERHANDLEDATA * )HandleManageArray[ DX_HANDLETYPE_VERTEX_BUFFER ].Handle[ i ] ;
			if( VertexBuffer == NULL ) continue ;
			ReleaseDirect3DVertexBufferObject( VertexBuffer ) ;
		}
	}

	if( HandleManageArray[ DX_HANDLETYPE_INDEX_BUFFER ].InitializeFlag )
	{
		for( i = HandleManageArray[ DX_HANDLETYPE_INDEX_BUFFER ].AreaMin ; i <= HandleManageArray[ DX_HANDLETYPE_INDEX_BUFFER ].AreaMax ; i ++ )
		{
			IndexBuffer = ( INDEXBUFFERHANDLEDATA * )HandleManageArray[ DX_HANDLETYPE_INDEX_BUFFER ].Handle[ i ] ;
			if( IndexBuffer == NULL ) continue ;
			ReleaseDirect3DIndexBufferObject( IndexBuffer ) ;
		}
	}

	if( HandleManageArray[ DX_HANDLETYPE_SHADER ].InitializeFlag )
	{
		for( i = HandleManageArray[ DX_HANDLETYPE_SHADER ].AreaMin ; i <= HandleManageArray[ DX_HANDLETYPE_SHADER ].AreaMax ; i ++ )
		{
			Shader = ( SHADERHANDLEDATA * )HandleManageArray[ DX_HANDLETYPE_SHADER ].Handle[ i ] ;
			if( Shader == NULL ) continue ;
			if( Shader->IsVertexShader )
			{
				if( Shader->VertexShader )
				{
					Graphics_ObjectRelease( Shader->VertexShader ) ;
					Shader->VertexShader = NULL ;
				}
			}
			else
			{
				if( Shader->PixelShader )
				{
					Graphics_ObjectRelease( Shader->PixelShader ) ;
					Shader->PixelShader = NULL ;
				}
			}
		}
	}

	// I
	return 0 ;
}

// OtBbNnhׂĂ DirectX IuWFNg擾
static int AllocOrigDirectXObjectAll()
{
	int i ;
	SHADERHANDLEDATA *Shader ;
	VERTEXBUFFERHANDLEDATA *VertexBuffer ;
	INDEXBUFFERHANDLEDATA *IndexBuffer ;
	IMAGEDATA2_SYSMEMTEXTURE *MemTex ;
	IMAGEDATA2 *Image2 ;

	MemTex = GRH.SysMemTexture ;
	for( i = 0 ; i < GRH.SysMemTextureInitNum ; MemTex ++ )
	{
		if( MemTex->InitializeFlag == FALSE )
			continue ;

		i ++ ;

		CreateSysMemTextureDirect3D9Texture( MemTex ) ;
	}

	if( HandleManageArray[ DX_HANDLETYPE_GRAPH ].InitializeFlag )
	{
		for( i = HandleManageArray[ DX_HANDLETYPE_GRAPH ].AreaMin ; i <= HandleManageArray[ DX_HANDLETYPE_GRAPH ].AreaMax ; i ++ )
		{
			Image2 = ( IMAGEDATA2 * )HandleManageArray[ DX_HANDLETYPE_GRAPH ].Handle[ i ] ;

			if( Image2 == NULL ) continue ;
			if( Image2->Orig == NULL ) continue ;
			CreateOrigTexture( Image2->Orig ) ;
		}
	}

	if( HandleManageArray[ DX_HANDLETYPE_VERTEX_BUFFER ].InitializeFlag )
	{
		for( i = HandleManageArray[ DX_HANDLETYPE_VERTEX_BUFFER ].AreaMin ; i <= HandleManageArray[ DX_HANDLETYPE_VERTEX_BUFFER ].AreaMax ; i ++ )
		{
			VertexBuffer = ( VERTEXBUFFERHANDLEDATA * )HandleManageArray[ DX_HANDLETYPE_VERTEX_BUFFER ].Handle[ i ] ;
			if( VertexBuffer == NULL ) continue ;
			CreateDirect3DVertexBufferObject( VertexBuffer ) ;
		}
	}

	if( HandleManageArray[ DX_HANDLETYPE_INDEX_BUFFER ].InitializeFlag )
	{
		for( i = HandleManageArray[ DX_HANDLETYPE_INDEX_BUFFER ].AreaMin ; i <= HandleManageArray[ DX_HANDLETYPE_INDEX_BUFFER ].AreaMax ; i ++ )
		{
			IndexBuffer = ( INDEXBUFFERHANDLEDATA * )HandleManageArray[ DX_HANDLETYPE_INDEX_BUFFER ].Handle[ i ] ;
			if( IndexBuffer == NULL ) continue ;
			CreateDirect3DIndexBufferObject( IndexBuffer ) ;
		}
	}

	if( HandleManageArray[ DX_HANDLETYPE_SHADER ].InitializeFlag )
	{
		for( i = HandleManageArray[ DX_HANDLETYPE_SHADER ].AreaMin ; i <= HandleManageArray[ DX_HANDLETYPE_SHADER ].AreaMax ; i ++ )
		{
			Shader = ( SHADERHANDLEDATA * )HandleManageArray[ DX_HANDLETYPE_SHADER ].Handle[ i ] ;
			if( Shader == NULL ) continue ;
			if( Shader->IsVertexShader )
			{
				GraphicsDevice_CreateVertexShader( ( DWORD * )Shader->FunctionCode, &Shader->VertexShader ) ;
			}
			else
			{
				GraphicsDevice_CreatePixelShader( ( DWORD * )Shader->FunctionCode, &Shader->PixelShader ) ;
			}
		}
	}

	// I
	return 0 ;
}


static  D_D3DVERTEXELEMENT9	MakeVertexElement9( BYTE Stream, BYTE Offset, BYTE Type, BYTE Method, BYTE Usage, BYTE UsageIndex )
{
	D_D3DVERTEXELEMENT9 Result = { Stream, Offset, Type, Method, Usage, UsageIndex } ;
	return Result ;
}


// ݒɊÂĎgpyobt@Zbg
extern int SetupUseZBuffer( void )
{
	IMAGEDATA2 *TargetScreenImage2 ;
	IMAGEDATA2 *TargetZBufferImage2 ;

	// `̉摜̎擾
	if( GRAPHCHKFULL( GBASE.TargetScreen[ 0 ], TargetScreenImage2 ) )
	{
		TargetScreenImage2 = NULL ;
	}

	// gpyobt@̉摜̎擾
	if( GRAPHCHKFULL( GBASE.TargetZBuffer, TargetZBufferImage2 ) )
	{
		TargetZBufferImage2 = NULL ;
	}

	// }XNT[tFX݂ĂĊLȏꍇ̓}XNT[tFX̂yobt@gp
#ifndef DX_NON_MASK
	if( MASKD.MaskValidFlag && MASKD.MaskScreenSurface )
	{
		GraphicsDevice_SetDepthStencilSurface( GRH.ZBufferSurface ) ;
	}
	else
#endif
	// `\摜`悩ǂŏ𕪊
	if( TargetScreenImage2 )
	{
		// `yobt@āA`ȏ̃TCYꍇ͕`yobt@gp
		if( TargetZBufferImage2 != NULL &&
			TargetZBufferImage2->Width >= TargetScreenImage2->Width &&
			TargetZBufferImage2->Height >= TargetScreenImage2->Height )
		{
			GraphicsDevice_SetDepthStencilSurface( TargetZBufferImage2->Hard.Draw[ 0 ].Tex->ZBuffer ) ;
		}
		else
		// `\摜̂yobt@ꍇ͂̂yobt@gp
		if( TargetScreenImage2->Hard.Draw[ 0 ].Tex->ZBuffer )
		{
			GraphicsDevice_SetDepthStencilSurface( TargetScreenImage2->Hard.Draw[ 0 ].Tex->ZBuffer ) ;
		}
		else
		// `悪ftHĝyobt@傫yobt@O
		if( TargetScreenImage2->Width  > GRH.ZBufferSizeX || 
			TargetScreenImage2->Height > GRH.ZBufferSizeY )
		{
			GraphicsDevice_SetDepthStencilSurface( NULL ) ;
		}
		else
		{
			// ftHĝyobt@gp
			GraphicsDevice_SetDepthStencilSurface( GRH.ZBufferSurface ) ;
		}
	}
	else
	{
		// `yobt@āA`ȏ̃TCYꍇ͕`yobt@gp
		if( TargetZBufferImage2 != NULL &&
			TargetZBufferImage2->Width  >= GBASE.DrawSizeX &&
			TargetZBufferImage2->Height >= GBASE.DrawSizeY )
		{
			GraphicsDevice_SetDepthStencilSurface( TargetZBufferImage2->Hard.Draw[ 0 ].Tex->ZBuffer ) ;
		}
		else
		{
			// ȊȌꍇftHĝyobt@gp
			GraphicsDevice_SetDepthStencilSurface( GRH.ZBufferSurface ) ;
		}
	}

	// I
	return 0 ;
}


// w̃}`TvŎgpłőNIeBl擾
extern int NS_GetMultiSampleQuality( int Samples )
{
	IMAGEFORMATDESC Format ;
	SETUP_GRAPHHANDLE_GPARAM GParam ;
	int FormatIndex ;
	D_D3DFORMAT D3DFormat ;
	DWORD Quality ;

	if( Samples > 16 )
		Samples = 16 ;

	if( Graphics_IsValid() == 0 )
		return -1 ;

	// ݂̐ݒ̃tH[}bgZbgAbv
	InitSetupGraphHandleGParam( &GParam ) ; 
	GParam.DrawValidImageCreateFlag = TRUE ;
	GParam.CubeMapTextureCreateFlag = FALSE ;
	SetupFormatDesc( &Format, &GParam, 256, 256, GParam.AlphaChannelImageCreateFlag, FALSE, DX_BASEIMAGE_FORMAT_NORMAL, -1 ) ;

	// tH[}bgCfbNX𓾂
	FormatIndex = NS_GetTexFormatIndex( &Format ) ;

	// Direct3D ł̃tH[}bg擾
	D3DFormat = GRH.TextureFormat[ FormatIndex ] ;
	if( D3DFormat == D_D3DFMT_UNKNOWN )
		return -1 ;

	// ݒłNIeB擾
	Quality = 10000 ;
	if( CheckMultiSampleParam( D3DFormat, ( D_D3DMULTISAMPLE_TYPE * )&Samples, &Quality, TRUE ) < 0 )
		return -1 ;

	// NIeBԂ
	return Quality ;
}

#ifndef DX_NON_ASYNCLOAD

// }`Tv_ÕTvƃNIeB`FbN񓯊ǂݍݏpR[obN֐
static int CheckMultiSampleParamASyncCallback( ASYNCLOAD_MAINTHREAD_REQUESTINFO *Info )
{
	return CheckMultiSampleParam( 
						( D_D3DFORMAT )Info->Data[ 0 ],
						( D_D3DMULTISAMPLE_TYPE * )Info->Data[ 1 ],
						( DWORD * )Info->Data[ 2 ],
						( int )Info->Data[ 3 ],
						FALSE 
					) ;
}

#endif // DX_NON_ASYNCLOAD

// }`Tv_ÕTvƃNIeB`FbN
static int CheckMultiSampleParam( D_D3DFORMAT Format, D_D3DMULTISAMPLE_TYPE *Samples, DWORD *Quality, int SamplesFailedBreak, int ASyncThread )
{
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread == TRUE )
	{
		ASYNCLOAD_MAINTHREAD_REQUESTINFO AInfo ;

		AInfo.Function = CheckMultiSampleParamASyncCallback ;
		AInfo.Data[ 0 ] = ( DWORD_PTR )Format ;
		AInfo.Data[ 1 ] = ( DWORD_PTR )Samples ;
		AInfo.Data[ 2 ] = ( DWORD_PTR )Quality ;
		AInfo.Data[ 3 ] = ( DWORD_PTR )SamplesFailedBreak ;
		return AddASyncLoadRequestMainThreadInfo( &AInfo ) ;
	}
#endif // DX_NON_ASYNCLOAD

	return Graphics_CheckMultiSampleParam( Format, Samples, Quality, SamplesFailedBreak ) ;
}

// IMAGEDATA2_ORIG  IMAGEDATA2_ORIG_HARD_TEX ̏ GetSysMemTexture gp
static int GetSysMemTextureFromOrig( IMAGEDATA2_ORIG *Orig, IMAGEDATA2_ORIG_HARD_TEX *OrigTex, int ASyncThread )
{
	return GetSysMemTexture( Orig->FormatDesc.CubeMapTextureFlag, OrigTex->TexWidth, OrigTex->TexHeight, Orig->Hard.MipMapCount, Orig->ColorFormat, ASyncThread ) ; 
}


#ifndef DX_NON_ASYNCLOAD

static int GetSysMemTextureASyncCallback( ASYNCLOAD_MAINTHREAD_REQUESTINFO *Info )
{
	return GetSysMemTexture(
				( int )Info->Data[ 0 ],
				( int )Info->Data[ 1 ],
				( int )Info->Data[ 2 ],
				( int )Info->Data[ 3 ],
				( int )Info->Data[ 4 ],
				FALSE ) ;
}

#endif // DX_NON_ASYNCLOAD

// ǗeNX`ւ̓]p̃VXeeNX`擾
static int GetSysMemTexture( int CubeMap, int Width, int Height, int MipMapCount, int Format, int ASyncThread )
{
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		ASYNCLOAD_MAINTHREAD_REQUESTINFO AInfo ;

		AInfo.Function = GetSysMemTextureASyncCallback ;
		AInfo.Data[ 0 ] = ( DWORD_PTR )CubeMap ;
		AInfo.Data[ 1 ] = ( DWORD_PTR )Width ;
		AInfo.Data[ 2 ] = ( DWORD_PTR )Height ;
		AInfo.Data[ 3 ] = ( DWORD_PTR )MipMapCount ;
		AInfo.Data[ 4 ] = ( DWORD_PTR )Format ;
		return AddASyncLoadRequestMainThreadInfo( &AInfo ) ;
	}
#endif // DX_NON_ASYNCLOAD

	int i, j ;
	IMAGEDATA2_SYSMEMTEXTURE *MemTex ;
	IMAGEDATA2_SYSMEMTEXTURE *NewMemTex ;

	// ɓKeNX`Ŗgpׂ̂̂
	MemTex = GRH.SysMemTexture ;
	NewMemTex = NULL ;
	j = 0 ;
	for( i = 0 ; i < GRH.SysMemTextureInitNum ; MemTex ++ )
	{
		if( MemTex->InitializeFlag == FALSE )
		{
			if( NewMemTex == NULL )
			{
				NewMemTex = MemTex ;
			}
			continue ;
		}

		i ++ ;

		if( MemTex->CubeMap     != ( unsigned char )CubeMap ||
			MemTex->Width       != ( short )        Width ||
			MemTex->Height      != ( short )        Height ||
			MemTex->MipMapCount != ( unsigned char )MipMapCount ||
			MemTex->Format      != ( unsigned char )Format )
			continue ;

		j ++ ;

		if( MemTex->UseFlag == TRUE )
		{
			// tH[}bg̃eNX`K萔gpG[
			if( j == SYSMEMTEXTURE_ONE_FORMAT_NUM )
				return -1 ;
			continue ;
		}

		MemTex->UseCount ++ ;
		MemTex->UseFlag = TRUE ;
		return ( int )( MemTex - GRH.SysMemTexture ) ; 
	}

	// KeNX`AׂẴeNX`ς݂̏ꍇ͖gpŎgppx̒ႢeNX`
	if( GRH.SysMemTextureInitNum == SYSMEMTEXTURE_NUM )
	{
		unsigned int MinUseCount ;

		MinUseCount = 0xffffffff ;
		MemTex = GRH.SysMemTexture ;
		NewMemTex = NULL ;
		for( i = 0 ; i < SYSMEMTEXTURE_NUM ; i ++, MemTex ++ )
		{
			if( MemTex->UseFlag == FALSE &&
				MemTex->UseCount <= MinUseCount )
			{
				MinUseCount = MemTex->UseCount ;
				NewMemTex = MemTex ;
			}
		}

		// ׂĂgp̏ꍇ̓G[
		if( NewMemTex == NULL )
		{
			return -1 ;
		}

		// ̃f[^
		Graphics_ObjectRelease( NewMemTex->MemTexture ) ;
		NewMemTex->MemTexture = NULL ;

		NewMemTex->InitializeFlag = FALSE ;
		NewMemTex->UseCount = 0 ;
		NewMemTex->UseFlag = FALSE ;

		// f[^炷
		GRH.SysMemTextureInitNum -- ;
	}
	else
	{
		if( NewMemTex == NULL )
		{
			NewMemTex = MemTex ;
		}
	}

	// f[^̏
	NewMemTex->InitializeFlag = TRUE ;
	NewMemTex->UseFlag = TRUE ;
	NewMemTex->CubeMap = ( unsigned char )CubeMap ;
	NewMemTex->MipMapCount = ( unsigned char )MipMapCount ;
	NewMemTex->Width = ( short )Width ;
	NewMemTex->Height = ( short )Height ;
	NewMemTex->Format = ( unsigned char )Format ;
	NewMemTex->UseCount = 1 ;

	// eNX`̍쐬
	if( CreateSysMemTextureDirect3D9Texture( NewMemTex ) < 0 )
	{
		return -1 ;
	}

	// f[^̒ǉ
	GRH.SysMemTextureInitNum ++ ;

	return ( int )( NewMemTex - GRH.SysMemTexture ) ;
}

// \̂̃f[^ɓ]p̃VXeeNX`쐬
static int CreateSysMemTextureDirect3D9Texture( IMAGEDATA2_SYSMEMTEXTURE *MemTex )
{
	if( MemTex->CubeMap != 0 )
	{
		if( GraphicsDevice_CreateCubeTexture(
			MemTex->Width,											// 
			MemTex->MipMapCount,									// MipMap x
			D_D3DUSAGE_DYNAMIC,										// tO
			GRH.TextureFormat[ MemTex->Format ],					// tH[}bg
			D_D3DPOOL_SYSTEMMEM,									// eNX` DirectX Ǘ邩ǂ
			( DX_DIRECT3DCUBETEXTURE9 ** )&MemTex->MemTexture,		// DX_DIRECT3DCUBETEXTURE9 ̃|C^󂯎AhX
			NULL													//  NULL
			) != D_D3D_OK )
		{
			DXST_ERRORLOG_ADD( _T( "L[u}bveNX`̍쐬Ɏs܂\n" ) ) ;
			return -1 ;
		}
	}
	else
	{
		if( GraphicsDevice_CreateTexture(
			MemTex->Width,									// 
			MemTex->Height,									// 
			MemTex->MipMapCount,							// MipMap x
			D_D3DUSAGE_DYNAMIC,								// tO
			GRH.TextureFormat[ MemTex->Format ],			// tH[}bg
			D_D3DPOOL_SYSTEMMEM,							// eNX` DirectX Ǘ邩ǂ
			( DX_DIRECT3DTEXTURE9 ** )&MemTex->MemTexture,	// DX_DIRECT3DTEXTURE9 ̃|C^󂯎AhX
			NULL											//  NULL
			) != D_D3D_OK )
		{
			DXST_ERRORLOG_ADD( _T( "eNX`̍쐬Ɏs܂\n" ) ) ;
			return -1 ;
		}
	}

	// I
	return 0 ;
}


#ifndef DX_NON_ASYNCLOAD

static int ReleaseSysMemTextureASyncCallback( ASYNCLOAD_MAINTHREAD_REQUESTINFO *Info )
{
	return ReleaseSysMemTexture(
				( int )Info->Data[ 0 ],
				FALSE ) ;
}

#endif // DX_NON_ASYNCLOAD

// ǗeNX`ւ̓]p̃VXeeNX`̎擾
static int ReleaseSysMemTexture( int Index, int ASyncThread )
{
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		ASYNCLOAD_MAINTHREAD_REQUESTINFO AInfo ;

		AInfo.Function = ReleaseSysMemTextureASyncCallback ;
		AInfo.Data[ 0 ] = ( DWORD_PTR )Index ;
		return AddASyncLoadRequestMainThreadInfo( &AInfo ) ;
	}
#endif // DX_NON_ASYNCLOAD

	IMAGEDATA2_SYSMEMTEXTURE *MemTex ;

	MemTex = &GRH.SysMemTexture[ Index ] ;

	if( MemTex->InitializeFlag == FALSE ||
		MemTex->UseFlag == FALSE )
		return 0 ;

	MemTex->UseFlag = FALSE ;

	// I
	return 0 ;
}

// ǗeNX`ւ̓]p̃VXeeNX`ׂĉ
static int ReleaseSysMemTextureAll( void )
{
	int i ;
	IMAGEDATA2_SYSMEMTEXTURE *MemTex ;

	MemTex = GRH.SysMemTexture ;
	for( i = 0 ; i < GRH.SysMemTextureInitNum ; MemTex ++ )
	{
		if( MemTex->InitializeFlag == FALSE )
			continue ;

		i ++ ;

		if( MemTex->MemTexture != NULL )
		{
			Graphics_ObjectRelease( MemTex->MemTexture ) ;
			MemTex->MemTexture = NULL ;
		}

		MemTex->InitializeFlag = FALSE ;
		MemTex->UseCount = 0 ;
		MemTex->UseFlag = FALSE ;
	}
	GRH.SysMemTextureInitNum = 0 ;

	// I
	return 0 ;
}

// `peNX`ƕ`peNX`ĂꍇɁA`peNX`ɕ`peNX`̓e𔽉f
static int UpdateDrawTexture( IMAGEDATA2_ORIG_HARD_TEX *OrigTex, int TargetSurface )
{
	GraphicsDevice_StretchRect(
		OrigTex->RenderTargetSurface,
		NULL,
		OrigTex->Surface[ TargetSurface ],
		NULL,
		D_D3DTEXF_NONE ) ;

	// I
	return 0 ;
}

// lr``gp`\摜ǂ𒲂ׂ( TRUE:MSAA摜  FALSE:MSAA摜ł͂Ȃ )
static int CheckMultiSampleDrawValidGraph( int GrHandle )
{
	IMAGEDATA2 *Image2 ;

	if( GRAPHCHKFULL( GrHandle, Image2 ) )
		return FALSE ;

	if( Image2->Orig->FormatDesc.TextureFlag == FALSE )
		return FALSE ;

	return Image2->Orig->FormatDesc.MSSamples != 0 ? TRUE : FALSE ;
}



#ifndef DX_NON_MOVIE

// [r[摜XV
static void UpdateGraphMovie( MOVIEGRAPH *Movie, DWORD_PTR GrHandle )
{
	IMAGEDATA2 *Image2 ;
	IMAGEDATA2_ORIG *Orig ;

	if( GRAPHCHK( ( LONG_PTR )GrHandle, Image2 ) )
		return;
	Orig = Image2->Orig ;

	// eNX`ǂŏ𕪊
	if( Image2->Orig->FormatDesc.TextureFlag )
	{
		// eNX`̏ꍇ

	//	D_DDSURFACEDESC2 SrcDesc ;
		BASEIMAGE MovieImage, AlphaImage ;
		RECT SrcRect ;
#ifndef DX_NON_OGGTHEORA
		DX_DIRECT3DSURFACE9 *YUY2Image ;
#endif

		// [r[C[W̍\z
#ifndef DX_NON_OGGTHEORA
		// Ogg Theora gpĂꍇ͂ōXV
		if( Movie->TheoraFlag )
		{
			if( Movie->RightAlpha == TRUE || TheoraDecode_GetYUVImage( Movie->TheoraHandle ) == NULL )
			{
				if( TheoraDecode_SetupImage( Movie->TheoraHandle, 1, 0 ) == 0 )
				{
					return ;
				}
			}
			else
			{
				if( TheoraDecode_SetupImage( Movie->TheoraHandle, 0, 1 ) == 0 )
				{
					return ;
				}
			}
		}

		// Theora gpĂāA YUY2 tH[}bggpĂ邩ŏ𕪊
		if( Movie->TheoraFlag && Movie->RightAlpha == FALSE && ( YUY2Image = ( DX_DIRECT3DSURFACE9 * )TheoraDecode_GetYUVImage( Movie->TheoraHandle ) ) )
		{
			if( GraphicsDevice_IsValid() != 0 )
			{
				RECT Rect ;
				DX_DIRECT3DSURFACE9 *Surface ;

				// rbg}bvf[^𕪊ĂeNX`[ɓ\t
				SETRECT( Rect, 0, 0, Image2->Orig->Hard.Tex[ 0 ].UseWidth, Image2->Orig->Hard.Tex[ 0 ].UseHeight ) ;

				// OtBbN̓]
				if( GraphicsTexture_GetSurfaceLevel( Image2->Orig->Hard.Tex[ 0 ].Texture, 0, &Surface ) == D_D3D_OK )
				{
					HRESULT hr ;
					hr = GraphicsDevice_StretchRect( YUY2Image, &Rect, Surface, &Rect, D_D3DTEXF_NONE ) ;
					Graphics_ObjectRelease( Surface ) ;
				}
			}
		}
		else
#endif
		{
			// [r[̃C[W쐬
			MovieImage = *Movie->UseNowImage ;
			
			// EAt@̏ꍇ̓At@]鏀
			if( Movie->RightAlpha )
			{
				MovieImage.Width /= 2;
				AlphaImage = MovieImage;
				AlphaImage.GraphData = (BYTE *)MovieImage.GraphData + MovieImage.Width * MovieImage.ColorData.PixelByte ;
			}

			// ]`Zbg
			SETRECT( SrcRect, Image2->UseOrigX, Image2->UseOrigY, Image2->UseOrigX + Image2->Width, Image2->UseOrigY + Image2->Height ) ;

			// ĂeNX`[ɓ\t
			BltBmpOrBaseImageToGraph3(
				NULL,
				NULL,
				NULL,
				&SrcRect,
				0,
				0,
				( int )GrHandle,
				FALSE,
				&MovieImage,
				Movie->RightAlpha ? &AlphaImage : NULL,
				FALSE,
				FALSE,
				FALSE ) ;
		}
	}
	else
	{
		// eNX`ł͖ꍇ
		MEMIMG *MemImg ;

		MemImg = &Image2->Soft.MemImg ;

#ifndef DX_NON_OGGTHEORA
		// Ogg Theora gpĂꍇ͂ōXV
		if( Movie->TheoraFlag )
		{
			if( TheoraDecode_SetupImage( Movie->TheoraHandle, 1, 0 ) == 0 )
				return ;
		}
#endif

		// sNZtH[}bgႤAEAt@ƂĈꍇ̓J[}b`O]s
		if( Movie->SurfaceMode == DX_MOVIESURFACE_FULLCOLOR ||
			MemImg->Base->ColorDataP->ColorBitDepth != Movie->UseNowImage->ColorData.ColorBitDepth ||
			Movie->RightAlpha == 1 )
		{
			// EAt@ł͂Ȃꍇ͊ȈՓ]
			if( Movie->RightAlpha == 0 )
			{
				BltBaseImageToMemImg(
					Movie->UseNowImage,
					NULL,
					MemImg,
					0,
					0,
					Image2->Width,
					Image2->Height,
					0,
					0,
					FALSE ) ;
			}
			else
			{
				// EAt@̏ꍇ͒ʏ]
				BASEIMAGE MovieImage, AlphaImage;
				RECT SrcRect ;

				SETRECT( SrcRect, 0, 0, Image2->Width, Image2->Height ) ;
				MovieImage.ColorData	= Movie->UseNowImage->ColorData ;
				MovieImage.GraphData	= Movie->UseNowImage->GraphData ;
				MovieImage.Pitch		= Movie->UseNowImage->Pitch ;
				MovieImage.Width		= Movie->UseNowImage->Width / 2;
				MovieImage.Height		= Movie->UseNowImage->Height ;

				AlphaImage = MovieImage;
				AlphaImage.GraphData = (BYTE *)MovieImage.GraphData + MovieImage.Width * MovieImage.ColorData.PixelByte ;

				// OtBbN̓]
				BltBaseImageToMemImg(
					&MovieImage,
					&AlphaImage,
					MemImg,
					0,
					0,
					Image2->Width,
					Image2->Height,
					0,
					0,
					FALSE ) ;
			}
		}
		else
		{
			// ]vO
			void *DestP, *SrcP ;
			int SrcAddPitch, DestAddPitch ;
			int DwMoveSetNum, NokoriMoveSetNum ;
			int MoveLineByte, ColorBitDepth ;
			int PixelByte ;
			int BltHeight ;

			// ]郉CZbg
			BltHeight = Movie->Height ;

			// FrbgZbg
			ColorBitDepth = NS_GetColorBitDepth() ;

			// Phbg̃oCg擾
			PixelByte = ColorBitDepth / 8 ;

			// PC̓]TCYZbg
			MoveLineByte = Movie->Width * PixelByte ;

			// ]AAhXZbg
			DestP = MemImg->UseImage ;
			SrcP = Movie->UseNowImage->GraphData ;

			// PC]A̓]AhX܂ł̃oCgvZ
			DestAddPitch = MemImg->Base->Pitch - MoveLineByte ;
			SrcAddPitch = Movie->UseNowImage->Pitch - MoveLineByte ;

			// SoCg]Ǎ゠܂]sNZ邩Zo
			DwMoveSetNum = MoveLineByte / 4 ;
			NokoriMoveSetNum = ( MoveLineByte - DwMoveSetNum * 4 ) / PixelByte ;

			// ]
#ifndef DX_NON_INLINE_ASM
			_asm{
				PUSHF
				CLD
				MOV		EDI, DestP
				MOV		ESI, SrcP
				MOV		EAX, DestAddPitch
				MOV		EBX, SrcAddPitch
				MOV		EDX, BltHeight
				CMP		ColorBitDepth, 8
				JZ		CB8
				CMP		ColorBitDepth, 16
				JZ		CB16


			CB32:
				MOV		ECX, DwMoveSetNum
				REP		MOVSD
				ADD		EDI, DestAddPitch
				ADD		ESI, SrcAddPitch
				DEC		EDX
				JNZ		CB32
				JMP		END_


			CB16:
				MOV		ECX, DwMoveSetNum
				TEST	ECX, 0xffffffff
				JZ		B161
				REP		MOVSD
			B161:
				MOV		ECX, NokoriMoveSetNum
				TEST	ECX, 0xffffffff
				JZ		B162
				REP		MOVSW
			B162:
				ADD		EDI, DestAddPitch
				ADD		ESI, SrcAddPitch
				DEC		EDX
				JNZ		CB16
				JMP		END_


			CB8:
				MOV		ECX, DwMoveSetNum
				TEST	ECX, 0xffffffff
				JZ		B81
				REP		MOVSD
			B81:
				MOV		ECX, NokoriMoveSetNum
				TEST	ECX, 0xffffffff
				JZ		B82
				REP		MOVSB
			B82:
				ADD		EDI, DestAddPitch
				ADD		ESI, SrcAddPitch
				DEC		EDX
				JNZ		CB8
				JMP		END_

			END_:
				POPF
			}
#else
			int i, j ;
			BYTE *DestBP, *SrcBP ;

			DestBP = ( BYTE * )DestP ;
			SrcBP = ( BYTE * )SrcP ;
			switch( ColorBitDepth )
			{
			case 8 :
				for( i = BltHeight ; i > 0 ; i -- )
				{
					for( j = DwMoveSetNum ; j > 0 ; j --, DestBP += 4, SrcBP += 4 )
					{
						*( ( DWORD * )DestBP ) = *( ( DWORD * )SrcBP ) ;
					}
					for( j = NokoriMoveSetNum ; j > 0 ; j --, DestBP ++, SrcBP ++ )
					{
						*DestBP = *SrcBP ;
					}
					DestBP += DestAddPitch ;
					SrcBP += SrcAddPitch ;
				}
				break ;

			case 16 :
				for( i = BltHeight ; i > 0 ; i -- )
				{
					for( j = DwMoveSetNum ; j > 0 ; j --, DestBP += 4, SrcBP += 4 )
					{
						*( ( DWORD * )DestBP ) = *( ( DWORD * )SrcBP ) ;
					}
					for( j = NokoriMoveSetNum ; j > 0 ; j --, DestBP += 2, SrcBP += 2 )
					{
						*( ( WORD * )DestBP ) = *( ( WORD * )SrcBP ) ;
					}
					DestBP += DestAddPitch ;
					SrcBP += SrcAddPitch ;
				}
				break ;

			case 32 :
				for( i = BltHeight ; i > 0 ; i -- )
				{
					for( j = DwMoveSetNum ; j > 0 ; j --, DestBP += 4, SrcBP += 4 )
					{
						*( ( DWORD * )DestBP ) = *( ( DWORD * )SrcBP ) ;
					}
					DestBP += DestAddPitch ;
					SrcBP += SrcAddPitch ;
				}
				break ;
			}
#endif
		}
	}
}

#endif

// D3DFORMAT ̃tH[}bgɍ킹J[tH[}bg擾
extern COLORDATA *GetD3DFormatColorData( D_D3DFORMAT Format )
{
	static int InitializeFlag = FALSE ;
	static COLORDATA R8G8B8_ColorData,   A8R8G8B8_ColorData,    X8R8G8B8_ColorData ;
	static COLORDATA R5G6B5_ColorData,   X1R5G5B5_ColorData,    A1R5G5B5_ColorData ;
	static COLORDATA A4R4G4B4_ColorData, R3G3B2_ColorData,      A8R3G3B2_ColorData ;
	static COLORDATA X4R4G4B4_ColorData, A2B10G10R10_ColorData, A8B8G8R8_ColorData ;
	static COLORDATA X8B8G8R8_ColorData, A2R10G10B10_ColorData ;
	static COLORDATA A16B16G16R16I_ColorData ;
	static COLORDATA A16B16G16R16F_ColorData ;
	static COLORDATA A32B32G32R32F_ColorData ;
	static COLORDATA ONE_I8_ColorData ;
	static COLORDATA ONE_I16_ColorData ;
	static COLORDATA ONE_F16_ColorData ;
	static COLORDATA ONE_F32_ColorData ;
	static COLORDATA TWO_I8_ColorData ;
	static COLORDATA TWO_I16_ColorData ;
	static COLORDATA TWO_F16_ColorData ;
	static COLORDATA TWO_F32_ColorData ;

	if( InitializeFlag == FALSE )
	{
		InitializeFlag = TRUE ;
		NS_CreateColorData( &R8G8B8_ColorData,         24, 0x00ff0000, 0x0000ff00, 0x000000ff, 0x00000000 ) ;
		NS_CreateColorData( &A8R8G8B8_ColorData,       32, 0x00ff0000, 0x0000ff00, 0x000000ff, 0xff000000 ) ;
		NS_CreateColorData( &X8R8G8B8_ColorData,       32, 0x00ff0000, 0x0000ff00, 0x000000ff, 0x00000000 ) ;
		NS_CreateColorData( &R5G6B5_ColorData,         16, 0x0000f800, 0x000007e0, 0x0000001f, 0x00000000 ) ;
		NS_CreateColorData( &X1R5G5B5_ColorData,       16, 0x00007c00, 0x000003e0, 0x0000001f, 0x00000000 ) ;
		NS_CreateColorData( &A1R5G5B5_ColorData,       16, 0x00007c00, 0x000003e0, 0x0000001f, 0x00008000 ) ;
		NS_CreateColorData( &A4R4G4B4_ColorData,       16, 0x00000f00, 0x000000f0, 0x0000000f, 0x0000f000 ) ;
		NS_CreateColorData( &R3G3B2_ColorData,          8, 0x000000e0, 0x0000001c, 0x00000003, 0x00000000 ) ;
		NS_CreateColorData( &A8R3G3B2_ColorData,       16, 0x000000e0, 0x0000001c, 0x00000003, 0x0000ff00 ) ;
		NS_CreateColorData( &X4R4G4B4_ColorData,       16, 0x00000f00, 0x000000f0, 0x0000000f, 0x00000000 ) ;
		NS_CreateColorData( &A2B10G10R10_ColorData,    32, 0x000003ff, 0x000ffc00, 0x3ff00000, 0xc0000000 ) ;
		NS_CreateColorData( &A8B8G8R8_ColorData,       32, 0x000000ff, 0x0000ff00, 0x00ff0000, 0xff000000 ) ;
		NS_CreateColorData( &X8B8G8R8_ColorData,       32, 0x000000ff, 0x0000ff00, 0x00ff0000, 0x00000000 ) ;
		NS_CreateColorData( &A2R10G10B10_ColorData,    32, 0x3ff00000, 0x000ffc00, 0x000003ff, 0xc0000000 ) ;
		NS_CreateColorData( &A16B16G16R16I_ColorData,   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 4, 16, FALSE ) ;
		NS_CreateColorData( &A16B16G16R16F_ColorData,   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 4, 16,  TRUE ) ;
		NS_CreateColorData( &A32B32G32R32F_ColorData,   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 4, 32,  TRUE ) ;
		NS_CreateColorData( &ONE_I8_ColorData,	        0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1,  8, FALSE ) ;
		NS_CreateColorData( &ONE_I16_ColorData,	        0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1, 16, FALSE ) ;
		NS_CreateColorData( &ONE_F16_ColorData,	        0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1, 16,  TRUE ) ;
		NS_CreateColorData( &ONE_F32_ColorData,	        0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1, 32,  TRUE ) ;
		NS_CreateColorData( &TWO_I8_ColorData,	        0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 2,  8, FALSE ) ;
		NS_CreateColorData( &TWO_I16_ColorData,	        0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 2, 16, FALSE ) ;
		NS_CreateColorData( &TWO_F16_ColorData,	        0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 2, 16,  TRUE ) ;
		NS_CreateColorData( &TWO_F32_ColorData,	        0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 2, 32,  TRUE ) ;
	}

	switch( Format )
	{
	case D_D3DFMT_R8G8B8 :        return &R8G8B8_ColorData ;
	case D_D3DFMT_A8R8G8B8 :      return &A8R8G8B8_ColorData ;
	case D_D3DFMT_X8R8G8B8 :      return &X8R8G8B8_ColorData ;
	case D_D3DFMT_R5G6B5 :        return &R5G6B5_ColorData ;
	case D_D3DFMT_X1R5G5B5 :      return &X1R5G5B5_ColorData ;
	case D_D3DFMT_A1R5G5B5 :      return &A1R5G5B5_ColorData ;
	case D_D3DFMT_A4R4G4B4 :      return &A4R4G4B4_ColorData ;
	case D_D3DFMT_R3G3B2 :        return &R3G3B2_ColorData ;
	case D_D3DFMT_A8R3G3B2 :      return &A8R3G3B2_ColorData ;
	case D_D3DFMT_X4R4G4B4 :      return &X4R4G4B4_ColorData ;
	case D_D3DFMT_A2B10G10R10 :   return &A2B10G10R10_ColorData ;
	case D_D3DFMT_A8B8G8R8 :      return &A8B8G8R8_ColorData ;
	case D_D3DFMT_X8B8G8R8 :      return &X8B8G8R8_ColorData ;
	case D_D3DFMT_A2R10G10B10 :   return &A2R10G10B10_ColorData ;
	case D_D3DFMT_A16B16G16R16 :  return &A16B16G16R16I_ColorData ;
	case D_D3DFMT_A16B16G16R16F : return &A16B16G16R16F_ColorData ;
	case D_D3DFMT_A32B32G32R32F : return &A32B32G32R32F_ColorData ;
	case D_D3DFMT_L8 :            return &ONE_I8_ColorData ;
	case D_D3DFMT_L16 :           return &ONE_I16_ColorData ;
	case D_D3DFMT_R16F :          return &ONE_F16_ColorData ;
	case D_D3DFMT_R32F :          return &ONE_F32_ColorData ;
	case D_D3DFMT_V8U8 :          return &TWO_I8_ColorData ;
	case D_D3DFMT_G16R16 :        return &TWO_I16_ColorData ;
	case D_D3DFMT_G16R16F :       return &TWO_F16_ColorData ;
	case D_D3DFMT_G32R32F :       return &TWO_F32_ColorData ;
	}
	return NULL ;
}

extern int AllocCommonBuffer( int Index, DWORD Size )
{
	if( Index >= COMMON_BUFFER_NUM || Index < 0 )
	{
		return -1 ;
	}

	if( GRH.CommonBufferSize[ Index ] >= Size )
	{
		return 0 ;
	}

	GRH.CommonBuffer[ Index ] = DXALLOC( Size ) ;
	if( GRH.CommonBuffer[ Index ] == NULL )
	{
		return -1 ;
	}
	GRH.CommonBufferSize[ Index ] = Size ;

	return 0 ;
}

extern int TerminateCommonBuffer( void ) 
{
	int i ;

	for( i = 0 ; i < COMMON_BUFFER_NUM ; i ++ )
	{
		if( GRH.CommonBuffer[ i ] != NULL )
		{
			DXFREE( GRH.CommonBuffer[ i ] ) ;
			GRH.CommonBuffer[ i ] = 0 ;
		}

		GRH.CommonBufferSize[ i ] = 0 ;
	}

	return 0 ;
}

// VOtBbNnhmۂ
extern int AddGraphHandle( void )
{
	return AddHandle( DX_HANDLETYPE_GRAPH );
}

// OtBbNnh̏
extern int InitializeGraphHandle( HANDLEINFO *HandleInfo )
{
	IMAGEDATA2 *Image2 = ( IMAGEDATA2 * )HandleInfo ;

#ifndef DX_NON_MOVIE
	// [r[nh͖
	Image2->MovieHandle = -1 ;
#endif

	// I
	return 0 ;
}

// OtBbNnȟn
extern int TerminateGraphHandle( HANDLEINFO *HandleInfo )
{
	IMAGEDATA2 *Image2 = ( IMAGEDATA2 * )HandleInfo ;
	int i ;

	// [r[OtBbNꍇ̌ns
#ifndef DX_NON_MOVIE
	CloseMovie( Image2->MovieHandle ) ;
#endif

	// `ɂȂĂ`\ʂɂ
	for( i = 0 ; i < GRH.RenderTargetNum ; i ++ )
	{
		if( GBASE.TargetScreen[ i ] == Image2->HandleInfo.Handle )
		{
			NS_SetRenderTargetToShader( i, i == 0 ? DX_SCREEN_FRONT : -1 ) ;
		}
	}

	// `yobt@ɂȂĂ`𗠉ʂɂ
	if( GBASE.TargetZBuffer == Image2->HandleInfo.Handle )
	{
		NS_SetDrawZBuffer( DX_SCREEN_BACK ) ;
	}

	// IWif[^ꍇ̓IWif[^̉s
	if( Image2->Orig )
	{
		// eNX`ǂŏ𕪊
		if( Image2->Orig->FormatDesc.TextureFlag )
		{
			// eNX`̏ꍇ
		}
		else
		{
			// eNX`ł͖ꍇ

			// `p MEMIMG ̌n
			TerminateMemImg( &Image2->Soft.MemImg ) ;
		}

		// IWif[^̎QƐfNg
		Image2->Orig->RefCount -- ;

		// OɂȂIWif[^̉s
		if( Image2->Orig->RefCount == 0 )
		{
			// yobt@
			//ReleaseOrigZBuffer( Image2->Orig ) ;

			// eNX`ǂŏ𕪊
			if( Image2->Orig->FormatDesc.TextureFlag )
			{
				// eNX`̏ꍇ

				// eNX`IuWFNg̉
				ReleaseOrigTexture( Image2->Orig ) ;
			}
			else
			{
				// eNX`ł͖ꍇ

				// MEMIMG 
				TerminateMemImg( &Image2->Orig->Soft.MemImg ) ;
			}

			// IWi摜f[^pɊmۂ̈J
			DXFREE( Image2->Orig ) ;
		}

		Image2->Orig = NULL ;
	}

	// tJ[C[Wꍇ͉
	if( Image2->FullColorImage != NULL )
	{
		DXFREE( Image2->FullColorImage ) ;
		Image2->FullColorImage = NULL ;
	}

	// bNC[Wꍇ͉
	if( Image2->LockImage != NULL )
	{
		DXFREE( Image2->LockImage ) ;
		Image2->LockImage = NULL ;
	}

	// t@CۑpɃmۂĂꍇ͉
	SetGraphBaseInfo( Image2->HandleInfo.Handle, NULL, NULL, NULL, NULL, NULL, 0, NULL, 0, NULL, NULL, FALSE, -1, FALSE ) ;

	// ɗĂtOւ̃|C^Lłꍇ͗Ă
	if( Image2->LostFlag != NULL )
		*Image2->LostFlag = TRUE ;

	// I
	return 0 ;
}

// OtBbÑf[^CfbNXlo
extern IMAGEDATA2 *GetGraphData2( int GrHandle, int ASyncThread )
{
	IMAGEDATA2 *Image2 ;

	// G[
	if( ASyncThread )
	{
		if( GRAPHCHK_ASYNC( GrHandle, Image2 ) )
			return NULL ;
	}
	else
	{
		if( GRAPHCHK( GrHandle, Image2 ) )
			return NULL ;
	}

	return Image2 ;
}




// Direct3DDevice9 IuWFNg̍쐬
extern int CreateDirect3D9DeviceObject()
{
	HRESULT hr ;
	const TCHAR *String = NULL ;
	int ErrorRet = -1 ;

	if( Graphics_IsValid() == 0 ) return -1 ;

	// ɍ쐬ς݂̏ꍇ͈x폜
	GraphicsDevice_Release() ;
	GRH.BeginSceneFlag = FALSE ;

	// VF[_[QDOgȂł̓tXN[A`GCAX𐳏Ɏg\Ⴂ̂
	// VF[_[QDOgȂł̓tXN[A`GCAX𖳌ɂ
	if( NS_GetValidShaderVersion() < 200 )
	{
		GRH.FSAAMultiSampleType = D_D3DMULTISAMPLE_NONE ;
		GRH.FSAAMultiSampleQuality = 0 ;
	}

	// foCX̍쐬
	if( Graphics_CreateDevice() < 0 )
	{
		// sʃ[hύXĎ
		GRA2.MainScreenColorBitDepth = 32 ;
		SetMemImgDefaultColorType( GRA2.MainScreenColorBitDepth == 32 ? 1 : 0 ) ;
		if( Graphics_CreateDevice() < 0 )
		{
			SetMainScreenSize( 800, 600 ) ;
			if( Graphics_CreateDevice() < 0 )
			{
				SetMainScreenSize( 1024, 768 ) ;
				if( Graphics_CreateDevice() < 0 )
				{
					goto ERR ;
				}
			}
		}
	}

	// VSync̑OSleep鎞Ԃ擾
	GraphicsDevice_WaitVSyncInitialize() ;

	// Œ@\pCvCɖ߂
	GRH.SetVS = NULL ;
	GRH.SetVD = NULL ;
	GRH.SetPS = NULL ;
	GRH.SetFVF = 0 ;
	GRH.SetIB = NULL ;
	GRH.SetVB = NULL ;

	// obNobt@̃AhX擾Ă
	hr = GraphicsDevice_GetBackBuffer( 0, 0, D_D3DBACKBUFFER_TYPE_MONO, &GRH.BackBufferSurface ) ;

	DXST_ERRORLOG_ADD( _T( "\n" ) ) ;

	// ꍇ̓foCX擾
	GraphicsDevice_GetDeviceCaps( &GRH.DeviceCaps ) ;

	// Ƀ_Oł^[Qbg̐ۑ
	GRH.RenderTargetNum = GRH.DeviceCaps.NumSimultaneousRTs ;
	if( GRH.RenderTargetNum > DX_RENDERTARGET_COUNT )
	{
		GRH.RenderTargetNum = DX_RENDERTARGET_COUNT ;
	}

	// eNX`Xe[W̃e|WX^gpł邩ǂۑ
	GRH.ValidTexTempRegFlag = ( GRH.DeviceCaps.PrimitiveMiscCaps & D_D3DPMISCCAPS_TSSARGTEMP ) != 0 ? TRUE : FALSE ;

	// VF[_[gȂݒ̏ꍇ͕K
	if( GRH.NonUseVertexHardwareProcess )
	{
		GRH.ValidVertexShader = FALSE ;
		GRH.ValidPixelShader = FALSE ;
		GRH.ValidVertexShader_SM3 = FALSE ;
		GRH.ValidPixelShader_SM3 = FALSE ;
	}
	else
	{
		// _VF[_[gp\ǂۑ
		GRH.ValidVertexShader = /* GRH.VertexHardwareProcess && */ ( GRH.DeviceCaps.VertexShaderVersion & 0xffff ) >= 0x0200 ;

		// sNZVF[_[gp\ǂۑ
		GRH.ValidPixelShader = /* GRH.VertexHardwareProcess && */ ( GRH.DeviceCaps.PixelShaderVersion & 0xffff ) >= 0x0200 ;

		// SM3.0̒_VF[_[gp\ǂۑ
		GRH.ValidVertexShader_SM3 = /* GRH.VertexHardwareProcess && */ ( GRH.DeviceCaps.VertexShaderVersion & 0xffff ) >= 0x0300 ;

		// SM3.0̃sNZVF[_[gp\ǂۑ
		GRH.ValidPixelShader_SM3 = /* GRH.VertexHardwareProcess && */ ( GRH.DeviceCaps.PixelShaderVersion & 0xffff ) >= 0x0300 ;
	}

	// D3DBLENDOP_ADD ȊOgpł邩ǂ擾
	GRH.ValidDestBlendOp = ( GRH.DeviceCaps.PrimitiveMiscCaps & D_D3DPMISCCAPS_BLENDOP ) == 0 ? FALSE : TRUE ;

	// eNX`̃TCYQ̂łKv邩ǂ擾
	GRH.TextureSizePow2 = ( GRH.DeviceCaps.TextureCaps & D_D3DPTEXTURECAPS_POW2 ) != 0 ? TRUE : FALSE ;

	// tŃeNX`̃TCYQ̂łȂĂvǂ擾
	GRH.TextureSizeNonPow2Conditional = ( GRH.DeviceCaps.TextureCaps & D_D3DPTEXTURECAPS_NONPOW2CONDITIONAL ) != 0 ? TRUE : FALSE ;

	// eNX`TCYݒ肳ĂȂꍇ͐ݒ肷
	if( GRH.DeviceCaps.MaxTextureWidth  == 0 ) GRH.DeviceCaps.MaxTextureWidth  = DEFAULT_MAXTEXTURE_SIZE ;
	if( GRH.DeviceCaps.MaxTextureHeight == 0 ) GRH.DeviceCaps.MaxTextureHeight = DEFAULT_MAXTEXTURE_SIZE ;

	// TCY̏قőTCYƂ
	GRH.MaxTextureSize = GRH.DeviceCaps.MaxTextureWidth < GRH.DeviceCaps.MaxTextureHeight ? GRH.DeviceCaps.MaxTextureWidth : GRH.DeviceCaps.MaxTextureHeight ;

	// xɕ`łőv~eBu擾
	GRH.MaxPrimitiveCount = GRH.DeviceCaps.MaxPrimitiveCount ;

	// _J[gp邩ǂ̒l
	GRH.MaterialUseVertexDiffuseColor = 0xff ;
	GRH.MaterialUseVertexSpecularColor = 0xff ;

	// DrawPreparation sׂtO𗧂Ă
	GRH.DrawPrepAlwaysFlag = TRUE ;

	{
		D_D3DADAPTER_IDENTIFIER9 Iden ;

		Graphics_GetAdapterIdentifier( D_D3DADAPTER_DEFAULT, 0, &Iden ) ;
		DXST_ERRORLOGFMT_ADDA(( "Driver:%s  Description:%s", Iden.Driver, Iden.Description )) ;
	}

	// etH[}bg𒲂ׂ
	{
		D_D3DSURFACE_DESC SurfaceDesc ;

		// ʂ̃tH[}bg̎擾
		GraphicsSurface_GetDesc( GRH.BackBufferSurface, &SurfaceDesc ) ;
		GRH.ScreenFormat = SurfaceDesc.Format ;
		switch( GRH.ScreenFormat )
		{
		case D_D3DFMT_X8R8G8B8 : String = _T( "D3DFMT_X8R8G8B8" ) ; break ;
		case D_D3DFMT_R5G6B5 :   String = _T( "D3DFMT_R5G6B5" ) ;   break ;
		case D_D3DFMT_X1R5G5B5 : String = _T( "D3DFMT_X1R5G5B5" ) ; break ;
		default:
			DXST_ERRORLOGFMT_ADD(( _T( "obNobt@ΉĂȂtH[}bg %d ł" ), GRH.ScreenFormat )) ;
			break ;
		}
		DXST_ERRORLOGFMT_ADD(( _T( "ʂ̃tH[}bg %s ł" ), String )) ;

		// 16rbgyobt@tH[}bg̐ݒ
		GRH.ZBufferFormat[ ZBUFFER_FORMAT_16BIT ] = D_D3DFMT_D16 ;
		String = _T( "D3DFMT_D16" ) ;
		DXST_ERRORLOGFMT_ADD(( _T( "16bit Zobt@tH[}bg %s ł" ), String )) ;

		// 24rbgyobt@tH[}bg̑I
		if( Graphics_CheckDepthStencilMatch( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, GRH.ScreenFormat, D_D3DFMT_D24X8 ) == D_D3D_OK )
		{
			GRH.ZBufferFormat[ ZBUFFER_FORMAT_24BIT ] = D_D3DFMT_D24X8 ;
			String = _T( "D3DFMT_D24X8" ) ;
		}
		else
		if( Graphics_CheckDepthStencilMatch( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, GRH.ScreenFormat, D_D3DFMT_D32 ) == D_D3D_OK )
		{
			GRH.ZBufferFormat[ ZBUFFER_FORMAT_24BIT ] = D_D3DFMT_D32 ;
			String = _T( "D3DFMT_D32" ) ;
		}
		else
		{
			GRH.ZBufferFormat[ ZBUFFER_FORMAT_24BIT ] = D_D3DFMT_D16 ;
			String = _T( "D3DFMT_D16" ) ;
		}
		DXST_ERRORLOGFMT_ADD(( _T( "24bit Zobt@tH[}bg %s ł" ), String )) ;

		// 32rbgyobt@tH[}bg̑I
		if( Graphics_CheckDepthStencilMatch( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, GRH.ScreenFormat, D_D3DFMT_D32 ) == D_D3D_OK )
		{
			GRH.ZBufferFormat[ ZBUFFER_FORMAT_32BIT ] = D_D3DFMT_D32 ;
			String = _T( "D3DFMT_D32" ) ;
		}
		else
		if( Graphics_CheckDepthStencilMatch( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, GRH.ScreenFormat, D_D3DFMT_D24X8 ) == D_D3D_OK )
		{
			GRH.ZBufferFormat[ ZBUFFER_FORMAT_32BIT ] = D_D3DFMT_D24X8 ;
			String = _T( "D3DFMT_D24X8" ) ;
		}
		else
		if( Graphics_CheckDepthStencilMatch( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, GRH.ScreenFormat, D_D3DFMT_D16 ) == D_D3D_OK )
		{
			GRH.ZBufferFormat[ ZBUFFER_FORMAT_32BIT ] = D_D3DFMT_D16 ;
			String = _T( "D3DFMT_D16" ) ;
		}
		DXST_ERRORLOGFMT_ADD(( _T( "32bit Zobt@tH[}bg %s ł" ), String )) ;

		// 16rbgJ[tH[}bg̑I
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, 0, D_D3DRTYPE_TEXTURE, D_D3DFMT_R5G6B5 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_RGB16 ] = D_D3DFMT_R5G6B5 ;
			String = _T( "D3DFMT_R5G6B5" ) ;
		}
		else
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, 0, D_D3DRTYPE_TEXTURE, D_D3DFMT_X1R5G5B5 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_RGB16 ] = D_D3DFMT_X1R5G5B5 ;
			String = _T( "D3DFMT_X1R5G5B5" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł 16bit J[tH[}bg܂ł\n" ) ) ;
			goto ERR ;
		}
		DXST_ERRORLOGFMT_ADD(( _T( "16bit J[tH[}bg %s ł" ), String )) ;

		// 32rbgJ[tH[}bg̑I
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, 0, D_D3DRTYPE_TEXTURE, D_D3DFMT_X8R8G8B8 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_RGB32 ] = D_D3DFMT_X8R8G8B8 ;
			String = _T( "D3DFMT_X8R8G8B8" ) ;
		}
		else
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_RGB32 ] = GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_RGB16 ] ;
		}
		DXST_ERRORLOGFMT_ADD(( _T( "32bit J[tH[}bg %s ł" ), String )) ;

		// At@t 16rbgJ[tH[}bg̑I
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, 0, D_D3DRTYPE_TEXTURE, D_D3DFMT_A4R4G4B4 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHA_RGB16 ] = D_D3DFMT_A4R4G4B4 ;
			String = _T( "D3DFMT_A4R4G4B4" ) ;
		}
		else
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, 0, D_D3DRTYPE_TEXTURE, D_D3DFMT_A8R8G8B8 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHA_RGB16 ] = D_D3DFMT_A8R8G8B8 ;
			String = _T( "D3DFMT_A8R8G8B8" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpłAt@t 16bit J[tH[}bg܂ł\n" ) ) ;
			goto ERR ;
		}
		DXST_ERRORLOGFMT_ADD(( _T( "At@t 16bit J[tH[}bg %s ł" ), String )) ;

		// At@t 32rbgJ[tH[}bg̑I
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, 0, D_D3DRTYPE_TEXTURE, D_D3DFMT_A8R8G8B8 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHA_RGB32 ] = D_D3DFMT_A8R8G8B8 ;
			String = _T( "D3DFMT_A8R8G8B8" ) ;
		}
		else
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, 0, D_D3DRTYPE_TEXTURE, D_D3DFMT_A4R4G4B4 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHA_RGB32 ] = D_D3DFMT_A4R4G4B4 ;
			String = _T( "D3DFMT_A4R4G4B4" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpłAt@t 32bit J[tH[}bg܂ł\n" ) ) ;
			goto ERR ;
		}
		DXST_ERRORLOGFMT_ADD(( _T( "At@t 32bit J[tH[}bg %s ł" ), String )) ;

		// At@eXgp 16rbgJ[tH[}bg̑I
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, 0, D_D3DRTYPE_TEXTURE, D_D3DFMT_A1R5G5B5 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHATEST_RGB16 ] = D_D3DFMT_A1R5G5B5 ;
			String = _T( "D3DFMT_A1R5G5B5" ) ;
		}
		else
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, 0, D_D3DRTYPE_TEXTURE, D_D3DFMT_A8R8G8B8 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHATEST_RGB16 ] = D_D3DFMT_A8R8G8B8 ;
			String = _T( "D3DFMT_A8R8G8B8" ) ;
		}
		else
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, 0, D_D3DRTYPE_TEXTURE, D_D3DFMT_A4R4G4B4 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHATEST_RGB16 ] = D_D3DFMT_A4R4G4B4 ;
			String = _T( "D3DFMT_A4R4G4B4" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpłAt@eXgp 16bit J[tH[}bg܂ł\n" ) ) ;
			goto ERR ;
		}
		DXST_ERRORLOGFMT_ADD(( _T( "At@eXgp 16bit J[tH[}bg %s ł" ), String )) ;

		// At@eXgp 32rbgJ[tH[}bg̑I
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, 0, D_D3DRTYPE_TEXTURE, D_D3DFMT_A8R8G8B8 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHATEST_RGB32 ] = D_D3DFMT_A8R8G8B8 ;
			String = _T( "D3DFMT_A8R8G8B8" ) ;
		}
		else
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, 0, D_D3DRTYPE_TEXTURE, D_D3DFMT_A1R5G5B5 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHATEST_RGB32 ] = D_D3DFMT_A1R5G5B5 ;
			String = _T( "D3DFMT_A1R5G5B5" ) ;
		}
		else
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, 0, D_D3DRTYPE_TEXTURE, D_D3DFMT_A4R4G4B4 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHATEST_RGB32 ] = D_D3DFMT_A4R4G4B4 ;
			String = _T( "D3DFMT_A4R4G4B4" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpłAt@eXgp 32bit J[tH[}bg܂ł\n" ) ) ;
			goto ERR ;
		}
		DXST_ERRORLOGFMT_ADD(( _T( "At@eXgp 32bit J[tH[}bg %s ł" ), String )) ;

		// DXT1tH[}bg̃`FbN
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, 0, D_D3DRTYPE_TEXTURE, D_D3DFMT_DXT1 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT1 ] = D_D3DFMT_DXT1 ;
			String = _T( "D3DFMT_DXT1 ł" ) ;
		}
		else
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT1 ] = GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHATEST_RGB16 ] ;
			String = _T( "g܂" ) ;
		}
		DXST_ERRORLOGFMT_ADD(( _T( "cwsPeNX`tH[}bg%s" ), String )) ;

		// DXT2tH[}bg̃`FbN
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, 0, D_D3DRTYPE_TEXTURE, D_D3DFMT_DXT2 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT2 ] = D_D3DFMT_DXT2 ;
			String = _T( "D3DFMT_DXT2 ł" ) ;
		}
		else
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT2 ] = GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHA_RGB32 ] ;
			String = _T( "g܂" ) ;
		}
		DXST_ERRORLOGFMT_ADD(( _T( "cwsQeNX`tH[}bg%s" ), String )) ;

		// DXT3tH[}bg̃`FbN
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, 0, D_D3DRTYPE_TEXTURE, D_D3DFMT_DXT3 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT3 ] = D_D3DFMT_DXT3 ;
			String = _T( "D3DFMT_DXT3 ł" ) ;
		}
		else
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT3 ] = GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHA_RGB32 ] ;
			String = _T( "g܂" ) ;
		}
		DXST_ERRORLOGFMT_ADD(( _T( "cwsReNX`tH[}bg%s" ), String )) ;

		// DXT4tH[}bg̃`FbN
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, 0, D_D3DRTYPE_TEXTURE, D_D3DFMT_DXT4 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT4 ] = D_D3DFMT_DXT4 ;
			String = _T( "D3DFMT_DXT4 ł" ) ;
		}
		else
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT4 ] = GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHA_RGB32 ] ;
			String = _T( "g܂" ) ;
		}
		DXST_ERRORLOGFMT_ADD(( _T( "cwsSeNX`tH[}bg%s" ), String )) ;

		// DXT5tH[}bg̃`FbN
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, 0, D_D3DRTYPE_TEXTURE, D_D3DFMT_DXT5 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT5 ] = D_D3DFMT_DXT5 ;
			String = _T( "D3DFMT_DXT5 ł" ) ;
		}
		else
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT5 ] = GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHA_RGB32 ] ;
			String = _T( "g܂" ) ;
		}
		DXST_ERRORLOGFMT_ADD(( _T( "cwsTeNX`tH[}bg%s" ), String )) ;

		// `\ 16rbgJ[tH[}bg̑I
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, GRH.ScreenFormat == D_D3DFMT_R5G6B5 ? D_D3DFMT_R5G6B5 : D_D3DFMT_X1R5G5B5 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_RGB16 ] = GRH.ScreenFormat == D_D3DFMT_R5G6B5 ? D_D3DFMT_R5G6B5 : D_D3DFMT_X1R5G5B5 ;
			String = GRH.ScreenFormat == D_D3DFMT_R5G6B5 ? _T( "D3DFMT_R5G6B5" ) : _T( "D3DFMT_R5G5B5" ) ;
		}
		else
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, GRH.ScreenFormat == D_D3DFMT_R5G6B5 ? D_D3DFMT_X1R5G5B5 : D_D3DFMT_R5G6B5 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_RGB16 ] = GRH.ScreenFormat == D_D3DFMT_R5G6B5 ? D_D3DFMT_X1R5G5B5 : D_D3DFMT_R5G6B5 ;
			String = GRH.ScreenFormat == D_D3DFMT_R5G6B5 ? _T( "D3DFMT_R5G5B5" ) : _T( "D3DFMT_R5G6B5" ) ;
		}
		else
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_X8R8G8B8 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_RGB16 ] = D_D3DFMT_X8R8G8B8 ;
			String = _T( "D3DFMT_X8R8G8B8" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`p 16bit J[tH[}bg܂ł\n" ) ) ;
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_RGB16 ] = D_D3DFMT_UNKNOWN ;
		}

		if( GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_RGB16 ] != D_D3DFMT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`p 16bit J[tH[}bg %s ł" ), String )) ;
		}

		// `\ 32rbgJ[tH[}bg̑I
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_X8R8G8B8 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_RGB32 ] = D_D3DFMT_X8R8G8B8 ;
			String = _T( "D3DFMT_X8R8G8B8" ) ;
		}
		else
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_R5G6B5 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_RGB32 ] = D_D3DFMT_R5G6B5 ;
			String = _T( "D3DFMT_R5G6B5" ) ;
		}
		else
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_X1R5G5B5 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_RGB32 ] = D_D3DFMT_X1R5G5B5 ;
			String = _T( "D3DFMT_R5G5B5" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`p 32bit J[tH[}bg܂ł\n" ) ) ;
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_RGB32 ] = D_D3DFMT_UNKNOWN ;
		}

		if( GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_RGB32 ] != D_D3DFMT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`p 32bit J[tH[}bg %s ł" ), String )) ;
		}

		// `\ At@`lt 32 rbgJ[tH[}bg̑I
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_A8R8G8B8 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ALPHA_RGB32 ] = D_D3DFMT_A8R8G8B8 ;
			String = _T( "D3DFMT_A8R8G8B8" ) ;
		}
		else
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_A4R4G4B4 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ALPHA_RGB32 ] = D_D3DFMT_A4R4G4B4 ;
			String = _T( "D3DFMT_A4R4G4B4" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pAt@t 32bit J[tH[}bg܂ł\n" ) ) ;
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ALPHA_RGB32 ] = D_D3DFMT_UNKNOWN ;
		}

		if( GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ALPHA_RGB32 ] != D_D3DFMT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pAt@t 32bit J[tH[}bg %s ł" ), String )) ;
		}

		// `\ ARGB16rbg^J[tH[}bg̑I
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_A16B16G16R16 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_I16 ] = D_D3DFMT_A16B16G16R16 ;
			String = _T( "D3DFMT_A16B16G16R16" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pABGR16rbg^J[tH[}bg܂ł\n" ) ) ;
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_I16 ] = D_D3DFMT_UNKNOWN ;
		}

		if( GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_I16 ] != D_D3DFMT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pABGR16rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// `\ ARGB_16rbg^J[tH[}bg̑I
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_A16B16G16R16F ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_F16 ] = D_D3DFMT_A16B16G16R16F ;
			String = _T( "D3DFMT_A16B16G16R16F" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pABGR_16rbg^J[tH[}bg܂ł\n" ) ) ;
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_F16 ] = D_D3DFMT_UNKNOWN ;
		}

		if( GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_F16 ] != D_D3DFMT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pABGR_16rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// `\ ARGB_32rbg^J[tH[}bg̑I
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_A32B32G32R32F ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_F32 ] = D_D3DFMT_A32B32G32R32F ;
			String = _T( "D3DFMT_A32B32G32R32F" ) ;
		}
		else
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_A16B16G16R16F ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_F32 ] = D_D3DFMT_A16B16G16R16F ;
			String = _T( "D3DFMT_A16B16G16R16F" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pABGR_32rbg^J[tH[}bg܂ł\n" ) ) ;
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_F32 ] = D_D3DFMT_UNKNOWN ;
		}

		if( GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_F32 ] != D_D3DFMT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pABGR_32rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// `\ P`l8rbg^J[tH[}bg̑I
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_L8 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I8 ] = D_D3DFMT_L8 ;
			String = _T( "D3DFMT_L8" ) ;
		}
		else
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_A8L8 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I8 ] = D_D3DFMT_A8L8 ;
			String = _T( "D3DFMT_A8L8" ) ;
		}
		else
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_A8R8G8B8 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I8 ] = D_D3DFMT_A8R8G8B8 ;
			String = _T( "D3DFMT_A8R8G8B8" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pP`l8rbg^J[tH[}bg܂ł\n" ) ) ;
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I8 ] = D_D3DFMT_UNKNOWN ;
		}

		if( GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I8 ] != D_D3DFMT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pP`l8rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// `\ P`l16rbg^J[tH[}bg̑I
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_L16 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I16 ] = D_D3DFMT_L16 ;
			String = _T( "D3DFMT_L16" ) ;
		}
		else
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_G16R16 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I16 ] = D_D3DFMT_G16R16 ;
			String = _T( "D3DFMT_G16R16" ) ;
		}
		else
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_A16B16G16R16 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I16 ] = D_D3DFMT_A16B16G16R16 ;
			String = _T( "D3DFMT_A16B16G16R16" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pP`l16rbg^J[tH[}bg܂ł\n" ) ) ;
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I16 ] = D_D3DFMT_UNKNOWN ;
		}

		if( GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I16 ] != D_D3DFMT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pP`l16rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// `\ P`l_16rbg^J[tH[}bg̑I
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_R16F ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F16 ] = D_D3DFMT_R16F ;
			String = _T( "D3DFMT_R16F" ) ;
		}
		else
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_G16R16F ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F16 ] = D_D3DFMT_G16R16F ;
			String = _T( "D3DFMT_G16R16F" ) ;
		}
		else
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_A16B16G16R16F ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F16 ] = D_D3DFMT_A16B16G16R16F ;
			String = _T( "D3DFMT_A16B16G16R16F" ) ;
		}
		else
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_A32B32G32R32F ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F16 ] = D_D3DFMT_A32B32G32R32F ;
			String = _T( "D3DFMT_A32B32G32R32F" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pP`l_16rbg^J[tH[}bg܂ł\n" ) ) ;
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F16 ] = D_D3DFMT_UNKNOWN ;
		}

		if( GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F16 ] != D_D3DFMT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pP`l_16rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// `\ P`l_32rbg^J[tH[}bg̑I
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_R32F ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F32 ] = D_D3DFMT_R32F ;
			String = _T( "D3DFMT_R32F" ) ;
		}
		else
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_G32R32F ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F32 ] = D_D3DFMT_G32R32F ;
			String = _T( "D3DFMT_G32R32F" ) ;
		}
		else
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_A32B32G32R32F ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F32 ] = D_D3DFMT_A32B32G32R32F ;
			String = _T( "D3DFMT_A32B32G32R32F" ) ;
		}
		else
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_A16B16G16R16F ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F32 ] = D_D3DFMT_A16B16G16R16F ;
			String = _T( "D3DFMT_A16B16G16R16F" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pP`l_32rbg^J[tH[}bg܂ł\n" ) ) ;
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F32 ] = D_D3DFMT_UNKNOWN ;
		}

		if( GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F32 ] != D_D3DFMT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pP`l_32rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// `\ Q`l8rbg^J[tH[}bg̑I
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_A8L8 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I8 ] = D_D3DFMT_A8L8 ;
			String = _T( "D3DFMT_V8U8" ) ;
		}
		else
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_A8R8G8B8 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I8 ] = D_D3DFMT_A8R8G8B8 ;
			String = _T( "D3DFMT_A8B8G8R8" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pQ`l8rbg^J[tH[}bg܂ł\n" ) ) ;
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I8 ] = D_D3DFMT_UNKNOWN ;
		}

		if( GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I8 ] != D_D3DFMT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pQ`l8rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// `\ Q`l16rbg^J[tH[}bg̑I
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_G16R16 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I16 ] = D_D3DFMT_G16R16 ;
			String = _T( "D3DFMT_G16R16" ) ;
		}
		else
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_A16B16G16R16 ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I16 ] = D_D3DFMT_A16B16G16R16 ;
			String = _T( "D3DFMT_A16B16G16R16" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pQ`l16rbg^J[tH[}bg܂ł\n" ) ) ;
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I16 ] = D_D3DFMT_UNKNOWN ;
		}

		if( GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I16 ] != D_D3DFMT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pQ`l16rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// `\ Q`l_16rbg^J[tH[}bg̑I
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_G16R16F ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F16 ] = D_D3DFMT_G16R16F ;
			String = _T( "D3DFMT_G16R16F" ) ;
		}
		else
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_A16B16G16R16F ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F16 ] = D_D3DFMT_A16B16G16R16F ;
			String = _T( "D3DFMT_A16B16G16R16F" ) ;
		}
		else
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_A32B32G32R32F ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F16 ] = D_D3DFMT_A32B32G32R32F ;
			String = _T( "D3DFMT_A32B32G32R32F" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pQ`l_16rbg^J[tH[}bg܂ł\n" ) ) ;
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F16 ] = D_D3DFMT_UNKNOWN ;
		}

		if( GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F16 ] != D_D3DFMT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pQ`l_16rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// `\ Q`l_32rbg^J[tH[}bg̑I
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_G32R32F ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F32 ] = D_D3DFMT_G32R32F ;
			String = _T( "D3DFMT_G32R32F" ) ;
		}
		else
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_A32B32G32R32F ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F32 ] = D_D3DFMT_A32B32G32R32F ;
			String = _T( "D3DFMT_A32B32G32R32F" ) ;
		}
		else
		if( Graphics_CheckDeviceFormat( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, GRH.ScreenFormat, D_D3DUSAGE_RENDERTARGET, D_D3DRTYPE_TEXTURE, D_D3DFMT_A16B16G16R16F ) == D_D3D_OK )
		{
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F32 ] = D_D3DFMT_A16B16G16R16F ;
			String = _T( "D3DFMT_A16B16G16R16F" ) ;
		}
		else
		{
			DXST_ERRORLOG_ADD( _T( "gpł`pQ`l_32rbg^J[tH[}bg܂ł\n" ) ) ;
			GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F32 ] = D_D3DFMT_UNKNOWN ;
		}

		if( GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F32 ] != D_D3DFMT_UNKNOWN )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "`pQ`l_32rbg^J[tH[}bg %s ł" ), String )) ;
		}

		// }XNJ[obt@ptH[}bg̑I
		GRH.MaskColorFormat = GRA2.MainScreenColorBitDepth == 32 ? GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_RGB32 ] : GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_RGB16 ] ;

		// }XNAt@tH[}bg̑I
		GRH.MaskAlphaFormat = GRA2.MainScreenColorBitDepth == 32 ? GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHATEST_RGB32 ] : GRH.TextureFormat[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHATEST_RGB16 ] ;
	}

	// o
	{
		DXST_ERRORLOGFMT_ADD(( _T( "xɕ`łv~eBu̍ő吔:%d" ), GRH.MaxPrimitiveCount )) ;
		DXST_ERRORLOGFMT_ADD(( _T( "ΉĂő咸_CfbNX:%d" ), GRH.DeviceCaps.MaxVertexIndex )) ;
		DXST_ERRORLOGFMT_ADD(( _T( "Ƀ_Ołobt@̐:%d" ), GRH.RenderTargetNum )) ;
		DXST_ERRORLOGFMT_ADD(( _T( "őeNX`TCY@:%d :%d" ), GRH.DeviceCaps.MaxTextureWidth, GRH.DeviceCaps.MaxTextureHeight )) ;
		DXST_ERRORLOGFMT_ADD(( _T( "eNX`Xe[We|WX^F%s" ), GRH.ValidTexTempRegFlag ? _T( "gp" ) : _T( "gps" ) )) ;
		DXST_ERRORLOGFMT_ADD(( _T( "Z̃n[hEFAΉF%s" ), GRH.ValidDestBlendOp ? _T( "lCeBu" ) : _T( "G~[g" ) )) ;
		if( GRH.VertexHardwareProcess )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "n[hEFA_VF[_[o[WR[hF%x" ), GRH.DeviceCaps.VertexShaderVersion & 0xffff )) ;
			DXST_ERRORLOGFMT_ADD(( _T( "G~[V_VF[_[o[WR[hFG~[V" ) )) ;
		}
		else
		{
			DXST_ERRORLOGFMT_ADD(( _T( "n[hEFA_VF[_[o[WR[hF%x" ), GRH.NativeVertexShaderVersion & 0xffff )) ;
			DXST_ERRORLOGFMT_ADD(( _T( "G~[V_VF[_[o[WR[hF%x" ), GRH.DeviceCaps.VertexShaderVersion & 0xffff )) ;
		}
		DXST_ERRORLOGFMT_ADD(( _T( "sNZVF[_[o[WR[hF%x" ), GRH.DeviceCaps.PixelShaderVersion & 0xffff )) ;
	}

	// `̏`bNēǂݎꍇƈꎞIȕ`T[tFXēǂݎꍇ̂ǂ炪𒲂ׂ
	{
		DX_DIRECT3DSURFACE9 *RTSurface = NULL ;
		DX_DIRECT3DSURFACE9 *SMSurface = NULL ;
		DX_DIRECT3DSURFACE9 *DestSurface = NULL ;
		D_D3DLOCKED_RECT SrcLockedRect ;
		D_D3DLOCKED_RECT DestLockedRect ;
		RECT LockRect ;
		LONGLONG Time1 = 0, Time2 = 0;
		int Size, i, j ;
		COLORDATA *ColorData ;

		// Ԃł̓bNgpȂAɂĂ
		GRH.UseRenderTargetLock = FALSE ;

		// LbVȂǂ̊֌WŐssɂȂ\邽߁AR񓯂ƂJԂ
		for( j = 0 ; j < 3 ; j ++ )
		{
			// `FbNJn
			Time1 = -1 ;
			Time2 = -1 ;
			for(;;)
			{
				// eXgɎgpT[tFX̃TCY
				Size = 256 ;
				while( Size > GRA2.MainScreenSizeX || Size > GRA2.MainScreenSizeY ) Size >>= 1 ;

				// ̏o͐̃T[tFX쐬
				DestSurface = NULL ;
				if( GraphicsDevice_CreateOffscreenPlainSurface(
						Size, Size, GRH.ScreenFormat, D_D3DPOOL_SYSTEMMEM, &DestSurface, NULL ) != D_D3D_OK )
					break ;

				// bN`̍쐬
				LockRect.left   = 0 ;
				LockRect.top    = 0 ;
				LockRect.right  = Size ;
				LockRect.bottom = Size ;

				// J[f[^̎擾
				ColorData = GetD3DFormatColorData( GRH.ScreenFormat ) ;

				// ̏o͐̃T[tFXbN
				if( GraphicsSurface_LockRect( DestSurface, &DestLockedRect, &LockRect, D_D3DLOCK_READONLY ) != D_D3D_OK )
					break ;

				// ŏɒڃbNꍇ݂
				{
					Time1 = NS_GetNowHiPerformanceCount() ;

					// ڃbN
					if( GraphicsSurface_LockRect( GRH.BackBufferSurface, &SrcLockedRect, &LockRect, D_D3DLOCK_READONLY ) != D_D3D_OK )
						break ;

					// f[^]
					for( i = 0 ; i < Size ; i ++ )
						_MEMCPY(
							( BYTE * )DestLockedRect.pBits + DestLockedRect.Pitch * i,
							( BYTE * )SrcLockedRect.pBits + SrcLockedRect.Pitch * i,
							Size * ColorData->PixelByte ) ;

					// bN
					GraphicsSurface_UnlockRect( GRH.BackBufferSurface ) ;

					Time1 = NS_GetNowHiPerformanceCount() - Time1 ;

				}

				// ꎞIȕ`T[tFX쐬ēǂݎꍇ݂
				{
					Time2 = GetNowHiPerformanceCount() ;

					// bNTCYƓ傫̕`\T[tFX̍쐬
					if( GraphicsDevice_CreateRenderTarget(
							Size, Size, GRH.ScreenFormat, D_D3DMULTISAMPLE_NONE, 0, FALSE, &RTSurface, NULL ) != D_D3D_OK )
						break ;

					// bNTCYƓ傫̃VXẽItXN[T[tFX̍쐬
					if( GraphicsDevice_CreateOffscreenPlainSurface(
							Size, Size, GRH.ScreenFormat, D_D3DPOOL_SYSTEMMEM, &SMSurface, NULL ) != D_D3D_OK )
						break ;

					// ܂`\T[tFXɓe]
					GraphicsDevice_StretchRect(
						GRH.BackBufferSurface, &LockRect,
						RTSurface,             &LockRect, D_D3DTEXF_NONE ) ;

					// ̌VXeT[tFXɓe]
					GraphicsDevice_GetRenderTargetData(
						RTSurface, SMSurface ) ;

					// VXeT[tFXbN
					if( GraphicsSurface_LockRect( SMSurface, &SrcLockedRect, NULL, D_D3DLOCK_READONLY ) != D_D3D_OK )
						break ;

					// f[^]
					for( i = 0 ; i < Size ; i ++ )
						_MEMCPY(
							( BYTE * )DestLockedRect.pBits + DestLockedRect.Pitch * i,
							( BYTE * )SrcLockedRect.pBits + SrcLockedRect.Pitch * i,
							Size * ColorData->PixelByte ) ;

					// bN
					GraphicsSurface_UnlockRect( SMSurface ) ;

					// ꎞIȃT[tFX
					Graphics_ObjectRelease( RTSurface ) ;
					Graphics_ObjectRelease( SMSurface ) ;
					RTSurface = NULL ;
					SMSurface = NULL ;

					Time2 = GetNowHiPerformanceCount() - Time2 ;
				}

				break ;
			}
			if( SMSurface != NULL )
			{
				Graphics_ObjectRelease( SMSurface ) ;
				SMSurface = NULL ;
			}
			if( RTSurface != NULL )
			{
				Graphics_ObjectRelease( RTSurface ) ;
				RTSurface = NULL ;
			}
			if( DestSurface != NULL )
			{
				Graphics_ObjectRelease( DestSurface ) ;
				DestSurface = NULL ;
			}
		}

		if( Time2 == -1 || Time1 == -1 )
		{
			DXST_ERRORLOG_ADD( _T( "obNobt@bN̓bNł܂\n" ) ) ;
		}
		else
		{
			// ȕgp
			DXST_ERRORLOGFMT_ADD( ( _T( "obNobt@bN]̎:%dnsec  ꎞIȕ`\obt@gp]̎:%dnsec" ), ( int )Time1, ( int )Time2 ) ) ;
			if( Time1 < Time2 )
			{
				GRH.UseRenderTargetLock = TRUE ;
				DXST_ERRORLOG_ADD( _T( "obNobt@bNgp܂\n" ) ) ;
			}
			else
			{
				DXST_ERRORLOG_ADD( _T( "obNobt@bNgp܂\n" ) ) ;
			}
		}
	}

	// I
	return 0 ;

	// G[
ERR:
	return ErrorRet ;
}

// Direct3D9 ̃VF[_[̃ZbgAbvs( 0:  -1:s )
extern int SetupDirect3D9Shader()
{
	// ɍ쐬ĂƂ̂߂ɍ폜s
	TerminateDirect3D9Shader() ;

	// VF[_[gpł邩ׂ
	GRH.UseShader = FALSE ;
	if( ( GRH.ValidVertexShader_SM3 && GRH.ValidPixelShader_SM3 ) ||
		( GRH.ValidVertexShader && GRH.ValidPixelShader ) )
	{
		GRH.UseShader = TRUE ;

		// VF[_[R[hWJĂȂꍇ͓WJ
		if( GRA2.ShaderInitializeFlag == FALSE )
		{
			if( ShaderCodeSetup() == FALSE )
			{
				DXST_ERRORLOGFMT_ADD( ( _T( "VF[_[R[hWJ郁̈̊mۂɎs܂\n" ) ) ) ;
				GRH.UseShader = FALSE ;
				goto ENDLABEL ;
			}
		}

#ifndef DX_NON_MODEL
		if( GRH.ValidVertexShader_SM3 && GRH.ValidPixelShader_SM3 )
		{
			// _VF[_[Ă݂
			if( GraphicsDevice_CreateVertexShader(
					( DWORD * )GRA2.DefaultVertexShaderAddress_SM3[ 0 ][ 0 ][ 0 ],
									  &GRH.DefaultVertexShader_SM3[ 0 ][ 0 ][ 0 ] )
					!= D_D3D_OK )
			{
				DXST_ERRORLOGFMT_ADD( ( _T( "_VF[_[IuWFNg̍쐬Ɏs܂\n" ) ) ) ;
				GRH.UseShader = FALSE ;
				goto ENDLABEL ;
			}

			// sNZVF[_[Ă݂
			if( GraphicsDevice_CreatePixelShader(
					( DWORD * )GRA2.DefaultPixelShaderAddress_SM3[ 0 ][ 0 ][ 0 ][ 0 ][ 0 ][ 0 ][ 0 ][ GRA2.LightIndexList_SM3[ 1 ][ 0 ][ 0 ][ 0 ][ 0 ][ 0 ] ][ 0 ],
									  &GRH.DefaultPixelShader_SM3[ 0 ][ 0 ][ 0 ][ 0 ][ 0 ][ 0 ][ 0 ][ GRA2.LightIndexList_SM3[ 1 ][ 0 ][ 0 ][ 0 ][ 0 ][ 0 ] ][ 0 ] )
					!= D_D3D_OK )
			{
				DXST_ERRORLOGFMT_ADD( ( _T( "sNZVF[_[IuWFNg̍쐬Ɏs܂\n" ) ) ) ;
				GRH.UseShader = FALSE ;
				goto ENDLABEL ;
			}
		}

		if( GRH.ValidVertexShader && GRH.ValidPixelShader )
		{
			// _VF[_[Ă݂
			if( GraphicsDevice_CreateVertexShader(
					( DWORD * )GRA2.DefaultVertexShaderAddress[ 0 ][ 0 ][ 1 ][ 1 ][ 0 ][ 0 ][ 0 ][ GRA2.LightIndexList[ 0 ][ 0 ][ 0 ] ][ 0 ],
									  &GRH.DefaultVertexShader[ 0 ][ 0 ][ 1 ][ 1 ][ 0 ][ 0 ][ 0 ][ GRA2.LightIndexList[ 0 ][ 0 ][ 0 ] ][ 0 ] )
					!= D_D3D_OK )
			{
				DXST_ERRORLOGFMT_ADD( ( _T( "_VF[_[IuWFNg̍쐬Ɏs܂\n" ) ) ) ;
				GRH.UseShader = FALSE ;
				goto ENDLABEL ;
			}

			// sNZVF[_[Ă݂
			if( GraphicsDevice_CreatePixelShader(
					( DWORD * )GRA2.DefaultPixelShaderAddress[ 0 ][ 0 ][ 0 ][ 0 ][ 0 ][ 1 ][ 0 ][ 1 ][ 1 ][ 1 ][ 0 ][ 0 ][ 0 ],
									  &GRH.DefaultPixelShader[ 0 ][ 0 ][ 0 ][ 0 ][ 0 ][ 1 ][ 0 ][ 1 ][ 1 ][ 1 ][ 0 ][ 0 ][ 0 ] )
					!= D_D3D_OK )
			{
				DXST_ERRORLOGFMT_ADD( ( _T( "sNZVF[_[IuWFNg̍쐬Ɏs܂\n" ) ) ) ;
				GRH.UseShader = FALSE ;
				goto ENDLABEL ;
			}
		}
#endif // DX_NON_MODEL

		// {Iȕ`揈ɎgpsNZVF[_[쐬
		{
			int i, j, k, l, m ;
			char FileName[ 64 ] ;
			int Addr, Size ;
			void *DataImage ;

			DataImage = DXA_GetFileImage( &GRA2.BaseShaderBinDxa ) ;

			// eNX`ȂVF[_[̍쐬
			_STRCPY( FileName, "ps_nonetex_type0_ach0.pso" ) ;
			for( i = 0 ; i < 7 ; i ++ )
			{
				FileName[ 15 ] = ( char )( '0' + i ) ;
				for( j = 0 ; j < 2 ; j ++ )
				{
					FileName[ 20 ] = ( char )( '0' + j ) ;

					if( DXA_GetFileInfo( &GRA2.BaseShaderBinDxa, FileName, &Addr, &Size ) == 0 )
					{
						if( GraphicsDevice_CreatePixelShader( ( DWORD * )( ( BYTE * )DataImage + Addr ), &GRH.BaseNoneTexPixelShader[ i ][ j ] ) != D_D3D_OK )
						{
							DXST_ERRORLOGFMT_ADD( ( _T( "{VF[_[IuWFNg̍쐬Ɏs܂\n" ) ) ) ;
							GRH.UseShader = FALSE ;
							goto ENDLABEL ;
						}
					}
				}
			}

			// eNX`VF[_[̍쐬
			_STRCPY( FileName, "ps_blend0_type0_igcolor0_igtalpha0_ach0.pso" ) ;
			for( i = 0 ; i < 4 ; i ++ )
			{
				FileName[ 8 ] = ( char )( '0' + i ) ;
				for( j = 0 ; j < 7 ; j ++ )
				{
					FileName[ 14 ] = ( char )( '0' + j ) ;
					for( k = 0 ; k < 2 ; k ++ )
					{
						FileName[ 23 ] =( char )(  '0' + k ) ;
						for( l = 0 ; l < 2 ; l ++ )
						{
							FileName[ 33 ] = ( char )( '0' + l ) ;
							for( m = 0 ; m < 2 ; m ++ )
							{
								FileName[ 38 ] = ( char )( '0' + m ) ;

								if( DXA_GetFileInfo( &GRA2.BaseShaderBinDxa, FileName, &Addr, &Size ) == 0 )
								{
									if( GraphicsDevice_CreatePixelShader( ( DWORD * )( ( BYTE * )DataImage + Addr ), &GRH.BaseUseTexPixelShader[ i ][ j ][ k ][ l ][ m ] ) != D_D3D_OK )
									{
										DXST_ERRORLOGFMT_ADD( ( _T( "{VF[_[IuWFNg̍쐬Ɏs܂\n" ) ) ) ;
										GRH.UseShader = FALSE ;
										goto ENDLABEL ;
									}
								}
							}
						}
					}
				}
			}

			// }XNpVF[_[̍쐬
			DXA_GetFileInfo( &GRA2.BaseShaderBinDxa, "ps_mask_blend.pso", &Addr, &Size ) ;
			if( GraphicsDevice_CreatePixelShader( ( DWORD * )( ( BYTE * )DataImage + Addr ), &GRH.MaskEffectPixelShader ) != D_D3D_OK )
			{
				DXST_ERRORLOGFMT_ADD( ( _T( "}XNpVF[_[IuWFNg̍쐬Ɏs܂\n" ) ) ) ;
				GRH.UseShader = FALSE ;
				goto ENDLABEL ;
			}
		}
	}

ENDLABEL:

//	GRH.UseShader = FALSE ;

	if( GRH.UseShader == FALSE )
	{
		DXST_ERRORLOGFMT_ADD( ( _T( "vO}uVF[_[gp܂\n" ) ) ) ;
	}
	else
	{
		DXST_ERRORLOGFMT_ADD( ( _T( "vO}uVF[_[gp܂\n" ) ) ) ;
	}

	// VF[_[̒萔Zbg
	static float ZeroOne[ 4 ]        = { 0.0f, 1.0f, 0.0f, 0.0f } ;
	static float ZeroHalfOneTwo[ 4 ] = { 0.0f, 0.5f, 1.0f, 2.0f } ;
	SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_VS_FLOAT, DX_SHADERCONSTANTSET_LIB, DX_VS_CONSTF_ZERO_ONE,          ZeroOne,        1, TRUE ) ;
	SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB, DX_PS_CONSTF_ZERO_HALF_ONE_TWO, ZeroHalfOneTwo, 1, TRUE ) ;

	// I
	return 0 ;
}


// Direct3DVertexDeclaration9 IuWFNg̍쐬( 0:  -1:s )
extern int CreateDirect3D9VertexDeclaration()
{
	// ɍ쐬ĂƂ̂߂ɍ폜s
	TerminateDirect3D9VertexDeclaration() ;

#ifndef DX_NON_MODEL
	{
		D_D3DVERTEXELEMENT9 *VE, VertElem[ 64 ] = 
		{
			{ 0, 0,   D_D3DDECLTYPE_FLOAT3,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_POSITION,     0 },
			{ 0, 12,  D_D3DDECLTYPE_FLOAT4,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_BLENDWEIGHT,  0 },
			{ 0, 28,  D_D3DDECLTYPE_UBYTE4,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_BLENDINDICES, 0 },
			{ 0, 32,  D_D3DDECLTYPE_FLOAT3,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_NORMAL,       0 },
			{ 0, 44,  D_D3DDECLTYPE_D3DCOLOR, D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_COLOR,        0 },
			{ 0, 48,  D_D3DDECLTYPE_D3DCOLOR, D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_COLOR,        1 },
			{ 0, 52,  D_D3DDECLTYPE_FLOAT4,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_TEXCOORD,     0 },
			D_D3DDECL_END()
		} ;
		int offset, index ;
		int i, j, k, l ;

		// ov}bvǂłQ[v
		for( i = 0 ; i < 2 ; i ++ )
		{
			// XLjObV^CvɂĂR[v
			for( j = 0 ; j < 3 ; j ++ )
			{
				if( i == 0 )
				{
					switch( j )
					{
					case 0 :
						// ov}bv񖳂̃bV
						VertElem[ 0 ] = MakeVertexElement9( 0,  0,  D_D3DDECLTYPE_FLOAT3,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_POSITION,     0 ) ;
						VertElem[ 1 ] = MakeVertexElement9( 0, 12,  D_D3DDECLTYPE_FLOAT3,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_NORMAL,       0 ) ;
						VertElem[ 2 ] = MakeVertexElement9( 0, 24,  D_D3DDECLTYPE_D3DCOLOR, D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_COLOR,        0 ) ;
						VertElem[ 3 ] = MakeVertexElement9( 0, 28,  D_D3DDECLTYPE_D3DCOLOR, D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_COLOR,        1 ) ;
						offset = 32 ;
						index = 4 ;
						break ;

					case 1 :
						// ov}bv񖳂S{[XLjObV
						VertElem[ 0 ] = MakeVertexElement9( 0,  0,  D_D3DDECLTYPE_FLOAT3,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_POSITION,     0 ) ;
						VertElem[ 1 ] = MakeVertexElement9( 0, 12,  D_D3DDECLTYPE_UBYTE4,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_BLENDINDICES, 0 ) ;
						VertElem[ 2 ] = MakeVertexElement9( 0, 16,  D_D3DDECLTYPE_FLOAT4,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_BLENDWEIGHT,  0 ) ;
						VertElem[ 3 ] = MakeVertexElement9( 0, 32,  D_D3DDECLTYPE_FLOAT3,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_NORMAL,       0 ) ;
						VertElem[ 4 ] = MakeVertexElement9( 0, 44,  D_D3DDECLTYPE_D3DCOLOR, D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_COLOR,        0 ) ;
						VertElem[ 5 ] = MakeVertexElement9( 0, 48,  D_D3DDECLTYPE_D3DCOLOR, D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_COLOR,        1 ) ;
						offset = 52 ;
						index = 6 ;
						break ;

					case 2 :
						// ov}bv񖳂W{[XLjObV
						VertElem[ 0 ] = MakeVertexElement9( 0,  0,  D_D3DDECLTYPE_FLOAT3,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_POSITION,     0 ) ;
						VertElem[ 1 ] = MakeVertexElement9( 0, 12,  D_D3DDECLTYPE_UBYTE4,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_BLENDINDICES, 0 ) ;
						VertElem[ 2 ] = MakeVertexElement9( 0, 16,  D_D3DDECLTYPE_UBYTE4,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_BLENDINDICES, 1 ) ;
						VertElem[ 3 ] = MakeVertexElement9( 0, 20,  D_D3DDECLTYPE_FLOAT4,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_BLENDWEIGHT,  0 ) ;
						VertElem[ 4 ] = MakeVertexElement9( 0, 36,  D_D3DDECLTYPE_FLOAT4,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_BLENDWEIGHT,  1 ) ;
						VertElem[ 5 ] = MakeVertexElement9( 0, 52,  D_D3DDECLTYPE_FLOAT3,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_NORMAL,       0 ) ;
						VertElem[ 6 ] = MakeVertexElement9( 0, 64,  D_D3DDECLTYPE_D3DCOLOR, D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_COLOR,        0 ) ;
						VertElem[ 7 ] = MakeVertexElement9( 0, 68,  D_D3DDECLTYPE_D3DCOLOR, D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_COLOR,        1 ) ;
						offset = 72 ;
						index = 8 ;
						break ;
					}
				}
				else
				{
					switch( j )
					{
					case 0 :
						// ov}bvL荄̃bV
						VertElem[ 0 ] = MakeVertexElement9( 0,  0,  D_D3DDECLTYPE_FLOAT3,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_POSITION,     0 ) ;
						VertElem[ 1 ] = MakeVertexElement9( 0, 12,  D_D3DDECLTYPE_FLOAT3,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_TANGENT,      0 ) ;
						VertElem[ 2 ] = MakeVertexElement9( 0, 24,  D_D3DDECLTYPE_FLOAT3,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_BINORMAL,     0 ) ;
						VertElem[ 3 ] = MakeVertexElement9( 0, 36,  D_D3DDECLTYPE_FLOAT3,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_NORMAL,       0 ) ;
						VertElem[ 4 ] = MakeVertexElement9( 0, 48,  D_D3DDECLTYPE_D3DCOLOR, D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_COLOR,        0 ) ;
						VertElem[ 5 ] = MakeVertexElement9( 0, 52,  D_D3DDECLTYPE_D3DCOLOR, D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_COLOR,        1 ) ;
						offset = 56 ;
						index = 6 ;
						break ;

					case 1 :
						// ov}bvLS{[XLjObV
						VertElem[ 0 ] = MakeVertexElement9( 0,  0,  D_D3DDECLTYPE_FLOAT3,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_POSITION,     0 ) ;
						VertElem[ 1 ] = MakeVertexElement9( 0, 12,  D_D3DDECLTYPE_UBYTE4,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_BLENDINDICES, 0 ) ;
						VertElem[ 2 ] = MakeVertexElement9( 0, 16,  D_D3DDECLTYPE_FLOAT4,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_BLENDWEIGHT,  0 ) ;
						VertElem[ 3 ] = MakeVertexElement9( 0, 32,  D_D3DDECLTYPE_FLOAT3,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_TANGENT,      0 ) ;
						VertElem[ 4 ] = MakeVertexElement9( 0, 44,  D_D3DDECLTYPE_FLOAT3,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_BINORMAL,     0 ) ;
						VertElem[ 5 ] = MakeVertexElement9( 0, 56,  D_D3DDECLTYPE_FLOAT3,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_NORMAL,       0 ) ;
						VertElem[ 6 ] = MakeVertexElement9( 0, 68,  D_D3DDECLTYPE_D3DCOLOR, D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_COLOR,        0 ) ;
						VertElem[ 7 ] = MakeVertexElement9( 0, 72,  D_D3DDECLTYPE_D3DCOLOR, D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_COLOR,        1 ) ;
						offset = 76 ;
						index = 8 ;
						break ;

					case 2 :
						// ov}bvLW{[XLjObV
						VertElem[ 0 ] = MakeVertexElement9( 0,  0,  D_D3DDECLTYPE_FLOAT3,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_POSITION,     0 ) ;
						VertElem[ 1 ] = MakeVertexElement9( 0, 12,  D_D3DDECLTYPE_UBYTE4,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_BLENDINDICES, 0 ) ;
						VertElem[ 2 ] = MakeVertexElement9( 0, 16,  D_D3DDECLTYPE_UBYTE4,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_BLENDINDICES, 1 ) ;
						VertElem[ 3 ] = MakeVertexElement9( 0, 20,  D_D3DDECLTYPE_FLOAT4,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_BLENDWEIGHT,  0 ) ;
						VertElem[ 4 ] = MakeVertexElement9( 0, 36,  D_D3DDECLTYPE_FLOAT4,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_BLENDWEIGHT,  1 ) ;
						VertElem[ 5 ] = MakeVertexElement9( 0, 52,  D_D3DDECLTYPE_FLOAT3,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_TANGENT,      0 ) ;
						VertElem[ 6 ] = MakeVertexElement9( 0, 64,  D_D3DDECLTYPE_FLOAT3,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_BINORMAL,     0 ) ;
						VertElem[ 7 ] = MakeVertexElement9( 0, 76,  D_D3DDECLTYPE_FLOAT3,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_NORMAL,       0 ) ;
						VertElem[ 8 ] = MakeVertexElement9( 0, 88,  D_D3DDECLTYPE_D3DCOLOR, D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_COLOR,        0 ) ;
						VertElem[ 9 ] = MakeVertexElement9( 0, 92,  D_D3DDECLTYPE_D3DCOLOR, D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_COLOR,        1 ) ;
						offset = 96 ;
						index = 10 ;
						break ;
					}
				}

				for( k = 0 ; k < 9 ; k ++ )
				{
					VE = &VertElem[ index ] ;
					for( l = 0 ; l < k ; l ++, VE ++ )
					{
						VE->Stream     = 0 ;
						VE->Offset     = ( WORD )( offset + sizeof( float ) * 4 * l ) ;
						VE->Type       = D_D3DDECLTYPE_FLOAT4 ;
						VE->Method     = D_D3DDECLMETHOD_DEFAULT ;
						VE->Usage      = D_D3DDECLUSAGE_TEXCOORD ;
						VE->UsageIndex = ( BYTE )l ;
					}
					VE->Stream     = 0xFF ;
					VE->Offset     = 0 ;
					VE->Type       = D_D3DDECLTYPE_UNUSED ;
					VE->Method     = 0 ;
					VE->Usage      = 0 ;
					VE->UsageIndex = 0 ;

					GraphicsDevice_CreateVertexDeclaration( VertElem, &GRH.DefaultVertexDeclaration[ i ][ j ][ k ] ) ;
				}
			}
		}
	}
#endif // DX_NON_MODEL

	// [U[VF[_[[hŎgp钸_f[^`쐬
	{
		D_D3DVERTEXELEMENT9 _VertElem[ 10 ] ;

		// DX_VERTEX_TYPE_NORMAL_3D ( VERTEX3D\̌` )
		_VertElem[ 0 ] = MakeVertexElement9( 0,     0,  D_D3DDECLTYPE_FLOAT3,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_POSITION,     0 ) ;
		_VertElem[ 1 ] = MakeVertexElement9( 0,    12,  D_D3DDECLTYPE_FLOAT3,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_NORMAL,       0 ) ;
		_VertElem[ 2 ] = MakeVertexElement9( 0,    24,  D_D3DDECLTYPE_D3DCOLOR, D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_COLOR,        0 ) ;
		_VertElem[ 3 ] = MakeVertexElement9( 0,    28,  D_D3DDECLTYPE_D3DCOLOR, D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_COLOR,        1 ) ;
		_VertElem[ 4 ] = MakeVertexElement9( 0,    32,  D_D3DDECLTYPE_FLOAT2,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_TEXCOORD,     0 ) ;
		_VertElem[ 5 ] = MakeVertexElement9( 0,    40,  D_D3DDECLTYPE_FLOAT2,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_TEXCOORD,     1 ) ;
		_VertElem[ 6 ] = MakeVertexElement9( 0xff,  0,  D_D3DDECLTYPE_UNUSED,                         0,                       0,     0 ) ;
		GraphicsDevice_CreateVertexDeclaration( _VertElem, &GRH.UserShaderDeclaration[ DX_VERTEX_TYPE_NORMAL_3D ] ) ;

		// DX_VERTEX_TYPE_SHADER_3D ( VERTEX3DSHADER\̌` )
		_VertElem[ 0 ] = MakeVertexElement9( 0,     0,  D_D3DDECLTYPE_FLOAT3,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_POSITION,     0 ) ;
		_VertElem[ 1 ] = MakeVertexElement9( 0,    12,  D_D3DDECLTYPE_FLOAT4,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_POSITION,     1 ) ;
		_VertElem[ 2 ] = MakeVertexElement9( 0,    28,  D_D3DDECLTYPE_FLOAT3,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_NORMAL,       0 ) ;
		_VertElem[ 3 ] = MakeVertexElement9( 0,    40,  D_D3DDECLTYPE_FLOAT3,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_TANGENT,      0 ) ;
		_VertElem[ 4 ] = MakeVertexElement9( 0,    52,  D_D3DDECLTYPE_FLOAT3,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_BINORMAL,     0 ) ;
		_VertElem[ 5 ] = MakeVertexElement9( 0,    64,  D_D3DDECLTYPE_D3DCOLOR, D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_COLOR,        0 ) ;
		_VertElem[ 6 ] = MakeVertexElement9( 0,    68,  D_D3DDECLTYPE_D3DCOLOR, D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_COLOR,        1 ) ;
		_VertElem[ 7 ] = MakeVertexElement9( 0,    72,  D_D3DDECLTYPE_FLOAT2,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_TEXCOORD,     0 ) ;
		_VertElem[ 8 ] = MakeVertexElement9( 0,    80,  D_D3DDECLTYPE_FLOAT2,   D_D3DDECLMETHOD_DEFAULT, D_D3DDECLUSAGE_TEXCOORD,     1 ) ;
		_VertElem[ 9 ] = MakeVertexElement9( 0xff,  0,  D_D3DDECLTYPE_UNUSED,                         0,                       0,     0 ) ;
		GraphicsDevice_CreateVertexDeclaration( _VertElem, &GRH.UserShaderDeclaration[ DX_VERTEX_TYPE_SHADER_3D ] ) ;
	}

	// I
	return 0 ;
}

__inline void RGBtoVMaxRGBI( int R, int G, int B, BYTE &RD, BYTE &GD, BYTE &BD )
{
	int h, s ;

	if( R + G + B == 0 )
	{
		RD = 255 ;
		GD = 255 ;
		BD = 255 ;
		return ;
	}

	if( R > 255 ) R = 255 ;
	if( G > 255 ) G = 255 ;
	if( B > 255 ) B = 255 ;

	if( R > G )
	{
		if( R > B )
		{
			if( G > B )
			{
				// R > G > B
				if( R == B )
				{
					RD = 255 ;
					GD = 255 ;
					BD = 255 ;
				}
				else
				{
					h = ( G - B ) * 255 / ( R - B ) ;
					s = ( R - B ) * 255 / R ;

					RD = 255 ;
					GD = ( BYTE )( 255 - ( 255 - h ) * s / 255 ) ;
					BD = ( BYTE )( 255 - s ) ;
				}
			}
			else
			{
				// R > B > G
				if( R == G )
				{
					RD = 255 ;
					GD = 255 ;
					BD = 255 ;
				}
				else
				{
					h = ( B - G ) * 255 / ( R - G ) ;
					s = ( R - G ) * 255 / R ;

					RD = 255 ;
					GD = ( BYTE )( 255 - s ) ;
					BD = ( BYTE )( 255 - ( 255 - h ) * s / 255 ) ;
				}
			}
		}
		else
		{
			// B > R > G
			if( B == G )
			{
				RD = 255 ;
				GD = 255 ;
				BD = 255 ;
			}
			else
			{
				h = ( R - G ) * 255 / ( B - G ) ;
				s = ( B - G ) * 255 / B ;

				RD = ( BYTE )( 255 - ( 255 - h ) * s / 255 ) ;
				GD = ( BYTE )( 255 - s ) ;
				BD = 255 ;
			}
		}
	}
	else
	{
		if( G > B )
		{
			if( R > B )
			{
				// G > R > B
				if( G == B )
				{
					RD = 255 ;
					GD = 255 ;
					BD = 255 ;
				}
				else
				{
					h = ( R - B ) * 255 / ( G - B ) ;
					s = ( G - B ) * 255 / G ;

					RD = ( BYTE )( 255 - ( 255 - h ) * s / 255 ) ;
					GD = 255 ;
					BD = ( BYTE )( 255 - s ) ;
				}
			}
			else
			{
				// G > B > R
				if( G == R )
				{
					RD = 255 ;
					GD = 255 ;
					BD = 255 ;
				}
				else
				{
					h = ( B - R ) * 255 / ( G - R ) ;
					s = ( G - R ) * 255 / G ;

					RD = ( BYTE )( 255 - s ) ;
					GD = 255 ;
					BD = ( BYTE )( 255 - ( 255 - h ) * s / 255 ) ;
				}
			}
		}
		else
		{
			// B > G > R
			if( B == R )
			{
				RD = 255 ;
				GD = 255 ;
				BD = 255 ;
			}
			else
			{
				h = ( G - R ) * 255 / ( B - R ) ;
				s = ( B - R ) * 255 / B ;

				RD = ( BYTE )( 255 - s ) ;
				GD = ( BYTE )( 255 - ( 255 - h ) * s / 255 ) ;
				BD = 255 ;
			}
		}
	}
}

#ifndef DX_NON_MODEL

// RGBJ[PxőɂRGBlɕϊ邽߂̃{[eNX`쐬( 0:  -1:s )
extern int CreateRGBtoVMaxRGBVolumeTexture()
{
	DX_DIRECT3DVOLUMETEXTURE9 *TempMemTexture9 ;
	D_D3DLOCKED_BOX LockInfo ;
	D_D3DBOX LockBox ;
	int r, g, b ;
	BYTE *pDest ;
	HRESULT hr ;

	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	GRH.RGBtoVMaxRGBVolumeTexture = NULL ;
	TempMemTexture9 = NULL ;

	// {[eNX`̍쐬
	hr = GraphicsDevice_CreateVolumeTexture(
		RGBTOVMAXRGB_TEX_SIZE,
		RGBTOVMAXRGB_TEX_SIZE,
		RGBTOVMAXRGB_TEX_SIZE,
		1,
		0,
		D_D3DFMT_X8R8G8B8,
		D_D3DPOOL_DEFAULT,
		&GRH.RGBtoVMaxRGBVolumeTexture,
		NULL ) ;
	if( hr != D_D3D_OK )
	{
		DXST_ERRORLOG_ADD( _T( "RGBJ[PxőɂRGBlɕϊ邽߂̃{[eNX`̍쐬Ɏs܂\n" ) ) ;
		goto ERR ;
	}

	// ]pVXe{[eNX`̍쐬
	if( GraphicsDevice_CreateVolumeTexture(
		RGBTOVMAXRGB_TEX_SIZE,
		RGBTOVMAXRGB_TEX_SIZE,
		RGBTOVMAXRGB_TEX_SIZE,
		1,
		0,
		D_D3DFMT_X8R8G8B8,
		D_D3DPOOL_SYSTEMMEM,
		&TempMemTexture9,
		NULL ) != D_D3D_OK )
	{
		DXST_ERRORLOG_ADD( _T( "RGBJ[PxőɂRGBlɕϊ邽߂̓]p{[eNX`̍쐬Ɏs܂\n" ) ) ;
		goto ERR ;
	}

	// VXe{[eNX`̃bN
	_MEMSET( &LockInfo, 0, sizeof( LockInfo ) ) ;
	LockBox.Left   = 0 ;
	LockBox.Top    = 0 ;
	LockBox.Front  = 0 ;
	LockBox.Right  = RGBTOVMAXRGB_TEX_SIZE ;
	LockBox.Bottom = RGBTOVMAXRGB_TEX_SIZE ;
	LockBox.Back   = RGBTOVMAXRGB_TEX_SIZE ;
	hr = TempMemTexture9->LockBox( 0, &LockInfo, &LockBox, 0 ) ;
	if( hr == D_D3D_OK )
	{
		// VXe{[eNX`ɕϊ
		for( b = 0 ; b < RGBTOVMAXRGB_TEX_SIZE ; b ++ )
		{
			for( g = 0 ; g < RGBTOVMAXRGB_TEX_SIZE ; g ++ )
			{
				pDest = ( BYTE * )LockInfo.pBits + LockInfo.SlicePitch * b + LockInfo.RowPitch * g ;
				for( r = 0 ; r < RGBTOVMAXRGB_TEX_SIZE ; r ++, pDest += 4 )
				{
					RGBtoVMaxRGBI( r * 2, g * 2, b * 2, pDest[ 2 ], pDest[ 1 ], pDest[ 0 ] ) ;
					if( r < 8 && g < 8 && b < 8 )
					{
						pDest[ 0 ] = 255 ;
						pDest[ 1 ] = 255 ;
						pDest[ 2 ] = 255 ;
					}
					pDest[ 3 ] = 255 ;
				}
			}
		}
	}
	else
	{
		DXST_ERRORLOG_ADD( _T( "RGBJ[PxőɂRGBlɕϊ邽߂̓]p{[eNX`̃bNɎs܂\n" ) ) ;
		goto ERR ;
	}

	// bN̉
	TempMemTexture9->UnlockBox( 0 ) ;

	// eNX`̓]
	hr = GraphicsDevice_UpdateTexture( TempMemTexture9, GRH.RGBtoVMaxRGBVolumeTexture ) ;

	// VXe{[eNX`̉
	Graphics_ObjectRelease( TempMemTexture9 ) ;
	TempMemTexture9 = NULL ;

	// I
	return 0 ;

ERR :
	if( GRH.RGBtoVMaxRGBVolumeTexture )
	{
		Graphics_ObjectRelease( GRH.RGBtoVMaxRGBVolumeTexture ) ;
		GRH.RGBtoVMaxRGBVolumeTexture = NULL ;
	}

	if( TempMemTexture9 )
	{
		Graphics_ObjectRelease( TempMemTexture9 ) ;
		TempMemTexture9 = NULL ;
	}
	
	return -1 ;
}

#endif // DX_NON_MODEL

// yobt@IuWFNg̍쐬( 0:  -1:s )
extern int CreateDirect3D9ZBufferObject()
{
	HRESULT hr ;
	int w, h ;
	int depth ;
	int index ;

	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	// ɍ쐬ς݂̏ꍇ͈x폜
	if( GRH.ZBufferSurface )
	{
		Graphics_ObjectRelease( GRH.ZBufferSurface ) ;
		GRH.ZBufferSurface = NULL ;
	}

	DXST_ERRORLOG_ADD( _T( "yobt@쐬܂.... " ) ) ;

	// yobt@̃TCY
	if( GRH.UserZBufferSizeSet == FALSE ||
		GRH.ZBufferSizeX == 0 ||
		GRH.ZBufferSizeY == 0 )
	{
		for( w = 1 ; w < GRA2.MainScreenSizeX ; w <<= 1 ){}
		for( h = 1 ; h < GRA2.MainScreenSizeY ; h <<= 1 ){}
		GRH.ZBufferSizeX = w ;
		GRH.ZBufferSizeY = h ;
	}
	else
	{
		w = GRH.ZBufferSizeX ;
		h = GRH.ZBufferSizeY ;
	}

	// yobt@̃rbg[x
	if( GRH.UserZBufferBitDepthSet == FALSE ||
		GRH.ZBufferBitDepth == 0  )
	{
		depth = DEFAULT_ZBUFFER_BITDEPTH ;
		GRH.ZBufferBitDepth = DEFAULT_ZBUFFER_BITDEPTH ;
	}
	else
	{
		depth = GRH.ZBufferBitDepth ;
	}
	switch( depth )
	{
	default :
	case 16 : index = ZBUFFER_FORMAT_16BIT ; break ;
	case 24 : index = ZBUFFER_FORMAT_24BIT ; break ;
	case 32 : index = ZBUFFER_FORMAT_32BIT ; break ;
	}

	// 쐬
	hr = GraphicsDevice_CreateDepthStencilSurface( w, h, GRH.ZBufferFormat[ index ], GRH.FSAAMultiSampleType, GRH.FSAAMultiSampleQuality, TRUE, &GRH.ZBufferSurface, NULL ) ;
	if( FAILED( hr ) )
	{
		DXST_ERRORLOG_ADD( _T( "yobt@̍쐬Ɏs܂\n" ) ) ;
		return -1 ;
	}

	// foCXɃZbg
	GraphicsDevice_SetDepthStencilSurface( GRH.ZBufferSurface ) ;

	// NA
	GraphicsDevice_Clear( 0, NULL, D_D3DCLEAR_ZBUFFER, 0, 1.0f, 0 ) ;

	DXST_ERRORLOG_ADD( _T( "\n" ) ) ;

	// I
	return 0 ;
}

// ScreenCopy  GetDrawScreen 邽߂Ɏgpe|obt@̍쐬( 0:  -1:s )
extern int CreateSubBackBufferSurface()
{
	HRESULT hr ;

	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	// ɍ쐬Ăꍇ͈x폜
	if( GRH.SubBackBufferSurface )
	{
		Graphics_ObjectRelease( GRH.SubBackBufferSurface ) ;
		GRH.SubBackBufferSurface = NULL ;
	}

	// _O^[Qbg̍쐬
	hr = GraphicsDevice_CreateRenderTarget( GRA2.MainScreenSizeX, GRA2.MainScreenSizeY, GRH.ScreenFormat, GRH.FSAAMultiSampleType, GRH.FSAAMultiSampleQuality, FALSE, &GRH.SubBackBufferSurface, NULL ) ;
	if( FAILED( hr ) )
	{
		DXST_ERRORLOG_ADD( _T( "TuobNobt@̍쐬Ɏs܂\n" ) ) ;
		return -1 ;
	}

	// I
	return 0 ;
}

// Direct3DVertexDeclaration9 IuWFNg̍폜( 0:  -1:s )
extern int TerminateDirect3D9VertexDeclaration()
{
	int i ;

	if( GraphicsDevice_IsValid() == 0 )
		return 0 ;

	GraphicsDevice_SetVertexShader( NULL ) ;
	GraphicsDevice_SetPixelShader( NULL ) ;
	GRH.SetVS = NULL ;
	GRH.SetVD = NULL ;

#ifndef DX_NON_MODEL
	DX_DIRECT3DVERTEXDECLARATION9 **VD ;

	VD = ( DX_DIRECT3DVERTEXDECLARATION9 ** )GRH.DefaultVertexDeclaration ;
	for( i = 0 ; i < sizeof( GRH.DefaultVertexDeclaration ) / sizeof( DX_DIRECT3DVERTEXDECLARATION9 * ) ; i ++ )
	{
		if( VD[ i ] )
		{
			Graphics_ObjectRelease( VD[ i ] ) ;
			VD[ i ] = NULL ;
		}
	}

#endif // DX_NON_MODEL

	// [U[VF[_[[hp̒_錾̉
	for( i = 0 ; i < DX_VERTEX_TYPE_NUM ; i ++ )
	{
		if( GRH.UserShaderDeclaration[ i ] )
		{
			Graphics_ObjectRelease( GRH.UserShaderDeclaration[ i ] ) ;
			GRH.UserShaderDeclaration[ i ] = NULL ;
		}
	}

	// I
	return 0 ;
}

// Direct3D9 ̃VF[_[̌n( 0:  -1:s )
extern int TerminateDirect3D9Shader()
{
	if( GraphicsDevice_IsValid() == 0 )
		return 0 ;

	GraphicsDevice_SetVertexShader( NULL ) ;
	GraphicsDevice_SetPixelShader( NULL ) ;
	GRH.SetVS = NULL ;
	GRH.SetVD = NULL ;

	int i ;
	DX_DIRECT3DVERTEXSHADER9 **VS = NULL ;
	DX_DIRECT3DPIXELSHADER9 **PS = NULL ;

	PS = ( DX_DIRECT3DPIXELSHADER9 ** )GRH.BaseNoneTexPixelShader ;
	for( i = 0 ; i < sizeof( GRH.BaseNoneTexPixelShader ) / sizeof( DX_DIRECT3DPIXELSHADER9 * ) ; i ++ )
	{
		if( PS[ i ] )
		{
			Graphics_ObjectRelease( PS[ i ] ) ;
			PS[ i ] = NULL ;
		}
	}

	PS = ( DX_DIRECT3DPIXELSHADER9 ** )GRH.BaseUseTexPixelShader ;
	for( i = 0 ; i < sizeof( GRH.BaseUseTexPixelShader ) / sizeof( DX_DIRECT3DPIXELSHADER9 * ) ; i ++ )
	{
		if( PS[ i ] )
		{
			Graphics_ObjectRelease( PS[ i ] ) ;
			PS[ i ] = NULL ;
		}
	}

	if( GRH.MaskEffectPixelShader )
	{
		Graphics_ObjectRelease( GRH.MaskEffectPixelShader ) ;
		GRH.MaskEffectPixelShader = NULL ;
	}

#ifndef DX_NON_MODEL

	VS = ( DX_DIRECT3DVERTEXSHADER9 ** )GRH.DefaultVertexShader_SM3 ;
	for( i = 0 ; i < sizeof( GRH.DefaultVertexShader_SM3 ) / sizeof( DX_DIRECT3DVERTEXSHADER9 * ) ; i ++ )
	{
		if( VS[ i ] )
		{
			Graphics_ObjectRelease( VS[ i ] ) ;
			VS[ i ] = NULL ;
		}
	}

	PS = ( DX_DIRECT3DPIXELSHADER9 ** )GRH.DefaultPixelShader_SM3 ;
	for( i = 0 ; i < sizeof( GRH.DefaultPixelShader_SM3 ) / sizeof( DX_DIRECT3DPIXELSHADER9 * ) ; i ++ )
	{
		if( PS[ i ] )
		{
			Graphics_ObjectRelease( PS[ i ] ) ;
			PS[ i ] = NULL ;
		}
	}

	VS = ( DX_DIRECT3DVERTEXSHADER9 ** )GRH.DefaultVertexShader ;
	for( i = 0 ; i < sizeof( GRH.DefaultVertexShader ) / sizeof( DX_DIRECT3DVERTEXSHADER9 * ) ; i ++ )
	{
		if( VS[ i ] )
		{
			Graphics_ObjectRelease( VS[ i ] ) ;
			VS[ i ] = NULL ;
		}
	}

	PS = ( DX_DIRECT3DPIXELSHADER9 ** )GRH.DefaultPixelShader ;
	for( i = 0 ; i < sizeof( GRH.DefaultPixelShader ) / sizeof( DX_DIRECT3DPIXELSHADER9 * ) ; i ++ )
	{
		if( PS[ i ] )
		{
			Graphics_ObjectRelease( PS[ i ] ) ;
			PS[ i ] = NULL ;
		}
	}
#endif // DX_NON_MODEL

	// I
	return 0 ;
}

// VF[_[R[ȟns
static int ShaderCodeTerminate()
{
	// łɌnĂ牽Ȃ
	if( GRA2.ShaderInitializeFlag == FALSE )
		return TRUE ;

	// {VF[_[pcw`̌n
	DXA_Terminate( &GRA2.BaseShaderBinDxa ) ;


	// 𓀂VF[_[i[Ẳ
	if( GRA2.BaseShaderBinDxaImage != NULL )
	{
		DXFREE( GRA2.BaseShaderBinDxaImage ) ;
		GRA2.BaseShaderBinDxaImage = NULL ;
	}

#ifndef DX_NON_MODEL
	if( GRA2.ModelShaderPackImage )
	{
		DXFREE( GRA2.ModelShaderPackImage ) ;
		GRA2.ModelShaderPackImage = NULL ;
	}
#endif // DX_NON_MODEL

#ifndef DX_NON_FILTER

	// tB^[VF[_[pcw`̌n
	DXA_Terminate( &GRA2.FilterShaderBinDxa ) ;

	if( GRA2.RGBAMixS_ShaderPackImage )
	{
		DXFREE( GRA2.RGBAMixS_ShaderPackImage ) ;
		GRA2.RGBAMixS_ShaderPackImage = NULL ;
	}
	if( GRA2.FilterShaderBinDxaImage )
	{
		DXFREE( GRA2.FilterShaderBinDxaImage ) ;
		GRA2.FilterShaderBinDxaImage = NULL ;
	}

#endif // DX_NON_FILTER

	// tO|
	GRA2.ShaderInitializeFlag = FALSE ;

	// I
	return TRUE ;
}

// VF[_[R[hɓWJ
static int ShaderCodeSetup()
{
	int Size = 0, Addr = 0, i = 0 ;
	void **AddrBuf = NULL ;
	BYTE *ShaderAddr = NULL ;
	WORD *SizeBuf = NULL ;
	short *SizeDest = NULL ;

	// łɏĂ牽Ȃ
	if( GRA2.ShaderInitializeFlag == TRUE )
		return TRUE ;

#ifndef DX_NON_FILTER
	GRA2.FilterShaderBinDxaImage = NULL ;
	GRA2.RGBAMixS_ShaderPackImage = NULL ;
#endif // DX_NON_FILTER

#ifndef DX_NON_MODEL
	GRA2.ModelShaderPackImage = NULL ;
#endif // DX_NON_MODEL

	GRA2.BaseShaderBinDxaImage = NULL ;

	// {VF[_[IuWFNgt@Ccw`kf[^𓀂
	{
		Size = DXA_Decode( DxShaderCodeBin_Base, NULL ) ;
		GRA2.BaseShaderBinDxaImage = DXALLOC( Size ) ;
		if( GRA2.BaseShaderBinDxaImage == NULL )
			goto ERR ;

		DXA_Decode( DxShaderCodeBin_Base, GRA2.BaseShaderBinDxaImage ) ;

		// cw`t@CI[v
		DXA_Initialize( &GRA2.BaseShaderBinDxa ) ;
		if( DXA_OpenArchiveFromMem( &GRA2.BaseShaderBinDxa, GRA2.BaseShaderBinDxaImage, Size ) != 0 )
			goto ERR ;
	}

#ifndef DX_NON_FILTER

	// RGBAMixVF[_[pbNkt@CWJ
	{
		Size = DXA_Decode( DxShaderCodeBin_Filter, NULL ) ;
		GRA2.RGBAMixS_ShaderPackImage = DXALLOC( Size ) ;
		if( GRA2.RGBAMixS_ShaderPackImage == NULL )
			goto ERR ;

		DXA_Decode( DxShaderCodeBin_Filter, GRA2.RGBAMixS_ShaderPackImage ) ;

		// AhXXg̃Zbg
		Addr = 0 ;
		SizeBuf = ( WORD * )GRA2.RGBAMixS_ShaderPackImage ;
		ShaderAddr = ( BYTE * )GRA2.RGBAMixS_ShaderPackImage + sizeof( WORD ) * 256 ;
		AddrBuf = ( void ** )GRA2.RGBAMixS_ShaderAddress ;
		SizeDest = ( short * )GRA2.RGBAMixS_ShaderSize ;
		for( i = 0 ; i < 256 ; i ++, SizeBuf ++, AddrBuf ++, SizeDest ++ )
		{
			if( *SizeBuf != 0 )
			{
				*AddrBuf = ( void * )ShaderAddr ;
				ShaderAddr += *SizeBuf ;
			}
			*SizeDest = *SizeBuf ;
		}
	}

	// tB^[VF[_[IuWFNgt@Ccw`kf[^𓀂
	{
		Size = DXA_Decode( DxShaderCodeBin_Filter, NULL ) ;
		GRA2.FilterShaderBinDxaImage = DXALLOC( Size ) ;
		if( GRA2.FilterShaderBinDxaImage == NULL )
			goto ERR ;

		DXA_Decode( DxShaderCodeBin_Filter, GRA2.FilterShaderBinDxaImage ) ;

		// cw`t@CI[v
		DXA_Initialize( &GRA2.FilterShaderBinDxa ) ;
		if( DXA_OpenArchiveFromMem( &GRA2.FilterShaderBinDxa, GRA2.FilterShaderBinDxaImage, Size ) != 0 )
			goto ERR ;
	}

#endif // DX_NON_FILTER

#ifndef DX_NON_MODEL
	// RcfpVF[_[pbNkt@CWJ
	{
		// CgCfbNXXg̍\z
		{
			int l0, l1, l2, l3, l4, l5, ind ;

			ind = 0 ;
			for( l0 = 0 ; l0 < 4 ; l0 ++ )
			{
				for( l1 = 0 ; l1 <= l0 ; l1 ++ )
				{
					for( l2 = 0 ; l2 <= l1 ; l2 ++ )
					{
						for( l3 = 0 ; l3 <= l2 ; l3 ++ )
						{
							for( l4 = 0 ; l4 <= l3 ; l4 ++ )
							{
								for( l5 = 0 ; l5 <= l4 ; l5 ++ )
								{
									GRA2.LightIndexList_SM3[ l0 ][ l1 ][ l2 ][ l3 ][ l4 ][ l5 ] = ind ;
									ind ++ ;
								}
							}
						}
					}
				}
			}

			ind = 0 ;
			for( l0 = 0 ; l0 < 4 ; l0 ++ )
			{
				for( l1 = 0 ; l1 <= l0 ; l1 ++ )
				{
					for( l2 = 0 ; l2 <= l1 ; l2 ++ )
					{
						GRA2.LightIndexList[ l0 ][ l1 ][ l2 ] = ind ;
						ind ++ ;
					}
				}
			}
		}

		Size = DXA_Decode( DxShaderCodeBin_Model, NULL ) ;
		GRA2.ModelShaderPackImage = DXCALLOC( Size ) ;
		if( GRA2.ModelShaderPackImage == NULL )
			goto ERR ;

		DXA_Decode( DxShaderCodeBin_Model, GRA2.ModelShaderPackImage ) ;

		// AhXXg̃Zbg
		Addr = 0 ;
		SizeBuf = ( WORD * )GRA2.ModelShaderPackImage ;
		ShaderAddr = ( BYTE * )GRA2.ModelShaderPackImage +
			sizeof( WORD ) * (
				sizeof( GRH.DefaultVertexShader_SM3 ) / sizeof( DX_DIRECT3DVERTEXSHADER9 * ) +
				sizeof( GRH.DefaultPixelShader_SM3  ) / sizeof( DX_DIRECT3DPIXELSHADER9  * ) +
				sizeof( GRH.DefaultVertexShader     ) / sizeof( DX_DIRECT3DVERTEXSHADER9 * ) +
				sizeof( GRH.DefaultPixelShader      ) / sizeof( DX_DIRECT3DPIXELSHADER9  * ) ) ;

		AddrBuf = ( void ** )GRA2.DefaultVertexShaderAddress_SM3 ;
		for( i = 0 ; i < sizeof( GRH.DefaultVertexShader_SM3 ) / sizeof( DX_DIRECT3DVERTEXSHADER9 * ) ; i ++, SizeBuf ++, AddrBuf ++ )
		{
			if( *SizeBuf != 0 )
			{
				*AddrBuf = ( void * )ShaderAddr ;
				ShaderAddr += *SizeBuf ;
			}
		}

		AddrBuf = ( void ** )GRA2.DefaultPixelShaderAddress_SM3 ;
		for( i = 0 ; i < sizeof( GRH.DefaultPixelShader_SM3 ) / sizeof( DX_DIRECT3DPIXELSHADER9 * ) ; i ++, SizeBuf ++, AddrBuf ++ )
		{
			if( *SizeBuf != 0 )
			{
				*AddrBuf = ( void * )ShaderAddr ;
				ShaderAddr += *SizeBuf ;
			}
		}

		AddrBuf = ( void ** )GRA2.DefaultVertexShaderAddress ;
		for( i = 0 ; i < sizeof( GRH.DefaultVertexShader ) / sizeof( DX_DIRECT3DVERTEXSHADER9 * ) ; i ++, SizeBuf ++, AddrBuf ++ )
		{
			if( *SizeBuf != 0 )
			{
				*AddrBuf = ( void * )ShaderAddr ;
				ShaderAddr += *SizeBuf ;
			}
		}

		AddrBuf = ( void ** )GRA2.DefaultPixelShaderAddress ;
		for( i = 0 ; i < sizeof( GRH.DefaultPixelShader ) / sizeof( DX_DIRECT3DPIXELSHADER9 * ) ; i ++, SizeBuf ++, AddrBuf ++ )
		{
			if( *SizeBuf != 0 )
			{
				*AddrBuf = ( void * )ShaderAddr ;
				ShaderAddr += *SizeBuf ;
			}
		}
	}
#endif // DX_NON_MODEL

	GRA2.ShaderInitializeFlag = TRUE ;

	// I
	return TRUE ;

ERR :
	if( GRA2.BaseShaderBinDxaImage != NULL )
	{
		DXFREE( GRA2.BaseShaderBinDxaImage ) ;
		GRA2.BaseShaderBinDxaImage = NULL ;
	}

#ifndef DX_NON_FILTER
	if( GRA2.FilterShaderBinDxaImage != NULL )
	{
		DXFREE( GRA2.FilterShaderBinDxaImage ) ;
		GRA2.FilterShaderBinDxaImage = NULL ;
	}

	if( GRA2.RGBAMixS_ShaderPackImage != NULL )
	{
		DXFREE( GRA2.RGBAMixS_ShaderPackImage ) ;
		GRA2.RGBAMixS_ShaderPackImage = NULL ;
	}
#endif // DX_NON_FILTER

#ifndef DX_NON_MODEL
	if( GRA2.ModelShaderPackImage != NULL )
	{
		DXFREE( GRA2.ModelShaderPackImage ) ;
		GRA2.ModelShaderPackImage = NULL ;
	}
#endif // DX_NON_MODEL

	return FALSE ;
}

#ifndef DX_NON_FILTER

// w薼̎OpӃVF[_[ǂݍ
static int MemLoadShaderCode( const char *ShaderName, bool IsVertexShader )
{
	int Addr, Size ;
	BYTE *FileImage ;
	int Ret ;

	if( GRA2.ShaderInitializeFlag == FALSE ) return -1 ;

	if( DXA_GetFileInfo( &GRA2.FilterShaderBinDxa, ShaderName, &Addr, &Size ) < 0 ) return -1 ;

	FileImage = ( BYTE * )DXA_GetFileImage( &GRA2.FilterShaderBinDxa ) + Addr ;

	Ret = CreateShader_UseGParam( IsVertexShader, FileImage, Size, FALSE, FALSE ) ;

	return Ret ;
}

#endif // DX_NON_FILTER


// n[hEGAANZ[^֌W̏
static int InitializeHardware()
{
	int i ;

#ifndef DX_NON_FILTER
	// VF[_[nhlZbg
	_MEMSET( &GRH.ShaderCode, 0xff, sizeof( GRH.ShaderCode ) ) ;
#endif // DX_NON_FILTER

	// _obt@̌ŒlZbg
	{
		VERTEX_NOTEX_2D    *vertNoTex ;
		VERTEX_2D          *vertTex ;
		VERTEX_BLENDTEX_2D *vertBlend ;

		vertNoTex = (VERTEX_NOTEX_2D    *)GRH.NoTexVertexBuffer ;
		vertTex   = (VERTEX_2D          *)GRH.TexVertexBuffer ;
		vertBlend = (VERTEX_BLENDTEX_2D *)GRH.BlendTexVertexBuffer ;
		
		for( i = 0 ; i < D3DDEV_NOTEX_VERTMAXNUM ; i ++, vertNoTex ++ )
		{
			vertNoTex->pos.z = 0.0F ;
			vertNoTex->rhw   = 1.0F ;
		}

		for( i = 0 ; i < D3DDEV_TEX_VERTMAXNUM ; i ++, vertTex ++ )
		{
			vertTex->pos.z = 0.0F ;
			vertTex->rhw   = 1.0F ;
		}

		for( i = 0 ; i < D3DDEV_BLENDTEX_VERTMAXNUM ; i ++, vertBlend ++ )
		{
			vertBlend->pos.z    = 0.0F ;
			vertBlend->rhw      = 1.0F ;
			vertBlend->specular = 0xffffffff ;
		}
		
		GRH.VertexBufferPoint[ 0 ][ 0 ] = ( BYTE * )GRH.NoTexVertexBuffer ;
		GRH.VertexBufferPoint[ 0 ][ 1 ] = ( BYTE * )GRH.TexVertexBuffer ;
		GRH.VertexBufferPoint[ 0 ][ 2 ] = ( BYTE * )GRH.BlendTexVertexBuffer ;
		GRH.VertexBufferPoint[ 1 ][ 0 ] = ( BYTE * )GRH.Vertex3DBuffer ;
		GRH.VertexBufferPoint[ 1 ][ 1 ] = ( BYTE * )GRH.Vertex3DBuffer ;
	}

	// `Xe[^X̃Zbg
	{
		float FloatParam ;

		// eNX``pݒ
		for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++ )
		{
			if( GBASE.TexAddressModeU[ i ] == 0 )
				GBASE.TexAddressModeU[ i ] = D_D3DTADDRESS_CLAMP ;
			if( GBASE.TexAddressModeV[ i ] == 0 )
				GBASE.TexAddressModeV[ i ] = D_D3DTADDRESS_CLAMP ;
			if( GBASE.TexAddressModeW[ i ] == 0 )
				GBASE.TexAddressModeW[ i ] = D_D3DTADDRESS_CLAMP ;
		}
		for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++ )
		{
			// eNX`AhX[hݒ
			GraphicsDevice_SetSamplerState( i, D_D3DSAMP_ADDRESSU, GBASE.TexAddressModeU[ i ] ) ;
			GraphicsDevice_SetSamplerState( i, D_D3DSAMP_ADDRESSV, GBASE.TexAddressModeV[ i ] ) ;
			GraphicsDevice_SetSamplerState( i, D_D3DSAMP_ADDRESSW, GBASE.TexAddressModeW[ i ] ) ;

			// tB^O[hݒ
			switch( GRH.DrawMode )
			{
			case DX_DRAWMODE_NEAREST :
				GRH.MagFilter[ i ] = D_D3DTEXF_POINT ;
				GRH.MinFilter[ i ] = D_D3DTEXF_POINT ;
				GRH.MipFilter[ i ] = D_D3DTEXF_POINT ;
				break ;

			case DX_DRAWMODE_BILINEAR :
				GRH.MagFilter[ i ] = D_D3DTEXF_LINEAR ;
				GRH.MinFilter[ i ] = D_D3DTEXF_LINEAR ;
				GRH.MipFilter[ i ] = D_D3DTEXF_LINEAR ;
				break ;

			case DX_DRAWMODE_ANISOTROPIC :
				GRH.MagFilter[ i ] = D_D3DTEXF_ANISOTROPIC ;
				GRH.MinFilter[ i ] = D_D3DTEXF_ANISOTROPIC ;
				GRH.MipFilter[ i ] = D_D3DTEXF_LINEAR ;
				break ;
			}
			GraphicsDevice_SetSamplerState( i, D_D3DSAMP_MAGFILTER, GRH.MagFilter[ i ] ) ;
			GraphicsDevice_SetSamplerState( i, D_D3DSAMP_MINFILTER, GRH.MinFilter[ i ] ) ;
			GraphicsDevice_SetSamplerState( i, D_D3DSAMP_MIPFILTER, GRH.MipFilter[ i ] ) ;

			// őٕZbg
			GRH.MaxAnisotropyDim[ i ] = 1 ;
		}

		// Ō̃hbg`悵Ȃ
//		GraphicsDevice_SetRenderState( D_D3DRS_LASTPIXEL, TRUE ) ;

		// JOIt
		GraphicsDevice_SetRenderState( D_D3DRS_CULLMODE, D_D3DCULL_NONE ) ;

		// CeBOnm
		GraphicsDevice_SetRenderState( D_D3DRS_LIGHTING, TRUE ) ;

		// tbgVF[fBO
		GraphicsDevice_SetRenderState( D_D3DRS_SHADEMODE, D_D3DSHADE_FLAT ) ;

		// `uhȂ
//		GraphicsDevice_SetRenderState( D_D3DRS_ALPHABLENDENABLE, FALSE ) ;

		// fBUOnee
		GraphicsDevice_SetRenderState( D_D3DRS_DITHERENABLE, FALSE ) ;

		// XyLCgnee
		GraphicsDevice_SetRenderState( D_D3DRS_SPECULARENABLE, TRUE ) ;

		// ArGgCg\[X̓}eA
		GraphicsDevice_SetRenderState( D_D3DRS_AMBIENTMATERIALSOURCE, D_D3DMCS_MATERIAL  ) ;

		// @̐Ks
		GraphicsDevice_SetRenderState( D_D3DRS_NORMALIZENORMALS, TRUE ) ;

		// tHO͖
		GraphicsDevice_SetRenderState( D_D3DRS_FOGENABLE, FALSE ) ;
		GraphicsDevice_SetRenderState( D_D3DRS_FOGVERTEXMODE, D_D3DFOG_NONE ) ;
		GraphicsDevice_SetRenderState( D_D3DRS_FOGCOLOR, 0 ) ;
		FloatParam = 0.0f ;
		GraphicsDevice_SetRenderState( D_D3DRS_FOGSTART, *( ( DWORD * )&FloatParam ) ) ;
		FloatParam = 1.0f ;
		GraphicsDevice_SetRenderState( D_D3DRS_FOGEND, *( ( DWORD * )&FloatParam ) ) ;

		// }eÃp[^擾
		{
			D_D3DMATERIAL9 Material ;

			GraphicsDevice_GetMaterial( &Material ) ;
			GRH.Material.Diffuse.r = Material.Diffuse.r ;
			GRH.Material.Diffuse.g = Material.Diffuse.g ;
			GRH.Material.Diffuse.b = Material.Diffuse.b ;
			GRH.Material.Diffuse.a = Material.Diffuse.a ;
			GRH.Material.Specular.r = Material.Specular.r ;
			GRH.Material.Specular.g = Material.Specular.g ;
			GRH.Material.Specular.b = Material.Specular.b ;
			GRH.Material.Specular.a = Material.Specular.a ;
			GRH.Material.Emissive.r = Material.Emissive.r ;
			GRH.Material.Emissive.g = Material.Emissive.g ;
			GRH.Material.Emissive.b = Material.Emissive.b ;
			GRH.Material.Emissive.a = Material.Emissive.a ;
			GRH.Material.Ambient.r = Material.Ambient.r ;
			GRH.Material.Ambient.g = Material.Ambient.g ;
			GRH.Material.Ambient.b = Material.Ambient.b ;
			GRH.Material.Ambient.a = Material.Ambient.a ;
			GRH.Material.Power = Material.Power ;
		}
	}

	// ufBOp[^
	_MEMSET( &GRH.BlendInfo, 0, sizeof( DIRECT3DBLENDINFO ) ) ;
	GRH.BlendInfo.UseTextureStageNum = 0 ;
	for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++ )
	{
		GRH.BlendInfo.TextureStageInfo[i].Texture       = NULL ;
		GRH.BlendInfo.TextureStageInfo[i].ResultTempARG = FALSE ;
		GRH.BlendInfo.TextureStageInfo[i].AlphaARG1     = D_D3DTA_TEXTURE ;
		GRH.BlendInfo.TextureStageInfo[i].AlphaARG2     = D_D3DTA_DIFFUSE ;
		GRH.BlendInfo.TextureStageInfo[i].AlphaOP       = D_D3DTOP_DISABLE ;
		GRH.BlendInfo.TextureStageInfo[i].ColorARG1     = D_D3DTA_TEXTURE ;
		GRH.BlendInfo.TextureStageInfo[i].ColorARG2     = D_D3DTA_DIFFUSE ;
		GRH.BlendInfo.TextureStageInfo[i].ColorOP       = D_D3DTOP_DISABLE ;
	}

	GRH.DiffuseColor            = 0xffffffff ;

	GRH.DrawPrepAlwaysFlag      = TRUE ;
	GRH.EnableZBufferFlag		= TRUE ;
	GRH.WriteZBufferFlag		= FALSE ; 
	GRH.ZBufferCmpType			= DX_CMP_LESSEQUAL ;
	GRH.ZBias					= 0 ;
	GRH.FillMode				= D_D3DFILL_SOLID ;
	GRH.UseDiffuseRGBColor		= FALSE ;
	GRH.UseDiffuseAlphaColor	= FALSE ;
	GRH.BlendMode				= DX_BLENDMODE_NOBLEND ;
	GRH.BlendGraphBorderParam	= -1 ;
	GRH.AlphaTestMode           = -1 ;
	GRH.AlphaTestParam          = 0 ;
	GRH.AlphaChannelValidFlag	= FALSE ;
	GRH.AlphaTestValidFlag		= FALSE ;
	GRH.ChangeBlendParamFlag	= TRUE ;
	GRH.ChangeTextureFlag		= FALSE ;
	GRH.BlendMaxNotDrawFlag		= FALSE ;
	GRH.CullMode				= FALSE ;
	GRH.UseSpecular             = TRUE ;

	GRH.Viewport.X				= 0 ;
	GRH.Viewport.Y				= 0 ;
	GRH.Viewport.Width			= GRA2.MainScreenSizeX ;
	GRH.Viewport.Height			= GRA2.MainScreenSizeY ;
	GRH.Viewport.MinZ			= 0.0f ;
	GRH.Viewport.MaxZ			= 1.0f ;

	for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++ )
	{
		GRH.TexAddressModeU[ i ] = GBASE.TexAddressModeU[ i ] ;
		GRH.TexAddressModeV[ i ] = GBASE.TexAddressModeV[ i ] ;
		GRH.TexAddressModeW[ i ] = GBASE.TexAddressModeW[ i ] ;
	}
	GRH.PerspectiveFlag			= FALSE ;
	GRH.LightFlag				= TRUE ;
//	GRH.AlphaValidFlag			= FALSE ;
//	GRH.AlphaBlendEnable		= FALSE ;
	GRH.DrawMode				= DX_DRAWMODE_OTHER ;
	GRH.MaxAnisotropy			= 1 ;
	GRH.TargetSurface[ 0 ]		= GRH.BackBufferSurface ;
	GRH.BeginSceneFlag			= FALSE ;
//	GRH.BlendParam				= 0 ;
	GRH.BlendTexture			= NULL ;
	GRH.BlendGraphType			= 0 ;
	GRH.RenderTexture			= NULL ;
	GRH.ShadeMode				= DX_SHADEMODE_FLAT ;
	GRH.VertexNum				= 0 ;
	GRH.VertexBufferNextAddress = GRH.TexVertexBuffer ;
	GRH.VertexType				= VERTEXTYPE_TEX ;
//	GRH.VertexBufferUseFlag		= FALSE ;
//	GRH.ColorKeyFlag			= FALSE ;
	GRH.FogEnable				= FALSE ;
	GRH.FogColor				= 0 ;
	GRH.FogMode					= DX_FOGMODE_NONE ;
	GRH.FogStart				= 0.0f ;
	GRH.FogEnd					= 1.0f ;

	// ݒtbV
	RefreshRenderStateHardware() ;

	// ܂Ȃ
	{
		VERTEX_NOTEX_2D *vec ;

		BeginScene() ;
		DrawPreparation( NULL, 0 ) ;

		GETVERTEX_POINT( vec ) ;

		vec->pos.x = 0.0f ;
		vec->pos.y = 0.0f ;
		vec->pos.z = 0.0f ;

		ADD4VERTEX_POINT
	}

	// I
	return 0 ;
}

// ꎞIɃn[hEGAjۂɁAjȌԂo߂̊֐
static int ReInitializeHardware()
{
	int i ;

	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	// `Xe[^X̃Zbg
	{
		// eNX``pݒ
//		GraphicsDevice_SetTextureStageState( 0, D_D3DTSS_ADDRESS, D_D3DTADDRESS_CLAMP );

		// fBUOnee
		GraphicsDevice_SetRenderState( D_D3DRS_DITHERENABLE, FALSE ) ;
	}

	// tO𗧂Ă
	GRH.InitializeFlag = TRUE ;

	// K DrawPreparation stO𗧂Ă
	GRH.DrawPrepAlwaysFlag = TRUE ;

	// 폜OƓo
	{
		// `̐ݒ
//		if( GRH.TargetSurface != NULL )
//			SetRenderTargetHardware( GRH.TargetSurface ) ;

		// eNX`̃Zbg
		GRH.RenderTexture = NULL ;

		// `撸_Zbg
		GRH.VertexNum = 0 ;

		// `uh[h̐ݒ
		SetDrawBlendModeHardware( GRH.BlendMode, GRH.AlphaTestValidFlag, GRH.AlphaChannelValidFlag ) ;
//		RefreshBlendStateHardware( DevHandle ) ;

		// `摜̐F𖳎邩ǂZbg
		SetIgnoreDrawGraphColorHardware( GRH.IgnoreGraphColorFlag ) ;

		// JO[h̃Zbg
		SetUseCullingHardware( GRH.CullMode ) ;

		// `惂[h̐ݒ
		SetDrawModeHardware( GRH.DrawMode ) ;

		// VF[fBO[h̃Zbg
		SetShadeModeHardware( GRH.ShadeMode ) ;

		// ٕtB^O̐ݒZbg
		SetMaxAnisotropyHardware( GRH.MaxAnisotropy ) ;

		// JO[h̐ݒZbg
		SetUseCullingHardware( GRH.CullMode ) ;

		// UVAhbVO[h̐ݒZbg
		for( i = 0 ; i < 8 ; i ++ )
		{
			SetTextureAddressUHardware( GRH.TexAddressModeU[ i ], i ) ;
			SetTextureAddressVHardware( GRH.TexAddressModeV[ i ], i ) ;
			SetTextureAddressWHardware( GRH.TexAddressModeW[ i ], i ) ;
		}

		// eNX`Wϊsgp邩ǂ̐ݒZbg
		for( i = 0 ; i < 8 ; i ++ )
		{
			SetTextureAddressTransformMatrixHardware( GRH.TextureTransformUse[ i ], &GRH.TextureTransformMatrix[ i ], i ) ;
		}

		// tHO̐ݒZbg
		SetFogEnableHardware( GRH.FogEnable ) ;
		SetFogModeHardware( GRH.FogMode ) ;
		SetFogColorHardware( GRH.FogColor ) ;
		SetFogStartEndHardware( GRH.FogStart, GRH.FogEnd ) ;
		SetFogDensityHardware( GRH.FogDensity ) ;

		// yobt@̐ݒZbg
		SetUseZBufferHardware( GRH.EnableZBufferFlag ) ;
		SetWriteZBufferHardware( GRH.WriteZBufferFlag ) ;
		SetZBufferCmpTypeHardware( GRH.ZBufferCmpType ) ;
		SetZBiasHardware( GRH.ZBias ) ;
		SetFillModeHardware( GRH.FillMode ) ;

		// s̍Đݒ
		NS_SetTransformToWorld( &GBASE.WorldMatrix ) ;
		NS_SetTransformToView( &GBASE.ViewMatrix ) ;
		_SetTransformToProjection( &GBASE.ProjectionMatrix ) ;
		NS_SetTransformToViewport( &GBASE.ViewportMatrix ) ;

		// }eA̍Đݒ
		SetMaterialHardware( &GRH.Material ) ;
		SetUseSpecularHardware( GRH.UseSpecular ) ;
		SetMaterialUseVertexDiffuseColorHardware( GRH.MaterialUseVertexDiffuseColor ) ;
		SetMaterialUseVertexSpecularColorHardware( GRH.MaterialUseVertexSpecularColor ) ;

		// Cg̍Đݒ
		SetAmbientColorHardware(
			( ( ( DWORD )( _FTOL( GRH.GlobalAmbientLightColor.a ) * 255 ) ) << 24 ) | 
			( ( ( DWORD )( _FTOL( GRH.GlobalAmbientLightColor.r ) * 255 ) ) << 16 ) | 
			( ( ( DWORD )( _FTOL( GRH.GlobalAmbientLightColor.g ) * 255 ) ) << 8  ) | 
			( ( ( DWORD )( _FTOL( GRH.GlobalAmbientLightColor.b ) * 255 ) ) << 0  ) ) ;
		SetUseLightFlagHardware( GRH.LightFlag ) ;
		for( i = 0 ; i < 256 ; i ++ )
		{
			if( GRH.LightParam[ i ].Type == 0 ) continue ;
			SetLightHardware( i, &GRH.LightParam[ i ] ) ;
			SetLightEnableHardware( i, GRH.LightEnableFlag[ i ] ) ;
		}

		// `̈̐ݒ
		{
			D_D3DVIEWPORT9 Viewport ;

			// r[|[g̃ZbeBO
			_MEMSET( &Viewport, 0, sizeof( Viewport ) ) ;
			Viewport.X		= GBASE.DrawArea.left ;
			Viewport.Y		= GBASE.DrawArea.top ;
			Viewport.Width	= GBASE.DrawArea.right  - GBASE.DrawArea.left ;
			Viewport.Height	= GBASE.DrawArea.bottom - GBASE.DrawArea.top ;
			Viewport.MinZ	= 0.0f ;
			Viewport.MaxZ	= 1.0f ;

			// Zbg
			SetViewportHardware( &Viewport ) ;
			SetScissorRectHardware( &GBASE.DrawArea ) ;
		}

		// eXe[WŎgpeNX`W̃Zbg
		D_ResetTextureCoord() ;
	
		// ݒ𔽉f
		RefreshBlendStateHardware() ;
		RefreshRenderStateHardware() ;
	}

	// tO|
	GRH.InitializeFlag = FALSE ;

	// I
	return 0 ;
}

// cRcc{ݒ
static int SetBaseHardwareState()
{
	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	if( GRH.InitializeFlag == FALSE )
	{
		// o
		RenderVertexHardware() ;
	}

	// At@ufBOJ[L[
//	GraphicsDevice_SetRenderState( D_D3DRS_COLORKEYBLENDENABLE, FALSE ) ;

	// Ō̃hbg`悵Ȃ
//	GraphicsDevice_SetRenderState( D_D3DRS_LASTPIXEL, TRUE ) ;

	// eNX``pݒ
	GraphicsDevice_SetSamplerState( 0, D_D3DSAMP_ADDRESSU, GRH.TexAddressModeU[ 0 ] ) ;
	GraphicsDevice_SetSamplerState( 0, D_D3DSAMP_ADDRESSV, GRH.TexAddressModeV[ 0 ] ) ;
	GraphicsDevice_SetSamplerState( 1, D_D3DSAMP_ADDRESSU, GRH.TexAddressModeU[ 1 ] ) ;
	GraphicsDevice_SetSamplerState( 1, D_D3DSAMP_ADDRESSV, GRH.TexAddressModeV[ 1 ] ) ;
	GraphicsDevice_SetSamplerState( 2, D_D3DSAMP_ADDRESSU, GRH.TexAddressModeU[ 2 ] ) ;
	GraphicsDevice_SetSamplerState( 2, D_D3DSAMP_ADDRESSV, GRH.TexAddressModeV[ 2 ] ) ;
	GraphicsDevice_SetSamplerState( 3, D_D3DSAMP_ADDRESSU, GRH.TexAddressModeU[ 3 ] ) ;
	GraphicsDevice_SetSamplerState( 3, D_D3DSAMP_ADDRESSV, GRH.TexAddressModeV[ 3 ] ) ;
	GraphicsDevice_SetTextureStageState( 0, D_D3DTSS_TEXCOORDINDEX, 0 ) ;
	GraphicsDevice_SetTextureStageState( 1, D_D3DTSS_TEXCOORDINDEX, 1 ) ;
	GraphicsDevice_SetTextureStageState( 2, D_D3DTSS_TEXCOORDINDEX, 1 ) ;
	GraphicsDevice_SetTextureStageState( 3, D_D3DTSS_TEXCOORDINDEX, 0 ) ;
	GRH.BlendInfo.TextureStageInfo[ 0 ].TextureCoordIndex = 0 ;
	GRH.BlendInfo.TextureStageInfo[ 1 ].TextureCoordIndex = 1 ;
	GRH.BlendInfo.TextureStageInfo[ 2 ].TextureCoordIndex = 1 ;
	GRH.BlendInfo.TextureStageInfo[ 3 ].TextureCoordIndex = 0 ;
	if( GRH.ValidTexTempRegFlag )
	{
		GraphicsDevice_SetTextureStageState( 0, D_D3DTSS_RESULTARG, D_D3DTA_CURRENT ) ;
		GraphicsDevice_SetTextureStageState( 1, D_D3DTSS_RESULTARG, D_D3DTA_CURRENT ) ;
		GraphicsDevice_SetTextureStageState( 2, D_D3DTSS_RESULTARG, D_D3DTA_CURRENT ) ;
		GraphicsDevice_SetTextureStageState( 3, D_D3DTSS_RESULTARG, D_D3DTA_CURRENT ) ;
		GRH.BlendInfo.TextureStageInfo[ 0 ].ResultTempARG = FALSE ;
		GRH.BlendInfo.TextureStageInfo[ 1 ].ResultTempARG = FALSE ;
		GRH.BlendInfo.TextureStageInfo[ 2 ].ResultTempARG = FALSE ;
		GRH.BlendInfo.TextureStageInfo[ 3 ].ResultTempARG = FALSE ;
	}

	// p[XyNeBuRNgݒ
//	GraphicsDevice_SetRenderState( D_D3DRS_TEXTUREPERSPECTIVE, GRH.PerspectiveFlag ) ;

	// VF[fBO[hݒ
	GraphicsDevice_SetRenderState( D_D3DRS_SHADEMODE, GRH.ShadeMode ) ;

	// CeBOݒ
	GraphicsDevice_SetRenderState( D_D3DRS_LIGHTING, GRH.LightFlag ) ;

	// JOݒ
	GraphicsDevice_SetRenderState( D_D3DRS_CULLMODE, D_D3DCULL_NONE ) ;

	// fBUOnee
	GraphicsDevice_SetRenderState( D_D3DRS_DITHERENABLE, FALSE ) ;
	
	// VF[_[̒萔Zbg
	static float ZeroOne[ 4 ]        = { 0.0f, 1.0f, 0.0f, 0.0f } ;
	static float ZeroHalfOneTwo[ 4 ] = { 0.0f, 0.5f, 1.0f, 2.0f } ;
	SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_VS_FLOAT, DX_SHADERCONSTANTSET_LIB, DX_VS_CONSTF_ZERO_ONE,         ZeroOne,        1, TRUE ) ;
	SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB, DX_PS_CONSTF_ZERO_HALF_ONE_TWO, ZeroHalfOneTwo, 1, TRUE ) ;

	// Œ@\pCvCɖ߂
	if( GRH.SetVS )
	{
		GraphicsDevice_SetVertexShader( NULL ) ;
		GRH.SetVS = NULL ;
		GRH.SetVD = NULL ;
	}

	if( GRH.SetPS )
	{
		GraphicsDevice_SetPixelShader( NULL ) ;
		GRH.SetPS = NULL ;
		GRH.NormalPS = FALSE ;
		GRH.DrawPrepAlwaysFlag = TRUE ;
	}
	GRH.SetFVF = 0 ;
	GRH.SetIB = NULL ;
	GRH.SetVB = NULL ;

	// I
	return 0 ;
}




// uhe[u(fobOp)
static const char *__BufferBlendName[] =
{
	NULL,
	"D3DBLEND_ZERO",
	"D3DBLEND_ONE",
	"D3DBLEND_SRCCOLOR",
	"D3DBLEND_INVSRCCOLOR",
	"D3DBLEND_SRCALPHA",
	"D3DBLEND_INVSRCALPHA",
	"D3DBLEND_DESTALPHA",
	"D3DBLEND_INVDESTALPHA",
	"D3DBLEND_DESTCOLOR",
	"D3DBLEND_INVDESTCOLOR",
	"D3DBLEND_SRCALPHASAT",
	"D3DBLEND_BOTHSRCALPHA",
	"D3DBLEND_BOTHINVSRCALPHA",
} ;

// vfe[u(fobOp)
static const char *__TextureStage_ARGName[] =
{
	"D3DTA_DIFFUSE",
	"D3DTA_CURRENT",
	"D3DTA_TEXTURE",
	"D3DTA_TFACTOR",
} ;

// uhe[u(fobOp)
static const char *__TextureStage_OPName[] =
{
	NULL, 
	"D3DTOP_DISABLE",
	"D3DTOP_SELECTARG1",
	"D3DTOP_SELECTARG2",

	"D3DTOP_MODULATE",
	"D3DTOP_MODULATE2X",
	"D3DTOP_MODULATE4X",

	"D3DTOP_ADD",
	"D3DTOP_ADDSIGNED",
	"D3DTOP_ADDSIGNED2X",
	"D3DTOP_SUBTRACT",
	"D3DTOP_ADDSMOOTH",

	"D3DTOP_BLENDDIFFUSEALPHA",
	"D3DTOP_BLENDTEXTUREALPHA",
	"D3DTOP_BLENDFACTORALPHA",

	"D3DTOP_BLENDTEXTUREALPHAPM",
	"D3DTOP_BLENDCURRENTALPHA",

	"D3DTOP_PREMODULATE",
	"D3DTOP_MODULATEALPHA_ADDCOLOR",
	"D3DTOP_MODULATECOLOR_ADDALPHA",
	"D3DTOP_MODULATEINVALPHA_ADDCOLOR",
	"D3DTOP_MODULATEINVCOLOR_ADDALPHA",

	"D3DTOP_BUMPENVMAP",
	"D3DTOP_BUMPENVMAPLUMINANCE",
	"D3DTOP_DOTPRODUCT3",
} ;


// qfaluhXe[ge[u
// [uh[hl]
// [
//   0:DESTBLEND
//   1:SRCBLEND
//   2:gpeNX`uhe[u( TEXTURE_BLEND_TABLE_INDEX_NORMAL  )
//   3:gpBLENDOP
//   4:uh@\gp邩ǂ( 1:gp 0:gpȂ )
//   5:`l݂̑`̏ꍇɃsNZVF[_[gpuhsǂ( 1:s  0:sȂ )
// ]
#define RGB_BLENDSTATE_TABLE_DESTBLEND				(0)
#define RGB_BLENDSTATE_TABLE_SRCBLEND				(1)
#define RGB_BLENDSTATE_TABLE_TEXBLENDTABLEINDEX		(2)
#define RGB_BLENDSTATE_TABLE_BLENDOP				(3)
#define RGB_BLENDSTATE_TABLE_ALPHABLENDENABLE		(4)
#define RGB_BLENDSTATE_TABLE_SHADERALPHABLEND		(5)

#define TEXTURE_BLEND_TABLE_INDEX_NORMAL			(0)			// 0:ʏ`
#define TEXTURE_BLEND_TABLE_INDEX_MUL				(1)			// 1:Z`
#define TEXTURE_BLEND_TABLE_INDEX_INVERSE			(2)			// 2:RGB]
#define TEXTURE_BLEND_TABLE_INDEX_X4				(3)			// 3:`Px4{
#define TEXTURE_BLEND_TABLE_INDEX_PMA_NORMAL		(4)			// 4:Zς݃uh[h̒ʏ`
#define TEXTURE_BLEND_TABLE_INDEX_PMA_INVERSE		(5)			// 5:Zς݃uh[hRGB]
#define TEXTURE_BLEND_TABLE_INDEX_PMA_X4			(6)			// 6:Zς݃uh[h̕`Px4{
#define TEXTURE_BLEND_TABLE_INDEX_NUM				(7)
static const int __RGBBlendStateTable[ DX_BLENDMODE_NUM ][ 6 ] =
{
	{ -1,						-1,							0, D_D3DBLENDOP_ADD,			0, 0 },	// DX_BLENDMODE_NOBLEND			m[uh
	{ D_D3DBLEND_INVSRCALPHA,	D_D3DBLEND_SRCALPHA,		0, D_D3DBLENDOP_ADD,			1, 1 },	// DX_BLENDMODE_ALPHA			uh
	{ D_D3DBLEND_ONE,			D_D3DBLEND_SRCALPHA,		0, D_D3DBLENDOP_ADD,			1, 0 },	// DX_BLENDMODE_ADD				Zuh
	{ D_D3DBLEND_ZERO,			D_D3DBLEND_INVDESTCOLOR,	0, D_D3DBLENDOP_ADD,			1, 0 },	// DX_BLENDMODE_SUB				Zuh
	{ D_D3DBLEND_SRCCOLOR,		D_D3DBLEND_ZERO,			0, D_D3DBLENDOP_ADD,			1, 0 },	// DX_BLENDMODE_MUL				Zuh
	{ D_D3DBLEND_ONE,			D_D3DBLEND_SRCALPHA,		0, D_D3DBLENDOP_ADD,			1, 0 },	// DX_BLENDMODE_SUB2			pZuhP
	{ -1,						-1,							0, D_D3DBLENDOP_ADD,			0, 0 },	// DX_BLENDMODE_XOR				XORuh(Ή)
	{ -1,						-1,							0, D_D3DBLENDOP_ADD,			0, 0 },	// 
	{ D_D3DBLEND_ONE,			D_D3DBLEND_ZERO,			0, D_D3DBLENDOP_ADD,			1, 0 },	// DX_BLENDMODE_DESTCOLOR		J[͍XVȂ
	{ D_D3DBLEND_ZERO,			D_D3DBLEND_INVDESTCOLOR,	0, D_D3DBLENDOP_ADD,			1, 0 },	// DX_BLENDMODE_INVDESTCOLOR	`̐F̔]l|
	{ D_D3DBLEND_INVSRCALPHA,	D_D3DBLEND_SRCALPHA,		2, D_D3DBLENDOP_ADD,			1, 1 },	// DX_BLENDMODE_INVSRC			`挳̐F𔽓]
	{ D_D3DBLEND_SRCCOLOR,		D_D3DBLEND_ZERO,			1, D_D3DBLENDOP_ADD,			1, 0 },	// DX_BLENDMODE_MULA			At@`lltZuh
	{ D_D3DBLEND_INVSRCALPHA,	D_D3DBLEND_SRCALPHA,		3, D_D3DBLENDOP_ADD,			1, 1 },	// DX_BLENDMODE_ALPHA_X4		uh̕`摤̋PxőS{ɂł郂[h
	{ D_D3DBLEND_ONE,			D_D3DBLEND_SRCALPHA,		3, D_D3DBLENDOP_ADD,			1, 0 },	// DX_BLENDMODE_ADD_X4			Zuh̕`摤̋PxőS{ɂł郂[h
	{ D_D3DBLEND_ZERO,			D_D3DBLEND_ONE,				0, D_D3DBLENDOP_ADD,			1, 0 },	// DX_BLENDMODE_SRCCOLOR		`挳̃J[ł̂܂ܕ`悳
	{ D_D3DBLEND_INVSRCALPHA,	D_D3DBLEND_ONE,				0, D_D3DBLENDOP_ADD,			1, 0 },	// DX_BLENDMODE_HALF_ADD		Zuh
	{ D_D3DBLEND_ONE,			D_D3DBLEND_SRCALPHA,		0, D_D3DBLENDOP_REVSUBTRACT,	1, 0 },	// DX_BLENDMODE_SUB1			o̓uhgp\ȏꍇ̌Zuh

	{ D_D3DBLEND_INVSRCALPHA,	D_D3DBLEND_ONE,				4, D_D3DBLENDOP_ADD,			1 },	// DX_BLENDMODE_PMA_ALPHA		Zς݃uh[h̃uh
	{ D_D3DBLEND_ONE,			D_D3DBLEND_ONE,				4, D_D3DBLENDOP_ADD,			1 },	// DX_BLENDMODE_PMA_ADD			Zς݃uh[h̉Zuh
	{ D_D3DBLEND_ONE,			D_D3DBLEND_ONE,				4, D_D3DBLENDOP_REVSUBTRACT,	1 },	// DX_BLENDMODE_PMA_SUB			Zς݃uh[ȟZuh
	{ D_D3DBLEND_INVSRCALPHA,	D_D3DBLEND_ONE,				5, D_D3DBLENDOP_ADD,			1 },	// DX_BLENDMODE_PMA_INVSRC		Zς݃uh[h̕`挳̐F𔽓]
	{ D_D3DBLEND_INVSRCALPHA,	D_D3DBLEND_ONE,				6, D_D3DBLENDOP_ADD,			1 },	// DX_BLENDMODE_PMA_ALPHA_X4	Zς݃uh[h̃uh̕`摤̋PxőS{ɂł郂[h
	{ D_D3DBLEND_ONE,			D_D3DBLEND_ONE,				6, D_D3DBLENDOP_ADD,			1 },	// DX_BLENDMODE_PMA_ADD_X4		Zς݃uh[h̉Zuh̕`摤̋PxőS{ɂł郂[h
} ;

// `luhXe[ge[u[uh[hl][ 0:DESTBLEND  1:SRCBLEND  2:VF[_[uhgp邩( 0:gpȂ  1:gp )  3:gpBLENDOP ]
#define ALPHA_BLENDSTATE_TABLE_DESTBLEND			(0)
#define ALPHA_BLENDSTATE_TABLE_SRCBLEND				(1)
#define ALPHA_BLENDSTATE_TABLE_USESHADERBLEND		(2)
#define ALPHA_BLENDSTATE_TABLE_BLENDOP				(3)
static const int __ABlendStateTable[ DX_BLENDMODE_NUM ][ 4 ] =
{
	{ -1,						-1,							0, D_D3DBLENDOP_ADD			},  // DX_BLENDMODE_NOBLEND			m[uh
	{ -1,						-1,							1, D_D3DBLENDOP_ADD			},	// DX_BLENDMODE_ALPHA			uh
	{ D_D3DBLEND_ONE,			D_D3DBLEND_ZERO,			0, D_D3DBLENDOP_ADD			},	// DX_BLENDMODE_ADD				Zuh
	{ D_D3DBLEND_ONE,			D_D3DBLEND_ZERO,			0, D_D3DBLENDOP_ADD			},	// DX_BLENDMODE_SUB				Zuh
	{ D_D3DBLEND_ONE,			D_D3DBLEND_ZERO,			0, D_D3DBLENDOP_ADD			},	// DX_BLENDMODE_MUL				Zuh
	{ D_D3DBLEND_ONE,			D_D3DBLEND_ZERO,			0, D_D3DBLENDOP_ADD			},	// DX_BLENDMODE_SUB2			pZuhP
	{ -1,						-1,							0, D_D3DBLENDOP_ADD			},	// DX_BLENDMODE_XOR				XORuh(Ή)
	{ -1,						-1,							0, D_D3DBLENDOP_ADD			},	// 
	{ D_D3DBLEND_ONE,			D_D3DBLEND_ZERO,			0, D_D3DBLENDOP_ADD			},	// DX_BLENDMODE_DESTCOLOR		J[͍XVȂ
	{ D_D3DBLEND_ONE,			D_D3DBLEND_ZERO,			0, D_D3DBLENDOP_ADD			},	// DX_BLENDMODE_INVDESTCOLOR	`̐F̔]l|
	{ -1,						-1,							1, D_D3DBLENDOP_ADD			},	// DX_BLENDMODE_INVSRC			`挳̐F𔽓]
	{ D_D3DBLEND_ONE,			D_D3DBLEND_ZERO,			0, D_D3DBLENDOP_ADD			},	// DX_BLENDMODE_MULA			At@`lltZuh
	{ -1,						-1,							1, D_D3DBLENDOP_ADD			},	// DX_BLENDMODE_ALPHA_X4		uh̕`摤̋PxőS{ɂł郂[h
	{ D_D3DBLEND_ONE,			D_D3DBLEND_ZERO,			0, D_D3DBLENDOP_ADD			},	// DX_BLENDMODE_ADD_X4			Zuh̕`摤̋PxőS{ɂł郂[h
	{ D_D3DBLEND_ZERO,			D_D3DBLEND_ONE,				0, D_D3DBLENDOP_ADD			},	// DX_BLENDMODE_SRCCOLOR		`挳̃J[ł̂܂ܕ`悳
	{ D_D3DBLEND_INVSRCALPHA,	D_D3DBLEND_ONE,				0, D_D3DBLENDOP_ADD			},	// DX_BLENDMODE_HALF_ADD		Zuh
	{ D_D3DBLEND_ONE,			D_D3DBLEND_ZERO,			0, D_D3DBLENDOP_ADD			},	// DX_BLENDMODE_SUB1			o̓uhgp\ȏꍇ̌Zuh

	{ D_D3DBLEND_INVSRCALPHA,	D_D3DBLEND_ONE,				0, D_D3DBLENDOP_ADD			},	// DX_BLENDMODE_PMA_ALPHA		Zς݃uh[h̃uh
	{ D_D3DBLEND_ONE,			D_D3DBLEND_ONE,				0, D_D3DBLENDOP_ADD			},	// DX_BLENDMODE_PMA_ADD			Zς݃uh[h̉Zuh
	{ D_D3DBLEND_ONE,			D_D3DBLEND_ONE,				0, D_D3DBLENDOP_REVSUBTRACT },	// DX_BLENDMODE_PMA_SUB			Zς݃uh[ȟZuh
	{ D_D3DBLEND_INVSRCALPHA,	D_D3DBLEND_ONE,				0, D_D3DBLENDOP_ADD			},	// DX_BLENDMODE_PMA_INVSRC		Zς݃uh[h̕`挳̐F𔽓]
	{ D_D3DBLEND_INVSRCALPHA,	D_D3DBLEND_ONE,				0, D_D3DBLENDOP_ADD			},	// DX_BLENDMODE_PMA_ALPHA_X4	Zς݃uh[h̃uh̕`摤̋PxőS{ɂł郂[h
	{ D_D3DBLEND_ONE,			D_D3DBLEND_ONE,				0, D_D3DBLENDOP_ADD			},	// DX_BLENDMODE_PMA_ADD_X4		Zς݃uh[h̉Zuh̕`摤̋PxőS{ɂł郂[h
} ;

#define __NONE		(-1)

#define __DIFF		D_D3DTA_DIFFUSE
#define __CURR		D_D3DTA_CURRENT
#define __TEX_		D_D3DTA_TEXTURE
#define __FACT		D_D3DTA_TFACTOR
#define __SPEC		D_D3DTA_SPECULAR
#define __COMP		D_D3DTA_COMPLEMENT
#define __ALRP		D_D3DTA_ALPHAREPLICATE
#define __TEMP		D_D3DTA_TEMP

#define __DISB		D_D3DTOP_DISABLE
#define __SEL1		D_D3DTOP_SELECTARG1
#define __SEL2		D_D3DTOP_SELECTARG2
#define __MUL1		D_D3DTOP_MODULATE
#define __MUL2		D_D3DTOP_MODULATE2X
#define __MUL4		D_D3DTOP_MODULATE4X
#define __ADD1		D_D3DTOP_ADD
#define __SUB1		D_D3DTOP_SUBTRACT
#define __BLDC		D_D3DTOP_BLENDCURRENTALPHA 
#define __BLDF		D_D3DTOP_BLENDFACTORALPHA 

#define __NUM(x)	((void *)(x))
#define DISB_ST		{NULL, -1, -1, __NONE,__NONE,__DISB,	__NONE,__NONE,__DISB},

// ZuhpXe[g
static const DIRECT3DTEXTURESTAGEINFO __TexSubBlendStageStateTable[USE_TEXTURESTAGE_NUM] =
{
	/*Stage0*/{__NUM(1),0,0,__NONE,__DIFF,__SEL2,	__DIFF,__NONE,__SEL1},
	/*Stage1*/{    NULL,0,0,__NONE,__NONE,__DISB,	__NONE,__NONE,__DISB},
	/*Stage2*/{    NULL,0,0,__NONE,__NONE,__DISB,	__NONE,__NONE,__DISB},
	/*Stage3*/{    NULL,0,0,__NONE,__NONE,__DISB,	__NONE,__NONE,__DISB},
} ;

// eNX`[Xe[WXe[g
//0:[0:ʏ` 1:MUL 2:RGB] 3:`Px4{ 4:Zς݃uh[h̒ʏ` 5:Zς݃uh[hRGB] 6:Zς݃uh[h̕`Px4{]
//1:[0:uheNX`  1:DX_BLENDGRAPHTYPE_NORMAL  2:DX_BLENDGRAPHTYPE_WIPE  3:DX_BLENDGRAPHTYPE_ALPHA ]
//2:[0:fBt[YRGBJ[  1:fBt[YRGBJ[]
//3:[0:fBt[YAlphaJ[  1:fBt[YAlphaJ[]
//4:[0:`l@1:`l  2:eXg]
//5:[ eNX`[Xe[Wio[ ]
static const DIRECT3DTEXTURESTAGEINFO __TexStageStateTable[ TEXTURE_BLEND_TABLE_INDEX_NUM ][4][2][2][3][USE_TEXTURESTAGE_NUM] =
{
	// ʏ`
	{
		// uheNX`
		{
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__NONE,__DIFF,__SEL2,	__TEX_,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//eXg
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__NONE,__DIFF,__SEL2,	__TEX_,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__DIFF,__MUL1,	__TEX_,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__DIFF,__MUL1,	__TEX_,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[Ȃ
				{
					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__NONE,__DIFF,__SEL2,	__TEX_,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__NONE,__SEL1,	__TEX_,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__NONE,__SEL1,	__TEX_,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__NONE,__DIFF,__SEL2,	__TEX_,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__DIFF,__MUL1,	__TEX_,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__DIFF,__MUL1,	__TEX_,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
		},
		//uheNX` DX_BLENDGRAPHTYPE_NORMAL
		{
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_,__BLDF}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_,__BLDF}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_,__BLDF}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
		},
		//uheNX` DX_BLENDGRAPHTYPE_WIPE
		{
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__FACT,__MUL1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __CURR,__DIFF,__MUL1,	__TEX_,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __SPEC,__CURR,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __DIFF,__CURR,__MUL1,	__TEX_,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(4), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __SPEC,__CURR,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_,__NONE,__SEL1},
						/*Stage3*/{    NULL, 0, 0, __DIFF,__CURR,__MUL1,	__CURR,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_,__NONE,__SEL1},
						/*Stage2*/{    NULL, 1, 0, __DIFF,__CURR,__MUL1,	__CURR,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __CURR,__DIFF,__MUL1,	__TEX_,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __SPEC,__CURR,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __DIFF,__CURR,__MUL1,	__TEX_,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(4), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __SPEC,__CURR,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_,__DIFF,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __DIFF,__CURR,__MUL1,	__CURR,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_,__DIFF,__MUL1},
						/*Stage2*/{    NULL, 1, 0, __DIFF,__CURR,__MUL1,	__CURR,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
		},
		//uheNX` DX_BLENDGRAPHTYPE_ALPHA
		{
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(2), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(2), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(3), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(3), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(3), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
		},
	},

	// MUL`
	{
		// uheNX`
		{
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __NONE,__DIFF,__SEL2,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__NONE,__SEL1,	__CURR,__FACT,__BLDC}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__NONE,__SEL1,	__CURR,__FACT,__BLDC}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//eXg
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__NONE,__SEL1,	__CURR,__FACT,__BLDC}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __NONE,__DIFF,__SEL2,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__NONE,__SEL1,	__CURR,__FACT,__BLDC}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__DIFF,__MUL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__NONE,__SEL1,	__CURR,__FACT,__BLDC}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__DIFF,__MUL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__NONE,__SEL1,	__CURR,__FACT,__BLDC}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[Ȃ
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __NONE,__DIFF,__SEL2,	__TEX_,__DIFF,__MUL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__NONE,__SEL1,	__CURR,__FACT,__BLDC}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__DIFF,__MUL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__NONE,__SEL1,	__CURR,__FACT,__BLDC}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__DIFF,__MUL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__NONE,__SEL1,	__CURR,__FACT,__BLDC}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __NONE,__DIFF,__SEL2,	__TEX_,__DIFF,__MUL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__NONE,__SEL1,	__CURR,__FACT,__BLDC}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__DIFF,__MUL1,	__TEX_,__DIFF,__MUL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__NONE,__SEL1,	__CURR,__FACT,__BLDC}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__DIFF,__MUL1,	__TEX_,__DIFF,__MUL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__NONE,__SEL1,	__CURR,__FACT,__BLDC}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
		},
		//uheNX` DX_BLENDGRAPHTYPE_NORMAL
		{
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
		},
		//uheNX` DX_BLENDGRAPHTYPE_WIPE
		{
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
		},
		//uheNX` DX_BLENDGRAPHTYPE_ALPHA
		{
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						 DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
		},
	},

	// RGB]
	{
		// uheNX`
		{
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__NONE,__DIFF,__SEL2,	__TEX_ | __COMP,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__NONE,__SEL1,	__TEX_ | __COMP,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//eXg
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__NONE,__SEL1,	__TEX_ | __COMP,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__NONE,__DIFF,__SEL2,	__TEX_ | __COMP,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__DIFF,__MUL1,	__TEX_ | __COMP,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__DIFF,__MUL1,	__TEX_ | __COMP,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[Ȃ
				{
					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0, __NONE,__DIFF,__SEL2,	__TEX_ | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_ | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(1), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_ | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0, __NONE,__DIFF,__SEL2,	__TEX_ | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0, __TEX_,__DIFF,__MUL1,	__TEX_ | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(1), 0, 0, __TEX_,__DIFF,__MUL1,	__TEX_ | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
		},
		//uheNX` DX_BLENDGRAPHTYPE_NORMAL
		{
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
		},
		//uheNX` DX_BLENDGRAPHTYPE_WIPE
		{
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __DIFF,__CURR,__MUL1,	__TEX_ | __COMP,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __SPEC,__CURR,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_ | __COMP,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_ | __COMP,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __DIFF,__CURR,__MUL1,	__TEX_ | __COMP,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(4), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __SPEC,__CURR,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_ | __COMP,__NONE,__SEL1},
						/*Stage3*/{    NULL, 0, 0, __DIFF,__CURR,__MUL1,	__CURR,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_ | __COMP,__NONE,__SEL1},
						/*Stage2*/{    NULL, 1, 0, __DIFF,__CURR,__MUL1,	__CURR,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __CURR,__DIFF,__MUL1,	__TEX_ | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __SPEC,__CURR,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_ | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_ | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __DIFF,__CURR,__MUL1,	__TEX_ | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(4), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __SPEC,__CURR,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_ | __COMP,__DIFF,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __DIFF,__CURR,__MUL1,	__CURR,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_ | __COMP,__DIFF,__MUL1},
						/*Stage2*/{    NULL, 1, 0, __DIFF,__CURR,__MUL1,	__CURR,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
		},
		//uheNX` DX_BLENDGRAPHTYPE_ALPHA
		{
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
		},
	},

	// `PxS{
	{
		// uheNX`
		{
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__NONE,__DIFF,__SEL2,	__TEX_,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__NONE,__SEL1,	__TEX_,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//eXg
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__NONE,__SEL1,	__TEX_,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__NONE,__DIFF,__SEL2,	__TEX_,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__DIFF,__MUL1,	__TEX_,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__DIFF,__MUL1,	__TEX_,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[Ȃ
				{
					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__NONE,__DIFF,__SEL2,	__TEX_,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__NONE,__SEL1,	__TEX_,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__NONE,__SEL1,	__TEX_,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__NONE,__DIFF,__SEL2,	__TEX_,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__DIFF,__MUL1,	__TEX_,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__DIFF,__MUL1,	__TEX_,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
		},
		//uheNX` DX_BLENDGRAPHTYPE_NORMAL
		{
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(5), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__SUB1,	__CURR,__TEX_,__SUB1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__FACT,__MUL1,	__CURR,__FACT,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__TEX_,__ADD1,	__CURR,__TEX_,__ADD1},
						/*Stage4*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(5), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__SUB1,	__CURR,__TEX_,__SUB1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__FACT,__MUL1,	__CURR,__FACT,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__TEX_,__ADD1,	__CURR,__TEX_,__ADD1},
						/*Stage4*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(5), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__SUB1,	__CURR,__TEX_,__SUB1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__FACT,__MUL1,	__CURR,__FACT,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__TEX_,__ADD1,	__CURR,__TEX_,__ADD1},
						/*Stage4*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(5), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__SUB1,	__CURR,__TEX_,__SUB1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__FACT,__MUL1,	__CURR,__FACT,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__TEX_,__ADD1,	__CURR,__TEX_,__ADD1},
						/*Stage4*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(5), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__SUB1,	__CURR,__TEX_,__SUB1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__FACT,__MUL1,	__CURR,__FACT,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__TEX_,__ADD1,	__CURR,__TEX_,__ADD1},
						/*Stage4*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(5), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__SUB1,	__CURR,__TEX_,__SUB1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__FACT,__MUL1,	__CURR,__FACT,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__TEX_,__ADD1,	__CURR,__TEX_,__ADD1},
						/*Stage4*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST
					},
				},
			},
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(5), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__SUB1,	__CURR,__TEX_,__SUB1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__FACT,__MUL1,	__CURR,__FACT,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__TEX_,__ADD1,	__CURR,__TEX_,__ADD1},
						/*Stage4*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(5), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__SUB1,	__CURR,__TEX_,__SUB1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__FACT,__MUL1,	__CURR,__FACT,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__TEX_,__ADD1,	__CURR,__TEX_,__ADD1},
						/*Stage4*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(5), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__SUB1,	__CURR,__TEX_,__SUB1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__FACT,__MUL1,	__CURR,__FACT,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__TEX_,__ADD1,	__CURR,__TEX_,__ADD1},
						/*Stage4*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(5), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__SUB1,	__CURR,__TEX_,__SUB1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__FACT,__MUL1,	__CURR,__FACT,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__TEX_,__ADD1,	__CURR,__TEX_,__ADD1},
						/*Stage4*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(5), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__SUB1,	__CURR,__TEX_,__SUB1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__FACT,__MUL1,	__CURR,__FACT,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__TEX_,__ADD1,	__CURR,__TEX_,__ADD1},
						/*Stage4*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(5), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__SUB1,	__CURR,__TEX_,__SUB1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__FACT,__MUL1,	__CURR,__FACT,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__TEX_,__ADD1,	__CURR,__TEX_,__ADD1},
						/*Stage4*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST
					},
				},
			},
		},
		//uheNX` DX_BLENDGRAPHTYPE_WIPE
		{
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __CURR,__DIFF,__MUL1,	__TEX_,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __SPEC,__CURR,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __DIFF,__CURR,__MUL1,	__TEX_,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(4), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __SPEC,__CURR,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_,__DIFF,__MUL4},
						/*Stage3*/{    NULL, 0, 0, __DIFF,__CURR,__MUL1,	__CURR,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_,__DIFF,__MUL4},
						/*Stage2*/{    NULL, 1, 0, __DIFF,__CURR,__MUL1,	__CURR,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __CURR,__DIFF,__MUL1,	__TEX_,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __SPEC,__CURR,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __DIFF,__CURR,__MUL1,	__TEX_,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(4), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __SPEC,__CURR,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_,__DIFF,__MUL4},
						/*Stage3*/{    NULL, 0, 0, __DIFF,__CURR,__MUL1,	__CURR,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_,__DIFF,__MUL4},
						/*Stage2*/{    NULL, 1, 0, __DIFF,__CURR,__MUL1,	__CURR,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
		},
		//uheNX` DX_BLENDGRAPHTYPE_ALPHA
		{
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
		},
	},

	// Zς݃uh[h̒ʏ`
	{
		// uheNX`
		{
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__NONE,__DIFF,__SEL2,	__TEX_,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//eXg
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__NONE,__DIFF,__SEL2,	__TEX_,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__DIFF,__MUL1,	__TEX_,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__DIFF,__MUL1,	__TEX_,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[Ȃ
				{
					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__NONE,__DIFF,__SEL2,	__TEX_,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__NONE,__SEL1,	__TEX_,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__NONE,__SEL1,	__TEX_,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0,__NONE,__DIFF,__SEL2,	__TEX_,__DIFF         ,__MUL1},
						/*Stage1*/{       0, 0, 0,__CURR,__NONE,__SEL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0,__TEX_,__DIFF,__MUL1,	__TEX_,__DIFF         ,__MUL1},
						/*Stage1*/{       0, 0, 0,__CURR,__NONE,__SEL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(2), 0, 0,__TEX_,__DIFF,__MUL1,	__TEX_,__DIFF         ,__MUL1},
						/*Stage1*/{       0, 0, 0,__CURR,__NONE,__SEL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
		},
		//uheNX` DX_BLENDGRAPHTYPE_NORMAL
		{
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_,__BLDF}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_,__BLDF}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_,__BLDF}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE         ,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_         ,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE         ,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_         ,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE         ,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_         ,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(4), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE         ,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_         ,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF         ,__MUL1}, 
						/*Stage3*/{    NULL, 0, 0, __CURR,__NONE,__SEL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(4), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE         ,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_         ,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF         ,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__NONE,__SEL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(4), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE         ,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR,__TEX_         ,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF         ,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__NONE,__SEL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
		},
		//uheNX` DX_BLENDGRAPHTYPE_WIPE
		{
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__FACT,__MUL1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __CURR,__DIFF,__MUL1,	__TEX_,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __SPEC,__CURR,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF         ,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __DIFF,__CURR,__MUL1,	__TEX_,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(4), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF         ,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __SPEC,__CURR,__MUL1,	__CURR,__NONE         ,__SEL1},
						/*Stage2*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_,__DIFF | __ALRP,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __DIFF,__CURR,__MUL1,	__CURR,__NONE         ,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF         ,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_,__DIFF | __ALRP,__MUL1},
						/*Stage2*/{    NULL, 1, 0, __DIFF,__CURR,__MUL1,	__CURR,__NONE         ,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __CURR,__DIFF,__MUL1,	__TEX_,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __SPEC,__CURR,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF         ,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __DIFF,__CURR,__MUL1,	__TEX_,__DIFF         ,__MUL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__NONE,__SEL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(4), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF         ,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __SPEC,__CURR,__MUL1,	__CURR,__NONE         ,__SEL1},
						/*Stage2*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_,__DIFF         ,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __DIFF,__CURR,__MUL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF         ,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_,__DIFF         ,__MUL1},
						/*Stage2*/{    NULL, 1, 0, __DIFF,__CURR,__MUL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
		},
		//uheNX` DX_BLENDGRAPHTYPE_ALPHA
		{
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(2), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(2), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(3), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__DIFF | __ALRP,__MUL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE         ,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF         ,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__DIFF | __ALRP,__MUL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE         ,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF         ,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__DIFF | __ALRP,__MUL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE         ,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF         ,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(3), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(3), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__DIFF | __ALRP,__MUL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE         ,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF         ,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__DIFF | __ALRP,__MUL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE         ,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF         ,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__DIFF | __ALRP,__MUL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE         ,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF         ,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
		},
	},

	// Zς݃uh[hRGB]
	{
		// uheNX`
		{
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__NONE,__DIFF,__SEL2,	__TEX_ | __COMP,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__NONE,__SEL1,	__TEX_ | __COMP,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//eXg
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__NONE,__SEL1,	__TEX_ | __COMP,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__NONE,__DIFF,__SEL2,	__TEX_ | __COMP,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__DIFF,__MUL1,	__TEX_ | __COMP,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__DIFF,__MUL1,	__TEX_ | __COMP,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[Ȃ
				{
					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0, __NONE,__DIFF,__SEL2,	__TEX_ | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_ | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(1), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_ | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __NONE,__DIFF,__SEL2,	__TEX_ | __COMP,__DIFF         ,__MUL1}, 
						/*Stage1*/{       0, 0, 0, __CURR,__NONE,__SEL1,	__CURR         ,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__DIFF,__MUL1,	__TEX_ | __COMP,__DIFF         ,__MUL1},
						/*Stage1*/{       0, 0, 0, __CURR,__NONE,__SEL1,	__CURR         ,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__DIFF,__MUL1,	__TEX_ | __COMP,__DIFF         ,__MUL1},
						/*Stage1*/{       0, 0, 0, __CURR,__NONE,__SEL1,	__CURR         ,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
		},
		//uheNX` DX_BLENDGRAPHTYPE_NORMAL
		{
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_         ,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR         ,__TEX_,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_         ,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR         ,__TEX_,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_         ,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR         ,__TEX_,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_         ,__NONE         ,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR         ,__TEX_         ,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_         ,__NONE         ,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR         ,__TEX_         ,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_         ,__NONE         ,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR         ,__TEX_         ,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_         ,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR         ,__TEX_,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_         ,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR         ,__TEX_,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_         ,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR         ,__TEX_,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(4), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_         ,__NONE         ,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR         ,__TEX_         ,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF         ,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__NONE,__SEL1,	__CURR         ,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(4), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_         ,__NONE         ,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR         ,__TEX_         ,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF         ,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__NONE,__SEL1,	__CURR         ,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(4), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_         ,__NONE         ,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__BLDF,	__CURR         ,__TEX_         ,__BLDF},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF         ,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__NONE,__SEL1,	__CURR         ,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
		},
		//uheNX` DX_BLENDGRAPHTYPE_WIPE
		{
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__FACT,__ADD1,	__NONE         ,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __DIFF,__CURR,__MUL1,	__TEX_ | __COMP,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__FACT,__ADD1,	__NONE         ,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __SPEC,__CURR,__MUL1,	__CURR         ,__NONE,__SEL1},
						/*Stage2*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_ | __COMP,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__FACT,__ADD1,	__NONE         ,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_ | __COMP,__NONE,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__FACT,__ADD1,	__NONE         ,__DIFF         ,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __DIFF,__CURR,__MUL1,	__TEX_ | __COMP,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(4), 0, 0, __TEX_,__FACT,__ADD1,	__NONE         ,__DIFF         ,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __SPEC,__CURR,__MUL1,	__CURR         ,__NONE         ,__SEL1},
						/*Stage2*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_ | __COMP,__DIFF | __ALRP,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __DIFF,__CURR,__MUL1,	__CURR         ,__NONE         ,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__FACT,__ADD1,	__NONE         ,__DIFF         ,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_ | __COMP,__DIFF | __ALRP,__MUL1},
						/*Stage2*/{    NULL, 1, 0, __DIFF,__CURR,__MUL1,	__CURR         ,__NONE         ,__SEL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__FACT,__ADD1,	__NONE         ,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __CURR,__DIFF,__MUL1,	__TEX_ | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__FACT,__ADD1,	__NONE         ,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __SPEC,__CURR,__MUL1,	__CURR         ,__NONE,__SEL1},
						/*Stage2*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_ | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__FACT,__ADD1,	__NONE         ,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_ | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__FACT,__ADD1,	__NONE         ,__DIFF         ,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __DIFF,__CURR,__MUL1,	__TEX_ | __COMP,__DIFF         ,__MUL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__CURR,__SEL1,	__CURR         ,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(4), 0, 0, __TEX_,__FACT,__ADD1,	__NONE         ,__DIFF         ,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __SPEC,__CURR,__MUL1,	__CURR         ,__NONE         ,__SEL1},
						/*Stage2*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_ | __COMP,__DIFF         ,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __DIFF,__CURR,__MUL1,	__CURR         ,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__FACT,__ADD1,	__NONE         ,__DIFF         ,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_ | __COMP,__DIFF         ,__MUL1},
						/*Stage2*/{    NULL, 1, 0, __DIFF,__CURR,__MUL1,	__CURR         ,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
		},
		//uheNX` DX_BLENDGRAPHTYPE_ALPHA
		{
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_         ,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR         ,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_         ,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR         ,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_         ,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR         ,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(4), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_         ,__NONE         ,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR         ,__NONE         ,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF         ,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__NONE,__SEL1,	__CURR         ,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(4), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_         ,__NONE         ,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR         ,__NONE         ,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF         ,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__NONE,__SEL1,	__CURR         ,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(4), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_         ,__NONE         ,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR         ,__NONE         ,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF         ,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__NONE,__SEL1,	__CURR         ,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_         ,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR         ,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_         ,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR         ,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_         ,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR         ,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(4), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_         ,__NONE         ,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR         ,__NONE         ,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF         ,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__NONE,__SEL1,	__CURR         ,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(4), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_         ,__NONE         ,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR         ,__NONE         ,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF         ,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__NONE,__SEL1,	__CURR         ,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(4), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_         ,__NONE         ,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR         ,__NONE         ,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR | __COMP,__DIFF         ,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__NONE,__SEL1,	__CURR         ,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
		},
	},

	// Zς݃uh[h̕`PxS{
	{
		// uheNX`
		{
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__NONE,__DIFF,__SEL2,	__TEX_,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__NONE,__SEL1,	__TEX_,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//eXg
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__NONE,__SEL1,	__TEX_,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0,__NONE,__DIFF,__SEL2,	__TEX_,__DIFF         ,__MUL4},
						/*Stage1*/{    NULL, 0, 0,__CURR,__NONE,__SEL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0,__TEX_,__DIFF,__MUL1,	__TEX_,__DIFF         ,__MUL4},
						/*Stage1*/{    NULL, 0, 0,__CURR,__NONE,__SEL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(2), 0, 0,__TEX_,__DIFF,__MUL1,	__TEX_,__DIFF         ,__MUL4},
						/*Stage1*/{    NULL, 0, 0,__CURR,__NONE,__SEL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[Ȃ
				{
					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__NONE,__DIFF,__SEL2,	__TEX_,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__NONE,__SEL1,	__TEX_,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(1), 0, 0,__TEX_,__NONE,__SEL1,	__TEX_,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0,__NONE,__DIFF,__SEL2,	__TEX_,__DIFF         ,__MUL4},
						/*Stage1*/{    NULL, 0, 0,__CURR,__NONE,__SEL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0,__TEX_,__DIFF,__MUL1,	__TEX_,__DIFF         ,__MUL4},
						/*Stage1*/{    NULL, 0, 0,__CURR,__NONE,__SEL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(2), 0, 0,__TEX_,__DIFF,__MUL1,	__TEX_,__DIFF         ,__MUL4},
						/*Stage1*/{    NULL, 0, 0,__CURR,__NONE,__SEL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
		},
		//uheNX` DX_BLENDGRAPHTYPE_NORMAL
		{
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(5), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__SUB1,	__CURR,__TEX_,__SUB1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__FACT,__MUL1,	__CURR,__FACT,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__TEX_,__ADD1,	__CURR,__TEX_,__ADD1},
						/*Stage4*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(5), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__SUB1,	__CURR,__TEX_,__SUB1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__FACT,__MUL1,	__CURR,__FACT,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__TEX_,__ADD1,	__CURR,__TEX_,__ADD1},
						/*Stage4*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(5), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__SUB1,	__CURR,__TEX_,__SUB1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__FACT,__MUL1,	__CURR,__FACT,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__TEX_,__ADD1,	__CURR,__TEX_,__ADD1},
						/*Stage4*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(6), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE         ,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__SUB1,	__CURR,__TEX_         ,__SUB1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__FACT,__MUL1,	__CURR,__FACT         ,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__TEX_,__ADD1,	__CURR,__TEX_         ,__ADD1},
						/*Stage4*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF         ,__MUL4},
						/*Stage5*/{    NULL, 0, 0, __CURR,__NONE,__SEL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(6), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE         ,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__SUB1,	__CURR,__TEX_         ,__SUB1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__FACT,__MUL1,	__CURR,__FACT         ,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__TEX_,__ADD1,	__CURR,__TEX_         ,__ADD1},
						/*Stage4*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF         ,__MUL4},
						/*Stage5*/{    NULL, 0, 0, __CURR,__NONE,__SEL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(6), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE         ,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__SUB1,	__CURR,__TEX_         ,__SUB1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__FACT,__MUL1,	__CURR,__FACT         ,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__TEX_,__ADD1,	__CURR,__TEX_         ,__ADD1},
						/*Stage4*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF         ,__MUL4},
						/*Stage5*/{    NULL, 0, 0, __CURR,__NONE,__SEL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST
					},
				},
			},
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(5), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__SUB1,	__CURR,__TEX_,__SUB1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__FACT,__MUL1,	__CURR,__FACT,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__TEX_,__ADD1,	__CURR,__TEX_,__ADD1},
						/*Stage4*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(5), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__SUB1,	__CURR,__TEX_,__SUB1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__FACT,__MUL1,	__CURR,__FACT,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__TEX_,__ADD1,	__CURR,__TEX_,__ADD1},
						/*Stage4*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(5), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__SUB1,	__CURR,__TEX_,__SUB1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__FACT,__MUL1,	__CURR,__FACT,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__TEX_,__ADD1,	__CURR,__TEX_,__ADD1},
						/*Stage4*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(6), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE         ,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__SUB1,	__CURR,__TEX_         ,__SUB1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__FACT,__MUL1,	__CURR,__FACT         ,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__TEX_,__ADD1,	__CURR,__TEX_         ,__ADD1},
						/*Stage4*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF         ,__MUL4},
						/*Stage5*/{    NULL, 0, 0, __CURR,__NONE,__SEL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(6), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE         ,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__SUB1,	__CURR,__TEX_         ,__SUB1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__FACT,__MUL1,	__CURR,__FACT         ,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__TEX_,__ADD1,	__CURR,__TEX_         ,__ADD1},
						/*Stage4*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF         ,__MUL4},
						/*Stage5*/{    NULL, 0, 0, __CURR,__NONE,__SEL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(6), 1, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE         ,__SEL1},
						/*Stage1*/{    NULL, 0, 0, __CURR,__TEX_,__SUB1,	__CURR,__TEX_         ,__SUB1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__FACT,__MUL1,	__CURR,__FACT         ,__MUL1},
						/*Stage3*/{    NULL, 0, 0, __CURR,__TEX_,__ADD1,	__CURR,__TEX_         ,__ADD1},
						/*Stage4*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF         ,__MUL4},
						/*Stage5*/{    NULL, 0, 0, __CURR,__NONE,__SEL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST
					},
				},
			},
		},
		//uheNX` DX_BLENDGRAPHTYPE_WIPE
		{
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __CURR,__DIFF,__MUL1,	__TEX_,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __SPEC,__CURR,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF         ,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __DIFF,__CURR,__MUL1,	__TEX_,__DIFF         ,__MUL4},
						/*Stage2*/{    NULL, 0, 0, __CURR,__NONE,__SEL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(4), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF         ,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __SPEC,__CURR,__MUL1,	__CURR,__NONE         ,__SEL1},
						/*Stage2*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_,__DIFF         ,__MUL4},
						/*Stage3*/{    NULL, 0, 0, __DIFF,__CURR,__MUL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF         ,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_,__DIFF         ,__MUL4},
						/*Stage2*/{    NULL, 1, 0, __DIFF,__CURR,__MUL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __CURR,__DIFF,__MUL1,	__TEX_,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __SPEC,__CURR,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF         ,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __DIFF,__CURR,__MUL1,	__TEX_,__DIFF         ,__MUL4},
						/*Stage2*/{    NULL, 0, 0, __CURR,__NONE,__SEL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(4), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF         ,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __SPEC,__CURR,__MUL1,	__CURR,__NONE         ,__SEL1},
						/*Stage2*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_,__DIFF         ,__MUL4},
						/*Stage3*/{    NULL, 0, 0, __DIFF,__CURR,__MUL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__FACT,__ADD1,	__NONE,__DIFF         ,__SEL2},
						/*Stage1*/{    NULL, 1, 0, __TEX_,__CURR,__MUL1,	__TEX_,__DIFF         ,__MUL4},
						/*Stage2*/{    NULL, 1, 0, __DIFF,__CURR,__MUL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
		},
		//uheNX` DX_BLENDGRAPHTYPE_ALPHA
		{
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(2), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(4), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE         ,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE         ,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF         ,__MUL4},
						/*Stage3*/{    NULL, 0, 0, __CURR,__NONE,__SEL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(4), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE         ,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE         ,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF         ,__MUL4},
						/*Stage3*/{    NULL, 0, 0, __CURR,__NONE,__SEL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(4), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE         ,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE         ,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF         ,__MUL4},
						/*Stage3*/{    NULL, 0, 0, __CURR,__NONE,__SEL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
			//fBt[YRGBJ[
			{
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(3), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF,__MUL4}, DISB_ST DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
				//fBt[YAlphaJ[
				{
					//`l
					{
						/*Stage0*/{__NUM(4), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE         ,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE         ,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF         ,__MUL4},
						/*Stage3*/{    NULL, 0, 0, __CURR,__NONE,__SEL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST
					},

					//`l
					{
						/*Stage0*/{__NUM(4), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE         ,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE         ,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF         ,__MUL4},
						/*Stage3*/{    NULL, 0, 0, __CURR,__NONE,__SEL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST
					},
					
					//eXg
					{
						/*Stage0*/{__NUM(4), 0, 0, __TEX_,__NONE,__SEL1,	__TEX_,__NONE         ,__SEL1},
						/*Stage1*/{    NULL, 1, 0, __CURR,__TEX_,__MUL1,	__CURR,__NONE         ,__SEL1},
						/*Stage2*/{    NULL, 0, 0, __CURR,__DIFF,__MUL1,	__CURR,__DIFF         ,__MUL4},
						/*Stage3*/{    NULL, 0, 0, __CURR,__NONE,__SEL1,	__CURR,__DIFF | __ALRP,__MUL1}, DISB_ST DISB_ST DISB_ST DISB_ST
					},
				},
			},
		},
	},
} ;

#undef __DIFF
#undef __CURR
#undef __TEX_
#undef __FACT
#undef __SPEC
#undef __TEMP

#undef __DISB
#undef __SEL1
#undef __SEL2
#undef __MUL1
#undef __MUL2
#undef __MUL4
#undef __ADD1

#undef __NUM

// uhݒXV(Direct3D ɔf)
static int  RefreshBlendStateHardware( DIRECT3DBLENDINFO *pUserInfo, int TextureStageIsTextureAndTextureCoordOnlyFlag, int TextureIsGraphHandleFlag )
{
	DIRECT3DBLENDINFO BlendInfo ;
	int AlphaTableIndex ;
	int BlendTextureIndex ;
	int NextBlendMode ;
	int i ;
	int StageNum ;
	int TextureOnly ;
	DIRECT3DTEXTURESTAGEINFO *Dest ;
	const DIRECT3DTEXTURESTAGEINFO *Src, *TextureStageInfo ;
	DX_DIRECT3DTEXTURE9 *StageTexture[USE_TEXTURESTAGE_NUM] = { NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL } ;
	DX_DIRECT3DPIXELSHADER9 *UsePixelShader = NULL ;
	IMAGEDATA2 *Image2 ;
	int UseFloatFactorColor = FALSE ;
	FLOAT4 FloatFactorColor ;
	DIRECT3DTEXTURESTAGEINFO TempTextureStageInfo[ USE_TEXTURESTAGE_NUM ] ;
	int UseShaderFlag ;

	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	UseShaderFlag = GRH.UseShader && GRH.NormalDraw_NotUseShader == FALSE ? TRUE : FALSE ;

	BlendInfo.TextureStageInfo[0].ResultTempARG = FALSE ;
	BlendInfo.TextureStageInfo[1].ResultTempARG = FALSE ;
	BlendInfo.TextureStageInfo[2].ResultTempARG = FALSE ;
	BlendInfo.TextureStageInfo[3].ResultTempARG = FALSE ;
	BlendInfo.TextureStageInfo[4].ResultTempARG = FALSE ;
	BlendInfo.TextureStageInfo[5].ResultTempARG = FALSE ;
	BlendInfo.TextureStageInfo[6].ResultTempARG = FALSE ;
	BlendInfo.TextureStageInfo[7].ResultTempARG = FALSE ;

	BlendInfo.SeparateAlphaBlendEnable = FALSE ;
	BlendInfo.SrcBlendAlpha = -1 ;
	BlendInfo.DestBlendAlpha = -1 ;
	BlendInfo.BlendOpAlpha = -1 ;

	// [U[w̃uh񂪂邩ǂŏ𕪊
	TextureOnly = FALSE ;
	if( pUserInfo )
	{
		StageNum = pUserInfo->UseTextureStageNum ;

		_MEMCPY( &BlendInfo, pUserInfo, sizeof( DIRECT3DBLENDINFO ) - sizeof( pUserInfo->TextureStageInfo ) ) ;
		TextureStageInfo = pUserInfo->TextureStageInfo ;
		TextureOnly = TextureStageIsTextureAndTextureCoordOnlyFlag ;

		// OtBbNnheNX`擾
		if( TextureIsGraphHandleFlag )
		{
			for( i = 0 ; i < StageNum ; i ++ )
			{
				if( GRAPHCHK( ( LONG_PTR )pUserInfo->TextureStageInfo[ i ].Texture, Image2 ) )
				{
					StageTexture[ i ] = NULL ;
				}
				else
				{
					StageTexture[ i ] = Image2->Hard.Draw[ 0 ].Tex->Texture ;
				}
			}
		}
		else
		{
			for( i = 0 ; i < StageNum ; i ++ )
			{
				StageTexture[ i ] = ( DX_DIRECT3DTEXTURE9 * )pUserInfo->TextureStageInfo[ i ].Texture ;
			}
		}

		GRH.UseAlphaChDrawShader = FALSE ;
	}
	else
	if( GRH.UserBlendInfoFlag == TRUE )
	{
		StageNum = GRH.UserBlendInfo.UseTextureStageNum ;

		_MEMCPY( &BlendInfo, &GRH.UserBlendInfo, sizeof( DIRECT3DBLENDINFO ) - sizeof( GRH.UserBlendInfo.TextureStageInfo ) ) ;
		TextureStageInfo = GRH.UserBlendInfo.TextureStageInfo ;
		TextureOnly = GRH.UserBlendInfoTextureStageIsTextureAndTextureCoordOnlyFlag ;

		// OtBbNnheNX`擾
		if( TextureIsGraphHandleFlag )
		{
			for( i = 0 ; i < StageNum ; i ++ )
			{
				if( GRAPHCHK( ( LONG_PTR )GRH.UserBlendInfo.TextureStageInfo[ i ].Texture, Image2 ) )
					StageTexture[ i ] = NULL ;
				else
					StageTexture[ i ] = Image2->Hard.Draw[ 0 ].Tex->Texture ;
			}
		}
		else
		{
			for( i = 0 ; i < StageNum ; i ++ )
			{
				StageTexture[ i ] = ( DX_DIRECT3DTEXTURE9 * )GRH.UserBlendInfo.TextureStageInfo[ i ].Texture ;
			}
		}

		GRH.UseAlphaChDrawShader = FALSE ;
	}
	else
	{
		// tOĂ炸Ap[^ؕύXĖ牽Ȃ
		if( GRH.InitializeFlag == FALSE && GRH.ChangeBlendParamFlag == FALSE && GRH.ChangeTextureFlag == FALSE ) return -1 ; 

		// `eNX`̂ݕύXꂽꍇ͕`eNX`̕ύX̂ݍs
		if( GRH.InitializeFlag == FALSE && GRH.ChangeBlendParamFlag == FALSE && GRH.ChangeTextureFlag == TRUE )
		{
			// uheNX`ꍇƖꍇŏ𕪊
			if( GRH.BlendTexture != NULL )
			{
				// ꍇ

				if( UseShaderFlag )
				{
					// gpeNX`[AhXZbg
					GraphicsDevice_SetTexture( 0, GRH.RenderTexture ) ;
					GRH.BlendInfo.TextureStageInfo[0].Texture = GRH.RenderTexture ;

					GraphicsDevice_SetTexture( 1, GRH.BlendTexture ) ;
					GRH.BlendInfo.TextureStageInfo[1].Texture = GRH.BlendTexture ;
				}
				else
				{
					// [hɂďύX
					switch( GRH.BlendGraphType )
					{
					case DX_BLENDGRAPHTYPE_NORMAL :
						GraphicsDevice_SetTexture( 0, GRH.BlendTexture ) ;
						GRH.BlendInfo.TextureStageInfo[0].Texture = GRH.BlendTexture ;

						GraphicsDevice_SetTexture( 1, GRH.RenderTexture ) ;
						GRH.BlendInfo.TextureStageInfo[1].Texture = GRH.RenderTexture ;

						GraphicsDevice_SetTexture( 3, GRH.RenderTexture ) ;
						GRH.BlendInfo.TextureStageInfo[3].Texture = GRH.RenderTexture ;
						break;

					case DX_BLENDGRAPHTYPE_WIPE :
						GraphicsDevice_SetTexture( 0, GRH.BlendTexture ) ;
						GRH.BlendInfo.TextureStageInfo[0].Texture = GRH.BlendTexture ;

						// `lLȏꍇƂłȂꍇŏ𕪊
						if( GRH.AlphaChannelValidFlag == TRUE )
						{
							GraphicsDevice_SetTexture( 2, GRH.RenderTexture ) ;
							GRH.BlendInfo.TextureStageInfo[2].Texture = GRH.RenderTexture ;
	//						StageTexture[2] = GRH.RenderTexture ;
						}
						else
						{
							GraphicsDevice_SetTexture( 1, GRH.RenderTexture ) ;
							GRH.BlendInfo.TextureStageInfo[1].Texture = GRH.RenderTexture ;
	//						StageTexture[1] = GRH.RenderTexture ;
						}
						break ;

					case DX_BLENDGRAPHTYPE_ALPHA :
						GraphicsDevice_SetTexture( 0, GRH.RenderTexture ) ;
						GRH.BlendInfo.TextureStageInfo[0].Texture = GRH.RenderTexture ;

						GraphicsDevice_SetTexture( 1, GRH.BlendTexture ) ;
						GRH.BlendInfo.TextureStageInfo[1].Texture = GRH.BlendTexture ;
						break;
					}
				}
			}
			else
			{
				// ꍇ
				GraphicsDevice_SetTexture( 0, GRH.RenderTexture ) ;
				GRH.BlendInfo.TextureStageInfo[0].Texture = GRH.RenderTexture ;
	//			StageTexture[0] = GRH.RenderTexture ;
			}

			// eNX`ύXꂽAtO|
			GRH.ChangeTextureFlag = FALSE ;
			GRH.DrawPrepAlwaysFlag = TRUE ;

			// I
			return 0 ;
		}

		// eNX`ύXꂽAtO|
		GRH.ChangeTextureFlag = FALSE ;
		GRH.DrawPrepAlwaysFlag = TRUE ;

		// p[^ύXꂽAtO|
		GRH.ChangeBlendParamFlag = FALSE ;

		// _o
	//	RenderVertexHardware() ;

		// uh[ȟ
		{
			NextBlendMode = GRH.BlendMode ;
			switch( GRH.BlendMode )
			{
			case DX_BLENDMODE_SUB :
				// Zuhw D3DRS_BLENDOP gp\ȏꍇ 14Ԗڂ̃uh[hgp
				if( GRH.ValidDestBlendOp )
				{
					NextBlendMode = DX_BLENDMODE_SUB1 ;
				}
				break ;

			case DX_BLENDMODE_NOBLEND :
				// `Ƀlꍇ DX_BLENDMODE_NOBLEND łuh[h DX_BLENDMODE_SRCCOLOR ɂ
				if( GBASE.AlphaChDrawMode )
				{
					NextBlendMode = DX_BLENDMODE_SRCCOLOR ;
				}

				// `挳摜Ƀ`lꍇuh摜̗LȂǏ DX_BLENDMODE_ALPHA gp
				if( GRH.RenderTexture != NULL )
				{
					if( GRH.BlendTexture != NULL )
					{
						switch( GRH.BlendGraphType )
						{
						case DX_BLENDGRAPHTYPE_NORMAL :
						case DX_BLENDGRAPHTYPE_ALPHA :
							if( GRH.AlphaTestValidFlag == TRUE || GRH.AlphaChannelValidFlag == TRUE )
							{
								NextBlendMode = DX_BLENDMODE_ALPHA ;
							}
							break ;

						case DX_BLENDGRAPHTYPE_WIPE :
							NextBlendMode = DX_BLENDMODE_ALPHA ;
							break ;
						}
					}
					else
					{
						if( GRH.AlphaChannelValidFlag == TRUE )
						{
							NextBlendMode = DX_BLENDMODE_ALPHA ;
						}
					}
				}
				break ;
			}
		}
		
		// \[XuhƃfXguh̒lZbg
		BlendInfo.DestBlend = __RGBBlendStateTable[ NextBlendMode ][ RGB_BLENDSTATE_TABLE_DESTBLEND ] ;
		BlendInfo.SrcBlend  = __RGBBlendStateTable[ NextBlendMode ][ RGB_BLENDSTATE_TABLE_SRCBLEND ] ;
		BlendInfo.BlendOp   = __RGBBlendStateTable[ NextBlendMode ][ RGB_BLENDSTATE_TABLE_BLENDOP ] ;
		BlendInfo.FactorColor = 0xffffffff ;

		// Direct3D ̃uh@\gpuh[hǂ擾
		BlendInfo.AlphaBlendEnable = __RGBBlendStateTable[ NextBlendMode ][ RGB_BLENDSTATE_TABLE_ALPHABLENDENABLE ] ;

		// ݂̃l𐳂vZuh[hgp邩ǂŏ𕪊
		GRH.UseAlphaChDrawShader = FALSE ;
		if( 0 ) // d̂łƂ肠
		{
			if( UseShaderFlag && GBASE.AlphaChDrawMode )
			{
				// uhɃVF[_[gpꍇƂłȂꍇŕ
				if( __RGBBlendStateTable[ NextBlendMode ][ RGB_BLENDSTATE_TABLE_SHADERALPHABLEND ] == 1 )
				{
					GRH.UseAlphaChDrawShader = TRUE ;

					BlendInfo.SeparateAlphaBlendEnable = FALSE ;
					BlendInfo.SrcBlend       = D_D3DBLEND_ONE ;
					BlendInfo.DestBlend      = D_D3DBLEND_ZERO ;
					BlendInfo.BlendOp        = D_D3DBLENDOP_ADD ;
					BlendInfo.SrcBlendAlpha  = -1 ;
					BlendInfo.DestBlendAlpha = -1 ;
					BlendInfo.BlendOpAlpha   = -1 ;
				}
			}
		}

		// JgeNX`ꍇƂꍇŕ
		if( GRH.RenderTexture == NULL )
		{
			// JgeNX`ꍇ͐┠̕`ƔfAeNX`Xe[W͖ɂ

			// Ƃ肠`揈s
			GRH.BlendMaxNotDrawFlag = FALSE ;
			
			// VF[_[gp邩ǂŏ𕪊
			if( UseShaderFlag )
			{
				UsePixelShader = GRH.BaseNoneTexPixelShader[ __RGBBlendStateTable[ NextBlendMode ][ RGB_BLENDSTATE_TABLE_TEXBLENDTABLEINDEX ] ][ GRH.UseAlphaChDrawShader ] ;
				StageNum = 0 ;
			}
			else
			{
				// Zuh̔]̎̂ݐp̃e[ugp
				if( NextBlendMode == DX_BLENDMODE_SUB )
				{
					TextureStageInfo = __TexSubBlendStageStateTable ;
					StageNum = (int)(DWORD_PTR)TextureStageInfo[0].Texture ;
				}
				else
				{
					IMAGEDATA2 *WhiteTex ;

					BlendInfo.TextureStageInfo[0].TextureCoordIndex = 0 ;
					BlendInfo.TextureStageInfo[1].TextureCoordIndex = 0 ;
					BlendInfo.TextureStageInfo[1].AlphaARG1 = D_D3DTA_DIFFUSE ;
					BlendInfo.TextureStageInfo[1].AlphaARG2 = D_D3DTA_DIFFUSE ;
					BlendInfo.TextureStageInfo[1].AlphaOP   = D_D3DTOP_DISABLE ;
					BlendInfo.TextureStageInfo[1].ColorARG1 = D_D3DTA_DIFFUSE ;
					BlendInfo.TextureStageInfo[1].ColorARG2 = D_D3DTA_DIFFUSE ;
					BlendInfo.TextureStageInfo[1].ColorOP   = D_D3DTOP_DISABLE ;
					StageNum = 1 ;
					switch( __RGBBlendStateTable[ NextBlendMode ][ RGB_BLENDSTATE_TABLE_TEXBLENDTABLEINDEX ] )
					{
					case TEXTURE_BLEND_TABLE_INDEX_NORMAL :	// ʏ`
						BlendInfo.TextureStageInfo[0].AlphaARG1 = D_D3DTA_DIFFUSE ;
						BlendInfo.TextureStageInfo[0].AlphaARG2 = D_D3DTA_DIFFUSE ;
						BlendInfo.TextureStageInfo[0].AlphaOP   = D_D3DTOP_SELECTARG2 ;
						BlendInfo.TextureStageInfo[0].ColorARG1 = D_D3DTA_DIFFUSE ;
						BlendInfo.TextureStageInfo[0].ColorARG2 = D_D3DTA_DIFFUSE ;
						BlendInfo.TextureStageInfo[0].ColorOP   = D_D3DTOP_SELECTARG2 ;
						break ;

					case TEXTURE_BLEND_TABLE_INDEX_MUL :	// Z`
						BlendInfo.TextureStageInfo[0].AlphaARG1 = D_D3DTA_DIFFUSE ;
						BlendInfo.TextureStageInfo[0].AlphaARG2 = D_D3DTA_DIFFUSE ;
						BlendInfo.TextureStageInfo[0].AlphaOP   = D_D3DTOP_SELECTARG2 ;
						BlendInfo.TextureStageInfo[0].ColorARG1 = D_D3DTA_DIFFUSE ;
						BlendInfo.TextureStageInfo[0].ColorARG2 = D_D3DTA_TFACTOR ;
						BlendInfo.TextureStageInfo[0].ColorOP   = D_D3DTOP_BLENDDIFFUSEALPHA ;
						break ;

					case TEXTURE_BLEND_TABLE_INDEX_INVERSE :	// qfa]
						BlendInfo.TextureStageInfo[0].AlphaARG1 = D_D3DTA_DIFFUSE ;
						BlendInfo.TextureStageInfo[0].AlphaARG2 = D_D3DTA_DIFFUSE ;
						BlendInfo.TextureStageInfo[0].AlphaOP   = D_D3DTOP_SELECTARG2 ;
						BlendInfo.TextureStageInfo[0].ColorARG1 = D_D3DTA_DIFFUSE | D_D3DTA_COMPLEMENT;
						BlendInfo.TextureStageInfo[0].ColorARG2 = D_D3DTA_DIFFUSE ;
						BlendInfo.TextureStageInfo[0].ColorOP   = D_D3DTOP_SELECTARG1 ;
						break ;

					case TEXTURE_BLEND_TABLE_INDEX_X4 :	// `Px4{
						if( GRH.WhiteTexHandle <= 0 )
						{
							LOADGRAPH_GPARAM GParam ;

							InitLoadGraphGParam( &GParam ) ;
							InitSetupGraphHandleGParam_Normal_NonDrawValid( &GParam.CreateGraphGParam.InitHandleGParam, 16, TRUE, FALSE ) ;
							GParam.CreateGraphGParam.InitHandleGParam.TransColor = ( BYTE )255 << 16 | ( BYTE )0 << 8 | ( BYTE )255 ;
							GRH.WhiteTexHandle = CreateGraphFromMem_UseGParam( &GParam, FALSE, GRH.WhiteTexHandle, WhiteTga8x8TextureFileImage, 84 ) ;
							NS_SetDeleteHandleFlag( GRH.WhiteTexHandle, &GRH.WhiteTexHandle ) ;
							NS_SetDeviceLostDeleteGraphFlag( GRH.WhiteTexHandle, TRUE ) ;
							BeginScene() ;
						}
						GRAPHCHK( GRH.WhiteTexHandle, WhiteTex ) ;
						StageTexture[0] = WhiteTex->Orig->Hard.Tex[ 0 ].Texture ;
						BlendInfo.TextureStageInfo[0].AlphaARG1 = D_D3DTA_DIFFUSE ;
						BlendInfo.TextureStageInfo[0].AlphaARG2 = D_D3DTA_DIFFUSE ;
						BlendInfo.TextureStageInfo[0].AlphaOP   = D_D3DTOP_SELECTARG2 ;
						BlendInfo.TextureStageInfo[0].ColorARG1 = D_D3DTA_DIFFUSE ;
						BlendInfo.TextureStageInfo[0].ColorARG2 = D_D3DTA_TEXTURE ;
						BlendInfo.TextureStageInfo[0].ColorOP   = D_D3DTOP_MODULATE4X ;
						break ;

					case TEXTURE_BLEND_TABLE_INDEX_PMA_NORMAL :		// Zς݃uh[h̒ʏ`
						BlendInfo.TextureStageInfo[0].AlphaARG1 = D_D3DTA_DIFFUSE ;
						BlendInfo.TextureStageInfo[0].AlphaARG2 = D_D3DTA_DIFFUSE ;
						BlendInfo.TextureStageInfo[0].AlphaOP   = D_D3DTOP_SELECTARG2 ;
						BlendInfo.TextureStageInfo[0].ColorARG1 = D_D3DTA_DIFFUSE ;
						BlendInfo.TextureStageInfo[0].ColorARG2 = D_D3DTA_DIFFUSE | D_D3DTA_ALPHAREPLICATE ;
						BlendInfo.TextureStageInfo[0].ColorOP   = D_D3DTOP_MODULATE ;
						break ;

					case TEXTURE_BLEND_TABLE_INDEX_PMA_INVERSE :	// Zς݃uh[hRGB]
						BlendInfo.TextureStageInfo[0].AlphaARG1 = D_D3DTA_DIFFUSE ;
						BlendInfo.TextureStageInfo[0].AlphaARG2 = D_D3DTA_DIFFUSE ;
						BlendInfo.TextureStageInfo[0].AlphaOP   = D_D3DTOP_SELECTARG2 ;
						BlendInfo.TextureStageInfo[0].ColorARG1 = D_D3DTA_DIFFUSE | D_D3DTA_COMPLEMENT;
						BlendInfo.TextureStageInfo[0].ColorARG2 = D_D3DTA_DIFFUSE | D_D3DTA_ALPHAREPLICATE ;
						BlendInfo.TextureStageInfo[0].ColorOP   = D_D3DTOP_MODULATE ;
						break ;

					case TEXTURE_BLEND_TABLE_INDEX_PMA_X4 :			// Zς݃uh[h̕`Px4{
						if( GRH.WhiteTexHandle <= 0 )
						{
							LOADGRAPH_GPARAM GParam ;

							InitLoadGraphGParam( &GParam ) ;
							InitSetupGraphHandleGParam_Normal_NonDrawValid( &GParam.CreateGraphGParam.InitHandleGParam, 16, TRUE, FALSE ) ;
							GParam.CreateGraphGParam.InitHandleGParam.TransColor = ( BYTE )255 << 16 | ( BYTE )0 << 8 | ( BYTE )255 ;
							GRH.WhiteTexHandle = CreateGraphFromMem_UseGParam( &GParam, FALSE, GRH.WhiteTexHandle, WhiteTga8x8TextureFileImage, 84 ) ;
							NS_SetDeleteHandleFlag( GRH.WhiteTexHandle, &GRH.WhiteTexHandle ) ;
							NS_SetDeviceLostDeleteGraphFlag( GRH.WhiteTexHandle, TRUE ) ;
							BeginScene() ;
						}
						GRAPHCHK( GRH.WhiteTexHandle, WhiteTex ) ;
						StageTexture[0] = WhiteTex->Orig->Hard.Tex[ 0 ].Texture ;
						BlendInfo.TextureStageInfo[0].AlphaARG1 = D_D3DTA_DIFFUSE ;
						BlendInfo.TextureStageInfo[0].AlphaARG2 = D_D3DTA_DIFFUSE ;
						BlendInfo.TextureStageInfo[0].AlphaOP   = D_D3DTOP_SELECTARG2 ;
						BlendInfo.TextureStageInfo[0].ColorARG1 = D_D3DTA_DIFFUSE ;
						BlendInfo.TextureStageInfo[0].ColorARG2 = D_D3DTA_TEXTURE ;
						BlendInfo.TextureStageInfo[0].ColorOP   = D_D3DTOP_MODULATE4X ;

						BlendInfo.TextureStageInfo[1].AlphaARG1 = D_D3DTA_CURRENT ;
						BlendInfo.TextureStageInfo[1].AlphaARG2 = D_D3DTA_DIFFUSE ;
						BlendInfo.TextureStageInfo[1].AlphaOP   = D_D3DTOP_SELECTARG1 ;
						BlendInfo.TextureStageInfo[1].ColorARG1 = D_D3DTA_CURRENT ;
						BlendInfo.TextureStageInfo[1].ColorARG2 = D_D3DTA_DIFFUSE | D_D3DTA_ALPHAREPLICATE ;
						BlendInfo.TextureStageInfo[1].ColorOP   = D_D3DTOP_MODULATE ;

						BlendInfo.TextureStageInfo[2].AlphaARG1 = D_D3DTA_DIFFUSE ;
						BlendInfo.TextureStageInfo[2].AlphaARG2 = D_D3DTA_DIFFUSE ;
						BlendInfo.TextureStageInfo[2].AlphaOP   = D_D3DTOP_DISABLE ;
						BlendInfo.TextureStageInfo[2].ColorARG1 = D_D3DTA_DIFFUSE ;
						BlendInfo.TextureStageInfo[2].ColorARG2 = D_D3DTA_DIFFUSE ;
						BlendInfo.TextureStageInfo[2].ColorOP   = D_D3DTOP_DISABLE ;
						StageNum = 2 ;
						break ;
					}

					TextureStageInfo = BlendInfo.TextureStageInfo ;
				}
			}

			// eXg͍sȂ
			BlendInfo.AlphaTestEnable = FALSE ;
			BlendInfo.AlphaRef        = GRH.BlendInfo.AlphaRef ;
			BlendInfo.AlphaFunc       = GRH.BlendInfo.AlphaFunc ;

			// _^CṽZbg
			GRH.VertexType = VERTEXTYPE_NOTEX ;
			GRH.VertexBufferNextAddress = GRH.VertexBufferPoint[ GRH.Use3DVertex ][ GRH.VertexType ] ;
		}
		else
		{
			// JgeNX`ꍇ̓eNX`Xe[Wuhe[ul擾

			// uheNX`[邩ǂ擾
			BlendTextureIndex = GRH.BlendTexture != NULL ? GRH.BlendGraphType + 1 : 0 ;

			// gpeNX`uhXe[WXe[^Xe[ũCfbNXZbg
			AlphaTableIndex = 0 ;
			if( GRH.AlphaChannelValidFlag || GRH.AlphaTestValidFlag || ( GRH.EnableZBufferFlag && BlendTextureIndex == 0 ) )
			{
				AlphaTableIndex = GRH.AlphaChannelValidFlag ? 1 : 2 ;
			}

			// uheNX`[gp邩ǂŕ
			if( BlendTextureIndex != 0 )
			{
				int TableIndex ;

				// uheNX`[ꍇ AlphaTestValidFlag ͖

				// gpe[ũCfbNXo
				if( NextBlendMode == DX_BLENDMODE_ADD_X4 || NextBlendMode == DX_BLENDMODE_ALPHA_X4 )
				{
					TableIndex = TEXTURE_BLEND_TABLE_INDEX_X4 ;
				}
				else
				if( NextBlendMode == DX_BLENDMODE_INVSRC )
				{
					TableIndex = TEXTURE_BLEND_TABLE_INDEX_INVERSE ;
				}
				else
				{
					TableIndex = TEXTURE_BLEND_TABLE_INDEX_NORMAL ;
				}
				
				// VF[_[gp邩ǂŏ𕪊
				if( UseShaderFlag )
				{
					// gpeNX`[AhXZbg
					StageTexture[0] = GRH.RenderTexture ;
					StageTexture[1] = GRH.BlendTexture ;
					StageTexture[2] = NULL ;
					StageNum = 2 ;
				}
				else
				{
					// eNX`[Xe[WXe[g̐ݒl擾
					TextureStageInfo = BlendInfo.TextureStageInfo ;
					memcpy( BlendInfo.TextureStageInfo,
							__TexStageStateTable[ TableIndex ][ BlendTextureIndex ][ GRH.UseDiffuseRGBColor ][ GRH.UseDiffuseAlphaColor ][ AlphaTableIndex ],
							 sizeof( DIRECT3DTEXTURESTAGEINFO ) * USE_TEXTURESTAGE_NUM ) ;

/*
					int p[5] ;

					p[0] = TableIndex ;
					p[1] = BlendTextureIndex ;
					p[2] = GRH.UseDiffuseRGBColor ;
					p[3] = GRH.UseDiffuseAlphaColor ;
					p[4] = AlphaTableIndex ;
*/
					StageNum = (int)(DWORD_PTR)TextureStageInfo[0].Texture ;
				}

				// _^CṽZbg
				GRH.VertexType = VERTEXTYPE_BLENDTEX ;
				GRH.VertexBufferNextAddress = GRH.VertexBufferPoint[ GRH.Use3DVertex ][ GRH.VertexType ] ;

				// uh^Cvɂď𕪊
				switch( GRH.BlendGraphType )
				{
				case DX_BLENDGRAPHTYPE_NORMAL :
					// Ƃ肠`揈s
					GRH.BlendMaxNotDrawFlag = FALSE ;

					// Lȏꍇ̓lȌꍇ̂ݕ\Ȃ悤ɂ
					if( GRH.AlphaTestValidFlag == TRUE || BlendInfo.AlphaBlendEnable == TRUE || GRH.AlphaChannelValidFlag == TRUE )
					{
						BlendInfo.AlphaTestEnable = TRUE ;
						BlendInfo.AlphaRef        = 0 ;
						BlendInfo.AlphaFunc       = D_D3DCMP_GREATER ;
					}
					else
					{
						BlendInfo.AlphaTestEnable = FALSE ;
						BlendInfo.AlphaRef        = GRH.BlendInfo.AlphaRef ;
						BlendInfo.AlphaFunc       = GRH.BlendInfo.AlphaFunc ;
					}

					// NXtF[hݒ肷
					BlendInfo.FactorColor = ( GRH.BlendGraphFadeRatio << 24 ) | 0x00ffffff ;

					// VF[_[gp邩ǂŏ𕪊
					if( UseShaderFlag == FALSE )
					{
						// gpeNX`[AhXZbgƒ_^CvAeNX`Xe[WgpeNX`W̃CfbNXZbg
						StageTexture[0] = GRH.BlendTexture ;
						StageTexture[1] = GRH.RenderTexture ;
						StageTexture[2] = NULL ;

						// eNX`J[tOĂꍇ̓eNX`vf𖳌ɂ
						if( GRH.IgnoreGraphColorFlag )
						{
							BlendInfo.TextureStageInfo[ 0 ].ColorARG1 = D_D3DTA_DIFFUSE ;
							BlendInfo.TextureStageInfo[ 0 ].ColorARG2 = -1 ;
							BlendInfo.TextureStageInfo[ 0 ].ColorOP = D_D3DTOP_SELECTARG1 ;
							BlendInfo.TextureStageInfo[ 1 ].ColorARG1 = D_D3DTA_CURRENT ;
							BlendInfo.TextureStageInfo[ 1 ].ColorARG2 = -1 ;
							BlendInfo.TextureStageInfo[ 1 ].ColorOP = D_D3DTOP_SELECTARG1 ;
							if( StageNum == 3 )
							{
								BlendInfo.TextureStageInfo[ 2 ].ColorARG1 = D_D3DTA_CURRENT ;
								BlendInfo.TextureStageInfo[ 2 ].ColorARG2 = -1 ;
								BlendInfo.TextureStageInfo[ 2 ].ColorOP = D_D3DTOP_SELECTARG1 ;
							}
						}
					}
					else
					{
						// gpVF[_[Zbg
						UsePixelShader = GRH.BaseUseTexPixelShader[ 1 ][ TableIndex ][ GRH.IgnoreGraphColorFlag ? 1 : 0 ][ AlphaTableIndex == 0 ? 1 : 0 ][ GRH.UseAlphaChDrawShader ] ;
					}
					break ;

				case DX_BLENDGRAPHTYPE_WIPE :
					// uhElő̏ꍇ͉`悵Ȃ
					GRH.BlendMaxNotDrawFlag = GRH.BlendGraphBorderParam == 255 ? TRUE : FALSE ;

					// VF[_[gp邩ǂŏ𕪊
					if( UseShaderFlag == FALSE )
					{
						// gpeNX`[AhXZbgƒ_^CvAeNX`Xe[WgpeNX`W̃CfbNXZbg
						StageTexture[0] = GRH.BlendTexture ;
						if( GRH.AlphaChannelValidFlag == TRUE )
						{
							StageTexture[1] = NULL ;
							StageTexture[2] = GRH.RenderTexture ;
						}
						else
						{
							StageTexture[1] = GRH.RenderTexture ;
						}
					}
					else
					{
						// gpVF[_[Zbg
						UsePixelShader = GRH.BaseUseTexPixelShader[ 2 ][ TableIndex ][ GRH.IgnoreGraphColorFlag ? 1 : 0 ][ AlphaTableIndex == 0 ? 1 : 0 ][ GRH.UseAlphaChDrawShader ] ;

						// float^ FactorColor gp
						UseFloatFactorColor = TRUE ;
						FloatFactorColor.x = 0.0f ;
						FloatFactorColor.y = 0.0f ;
						FloatFactorColor.z = 0.0f ;
						FloatFactorColor.w = 0.0f ;
					}

					// E͈͂Pȉǂŏ𕪊
					if( GRH.BlendGraphBorderRange <= 1 )
					{
						// ͂wǗO -------------------------------------------

						// eXggp
						BlendInfo.AlphaTestEnable = TRUE ;
						BlendInfo.AlphaRef = GRH.BlendGraphBorderParam ;
						BlendInfo.AlphaFunc = D_D3DCMP_GREATEREQUAL ;

						// uh@\nee
						BlendInfo.AlphaBlendEnable = FALSE ;

						// 郿l͖
						if( UseShaderFlag )
						{
							FloatFactorColor.w = 0.0f ;
							FloatFactorColor.z = 1.0f ;
						}
						else
						{
							BlendInfo.FactorColor = 0x00FFFFFF | ( 0 << 24 ) ;
						}

						// 摜`lgpĂāA BlendGraphBorderParam  0 
						// AlphaRef OɂȂ
						if( ( GRH.AlphaChannelValidFlag || GRH.AlphaTestValidFlag ) && GRH.BlendGraphBorderParam == 0 )
						{
							BlendInfo.AlphaRef = 1 ;
						}

						// -------------------------------------------------------------------
					}
					else
					{
						int p ;
					
						// uhɂeNX`uh

						// eXg͍sȂ
						BlendInfo.AlphaTestEnable = FALSE ;
						BlendInfo.AlphaRef        = GRH.BlendInfo.AlphaRef ;
						BlendInfo.AlphaFunc       = GRH.BlendInfo.AlphaFunc ;

						// uh@\nm
						BlendInfo.AlphaBlendEnable = TRUE ;

						// E͈͂ɂĂSiK
						if( GRH.BlendGraphBorderRange <= 64 )
						{
							// ~S

							p = 1280 - GRH.BlendGraphBorderParam * 1280 / 255 ; 
							BlendInfo.TextureStageInfo[1].AlphaOP = D_D3DTOP_MODULATE4X ;

							// uheNX`̃uhlɂčp[^ύX
							if( p < 1024 )
							{
								BlendInfo.FactorColor = 0x00FFFFFF | ( ( 255 - p * 255 / 1024 ) << 24 ) ;
								BlendInfo.TextureStageInfo[0].AlphaOP = D_D3DTOP_SUBTRACT ;

								if( UseShaderFlag )
								{
									FloatFactorColor.w = - ( float )( BlendInfo.FactorColor >> 24 ) / 255.0f ;
								}
							}
							else
							{
								BlendInfo.FactorColor = 0x00FFFFFF | ( ( 64 * ( p - 1024 ) / 256 ) << 24 ) ;
								BlendInfo.TextureStageInfo[0].AlphaOP = D_D3DTOP_ADD ;

								if( UseShaderFlag )
								{
									FloatFactorColor.w = ( float )( BlendInfo.FactorColor >> 24 ) / 255.0f ;
								}
							}

							if( UseShaderFlag )
							{
								FloatFactorColor.z = 4.0f ;
							}
						}
						else
						if( GRH.BlendGraphBorderRange <= 128 )
						{
							// ~Q

							p = 768 - GRH.BlendGraphBorderParam * 768 / 255 ; 
							BlendInfo.TextureStageInfo[1].AlphaOP = D_D3DTOP_MODULATE2X ;

							// uheNX`̃uhlɂčp[^ύX
							if( p < 512 )
							{
								BlendInfo.FactorColor = 0x00FFFFFF | ( ( 255 - p * 255 / 512 ) << 24 ) ;
								BlendInfo.TextureStageInfo[0].AlphaOP = D_D3DTOP_SUBTRACT ;

								if( UseShaderFlag )
								{
									FloatFactorColor.w = - ( float )( BlendInfo.FactorColor >> 24 ) / 255.0f ;
								}
							}
							else
							{
								BlendInfo.FactorColor = 0x00FFFFFF | ( ( 128 * ( p - 512 ) / 256 ) << 24 ) ;
								BlendInfo.TextureStageInfo[0].AlphaOP = D_D3DTOP_ADD ;

								if( UseShaderFlag )
								{
									FloatFactorColor.w = ( float )( BlendInfo.FactorColor >> 24 ) / 255.0f ;
								}
							}

							if( UseShaderFlag )
							{
								FloatFactorColor.z = 2.0f ;
							}
						}
						else
						{
							// ~P

							p = 512 - GRH.BlendGraphBorderParam * 512 / 255 ; 
							BlendInfo.TextureStageInfo[1].AlphaOP = D_D3DTOP_MODULATE ;

							// uheNX`̃uhlɂčp[^ύX
							if( p < 256 )
							{
								BlendInfo.FactorColor = 0x00FFFFFF | ( ( 255 - p * 255 / 256 ) << 24 ) ;
								BlendInfo.TextureStageInfo[0].AlphaOP = D_D3DTOP_SUBTRACT ;

								if( UseShaderFlag )
								{
									FloatFactorColor.w = - ( float )( BlendInfo.FactorColor >> 24 ) / 255.0f ;
								}
							}
							else
							{
								BlendInfo.FactorColor = 0x00FFFFFF | ( ( 255 * ( p - 256 ) / 256 ) << 24 ) ;
								BlendInfo.TextureStageInfo[0].AlphaOP = D_D3DTOP_ADD ;

								if( UseShaderFlag )
								{
									FloatFactorColor.w = ( float )( BlendInfo.FactorColor >> 24 ) / 255.0f ;
								}
							}

							if( UseShaderFlag )
							{
								FloatFactorColor.z = 1.0f ;
							}
						}
					}

					if( UseShaderFlag == FALSE )
					{
						// eNX`J[tOĂꍇ̓eNX`vf𖳌ɂ
						if( GRH.IgnoreGraphColorFlag )
						{
							int TargetNumber ;

							if( GRH.AlphaChannelValidFlag == TRUE )
							{
								TargetNumber = 2 ;
							}
							else
							{
								TargetNumber = 1 ;
							}

							if( BlendInfo.TextureStageInfo[ TargetNumber ].ColorARG1 == D_D3DTA_TEXTURE &&
								BlendInfo.TextureStageInfo[ TargetNumber ].ColorOP == D_D3DTOP_SELECTARG1 )
							{
								BlendInfo.TextureStageInfo[ TargetNumber ].ColorARG1 = D_D3DTA_CURRENT ;
							}
							else
							if( BlendInfo.TextureStageInfo[ TargetNumber ].ColorARG1 == ( D_D3DTA_TEXTURE | D_D3DTA_COMPLEMENT ) &&
								BlendInfo.TextureStageInfo[ TargetNumber ].ColorOP == D_D3DTOP_SELECTARG1 )
							{
								BlendInfo.TextureStageInfo[ TargetNumber ].ColorARG1 = D_D3DTA_CURRENT | D_D3DTA_COMPLEMENT ;
							}
							else
							if( BlendInfo.TextureStageInfo[ TargetNumber ].ColorARG1 == D_D3DTA_TEXTURE &&
								( BlendInfo.TextureStageInfo[ TargetNumber ].ColorOP == D_D3DTOP_MODULATE ||
								  BlendInfo.TextureStageInfo[ TargetNumber ].ColorOP == D_D3DTOP_MODULATE2X ||
								  BlendInfo.TextureStageInfo[ TargetNumber ].ColorOP == D_D3DTOP_MODULATE4X ) )
							{
								BlendInfo.TextureStageInfo[ TargetNumber ].ColorOP = D_D3DTOP_SELECTARG2 ;
							}
						}
					}
					break ;

				case DX_BLENDGRAPHTYPE_ALPHA :
					// Ƃ肠`揈s
					GRH.BlendMaxNotDrawFlag = FALSE ;

					// Lȏꍇ̓lȌꍇ̂ݕ\Ȃ悤ɂ
					if( BlendInfo.AlphaBlendEnable == TRUE )
					{
						BlendInfo.AlphaTestEnable = TRUE ;
						BlendInfo.AlphaRef        = 0 ;
						BlendInfo.AlphaFunc       = D_D3DCMP_GREATER ;
					}
					else
					{
						BlendInfo.AlphaTestEnable = FALSE ;
						BlendInfo.AlphaRef        = GRH.BlendInfo.AlphaRef ;
						BlendInfo.AlphaFunc       = GRH.BlendInfo.AlphaFunc ;
					}

					// VF[_[gp邩ǂŏ𕪊
					if( UseShaderFlag == FALSE )
					{
						// gpeNX`[AhXZbgƒ_^CvAeNX`Xe[WgpeNX`W̃CfbNXZbg
						StageTexture[0] = GRH.RenderTexture ;
						StageTexture[1] = GRH.BlendTexture ;
						StageTexture[2] = NULL ;

						// eNX`J[tOĂꍇ̓eNX`J[vf𖳌ɂ
						if( GRH.IgnoreGraphColorFlag )
						{
							BlendInfo.TextureStageInfo[ 0 ].ColorARG1 = D_D3DTA_DIFFUSE ;
						}
					}
					else
					{
						// gpVF[_[Zbg
						UsePixelShader = GRH.BaseUseTexPixelShader[ 3 ][ TableIndex ][ GRH.IgnoreGraphColorFlag ? 1 : 0 ][ AlphaTableIndex == 0 ? 1 : 0 ][ GRH.UseAlphaChDrawShader ] ;
					}
					break ;
				}
			}
			else
			{
				// uheNX`[ꍇ

				// Ƃ肠`揈s
				GRH.BlendMaxNotDrawFlag = FALSE ;

				// _^CṽZbg
				GRH.VertexType = VERTEXTYPE_TEX ;
				GRH.VertexBufferNextAddress = GRH.VertexBufferPoint[ GRH.Use3DVertex ][ GRH.VertexType ] ;

				// VF[_[gp邩ǂŏ𕪊
				if( UseShaderFlag )
				{
					// gpsNZVF[_[Zbg
					UsePixelShader = GRH.BaseUseTexPixelShader[ 0 ][ __RGBBlendStateTable[NextBlendMode][RGB_BLENDSTATE_TABLE_TEXBLENDTABLEINDEX] ][ GRH.IgnoreGraphColorFlag ? 1 : 0 ][ AlphaTableIndex == 0 ? 1 : 0 ][ GRH.UseAlphaChDrawShader ] ;

					// gpeNX`͈̐
					StageNum = 1 ;
				}
				else
				{
					// eNX`[Xe[WXe[g̐ݒl擾
					TextureStageInfo = __TexStageStateTable[ __RGBBlendStateTable[ NextBlendMode ][ RGB_BLENDSTATE_TABLE_TEXBLENDTABLEINDEX ] ][ FALSE ][ GRH.UseDiffuseRGBColor ][ GRH.UseDiffuseAlphaColor ][ AlphaTableIndex ] ;
					StageNum = (int)(DWORD_PTR)TextureStageInfo[0].Texture ;

					// eNX`J[tOĂꍇ̓eNX`vf𖳌ɂ
					if( GRH.IgnoreGraphColorFlag )
					{
						_MEMCPY( TempTextureStageInfo, TextureStageInfo, sizeof( DIRECT3DTEXTURESTAGEINFO ) * ( StageNum + 1 ) ) ;
						if( TempTextureStageInfo[ 0 ].ColorARG1 == D_D3DTA_TEXTURE )
						{
							TempTextureStageInfo[ 0 ].ColorARG1 = D_D3DTA_TFACTOR ;
						}
						else
						if( TempTextureStageInfo[ 0 ].ColorARG1 == ( D_D3DTA_TEXTURE | D_D3DTA_COMPLEMENT ) )
						{
							TempTextureStageInfo[ 0 ].ColorARG1 = D_D3DTA_TFACTOR | D_D3DTA_COMPLEMENT ;
						}
						TextureStageInfo = TempTextureStageInfo ;
					}
				}

				// eXggp邩ǂŏ𕪊
				if( GRH.AlphaTestValidFlag == TRUE )
				{
					// eXgs(ߐFȊOɃeXg̓uheNX`łgpĂ)
					BlendInfo.AlphaTestEnable = TRUE ;
					BlendInfo.AlphaRef = 16 ;
					BlendInfo.AlphaFunc = D_D3DCMP_GREATER ;
				}
				else
				{
					// Lȏꍇ̓lȌꍇ̂ݕ\Ȃ悤ɂ
					if( BlendInfo.AlphaBlendEnable == TRUE )
					{
						BlendInfo.AlphaTestEnable = TRUE ;
						BlendInfo.AlphaRef        = 0 ;
						BlendInfo.AlphaFunc       = D_D3DCMP_GREATER ;
					}
					else
					{
						BlendInfo.AlphaTestEnable = FALSE ;
						BlendInfo.AlphaRef        = GRH.BlendInfo.AlphaRef ;
						BlendInfo.AlphaFunc       = GRH.BlendInfo.AlphaFunc ;
					}
				}

				// gpeNX`[AhXZbg
				StageTexture[0] = GRH.RenderTexture ;
			}
		}

		// `l𐳂vZVF[_[gpꍇ̓_O^[Qbg̃eNX`Zbg
		if( GRH.UseAlphaChDrawShader )
		{
			StageTexture[ 2 ] = GRH.RenderTargetTexture ;
			if( StageNum < 3 )
			{
				for( i = StageNum ; i < 2 ; i ++ )
				{
					StageTexture[ i ] = NULL ;
				}
				StageNum = 3 ;
			}
		}
		
		// tOĂ邩ǂŏ𕪊	
		if( StageNum != GRH.BlendInfo.UseTextureStageNum )
		{
			int InitFlag ;
			
			GRH.BlendInfo.UseTextureStageNum = StageNum ;
			
			InitFlag = GRH.InitializeFlag ;

			GRH.InitializeFlag = TRUE ;
			SetDrawModeHardware( GRH.DrawMode ) ;
			SetMaxAnisotropyHardware( GRH.MaxAnisotropy ) ;
			GRH.InitializeFlag = InitFlag ;
		}
		if( StageNum < USE_TEXTURESTAGE_NUM ) StageNum ++ ;

		// At@eXgp[^Lȏꍇ͂D悷
		if( GRH.AlphaTestMode != -1 )
		{
			BlendInfo.AlphaTestEnable = TRUE ;
			BlendInfo.AlphaFunc = GRH.AlphaTestMode ;
			BlendInfo.AlphaRef = GRH.AlphaTestParam ;
		}
	}
	if( GRH.InitializeFlag == TRUE )
	{
		// Ăꍇ͏ԂSčXV

//		GraphicsDevice_SetRenderState( D_D3DRS_COLORKEYENABLE, BlendInfo.AlphaTestEnable ) ;
//		GRH.BlendInfo.AlphaTestEnable = BlendInfo.AlphaTestEnable ;

		GraphicsDevice_SetRenderState( D_D3DRS_ALPHAFUNC, BlendInfo.AlphaFunc ) ;
		GRH.BlendInfo.AlphaFunc = BlendInfo.AlphaFunc ;

		GraphicsDevice_SetRenderState( D_D3DRS_ALPHAREF, BlendInfo.AlphaRef ) ;
		GRH.BlendInfo.AlphaRef = BlendInfo.AlphaRef ;
		
		GraphicsDevice_SetRenderState( D_D3DRS_ALPHATESTENABLE, BlendInfo.AlphaTestEnable ) ;
		GRH.BlendInfo.AlphaTestEnable = BlendInfo.AlphaTestEnable ;

		GraphicsDevice_SetRenderState( D_D3DRS_ALPHABLENDENABLE, BlendInfo.AlphaBlendEnable ) ;
		GRH.BlendInfo.AlphaBlendEnable = BlendInfo.AlphaBlendEnable ;
			
		if( UseShaderFlag == FALSE )
		{
			GraphicsDevice_SetRenderState( D_D3DRS_TEXTUREFACTOR, BlendInfo.FactorColor ) ;
		}
		GRH.BlendInfo.FactorColor = BlendInfo.FactorColor ;

		{
			if( UseFloatFactorColor )
			{
				*( ( FLOAT4 * )GRH.FactorColorPSConstantF ) = FloatFactorColor ;
			}
			else
			{
				GRH.FactorColorPSConstantF[ 0 ] = (   BlendInfo.FactorColor         & 0xff ) / 255.0f ;
				GRH.FactorColorPSConstantF[ 1 ] = ( ( BlendInfo.FactorColor >> 8  ) & 0xff ) / 255.0f ;
				GRH.FactorColorPSConstantF[ 2 ] = ( ( BlendInfo.FactorColor >> 16 ) & 0xff ) / 255.0f ;
				GRH.FactorColorPSConstantF[ 3 ] = ( ( BlendInfo.FactorColor >> 24 ) & 0xff ) / 255.0f ;
			}
			SetShaderConstantSet(
				&GRH.ShaderConstantInfo,
				DX_SHADERCONSTANTTYPE_PS_FLOAT,
				DX_SHADERCONSTANTSET_LIB,
				DX_PS_CONSTF_FACTORCOLOR,
				GRH.FactorColorPSConstantF,
				1,
				TRUE
			) ;
		}

		if( BlendInfo.SrcBlend != -1 )
		{
			GraphicsDevice_SetRenderState( D_D3DRS_SRCBLEND, BlendInfo.SrcBlend ) ;
			GRH.BlendInfo.SrcBlend = BlendInfo.SrcBlend ;
		}
		else
		if( GRH.BlendInfo.SrcBlend > 1 )
		{
			GraphicsDevice_SetRenderState( D_D3DRS_SRCBLEND, GRH.BlendInfo.SrcBlend ) ;
		}

		if( BlendInfo.DestBlend != -1 )
		{
			GraphicsDevice_SetRenderState( D_D3DRS_DESTBLEND, BlendInfo.DestBlend ) ;
			GRH.BlendInfo.DestBlend = BlendInfo.DestBlend ;
		}
		else
		if( GRH.BlendInfo.DestBlend > 1 )
		{
			GraphicsDevice_SetRenderState( D_D3DRS_DESTBLEND, GRH.BlendInfo.DestBlend ) ;
		}

		if( BlendInfo.BlendOp != -1 )
		{
			GraphicsDevice_SetRenderState( D_D3DRS_BLENDOP, BlendInfo.BlendOp ) ;
			GRH.BlendInfo.BlendOp = BlendInfo.BlendOp ;
		}
		else
		if( GRH.BlendInfo.BlendOp > 1 )
		{
			GraphicsDevice_SetRenderState( D_D3DRS_BLENDOP, GRH.BlendInfo.BlendOp ) ;
		}

		GraphicsDevice_SetRenderState( D_D3DRS_SEPARATEALPHABLENDENABLE, BlendInfo.SeparateAlphaBlendEnable ) ;
		GRH.BlendInfo.SeparateAlphaBlendEnable = BlendInfo.SeparateAlphaBlendEnable ;

		if( BlendInfo.SrcBlendAlpha != -1 )
		{
			GraphicsDevice_SetRenderState( D_D3DRS_SRCBLENDALPHA, BlendInfo.SrcBlendAlpha ) ;
			GRH.BlendInfo.SrcBlendAlpha = BlendInfo.SrcBlendAlpha ;
		}
		else
		if( GRH.BlendInfo.SrcBlendAlpha > 1 )
		{
			GraphicsDevice_SetRenderState( D_D3DRS_SRCBLENDALPHA, GRH.BlendInfo.SrcBlendAlpha ) ;
		}

		if( BlendInfo.DestBlendAlpha != -1 )
		{
			GraphicsDevice_SetRenderState( D_D3DRS_DESTBLENDALPHA, BlendInfo.DestBlendAlpha ) ;
			GRH.BlendInfo.DestBlendAlpha = BlendInfo.DestBlendAlpha ;
		}
		else
		if( GRH.BlendInfo.DestBlendAlpha > 1 )
		{
			GraphicsDevice_SetRenderState( D_D3DRS_DESTBLENDALPHA, GRH.BlendInfo.DestBlendAlpha ) ;
		}

		if( BlendInfo.BlendOpAlpha != -1 )
		{
			GraphicsDevice_SetRenderState( D_D3DRS_BLENDOPALPHA, BlendInfo.BlendOpAlpha ) ;
			GRH.BlendInfo.BlendOpAlpha = BlendInfo.BlendOpAlpha ;
		}
		else
		if( GRH.BlendInfo.BlendOpAlpha > 1 )
		{
			GraphicsDevice_SetRenderState( D_D3DRS_BLENDOPALPHA, GRH.BlendInfo.BlendOpAlpha ) ;
		}

		if( UseShaderFlag )
		{
			Src = NULL ;
		}
		else
		{
			Src  = TextureStageInfo ;
		}
		Dest = GRH.BlendInfo.TextureStageInfo ;
		for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++, Src ++, Dest ++ )
		{
//			if( i >= 2 && Src[-1].AlphaOP == D_D3DTOP_DISABLE && TextureOnly == FALSE ) break ;

			if( i < StageNum )
			{
				GraphicsDevice_SetTexture( i, StageTexture[i] ) ;
				Dest->Texture = StageTexture[i] ;

				if( UseShaderFlag == FALSE )
				{
					if( Src->TextureCoordIndex != -1 )
					{
						GraphicsDevice_SetTextureStageState( i, D_D3DTSS_TEXCOORDINDEX, Src->TextureCoordIndex ) ;
						Dest->TextureCoordIndex = Src->TextureCoordIndex ;
					}
				}
			}
			else
			{
				GraphicsDevice_SetTexture( i, NULL ) ;
				Dest->Texture = NULL ;

				if( UseShaderFlag == FALSE )
				{
					GraphicsDevice_SetTextureStageState( i, D_D3DTSS_TEXCOORDINDEX, 0 ) ;
					Dest->TextureCoordIndex = 0 ;
				}
			}

			if( TextureOnly || ( UseShaderFlag && i != 0 ) ) continue ;

			if( UseShaderFlag )
			{
				GraphicsDevice_SetPixelShader( UsePixelShader ) ;
				GRH.SetPS = UsePixelShader ;
				GRH.NormalPS = TRUE ;
				GRH.DrawPrepAlwaysFlag = TRUE ;
			}
			else
			{
				if( i < StageNum )
				{
					if( GRH.ValidTexTempRegFlag )
					{
						if( Src->ResultTempARG != -1 )
						{
							GraphicsDevice_SetTextureStageState( i, D_D3DTSS_RESULTARG, Src->ResultTempARG ? D_D3DTA_TEMP : D_D3DTA_CURRENT ) ;
							Dest->ResultTempARG = Src->ResultTempARG ;
						}
					}

					if( Src->AlphaOP != -1 )
					{
						GraphicsDevice_SetTextureStageState( i, D_D3DTSS_ALPHAOP, Src->AlphaOP ) ;
						Dest->AlphaOP = Src->AlphaOP ;
					}

					if( Src->AlphaARG1 != -1 )
					{
						GraphicsDevice_SetTextureStageState( i, D_D3DTSS_ALPHAARG1, Src->AlphaARG1 ) ;
						Dest->AlphaARG1 = Src->AlphaARG1 ;
					}

					if( Src->AlphaARG2 != -1 )
					{
						GraphicsDevice_SetTextureStageState( i, D_D3DTSS_ALPHAARG2, Src->AlphaARG2 ) ;
						Dest->AlphaARG2 = Src->AlphaARG2 ;
					}

					if( Src->ColorOP != -1 )
					{
						GraphicsDevice_SetTextureStageState( i, D_D3DTSS_COLOROP, Src->ColorOP ) ;
						Dest->ColorOP = Src->ColorOP ;
					}

					if( Src->ColorARG1 != -1 )
					{
						GraphicsDevice_SetTextureStageState( i, D_D3DTSS_COLORARG1, Src->ColorARG1 ) ;
						Dest->ColorARG1 = Src->ColorARG1 ;
					}

					if( Src->ColorARG2 != -1 )
					{
						GraphicsDevice_SetTextureStageState( i, D_D3DTSS_COLORARG2, Src->ColorARG2 ) ;
						Dest->ColorARG2 = Src->ColorARG2 ;
					}
				}
				else
				{
					if( GRH.ValidTexTempRegFlag )
					{
						GraphicsDevice_SetTextureStageState( i, D_D3DTSS_RESULTARG, D_D3DTA_CURRENT ) ;
						Dest->ResultTempARG = FALSE ;
					}

					GraphicsDevice_SetTextureStageState( i, D_D3DTSS_ALPHAOP, D_D3DTOP_DISABLE ) ;
					Dest->AlphaOP = D_D3DTOP_DISABLE ;

					GraphicsDevice_SetTextureStageState( i, D_D3DTSS_ALPHAARG1, D_D3DTA_DIFFUSE ) ;
					Dest->AlphaARG1 = D_D3DTA_DIFFUSE ;

					GraphicsDevice_SetTextureStageState( i, D_D3DTSS_ALPHAARG2, D_D3DTA_DIFFUSE ) ;
					Dest->AlphaARG2 = D_D3DTA_DIFFUSE ;

					GraphicsDevice_SetTextureStageState( i, D_D3DTSS_COLOROP, D_D3DTOP_DISABLE ) ;
					Dest->ColorOP = D_D3DTOP_DISABLE ;

					GraphicsDevice_SetTextureStageState( i, D_D3DTSS_COLORARG1, D_D3DTA_DIFFUSE ) ;
					Dest->ColorARG1 = D_D3DTA_DIFFUSE ;

					GraphicsDevice_SetTextureStageState( i, D_D3DTSS_COLORARG2, D_D3DTA_DIFFUSE ) ;
					Dest->ColorARG2 = D_D3DTA_DIFFUSE ;
				}
			}
		}
	}
	else
	{
		// ĂȂꍇ͕ύX_̂ݍĐݒ肷

/*		if( BlendInfo.AlphaTestEnable != GRH.BlendInfo.AlphaTestEnable )
		{
			GraphicsDevice_SetRenderState( D_D3DRS_COLORKEYENABLE, BlendInfo.AlphaTestEnable ) ;
			GRH.BlendInfo.AlphaTestEnable = BlendInfo.AlphaTestEnable ;
		}
*/
		if( BlendInfo.AlphaFunc != GRH.BlendInfo.AlphaFunc )
		{
			GraphicsDevice_SetRenderState( D_D3DRS_ALPHAFUNC, BlendInfo.AlphaFunc ) ;
			GRH.BlendInfo.AlphaFunc = BlendInfo.AlphaFunc ;
		}

		if( BlendInfo.AlphaRef != GRH.BlendInfo.AlphaRef )
		{
			GraphicsDevice_SetRenderState( D_D3DRS_ALPHAREF, BlendInfo.AlphaRef ) ;
			GRH.BlendInfo.AlphaRef = BlendInfo.AlphaRef ;
		}
		
		if( BlendInfo.AlphaTestEnable != GRH.BlendInfo.AlphaTestEnable )
		{
			GraphicsDevice_SetRenderState( D_D3DRS_ALPHATESTENABLE, BlendInfo.AlphaTestEnable ) ;
			GRH.BlendInfo.AlphaTestEnable = BlendInfo.AlphaTestEnable ;
		}
		
		if( BlendInfo.AlphaBlendEnable != GRH.BlendInfo.AlphaBlendEnable )
		{
			GraphicsDevice_SetRenderState( D_D3DRS_ALPHABLENDENABLE, BlendInfo.AlphaBlendEnable ) ;
			GRH.BlendInfo.AlphaBlendEnable = BlendInfo.AlphaBlendEnable ;
		}
			
		if( BlendInfo.FactorColor != GRH.BlendInfo.FactorColor )
		{
			if( UseShaderFlag == FALSE )
			{
				GraphicsDevice_SetRenderState( D_D3DRS_TEXTUREFACTOR, BlendInfo.FactorColor ) ;
			}
			GRH.BlendInfo.FactorColor = BlendInfo.FactorColor ;
		}

		{
			float FactorData[ 4 ] ;

			if( UseFloatFactorColor )
			{
				*( ( FLOAT4 * )FactorData ) = FloatFactorColor ;
			}
			else
			{
				FactorData[ 0 ] = (   BlendInfo.FactorColor         & 0xff ) / 255.0f ;
				FactorData[ 1 ] = ( ( BlendInfo.FactorColor >> 8  ) & 0xff ) / 255.0f ;
				FactorData[ 2 ] = ( ( BlendInfo.FactorColor >> 16 ) & 0xff ) / 255.0f ;
				FactorData[ 3 ] = ( ( BlendInfo.FactorColor >> 24 ) & 0xff ) / 255.0f ;
			}
			if( _MEMCMP( GRH.FactorColorPSConstantF, FactorData, sizeof( float ) * 4 ) != 0 )
			{
				_MEMCPY( GRH.FactorColorPSConstantF, FactorData, sizeof( float ) * 4 ) ;
				SetShaderConstantSet(
					&GRH.ShaderConstantInfo,
					DX_SHADERCONSTANTTYPE_PS_FLOAT,
					DX_SHADERCONSTANTSET_LIB,
					DX_PS_CONSTF_FACTORCOLOR,
					FactorData,
					1,
					TRUE
				) ;
			}
		}

		if( BlendInfo.SrcBlend != -1 && BlendInfo.SrcBlend != GRH.BlendInfo.SrcBlend )
		{
			GraphicsDevice_SetRenderState( D_D3DRS_SRCBLEND, BlendInfo.SrcBlend ) ;
			GRH.BlendInfo.SrcBlend = BlendInfo.SrcBlend ;
		}

		if( BlendInfo.DestBlend != -1 && BlendInfo.DestBlend != GRH.BlendInfo.DestBlend )
		{
			GraphicsDevice_SetRenderState( D_D3DRS_DESTBLEND, BlendInfo.DestBlend ) ;
			GRH.BlendInfo.DestBlend = BlendInfo.DestBlend ;
		}

		if( BlendInfo.BlendOp != -1 && BlendInfo.BlendOp != GRH.BlendInfo.BlendOp )
		{
			GraphicsDevice_SetRenderState( D_D3DRS_BLENDOP, BlendInfo.BlendOp ) ;
			GRH.BlendInfo.BlendOp = BlendInfo.BlendOp ;
		}

		if( BlendInfo.SeparateAlphaBlendEnable != GRH.BlendInfo.SeparateAlphaBlendEnable )
		{
			GraphicsDevice_SetRenderState( D_D3DRS_SEPARATEALPHABLENDENABLE, BlendInfo.SeparateAlphaBlendEnable ) ;
			GRH.BlendInfo.SeparateAlphaBlendEnable = BlendInfo.SeparateAlphaBlendEnable ;
		}

		if( BlendInfo.SrcBlendAlpha != -1 && BlendInfo.SrcBlendAlpha != GRH.BlendInfo.SrcBlendAlpha )
		{
			GraphicsDevice_SetRenderState( D_D3DRS_SRCBLENDALPHA, BlendInfo.SrcBlendAlpha ) ;
			GRH.BlendInfo.SrcBlendAlpha = BlendInfo.SrcBlendAlpha ;
		}

		if( BlendInfo.DestBlendAlpha != -1 && BlendInfo.DestBlendAlpha != GRH.BlendInfo.DestBlendAlpha )
		{
			GraphicsDevice_SetRenderState( D_D3DRS_DESTBLENDALPHA, BlendInfo.DestBlendAlpha ) ;
			GRH.BlendInfo.DestBlendAlpha = BlendInfo.DestBlendAlpha ;
		}

		if( BlendInfo.BlendOpAlpha != -1 && BlendInfo.BlendOpAlpha != GRH.BlendInfo.BlendOpAlpha )
		{
			GraphicsDevice_SetRenderState( D_D3DRS_BLENDOPALPHA, BlendInfo.BlendOpAlpha ) ;
			GRH.BlendInfo.BlendOpAlpha = BlendInfo.BlendOpAlpha ;
		}


		if( UseShaderFlag )
		{
			Src = NULL ;
		}
		else
		{
			Src  = TextureStageInfo ;
		}
		int UseShaderStageNum = GRH.UseAlphaChDrawShader ? 3 : 2 ;
		Dest = GRH.BlendInfo.TextureStageInfo ;
		for( i = 0 ; i < StageNum ; i ++, Src ++, Dest ++ )
		{
			if( i >= UseShaderStageNum && ( UseShaderFlag || Src[-1].AlphaOP == D_D3DTOP_DISABLE ) && TextureOnly == FALSE ) break ;

			if( StageTexture[i] != Dest->Texture )
			{
				HRESULT hr ;

				hr = GraphicsDevice_SetTexture( i, StageTexture[i] ) ;
				Dest->Texture = StageTexture[i] ;
			}

			if( UseShaderFlag == FALSE )
			{
				if( Src->TextureCoordIndex != -1 && Src->TextureCoordIndex != Dest->TextureCoordIndex )
				{
					GraphicsDevice_SetTextureStageState( i, D_D3DTSS_TEXCOORDINDEX, Src->TextureCoordIndex ) ;
					Dest->TextureCoordIndex = Src->TextureCoordIndex ;
				}
			}

			if( TextureOnly || ( UseShaderFlag && i != 0 ) ) continue ;

			if( UseShaderFlag )
			{
				if( GRH.SetPS != UsePixelShader )
				{
					GraphicsDevice_SetPixelShader( UsePixelShader ) ;
					GRH.SetPS = UsePixelShader ;
					GRH.NormalPS = TRUE ;
					GRH.DrawPrepAlwaysFlag = TRUE ;
				}
			}
			else
			{
				if( GRH.ValidTexTempRegFlag )
				{
					if( Src->ResultTempARG != -1 && Src->ResultTempARG != Dest->ResultTempARG )
					{
						GraphicsDevice_SetTextureStageState( i, D_D3DTSS_RESULTARG, Src->ResultTempARG ? D_D3DTA_TEMP : D_D3DTA_CURRENT ) ;
						Dest->ResultTempARG = Src->ResultTempARG ;
					}
				}

				if( Src->AlphaOP != -1 && Src->AlphaOP != Dest->AlphaOP )
				{
					GraphicsDevice_SetTextureStageState( i, D_D3DTSS_ALPHAOP, Src->AlphaOP ) ;
					Dest->AlphaOP = Src->AlphaOP ;
				}

				if( Src->AlphaARG1 != -1 && Src->AlphaARG1 != Dest->AlphaARG1 )
				{
					GraphicsDevice_SetTextureStageState( i, D_D3DTSS_ALPHAARG1, Src->AlphaARG1 ) ;
					Dest->AlphaARG1 = Src->AlphaARG1 ;
				}

				if( Src->AlphaARG2 != -1 && Src->AlphaARG2 != Dest->AlphaARG2 )
				{
					GraphicsDevice_SetTextureStageState( i, D_D3DTSS_ALPHAARG2, Src->AlphaARG2 ) ;
					Dest->AlphaARG2 = Src->AlphaARG2 ;
				}

				if( Src->ColorOP != -1 && Src->ColorOP != Dest->ColorOP )
				{
					GraphicsDevice_SetTextureStageState( i, D_D3DTSS_COLOROP, Src->ColorOP ) ;
					Dest->ColorOP = Src->ColorOP ;
				}

				if( Src->ColorARG1 != -1 && Src->ColorARG1 != Dest->ColorARG1 )
				{
					GraphicsDevice_SetTextureStageState( i, D_D3DTSS_COLORARG1, Src->ColorARG1 ) ;
					Dest->ColorARG1 = Src->ColorARG1 ;
				}

				if( Src->ColorARG2 != -1 && Src->ColorARG2 != Dest->ColorARG2 )
				{
					GraphicsDevice_SetTextureStageState( i, D_D3DTSS_COLORARG2, Src->ColorARG2 ) ;
					Dest->ColorARG2 = Src->ColorARG2 ;
				}
			}
		}
		for( ; i < USE_TEXTURESTAGE_NUM ; i ++, Dest ++ )
		{
			if( Dest->Texture != NULL )
			{
				GraphicsDevice_SetTexture( i, NULL ) ;
				Dest->Texture = NULL ;
			}
		}
	}
	
	// I
	return 0 ;
}

// `惂[h̃Zbg
static int  SetDrawModeHardware( int DrawMode )
{
	int i, num ;

	if( GraphicsDevice_IsValid() == 0 ) return -1 ;
	if( GRH.DrawMode == DrawMode && GRH.InitializeFlag == FALSE ) return 0 ;

	if( GRH.InitializeFlag == FALSE )
	{
		// _o
		RenderVertexHardware() ;
	}

	// _OݒύX
	num = GRH.BlendInfo.UseTextureStageNum ;
	if( num < 4 ) num = 4 ;
	switch( DrawMode )
	{
	case DX_DRAWMODE_BILINEAR :
		// oCjA`
		for( i = 0 ; i < num ; i ++ )
		{
			if( GRH.MagFilter[ i ] != D_D3DTEXF_LINEAR || GRH.InitializeFlag )
			{
				GraphicsDevice_SetSamplerState( i, D_D3DSAMP_MAGFILTER, D_D3DTEXF_LINEAR ) ;
				GRH.MagFilter[ i ] = D_D3DTEXF_LINEAR ;
			}
			if( GRH.MinFilter[ i ] != D_D3DTEXF_LINEAR || GRH.InitializeFlag )
			{
				GraphicsDevice_SetSamplerState( i, D_D3DSAMP_MINFILTER, D_D3DTEXF_LINEAR ) ;
				GRH.MinFilter[ i ] = D_D3DTEXF_LINEAR ;
			}
			if( GRH.MipFilter[ i ] != D_D3DTEXF_LINEAR || GRH.InitializeFlag )
			{
				GraphicsDevice_SetSamplerState( i, D_D3DSAMP_MIPFILTER, D_D3DTEXF_NONE ) ;
				GRH.MipFilter[ i ] = D_D3DTEXF_NONE ;
			}
		}
		break ;

	case DX_DRAWMODE_NEAREST :
		// AXglCo[
		for( i = 0 ; i < num ; i ++ )
		{
			if( GRH.MagFilter[ i ] != D_D3DTEXF_POINT || GRH.InitializeFlag )
			{
				GraphicsDevice_SetSamplerState( i, D_D3DSAMP_MAGFILTER, D_D3DTEXF_POINT ) ;
				GRH.MagFilter[ i ] = D_D3DTEXF_POINT ;
			}
			if( GRH.MinFilter[ i ] != D_D3DTEXF_POINT || GRH.InitializeFlag )
			{
				GraphicsDevice_SetSamplerState( i, D_D3DSAMP_MINFILTER, D_D3DTEXF_POINT ) ;
				GRH.MinFilter[ i ] = D_D3DTEXF_POINT ;
			}
			if( GRH.MipFilter[ i ] != D_D3DTEXF_POINT || GRH.InitializeFlag )
			{
				GraphicsDevice_SetSamplerState( i, D_D3DSAMP_MIPFILTER, D_D3DTEXF_NONE ) ;
				GRH.MipFilter[ i ] = D_D3DTEXF_NONE ;
			}
		}
		break ;

	case DX_DRAWMODE_ANISOTROPIC :
		// ٕtB^O
		for( i = 0 ; i < num ; i ++ )
		{
			if( GRH.MagFilter[ i ] != D_D3DTEXF_LINEAR || GRH.InitializeFlag )
			{
				GraphicsDevice_SetSamplerState( i, D_D3DSAMP_MAGFILTER, D_D3DTEXF_LINEAR ) ;
				GRH.MagFilter[ i ] = D_D3DTEXF_LINEAR ;
			}
			if( GRH.MinFilter[ i ] != D_D3DTEXF_ANISOTROPIC || GRH.InitializeFlag )
			{
				GraphicsDevice_SetSamplerState( i, D_D3DSAMP_MINFILTER, D_D3DTEXF_ANISOTROPIC ) ;
				GRH.MinFilter[ i ] = D_D3DTEXF_ANISOTROPIC ;
			}
			if( GRH.MipFilter[ i ] != D_D3DTEXF_LINEAR || GRH.InitializeFlag )
			{
				GraphicsDevice_SetSamplerState( i, D_D3DSAMP_MIPFILTER, D_D3DTEXF_LINEAR ) ;
				GRH.MipFilter[ i ] = D_D3DTEXF_LINEAR ;
			}
		}
		break ;

	default : return -1 ;
	}
	GRH.DrawMode = DrawMode ;
	GRH.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// őٕ̃Zbg
static int SetMaxAnisotropyHardware( int MaxAnisotropy )
{
	int i, num ;

	if( GraphicsDevice_IsValid() == 0 ) return -1 ;
	if( GRH.MaxAnisotropy == MaxAnisotropy && GRH.InitializeFlag == FALSE ) return 0 ;

	// l̕␳
	if( MaxAnisotropy < 1 )
		MaxAnisotropy = 1 ;

	// _o
	RenderVertexHardware() ;

	// _OݒύX
	num = GRH.BlendInfo.UseTextureStageNum ;
	if( num < 4 ) num = 4 ;
	for( i = 0 ; i < num ; i ++ )
	{
		if( GRH.MaxAnisotropyDim[ i ] != MaxAnisotropy )
		{
			GraphicsDevice_SetSamplerState( i, D_D3DSAMP_MAXANISOTROPY, MaxAnisotropy ) ;
			GRH.MaxAnisotropyDim[ i ] = MaxAnisotropy ;
		}
	}

	GRH.MaxAnisotropy = MaxAnisotropy ;
	GRH.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// `uh[h̐ݒ
static int SetDrawBlendModeHardware( int BlendMode, int AlphaTestValidFlag, int AlphaChannelValidFlag )
{
	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	if( GRH.InitializeFlag == FALSE && GRH.BlendMode == BlendMode && GRH.AlphaTestValidFlag == AlphaTestValidFlag && GRH.AlphaChannelValidFlag == AlphaChannelValidFlag ) return 0 ;

	// _̏o
	RenderVertexHardware() ;

	GRH.BlendMode             = BlendMode ;
	GRH.AlphaChannelValidFlag = AlphaChannelValidFlag ;
	GRH.AlphaTestValidFlag    = AlphaTestValidFlag ;
	GRH.DrawPrepAlwaysFlag    = TRUE ;

	// p[^ύXꂽAtO𗧂Ă
	GRH.ChangeBlendParamFlag = TRUE ;

	return 0 ;
}

// `掞̉摜̐F𖳎邩ǂݒ肷
static int	SetIgnoreDrawGraphColorHardware( int EnableFlag )
{
	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	if( GRH.InitializeFlag == FALSE &&
		GRH.IgnoreGraphColorFlag == EnableFlag )
		return 0 ;

	// _̏o
	RenderVertexHardware() ;

	GRH.IgnoreGraphColorFlag = EnableFlag ;
	GRH.DrawPrepAlwaysFlag = TRUE ;

	// p[^ύXꂽAtO𗧂Ă
	GRH.ChangeBlendParamFlag = TRUE ;

	return 0 ;
}

// At@eXg̐ݒ
static int  SetDrawAlphaTestHardware( int TestMode, int TestParam )
{
	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	if( GRH.InitializeFlag == FALSE && GRH.AlphaTestMode == TestMode && GRH.AlphaTestParam == TestParam ) return 0 ;

	// _̏o
	RenderVertexHardware() ;

	GRH.AlphaTestMode  = TestMode ;
	GRH.AlphaTestParam = TestParam ;
	GRH.DrawPrepAlwaysFlag = TRUE ;

	// p[^ύXꂽAtO𗧂Ă
	GRH.ChangeBlendParamFlag = TRUE ;

	return 0 ;
}

// `Ώۂ̕ύX
extern int SetRenderTargetHardware( DX_DIRECT3DSURFACE9 *TargetSurface, int TargetIndex )
{
	D_D3DSURFACE_DESC SurfaceDesc ;
	HRESULT hr ;

	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	if( TargetIndex < 0 || TargetIndex >= DX_RENDERTARGET_COUNT ) return -1 ;

	if( GRH.TargetSurface[ TargetIndex ] == TargetSurface && GRH.InitializeFlag == FALSE ) return 0 ;

	// _o
	RenderVertexHardware() ;

	// _O^[Qbg̕ύX
	hr = GraphicsDevice_SetRenderTarget( TargetIndex, TargetSurface ) ;

	// _O^[Qbg̕ۑ
	GRH.TargetSurface[ TargetIndex ] = TargetSurface ;

	// r[|[g̐ݒlXV
	if( TargetIndex == 0 )
	{
		GraphicsSurface_GetDesc( TargetSurface, &SurfaceDesc ) ; 
		SetViewportHardwareEasy( 0, 0, SurfaceDesc.Width, SurfaceDesc.Height ) ;
	}

	// I
	return  0 ;
}

// eNX`Xe[WXe[g𒼐ڎw肷( NULL Ŗ )
extern int SetUserBlendInfo( DIRECT3DBLENDINFO *BlendInfo, int TextureStageIsTextureAndTextureCoordOnlyFlag )
{
	RenderVertexHardware() ;

	if( BlendInfo == NULL )
	{
		GRH.UserBlendInfoFlag = FALSE ;
	}
	else
	{
		GRH.UserBlendInfo = *BlendInfo ;
		GRH.UserBlendInfoTextureStageIsTextureAndTextureCoordOnlyFlag = TextureStageIsTextureAndTextureCoordOnlyFlag ;
		GRH.UserBlendInfoFlag = TRUE ;
		GRH.DrawPrepAlwaysFlag = TRUE ;
		GRH.ChangeBlendParamFlag = TRUE ;
		GRH.ChangeTextureFlag = TRUE ;

		// uh[htbV
		RefreshBlendStateHardware() ;
	}

	// I
	return 0 ;
}

// yobt@̗L̃Zbg
static int SetUseZBufferHardware( int Flag )
{
	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	// tO牽I
	if( GRH.InitializeFlag == FALSE && GRH.EnableZBufferFlag == Flag ) return 0 ;

	if( GRH.InitializeFlag == FALSE )
	{
		// _o
		RenderVertexHardware() ;
	}

	// yobt@̗LԂύX
	GraphicsDevice_SetRenderState( D_D3DRS_ZENABLE, Flag == TRUE ? D_D3DZB_TRUE : D_D3DZB_FALSE ) ;
	GRH.EnableZBufferFlag = Flag ;
	GRH.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// yobt@݂̗̏LZbg
static int SetWriteZBufferHardware( int Flag )
{
	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	// tO牽I
	if( GRH.InitializeFlag == FALSE && GRH.WriteZBufferFlag == Flag ) return 0 ;

	if( GRH.InitializeFlag == FALSE )
	{
		// _o
		RenderVertexHardware() ;
	}

	// yobt@̏ݏԂύX
	GraphicsDevice_SetRenderState( D_D3DRS_ZWRITEENABLE, Flag ) ;
	GRH.WriteZBufferFlag = Flag ;
	GRH.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// yl̔r^CvZbg
static int SetZBufferCmpTypeHardware( int CmpType )
{
	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	// ^Cv牽I
	if( GRH.InitializeFlag == FALSE && GRH.ZBufferCmpType == CmpType ) return 0 ;

	if( GRH.InitializeFlag == FALSE )
	{
		// _o
		RenderVertexHardware() ;
	}

	// yl̔r^CvύX
	GraphicsDevice_SetRenderState( D_D3DRS_ZFUNC, CmpType ) ;
	GRH.ZBufferCmpType = CmpType ;
	GRH.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// yoCAXZbg
static int SetZBiasHardware( int Bias )
{
	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	// oCAXl牽I
	if( GRH.InitializeFlag == FALSE && GRH.ZBias == Bias ) return 0 ;

	if( GRH.InitializeFlag == FALSE )
	{
		// _o
		RenderVertexHardware() ;
	}

	// yoCAXύX
	GraphicsDevice_SetRenderState( D_D3DRS_DEPTHBIAS, Bias ) ;
	GRH.ZBias = Bias ;
	GRH.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// tB[hZbg
static int	SetFillModeHardware( int FillMode )
{
	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	// tB[h牽I
	if( GRH.InitializeFlag == FALSE && GRH.FillMode == FillMode ) return 0 ;

	if( GRH.InitializeFlag == FALSE )
	{
		// _o
		RenderVertexHardware() ;
	}

	// tB[hύX
	GraphicsDevice_SetRenderState( D_D3DRS_FILLMODE, FillMode ) ;
	GRH.FillMode = FillMode ;
	GRH.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// eNX`Zbg 
__inline static int SetTextureHardware( DX_DIRECT3DTEXTURE9 * RenderTexture )
{
	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	if( RenderTexture == GRH.RenderTexture && GRH.InitializeFlag == FALSE ) return 0 ;

	if( GRH.InitializeFlag == FALSE )
	{
		// _o
		RenderVertexHardware() ;
	}

	// eNX`ύXꂽAtO𗧂Ă
	GRH.ChangeTextureFlag = TRUE ;

	// eNX`̗L薳ύXꂽꍇ̓uhp[^̕ύXstOZbg
	if( ( GRH.RenderTexture == NULL && RenderTexture != NULL ) ||
		( GRH.RenderTexture != NULL && RenderTexture == NULL ) )
		GRH.ChangeBlendParamFlag = TRUE ;

	// eNX`Zbg
	GRH.RenderTexture = RenderTexture ;
	GRH.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// uheNX`Zbg 
__inline static int SetBlendTextureHardware( DX_DIRECT3DTEXTURE9 *BlendTexture, int TexWidth, int TexHeight )
{
	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	if( GRH.InitializeFlag == FALSE && BlendTexture == GRH.BlendTexture ) return 0 ;

	if( GRH.InitializeFlag == FALSE )
	{
		// _̏o
		RenderVertexHardware() ;
	}

	// eNX`ύXꂽAtO𗧂Ă
	GRH.ChangeTextureFlag = TRUE ;
	GRH.DrawPrepAlwaysFlag = TRUE ;

	// uheNX`̗L薳ύXꂽꍇ̓uhp[^̕ύXstOZbg
	if( ( GRH.BlendTexture == NULL && BlendTexture != NULL ) ||
		( GRH.BlendTexture != NULL && BlendTexture == NULL ) )
		GRH.ChangeBlendParamFlag = TRUE ;

	// eNX`Zbg
	GRH.BlendTexture = BlendTexture ;

	// eNX`̕ƍۑ
	if( BlendTexture != NULL )
	{
		GRH.BlendTextureWidth  = ( float )TexWidth  ;
		GRH.BlendTextureHeight = ( float )TexHeight ;
		GRH.InvBlendTextureWidth  = 1.0F / GRH.BlendTextureWidth ;
		GRH.InvBlendTextureHeight = 1.0F / GRH.BlendTextureHeight ;
	}

	// I
	return 0 ;
}

// uheNX`̃p[^Zbg
__inline static int SetBlendTextureParamHardware( int BlendType, int *Param )
{
	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	// p[^ۑ
	switch( BlendType )
	{
	case DX_BLENDGRAPHTYPE_NORMAL :
		if( GRH.InitializeFlag == FALSE &&
			BlendType == GRH.BlendGraphType &&
			GRH.BlendGraphFadeRatio == Param[ 0 ] )
			return 0 ;

		if( GRH.InitializeFlag == FALSE )
		{
			// _̏o
			RenderVertexHardware() ;
		}

		GRH.BlendGraphFadeRatio = Param[ 0 ] ;
		break;

	case DX_BLENDGRAPHTYPE_WIPE:
		if( GRH.InitializeFlag == FALSE &&
			BlendType == GRH.BlendGraphType &&
			GRH.BlendGraphBorderParam == Param[ 0 ] &&
			GRH.BlendGraphBorderRange == Param[ 1 ] )
			return 0 ;

		if( GRH.InitializeFlag == FALSE )
		{
			// _̏o
			RenderVertexHardware() ;
		}

		GRH.BlendGraphBorderParam = Param[ 0 ] ;
		GRH.BlendGraphBorderRange = Param[ 1 ] ;
		break;

	case DX_BLENDGRAPHTYPE_ALPHA :
		if( GRH.InitializeFlag == FALSE &&
			BlendType == GRH.BlendGraphType )
			return 0 ;

		if( GRH.InitializeFlag == FALSE )
		{
			// _̏o
			RenderVertexHardware() ;
		}
		break;
	}

	// uh^Cvۑ
	GRH.BlendGraphType = BlendType ;

	// p[^ύXꂽAtO𗧂Ă
	GRH.ChangeBlendParamFlag = TRUE ;
	GRH.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// fBt[YJ[̃lgp邩ǂtOZbg
static int SetUseDiffuseAlphaColorFlagHardware( int UseFlag )
{
	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	if( UseFlag == GRH.UseDiffuseAlphaColor && GRH.InitializeFlag == FALSE ) return 0 ;

	// _̏o
	RenderVertexHardware() ;

	// p[^̕ۑ
	GRH.UseDiffuseAlphaColor = UseFlag ;
	GRH.DrawPrepAlwaysFlag = TRUE ;

	// p[^ύXꂽAtO𗧂Ă
	GRH.ChangeBlendParamFlag = TRUE ;

	// I
	return 0 ;
}

// fBt[YJ[̂qfalgp邩ǂtOZbg
static int SetUseDiffuseRGBColorFlagHardware( int UseFlag )
{
	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	if( UseFlag == GRH.UseDiffuseRGBColor && GRH.InitializeFlag == FALSE ) return 0 ;

	// _̏o
	RenderVertexHardware() ;

	// p[^̕ۑ
	GRH.UseDiffuseRGBColor = UseFlag ;
	GRH.DrawPrepAlwaysFlag = TRUE ;

	// p[^ύXꂽAtO𗧂Ă
	GRH.ChangeBlendParamFlag = TRUE ;

	// I
	return 0 ;
}

// `ݒtbV
static void RefreshRenderStateHardware()
{
	if( GraphicsDevice_IsValid() == 0 ) return ;

	// tO𗧂Ă
	GRH.InitializeFlag = TRUE ;

	// DrawPreparation sׂtO𗧂Ă
	GRH.DrawPrepAlwaysFlag = TRUE ;

	// ݒ̃tbV
	SetFogEnableHardware         ( GRH.FogEnable          ) ;
	SetViewportHardware          ( &GRH.Viewport          ) ;
	SetScissorRectHardware       ( &GRH.ScissorRect       ) ;
	SetTextureHardware			 ( GRH.RenderTexture      ) ;
	SetBaseHardwareState         (                        ) ;
	SetDrawModeHardware          ( GRH.DrawMode           ) ;
//	SetDrawBlendModeHardware     ( GRH.BlendMode, GRH.AlphaChannelValidFlag  ) ;
	RefreshBlendStateHardware    (                        ) ;
	SetUseZBufferHardware        ( GRH.EnableZBufferFlag  ) ;
	SetWriteZBufferHardware      ( GRH.WriteZBufferFlag   ) ;
	SetZBufferCmpTypeHardware    ( GRH.ZBufferCmpType     ) ;
	SetZBiasHardware             ( GRH.ZBias              ) ;
	SetFillModeHardware          ( GRH.FillMode           ) ;
	SetUseCullingHardware        ( GRH.CullMode           ) ;
	SetShadeModeHardware         ( GRH.ShadeMode          ) ;
	SetMaterialHardware          ( &GRH.Material          ) ;
	SetUseSpecularHardware       ( GRH.UseSpecular        ) ;
	SetMaterialUseVertexDiffuseColorHardware( GRH.MaterialUseVertexDiffuseColor ) ;
	SetMaterialUseVertexSpecularColorHardware( GRH.MaterialUseVertexSpecularColor ) ;

	if( GraphicsDevice_IsValid() != 0 )
	{
		GraphicsDevice_SetVertexShaderConstantF( 0, ( float * )GRH.ShaderConstantInfo.FixInfo[ DX_SHADERCONSTANTTYPE_VS_FLOAT ].Float4, 256 ) ;
		GraphicsDevice_SetVertexShaderConstantI( 0, ( int   * )GRH.ShaderConstantInfo.FixInfo[ DX_SHADERCONSTANTTYPE_VS_INT   ].Int4,   16  ) ;
		GraphicsDevice_SetVertexShaderConstantB( 0, ( BOOL  * )GRH.ShaderConstantInfo.FixInfo[ DX_SHADERCONSTANTTYPE_VS_BOOL  ].Bool,   16  ) ;

		GraphicsDevice_SetPixelShaderConstantF( 0, ( float * )GRH.ShaderConstantInfo.FixInfo[ DX_SHADERCONSTANTTYPE_PS_FLOAT ].Float4, 224 ) ;
		GraphicsDevice_SetPixelShaderConstantI( 0, ( int   * )GRH.ShaderConstantInfo.FixInfo[ DX_SHADERCONSTANTTYPE_PS_INT   ].Int4,   16  ) ;
		GraphicsDevice_SetPixelShaderConstantB( 0, ( BOOL  * )GRH.ShaderConstantInfo.FixInfo[ DX_SHADERCONSTANTTYPE_PS_BOOL  ].Bool,   16  ) ;
	}

	// tO|
	GRH.InitializeFlag = FALSE ;
}

// [hϊpsZbg
static int SetTransformToWorldHardware( const MATRIX *Matrix )
{
	if( GraphicsDevice_IsValid() == 0 ) return 0 ;

	GraphicsDevice_SetTransform( D_D3DTS_WORLDMATRIX( 0 ), ( D_D3DMATRIX * )Matrix ) ;

//	if( GRH.UseShader )
	{
		// ]us𒸓_VF[_[ɃZbg
		MATRIX TransMat ;
		CreateTransposeMatrix( &TransMat, Matrix ) ;
		SetShaderConstantSet(
			&GRH.ShaderConstantInfo,
			DX_SHADERCONSTANTTYPE_VS_FLOAT,
			DX_SHADERCONSTANTSET_LIB,
			DX_VS_CONSTF_WORLD_MAT_START,
			&TransMat,
			4,
			TRUE
		) ;
	}

	// I
	return 0 ;
}

// ArGgCgƃG~bVuJ[|킹p[^XV
void RefreshAmbientAndEmissiveParam()
{
	int i ;
	COLOR Result ;

	// ʒl
	Result.r = 0.0f ;
	Result.g = 0.0f ;
	Result.b = 0.0f ;
	Result.a = 0.0f ;

	// LȃCg̃ArGgJ[ƃ}eÃArGgJ[ẐVF[_[ɃZbg
	for( i = 0 ; i <= GRH.LightEnableMaxIndex ; i ++ )
	{
		if( GRH.LightEnableFlag[ i ] == FALSE ) continue ;
		Result.r = GRH.LightParam[ i ].Ambient.r * GRH.Material.Ambient.r ;
		Result.g = GRH.LightParam[ i ].Ambient.g * GRH.Material.Ambient.g ;
		Result.b = GRH.LightParam[ i ].Ambient.b * GRH.Material.Ambient.b ;
		Result.a = GRH.LightParam[ i ].Ambient.a * GRH.Material.Ambient.a ;

		// o[ebNXVF[_[ƃsNZVF[_[ɔf
		if( i < DX_VS_CONSTB_LIGHT_NUM )
		{
			SetShaderConstantSet(
				&GRH.ShaderConstantInfo,
				DX_SHADERCONSTANTTYPE_VS_FLOAT,
				DX_SHADERCONSTANTSET_LIB,
				DX_VS_CONSTF_LIGHT_START + DX_VS_CONSTF_LIGHT_UNITSIZE * i + DX_VS_CONSTF_LGT_AMBIENT,
				&Result,
				1,
				TRUE
			) ;
			SetShaderConstantSet(
				&GRH.ShaderConstantInfo,
				DX_SHADERCONSTANTTYPE_PS_FLOAT,
				DX_SHADERCONSTANTSET_LIB,
				DX_PS_CONSTF_LIGHT_START  + DX_PS_CONSTF_LIGHT_UNITSIZE  * i + DX_PS_CONSTF_LGT_AMBIENT,
				&Result,
				1,
				TRUE
			) ;
		}
		if( i < DX_PS_CONSTB_LIGHT2_NUM )
		{
			SetShaderConstantSet(
				&GRH.ShaderConstantInfo,
				DX_SHADERCONSTANTTYPE_PS_FLOAT,
				DX_SHADERCONSTANTSET_LIB,
				DX_PS_CONSTF_LIGHT2_START  + DX_PS_CONSTF_LIGHT2_UNITSIZE  * i + DX_PS_CONSTF_LGT2_AMBIENT,
				&Result,
				1,
				TRUE
			) ;
		}
	}

	// O[oArGgCgJ[ƃ}eAArGgJ[ẐƃG~bVuJ[Ẑ쐬
	Result.r = GRH.GlobalAmbientLightColor.r * GRH.Material.Ambient.r + GRH.Material.Emissive.r ;
	Result.g = GRH.GlobalAmbientLightColor.g * GRH.Material.Ambient.g + GRH.Material.Emissive.g ;
	Result.b = GRH.GlobalAmbientLightColor.b * GRH.Material.Ambient.b + GRH.Material.Emissive.b ;
	Result.a = GRH.GlobalAmbientLightColor.a * GRH.Material.Ambient.a + GRH.Material.Emissive.a ;

	// o[ebNXVF[_[ƃsNZVF[_[ɔf
	SetShaderConstantSet(
		&GRH.ShaderConstantInfo,
		DX_SHADERCONSTANTTYPE_VS_FLOAT,
		DX_SHADERCONSTANTSET_LIB,
		DX_VS_CONSTF_AMBIENT_EMISSIVE,
		&Result,
		1,
		TRUE
	) ;
	SetShaderConstantSet(
		&GRH.ShaderConstantInfo,
		DX_SHADERCONSTANTTYPE_PS_FLOAT,
		DX_SHADERCONSTANTSET_LIB,
		DX_PS_CONSTF_AMBIENT_EMISSIVE,
		&Result,
		1,
		TRUE
	) ;
}

// gpVF[_[̃CfbNX̒lXV
static void RefreshUseShaderIndex()
{
	int LightMode[ DX_PS_CONSTB_LIGHT2_NUM ] ;
	int PhongValid ;
	int i ;

	if( GRH.UseShader == FALSE ) return ;

	PhongValid = 0 ;
	LightMode[ 0 ] = 0 ;
	LightMode[ 1 ] = 0 ;
	LightMode[ 2 ] = 0 ;
	LightMode[ 3 ] = 0 ;
	LightMode[ 4 ] = 0 ;
	LightMode[ 5 ] = 0 ;
	GRH.UseOnlyShaderModel3Code = FALSE ;
	if( GRH.LightFlag )
	{
		for( i = 0 ; i < DX_PS_CONSTB_LIGHT2_NUM ; i ++ )
		{
			if( GRH.LightEnableFlag[ i ] )
			{
				LightMode[ i ] = GRH.LightParam[ i ].Type ;
				PhongValid = 1 ;

				// Shader Model 2.0 ł̓Cg͂R܂łΉĂȂ
				if( i >= 3 )
				{
					GRH.UseOnlyShaderModel3Code = TRUE ;
				}
			}
		}
	}

	GRH.UseBaseVertexShaderIndex =
		VS_LIGHTUSE( GRH.LightFlag ) + 
		VS_PHONG( PhongValid ) +
		VS_FOGMODE( GRH.FogEnable ? GRH.FogMode : DX_FOGMODE_NONE ) +
		VS_LIGHTINDEX( GRA2.LightIndexList[ LightMode[ 0 ] ][ LightMode[ 1 ] ][ LightMode[ 2 ] ] ) //+
//		VS_LIGHT0TYPE( LightMode[ 0 ] ) +
//		VS_LIGHT1TYPE( LightMode[ 1 ] ) +
//		VS_LIGHT2TYPE( LightMode[ 2 ] ) +
//		VS_DIFCSOURCE( 0 ) + VS_SPECSOURCE( 0 )
	;

	GRH.UseBasePixelShaderIndex =
		PS_LIGHTUSE( GRH.LightFlag ) + 
		PS_PHONG( PhongValid ) +
		PS_LIGHT0TYPE( LightMode[ 0 ] == DX_LIGHTTYPE_D3DLIGHT_DIRECTIONAL ? 2 : ( LightMode[ 0 ] ? 1 : 0 ) ) +
		PS_LIGHT1TYPE( LightMode[ 1 ] == DX_LIGHTTYPE_D3DLIGHT_DIRECTIONAL ? 2 : ( LightMode[ 1 ] ? 1 : 0 ) ) +
		PS_LIGHT2TYPE( LightMode[ 2 ] == DX_LIGHTTYPE_D3DLIGHT_DIRECTIONAL ? 2 : ( LightMode[ 2 ] ? 1 : 0 ) ) //+
//		PS_DIFCSOURCE( 0 ) + PS_SPECSOURCE( 0 )
	;

	GRH.UseBaseVertexShaderIndex_SM3 =
		VS_SM3_FOGMODE( GRH.FogEnable ? GRH.FogMode : DX_FOGMODE_NONE ) //+
//		VS_SM3_DIFCSOURCE( 0 ) + VS_SM3_SPECSOURCE( 0 )
	;

	GRH.UseBasePixelShaderIndex_SM3 =
		PS_SM3_LIGHTINDEX( GRA2.LightIndexList_SM3[ LightMode[ 0 ] ][ LightMode[ 1 ] ][ LightMode[ 2 ] ][ LightMode[ 3 ] ][ LightMode[ 4 ] ][ LightMode[ 5 ] ] ) //+
//		PS_SM3_LIGHT0TYPE( LightMode[ 0 ] ) +
//		PS_SM3_LIGHT1TYPE( LightMode[ 1 ] ) +
//		PS_SM3_LIGHT2TYPE( LightMode[ 2 ] ) +
//		PS_SM3_LIGHT3TYPE( LightMode[ 3 ] ) +
//		PS_SM3_LIGHT4TYPE( LightMode[ 4 ] ) +
//		PS_SM3_LIGHT5TYPE( LightMode[ 5 ] ) +
//		PS_SM3_DIFCSOURCE( 0 ) + PS_SM3_SPECSOURCE( 0 )
	;
}

// r[ϊpsZbg
static int SetTransformToViewHardware( const MATRIX *Matrix )
{
	if( GraphicsDevice_IsValid() == 0 ) return 0 ;

	GraphicsDevice_SetTransform( D_D3DTS_VIEW, ( D_D3DMATRIX * )Matrix ) ;

//	if( GRH.UseShader )
	{
		int i ;
		VECTOR Dir, Pos ;
		float Data[ 2 ][ 4 ] ;
		MATRIX RotateTransMat ;

		// ]us𒸓_VF[_[ɃZbg
		MATRIX TransMat ;
		CreateTransposeMatrix( &TransMat, Matrix ) ;
		SetShaderConstantSet(
			&GRH.ShaderConstantInfo,
			DX_SHADERCONSTANTTYPE_VS_FLOAT,
			DX_SHADERCONSTANTSET_LIB,
			DX_VS_CONSTF_VIEW_MAT,
			&TransMat,
			4,
			TRUE
		) ;

		// Cg̈ʒuE̍ČvZ
		RotateTransMat = *Matrix ;
		RotateTransMat.m[ 3 ][ 0 ] = 0.0f ;
		RotateTransMat.m[ 3 ][ 1 ] = 0.0f ;
		RotateTransMat.m[ 3 ][ 2 ] = 0.0f ;
		for( i = 0 ; i < DX_PS_CONSTB_LIGHT2_NUM ; i ++ )
		{
			VectorTransform( &Dir, &GRH.LightParam[ i ].Direction, &RotateTransMat ) ;
			VectorTransform( &Pos, &GRH.LightParam[ i ].Position,  &GBASE.ViewMatrix ) ;
			Data[ 0 ][ 0 ] = Pos.x ;
			Data[ 0 ][ 1 ] = Pos.y ;
			Data[ 0 ][ 2 ] = Pos.z ;
			Data[ 0 ][ 3 ] = 1.0f ;
			Data[ 1 ][ 0 ] = Dir.x ;
			Data[ 1 ][ 1 ] = Dir.y ;
			Data[ 1 ][ 2 ] = Dir.z ;
			Data[ 1 ][ 3 ] = 0.0f ;
			if( i < DX_VS_CONSTF_LIGHT_NUM )
			{
				SetShaderConstantSet(
					&GRH.ShaderConstantInfo,
					DX_SHADERCONSTANTTYPE_VS_FLOAT,
					DX_SHADERCONSTANTSET_LIB,
					DX_VS_CONSTF_LIGHT_START + i * DX_VS_CONSTF_LIGHT_UNITSIZE,
					Data[ 0 ],
					2,
					TRUE
				) ;
			}
			SetShaderConstantSet(
				&GRH.ShaderConstantInfo,
				DX_SHADERCONSTANTTYPE_PS_FLOAT,
				DX_SHADERCONSTANTSET_LIB,
				DX_PS_CONSTF_LIGHT2_START + i * DX_PS_CONSTF_LIGHT2_UNITSIZE,
				Data[ 0 ],
				2,
				TRUE
			) ;
		}
	}

	// I
	return 0 ;
}


// eϊpsZbg
static int SetTransformToProjectionHardware( const MATRIX *Matrix )
{
	MATRIX TransMat ;

	if( GraphicsDevice_IsValid() == 0 ) return 0 ;

	GraphicsDevice_SetTransform( D_D3DTS_PROJECTION, ( D_D3DMATRIX * )Matrix ) ;

	// ]us𒸓_VF[_[ɃZbg
//	if( GRH.UseShader )
	{
		CreateTransposeMatrix( &TransMat, Matrix ) ;
		SetShaderConstantSet(
			&GRH.ShaderConstantInfo,
			DX_SHADERCONSTANTTYPE_VS_FLOAT,
			DX_SHADERCONSTANTSET_LIB,
			DX_VS_CONSTF_PROJECTION_MAT,
			&TransMat,
			4,
			TRUE
		) ;
	}

	// I
	return 0 ;
}


// Cg̃Zbg
static int SetLightHardware( int LightNumber, LIGHT *Light )
{
	if( GraphicsDevice_IsValid() == 0 ) return 0 ;

	// obt@ɂ܂_o
	RenderVertexHardware() ;

	// p[^̕ۑ
	if( LightNumber < 256 && LightNumber >= 0 )
	{
		GRH.LightParam[ LightNumber ] = *Light ;
	}

	// o[ebNXVF[_[ƃsNZVF[_[ɂf
//	if( GRH.UseShader )
	{
		if( LightNumber < DX_PS_CONSTB_LIGHT2_NUM )
		{
			float Data[ 7 ][ 4 ] ;
			float ThetaSin, ThetaCos ;
			float PhiSin, PhiCos ;
			VECTOR Dir, Pos ;

			Dir = VTransformSR( Light->Direction, GBASE.ViewMatrix ) ;
			Pos = VTransform(   Light->Position,  GBASE.ViewMatrix ) ;
			Data[ 0 ][ 0 ] = Pos.x ;
			Data[ 0 ][ 1 ] = Pos.y ;
			Data[ 0 ][ 2 ] = Pos.z ;
			Data[ 0 ][ 3 ] = 1.0f ;
			Data[ 1 ][ 0 ] = Dir.x ;
			Data[ 1 ][ 1 ] = Dir.y ;
			Data[ 1 ][ 2 ] = Dir.z ;
			Data[ 1 ][ 3 ] = 0.0f ;
			Data[ 2 ][ 0 ] = Light->Diffuse.r ;
			Data[ 2 ][ 1 ] = Light->Diffuse.g ;
			Data[ 2 ][ 2 ] = Light->Diffuse.b ;
			Data[ 2 ][ 3 ] = Light->Diffuse.a ;
			Data[ 3 ][ 0 ] = Light->Specular.r ;
			Data[ 3 ][ 1 ] = Light->Specular.g ;
			Data[ 3 ][ 2 ] = Light->Specular.b ;
			Data[ 3 ][ 3 ] = Light->Specular.a ;
			Data[ 4 ][ 0 ] = Light->Ambient.r ;
			Data[ 4 ][ 1 ] = Light->Ambient.g ;
			Data[ 4 ][ 2 ] = Light->Ambient.b ;
			Data[ 4 ][ 3 ] = Light->Ambient.a ;
			Data[ 5 ][ 0 ] = Light->Range * Light->Range ;
			Data[ 5 ][ 1 ] = Light->Falloff ;
			Data[ 5 ][ 2 ] = Light->Attenuation0 ;
			Data[ 5 ][ 3 ] = Light->Attenuation1 ;
			Data[ 6 ][ 0 ] = Light->Attenuation2 ;
			_SINCOS( Light->Theta / 2.0f, &ThetaSin, &ThetaCos ) ;
			_SINCOS( Light->Phi / 2.0f, &PhiSin, &PhiCos ) ;
			Data[ 6 ][ 1 ] = PhiCos ;
			Data[ 6 ][ 2 ] = 1.0f / ( ThetaCos - PhiCos ) ;
			Data[ 6 ][ 3 ] = 0.0f ;
			if( LightNumber < DX_VS_CONSTF_LIGHT_NUM )
			{
				SetShaderConstantSet(
					&GRH.ShaderConstantInfo,
					DX_SHADERCONSTANTTYPE_VS_FLOAT,
					DX_SHADERCONSTANTSET_LIB,
					DX_VS_CONSTF_LIGHT_START + LightNumber * DX_VS_CONSTF_LIGHT_UNITSIZE,
					Data[ 0 ],
					DX_VS_CONSTF_LIGHT_UNITSIZE,
					TRUE
				) ;
				SetShaderConstantSet(
					&GRH.ShaderConstantInfo,
					DX_SHADERCONSTANTTYPE_PS_FLOAT,
					DX_SHADERCONSTANTSET_LIB,
					DX_PS_CONSTF_LIGHT_START  + LightNumber * DX_PS_CONSTF_LIGHT_UNITSIZE,
					Data[ 2 ],
					DX_PS_CONSTF_LIGHT_UNITSIZE,
					TRUE
				) ;
			}
			SetShaderConstantSet(
				&GRH.ShaderConstantInfo,
				DX_SHADERCONSTANTTYPE_PS_FLOAT,
				DX_SHADERCONSTANTSET_LIB,
				DX_PS_CONSTF_LIGHT2_START + LightNumber * DX_PS_CONSTF_LIGHT2_UNITSIZE,
				Data[ 0 ],
				DX_PS_CONSTF_LIGHT2_UNITSIZE,
				TRUE
			) ;

			// ArGgJ[ƃG~bVuJ[|킹XV
			RefreshAmbientAndEmissiveParam() ;
		}

		if( LightNumber < DX_VS_CONSTB_LIGHT_NUM )
		{
			BOOL BData[ 2 ] ;
			BData[ 0 ] = Light->Type == D_D3DLIGHT_SPOT || Light->Type == D_D3DLIGHT_POINT ;
			BData[ 1 ] = Light->Type == D_D3DLIGHT_SPOT ;
			SetShaderConstantSet(
				&GRH.ShaderConstantInfo,
				DX_SHADERCONSTANTTYPE_VS_BOOL,
				DX_SHADERCONSTANTSET_LIB,
				DX_VS_CONSTB_LIGHT_START + LightNumber * DX_VS_CONSTB_LIGHT_UNITSIZE + DX_VS_CONSTB_LGT_POINT_OR_SPOT,
				BData,
				2,
				TRUE
			) ;
		}

		// gpVF[_[̃CfbNXXV
		RefreshUseShaderIndex() ;
	}

	return GraphicsDevice_SetLight( LightNumber, ( D_D3DLIGHT9 * )Light ) == D_D3D_OK ? 0 : -1 ;
}

// Cg̗LAύX
static int SetLightEnableHardware( int LightNumber, int EnableState )
{
	if( GraphicsDevice_IsValid() == 0 ) return 0 ;

	// obt@ɂ܂_o
	RenderVertexHardware() ;

	if( LightNumber < 256 )
	{
		GRH.LightEnableFlag[ LightNumber ] = EnableState ;

		// LȃCg̍őCfbNXXV
		if( EnableState == TRUE )
		{
			if( GRH.LightEnableMaxIndex < LightNumber )
				GRH.LightEnableMaxIndex = LightNumber ;
		}
		else
		{
			if( GRH.LightEnableMaxIndex == LightNumber )
			{
				int i ;

				for( i = LightNumber ; i > 0 && GRH.LightEnableFlag[ i ] == FALSE ; i -- ){}
				GRH.LightEnableMaxIndex = i ;
			}
		}

		// ArGgJ[ƃG~bVuJ[|킹XV
		RefreshAmbientAndEmissiveParam() ;
	}

	if( GRH.UseShader == TRUE && LightNumber < DX_VS_CONSTB_LIGHT_NUM )
	{
		BOOL BData ;
		BData = EnableState ;
		SetShaderConstantSet(
			&GRH.ShaderConstantInfo,
			DX_SHADERCONSTANTTYPE_VS_BOOL,
			DX_SHADERCONSTANTSET_LIB,
			DX_VS_CONSTB_LIGHT_START + LightNumber * DX_VS_CONSTB_LIGHT_UNITSIZE + DX_VS_CONSTB_LGT_USE,
			&BData,
			1,
			TRUE
		) ;
	}

	// gpVF[_[̃CfbNXXV
	RefreshUseShaderIndex() ;

	return GraphicsDevice_LightEnable( LightNumber, EnableState ) == D_D3D_OK ? 0 : -1 ;
}


// }eÃZbg
static int SetMaterialHardware( MATERIAL *Material )
{
	if( GraphicsDevice_IsValid() == 0 ) return 0 ;

	// ̃p[^Ɠꍇ͉Ȃ
	if( GRH.InitializeFlag == FALSE &&
		*( ( DWORD * )&GRH.Material.Ambient.a )  == *( ( DWORD * )&Material->Ambient.a  ) &&
		*( ( DWORD * )&GRH.Material.Ambient.r )  == *( ( DWORD * )&Material->Ambient.r  ) &&
		*( ( DWORD * )&GRH.Material.Ambient.g )  == *( ( DWORD * )&Material->Ambient.g  ) &&
		*( ( DWORD * )&GRH.Material.Ambient.b )  == *( ( DWORD * )&Material->Ambient.b  ) &&
		*( ( DWORD * )&GRH.Material.Diffuse.a )  == *( ( DWORD * )&Material->Diffuse.a  ) &&
		*( ( DWORD * )&GRH.Material.Diffuse.r )  == *( ( DWORD * )&Material->Diffuse.r  ) &&
		*( ( DWORD * )&GRH.Material.Diffuse.g )  == *( ( DWORD * )&Material->Diffuse.g  ) &&
		*( ( DWORD * )&GRH.Material.Diffuse.b )  == *( ( DWORD * )&Material->Diffuse.b  ) &&
		*( ( DWORD * )&GRH.Material.Emissive.a ) == *( ( DWORD * )&Material->Emissive.a ) &&
		*( ( DWORD * )&GRH.Material.Emissive.r ) == *( ( DWORD * )&Material->Emissive.r ) &&
		*( ( DWORD * )&GRH.Material.Emissive.g ) == *( ( DWORD * )&Material->Emissive.g ) &&
		*( ( DWORD * )&GRH.Material.Emissive.b ) == *( ( DWORD * )&Material->Emissive.b ) &&
		*( ( DWORD * )&GRH.Material.Specular.a ) == *( ( DWORD * )&Material->Specular.a ) &&
		*( ( DWORD * )&GRH.Material.Specular.r ) == *( ( DWORD * )&Material->Specular.r ) &&
		*( ( DWORD * )&GRH.Material.Specular.g ) == *( ( DWORD * )&Material->Specular.g ) &&
		*( ( DWORD * )&GRH.Material.Specular.b ) == *( ( DWORD * )&Material->Specular.b ) &&
		*( ( DWORD * )&GRH.Material.Power )      == *( ( DWORD * )&Material->Power      ) )
		return 0 ;

	if( GRH.InitializeFlag == FALSE )
	{
		// _o
		RenderVertexHardware() ;
	}

	// p[^ۑ
	GRH.Material = *Material ;

	// o[ebNXVF[_[ƃsNZVF[_[ɂf
//	if( GRH.UseShader )
	{
		float Data[ 3 ][ 4 ] ;

		Data[ 0 ][ 0 ] = Material->Diffuse.r ;
		Data[ 0 ][ 1 ] = Material->Diffuse.g ;
		Data[ 0 ][ 2 ] = Material->Diffuse.b ;
		Data[ 0 ][ 3 ] = Material->Diffuse.a ;
		Data[ 1 ][ 0 ] = Material->Specular.r ;
		Data[ 1 ][ 1 ] = Material->Specular.g ;
		Data[ 1 ][ 2 ] = Material->Specular.b ;
		Data[ 1 ][ 3 ] = Material->Specular.a ;
		Data[ 2 ][ 0 ] = Material->Power ;
		Data[ 2 ][ 1 ] = 0.0f ;
		Data[ 2 ][ 2 ] = 0.0f ;
		Data[ 2 ][ 3 ] = 0.0f ;
		SetShaderConstantSet(
			&GRH.ShaderConstantInfo,
			DX_SHADERCONSTANTTYPE_VS_FLOAT,
			DX_SHADERCONSTANTSET_LIB,
			DX_VS_CONSTF_MATERIAL_START,
			Data[ 0 ],
			DX_VS_CONSTF_MATERIAL_SIZE,
			TRUE
		) ;
		SetShaderConstantSet(
			&GRH.ShaderConstantInfo,
			DX_SHADERCONSTANTTYPE_PS_FLOAT,
			DX_SHADERCONSTANTSET_LIB,
			DX_PS_CONSTF_MATERIAL_START,
			Data[ 0 ],
			DX_PS_CONSTF_MATERIAL_SIZE,
			TRUE
		) ;

		// ArGgJ[ƃG~bVuJ[|킹̂XV
		RefreshAmbientAndEmissiveParam() ;
	}

	return GraphicsDevice_SetMaterial( ( D_D3DMATERIAL9 * )Material ) == D_D3D_OK ? 0 : -1 ;
}

// XyLgp邩ǂZbg
static int SetUseSpecularHardware( int UseFlag )
{
	if( GraphicsDevice_IsValid() == 0 ) return 0 ;

	// ̃p[^Ɠꍇ͉Ȃ
	if( GRH.UseSpecular == UseFlag && GRH.InitializeFlag == FALSE ) return 0 ;

	if( GRH.InitializeFlag == FALSE )
	{
		// _o
		RenderVertexHardware() ;
	}

	// p[^ۑ
	GRH.UseSpecular = UseFlag ;
	GRH.DrawPrepAlwaysFlag = TRUE ;

	return GraphicsDevice_SetRenderState( D_D3DRS_SPECULARENABLE, UseFlag ) == D_D3D_OK ? 0 : -1 ;
}

// _̃fBt[YJ[}eÃfBt[YJ[ƂĎgp邩ǂݒ肷
static int SetMaterialUseVertexDiffuseColorHardware( int UseFlag )
{
	if( GraphicsDevice_IsValid() == 0 ) return 0 ;

	// ̃p[^Ɠꍇ͉Ȃ
	if( GRH.MaterialUseVertexDiffuseColor == UseFlag && GRH.InitializeFlag == FALSE ) return 0 ;

	if( GRH.InitializeFlag == FALSE )
	{
		// _o
		RenderVertexHardware() ;
	}

	// p[^ۑ
	GRH.MaterialUseVertexDiffuseColor = UseFlag ;
	GRH.DrawPrepAlwaysFlag = TRUE ;

	// o[ebNXVF[_[ɔf
//	if( GRH.UseShader )
	{
		float Data[ 4 ] ;

		Data[ 0 ] = GRH.MaterialUseVertexDiffuseColor  ? 1.0f : 0.0f ;
		Data[ 1 ] = GRH.MaterialUseVertexSpecularColor ? 1.0f : 0.0f ;
		Data[ 2 ] = 0.0f ;
		Data[ 3 ] = 0.0f ;
		SetShaderConstantSet(
			&GRH.ShaderConstantInfo,
			DX_SHADERCONSTANTTYPE_VS_FLOAT,
			DX_SHADERCONSTANTSET_LIB,
			DX_VS_CONSTF_DIF_SPE_SOURCE,
			Data,
			1,
			TRUE
		) ;
	}

	return GraphicsDevice_SetRenderState( D_D3DRS_DIFFUSEMATERIALSOURCE, UseFlag ? D_D3DMCS_COLOR1 : D_D3DMCS_MATERIAL ) == D_D3D_OK ? 0 : -1 ;
}

// _̃XyLJ[}eÃXyLJ[ƂĎgp邩ǂݒ肷
static int SetMaterialUseVertexSpecularColorHardware( int UseFlag )
{
	if( GraphicsDevice_IsValid() == 0 ) return 0 ;

	// ̃p[^Ɠꍇ͉Ȃ
	if( GRH.MaterialUseVertexSpecularColor == UseFlag && GRH.InitializeFlag == FALSE ) return 0 ;

	if( GRH.InitializeFlag == FALSE )
	{
		// _o
		RenderVertexHardware() ;
	}

	// p[^ۑ
	GRH.MaterialUseVertexSpecularColor = UseFlag ;
	GRH.DrawPrepAlwaysFlag = TRUE ;

	// o[ebNXVF[_[ɔf
//	if( GRH.UseShader )
	{
		float Data[ 4 ] ;

		Data[ 0 ] = GRH.MaterialUseVertexDiffuseColor  ? 1.0f : 0.0f ;
		Data[ 1 ] = GRH.MaterialUseVertexSpecularColor ? 1.0f : 0.0f ;
		Data[ 2 ] = 0.0f ;
		Data[ 3 ] = 0.0f ;
		SetShaderConstantSet(
			&GRH.ShaderConstantInfo,
			DX_SHADERCONSTANTTYPE_VS_FLOAT,
			DX_SHADERCONSTANTSET_LIB,
			DX_VS_CONSTF_DIF_SPE_SOURCE,
			Data,
			1,
			TRUE
		) ;
	}

	return GraphicsDevice_SetRenderState( D_D3DRS_SPECULARMATERIALSOURCE, UseFlag ? D_D3DMCS_COLOR2 : D_D3DMCS_MATERIAL ) == D_D3D_OK ? 0 : -1 ;
}

// JO̗LZbg 
static int SetUseCullingHardware( int State )
{
	if( GraphicsDevice_IsValid() == 0 ) return 0 ;

	// [h牽I
	if( GRH.InitializeFlag == FALSE && GRH.CullMode == State ) return 0 ;
	
	if( GRH.InitializeFlag == FALSE )
	{
		// _o
		RenderVertexHardware() ;
	}

	// JO̐ݒύX
	GraphicsDevice_SetRenderState( D_D3DRS_CULLMODE, State == 2 ? D_D3DCULL_CW : ( State ? D_D3DCULL_CCW : D_D3DCULL_NONE ) ) == D_D3D_OK ? 0 : -1 ;
	GRH.CullMode = State;
	GRH.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0;
}

// ArGgJ[̃Zbg
static int SetAmbientColorHardware( int Color )
{
	if( GraphicsDevice_IsValid() == 0 ) return 0 ;

	// obt@ɂ܂_o
	RenderVertexHardware() ;

	// ArGgJ[ۑ
	GRH.GlobalAmbientLightColor.r = ( float )( ( DWORD )( Color >> 16 ) & 0xff ) / 255.0f ;
	GRH.GlobalAmbientLightColor.g = ( float )( ( DWORD )( Color >>  8 ) & 0xff ) / 255.0f ;
	GRH.GlobalAmbientLightColor.b = ( float )( ( DWORD )( Color >>  0 ) & 0xff ) / 255.0f ;
	GRH.GlobalAmbientLightColor.a = ( float )( ( DWORD )( Color >> 24 ) & 0xff ) / 255.0f ;

	// ArGgCgƃG~bVuJ[|킹p[^XV
	RefreshAmbientAndEmissiveParam() ;

	return GraphicsDevice_SetRenderState( D_D3DRS_AMBIENT, ( DWORD )Color ) == D_D3D_OK ? 0 : -1 ;
}

// VF[fBO[h̃Zbg
static int SetShadeModeHardware( int ShadeMode )
{
	if( GraphicsDevice_IsValid() == 0 ) return 0 ;

	if( GRH.ShadeMode == ShadeMode && GRH.InitializeFlag == FALSE ) return 0 ;

	GRH.ShadeMode = ShadeMode ;
	GRH.DrawPrepAlwaysFlag = TRUE ;

	if( GRH.InitializeFlag == FALSE )
	{
		// _o
		RenderVertexHardware() ;
	}

	return GraphicsDevice_SetRenderState( D_D3DRS_SHADEMODE, ShadeMode ) == D_D3D_OK ? 0 : -1 ;
}

// eNX`[̃AhbVO[hZbg
static int SetTextureAddressHardware( int AddressMode, int Stage )
{
	if( GraphicsDevice_IsValid() == 0 ) return 0 ;

	if( Stage == -1 )
	{
		if( AddressMode == GRH.TexAddressModeU[ 0 ] && AddressMode == GRH.TexAddressModeV[ 0 ] && AddressMode == GRH.TexAddressModeW[ 0 ] &&
			AddressMode == GRH.TexAddressModeU[ 1 ] && AddressMode == GRH.TexAddressModeV[ 1 ] && AddressMode == GRH.TexAddressModeW[ 1 ] &&
			AddressMode == GRH.TexAddressModeU[ 2 ] && AddressMode == GRH.TexAddressModeV[ 2 ] && AddressMode == GRH.TexAddressModeW[ 2 ] &&
			AddressMode == GRH.TexAddressModeU[ 3 ] && AddressMode == GRH.TexAddressModeV[ 3 ] && AddressMode == GRH.TexAddressModeW[ 3 ] &&
			AddressMode == GRH.TexAddressModeU[ 4 ] && AddressMode == GRH.TexAddressModeV[ 4 ] && AddressMode == GRH.TexAddressModeW[ 4 ] &&
			AddressMode == GRH.TexAddressModeU[ 5 ] && AddressMode == GRH.TexAddressModeV[ 5 ] && AddressMode == GRH.TexAddressModeW[ 5 ] &&
			AddressMode == GRH.TexAddressModeU[ 6 ] && AddressMode == GRH.TexAddressModeV[ 6 ] && AddressMode == GRH.TexAddressModeW[ 6 ] &&
			AddressMode == GRH.TexAddressModeU[ 7 ] && AddressMode == GRH.TexAddressModeV[ 7 ] && AddressMode == GRH.TexAddressModeW[ 7 ] && GRH.InitializeFlag == FALSE ) return 0 ;

		RenderVertexHardware() ;

		GRH.TexAddressModeU[ 0 ] = AddressMode ;
		GRH.TexAddressModeU[ 1 ] = AddressMode ;
		GRH.TexAddressModeU[ 2 ] = AddressMode ;
		GRH.TexAddressModeU[ 3 ] = AddressMode ;
		GRH.TexAddressModeU[ 4 ] = AddressMode ;
		GRH.TexAddressModeU[ 5 ] = AddressMode ;
		GRH.TexAddressModeU[ 6 ] = AddressMode ;
		GRH.TexAddressModeU[ 7 ] = AddressMode ;

		GRH.TexAddressModeV[ 0 ] = AddressMode ;
		GRH.TexAddressModeV[ 1 ] = AddressMode ;
		GRH.TexAddressModeV[ 2 ] = AddressMode ;
		GRH.TexAddressModeV[ 3 ] = AddressMode ;
		GRH.TexAddressModeV[ 4 ] = AddressMode ;
		GRH.TexAddressModeV[ 5 ] = AddressMode ;
		GRH.TexAddressModeV[ 6 ] = AddressMode ;
		GRH.TexAddressModeV[ 7 ] = AddressMode ;

		GRH.TexAddressModeW[ 0 ] = AddressMode ;
		GRH.TexAddressModeW[ 1 ] = AddressMode ;
		GRH.TexAddressModeW[ 2 ] = AddressMode ;
		GRH.TexAddressModeW[ 3 ] = AddressMode ;
		GRH.TexAddressModeW[ 4 ] = AddressMode ;
		GRH.TexAddressModeW[ 5 ] = AddressMode ;
		GRH.TexAddressModeW[ 6 ] = AddressMode ;
		GRH.TexAddressModeW[ 7 ] = AddressMode ;

		GRH.DrawPrepAlwaysFlag = TRUE ;

		GraphicsDevice_SetSamplerState( 7, D_D3DSAMP_ADDRESSU, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 7, D_D3DSAMP_ADDRESSV, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 7, D_D3DSAMP_ADDRESSW, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 6, D_D3DSAMP_ADDRESSU, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 6, D_D3DSAMP_ADDRESSV, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 6, D_D3DSAMP_ADDRESSW, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 5, D_D3DSAMP_ADDRESSU, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 5, D_D3DSAMP_ADDRESSV, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 5, D_D3DSAMP_ADDRESSW, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 4, D_D3DSAMP_ADDRESSU, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 4, D_D3DSAMP_ADDRESSV, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 4, D_D3DSAMP_ADDRESSW, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 3, D_D3DSAMP_ADDRESSU, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 3, D_D3DSAMP_ADDRESSV, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 3, D_D3DSAMP_ADDRESSW, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 2, D_D3DSAMP_ADDRESSU, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 2, D_D3DSAMP_ADDRESSV, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 2, D_D3DSAMP_ADDRESSW, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 1, D_D3DSAMP_ADDRESSU, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 1, D_D3DSAMP_ADDRESSV, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 1, D_D3DSAMP_ADDRESSW, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 0, D_D3DSAMP_ADDRESSU, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 0, D_D3DSAMP_ADDRESSV, AddressMode ) ;
		return GraphicsDevice_SetSamplerState( 0, D_D3DSAMP_ADDRESSW, AddressMode ) == D_D3D_OK ? 0 : -1 ;
	}
	else
	{
		if( Stage < 0 || Stage >= USE_TEXTURESTAGE_NUM ) return -1 ;
		if( AddressMode == GRH.TexAddressModeU[ Stage ] &&
			AddressMode == GRH.TexAddressModeV[ Stage ] &&
			AddressMode == GRH.TexAddressModeW[ Stage ] && GRH.InitializeFlag == FALSE ) return 0 ;

		RenderVertexHardware() ;

		GRH.TexAddressModeU[ Stage ] = AddressMode ;
		GRH.TexAddressModeV[ Stage ] = AddressMode ;
		GRH.TexAddressModeW[ Stage ] = AddressMode ;

		GRH.DrawPrepAlwaysFlag = TRUE ;

		GraphicsDevice_SetSamplerState( Stage, D_D3DSAMP_ADDRESSU, AddressMode ) ;
		GraphicsDevice_SetSamplerState( Stage, D_D3DSAMP_ADDRESSV, AddressMode ) ;
		return GraphicsDevice_SetSamplerState( Stage, D_D3DSAMP_ADDRESSW, AddressMode ) == D_D3D_OK ? 0 : -1 ;
	}
}

// eNX`[̃AhbVO[hZbg
static int SetTextureAddressUHardware( int AddressMode, int Stage )
{
	if( GraphicsDevice_IsValid() == 0 ) return 0 ;

	if( Stage == -1 )
	{
		if( AddressMode == GRH.TexAddressModeU[ 0 ] &&
			AddressMode == GRH.TexAddressModeU[ 1 ] &&
			AddressMode == GRH.TexAddressModeU[ 2 ] &&
			AddressMode == GRH.TexAddressModeU[ 3 ] &&
			AddressMode == GRH.TexAddressModeU[ 4 ] &&
			AddressMode == GRH.TexAddressModeU[ 5 ] &&
			AddressMode == GRH.TexAddressModeU[ 6 ] &&
			AddressMode == GRH.TexAddressModeU[ 7 ] && GRH.InitializeFlag == FALSE ) return 0 ;

		RenderVertexHardware() ;

		GRH.TexAddressModeU[ 0 ] = AddressMode ;
		GRH.TexAddressModeU[ 1 ] = AddressMode ;
		GRH.TexAddressModeU[ 2 ] = AddressMode ;
		GRH.TexAddressModeU[ 3 ] = AddressMode ;
		GRH.TexAddressModeU[ 4 ] = AddressMode ;
		GRH.TexAddressModeU[ 5 ] = AddressMode ;
		GRH.TexAddressModeU[ 6 ] = AddressMode ;
		GRH.TexAddressModeU[ 7 ] = AddressMode ;
		GRH.DrawPrepAlwaysFlag = TRUE ;

		GraphicsDevice_SetSamplerState( 7, D_D3DSAMP_ADDRESSU, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 6, D_D3DSAMP_ADDRESSU, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 5, D_D3DSAMP_ADDRESSU, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 4, D_D3DSAMP_ADDRESSU, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 3, D_D3DSAMP_ADDRESSU, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 2, D_D3DSAMP_ADDRESSU, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 1, D_D3DSAMP_ADDRESSU, AddressMode ) ;
		return GraphicsDevice_SetSamplerState( 0, D_D3DSAMP_ADDRESSU, AddressMode ) == D_D3D_OK ? 0 : -1 ;
	}
	else
	{
		if( Stage < 0 || Stage >= USE_TEXTURESTAGE_NUM ) return -1 ;
		if( AddressMode == GRH.TexAddressModeU[ Stage ] && GRH.InitializeFlag == FALSE ) return 0 ;

		RenderVertexHardware() ;

		GRH.TexAddressModeU[ Stage ] = AddressMode ;
		GRH.DrawPrepAlwaysFlag = TRUE ;

		return GraphicsDevice_SetSamplerState( Stage, D_D3DSAMP_ADDRESSU, AddressMode ) == D_D3D_OK ? 0 : -1 ;
	}
}

// eNX`[̃AhbVO[hZbg
static int SetTextureAddressVHardware( int AddressMode, int Stage )
{
	if( GraphicsDevice_IsValid() == 0 ) return 0 ;

	if( Stage == -1 )
	{
		if( AddressMode == GRH.TexAddressModeV[ 0 ] &&
			AddressMode == GRH.TexAddressModeV[ 1 ] &&
			AddressMode == GRH.TexAddressModeV[ 2 ] &&
			AddressMode == GRH.TexAddressModeV[ 3 ] &&
			AddressMode == GRH.TexAddressModeV[ 4 ] &&
			AddressMode == GRH.TexAddressModeV[ 5 ] &&
			AddressMode == GRH.TexAddressModeV[ 6 ] &&
			AddressMode == GRH.TexAddressModeV[ 7 ] && GRH.InitializeFlag == FALSE ) return 0 ;

		RenderVertexHardware() ;

		GRH.TexAddressModeV[ 0 ] = AddressMode ;
		GRH.TexAddressModeV[ 1 ] = AddressMode ;
		GRH.TexAddressModeV[ 2 ] = AddressMode ;
		GRH.TexAddressModeV[ 3 ] = AddressMode ;
		GRH.TexAddressModeV[ 4 ] = AddressMode ;
		GRH.TexAddressModeV[ 5 ] = AddressMode ;
		GRH.TexAddressModeV[ 6 ] = AddressMode ;
		GRH.TexAddressModeV[ 7 ] = AddressMode ;
		GRH.DrawPrepAlwaysFlag = TRUE ;

		GraphicsDevice_SetSamplerState( 7, D_D3DSAMP_ADDRESSV, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 6, D_D3DSAMP_ADDRESSV, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 5, D_D3DSAMP_ADDRESSV, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 4, D_D3DSAMP_ADDRESSV, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 3, D_D3DSAMP_ADDRESSV, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 2, D_D3DSAMP_ADDRESSV, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 1, D_D3DSAMP_ADDRESSV, AddressMode ) ;
		return GraphicsDevice_SetSamplerState( 0, D_D3DSAMP_ADDRESSV, AddressMode ) == D_D3D_OK ? 0 : -1 ;
	}
	else
	{
		if( Stage < 0 || Stage >= USE_TEXTURESTAGE_NUM ) return -1 ;
		if( AddressMode == GRH.TexAddressModeV[ Stage ] && GRH.InitializeFlag == FALSE ) return 0 ;

		RenderVertexHardware() ;

		GRH.TexAddressModeV[ Stage ] = AddressMode ;
		GRH.DrawPrepAlwaysFlag = TRUE ;

		return GraphicsDevice_SetSamplerState( Stage, D_D3DSAMP_ADDRESSV, AddressMode ) == D_D3D_OK ? 0 : -1 ;
	}
}

// eNX`[̃AhbVO[hZbg
static int SetTextureAddressWHardware( int AddressMode, int Stage )
{
	if( GraphicsDevice_IsValid() == 0 ) return 0 ;

	if( Stage == -1 )
	{
		if( AddressMode == GRH.TexAddressModeW[ 0 ] &&
			AddressMode == GRH.TexAddressModeW[ 1 ] &&
			AddressMode == GRH.TexAddressModeW[ 2 ] &&
			AddressMode == GRH.TexAddressModeW[ 3 ] &&
			AddressMode == GRH.TexAddressModeW[ 4 ] &&
			AddressMode == GRH.TexAddressModeW[ 5 ] &&
			AddressMode == GRH.TexAddressModeW[ 6 ] &&
			AddressMode == GRH.TexAddressModeW[ 7 ] && GRH.InitializeFlag == FALSE ) return 0 ;

		RenderVertexHardware() ;

		GRH.TexAddressModeW[ 0 ] = AddressMode ;
		GRH.TexAddressModeW[ 1 ] = AddressMode ;
		GRH.TexAddressModeW[ 2 ] = AddressMode ;
		GRH.TexAddressModeW[ 3 ] = AddressMode ;
		GRH.TexAddressModeW[ 4 ] = AddressMode ;
		GRH.TexAddressModeW[ 5 ] = AddressMode ;
		GRH.TexAddressModeW[ 6 ] = AddressMode ;
		GRH.TexAddressModeW[ 7 ] = AddressMode ;

		GraphicsDevice_SetSamplerState( 7, D_D3DSAMP_ADDRESSW, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 6, D_D3DSAMP_ADDRESSW, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 5, D_D3DSAMP_ADDRESSW, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 4, D_D3DSAMP_ADDRESSW, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 3, D_D3DSAMP_ADDRESSW, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 2, D_D3DSAMP_ADDRESSW, AddressMode ) ;
		GraphicsDevice_SetSamplerState( 1, D_D3DSAMP_ADDRESSW, AddressMode ) ;
		return GraphicsDevice_SetSamplerState( 0, D_D3DSAMP_ADDRESSW, AddressMode ) == D_D3D_OK ? 0 : -1 ;
	}
	else
	{
		if( Stage < 0 || Stage >= USE_TEXTURESTAGE_NUM ) return -1 ;
		if( AddressMode == GRH.TexAddressModeW[ Stage ] && GRH.InitializeFlag == FALSE ) return 0 ;

		RenderVertexHardware() ;

		GRH.TexAddressModeW[ Stage ] = AddressMode ;
		return GraphicsDevice_SetSamplerState( Stage, D_D3DSAMP_ADDRESSW, AddressMode ) == D_D3D_OK ? 0 : -1 ;
	}
}

// eNX`WϊsZbg
static int	SetTextureAddressTransformMatrixHardware( int Use, MATRIX *Matrix, int Stage )
{
	if( Stage == -1 )
	{
		RenderVertexHardware() ;

		if( Use == TRUE )
		{
			GraphicsDevice_SetTextureStageState( 0, D_D3DTSS_TEXTURETRANSFORMFLAGS, D_D3DTTFF_COUNT3 ) ;
			GraphicsDevice_SetTextureStageState( 1, D_D3DTSS_TEXTURETRANSFORMFLAGS, D_D3DTTFF_COUNT3 ) ;
			GraphicsDevice_SetTextureStageState( 2, D_D3DTSS_TEXTURETRANSFORMFLAGS, D_D3DTTFF_COUNT3 ) ;
			GraphicsDevice_SetTextureStageState( 3, D_D3DTSS_TEXTURETRANSFORMFLAGS, D_D3DTTFF_COUNT3 ) ;
			GraphicsDevice_SetTransform( D_D3DTS_TEXTURE0, ( D_D3DMATRIX * )Matrix ) ;
			GraphicsDevice_SetTransform( D_D3DTS_TEXTURE1, ( D_D3DMATRIX * )Matrix ) ;
			GraphicsDevice_SetTransform( D_D3DTS_TEXTURE2, ( D_D3DMATRIX * )Matrix ) ;
			GraphicsDevice_SetTransform( D_D3DTS_TEXTURE3, ( D_D3DMATRIX * )Matrix ) ;
		}
		else
		{
			GraphicsDevice_SetTextureStageState( 0, D_D3DTSS_TEXTURETRANSFORMFLAGS, D_D3DTTFF_DISABLE ) ;
			GraphicsDevice_SetTextureStageState( 1, D_D3DTSS_TEXTURETRANSFORMFLAGS, D_D3DTTFF_DISABLE ) ;
			GraphicsDevice_SetTextureStageState( 2, D_D3DTSS_TEXTURETRANSFORMFLAGS, D_D3DTTFF_DISABLE ) ;
			GraphicsDevice_SetTextureStageState( 3, D_D3DTSS_TEXTURETRANSFORMFLAGS, D_D3DTTFF_DISABLE ) ;
		}
		GRH.TextureTransformUse[ 0 ] = Use ;
		GRH.TextureTransformUse[ 1 ] = Use ;
		GRH.TextureTransformUse[ 2 ] = Use ;
		GRH.TextureTransformUse[ 3 ] = Use ;
		GRH.TextureTransformMatrix[ 0 ] = *Matrix ;
		GRH.TextureTransformMatrix[ 1 ] = *Matrix ;
		GRH.TextureTransformMatrix[ 2 ] = *Matrix ;
		GRH.TextureTransformMatrix[ 3 ] = *Matrix ;
	}
	else
	{
		if( Stage >= 8 || GRH.TextureTransformUse[ Stage ] == FALSE && Use == FALSE )
			return 0 ;

		RenderVertexHardware() ;

		if( Use == TRUE )
		{
			if( GRH.TextureTransformUse[ Stage ] == FALSE )
			{
				GraphicsDevice_SetTextureStageState( Stage, D_D3DTSS_TEXTURETRANSFORMFLAGS, D_D3DTTFF_COUNT3 ) ;
			}
			GraphicsDevice_SetTransform( ( D_D3DTRANSFORMSTATETYPE )( D_D3DTS_TEXTURE0 + Stage ), ( D_D3DMATRIX * )Matrix ) ;
		}
		else
		{
			GraphicsDevice_SetTextureStageState( Stage, D_D3DTSS_TEXTURETRANSFORMFLAGS, D_D3DTTFF_DISABLE ) ;
		}
		GRH.TextureTransformUse[ Stage ] = Use ;
		GRH.TextureTransformMatrix[ Stage ] = *Matrix ;
	}
	return 0 ;
}

// tHOLɂ邩ǂݒ肷( TRUE:L  FALSE: )
static int	SetFogEnableHardware( int Flag )
{
	if( GraphicsDevice_IsValid() == 0 ) return 0 ;

	if( Flag == GRH.FogEnable && GRH.InitializeFlag == FALSE ) return 0 ;

	RenderVertexHardware() ;

	GRH.FogEnable = Flag ;
	GRH.DrawPrepAlwaysFlag = TRUE ;

	// gpVF[_[̃CfbNXXV
	RefreshUseShaderIndex() ;

	{
		BOOL BData ;
		BData = Flag == 0 ? 0 : 1 ;
		SetShaderConstantSet(
			&GRH.ShaderConstantInfo,
			DX_SHADERCONSTANTTYPE_VS_BOOL,
			DX_SHADERCONSTANTSET_LIB,
			DX_VS_CONSTB_FOG_USE,
			&BData,
			1,
			TRUE
		) ;
	}

	return GraphicsDevice_SetRenderState( D_D3DRS_FOGENABLE, Flag ) == D_D3D_OK ? 0 : -1 ;
}

// tHO[hݒ肷
static int	SetFogModeHardware( int Mode /* DX_FOGMODE_NONE  */ )
{
	if( GraphicsDevice_IsValid() == 0 ) return 0 ;

	if( Mode == GRH.FogMode && GRH.InitializeFlag == FALSE ) return 0 ;

	RenderVertexHardware() ;

	// o[ebNXVF[_[p̃p[^Zbg
	if( GRH.UseShader )
	{
		BOOL BData[ 4 ] ;

		BData[ 0 ] = Mode == DX_FOGMODE_LINEAR ;
		BData[ 1 ] = Mode == DX_FOGMODE_EXP ;
		BData[ 2 ] = Mode == DX_FOGMODE_EXP2 ;
		BData[ 3 ] = Mode != DX_FOGMODE_NONE ;
		SetShaderConstantSet(
			&GRH.ShaderConstantInfo,
			DX_SHADERCONSTANTTYPE_VS_BOOL,
			DX_SHADERCONSTANTSET_LIB,
			DX_VS_CONSTB_FOG_LINEAR,
			BData,
			4,
			TRUE
		) ;
	}

	GRH.FogMode = Mode ;

	// gpVF[_[̃CfbNXXV
	RefreshUseShaderIndex() ;

	return GraphicsDevice_SetRenderState( D_D3DRS_FOGVERTEXMODE, Mode ) == D_D3D_OK ? 0 : -1 ;
}

// tHOJ[ύX
static int	SetFogColorHardware( DWORD Color )
{
	float Data[ 4 ] ;

	if( GraphicsDevice_IsValid() == 0 ) return 0 ;

	if( Color == GRH.FogColor && GRH.InitializeFlag == FALSE ) return 0 ;

	RenderVertexHardware() ;

//	if( GRH.UseShader )
	{
		Data[ 0 ] = ( ( Color >> 16 ) & 0xff ) / 255.0f ;
		Data[ 1 ] = ( ( Color >>  8 ) & 0xff ) / 255.0f ;
		Data[ 2 ] = ( ( Color >>  0 ) & 0xff ) / 255.0f ;
		Data[ 3 ] = 1.0f ;
		SetShaderConstantSet(
			&GRH.ShaderConstantInfo,
			DX_SHADERCONSTANTTYPE_PS_FLOAT,
			DX_SHADERCONSTANTSET_LIB,
			DX_PS_CONSTF_FOG_COLOR,
			Data,
			1,
			TRUE
		) ;
	}

	GRH.FogColor = Color ;
	return GraphicsDevice_SetRenderState( D_D3DRS_FOGCOLOR, Color ) == D_D3D_OK ? 0 : -1 ;
}

// tHOn܂鋗ƏI鋗ݒ肷( 0.0f ` 1.0f )
static int	SetFogStartEndHardware( float Start, float End )
{
	float Data[ 4 ] ;

	if( GraphicsDevice_IsValid() == 0 ) return 0 ;

	RenderVertexHardware() ;

	if( Start != GRH.FogStart || GRH.InitializeFlag == TRUE )
	{
		GRH.FogStart = Start ;
		GraphicsDevice_SetRenderState( D_D3DRS_FOGSTART, *(( DWORD *)&Start) ) ;

		// o[ebNXVF[_[p̃p[^Zbg
//		if( GRH.UseShader )
		{
			Data[ 0 ] = GRH.FogEnd / ( GRH.FogEnd - GRH.FogStart ) ;
			Data[ 1 ] = -1.0f / ( GRH.FogEnd - GRH.FogStart ) ;
			Data[ 2 ] = GRH.FogDensity ;
			Data[ 3 ] = 2.71828183f ;
			SetShaderConstantSet(
				&GRH.ShaderConstantInfo,
				DX_SHADERCONSTANTTYPE_VS_FLOAT,
				DX_SHADERCONSTANTSET_LIB,
				DX_VS_CONSTF_FOG,
				Data,
				1,
				TRUE
			) ;
		}
	}

	if( End != GRH.FogEnd || GRH.InitializeFlag == TRUE )
	{
		GRH.FogEnd = End ;
		GraphicsDevice_SetRenderState( D_D3DRS_FOGEND, *(( DWORD *)&End) ) ;

		// o[ebNXVF[_[p̃p[^Zbg
//		if( GRH.UseShader )
		{
			Data[ 0 ] = GRH.FogEnd / ( GRH.FogEnd - GRH.FogStart ) ;
			Data[ 1 ] = -1.0f / ( GRH.FogEnd - GRH.FogStart ) ;
			Data[ 2 ] = GRH.FogDensity ;
			Data[ 3 ] = 2.71828183f ;
			SetShaderConstantSet(
				&GRH.ShaderConstantInfo,
				DX_SHADERCONSTANTTYPE_VS_FLOAT,
				DX_SHADERCONSTANTSET_LIB,
				DX_VS_CONSTF_FOG,
				Data,
				1,
				TRUE
			) ;
		}
	}

	// I
	return 0 ;
}

// tHO̖xݒ肷( 0.0f ` 1.0f )
static int	SetFogDensityHardware( float Density )
{
	float Data[ 4 ] ;
	if( GraphicsDevice_IsValid() == 0 ) return 0 ;

	if( Density == GRH.FogDensity && GRH.InitializeFlag == FALSE ) return 0 ;

	RenderVertexHardware() ;

	GRH.FogDensity = Density ;

	// o[ebNXVF[_[p̃p[^Zbg
//	if( GRH.UseShader )
	{
		Data[ 0 ] = GRH.FogEnd / ( GRH.FogEnd - GRH.FogStart ) ;
		Data[ 1 ] = -1.0f / ( GRH.FogEnd - GRH.FogStart ) ;
		Data[ 2 ] = GRH.FogDensity ;
		Data[ 3 ] = 2.71828183f ;
		SetShaderConstantSet(
			&GRH.ShaderConstantInfo,
			DX_SHADERCONSTANTTYPE_VS_FLOAT,
			DX_SHADERCONSTANTSET_LIB,
			DX_VS_CONSTF_FOG,
			Data,
			1,
			TRUE
		) ;
	}

	return GraphicsDevice_SetRenderState( D_D3DRS_FOGDENSITY, *(( DWORD *)&Density) ) == D_D3D_OK ? 0 : -1 ;
}

// Cg̗LtOZbg
static int SetUseLightFlagHardware( int LightFlag )
{
	if( GraphicsDevice_IsValid() == 0 ) return 0 ;

	if( LightFlag == GRH.LightFlag && GRH.InitializeFlag == FALSE ) return 0 ;

	GRH.LightFlag = LightFlag ;
	GRH.DrawPrepAlwaysFlag = TRUE ;

	RefreshUseShaderIndex() ;

	return GraphicsDevice_SetRenderState( D_D3DRS_LIGHTING, LightFlag ) == D_D3D_OK ? 0 : -1 ;
}

// QzIɔzuꂽ_f[^𒸓_obt@ɒǉ
static int SetPlaneVertexHardware( VERTEX_2D *GraphVert, int xnum, int ynum )
{
	int i, j, k, l ;

	if( GraphicsDevice_IsValid() == 0 ) return 0 ;

	if( xnum < 2 || ynum < 2 ) return -1 ;

	// gCAOXg[h̏ꍇ̓obt@͎gpȂ
	RenderVertexHardware() ;

	// obt@gpȂݒɂȂĂ炱̏ŕ`
	{
#define MAX_POSNUM		1000
		WORD list[MAX_POSNUM] ;

		// _CfbNXXg쐬
		k = 0 ;
		l = 0 ;
		for( i = 0 ; i < ynum - 1 ; i ++ )
		{
			// _`
			if( k + xnum * 2 + 2 > MAX_POSNUM )
			{
				SETFVF( VERTEXFVF_2D )
				GraphicsDevice_DrawIndexedPrimitiveUP(
					D_D3DPT_TRIANGLESTRIP,
					0,
					xnum * ynum,
					k - 2,
					list,
					D_D3DFMT_INDEX16,
					GraphVert,
					sizeof( VERTEX_2D ) ) ;
				k = 0 ;
			}

			// O̍s̑ꍇ̓Xgbv̘Ap̒_o		
			if( k != 0 )
			{
				list[k] = ( WORD )( l + xnum ) ;
				k ++ ;
			}
			
			for( j = 0 ; j < xnum ; j ++, l ++ )
			{
				list[k] = ( WORD )( l + xnum ) ;
				list[k+1] = ( WORD )l ;
				k += 2 ;
			}
			if( i != ynum - 2 )
			{
				list[k] = list[k-1] ;
				k ++ ;
			}
		}
		if( k != 0 )
		{
			SETFVF( VERTEXFVF_2D )
			GraphicsDevice_DrawIndexedPrimitiveUP(
				D_D3DPT_TRIANGLESTRIP,
				0,
				xnum * ynum,
				k - 2,
				list,
				D_D3DFMT_INDEX16,
				GraphVert,
				sizeof( VERTEX_2D ) ) ;
		}
#undef	MAX_POSNUM
	}

	// I
	return 0 ;
}

// r[|[gZbg
static int  SetViewportHardware( D_D3DVIEWPORT9 *Viewport )
{
	HRESULT hr ;

	if( GraphicsDevice_IsValid() == 0 ) return -1 ;
	if( Viewport->X      == GRH.Viewport.X      &&
		Viewport->Y      == GRH.Viewport.Y      &&
		Viewport->Width  == GRH.Viewport.Width  &&
		Viewport->Height == GRH.Viewport.Height &&
		GRH.InitializeFlag == FALSE ) return 0 ;

	// o
	if( GRH.InitializeFlag == FALSE )
	{
		RenderVertexHardware() ;
	}

	// `IĂ
	EndScene() ;

	// r[|[g̃ZbeBO
	hr = GraphicsDevice_SetViewport( Viewport ) ;
	if( hr != D_D3D_OK )
		return DXST_ERRORLOGFMT_ADD(( _T( "r[|[g̃ZbgɎs܂ ErrorCode %x\n" ), hr ));

	// r[|[g̏̕ۑ
	GRH.Viewport = *Viewport ;

	// I
	return 0 ;
}

// r[|[gZbg( ȈՔ )
extern int SetViewportHardwareEasy( int x1, int y1, int x2, int y2 )
{
	D_D3DVIEWPORT9 Viewport ;

	Viewport.X = x1 ;
	Viewport.Y = y1 ;
	Viewport.Width = ( DWORD )( x2 - x1 ) ;
	Viewport.Height = ( DWORD )( y2 - y1 ) ;
	Viewport.MinZ = 0.0f ;
	Viewport.MaxZ = 1.0f ;

	return SetViewportHardware( &Viewport ) ;
}

// VU[`ݒ肷
static int	SetScissorRectHardware( RECT *Rect )
{
	if( GraphicsDevice_IsValid() == 0 ) return -1 ;
	if( Rect->left   == GRH.ScissorRect.left   &&
		Rect->right  == GRH.ScissorRect.right  &&
		Rect->top    == GRH.ScissorRect.top    &&
		Rect->bottom == GRH.ScissorRect.bottom &&
		GRH.InitializeFlag == FALSE ) return 0 ;

	if( GRH.InitializeFlag == FALSE )
	{
		// o
		RenderVertexHardware() ;
	}

	// `IĂ
	EndScene() ;

	// VU[`̃ZbeBO
	GraphicsDevice_SetScissorRect( Rect ) ;

	// VU[`̕ۑ
	GRH.ScissorRect = *Rect ;

	// I
	return 0 ;
}

// VU[`Lɂ邩ǂݒ
static int	SetScissorTestEnableHardware( int Enable )
{
	if( GraphicsDevice_IsValid() == 0 ) return -1 ;
	if( Enable == GRH.ScissorTestEnable &&
		GRH.InitializeFlag == FALSE ) return 0 ;

	// o
	RenderVertexHardware() ;

	// `IĂ
	EndScene() ;

	// VU[`̗LẼZbeBO
	GraphicsDevice_SetRenderState( D_D3DRS_SCISSORTESTENABLE, Enable ) ;

	// VU[`̗LẼZbeBOۑ
	GRH.ScissorTestEnable = Enable ;

	// I
	return 0 ;
}

// ttHg`sǂݒ
static int SetEdgeFontDrawFlagHardware( int EdgeFontFlag )
{
	if( GraphicsDevice_IsValid() == 0 ) return -1 ;
	if( EdgeFontFlag == GRH.EdgeFontDrawFlag && GRH.InitializeFlag == FALSE ) return 0 ;

	// o
	RenderVertexHardware() ;

	// VU[`̗LẼZbeBOۑ
	GRH.EdgeFontDrawFlag = EdgeFontFlag ;

	// p[^ύXꂽAtO𗧂Ă
	GRH.ChangeBlendParamFlag = TRUE ;

	// I
	return 0 ;
}

#ifndef DX_NON_ASYNCLOAD
int RenderVertexHardwareASyncCallback( ASYNCLOAD_MAINTHREAD_REQUESTINFO * /*Info*/ )
{
	return RenderVertexHardware( FALSE ) ;
}
#endif // DX_NON_ASYNCLOAD

// _obt@ɗ܂_f[^_O
extern int	RenderVertexHardware( int ASyncThread )
{
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		ASYNCLOAD_MAINTHREAD_REQUESTINFO AInfo ;

		AInfo.Function = RenderVertexHardwareASyncCallback ;
		return AddASyncLoadRequestMainThreadInfo( &AInfo ) ;
	}
#endif // DX_NON_ASYNCLOAD

	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	// _`͍sȂ
	if( GRH.VertexNum != 0 && DxLib_GetEndRequest() == FALSE )
	{
		// BeginScene ĂȂ炷
		if( GRH.BeginSceneFlag == FALSE ) BeginScene() ;

		// `tOĂȂ΃_O
		if( GRH.BlendMaxNotDrawFlag == FALSE )
		{
			if( GRH.VertexNum != 0 )
			{
				int PrimNum ;

				PrimNum = 0 ;
				switch( GRH.PrimitiveType )
				{
				case D_D3DPT_POINTLIST     : PrimNum = GRH.VertexNum ;     break ;
				case D_D3DPT_LINELIST      : PrimNum = GRH.VertexNum / 2 ; break ;
				case D_D3DPT_LINESTRIP     : PrimNum = GRH.VertexNum - 1 ; break ;
				case D_D3DPT_TRIANGLELIST  : PrimNum = GRH.VertexNum / 3 ; break ;
				case D_D3DPT_TRIANGLESTRIP : PrimNum = GRH.VertexNum - 2 ; break ;
				case D_D3DPT_TRIANGLEFAN   : PrimNum = GRH.VertexNum - 2 ; break ;
				}

				SETFVF( D3DDev_VertexType[ GRH.Use3DVertex ][ GRH.VertexType ] );
				if( GRH.Use3DVertex )
				{
					SetTransformToWorldHardware( &GlobalIdentMatrix ) ;
				}
				GraphicsDevice_DrawPrimitiveUP(
					GRH.PrimitiveType,
					PrimNum,
					GRH.VertexBufferPoint[ GRH.Use3DVertex ][ GRH.VertexType ],
					D3DDev_VertexSize[ GRH.Use3DVertex ][ GRH.VertexType ] ) ;

				if( GRH.Use3DVertex )
				{
					SetTransformToWorldHardware( &GBASE.WorldMatrix ) ;
				}

			}
		}
	}

	GRH.VertexNum = 0 ;
	GRH.VertexBufferNextAddress = GRH.VertexBufferPoint[ GRH.Use3DVertex ][ GRH.VertexType ] ;

	// I
	return 0 ;
}

// `揀s
static void FASTCALL DrawPreparation( DX_DIRECT3DTEXTURE9 *Texture, int ParamFlag )
{
	int ColorKey, AlphaTest, AlphaChannel, UseDiffuseRGB, UseDiffuseAlpha, ShadeMode, Specular, EdgeFont ;

	// ttHg̕`悩ǂ̃tO擾
	EdgeFont = ( ParamFlag & DRAWPREP_EDGEFONT ) != 0 ? TRUE : FALSE ;

	// K DrawPreparation sׂƂtO|
	GRH.DrawPrepAlwaysFlag = FALSE ;

	// VF[_[ZbgĂO
	if( ( ParamFlag & DRAWPREP_NOTSHADERRESET ) == 0 )
	{
		if( GRH.SetVS )
		{
			GraphicsDevice_SetVertexShader( NULL ) ;
			GRH.SetVS = NULL ;
			GRH.SetVD = NULL ;
			GRH.SetFVF = 0 ;
		}

		if( GRH.NormalPS == FALSE )
		{
			if( GRH.SetPS )
			{
				GraphicsDevice_SetPixelShader( NULL ) ;
				GRH.SetPS = NULL ;
			}
		}
	}

	GRH.SetIB = NULL ;
	GRH.SetVB = NULL ;

	// Cggǂŏ𕪊
	if( ( ParamFlag & DRAWPREP_LIGHTING ) != 0 && GBASE.Light.ProcessDisable == FALSE )
	{
		// Cg̐ݒ肪ύXĂύXK
		if( GBASE.Light.D3DChange )
		{
			RefreshLightState() ;
		}
		else
		{
			// CgLȂ̂ɈꎞIɖɂȂĂLɂ
			if( GRH.LightFlag == 0 )
			{
				SetUseLightFlagHardware( TRUE ) ;
			}
		}

		// }eA̐ݒ肪OύXĂ猳ɖ߂
		if( GBASE.Light.ChangeMaterial )
		{
			GBASE.Light.ChangeMaterial = 0 ;
			SetMaterialHardware( ( MATERIAL * )&GBASE.Light.Material ) ;
		}

		// _J[}eÃJ[ƂĎgp邩ǂZbg
		if( ( GBASE.Light.MaterialNotUseVertexDiffuseColor ? FALSE : TRUE ) != GRH.MaterialUseVertexDiffuseColor )
			SetMaterialUseVertexDiffuseColorHardware( GBASE.Light.MaterialNotUseVertexDiffuseColor ? FALSE : TRUE ) ;
		if( ( GBASE.Light.MaterialNotUseVertexSpecularColor ? FALSE : TRUE ) != GRH.MaterialUseVertexSpecularColor )
			SetMaterialUseVertexSpecularColorHardware( GBASE.Light.MaterialNotUseVertexSpecularColor ? FALSE : TRUE ) ;
	}
	else
	{
		// CgLɂȂĂ疳ɂ
		if( GRH.LightFlag == 1 )
		{
			SetUseLightFlagHardware( FALSE ) ;
		}
	}

	// XyLgp邩ǂ̐ݒs
	Specular = ( GBASE.NotUseSpecular == FALSE && ( ParamFlag & DRAWPREP_SPECULAR ) != 0 ) ? TRUE : FALSE ;
	if( Specular != GRH.UseSpecular )
		SetUseSpecularHardware( Specular ) ;

	// yobt@̐ݒs
	if( ParamFlag & DRAWPREP_3D )
	{
		if( GBASE.EnableZBufferFlag3D )
		{
			if( GRH.EnableZBufferFlag != GBASE.EnableZBufferFlag3D ) SetUseZBufferHardware(     GBASE.EnableZBufferFlag3D ) ;
			if( GRH.WriteZBufferFlag  != GBASE.WriteZBufferFlag3D  ) SetWriteZBufferHardware(   GBASE.WriteZBufferFlag3D  ) ;
			if( GRH.ZBufferCmpType    != GBASE.ZBufferCmpType3D    ) SetZBufferCmpTypeHardware( GBASE.ZBufferCmpType3D    ) ;
			if( GRH.ZBias             != GBASE.ZBias3D             ) SetZBiasHardware(          GBASE.ZBias3D             ) ;
		}
		else
		{
			if( GRH.EnableZBufferFlag ) SetUseZBufferHardware( FALSE ) ;
		}
	}
	else
	{
		if( GBASE.EnableZBufferFlag2D )
		{
			if( GRH.EnableZBufferFlag != GBASE.EnableZBufferFlag2D ) SetUseZBufferHardware(     GBASE.EnableZBufferFlag2D ) ;
			if( GRH.WriteZBufferFlag  != GBASE.WriteZBufferFlag2D  ) SetWriteZBufferHardware(   GBASE.WriteZBufferFlag2D  ) ;
			if( GRH.ZBufferCmpType    != GBASE.ZBufferCmpType2D    ) SetZBufferCmpTypeHardware( GBASE.ZBufferCmpType2D    ) ;
			if( GRH.ZBias             != GBASE.ZBias2D             ) SetZBiasHardware(          GBASE.ZBias2D             ) ;
		}
		else
		{
			if( GRH.EnableZBufferFlag ) SetUseZBufferHardware( FALSE ) ;
			if( GRH.WriteZBufferFlag  ) SetWriteZBufferHardware( FALSE ) ;
		}
	}

	// tB[h̃Zbg
	if( GRH.FillMode != GBASE.FillMode ) SetFillModeHardware( GBASE.FillMode ) ;

	// tHO̐ݒs
	if( ParamFlag & DRAWPREP_FOG )
	{
		if( GRH.FogEnable != GBASE.FogEnable ) SetFogEnableHardware( GBASE.FogEnable ) ;
	}
	else
	{
		if( GRH.FogEnable ) SetFogEnableHardware( FALSE ) ;
	}

	// ufBO֌W̃ZbeBOsꍇ̂ݎs
	if( ( ParamFlag & DRAWPREP_NOBLENDSETTING ) == 0 )
	{
		// OƂ܂ꍇ͉ɏI
//		if( Format    == GRH.DrawPrepFormat   &&
//			Texture   == GRH.DrawPrepTexture  &&
//			ParamFlag == GRH.DrawPrepParamFlag ) return ;

		// tȌ
		ColorKey     = FALSE ;
		AlphaTest    = FALSE ;
		AlphaChannel = FALSE ;

		// eNX`[gp邩ǂŏ𕪊
		// gpȂꍇ͏l̂܂
		if( Texture )
		{
			// ߐFsȂꍇ̓J[L[eXg`lgpȂ̂ŏl̂܂
			// ߐFsꍇ̂ݏ
			if( ParamFlag & DRAWPREP_TRANS )
			{
				int TexAlphaTestFlag = ( ParamFlag & DRAWPREP_TEXALPHATEST ) != 0 ? 1 : 0 ;
				int TexAlphaChFlag   = ( ParamFlag & DRAWPREP_TEXALPHACH   ) != 0 ? 1 : 0 ;

				// eNX`Ƀrbg邩ǂŏ𕪊
				if( TexAlphaTestFlag || TexAlphaChFlag )
				{
					// eNX`ɃrbgꍇJ[L[͎gpȂ(̂ŏl̂܂)
/*
					// eXgł_W̃f[^^_^ŁAeNX`tB^O[h
					// `Ԃꍇ̓`lƂĈ
					if( VectorIntFlag == FALSE && GBASE.DrawMode == DX_DRAWMODE_BILINEAR )
					{
						AlphaChannel = TRUE ;
					}
					else
					{
						// ȊȌꍇ̓eNX`[̃tOɈς˂
						AlphaTest = Format->AlphaTestFlag ;
						AlphaChannel = Format->AlphaChFlag ;
					}
*/
					// eXgł_W̃f[^^_^ŁAeNX`tB^O[h
					// `Ԃł邩Auh[h DX_BLENDMODE_NOBLEND ȊO烿`lƂĈ
					if( ( GBASE.BlendMode != DX_BLENDMODE_NOBLEND && GBASE.BlendMode != DX_BLENDMODE_DESTCOLOR ) ||
						( ( ParamFlag & DRAWPREP_VECTORINT ) == 0 && GBASE.DrawMode == DX_DRAWMODE_BILINEAR ) )
//					if( VectorIntFlag == FALSE && GBASE.DrawMode == DX_DRAWMODE_BILINEAR )
					{
						AlphaChannel = TRUE ;
					}
					else
					{
						// ȊȌꍇ̓eNX`[̃tOɈς˂
						AlphaTest    = TexAlphaTestFlag ;
						AlphaChannel = TexAlphaChFlag ;
					}
				}
				else
				{
					// eNX`ɃrbgȂꍇJ[L[gp(Aǂ TransFlag  )
					ColorKey = TRUE ;
				}
			}
		}

		// fBt[YJ[gp邩ǂZbg
		UseDiffuseRGB   = ( ParamFlag & DRAWPREP_DIFFUSERGB )   || ( GBASE.bDrawBright & 0xffffff ) != 0xffffff ;
		UseDiffuseAlpha = ( ParamFlag & DRAWPREP_DIFFUSEALPHA ) || ( GBASE.BlendMode != DX_BLENDMODE_NOBLEND || GBASE.UseNoBlendModeParam /*&& ( GBASE.BlendMode != DX_BLENDMODE_ALPHA || GBASE.BlendParam != 255 )*/ ) ;

		// ꂽp[^Zbg
		if( UseDiffuseRGB             != GRH.UseDiffuseRGBColor     ) SetUseDiffuseRGBColorFlagHardware(   UseDiffuseRGB   ) ;
		if( UseDiffuseAlpha           != GRH.UseDiffuseAlphaColor   ) SetUseDiffuseAlphaColorFlagHardware( UseDiffuseAlpha ) ;
		if( Texture                   != GRH.RenderTexture          ) SetTextureHardware(                  Texture         ) ;
		if( GRH.IgnoreGraphColorFlag  != GBASE.IgnoreGraphColorFlag ) SetIgnoreDrawGraphColorHardware( GBASE.IgnoreGraphColorFlag ) ;
		if( GRH.BlendMode             != GBASE.BlendMode ||
			GRH.AlphaTestValidFlag    != AlphaTest ||
			GRH.AlphaChannelValidFlag != AlphaChannel               ) SetDrawBlendModeHardware( GBASE.BlendMode, AlphaTest, AlphaChannel ) ;
		if( GRH.EdgeFontDrawFlag      != EdgeFont                   ) SetEdgeFontDrawFlagHardware( EdgeFont ) ;
		if( GRH.AlphaTestMode         != GBASE.AlphaTestMode ||
			GRH.AlphaTestParam        != GBASE.AlphaTestParam       ) SetDrawAlphaTestHardware( GBASE.AlphaTestMode, GBASE.AlphaTestParam ) ;
		if( GRH.ChangeBlendParamFlag || GRH.ChangeTextureFlag || ( GRH.UseShader && GRH.NormalDraw_NotUseShader == FALSE && GRH.NormalPS == FALSE ) ) RefreshBlendStateHardware() ;
	}

	// VF[fBO[h̃Zbg
	ShadeMode = ( ParamFlag & DRAWPREP_GOURAUDSHADE ) ? D_D3DSHADE_GOURAUD : D_D3DSHADE_FLAT ;

	if( ShadeMode          != GRH.ShadeMode        ) SetShadeModeHardware(      ShadeMode           ) ;
	if( GRH.DrawMode       != GBASE.DrawMode       ) SetDrawModeHardware(       GBASE.DrawMode      ) ;
	if( GRH.MaxAnisotropy  != GBASE.MaxAnisotropy  ) SetMaxAnisotropyHardware(  GBASE.MaxAnisotropy ) ;
	if( ParamFlag & DRAWPREP_CULLING )
	{
		if( GRH.CullMode   != GBASE.CullMode       ) SetUseCullingHardware(     GBASE.CullMode      ) ;
	}
	else
	{
		if( GRH.CullMode   != DX_CULLING_NONE      ) SetUseCullingHardware(     DX_CULLING_NONE     ) ;
	}
	if( GRH.TextureTransformMatrixDirectChange     )
	{
		SetTextureAddressTransformMatrixHardware( GBASE.TextureTransformUse, &GBASE.TextureTransformMatrix, -1 ) ;
		GRH.TextureTransformMatrixDirectChange = FALSE ;
		GRH.DrawPrepAlwaysFlag = TRUE ;
	}
	if( ParamFlag & DRAWPREP_TEXADDRESS )
	{
		if( GRH.TexAddressModeU[ 0 ] != GBASE.TexAddressModeU[ 0 ] ) SetTextureAddressUHardware( GBASE.TexAddressModeU[ 0 ], 0 ) ;
		if( GRH.TexAddressModeU[ 1 ] != GBASE.TexAddressModeU[ 1 ] ) SetTextureAddressUHardware( GBASE.TexAddressModeU[ 1 ], 1 ) ;
		if( GRH.TexAddressModeU[ 2 ] != GBASE.TexAddressModeU[ 2 ] ) SetTextureAddressUHardware( GBASE.TexAddressModeU[ 2 ], 2 ) ;
		if( GRH.TexAddressModeU[ 3 ] != GBASE.TexAddressModeU[ 3 ] ) SetTextureAddressUHardware( GBASE.TexAddressModeU[ 3 ], 3 ) ;
		if( GRH.TexAddressModeU[ 4 ] != GBASE.TexAddressModeU[ 4 ] ) SetTextureAddressUHardware( GBASE.TexAddressModeU[ 4 ], 4 ) ;
		if( GRH.TexAddressModeU[ 5 ] != GBASE.TexAddressModeU[ 5 ] ) SetTextureAddressUHardware( GBASE.TexAddressModeU[ 5 ], 5 ) ;
		if( GRH.TexAddressModeU[ 6 ] != GBASE.TexAddressModeU[ 6 ] ) SetTextureAddressUHardware( GBASE.TexAddressModeU[ 6 ], 6 ) ;
		if( GRH.TexAddressModeU[ 7 ] != GBASE.TexAddressModeU[ 7 ] ) SetTextureAddressUHardware( GBASE.TexAddressModeU[ 7 ], 7 ) ;

		if( GRH.TexAddressModeV[ 0 ] != GBASE.TexAddressModeV[ 0 ] ) SetTextureAddressVHardware( GBASE.TexAddressModeV[ 0 ], 0 ) ;
		if( GRH.TexAddressModeV[ 1 ] != GBASE.TexAddressModeV[ 1 ] ) SetTextureAddressVHardware( GBASE.TexAddressModeV[ 1 ], 1 ) ;
		if( GRH.TexAddressModeV[ 2 ] != GBASE.TexAddressModeV[ 2 ] ) SetTextureAddressVHardware( GBASE.TexAddressModeV[ 2 ], 2 ) ;
		if( GRH.TexAddressModeV[ 3 ] != GBASE.TexAddressModeV[ 3 ] ) SetTextureAddressVHardware( GBASE.TexAddressModeV[ 3 ], 3 ) ;
		if( GRH.TexAddressModeV[ 4 ] != GBASE.TexAddressModeV[ 4 ] ) SetTextureAddressVHardware( GBASE.TexAddressModeV[ 4 ], 4 ) ;
		if( GRH.TexAddressModeV[ 5 ] != GBASE.TexAddressModeV[ 5 ] ) SetTextureAddressVHardware( GBASE.TexAddressModeV[ 5 ], 5 ) ;
		if( GRH.TexAddressModeV[ 6 ] != GBASE.TexAddressModeV[ 6 ] ) SetTextureAddressVHardware( GBASE.TexAddressModeV[ 6 ], 6 ) ;
		if( GRH.TexAddressModeV[ 7 ] != GBASE.TexAddressModeV[ 7 ] ) SetTextureAddressVHardware( GBASE.TexAddressModeV[ 7 ], 7 ) ;
	}
	else
	{
		if( GRH.TexAddressModeU[ 0 ] != DX_TEXADDRESS_CLAMP || GRH.TexAddressModeV[ 0 ] != DX_TEXADDRESS_CLAMP ) SetTextureAddressHardware( DX_TEXADDRESS_CLAMP, 0 ) ;
		if( GRH.TexAddressModeU[ 1 ] != DX_TEXADDRESS_CLAMP || GRH.TexAddressModeV[ 1 ] != DX_TEXADDRESS_CLAMP ) SetTextureAddressHardware( DX_TEXADDRESS_CLAMP, 1 ) ;
		if( GRH.TexAddressModeU[ 2 ] != DX_TEXADDRESS_CLAMP || GRH.TexAddressModeV[ 2 ] != DX_TEXADDRESS_CLAMP ) SetTextureAddressHardware( DX_TEXADDRESS_CLAMP, 2 ) ;
		if( GRH.TexAddressModeU[ 3 ] != DX_TEXADDRESS_CLAMP || GRH.TexAddressModeV[ 3 ] != DX_TEXADDRESS_CLAMP ) SetTextureAddressHardware( DX_TEXADDRESS_CLAMP, 3 ) ;
	}

/*
	SetDrawBlendModeHardware( GBASE.BlendMode, GBASE.BlendParam,  ) ;

	if( ( Format->AlphaTestFlag || Format->AlphaChFlag ) && ( TransFlag != GRH.AlphaValidFlag ) )
	{
		SetDrawBlendModeHardware( DX_BLENDMODE_BLINEALPHA ,
									Format->AlphaTestFlag ? ( TransFlag  ? TRUE : FALSE ) : ( Format->AlphaChFlag ? TRUE : FALSE ) ) ;
	}
*/
	// p[^ۑ
//	GRH.DrawPrepFormat    = Format ;
	GRH.DrawPrepTexture   = Texture ;
	GRH.DrawPrepParamFlag = ParamFlag ;
}

// n[hEGAANZ[^gp DrawBillboard3DHardware
static int	DrawBillboard3DHardware( VECTOR Pos, float cx, float cy, float Size, float Angle, IMAGEDATA2 *Image2, IMAGEDATA2 *BlendImage2, int TransFlag, int TurnFlag, int DrawFlag, RECT *DrawArea )
{
	VERTEX_2D *DrawVect ;
	VERTEX_2D TempVect[ 6 ] ;
	VERTEX_3D *DrawVect3D ;
	VERTEX_BLENDTEX_2D *DrawVectB ;
	VERTEX_BLENDTEX_2D TempVectB[ 6 ] ;
	IMAGEDATA2_HARD_DRAW *DrawTex ;
	IMAGEDATA2_HARD_DRAW *BlendDrawTex ;
	IMAGEDATA2_ORIG *Orig ;
	IMAGEDATA2_HARD_VERT *TexVect ;
	IMAGEDATA2_HARD_VERT *BlendTexVect = NULL ;
	DWORD DiffuseColor ;
	int DrawTexNum ;
	int i, Flag ;
	int BlendGraphNoIncFlag ;
	float SizeX, SizeY, f ;
	VECTOR SrcVec[ 4 ], SrcVec2[ 4 ] ;
	float Sin = 0.0f, Cos = 1.0f, ScaleX, ScaleY ;
	float dleft = 0.0f, dright = 0.0f, dtop = 0.0f, dbottom = 0.0f ;

	Orig = Image2->Orig ;

	if( GraphicsDevice_IsValid() == 0 || GRH.FlipSkipFlag ) return -1 ;

	// `揀
	if( DrawFlag )
	{
		if( GRH.BeginSceneFlag == FALSE ) BeginScene() ;
		Flag = TransFlag | DRAWPREP_3D | DRAWPREP_FOG | DRAWPREP_TEXADDRESS ;
		DRAWPREP_TEX( Orig, Image2->Hard.Draw[ 0 ].Tex->Texture, Flag )
	}
	else
	{
		dleft   = -100000000.0f ;
		dright  =  100000000.0f ;
		dtop    = -100000000.0f ;
		dbottom =  100000000.0f ;
	}

	// _f[^擾
	DiffuseColor = GRH.DiffuseColor ;

	// `̐Zbg
	DrawTexNum = Image2->Hard.DrawNum ;

	// `̐uh摜ƈقȂĂOԖڂ̃eNX`gp
	BlendGraphNoIncFlag = FALSE ;
	if( BlendImage2 != NULL && BlendImage2->Hard.DrawNum != Image2->Hard.DrawNum )
	{
		BlendGraphNoIncFlag = TRUE ;
	}

	// `z̃AhXZbgĂ
	DrawTex = Image2->Hard.Draw ;
	BlendDrawTex = NULL ;
	if( BlendImage2 != NULL )
	{
		BlendDrawTex = BlendImage2->Hard.Draw ;
	}

	// TCYƍW֌W̎OvZ
	SizeX = Size ;
	SizeY = Size * ( float )Image2->Height / ( float )Image2->Width ;

	ScaleX = SizeX / Image2->Width ;
	ScaleY = SizeY / Image2->Height ;
	cx *= Image2->Width ;
	cy *= Image2->Height ;

	// ]ꍇ͉]l߂Ă
	if( Angle != 0.0 )
	{
		_SINCOS( (float)Angle, &Sin, &Cos ) ;
	}

	// eNX`[̐JԂ
	for( i = 0 ; i < DrawTexNum ; i ++, DrawTex ++ )
	{
		// `悷eNX`[̃Zbg
		if( DrawFlag )
		{
			if( GRH.RenderTexture != DrawTex->Tex->Texture )
				SetTextureHardware( DrawTex->Tex->Texture ) ;
			if( BlendDrawTex != NULL )
			{
				if( GRH.BlendTexture != BlendDrawTex->Tex->Texture )
					SetBlendTextureHardware( BlendDrawTex->Tex->Texture, BlendDrawTex->Tex->TexWidth, BlendDrawTex->Tex->TexHeight );
			}
			if( GRH.ChangeTextureFlag )
				RefreshBlendStateHardware() ;
		}

		TexVect = DrawTex->Vertex ;
		if( BlendDrawTex != NULL )
		{
			BlendTexVect = BlendDrawTex->Vertex ;
		}

		// uhOtBbNgpĂȂāA`悷ꍇ͍ȏgp
		if( GRH.VertexType != VERTEXTYPE_BLENDTEX && DrawFlag == TRUE )
		{
			GETVERTEX_BILLBOARD( DrawVect3D ) ;

			// ]ꍇƂȂꍇŏ𕪊
			if( Angle != 0.0 )
			{
				// [JW
				SrcVec[2].x = SrcVec[0].x = ( -cx + TexVect[0].x ) * ScaleX ;
				SrcVec[3].x = SrcVec[1].x = ( -cx + TexVect[1].x ) * ScaleX ;

				SrcVec[1].y = SrcVec[0].y = ( -cy + Image2->Height - TexVect[0].y ) * ScaleY ;
				SrcVec[3].y = SrcVec[2].y = ( -cy + Image2->Height - TexVect[2].y ) * ScaleY ;

				// ]vZ
				f             = SrcVec[ 0 ].x * Cos - SrcVec[ 0 ].y * Sin ;	
				SrcVec[ 0 ].y = SrcVec[ 0 ].x * Sin + SrcVec[ 0 ].y * Cos ;
				SrcVec[ 0 ].x = f ;

				f             = SrcVec[ 1 ].x * Cos - SrcVec[ 1 ].y * Sin ;	
				SrcVec[ 1 ].y = SrcVec[ 1 ].x * Sin + SrcVec[ 1 ].y * Cos ;
				SrcVec[ 1 ].x = f ;

				f             = SrcVec[ 2 ].x * Cos - SrcVec[ 2 ].y * Sin ;	
				SrcVec[ 2 ].y = SrcVec[ 2 ].x * Sin + SrcVec[ 2 ].y * Cos ;
				SrcVec[ 2 ].x = f ;

				f             = SrcVec[ 3 ].x * Cos - SrcVec[ 3 ].y * Sin ;	
				SrcVec[ 3 ].y = SrcVec[ 3 ].x * Sin + SrcVec[ 3 ].y * Cos ;
				SrcVec[ 3 ].x = f ;

				// r{[hW[hW֕ϊ
				DrawVect3D[ 0 ].pos.x = SrcVec[ 0 ].x * GBASE.BillboardMatrix.m[0][0] + SrcVec[ 0 ].y * GBASE.BillboardMatrix.m[1][0] + Pos.x ;
				DrawVect3D[ 0 ].pos.y = SrcVec[ 0 ].x * GBASE.BillboardMatrix.m[0][1] + SrcVec[ 0 ].y * GBASE.BillboardMatrix.m[1][1] + Pos.y ;
				DrawVect3D[ 0 ].pos.z = SrcVec[ 0 ].x * GBASE.BillboardMatrix.m[0][2] + SrcVec[ 0 ].y * GBASE.BillboardMatrix.m[1][2] + Pos.z ;

				DrawVect3D[ 1 ].pos.x = SrcVec[ 1 ].x * GBASE.BillboardMatrix.m[0][0] + SrcVec[ 1 ].y * GBASE.BillboardMatrix.m[1][0] + Pos.x ;
				DrawVect3D[ 1 ].pos.y = SrcVec[ 1 ].x * GBASE.BillboardMatrix.m[0][1] + SrcVec[ 1 ].y * GBASE.BillboardMatrix.m[1][1] + Pos.y ;
				DrawVect3D[ 1 ].pos.z = SrcVec[ 1 ].x * GBASE.BillboardMatrix.m[0][2] + SrcVec[ 1 ].y * GBASE.BillboardMatrix.m[1][2] + Pos.z ;

				DrawVect3D[ 2 ].pos.x = SrcVec[ 2 ].x * GBASE.BillboardMatrix.m[0][0] + SrcVec[ 2 ].y * GBASE.BillboardMatrix.m[1][0] + Pos.x ;
				DrawVect3D[ 2 ].pos.y = SrcVec[ 2 ].x * GBASE.BillboardMatrix.m[0][1] + SrcVec[ 2 ].y * GBASE.BillboardMatrix.m[1][1] + Pos.y ;
				DrawVect3D[ 2 ].pos.z = SrcVec[ 2 ].x * GBASE.BillboardMatrix.m[0][2] + SrcVec[ 2 ].y * GBASE.BillboardMatrix.m[1][2] + Pos.z ;

				DrawVect3D[ 3 ].pos.x = SrcVec[ 3 ].x * GBASE.BillboardMatrix.m[0][0] + SrcVec[ 3 ].y * GBASE.BillboardMatrix.m[1][0] + Pos.x ;
				DrawVect3D[ 3 ].pos.y = SrcVec[ 3 ].x * GBASE.BillboardMatrix.m[0][1] + SrcVec[ 3 ].y * GBASE.BillboardMatrix.m[1][1] + Pos.y ;
				DrawVect3D[ 3 ].pos.z = SrcVec[ 3 ].x * GBASE.BillboardMatrix.m[0][2] + SrcVec[ 3 ].y * GBASE.BillboardMatrix.m[1][2] + Pos.z ;
			}
			else
			{
				VECTOR TempVecX[ 2 ], TempVecY[ 2 ] ;

				// [JW
				SrcVec[0].x = ( -cx + TexVect[0].x ) * ScaleX ;
				SrcVec[1].x = ( -cx + TexVect[1].x ) * ScaleX ;

				SrcVec[0].y = ( -cy + Image2->Height - TexVect[0].y ) * ScaleY ;
				SrcVec[2].y = ( -cy + Image2->Height - TexVect[2].y ) * ScaleY ;

				// r{[hW[hW֕ϊ
				TempVecX[ 0 ].x = SrcVec[ 0 ].x * GBASE.BillboardMatrix.m[0][0] + Pos.x ;
				TempVecX[ 0 ].y = SrcVec[ 0 ].x * GBASE.BillboardMatrix.m[0][1] + Pos.y ;
				TempVecX[ 0 ].z = SrcVec[ 0 ].x * GBASE.BillboardMatrix.m[0][2] + Pos.z ;

				TempVecX[ 1 ].x = SrcVec[ 1 ].x * GBASE.BillboardMatrix.m[0][0] + Pos.x ;
				TempVecX[ 1 ].y = SrcVec[ 1 ].x * GBASE.BillboardMatrix.m[0][1] + Pos.y ;
				TempVecX[ 1 ].z = SrcVec[ 1 ].x * GBASE.BillboardMatrix.m[0][2] + Pos.z ;

				TempVecY[ 0 ].x = SrcVec[ 0 ].y * GBASE.BillboardMatrix.m[1][0] ;
				TempVecY[ 0 ].y = SrcVec[ 0 ].y * GBASE.BillboardMatrix.m[1][1] ;
				TempVecY[ 0 ].z = SrcVec[ 0 ].y * GBASE.BillboardMatrix.m[1][2] ;

				TempVecY[ 1 ].x = SrcVec[ 2 ].y * GBASE.BillboardMatrix.m[1][0] ;
				TempVecY[ 1 ].y = SrcVec[ 2 ].y * GBASE.BillboardMatrix.m[1][1] ;
				TempVecY[ 1 ].z = SrcVec[ 2 ].y * GBASE.BillboardMatrix.m[1][2] ;

				DrawVect3D[ 0 ].pos.x = TempVecX[ 0 ].x + TempVecY[ 0 ].x ;
				DrawVect3D[ 0 ].pos.y = TempVecX[ 0 ].y + TempVecY[ 0 ].y ;
				DrawVect3D[ 0 ].pos.z = TempVecX[ 0 ].z + TempVecY[ 0 ].z ;

				DrawVect3D[ 1 ].pos.x = TempVecX[ 1 ].x + TempVecY[ 0 ].x ;
				DrawVect3D[ 1 ].pos.y = TempVecX[ 1 ].y + TempVecY[ 0 ].y ;
				DrawVect3D[ 1 ].pos.z = TempVecX[ 1 ].z + TempVecY[ 0 ].z ;

				DrawVect3D[ 2 ].pos.x = TempVecX[ 0 ].x + TempVecY[ 1 ].x ;
				DrawVect3D[ 2 ].pos.y = TempVecX[ 0 ].y + TempVecY[ 1 ].y ;
				DrawVect3D[ 2 ].pos.z = TempVecX[ 0 ].z + TempVecY[ 1 ].z ;

				DrawVect3D[ 3 ].pos.x = TempVecX[ 1 ].x + TempVecY[ 1 ].x ;
				DrawVect3D[ 3 ].pos.y = TempVecX[ 1 ].y + TempVecY[ 1 ].y ;
				DrawVect3D[ 3 ].pos.z = TempVecX[ 1 ].z + TempVecY[ 1 ].z ;
			}

			DrawVect3D[4].pos = DrawVect3D[2].pos ;
			DrawVect3D[5].pos = DrawVect3D[1].pos ;

			*( ( DWORD * )&DrawVect3D[0].b ) = 
			*( ( DWORD * )&DrawVect3D[3].b ) = DiffuseColor ;

			if( TurnFlag )
			{
				DrawVect3D[5].u = DrawVect3D[3].u = DrawVect3D[1].u = TexVect[0].u ;
				DrawVect3D[4].u = DrawVect3D[2].u = DrawVect3D[0].u = TexVect[1].u ;
			}
			else
			{
				DrawVect3D[4].u = DrawVect3D[2].u = DrawVect3D[0].u = TexVect[0].u ;
				DrawVect3D[5].u = DrawVect3D[3].u = DrawVect3D[1].u = TexVect[1].u ;
			}
			DrawVect3D[5].v = DrawVect3D[1].v = DrawVect3D[0].v = TexVect[0].v ;
			DrawVect3D[4].v = DrawVect3D[3].v = DrawVect3D[2].v = TexVect[2].v ;

			// eNX`[`悷
			ADD4VERTEX_BILLBOARD
		}
		else
		{
			// r{[ĥS_𓾂
			{
				// ]ꍇƂȂꍇŏ𕪊
				if( Angle != 0.0 )
				{
					// [JW
					SrcVec[2].x = SrcVec[0].x = ( -cx + TexVect[0].x ) * ScaleX ;
					SrcVec[3].x = SrcVec[1].x = ( -cx + TexVect[1].x ) * ScaleX ;

					SrcVec[1].y = SrcVec[0].y = ( -cy + Image2->Height - TexVect[0].y ) * ScaleY ;
					SrcVec[3].y = SrcVec[2].y = ( -cy + Image2->Height - TexVect[2].y ) * ScaleY ;

					// ]vZ
					f             = SrcVec[ 0 ].x * Cos - SrcVec[ 0 ].y * Sin ;	
					SrcVec[ 0 ].y = SrcVec[ 0 ].x * Sin + SrcVec[ 0 ].y * Cos ;
					SrcVec[ 0 ].x = f ;

					f             = SrcVec[ 1 ].x * Cos - SrcVec[ 1 ].y * Sin ;	
					SrcVec[ 1 ].y = SrcVec[ 1 ].x * Sin + SrcVec[ 1 ].y * Cos ;
					SrcVec[ 1 ].x = f ;

					f             = SrcVec[ 2 ].x * Cos - SrcVec[ 2 ].y * Sin ;	
					SrcVec[ 2 ].y = SrcVec[ 2 ].x * Sin + SrcVec[ 2 ].y * Cos ;
					SrcVec[ 2 ].x = f ;

					f             = SrcVec[ 3 ].x * Cos - SrcVec[ 3 ].y * Sin ;	
					SrcVec[ 3 ].y = SrcVec[ 3 ].x * Sin + SrcVec[ 3 ].y * Cos ;
					SrcVec[ 3 ].x = f ;

					// r{[hW[hW֕ϊ
					SrcVec2[ 0 ].x = SrcVec[ 0 ].x * GBASE.BillboardMatrix.m[0][0] + SrcVec[ 0 ].y * GBASE.BillboardMatrix.m[1][0] + Pos.x ;
					SrcVec2[ 0 ].y = SrcVec[ 0 ].x * GBASE.BillboardMatrix.m[0][1] + SrcVec[ 0 ].y * GBASE.BillboardMatrix.m[1][1] + Pos.y ;
					SrcVec2[ 0 ].z = SrcVec[ 0 ].x * GBASE.BillboardMatrix.m[0][2] + SrcVec[ 0 ].y * GBASE.BillboardMatrix.m[1][2] + Pos.z ;

					SrcVec2[ 1 ].x = SrcVec[ 1 ].x * GBASE.BillboardMatrix.m[0][0] + SrcVec[ 1 ].y * GBASE.BillboardMatrix.m[1][0] + Pos.x ;
					SrcVec2[ 1 ].y = SrcVec[ 1 ].x * GBASE.BillboardMatrix.m[0][1] + SrcVec[ 1 ].y * GBASE.BillboardMatrix.m[1][1] + Pos.y ;
					SrcVec2[ 1 ].z = SrcVec[ 1 ].x * GBASE.BillboardMatrix.m[0][2] + SrcVec[ 1 ].y * GBASE.BillboardMatrix.m[1][2] + Pos.z ;

					SrcVec2[ 2 ].x = SrcVec[ 2 ].x * GBASE.BillboardMatrix.m[0][0] + SrcVec[ 2 ].y * GBASE.BillboardMatrix.m[1][0] + Pos.x ;
					SrcVec2[ 2 ].y = SrcVec[ 2 ].x * GBASE.BillboardMatrix.m[0][1] + SrcVec[ 2 ].y * GBASE.BillboardMatrix.m[1][1] + Pos.y ;
					SrcVec2[ 2 ].z = SrcVec[ 2 ].x * GBASE.BillboardMatrix.m[0][2] + SrcVec[ 2 ].y * GBASE.BillboardMatrix.m[1][2] + Pos.z ;

					SrcVec2[ 3 ].x = SrcVec[ 3 ].x * GBASE.BillboardMatrix.m[0][0] + SrcVec[ 3 ].y * GBASE.BillboardMatrix.m[1][0] + Pos.x ;
					SrcVec2[ 3 ].y = SrcVec[ 3 ].x * GBASE.BillboardMatrix.m[0][1] + SrcVec[ 3 ].y * GBASE.BillboardMatrix.m[1][1] + Pos.y ;
					SrcVec2[ 3 ].z = SrcVec[ 3 ].x * GBASE.BillboardMatrix.m[0][2] + SrcVec[ 3 ].y * GBASE.BillboardMatrix.m[1][2] + Pos.z ;
				}
				else
				{
					VECTOR TempVecX[ 2 ], TempVecY[ 2 ] ;

					// [JW
					SrcVec[0].x = ( -cx + TexVect[0].x ) * ScaleX ;
					SrcVec[1].x = ( -cx + TexVect[1].x ) * ScaleX ;

					SrcVec[0].y = ( -cy + Image2->Height - TexVect[0].y ) * ScaleY ;
					SrcVec[2].y = ( -cy + Image2->Height - TexVect[2].y ) * ScaleY ;

					// r{[hW[hW֕ϊ
					TempVecX[ 0 ].x = SrcVec[ 0 ].x * GBASE.BillboardMatrix.m[0][0] + Pos.x ;
					TempVecX[ 0 ].y = SrcVec[ 0 ].x * GBASE.BillboardMatrix.m[0][1] + Pos.y ;
					TempVecX[ 0 ].z = SrcVec[ 0 ].x * GBASE.BillboardMatrix.m[0][2] + Pos.z ;

					TempVecX[ 1 ].x = SrcVec[ 1 ].x * GBASE.BillboardMatrix.m[0][0] + Pos.x ;
					TempVecX[ 1 ].y = SrcVec[ 1 ].x * GBASE.BillboardMatrix.m[0][1] + Pos.y ;
					TempVecX[ 1 ].z = SrcVec[ 1 ].x * GBASE.BillboardMatrix.m[0][2] + Pos.z ;

					TempVecY[ 0 ].x = SrcVec[ 0 ].y * GBASE.BillboardMatrix.m[1][0] ;
					TempVecY[ 0 ].y = SrcVec[ 0 ].y * GBASE.BillboardMatrix.m[1][1] ;
					TempVecY[ 0 ].z = SrcVec[ 0 ].y * GBASE.BillboardMatrix.m[1][2] ;

					TempVecY[ 1 ].x = SrcVec[ 2 ].y * GBASE.BillboardMatrix.m[1][0] ;
					TempVecY[ 1 ].y = SrcVec[ 2 ].y * GBASE.BillboardMatrix.m[1][1] ;
					TempVecY[ 1 ].z = SrcVec[ 2 ].y * GBASE.BillboardMatrix.m[1][2] ;

					SrcVec2[ 0 ].x = TempVecX[ 0 ].x + TempVecY[ 0 ].x ;
					SrcVec2[ 0 ].y = TempVecX[ 0 ].y + TempVecY[ 0 ].y ;
					SrcVec2[ 0 ].z = TempVecX[ 0 ].z + TempVecY[ 0 ].z ;

					SrcVec2[ 1 ].x = TempVecX[ 1 ].x + TempVecY[ 0 ].x ;
					SrcVec2[ 1 ].y = TempVecX[ 1 ].y + TempVecY[ 0 ].y ;
					SrcVec2[ 1 ].z = TempVecX[ 1 ].z + TempVecY[ 0 ].z ;

					SrcVec2[ 2 ].x = TempVecX[ 0 ].x + TempVecY[ 1 ].x ;
					SrcVec2[ 2 ].y = TempVecX[ 0 ].y + TempVecY[ 1 ].y ;
					SrcVec2[ 2 ].z = TempVecX[ 0 ].z + TempVecY[ 1 ].z ;

					SrcVec2[ 3 ].x = TempVecX[ 1 ].x + TempVecY[ 1 ].x ;
					SrcVec2[ 3 ].y = TempVecX[ 1 ].y + TempVecY[ 1 ].y ;
					SrcVec2[ 3 ].z = TempVecX[ 1 ].z + TempVecY[ 1 ].z ;
				}
			}

			// _^Cvɂď𕪊
			switch( GRH.VertexType )
			{
			case VERTEXTYPE_BLENDTEX :
				// uheNX`gp

				// _obt@̎擾
				if( DrawFlag )
				{
					GETVERTEX_QUAD( DrawVectB )
				}
				else
				{
					DrawVectB = TempVectB ;
				}

				// XN[Wɕϊ
				DrawVectB[0].pos.x = SrcVec2[0].x * GBASE.BlendMatrix.m[0][0] + SrcVec2[0].y * GBASE.BlendMatrix.m[1][0] + SrcVec2[0].z * GBASE.BlendMatrix.m[2][0] + GBASE.BlendMatrix.m[3][0]  ;
				DrawVectB[0].pos.y = SrcVec2[0].x * GBASE.BlendMatrix.m[0][1] + SrcVec2[0].y * GBASE.BlendMatrix.m[1][1] + SrcVec2[0].z * GBASE.BlendMatrix.m[2][1] + GBASE.BlendMatrix.m[3][1]  ;
				DrawVectB[0].pos.z = SrcVec2[0].x * GBASE.BlendMatrix.m[0][2] + SrcVec2[0].y * GBASE.BlendMatrix.m[1][2] + SrcVec2[0].z * GBASE.BlendMatrix.m[2][2] + GBASE.BlendMatrix.m[3][2]  ;
				DrawVectB[0].rhw   = SrcVec2[0].x * GBASE.BlendMatrix.m[0][3] + SrcVec2[0].y * GBASE.BlendMatrix.m[1][3] + SrcVec2[0].z * GBASE.BlendMatrix.m[2][3] + GBASE.BlendMatrix.m[3][3]  ;

				DrawVectB[3].rhw = 
				DrawVectB[2].rhw = 
				DrawVectB[1].rhw = 
				DrawVectB[0].rhw = 1.0F / DrawVectB[0].rhw ;
				DrawVectB[0].pos.x *= DrawVectB[0].rhw ;
				DrawVectB[0].pos.y *= DrawVectB[0].rhw ;
				DrawVectB[3].pos.z =
				DrawVectB[2].pos.z =
				DrawVectB[1].pos.z =
				DrawVectB[0].pos.z *= DrawVectB[0].rhw ;

				DrawVectB[1].pos.x = ( SrcVec2[1].x * GBASE.BlendMatrix.m[0][0] + SrcVec2[1].y * GBASE.BlendMatrix.m[1][0] + SrcVec2[1].z * GBASE.BlendMatrix.m[2][0] + GBASE.BlendMatrix.m[3][0] ) * DrawVectB[0].rhw ;
				DrawVectB[1].pos.y = ( SrcVec2[1].x * GBASE.BlendMatrix.m[0][1] + SrcVec2[1].y * GBASE.BlendMatrix.m[1][1] + SrcVec2[1].z * GBASE.BlendMatrix.m[2][1] + GBASE.BlendMatrix.m[3][1] ) * DrawVectB[0].rhw ;
				DrawVectB[2].pos.x = ( SrcVec2[2].x * GBASE.BlendMatrix.m[0][0] + SrcVec2[2].y * GBASE.BlendMatrix.m[1][0] + SrcVec2[2].z * GBASE.BlendMatrix.m[2][0] + GBASE.BlendMatrix.m[3][0] ) * DrawVectB[0].rhw ;
				DrawVectB[2].pos.y = ( SrcVec2[2].x * GBASE.BlendMatrix.m[0][1] + SrcVec2[2].y * GBASE.BlendMatrix.m[1][1] + SrcVec2[2].z * GBASE.BlendMatrix.m[2][1] + GBASE.BlendMatrix.m[3][1] ) * DrawVectB[0].rhw ;
				DrawVectB[3].pos.x = ( SrcVec2[3].x * GBASE.BlendMatrix.m[0][0] + SrcVec2[3].y * GBASE.BlendMatrix.m[1][0] + SrcVec2[3].z * GBASE.BlendMatrix.m[2][0] + GBASE.BlendMatrix.m[3][0] ) * DrawVectB[0].rhw ;
				DrawVectB[3].pos.y = ( SrcVec2[3].x * GBASE.BlendMatrix.m[0][1] + SrcVec2[3].y * GBASE.BlendMatrix.m[1][1] + SrcVec2[3].z * GBASE.BlendMatrix.m[2][1] + GBASE.BlendMatrix.m[3][1] ) * DrawVectB[0].rhw ;

				DrawVectB[4].pos = DrawVectB[2].pos ;
				DrawVectB[5].pos = DrawVectB[1].pos ;
				DrawVectB[4].rhw = DrawVectB[2].rhw ;
				DrawVectB[5].rhw = DrawVectB[1].rhw ;

				DrawVectB[0].color	= 
				DrawVectB[3].color	= DiffuseColor ;

				if( TurnFlag )
				{
					DrawVectB[5].u1 = DrawVectB[3].u1 = DrawVectB[1].u1 = ( TexVect[0].x - BlendTexVect[0].x + GBASE.BlendGraphX ) * GRH.InvBlendTextureWidth ;
					DrawVectB[4].u1 = DrawVectB[2].u1 = DrawVectB[0].u1 = ( TexVect[1].x - BlendTexVect[0].x + GBASE.BlendGraphX ) * GRH.InvBlendTextureWidth ;
				}
				else
				{
					DrawVectB[4].u1 = DrawVectB[2].u1 = DrawVectB[0].u1 = ( TexVect[0].x - BlendTexVect[0].x + GBASE.BlendGraphX ) * GRH.InvBlendTextureWidth ;
					DrawVectB[5].u1 = DrawVectB[3].u1 = DrawVectB[1].u1 = ( TexVect[1].x - BlendTexVect[0].x + GBASE.BlendGraphX ) * GRH.InvBlendTextureWidth ;
				}
				DrawVectB[4].u2 = DrawVectB[2].u2 = DrawVectB[0].u2 = TexVect[0].u ;
				DrawVectB[5].u2 = DrawVectB[3].u2 = DrawVectB[1].u2 = TexVect[1].u ;

				DrawVectB[5].v1 = DrawVectB[1].v1 = DrawVectB[0].v1 = ( TexVect[0].y - BlendTexVect[0].y + GBASE.BlendGraphY ) * GRH.InvBlendTextureHeight ;
				DrawVectB[4].v1 = DrawVectB[3].v1 = DrawVectB[2].v1 = ( TexVect[2].y - BlendTexVect[0].y + GBASE.BlendGraphY ) * GRH.InvBlendTextureHeight ;

				DrawVectB[5].v2 = DrawVectB[1].v2 = DrawVectB[0].v2 = TexVect[0].v ;
				DrawVectB[4].v2 = DrawVectB[3].v2 = DrawVectB[2].v2 = TexVect[2].v ;

				// eNX`[`悷
				if( DrawFlag )
				{
					ADD4VERTEX_BLENDTEX
				}
				else
				{
					if( dright  > DrawVectB[ 0 ].pos.x ) dright  = DrawVectB[ 0 ].pos.x ;
					if( dright  > DrawVectB[ 1 ].pos.x ) dright  = DrawVectB[ 1 ].pos.x ;
					if( dright  > DrawVectB[ 2 ].pos.x ) dright  = DrawVectB[ 2 ].pos.x ;
					if( dright  > DrawVectB[ 3 ].pos.x ) dright  = DrawVectB[ 3 ].pos.x ;

					if( dleft   < DrawVectB[ 0 ].pos.x ) dleft   = DrawVectB[ 0 ].pos.x ;
					if( dleft   < DrawVectB[ 1 ].pos.x ) dleft   = DrawVectB[ 1 ].pos.x ;
					if( dleft   < DrawVectB[ 2 ].pos.x ) dleft   = DrawVectB[ 2 ].pos.x ;
					if( dleft   < DrawVectB[ 3 ].pos.x ) dleft   = DrawVectB[ 3 ].pos.x ;

					if( dbottom > DrawVectB[ 0 ].pos.y ) dbottom = DrawVectB[ 0 ].pos.y ;
					if( dbottom > DrawVectB[ 1 ].pos.y ) dbottom = DrawVectB[ 1 ].pos.y ;
					if( dbottom > DrawVectB[ 2 ].pos.y ) dbottom = DrawVectB[ 2 ].pos.y ;
					if( dbottom > DrawVectB[ 3 ].pos.y ) dbottom = DrawVectB[ 3 ].pos.y ;

					if( dtop    < DrawVectB[ 0 ].pos.y ) dtop    = DrawVectB[ 0 ].pos.y ;
					if( dtop    < DrawVectB[ 1 ].pos.y ) dtop    = DrawVectB[ 1 ].pos.y ;
					if( dtop    < DrawVectB[ 2 ].pos.y ) dtop    = DrawVectB[ 2 ].pos.y ;
					if( dtop    < DrawVectB[ 3 ].pos.y ) dtop    = DrawVectB[ 3 ].pos.y ;
				}

				if( BlendGraphNoIncFlag == FALSE )
				{
					BlendDrawTex ++ ;
				}
				break ;

			case VERTEXTYPE_TEX :
				// uheNX`gpȂ

				// _obt@̎擾
				if( DrawFlag )
				{
					GETVERTEX_QUAD( DrawVect )
				}
				else
				{
					DrawVect = TempVect;
				}

				// XN[Wɕϊ
				DrawVect[0].pos.x = SrcVec2[0].x * GBASE.BlendMatrix.m[0][0] + SrcVec2[0].y * GBASE.BlendMatrix.m[1][0] + SrcVec2[0].z * GBASE.BlendMatrix.m[2][0] + GBASE.BlendMatrix.m[3][0]  ;
				DrawVect[0].pos.y = SrcVec2[0].x * GBASE.BlendMatrix.m[0][1] + SrcVec2[0].y * GBASE.BlendMatrix.m[1][1] + SrcVec2[0].z * GBASE.BlendMatrix.m[2][1] + GBASE.BlendMatrix.m[3][1]  ;
				DrawVect[0].pos.z = SrcVec2[0].x * GBASE.BlendMatrix.m[0][2] + SrcVec2[0].y * GBASE.BlendMatrix.m[1][2] + SrcVec2[0].z * GBASE.BlendMatrix.m[2][2] + GBASE.BlendMatrix.m[3][2]  ;
				DrawVect[0].rhw   = SrcVec2[0].x * GBASE.BlendMatrix.m[0][3] + SrcVec2[0].y * GBASE.BlendMatrix.m[1][3] + SrcVec2[0].z * GBASE.BlendMatrix.m[2][3] + GBASE.BlendMatrix.m[3][3]  ;

				DrawVect[3].rhw = 
				DrawVect[2].rhw = 
				DrawVect[1].rhw = 
				DrawVect[0].rhw = 1.0F / DrawVect[0].rhw ;
				DrawVect[0].pos.x *= DrawVect[0].rhw ;
				DrawVect[0].pos.y *= DrawVect[0].rhw ;
				DrawVect[3].pos.z =
				DrawVect[2].pos.z =
				DrawVect[1].pos.z =
				DrawVect[0].pos.z *= DrawVect[0].rhw ;

				DrawVect[1].pos.x = ( SrcVec2[1].x * GBASE.BlendMatrix.m[0][0] + SrcVec2[1].y * GBASE.BlendMatrix.m[1][0] + SrcVec2[1].z * GBASE.BlendMatrix.m[2][0] + GBASE.BlendMatrix.m[3][0] ) * DrawVect[0].rhw ;
				DrawVect[1].pos.y = ( SrcVec2[1].x * GBASE.BlendMatrix.m[0][1] + SrcVec2[1].y * GBASE.BlendMatrix.m[1][1] + SrcVec2[1].z * GBASE.BlendMatrix.m[2][1] + GBASE.BlendMatrix.m[3][1] ) * DrawVect[0].rhw ;
				DrawVect[2].pos.x = ( SrcVec2[2].x * GBASE.BlendMatrix.m[0][0] + SrcVec2[2].y * GBASE.BlendMatrix.m[1][0] + SrcVec2[2].z * GBASE.BlendMatrix.m[2][0] + GBASE.BlendMatrix.m[3][0] ) * DrawVect[0].rhw ;
				DrawVect[2].pos.y = ( SrcVec2[2].x * GBASE.BlendMatrix.m[0][1] + SrcVec2[2].y * GBASE.BlendMatrix.m[1][1] + SrcVec2[2].z * GBASE.BlendMatrix.m[2][1] + GBASE.BlendMatrix.m[3][1] ) * DrawVect[0].rhw ;
				DrawVect[3].pos.x = ( SrcVec2[3].x * GBASE.BlendMatrix.m[0][0] + SrcVec2[3].y * GBASE.BlendMatrix.m[1][0] + SrcVec2[3].z * GBASE.BlendMatrix.m[2][0] + GBASE.BlendMatrix.m[3][0] ) * DrawVect[0].rhw ;
				DrawVect[3].pos.y = ( SrcVec2[3].x * GBASE.BlendMatrix.m[0][1] + SrcVec2[3].y * GBASE.BlendMatrix.m[1][1] + SrcVec2[3].z * GBASE.BlendMatrix.m[2][1] + GBASE.BlendMatrix.m[3][1] ) * DrawVect[0].rhw ;

				DrawVect[4].pos = DrawVect[2].pos ;
				DrawVect[5].pos = DrawVect[1].pos ;
				DrawVect[4].rhw = DrawVect[2].rhw ;
				DrawVect[5].rhw = DrawVect[1].rhw ;

				DrawVect[0].color	= 
				DrawVect[3].color	= DiffuseColor ;

				if( TurnFlag )
				{
					DrawVect[5].u       = DrawVect[3].u       = DrawVect[1].u       = TexVect[0].u ;
					DrawVect[4].u       = DrawVect[2].u       = DrawVect[0].u       = TexVect[1].u ;
				}
				else
				{
					DrawVect[4].u       = DrawVect[2].u       = DrawVect[0].u       = TexVect[0].u ;
					DrawVect[5].u       = DrawVect[3].u       = DrawVect[1].u       = TexVect[1].u ;
				}
				DrawVect[5].v       = DrawVect[1].v       = DrawVect[0].v       = TexVect[0].v ;
				DrawVect[4].v       = DrawVect[3].v       = DrawVect[2].v       = TexVect[2].v ;

				// eNX`[`悷
				if( DrawFlag )
				{
					ADD4VERTEX_TEX
				}
				else
				{
					if( dright  > DrawVect[ 0 ].pos.x ) dright  = DrawVect[ 0 ].pos.x ;
					if( dright  > DrawVect[ 1 ].pos.x ) dright  = DrawVect[ 1 ].pos.x ;
					if( dright  > DrawVect[ 2 ].pos.x ) dright  = DrawVect[ 2 ].pos.x ;
					if( dright  > DrawVect[ 3 ].pos.x ) dright  = DrawVect[ 3 ].pos.x ;

					if( dleft   < DrawVect[ 0 ].pos.x ) dleft   = DrawVect[ 0 ].pos.x ;
					if( dleft   < DrawVect[ 1 ].pos.x ) dleft   = DrawVect[ 1 ].pos.x ;
					if( dleft   < DrawVect[ 2 ].pos.x ) dleft   = DrawVect[ 2 ].pos.x ;
					if( dleft   < DrawVect[ 3 ].pos.x ) dleft   = DrawVect[ 3 ].pos.x ;

					if( dbottom > DrawVect[ 0 ].pos.y ) dbottom = DrawVect[ 0 ].pos.y ;
					if( dbottom > DrawVect[ 1 ].pos.y ) dbottom = DrawVect[ 1 ].pos.y ;
					if( dbottom > DrawVect[ 2 ].pos.y ) dbottom = DrawVect[ 2 ].pos.y ;
					if( dbottom > DrawVect[ 3 ].pos.y ) dbottom = DrawVect[ 3 ].pos.y ;

					if( dtop    < DrawVect[ 0 ].pos.y ) dtop    = DrawVect[ 0 ].pos.y ;
					if( dtop    < DrawVect[ 1 ].pos.y ) dtop    = DrawVect[ 1 ].pos.y ;
					if( dtop    < DrawVect[ 2 ].pos.y ) dtop    = DrawVect[ 2 ].pos.y ;
					if( dtop    < DrawVect[ 3 ].pos.y ) dtop    = DrawVect[ 3 ].pos.y ;
				}
				break ;
			}
		}
	}

	if( DrawFlag == FALSE )
	{
		DrawArea->left   = _FTOL( dleft   ) - 1 ;
		DrawArea->right  = _FTOL( dright  ) + 1 ;
		DrawArea->top    = _FTOL( dtop    ) - 1 ;
		DrawArea->bottom = _FTOL( dbottom ) + 1 ;
	}

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawModiBillboard3DHardware
static int DrawModiBillboard3DHardware( VECTOR Pos, float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, IMAGEDATA2 *Image2, IMAGEDATA2 *BlendImage2, int TransFlag, int DrawFlag, RECT *DrawArea )
{
	VERTEX_2D *DrawVect ;
	VERTEX_3D *DrawVect3D ;
	VERTEX_BLENDTEX_2D *DrawVectB ;
	IMAGEDATA2_HARD_DRAW *DrawTex ;
	IMAGEDATA2_HARD_DRAW *BlendDrawTex ;
	IMAGEDATA2_ORIG *Orig ;
	IMAGEDATA2_HARD_VERT *TexVect ;
	IMAGEDATA2_HARD_VERT *BlendTexVect = NULL ;
	DWORD DiffuseColor ;
	int DrawTexNum ;
	int i, Flag ;
	int BlendGraphNoIncFlag ;
	VECTOR SrcVec2[ 4 ] ;
	float dleft = 0.0f, dright = 0.0f, dtop = 0.0f, dbottom = 0.0f;

	Orig = Image2->Orig ;

	if( GraphicsDevice_IsValid() == 0 || GRH.FlipSkipFlag ) return -1 ;

	// `揀
	if( DrawFlag )
	{
		if( GRH.BeginSceneFlag == FALSE ) BeginScene() ;
		Flag = TransFlag | DRAWPREP_3D | DRAWPREP_FOG | DRAWPREP_TEXADDRESS ;
		DRAWPREP_TEX( Orig, Image2->Hard.Draw[ 0 ].Tex->Texture, Flag )
	}
	else
	{
		dleft   = -100000000.0f ;
		dright  =  100000000.0f ;
		dtop    = -100000000.0f ;
		dbottom =  100000000.0f ;
	}

	// _f[^擾
	DiffuseColor = GRH.DiffuseColor ;

	// `̐Zbg
	DrawTexNum = Image2->Hard.DrawNum ;

	// `̐uh摜ƈقȂĂOԖڂ̃eNX`gp
	BlendGraphNoIncFlag = FALSE ;
	if( BlendImage2 != NULL && BlendImage2->Hard.DrawNum != Image2->Hard.DrawNum )
	{
		BlendGraphNoIncFlag = TRUE ;
	}

	// `z̃AhXZbgĂ
	DrawTex = Image2->Hard.Draw ;
	BlendDrawTex = NULL ;
	if( BlendImage2 != NULL )
	{
		BlendDrawTex = BlendImage2->Hard.Draw ;
	}

	// eNX`[̐JԂ
	for( i = 0 ; i < DrawTexNum ; i ++, DrawTex ++ )
	{
		// `悷eNX`[̃Zbg
		if( DrawFlag )
		{
			if( GRH.RenderTexture != DrawTex->Tex->Texture )
				SetTextureHardware( DrawTex->Tex->Texture ) ;
			if( BlendDrawTex != NULL )
			{
				if( GRH.BlendTexture != BlendDrawTex->Tex->Texture )
					SetBlendTextureHardware( BlendDrawTex->Tex->Texture, BlendDrawTex->Tex->TexWidth, BlendDrawTex->Tex->TexHeight );
			}
			if( GRH.ChangeTextureFlag )
				RefreshBlendStateHardware() ;
		}

		TexVect = DrawTex->Vertex ;
		if( BlendDrawTex != NULL )
		{
			BlendTexVect = BlendDrawTex->Vertex ;
		}

		// uhOtBbNgpĂȂāA`悷ꍇ͍ȏgp
		if( GRH.VertexType != VERTEXTYPE_BLENDTEX && DrawFlag == TRUE )
		{
			GETVERTEX_BILLBOARD( DrawVect3D ) ;

			// r{[hW[hW֕ϊ
			DrawVect3D[ 0 ].pos.x = x1 * GBASE.BillboardMatrix.m[0][0] + y1 * GBASE.BillboardMatrix.m[1][0] + Pos.x ;
			DrawVect3D[ 0 ].pos.y = x1 * GBASE.BillboardMatrix.m[0][1] + y1 * GBASE.BillboardMatrix.m[1][1] + Pos.y ;
			DrawVect3D[ 0 ].pos.z = x1 * GBASE.BillboardMatrix.m[0][2] + y1 * GBASE.BillboardMatrix.m[1][2] + Pos.z ;

			DrawVect3D[ 1 ].pos.x = x2 * GBASE.BillboardMatrix.m[0][0] + y2 * GBASE.BillboardMatrix.m[1][0] + Pos.x ;
			DrawVect3D[ 1 ].pos.y = x2 * GBASE.BillboardMatrix.m[0][1] + y2 * GBASE.BillboardMatrix.m[1][1] + Pos.y ;
			DrawVect3D[ 1 ].pos.z = x2 * GBASE.BillboardMatrix.m[0][2] + y2 * GBASE.BillboardMatrix.m[1][2] + Pos.z ;

			DrawVect3D[ 2 ].pos.x = x4 * GBASE.BillboardMatrix.m[0][0] + y4 * GBASE.BillboardMatrix.m[1][0] + Pos.x ;
			DrawVect3D[ 2 ].pos.y = x4 * GBASE.BillboardMatrix.m[0][1] + y4 * GBASE.BillboardMatrix.m[1][1] + Pos.y ;
			DrawVect3D[ 2 ].pos.z = x4 * GBASE.BillboardMatrix.m[0][2] + y4 * GBASE.BillboardMatrix.m[1][2] + Pos.z ;

			DrawVect3D[ 3 ].pos.x = x3 * GBASE.BillboardMatrix.m[0][0] + y3 * GBASE.BillboardMatrix.m[1][0] + Pos.x ;
			DrawVect3D[ 3 ].pos.y = x3 * GBASE.BillboardMatrix.m[0][1] + y3 * GBASE.BillboardMatrix.m[1][1] + Pos.y ;
			DrawVect3D[ 3 ].pos.z = x3 * GBASE.BillboardMatrix.m[0][2] + y3 * GBASE.BillboardMatrix.m[1][2] + Pos.z ;

			DrawVect3D[4].pos = DrawVect3D[2].pos ;
			DrawVect3D[5].pos = DrawVect3D[1].pos ;

			*( ( DWORD * )&DrawVect3D[0].b ) = 
			*( ( DWORD * )&DrawVect3D[3].b )	= DiffuseColor ;

			DrawVect3D[4].u       = DrawVect3D[2].u       = DrawVect3D[0].u       = TexVect[0].u ;
			DrawVect3D[5].u       = DrawVect3D[3].u       = DrawVect3D[1].u       = TexVect[1].u ;
			DrawVect3D[5].v       = DrawVect3D[1].v       = DrawVect3D[0].v       = TexVect[0].v ;
			DrawVect3D[4].v       = DrawVect3D[3].v       = DrawVect3D[2].v       = TexVect[2].v ;

			// eNX`[`悷
			ADD4VERTEX_BILLBOARD
		}
		else
		{
			// r{[ĥS_𓾂
			{
				// r{[hW[hW֕ϊ
				SrcVec2[ 0 ].x = x1 * GBASE.BillboardMatrix.m[0][0] + y1 * GBASE.BillboardMatrix.m[1][0] + Pos.x ;
				SrcVec2[ 0 ].y = x1 * GBASE.BillboardMatrix.m[0][1] + y1 * GBASE.BillboardMatrix.m[1][1] + Pos.y ;
				SrcVec2[ 0 ].z = x1 * GBASE.BillboardMatrix.m[0][2] + y1 * GBASE.BillboardMatrix.m[1][2] + Pos.z ;

				SrcVec2[ 1 ].x = x2 * GBASE.BillboardMatrix.m[0][0] + y2 * GBASE.BillboardMatrix.m[1][0] + Pos.x ;
				SrcVec2[ 1 ].y = x2 * GBASE.BillboardMatrix.m[0][1] + y2 * GBASE.BillboardMatrix.m[1][1] + Pos.y ;
				SrcVec2[ 1 ].z = x2 * GBASE.BillboardMatrix.m[0][2] + y2 * GBASE.BillboardMatrix.m[1][2] + Pos.z ;

				SrcVec2[ 2 ].x = x4 * GBASE.BillboardMatrix.m[0][0] + y4 * GBASE.BillboardMatrix.m[1][0] + Pos.x ;
				SrcVec2[ 2 ].y = x4 * GBASE.BillboardMatrix.m[0][1] + y4 * GBASE.BillboardMatrix.m[1][1] + Pos.y ;
				SrcVec2[ 2 ].z = x4 * GBASE.BillboardMatrix.m[0][2] + y4 * GBASE.BillboardMatrix.m[1][2] + Pos.z ;

				SrcVec2[ 3 ].x = x3 * GBASE.BillboardMatrix.m[0][0] + y3 * GBASE.BillboardMatrix.m[1][0] + Pos.x ;
				SrcVec2[ 3 ].y = x3 * GBASE.BillboardMatrix.m[0][1] + y3 * GBASE.BillboardMatrix.m[1][1] + Pos.y ;
				SrcVec2[ 3 ].z = x3 * GBASE.BillboardMatrix.m[0][2] + y3 * GBASE.BillboardMatrix.m[1][2] + Pos.z ;
			}

			// _^Cvɂď𕪊
			switch( GRH.VertexType )
			{
			case VERTEXTYPE_BLENDTEX :
				// uheNX`gp

				// _obt@̎擾
				GETVERTEX_QUAD( DrawVectB )

				// XN[Wɕϊ
				DrawVectB[0].pos.x = SrcVec2[0].x * GBASE.BlendMatrix.m[0][0] + SrcVec2[0].y * GBASE.BlendMatrix.m[1][0] + SrcVec2[0].z * GBASE.BlendMatrix.m[2][0] + GBASE.BlendMatrix.m[3][0]  ;
				DrawVectB[0].pos.y = SrcVec2[0].x * GBASE.BlendMatrix.m[0][1] + SrcVec2[0].y * GBASE.BlendMatrix.m[1][1] + SrcVec2[0].z * GBASE.BlendMatrix.m[2][1] + GBASE.BlendMatrix.m[3][1]  ;
				DrawVectB[0].pos.z = SrcVec2[0].x * GBASE.BlendMatrix.m[0][2] + SrcVec2[0].y * GBASE.BlendMatrix.m[1][2] + SrcVec2[0].z * GBASE.BlendMatrix.m[2][2] + GBASE.BlendMatrix.m[3][2]  ;
				DrawVectB[0].rhw   = SrcVec2[0].x * GBASE.BlendMatrix.m[0][3] + SrcVec2[0].y * GBASE.BlendMatrix.m[1][3] + SrcVec2[0].z * GBASE.BlendMatrix.m[2][3] + GBASE.BlendMatrix.m[3][3]  ;

				DrawVectB[3].rhw = 
				DrawVectB[2].rhw = 
				DrawVectB[1].rhw = 
				DrawVectB[0].rhw = 1.0F / DrawVectB[0].rhw ;
				DrawVectB[0].pos.x *= DrawVectB[0].rhw ;
				DrawVectB[0].pos.y *= DrawVectB[0].rhw ;
				DrawVectB[3].pos.z =
				DrawVectB[2].pos.z =
				DrawVectB[1].pos.z =
				DrawVectB[0].pos.z *= DrawVectB[0].rhw ;

				DrawVectB[1].pos.x = ( SrcVec2[1].x * GBASE.BlendMatrix.m[0][0] + SrcVec2[1].y * GBASE.BlendMatrix.m[1][0] + SrcVec2[1].z * GBASE.BlendMatrix.m[2][0] + GBASE.BlendMatrix.m[3][0] ) * DrawVectB[0].rhw ;
				DrawVectB[1].pos.y = ( SrcVec2[1].x * GBASE.BlendMatrix.m[0][1] + SrcVec2[1].y * GBASE.BlendMatrix.m[1][1] + SrcVec2[1].z * GBASE.BlendMatrix.m[2][1] + GBASE.BlendMatrix.m[3][1] ) * DrawVectB[0].rhw ;
				DrawVectB[2].pos.x = ( SrcVec2[2].x * GBASE.BlendMatrix.m[0][0] + SrcVec2[2].y * GBASE.BlendMatrix.m[1][0] + SrcVec2[2].z * GBASE.BlendMatrix.m[2][0] + GBASE.BlendMatrix.m[3][0] ) * DrawVectB[0].rhw ;
				DrawVectB[2].pos.y = ( SrcVec2[2].x * GBASE.BlendMatrix.m[0][1] + SrcVec2[2].y * GBASE.BlendMatrix.m[1][1] + SrcVec2[2].z * GBASE.BlendMatrix.m[2][1] + GBASE.BlendMatrix.m[3][1] ) * DrawVectB[0].rhw ;
				DrawVectB[3].pos.x = ( SrcVec2[3].x * GBASE.BlendMatrix.m[0][0] + SrcVec2[3].y * GBASE.BlendMatrix.m[1][0] + SrcVec2[3].z * GBASE.BlendMatrix.m[2][0] + GBASE.BlendMatrix.m[3][0] ) * DrawVectB[0].rhw ;
				DrawVectB[3].pos.y = ( SrcVec2[3].x * GBASE.BlendMatrix.m[0][1] + SrcVec2[3].y * GBASE.BlendMatrix.m[1][1] + SrcVec2[3].z * GBASE.BlendMatrix.m[2][1] + GBASE.BlendMatrix.m[3][1] ) * DrawVectB[0].rhw ;

				DrawVectB[4].pos = DrawVectB[2].pos ;
				DrawVectB[5].pos = DrawVectB[1].pos ;
				DrawVectB[4].rhw = DrawVectB[2].rhw ;
				DrawVectB[5].rhw = DrawVectB[1].rhw ;

				DrawVectB[0].color	= 
				DrawVectB[3].color	= DiffuseColor ;

				DrawVectB[4].u1 = DrawVectB[2].u1 = DrawVectB[0].u1 = ( TexVect[0].x - BlendTexVect[0].x + GBASE.BlendGraphX ) * GRH.InvBlendTextureWidth ;
				DrawVectB[5].u1 = DrawVectB[3].u1 = DrawVectB[1].u1 = ( TexVect[1].x - BlendTexVect[0].x + GBASE.BlendGraphX ) * GRH.InvBlendTextureWidth ;
				DrawVectB[5].v1 = DrawVectB[1].v1 = DrawVectB[0].v1 = ( TexVect[0].y - BlendTexVect[0].y + GBASE.BlendGraphY ) * GRH.InvBlendTextureHeight ;
				DrawVectB[4].v1 = DrawVectB[3].v1 = DrawVectB[2].v1 = ( TexVect[2].y - BlendTexVect[0].y + GBASE.BlendGraphY ) * GRH.InvBlendTextureHeight ;

				DrawVectB[4].u2 = DrawVectB[2].u2 = DrawVectB[0].u2 = TexVect[0].u ;
				DrawVectB[5].u2 = DrawVectB[3].u2 = DrawVectB[1].u2 = TexVect[1].u ;
				DrawVectB[5].v2 = DrawVectB[1].v2 = DrawVectB[0].v2 = TexVect[0].v ;
				DrawVectB[4].v2 = DrawVectB[3].v2 = DrawVectB[2].v2 = TexVect[2].v ;

				// eNX`[`悷
				if( DrawFlag )
				{
					ADD4VERTEX_BLENDTEX
				}
				else
				{
					if( dright  > DrawVectB[ 0 ].pos.x ) dright  = DrawVectB[ 0 ].pos.x ;
					if( dright  > DrawVectB[ 1 ].pos.x ) dright  = DrawVectB[ 1 ].pos.x ;
					if( dright  > DrawVectB[ 2 ].pos.x ) dright  = DrawVectB[ 2 ].pos.x ;
					if( dright  > DrawVectB[ 3 ].pos.x ) dright  = DrawVectB[ 3 ].pos.x ;

					if( dleft   < DrawVectB[ 0 ].pos.x ) dleft   = DrawVectB[ 0 ].pos.x ;
					if( dleft   < DrawVectB[ 1 ].pos.x ) dleft   = DrawVectB[ 1 ].pos.x ;
					if( dleft   < DrawVectB[ 2 ].pos.x ) dleft   = DrawVectB[ 2 ].pos.x ;
					if( dleft   < DrawVectB[ 3 ].pos.x ) dleft   = DrawVectB[ 3 ].pos.x ;

					if( dbottom > DrawVectB[ 0 ].pos.y ) dbottom = DrawVectB[ 0 ].pos.y ;
					if( dbottom > DrawVectB[ 1 ].pos.y ) dbottom = DrawVectB[ 1 ].pos.y ;
					if( dbottom > DrawVectB[ 2 ].pos.y ) dbottom = DrawVectB[ 2 ].pos.y ;
					if( dbottom > DrawVectB[ 3 ].pos.y ) dbottom = DrawVectB[ 3 ].pos.y ;

					if( dtop    < DrawVectB[ 0 ].pos.y ) dtop    = DrawVectB[ 0 ].pos.y ;
					if( dtop    < DrawVectB[ 1 ].pos.y ) dtop    = DrawVectB[ 1 ].pos.y ;
					if( dtop    < DrawVectB[ 2 ].pos.y ) dtop    = DrawVectB[ 2 ].pos.y ;
					if( dtop    < DrawVectB[ 3 ].pos.y ) dtop    = DrawVectB[ 3 ].pos.y ;
				}

				if( BlendGraphNoIncFlag == FALSE )
				{
					BlendDrawTex ++ ;
				}
				break ;

			case VERTEXTYPE_TEX :
				// uheNX`gpȂ

				// _obt@̎擾
				GETVERTEX_QUAD( DrawVect )

				// XN[Wɕϊ
				DrawVect[0].pos.x = SrcVec2[0].x * GBASE.BlendMatrix.m[0][0] + SrcVec2[0].y * GBASE.BlendMatrix.m[1][0] + SrcVec2[0].z * GBASE.BlendMatrix.m[2][0] + GBASE.BlendMatrix.m[3][0]  ;
				DrawVect[0].pos.y = SrcVec2[0].x * GBASE.BlendMatrix.m[0][1] + SrcVec2[0].y * GBASE.BlendMatrix.m[1][1] + SrcVec2[0].z * GBASE.BlendMatrix.m[2][1] + GBASE.BlendMatrix.m[3][1]  ;
				DrawVect[0].pos.z = SrcVec2[0].x * GBASE.BlendMatrix.m[0][2] + SrcVec2[0].y * GBASE.BlendMatrix.m[1][2] + SrcVec2[0].z * GBASE.BlendMatrix.m[2][2] + GBASE.BlendMatrix.m[3][2]  ;
				DrawVect[0].rhw   = SrcVec2[0].x * GBASE.BlendMatrix.m[0][3] + SrcVec2[0].y * GBASE.BlendMatrix.m[1][3] + SrcVec2[0].z * GBASE.BlendMatrix.m[2][3] + GBASE.BlendMatrix.m[3][3]  ;

				DrawVect[3].rhw = 
				DrawVect[2].rhw = 
				DrawVect[1].rhw = 
				DrawVect[0].rhw = 1.0F / DrawVect[0].rhw ;
				DrawVect[0].pos.x *= DrawVect[0].rhw ;
				DrawVect[0].pos.y *= DrawVect[0].rhw ;
				DrawVect[3].pos.z =
				DrawVect[2].pos.z =
				DrawVect[1].pos.z =
				DrawVect[0].pos.z *= DrawVect[0].rhw ;

				DrawVect[1].pos.x = ( SrcVec2[1].x * GBASE.BlendMatrix.m[0][0] + SrcVec2[1].y * GBASE.BlendMatrix.m[1][0] + SrcVec2[1].z * GBASE.BlendMatrix.m[2][0] + GBASE.BlendMatrix.m[3][0] ) * DrawVect[0].rhw ;
				DrawVect[1].pos.y = ( SrcVec2[1].x * GBASE.BlendMatrix.m[0][1] + SrcVec2[1].y * GBASE.BlendMatrix.m[1][1] + SrcVec2[1].z * GBASE.BlendMatrix.m[2][1] + GBASE.BlendMatrix.m[3][1] ) * DrawVect[0].rhw ;
				DrawVect[2].pos.x = ( SrcVec2[2].x * GBASE.BlendMatrix.m[0][0] + SrcVec2[2].y * GBASE.BlendMatrix.m[1][0] + SrcVec2[2].z * GBASE.BlendMatrix.m[2][0] + GBASE.BlendMatrix.m[3][0] ) * DrawVect[0].rhw ;
				DrawVect[2].pos.y = ( SrcVec2[2].x * GBASE.BlendMatrix.m[0][1] + SrcVec2[2].y * GBASE.BlendMatrix.m[1][1] + SrcVec2[2].z * GBASE.BlendMatrix.m[2][1] + GBASE.BlendMatrix.m[3][1] ) * DrawVect[0].rhw ;
				DrawVect[3].pos.x = ( SrcVec2[3].x * GBASE.BlendMatrix.m[0][0] + SrcVec2[3].y * GBASE.BlendMatrix.m[1][0] + SrcVec2[3].z * GBASE.BlendMatrix.m[2][0] + GBASE.BlendMatrix.m[3][0] ) * DrawVect[0].rhw ;
				DrawVect[3].pos.y = ( SrcVec2[3].x * GBASE.BlendMatrix.m[0][1] + SrcVec2[3].y * GBASE.BlendMatrix.m[1][1] + SrcVec2[3].z * GBASE.BlendMatrix.m[2][1] + GBASE.BlendMatrix.m[3][1] ) * DrawVect[0].rhw ;

				DrawVect[4].pos = DrawVect[2].pos ;
				DrawVect[5].pos = DrawVect[1].pos ;
				DrawVect[4].rhw = DrawVect[2].rhw ;
				DrawVect[5].rhw = DrawVect[1].rhw ;

				DrawVect[0].color	= 
				DrawVect[3].color	= DiffuseColor ;

				DrawVect[4].u       = DrawVect[2].u       = DrawVect[0].u       = TexVect[0].u ;
				DrawVect[5].u       = DrawVect[3].u       = DrawVect[1].u       = TexVect[1].u ;
				DrawVect[5].v       = DrawVect[1].v       = DrawVect[0].v       = TexVect[0].v ;
				DrawVect[4].v       = DrawVect[3].v       = DrawVect[2].v       = TexVect[2].v ;

				// eNX`[`悷
				if( DrawFlag )
				{
					ADD4VERTEX_TEX
				}
				else
				{
					if( dright  > DrawVect[ 0 ].pos.x ) dright  = DrawVect[ 0 ].pos.x ;
					if( dright  > DrawVect[ 1 ].pos.x ) dright  = DrawVect[ 1 ].pos.x ;
					if( dright  > DrawVect[ 2 ].pos.x ) dright  = DrawVect[ 2 ].pos.x ;
					if( dright  > DrawVect[ 3 ].pos.x ) dright  = DrawVect[ 3 ].pos.x ;

					if( dleft   < DrawVect[ 0 ].pos.x ) dleft   = DrawVect[ 0 ].pos.x ;
					if( dleft   < DrawVect[ 1 ].pos.x ) dleft   = DrawVect[ 1 ].pos.x ;
					if( dleft   < DrawVect[ 2 ].pos.x ) dleft   = DrawVect[ 2 ].pos.x ;
					if( dleft   < DrawVect[ 3 ].pos.x ) dleft   = DrawVect[ 3 ].pos.x ;

					if( dbottom > DrawVect[ 0 ].pos.y ) dbottom = DrawVect[ 0 ].pos.y ;
					if( dbottom > DrawVect[ 1 ].pos.y ) dbottom = DrawVect[ 1 ].pos.y ;
					if( dbottom > DrawVect[ 2 ].pos.y ) dbottom = DrawVect[ 2 ].pos.y ;
					if( dbottom > DrawVect[ 3 ].pos.y ) dbottom = DrawVect[ 3 ].pos.y ;

					if( dtop    < DrawVect[ 0 ].pos.y ) dtop    = DrawVect[ 0 ].pos.y ;
					if( dtop    < DrawVect[ 1 ].pos.y ) dtop    = DrawVect[ 1 ].pos.y ;
					if( dtop    < DrawVect[ 2 ].pos.y ) dtop    = DrawVect[ 2 ].pos.y ;
					if( dtop    < DrawVect[ 3 ].pos.y ) dtop    = DrawVect[ 3 ].pos.y ;
				}
				break ;
			}
		}
	}

	if( DrawFlag == FALSE )
	{
		DrawArea->left   = _FTOL( dleft   ) - 1 ;
		DrawArea->right  = _FTOL( dright  ) + 1 ;
		DrawArea->top    = _FTOL( dtop    ) - 1 ;
		DrawArea->bottom = _FTOL( dbottom ) + 1 ;
	}

	// I
	return 0 ;
}



// 򂪕Kvȕ`n֐

// n[hEGAANZ[^gp DrawGraph
static int  DrawGraphHardware( int x, int y, float xf, float yf, IMAGEDATA2 *Image2, IMAGEDATA2 *BlendImage2, int TransFlag, int IntFlag )
{
	VERTEX_2D *DrawVect, *Vect ;
	VERTEX_BLENDTEX_2D *DrawVectB, *VectB ;
	IMAGEDATA2_HARD_DRAW *DrawTex ;
	IMAGEDATA2_HARD_DRAW *BlendDrawTex = NULL ;
	IMAGEDATA2_ORIG *Orig ;
	IMAGEDATA2_HARD_VERT *TexVect ;
	IMAGEDATA2_HARD_VERT *BlendTexVect ;
	DWORD DiffuseColor ;
	int DrawTexNum ;
	int i, j, Flag ;
	int BlendGraphNoIncFlag ;
	float left, right, top, bottom ;
	float Vx, Vy, VBx, VBy ;
	DWORD drawz;

	Orig = Image2->Orig ;

	if( GraphicsDevice_IsValid() == 0 || GRH.FlipSkipFlag ) return -1 ;

	// floatW␳
	xf -= 0.5F ;
	yf -= 0.5F ;

	// `揀
	if( GRH.BeginSceneFlag == FALSE ) BeginScene() ;
	Flag = TransFlag | ( IntFlag << 1 ) ;
	DRAWPREP_TEX( Orig, Image2->Hard.Draw[ 0 ].Tex->Texture, Flag )

	// _f[^擾
	DiffuseColor = GRH.DiffuseColor ;

	// `̐Zbg
	DrawTexNum = Image2->Hard.DrawNum ;

	// `̐uh摜ƈقȂĂOԖڂ̃eNX`gp
	BlendGraphNoIncFlag = FALSE ;
	if( BlendImage2 != NULL && BlendImage2->Hard.DrawNum != Image2->Hard.DrawNum )
	{
		BlendGraphNoIncFlag = TRUE ;
	}

	// `z̃AhXZbgĂ
	DrawTex = Image2->Hard.Draw ;
	if( BlendImage2 != NULL )
	{
		BlendDrawTex = BlendImage2->Hard.Draw ;
	}

	// yobt@ɏނylZbg
	drawz = *( ( DWORD * )&GBASE.DrawZ ) ;

	// `͈͂͂ݏoĂ邩ǂŏ𕪊
	if( IN_DRAWAREA_CHECK( x, y, x + Image2->Width, y + Image2->Height ) )
//	if( x + Image2->Width < GBASE.DrawArea.right && x > GBASE.DrawArea.left &&
//		y + Image2->Height < GBASE.DrawArea.bottom && y > GBASE.DrawArea.right )
	{
		// ͂ݏoĂȂꍇ

		// _^Cvɂď𕪊
		if( GRH.VertexType == VERTEXTYPE_BLENDTEX )
		{
			// uheNX`gp

			// eNX`[̐JԂ
			for( i = 0 ; i < DrawTexNum ; i ++, DrawTex ++ )
			{
				// `悷eNX`[̃Zbg
				if( GRH.RenderTexture != DrawTex->Tex->Texture )
					SetTextureHardware( DrawTex->Tex->Texture ) ;
				if( GRH.BlendTexture != BlendDrawTex->Tex->Texture )
					SetBlendTextureHardware( BlendDrawTex->Tex->Texture, BlendDrawTex->Tex->TexWidth, BlendDrawTex->Tex->TexHeight );
				if( GRH.ChangeTextureFlag )
					RefreshBlendStateHardware() ;

				// _obt@̎擾
				GETVERTEX_QUAD( DrawVectB )
				
				TexVect = DrawTex->Vertex ;
				BlendTexVect = BlendDrawTex->Vertex ;

				DrawVectB[0].color = 
				DrawVectB[3].color = ( DWORD )DiffuseColor ;

				DrawVectB[4].pos.x = DrawVectB[2].pos.x = DrawVectB[0].pos.x = xf + TexVect[0].x ;
				DrawVectB[5].pos.x = DrawVectB[3].pos.x = DrawVectB[1].pos.x = xf + TexVect[1].x ;
				DrawVectB[5].pos.y = DrawVectB[1].pos.y = DrawVectB[0].pos.y = yf + TexVect[0].y ;
				DrawVectB[4].pos.y = DrawVectB[3].pos.y = DrawVectB[2].pos.y = yf + TexVect[2].y ;

				DrawVectB[4].u1 = DrawVectB[2].u1 = DrawVectB[0].u1 = ( TexVect[0].x - BlendTexVect[0].x + GBASE.BlendGraphX ) * GRH.InvBlendTextureWidth ;
				DrawVectB[5].u1 = DrawVectB[3].u1 = DrawVectB[1].u1 = ( TexVect[1].x - BlendTexVect[0].x + GBASE.BlendGraphX ) * GRH.InvBlendTextureWidth ;
				DrawVectB[5].v1 = DrawVectB[1].v1 = DrawVectB[0].v1 = ( TexVect[0].y - BlendTexVect[0].y + GBASE.BlendGraphY ) * GRH.InvBlendTextureHeight ;
				DrawVectB[4].v1 = DrawVectB[3].v1 = DrawVectB[2].v1 = ( TexVect[2].y - BlendTexVect[0].y + GBASE.BlendGraphY ) * GRH.InvBlendTextureHeight ;

				DrawVectB[4].u2 = DrawVectB[2].u2 = DrawVectB[0].u2 = TexVect[0].u ;
				DrawVectB[5].u2 = DrawVectB[3].u2 = DrawVectB[1].u2 = TexVect[1].u ;
				DrawVectB[5].v2 = DrawVectB[1].v2 = DrawVectB[0].v2 = TexVect[0].v ;
				DrawVectB[4].v2 = DrawVectB[3].v2 = DrawVectB[2].v2 = TexVect[2].v ;

				if( GRH.UseAlphaChDrawShader )
				{
					DrawVectB[4].sc_u   = DrawVectB[2].sc_u   = DrawVectB[0].sc_u   = ( DrawVectB[0].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					DrawVectB[5].sc_u   = DrawVectB[3].sc_u   = DrawVectB[1].sc_u   = ( DrawVectB[1].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					DrawVectB[5].sc_v   = DrawVectB[1].sc_v   = DrawVectB[0].sc_v   = ( DrawVectB[0].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					DrawVectB[4].sc_v   = DrawVectB[3].sc_v   = DrawVectB[2].sc_v   = ( DrawVectB[2].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
				}

				*((DWORD *)&DrawVectB[0].pos.z) =
				*((DWORD *)&DrawVectB[1].pos.z) =
				*((DWORD *)&DrawVectB[2].pos.z) =
				*((DWORD *)&DrawVectB[3].pos.z) =
				*((DWORD *)&DrawVectB[4].pos.z) =
				*((DWORD *)&DrawVectB[5].pos.z) = drawz;

				// eNX`[`悷
				ADD4VERTEX_BLENDTEX

				if( BlendGraphNoIncFlag == FALSE )
				{
					BlendDrawTex ++ ;
				}
			}
		}
		else
		{
			// uheNX`gpȂ

			// eNX`[̐JԂ
			i = 0 ;
			for(;;)
			{
				// _obt@̎擾
				GETVERTEX_QUAD( DrawVect )

				// _f[^
				TexVect = DrawTex->Vertex ;
				DrawVect[0].color	= 
				DrawVect[3].color	= DiffuseColor ;

				DrawVect[4].pos.x   = DrawVect[2].pos.x   = DrawVect[0].pos.x   = TexVect[0].x + xf ;
				DrawVect[5].pos.x   = DrawVect[3].pos.x   = DrawVect[1].pos.x   = TexVect[1].x + xf ;
				DrawVect[5].pos.y   = DrawVect[1].pos.y   = DrawVect[0].pos.y   = TexVect[0].y + yf ;
				DrawVect[4].pos.y   = DrawVect[3].pos.y   = DrawVect[2].pos.y   = TexVect[2].y + yf ;

				DrawVect[4].u       = DrawVect[2].u       = DrawVect[0].u       = TexVect[0].u ;
				DrawVect[5].u       = DrawVect[3].u       = DrawVect[1].u       = TexVect[1].u ;
				DrawVect[5].v       = DrawVect[1].v       = DrawVect[0].v       = TexVect[0].v ;
				DrawVect[4].v       = DrawVect[3].v       = DrawVect[2].v       = TexVect[2].v ;

				if( GRH.UseAlphaChDrawShader )
				{
					DrawVect[4].sc_u   = DrawVect[2].sc_u   = DrawVect[0].sc_u   = ( DrawVect[0].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					DrawVect[5].sc_u   = DrawVect[3].sc_u   = DrawVect[1].sc_u   = ( DrawVect[1].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					DrawVect[5].sc_v   = DrawVect[1].sc_v   = DrawVect[0].sc_v   = ( DrawVect[0].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					DrawVect[4].sc_v   = DrawVect[3].sc_v   = DrawVect[2].sc_v   = ( DrawVect[2].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
				}

				*((DWORD *)&DrawVect[0].pos.z) =
				*((DWORD *)&DrawVect[1].pos.z) =
				*((DWORD *)&DrawVect[2].pos.z) =
				*((DWORD *)&DrawVect[3].pos.z) =
				*((DWORD *)&DrawVect[4].pos.z) =
				*((DWORD *)&DrawVect[5].pos.z) = drawz;

				// eNX`[`悷
				ADD4VERTEX_TEX

				i ++ ;
				if( i >= DrawTexNum ) break ;

				// `悷eNX`[̃Zbg
				DrawTex ++ ;
				SetTextureHardware( DrawTex->Tex->Texture ) ;
				RefreshBlendStateHardware() ;
			}
		}
	}
	else
	{
		// ͂ݏoĂꍇ

		// Sɂ͂ݏoĂ牽I
		if( OUT_DRAWAREA_CHECK( x, y, x + Image2->Width, y + Image2->Height ) ) return 0 ;
//		if( x > GBASE.DrawArea.right || x + Image2->Width < GBASE.DrawArea.left ||
//			y > GBASE.DrawArea.bottom || y + Image2->Height < GBASE.DrawArea.top ) return 0 ;

		// ``̕ۑ
		left	= GBASE.DrawAreaF.left   ;
		top		= GBASE.DrawAreaF.top    ;
		right	= GBASE.DrawAreaF.right  ;
		bottom	= GBASE.DrawAreaF.bottom ;

		// _^Cvɂď𕪊
		switch( GRH.VertexType )
		{
		case VERTEXTYPE_BLENDTEX :
			// uheNX`gp

			// eNX`[̐JԂ
			for( i = 0 ; i < DrawTexNum ; i ++, DrawTex ++ )
			{
				// `悷eNX`[̃Zbg
				if( GRH.RenderTexture != DrawTex->Tex->Texture )
					SetTextureHardware( DrawTex->Tex->Texture ) ;
				if( GRH.BlendTexture != BlendDrawTex->Tex->Texture )
					SetBlendTextureHardware( BlendDrawTex->Tex->Texture, BlendDrawTex->Tex->TexWidth, BlendDrawTex->Tex->TexHeight );
				if( GRH.ChangeTextureFlag )
					RefreshBlendStateHardware() ;

				// _obt@̎擾
				GETVERTEX_QUAD( DrawVectB )
				
				// _f[^
				VectB = DrawVectB ;
				TexVect = DrawTex->Vertex ;
				BlendTexVect = BlendDrawTex->Vertex ;

				Vx  = 1.0F / ( float )DrawTex->Tex->TexWidth  ;
				Vy  = 1.0F / ( float )DrawTex->Tex->TexHeight ;
				VBx = GRH.InvBlendTextureWidth  ;
				VBy = GRH.InvBlendTextureHeight ;

				DrawVectB[0].color = 
				DrawVectB[3].color = ( DWORD )DiffuseColor ;

				DrawVectB[2].pos.x = DrawVectB[0].pos.x = xf + TexVect[0].x ;
				DrawVectB[3].pos.x = DrawVectB[1].pos.x = xf + TexVect[1].x ;
				DrawVectB[1].pos.y = DrawVectB[0].pos.y = yf + TexVect[0].y ;
				DrawVectB[3].pos.y = DrawVectB[2].pos.y = yf + TexVect[2].y ;

				DrawVectB[2].u1 = DrawVectB[0].u1 = ( TexVect[0].x - BlendTexVect[0].x + GBASE.BlendGraphX ) * GRH.InvBlendTextureWidth ;
				DrawVectB[3].u1 = DrawVectB[1].u1 = ( TexVect[1].x - BlendTexVect[0].x + GBASE.BlendGraphX ) * GRH.InvBlendTextureWidth ;
				DrawVectB[1].v1 = DrawVectB[0].v1 = ( TexVect[0].y - BlendTexVect[0].y + GBASE.BlendGraphY ) * GRH.InvBlendTextureHeight ;
				DrawVectB[3].v1 = DrawVectB[2].v1 = ( TexVect[2].y - BlendTexVect[0].y + GBASE.BlendGraphY ) * GRH.InvBlendTextureHeight ;

				DrawVectB[2].u2 = DrawVectB[0].u2 = TexVect[0].u ;
				DrawVectB[3].u2 = DrawVectB[1].u2 = TexVect[1].u ;
				DrawVectB[1].v2 = DrawVectB[0].v2 = TexVect[0].v ;
				DrawVectB[3].v2 = DrawVectB[2].v2 = TexVect[2].v ;

				for( j = 0 ; j < 4 ; j ++, VectB ++ )
				{
					// ``oĂꍇ̕␳
					if( VectB->pos.x < left )
					{
						VectB->u2 += ( left - VectB->pos.x ) * Vx ;
						VectB->u1 += ( left - VectB->pos.x ) * VBx ;
						VectB->pos.x = left ;
					}
					else
					if( VectB->pos.x > right )
					{
						VectB->u2 -= ( VectB->pos.x - right ) * Vx ;
						VectB->u1 -= ( VectB->pos.x - right ) * VBx ;
						VectB->pos.x = right ;
					}	

					if( VectB->pos.y < top )
					{
						VectB->v2 += ( top - VectB->pos.y ) * Vy ;
						VectB->v1 += ( top - VectB->pos.y ) * VBy ;
						VectB->pos.y = top ;
					}
					else
					if( VectB->pos.y > bottom )
					{
						VectB->v2 -= ( VectB->pos.y - bottom ) * Vy ;
						VectB->v1 -= ( VectB->pos.y - bottom ) * VBy ;
						VectB->pos.y = bottom ;
					}
				}

				if( GRH.UseAlphaChDrawShader )
				{
					DrawVectB[0].sc_u = ( DrawVectB[0].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					DrawVectB[0].sc_v = ( DrawVectB[0].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					DrawVectB[1].sc_u = ( DrawVectB[1].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					DrawVectB[1].sc_v = ( DrawVectB[1].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					DrawVectB[2].sc_u = ( DrawVectB[2].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					DrawVectB[2].sc_v = ( DrawVectB[2].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					DrawVectB[3].sc_u = ( DrawVectB[3].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					DrawVectB[3].sc_v = ( DrawVectB[3].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
				}

				DrawVectB[4] = DrawVectB[2] ;
				DrawVectB[5] = DrawVectB[1] ;

				*((DWORD *)&DrawVectB[0].pos.z) =
				*((DWORD *)&DrawVectB[1].pos.z) =
				*((DWORD *)&DrawVectB[2].pos.z) =
				*((DWORD *)&DrawVectB[3].pos.z) =
				*((DWORD *)&DrawVectB[4].pos.z) =
				*((DWORD *)&DrawVectB[5].pos.z) = drawz;

				// eNX`[`悷
				ADD4VERTEX_BLENDTEX

				if( BlendGraphNoIncFlag == FALSE )
				{
					BlendDrawTex ++ ;
				}
			}
			break ;
		
		case VERTEXTYPE_TEX :
			// uheNX`gpȂ

			// eNX`[̐JԂ
			i = 0 ;
			for(;;)
			{
				// _obt@̎擾
				GETVERTEX_QUAD( DrawVect )
				
				// _f[^
				TexVect = DrawTex->Vertex ;
				DrawVect[0].color	= 
				DrawVect[3].color	= DiffuseColor ;

				DrawVect[2].pos.x   = DrawVect[0].pos.x   = TexVect[0].x + xf ;
				DrawVect[3].pos.x   = DrawVect[1].pos.x   = TexVect[1].x + xf ;
				DrawVect[1].pos.y   = DrawVect[0].pos.y   = TexVect[0].y + yf ;
				DrawVect[3].pos.y   = DrawVect[2].pos.y   = TexVect[2].y + yf ;

				DrawVect[2].u       = DrawVect[0].u       = TexVect[0].u ;
				DrawVect[3].u       = DrawVect[1].u       = TexVect[1].u ;
				DrawVect[1].v       = DrawVect[0].v       = TexVect[0].v ;
				DrawVect[3].v       = DrawVect[2].v       = TexVect[2].v ;
				
				// _f[^
				Vect = DrawVect ;
				Vx	= 1.0F / ( float )DrawTex->Tex->TexWidth ;
				Vy	= 1.0F / ( float )DrawTex->Tex->TexHeight ;
				for( j = 0 ; j < 4 ; j ++, Vect ++ )
				{
					// ``oĂꍇ̕␳
					if( Vect->pos.x < left )
					{
						Vect->u += ( left - Vect->pos.x ) * Vx ;
						Vect->pos.x = left ;
					}
					else
					if( Vect->pos.x > right )
					{
						Vect->u -= ( Vect->pos.x - right ) * Vx ;
						Vect->pos.x = right ;
					}	

					if( Vect->pos.y < top )
					{
						Vect->v += ( top - Vect->pos.y ) * Vy ;
						Vect->pos.y = top ;
					}
					else
					if( Vect->pos.y > bottom )
					{
						Vect->v -= ( Vect->pos.y - bottom ) * Vy ;
						Vect->pos.y = bottom ;
					}
				}
				
				if( GRH.UseAlphaChDrawShader )
				{
					DrawVect[0].sc_u = ( DrawVect[0].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					DrawVect[0].sc_v = ( DrawVect[0].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					DrawVect[1].sc_u = ( DrawVect[1].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					DrawVect[1].sc_v = ( DrawVect[1].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					DrawVect[2].sc_u = ( DrawVect[2].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					DrawVect[2].sc_v = ( DrawVect[2].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					DrawVect[3].sc_u = ( DrawVect[3].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					DrawVect[3].sc_v = ( DrawVect[3].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
				}

				DrawVect[4] = DrawVect[2] ;
				DrawVect[5] = DrawVect[1] ;

				*((DWORD *)&DrawVect[0].pos.z) =
				*((DWORD *)&DrawVect[1].pos.z) =
				*((DWORD *)&DrawVect[2].pos.z) =
				*((DWORD *)&DrawVect[3].pos.z) =
				*((DWORD *)&DrawVect[4].pos.z) =
				*((DWORD *)&DrawVect[5].pos.z) = drawz;

				// eNX`[`悷
				ADD4VERTEX_TEX

				i ++ ;
				if( i >= DrawTexNum ) break ;

				// `悷eNX`[̃Zbg
				DrawTex ++ ;
				SetTextureHardware( DrawTex->Tex->Texture ) ;
				RefreshBlendStateHardware() ;
			}
			break ;
		}
	}

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawExtendGraph
static int  DrawExtendGraphHardware( int x1, int y1, int x2, int y2, float x1f, float y1f, float x2f, float y2f, IMAGEDATA2 *Image2, IMAGEDATA2 *BlendImage2, int TransFlag, int IntFlag )
{
	VERTEX_2D *Vect ;
	VERTEX_BLENDTEX_2D *VectDataB, *VectB ; 
	IMAGEDATA2_HARD_DRAW *DrawTex ;
	IMAGEDATA2_HARD_DRAW *BlendDrawTex = NULL ;
	IMAGEDATA2_HARD_VERT *TexVect ;
	IMAGEDATA2_HARD_VERT *BlendTexVect ;
	IMAGEDATA2_ORIG *Orig ;
	int DrawTexNum ;
	int i, j ;
	int BlendGraphNoIncFlag ;
	float GraphExRateX, GraphExRateY ;
//	int ReverseX = FALSE, ReverseY = FALSE ;
	int Reverse ;
//	int AdjX = FALSE, AdjY = FALSE ;
	float left, right, top, bottom ;
	float Vx, Vy ;
	float VBx, VBy ;
	int DiffuseColor ;
	DWORD drawz;
	int Flag ;

	Orig = Image2->Orig ;

	if( GraphicsDevice_IsValid() == 0 || GRH.FlipSkipFlag ) return -1 ;

	// `攻
//	if( x2 - x1 == Image2->Width && y2 - y1 == Image2->Height ) return G_D3D_DrawGraph( x1, y1, GraphData, TransFlag ) ; 	

	// Ȃꍇ̓G[
	if( x1 == x2 || y1 == y2 ) return -1 ;

	// `̏
	if( GRH.BeginSceneFlag == FALSE ) BeginScene() ;
	Flag = TransFlag | ( IntFlag ? ( GBASE.DrawMode == DX_DRAWMODE_BILINEAR ? 0 : DRAWPREP_VECTORINT ) : 0 ) ;
	DRAWPREP_TEX( Orig, Image2->Hard.Draw[ 0 ].Tex->Texture, Flag )

	// fBt[YJ[̎擾
	DiffuseColor = GRH.DiffuseColor ;

	// `̐Zbg
	DrawTexNum = Image2->Hard.DrawNum ;

	// `̐uh摜ƈقȂĂOԖڂ̃eNX`gp
	BlendGraphNoIncFlag = FALSE ;
	if( BlendImage2 != NULL && BlendImage2->Hard.DrawNum != Image2->Hard.DrawNum )
	{
		BlendGraphNoIncFlag = TRUE ;
	}

	// `z̃AhXZbgĂ
	DrawTex = Image2->Hard.Draw ;
	if( BlendImage2 != NULL )
	{
		BlendDrawTex = BlendImage2->Hard.Draw ;
	}

	// yobt@ɏނylZbg
	drawz = *((DWORD *)&GBASE.DrawZ);

	// g嗦擾Ă
	GraphExRateX = ( x2f - x1f ) / Image2->Width ;
	GraphExRateY = ( y2f - y1f ) / Image2->Height ;
	Reverse = ( GraphExRateX < 0 ) != ( GraphExRateY < 0 ) ;

	x1f -= 0.5F ;
	y1f -= 0.5F ;

	if( x1 > x2 ){ i = x2; x2 = x1; x1 = i; }
	if( y1 > y2 ){ i = y2; y2 = y1; y1 = i; }

	// `͈͂͂ݏoĂ邩ǂŏ𕪊
	if( IN_DRAWAREA_CHECK( x1, y1, x2, y2 ) )
	{
		// _^Cvɂď𕪊
		switch( GRH.VertexType )
		{
		case VERTEXTYPE_BLENDTEX :	// uheNX`gp
			// eNX`[̐JԂ
			for( i = 0 ; i < DrawTexNum ; i ++, DrawTex ++ )
			{
				// `悷eNX`[̃Zbg
				if( GRH.RenderTexture != DrawTex->Tex->Texture )
					SetTextureHardware( DrawTex->Tex->Texture ) ;
				if( GRH.BlendTexture != BlendDrawTex->Tex->Texture )
					SetBlendTextureHardware( BlendDrawTex->Tex->Texture, BlendDrawTex->Tex->TexWidth, BlendDrawTex->Tex->TexHeight );
				if( GRH.ChangeTextureFlag )
					RefreshBlendStateHardware() ;

				// _f[^
				GETVERTEX_QUAD( VectDataB )
				
				TexVect = DrawTex->Vertex ;
				BlendTexVect = BlendDrawTex->Vertex ;

				VectDataB[0].color = 
				VectDataB[3].color = ( DWORD )DiffuseColor ;

				VectDataB[4].pos.x = VectDataB[2].pos.x = VectDataB[0].pos.x = TexVect[0].x * GraphExRateX + x1f ;
				VectDataB[5].pos.x = VectDataB[3].pos.x = VectDataB[1].pos.x = TexVect[1].x * GraphExRateX + x1f ;
				VectDataB[5].pos.y = VectDataB[1].pos.y = VectDataB[0].pos.y = TexVect[0].y * GraphExRateY + y1f ;
				VectDataB[4].pos.y = VectDataB[3].pos.y = VectDataB[2].pos.y = TexVect[2].y * GraphExRateY + y1f ;

				VectDataB[4].u1 = VectDataB[2].u1 = VectDataB[0].u1 = ( TexVect[0].x - BlendTexVect[0].x + GBASE.BlendGraphX ) * GRH.InvBlendTextureWidth ;
				VectDataB[5].u1 = VectDataB[3].u1 = VectDataB[1].u1 = ( TexVect[1].x - BlendTexVect[0].x + GBASE.BlendGraphX ) * GRH.InvBlendTextureWidth ;
				VectDataB[5].v1 = VectDataB[1].v1 = VectDataB[0].v1 = ( TexVect[0].y - BlendTexVect[0].y + GBASE.BlendGraphY ) * GRH.InvBlendTextureHeight ;
				VectDataB[4].v1 = VectDataB[3].v1 = VectDataB[2].v1 = ( TexVect[2].y - BlendTexVect[0].y + GBASE.BlendGraphY ) * GRH.InvBlendTextureHeight ;

				VectDataB[4].u2 = VectDataB[2].u2 = VectDataB[0].u2 = TexVect[0].u ;
				VectDataB[5].u2 = VectDataB[3].u2 = VectDataB[1].u2 = TexVect[1].u ;
				VectDataB[5].v2 = VectDataB[1].v2 = VectDataB[0].v2 = TexVect[0].v ;
				VectDataB[4].v2 = VectDataB[3].v2 = VectDataB[2].v2 = TexVect[2].v ;

				if( GRH.UseAlphaChDrawShader )
				{
					VectDataB[4].sc_u = VectDataB[2].sc_u = VectDataB[0].sc_u = ( VectDataB[0].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					VectDataB[5].sc_u = VectDataB[3].sc_u = VectDataB[1].sc_u = ( VectDataB[1].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					VectDataB[5].sc_v = VectDataB[1].sc_v = VectDataB[0].sc_v = ( VectDataB[0].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					VectDataB[4].sc_v = VectDataB[3].sc_v = VectDataB[2].sc_v = ( VectDataB[2].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
				}

				*((DWORD *)&VectDataB[0].pos.z) =
				*((DWORD *)&VectDataB[1].pos.z) =
				*((DWORD *)&VectDataB[2].pos.z) =
				*((DWORD *)&VectDataB[3].pos.z) =
				*((DWORD *)&VectDataB[4].pos.z) =
				*((DWORD *)&VectDataB[5].pos.z) = drawz;

				// eNX`[`悷
				ADD4VERTEX_BLENDTEX

				if( BlendGraphNoIncFlag == FALSE )
				{
					BlendDrawTex ++ ;
				}
			}
			break ;

		case VERTEXTYPE_TEX :	// uheNX`gpȂ
			// eNX`[̐JԂ
			i = 0 ;
			for(;;)
			{
				// _f[^
				GETVERTEX_QUAD( Vect )
				
				TexVect = DrawTex->Vertex ;
				
				Vect[0].color = 
				Vect[3].color = ( DWORD )DiffuseColor ;

				Vect[4].pos.x = Vect[2].pos.x = Vect[0].pos.x = TexVect[0].x * GraphExRateX + x1f ;
				Vect[5].pos.x = Vect[3].pos.x = Vect[1].pos.x = TexVect[1].x * GraphExRateX + x1f ;
				Vect[5].pos.y = Vect[1].pos.y = Vect[0].pos.y = TexVect[0].y * GraphExRateY + y1f ;
				Vect[4].pos.y = Vect[3].pos.y = Vect[2].pos.y = TexVect[2].y * GraphExRateY + y1f ;

				Vect[4].u       = Vect[2].u       = Vect[0].u       = TexVect[0].u ;
				Vect[5].u       = Vect[3].u       = Vect[1].u       = TexVect[1].u ;
				Vect[5].v       = Vect[1].v       = Vect[0].v       = TexVect[0].v ;
				Vect[4].v       = Vect[3].v       = Vect[2].v       = TexVect[2].v ;

				if( GRH.UseAlphaChDrawShader )
				{
					Vect[4].sc_u = Vect[2].sc_u = Vect[0].sc_u = ( Vect[0].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					Vect[5].sc_u = Vect[3].sc_u = Vect[1].sc_u = ( Vect[1].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					Vect[5].sc_v = Vect[1].sc_v = Vect[0].sc_v = ( Vect[0].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					Vect[4].sc_v = Vect[3].sc_v = Vect[2].sc_v = ( Vect[2].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
				}

				*((DWORD *)&Vect[0].pos.z) =
				*((DWORD *)&Vect[1].pos.z) =
				*((DWORD *)&Vect[2].pos.z) =
				*((DWORD *)&Vect[3].pos.z) =
				*((DWORD *)&Vect[4].pos.z) =
				*((DWORD *)&Vect[5].pos.z) = drawz;

				// eNX`[`悷
				ADD4VERTEX_TEX

				i ++ ;
				if( i >= DrawTexNum ) break ;

				// `悷eNX`[̃Zbg
				DrawTex ++ ;
				SetTextureHardware( DrawTex->Tex->Texture ) ;
				RefreshBlendStateHardware() ;
			}
			break ;
		}
	}
	else
	{
		// Sɂ͂ݏoĂ牽I
		if( OUT_DRAWAREA_CHECK( x1, y1, x2, y2 ) ) return 0 ;

		// ``̕ۑ
		left	= GBASE.DrawAreaF.left   - 0.5f + GBASE.WindowDrawRect.left ;
		top		= GBASE.DrawAreaF.top    - 0.5f + GBASE.WindowDrawRect.top  ;
		right	= GBASE.DrawAreaF.right  - 0.5f + GBASE.WindowDrawRect.left ;
		bottom	= GBASE.DrawAreaF.bottom - 0.5f + GBASE.WindowDrawRect.top  ;

		// _^Cvɂď𕪊
		switch( GRH.VertexType )
		{
		case VERTEXTYPE_BLENDTEX :	// uheNX`gp
			// eNX`[̐JԂ
			for( i = 0 ; i < DrawTexNum ; i ++, DrawTex ++ )
			{
				// `悷eNX`[̃Zbg
				if( GRH.RenderTexture != DrawTex->Tex->Texture )
					SetTextureHardware( DrawTex->Tex->Texture ) ;
				if( GRH.BlendTexture != BlendDrawTex->Tex->Texture )
					SetBlendTextureHardware( BlendDrawTex->Tex->Texture, BlendDrawTex->Tex->TexWidth, BlendDrawTex->Tex->TexHeight );
				if( GRH.ChangeTextureFlag )
					RefreshBlendStateHardware() ;

				GETVERTEX_QUAD( VectDataB )
				
				VectB = VectDataB ;
				Vx = 1.0F / ( DrawTex->Tex->TexWidth * GraphExRateX ) ;
				Vy = 1.0F / ( DrawTex->Tex->TexHeight * GraphExRateY ) ;
				VBx = GRH.InvBlendTextureWidth ;
				VBy = GRH.InvBlendTextureHeight ;

				// _f[^
				TexVect = DrawTex->Vertex ;
				BlendTexVect = BlendDrawTex->Vertex ;

				VectDataB[0].color = 
				VectDataB[3].color = ( DWORD )DiffuseColor ;

				VectDataB[2].pos.x = VectDataB[0].pos.x = TexVect[0].x * GraphExRateX + x1f ;
				VectDataB[3].pos.x = VectDataB[1].pos.x = TexVect[1].x * GraphExRateX + x1f ;
				VectDataB[1].pos.y = VectDataB[0].pos.y = TexVect[0].y * GraphExRateY + y1f ;
				VectDataB[3].pos.y = VectDataB[2].pos.y = TexVect[2].y * GraphExRateY + y1f ;

				VectDataB[2].u1 = VectDataB[0].u1 = ( TexVect[0].x - BlendTexVect[0].x + GBASE.BlendGraphX ) * GRH.InvBlendTextureWidth ;
				VectDataB[3].u1 = VectDataB[1].u1 = ( TexVect[1].x - BlendTexVect[0].x + GBASE.BlendGraphX ) * GRH.InvBlendTextureWidth ;
				VectDataB[1].v1 = VectDataB[0].v1 = ( TexVect[0].y - BlendTexVect[0].y + GBASE.BlendGraphY ) * GRH.InvBlendTextureHeight ;
				VectDataB[3].v1 = VectDataB[2].v1 = ( TexVect[2].y - BlendTexVect[0].y + GBASE.BlendGraphY ) * GRH.InvBlendTextureHeight ;

				VectDataB[2].u2 = VectDataB[0].u2 = TexVect[0].u ;
				VectDataB[3].u2 = VectDataB[1].u2 = TexVect[1].u ;
				VectDataB[1].v2 = VectDataB[0].v2 = TexVect[0].v ;
				VectDataB[3].v2 = VectDataB[2].v2 = TexVect[2].v ;

				for( j = 0 ; j < 4 ; j ++, VectB ++ )
				{
					// ``oĂꍇ̕␳
					if( VectB->pos.x < left )
					{
						VectB->u2 += ( left - VectB->pos.x ) * Vx ;
						VectB->u1 += ( left - VectB->pos.x ) * VBx ;
						VectB->pos.x = left ;
					}
					else
					if( VectB->pos.x > right )
					{
						VectB->u2 -= ( VectB->pos.x - right ) * Vx ;
						VectB->u1 -= ( VectB->pos.x - right ) * VBx ;
						VectB->pos.x = right ;
					}	

					if( VectB->pos.y < top )
					{
						VectB->v2 += ( top - VectB->pos.y ) * Vy ;
						VectB->v1 += ( top - VectB->pos.y ) * VBy ;
						VectB->pos.y = top ;
					}
					else
					if( VectB->pos.y > bottom )
					{
						VectB->v2 -= ( VectB->pos.y - bottom ) * Vy ;
						VectB->v1 -= ( VectB->pos.y - bottom ) * VBy ;
						VectB->pos.y = bottom ;
					}
				}

				if( GRH.UseAlphaChDrawShader )
				{
					VectDataB[0].sc_u = ( VectDataB[0].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					VectDataB[0].sc_v = ( VectDataB[0].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					VectDataB[1].sc_u = ( VectDataB[1].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					VectDataB[1].sc_v = ( VectDataB[1].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					VectDataB[2].sc_u = ( VectDataB[2].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					VectDataB[2].sc_v = ( VectDataB[2].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					VectDataB[3].sc_u = ( VectDataB[3].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					VectDataB[3].sc_v = ( VectDataB[3].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
				}

				*((DWORD *)&VectDataB[0].pos.z) =
				*((DWORD *)&VectDataB[1].pos.z) =
				*((DWORD *)&VectDataB[2].pos.z) =
				*((DWORD *)&VectDataB[3].pos.z) = drawz;

				VectDataB[4] = VectDataB[2] ;
				VectDataB[5] = VectDataB[1] ;

				// eNX`[`悷
				ADD4VERTEX_BLENDTEX

				if( BlendGraphNoIncFlag == FALSE )
				{
					BlendDrawTex ++ ;
				}
			}
			break ;

		case VERTEXTYPE_TEX :	// uheNX`gpȂ
			// eNX`[̐JԂ
			i = 0 ;
			for(;;)
			{
				// _f[^
				Vx = 1.0F / ( DrawTex->Tex->TexWidth * GraphExRateX ) ;
				Vy = 1.0F / ( DrawTex->Tex->TexHeight * GraphExRateY ) ;
				GETVERTEX_QUAD( Vect )
				
				TexVect = DrawTex->Vertex ;

				Vect[0].color = 
				Vect[3].color = ( DWORD )DiffuseColor ;

				Vect[2].pos.x = Vect[0].pos.x = TexVect[0].x * GraphExRateX + x1f ;
				Vect[3].pos.x = Vect[1].pos.x = TexVect[1].x * GraphExRateX + x1f ;
				Vect[1].pos.y = Vect[0].pos.y = TexVect[0].y * GraphExRateY + y1f ;
				Vect[3].pos.y = Vect[2].pos.y = TexVect[2].y * GraphExRateY + y1f ;

				Vect[2].u       = Vect[0].u       = TexVect[0].u ;
				Vect[3].u       = Vect[1].u       = TexVect[1].u ;
				Vect[1].v       = Vect[0].v       = TexVect[0].v ;
				Vect[3].v       = Vect[2].v       = TexVect[2].v ;

				*((DWORD *)&Vect[0].pos.z) =
				*((DWORD *)&Vect[1].pos.z) =
				*((DWORD *)&Vect[2].pos.z) =
				*((DWORD *)&Vect[3].pos.z) = drawz;

				for( j = 0 ; j < 4 ; j ++, Vect ++ )
				{
					// ``oĂꍇ̕␳
					if( Vect->pos.x < left )
					{
						Vect->u += ( left - Vect->pos.x ) * Vx ;
						Vect->pos.x = left ;
					}
					else
					if( Vect->pos.x > right )
					{
						Vect->u -= ( Vect->pos.x - right ) * Vx ;
						Vect->pos.x = right ;
					}	

					if( Vect->pos.y < top )
					{
						Vect->v += ( top - Vect->pos.y ) * Vy ;
						Vect->pos.y = top ;
					}
					else
					if( Vect->pos.y > bottom )
					{
						Vect->v -= ( Vect->pos.y - bottom ) * Vy ;
						Vect->pos.y = bottom ;
					}
				}

				if( GRH.UseAlphaChDrawShader )
				{
					Vect[-4].sc_u = ( Vect[-4].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					Vect[-4].sc_v = ( Vect[-4].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					Vect[-3].sc_u = ( Vect[-3].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					Vect[-3].sc_v = ( Vect[-3].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					Vect[-2].sc_u = ( Vect[-2].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					Vect[-2].sc_v = ( Vect[-2].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					Vect[-1].sc_u = ( Vect[-1].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					Vect[-1].sc_v = ( Vect[-1].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
				}

				Vect[0] = Vect[-2] ;
				Vect[1] = Vect[-3] ;

				// eNX`[`悷
				ADD4VERTEX_TEX

				i ++ ;
				if( i >= DrawTexNum ) break ;

				// `悷eNX`[̃Zbg
				DrawTex ++ ;
				SetTextureHardware( DrawTex->Tex->Texture ) ;
				RefreshBlendStateHardware() ;
			}
			break ;
		}
	}

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawRotaGraph
static int DrawRotaGraphHardware( int x, int y, float xf, float yf, double ExRate, double Angle, IMAGEDATA2 *Image2, IMAGEDATA2 *BlendImage2, int TransFlag, int TurnFlag, int IntFlag )
{
	VERTEX_2D *Vect ;
	VERTEX_BLENDTEX_2D *VectB ;
	int DiffuseColor ;
	IMAGEDATA2_HARD_DRAW *DrawTex ;
	IMAGEDATA2_HARD_DRAW *BlendDrawTex = NULL ;
	IMAGEDATA2_HARD_VERT *TexVect ;
	IMAGEDATA2_HARD_VERT *BlendTexVect ;
	int DrawTexNum ;
	int i ; 
	float Sin = 0.0f, Cos = 1.0f ;
	int BlendGraphNoIncFlag ;
	float XBuf[2], YBuf[2] ;
	float ExtendRate = ( float )ExRate ; 
	float ExtendRateX ;
	DWORD drawz;
//	BOOL Adj = FALSE ;
	float CenX, CenY ;
	float fx, fy ;
	int hx = 0, hy = 0 ;
	int FastCode, SinCosNone, AngleCheck, AlwaysCheck ;
	int Flag ;

	if( GraphicsDevice_IsValid() == 0 || GRH.FlipSkipFlag ) return -1 ;

	// Ȃꍇ̓G[
	if( ExRate == 0.0 ) return -1 ;

	// `̏
	if( GRH.BeginSceneFlag == FALSE ) BeginScene() ;
	Flag = TransFlag ;
	DRAWPREP_TEX( Image2->Orig, Image2->Hard.Draw[ 0 ].Tex->Texture, Flag )

	// ]vfׂ
	if( Angle == 0.0 )
	{
		SinCosNone = 1;
	}
	else
	{
		SinCosNone = 0;
		_SINCOS( (float)Angle, &Sin, &Cos ) ;
	}
//	if( _FABS( (float)Angle ) < 0.0001 && ExRate < 1.001 && ExRate > 0.999 ) Adj = TRUE ;

	// W̕␳
	if( IntFlag || GBASE.DrawMode == DX_DRAWMODE_NEAREST )
	{
		AlwaysCheck = 0 ;
		FastCode    = 0 ;
		hx          = Image2->Width % 2 ;
		hy          = Image2->Height % 2 ;
		fx = xf - ( float )x ;
		fy = yf - ( float )y ;
		if( fx < 0.0f ) fx = -fx;
		if( fy < 0.0f ) fy = -fy;
		if( fx < 0.00001f && fy < 0.00001f )
		{
			if( ExRate == 1.0 )
			{
				if( hx == hy )
				{
					if( hx == 0 )
					{
						CenX = ( float )(Image2->Width >> 1) ;
						CenY = ( float )(Image2->Height >> 1) ;
						xf   = ( float )x - 0.5F ;
						yf   = ( float )y - 0.5F ;
					}
					else
					{
						CenX = ( float )Image2->Width * 0.5F ;
						CenY = ( float )Image2->Height * 0.5F ;
						xf   = ( float )x ;
						yf   = ( float )y ;
						FastCode = 1;
					}
				}
				else
				{
					CenX = ( float )Image2->Width * 0.5F ;
					CenY = ( float )Image2->Height * 0.5F ;
					xf   = ( float )x ;
					yf   = ( float )y ;
						
					if( hx == 0 ) CenX -= 0.5F ;
					if( hy == 0 ) CenY -= 0.5F ;
				}
			}
			else
			{
				CenX = ( float )Image2->Width * 0.5F ;
				CenY = ( float )Image2->Height * 0.5F ;
				xf   = ( float )x - 0.5F ;
				yf   = ( float )y - 0.5F ;
				FastCode = 1 ;
			}
		}
		else
		{
			CenX = ( float )Image2->Width * 0.5F ;
			CenY = ( float )Image2->Height * 0.5F ;
			xf   = ( float )x ;
			yf   = ( float )y ;
			AlwaysCheck = 1 ;
		}
	}
	else
	{
		CenX = ( float )Image2->Width * 0.5F ;
		CenY = ( float )Image2->Height * 0.5F ;
		xf -= 0.5F ;
		yf -= 0.5F ;
		AngleCheck = 0 ;
		AlwaysCheck = 0 ;
		FastCode = 1 ;
	}

	// ȉ]l̃`FbNsǂ𒲂ׂ
	if( IntFlag == TRUE && AlwaysCheck == 0 && SinCosNone == 0 && ( hx == 1 || hy == 1 ) &&
		( ( Angle < DX_PI / 180.0 *         - 4.0   ) ||
		  ( Angle > DX_PI / 180.0 * ( 360.0 + 4.0 ) ) ||
		  ( Angle > DX_PI / 180.0 *         - 4.0   && Angle < DX_PI / 180.0 *           4.0   ) ||
		  ( Angle > DX_PI / 180.0 * (  90.0 - 4.0 ) && Angle < DX_PI / 180.0 * (  90.0 + 4.0 ) ) ||
		  ( Angle > DX_PI / 180.0 * ( 180.0 - 4.0 ) && Angle < DX_PI / 180.0 * ( 180.0 + 4.0 ) ) ||
		  ( Angle > DX_PI / 180.0 * ( 270.0 - 4.0 ) && Angle < DX_PI / 180.0 * ( 270.0 + 4.0 ) ) ||
		  ( Angle > DX_PI / 180.0 * ( 360.0 - 4.0 ) && Angle < DX_PI / 180.0 * ( 360.0 + 4.0 ) ) ) )
	{
		AngleCheck = 1 ;
	}
	else
	{
		AngleCheck = 0 ;
	}

	// _f[^擾îƂF̃Zbĝ݁j
	DiffuseColor = GRH.DiffuseColor ;

	// `̐Zbg
	DrawTexNum = Image2->Hard.DrawNum ;

	// `̐uh摜ƈقȂĂOԖڂ̃eNX`gp
	BlendGraphNoIncFlag = FALSE ;
	if( BlendImage2 != NULL && BlendImage2->Hard.DrawNum != Image2->Hard.DrawNum )
	{
		BlendGraphNoIncFlag = TRUE ;
	}

	// `z̃AhXZbgĂ
	DrawTex = Image2->Hard.Draw ;
	if( BlendImage2 != NULL )
	{
		BlendDrawTex = BlendImage2->Hard.Draw ;
	}

	// yobt@ɏނylZbg
	drawz = *((DWORD *)&GBASE.DrawZ);

	// ]l̊g嗦Zbg
	ExtendRateX = ( ( TurnFlag == TRUE ) ? -1.0f : 1.0f ) * ExtendRate ;

	// _^Cvɂď𕪊
	switch( GRH.VertexType )
	{
	case VERTEXTYPE_BLENDTEX :	// uheNX`gp
		// eNX`[̐JԂ
		if( DrawTexNum == 1 && FastCode == 1 )
		{
			// `悷eNX`[̃Zbg
			if( GRH.RenderTexture != DrawTex->Tex->Texture )
				SetTextureHardware( DrawTex->Tex->Texture ) ;
			if( GRH.BlendTexture != BlendDrawTex->Tex->Texture )
				SetBlendTextureHardware( BlendDrawTex->Tex->Texture, BlendDrawTex->Tex->TexWidth, BlendDrawTex->Tex->TexHeight );
			if( GRH.ChangeTextureFlag )
				RefreshBlendStateHardware() ;

			// _f[^
			GETVERTEX_QUAD( VectB )

			TexVect = DrawTex->Vertex ;
			BlendTexVect = BlendDrawTex->Vertex ;

			VectB[0].color = 
			VectB[3].color = ( DWORD )DiffuseColor ;

			XBuf[0] = ( TexVect[0].x - CenX ) * ExtendRateX ;		// OtBbNW̕␳ + gvZ
			YBuf[0] = ( TexVect[0].y - CenY ) * ExtendRate ;
			XBuf[1] = XBuf[0] * Cos - YBuf[0] * Sin ;					// ]vZ + XN[Wpӓ
			YBuf[1] = XBuf[0] * Sin + YBuf[0] * Cos ;
			VectB[0].pos.x =  XBuf[1] + xf ;
			VectB[0].pos.y =  YBuf[1] + yf ;
			VectB[3].pos.x = -XBuf[1] + xf ;
			VectB[3].pos.y = -YBuf[1] + yf ;
			
			XBuf[0] = ( TexVect[1].x - CenX ) * ExtendRateX ;		// OtBbNW̕␳ + gvZ
			YBuf[0] = ( TexVect[1].y - CenY ) * ExtendRate ;
			XBuf[1] = XBuf[0] * Cos - YBuf[0] * Sin ;					// ]vZ + XN[Wpӓ
			YBuf[1] = XBuf[0] * Sin + YBuf[0] * Cos ;
			VectB[5].pos.x = VectB[1].pos.x =  XBuf[1] + xf ;
			VectB[5].pos.y = VectB[1].pos.y =  YBuf[1] + yf ;
			VectB[4].pos.x = VectB[2].pos.x = -XBuf[1] + xf ;
			VectB[4].pos.y = VectB[2].pos.y = -YBuf[1] + yf ;

			VectB[4].u1 = VectB[2].u1 = VectB[0].u1 = ( TexVect[0].x - BlendTexVect[0].x + GBASE.BlendGraphX ) * GRH.InvBlendTextureWidth ;
			VectB[5].u1 = VectB[3].u1 = VectB[1].u1 = ( TexVect[1].x - BlendTexVect[0].x + GBASE.BlendGraphX ) * GRH.InvBlendTextureWidth ;
			VectB[5].v1 = VectB[1].v1 = VectB[0].v1 = ( TexVect[0].y - BlendTexVect[0].y + GBASE.BlendGraphY ) * GRH.InvBlendTextureHeight ;
			VectB[4].v1 = VectB[3].v1 = VectB[2].v1 = ( TexVect[2].y - BlendTexVect[0].y + GBASE.BlendGraphY ) * GRH.InvBlendTextureHeight ;

			VectB[4].u2 = VectB[2].u2 = VectB[0].u2 = TexVect[0].u ;
			VectB[5].u2 = VectB[3].u2 = VectB[1].u2 = TexVect[1].u ;
			VectB[5].v2 = VectB[1].v2 = VectB[0].v2 = TexVect[0].v ;
			VectB[4].v2 = VectB[3].v2 = VectB[2].v2 = TexVect[2].v ;

			if( GRH.UseAlphaChDrawShader )
			{
				VectB[0].sc_u =					( VectB[0].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
				VectB[0].sc_v =					( VectB[0].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
				VectB[3].sc_u =					( VectB[3].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
				VectB[3].sc_v =					( VectB[3].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
				VectB[5].sc_u = VectB[1].sc_u =	( VectB[1].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
				VectB[5].sc_v = VectB[1].sc_v =	( VectB[1].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
				VectB[4].sc_u = VectB[2].sc_u =	( VectB[2].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
				VectB[4].sc_v = VectB[2].sc_v =	( VectB[2].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
			}

			*((DWORD *)&VectB[0].pos.z) =
			*((DWORD *)&VectB[1].pos.z) =
			*((DWORD *)&VectB[2].pos.z) =
			*((DWORD *)&VectB[3].pos.z) =
			*((DWORD *)&VectB[4].pos.z) =
			*((DWORD *)&VectB[5].pos.z) = drawz;

			// eNX`[`悷
			ADD4VERTEX_BLENDTEX

			if( BlendGraphNoIncFlag == FALSE )
			{
				BlendDrawTex ++ ;
			}
		}
		else
		{
			// eNX`[̐JԂ
			for( i = 0 ; i < DrawTexNum ; i ++, DrawTex ++ )
			{
				// `悷eNX`[̃Zbg
				if( GRH.RenderTexture != DrawTex->Tex->Texture )
					SetTextureHardware( DrawTex->Tex->Texture ) ;
				if( GRH.BlendTexture != BlendDrawTex->Tex->Texture )
					SetBlendTextureHardware( BlendDrawTex->Tex->Texture, BlendDrawTex->Tex->TexWidth, BlendDrawTex->Tex->TexHeight );
				if( GRH.ChangeTextureFlag )
					RefreshBlendStateHardware() ;

				// _f[^
				GETVERTEX_QUAD( VectB )

				TexVect = DrawTex->Vertex ;
				BlendTexVect = BlendDrawTex->Vertex ;

				VectB[0].color = 
				VectB[3].color = ( DWORD )DiffuseColor ;

				XBuf[0] = ( TexVect[0].x - CenX ) * ExtendRateX ;		// OtBbNW̕␳ + gvZ
				YBuf[0] = ( TexVect[0].y - CenY ) * ExtendRate ;
				XBuf[1] = XBuf[0] * Cos - YBuf[0] * Sin ;					// ]vZ + XN[Wpӓ
				YBuf[1] = XBuf[0] * Sin + YBuf[0] * Cos ;
				VectB[0].pos.x =  XBuf[1] + xf ;
				VectB[0].pos.y =  YBuf[1] + yf ;

				XBuf[0] = ( TexVect[1].x - CenX ) * ExtendRateX ;		// OtBbNW̕␳ + gvZ
				YBuf[0] = ( TexVect[1].y - CenY ) * ExtendRate ;
				XBuf[1] = XBuf[0] * Cos - YBuf[0] * Sin ;					// ]vZ + XN[Wpӓ
				YBuf[1] = XBuf[0] * Sin + YBuf[0] * Cos ;
				VectB[5].pos.x = VectB[1].pos.x =  XBuf[1] + xf ;
				VectB[5].pos.y = VectB[1].pos.y =  YBuf[1] + yf ;

				XBuf[0] = ( TexVect[2].x - CenX ) * ExtendRateX ;		// OtBbNW̕␳ + gvZ
				YBuf[0] = ( TexVect[2].y - CenY ) * ExtendRate ;
				XBuf[1] = XBuf[0] * Cos - YBuf[0] * Sin ;					// ]vZ + XN[Wpӓ
				YBuf[1] = XBuf[0] * Sin + YBuf[0] * Cos ;
				VectB[4].pos.x = VectB[2].pos.x =  XBuf[1] + xf ;
				VectB[4].pos.y = VectB[2].pos.y =  YBuf[1] + yf ;

				XBuf[0] = ( TexVect[3].x - CenX ) * ExtendRateX ;		// OtBbNW̕␳ + gvZ
				YBuf[0] = ( TexVect[3].y - CenY ) * ExtendRate ;
				XBuf[1] = XBuf[0] * Cos - YBuf[0] * Sin ;					// ]vZ + XN[Wpӓ
				YBuf[1] = XBuf[0] * Sin + YBuf[0] * Cos ;
				VectB[3].pos.x =  XBuf[1] + xf ;
				VectB[3].pos.y =  YBuf[1] + yf ;

				VectB[0].u1 = ( TexVect[0].x - BlendTexVect[0].x + GBASE.BlendGraphX ) * GRH.InvBlendTextureWidth ;
				VectB[1].u1 = ( TexVect[1].x - BlendTexVect[0].x + GBASE.BlendGraphX ) * GRH.InvBlendTextureWidth ;
				VectB[2].u1 = ( TexVect[2].x - BlendTexVect[0].x + GBASE.BlendGraphX ) * GRH.InvBlendTextureWidth ;
				VectB[3].u1 = ( TexVect[3].x - BlendTexVect[0].x + GBASE.BlendGraphX ) * GRH.InvBlendTextureWidth ;
				VectB[4].u1 = VectB[2].u1 ;
				VectB[5].u1 = VectB[1].u1 ;
				
				VectB[0].v1 = ( TexVect[0].y - BlendTexVect[0].y + GBASE.BlendGraphY ) * GRH.InvBlendTextureHeight ;
				VectB[1].v1 = ( TexVect[1].y - BlendTexVect[0].y + GBASE.BlendGraphY ) * GRH.InvBlendTextureHeight ;
				VectB[2].v1 = ( TexVect[2].y - BlendTexVect[0].y + GBASE.BlendGraphY ) * GRH.InvBlendTextureHeight ;
				VectB[3].v1 = ( TexVect[3].y - BlendTexVect[0].y + GBASE.BlendGraphY ) * GRH.InvBlendTextureHeight ;
				VectB[4].v1 = VectB[2].v1 ;
				VectB[5].v1 = VectB[1].v1 ;

				VectB[4].u2 = VectB[2].u2 = VectB[0].u2 = TexVect[0].u ;
				VectB[5].u2 = VectB[3].u2 = VectB[1].u2 = TexVect[1].u ;
				VectB[5].v2 = VectB[1].v2 = VectB[0].v2 = TexVect[0].v ;
				VectB[4].v2 = VectB[3].v2 = VectB[2].v2 = TexVect[2].v ;

				if( GRH.UseAlphaChDrawShader )
				{
					VectB[0].sc_u =					( VectB[0].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					VectB[0].sc_v =					( VectB[0].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					VectB[3].sc_u =					( VectB[3].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					VectB[3].sc_v =					( VectB[3].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					VectB[5].sc_u = VectB[1].sc_u =	( VectB[1].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					VectB[5].sc_v = VectB[1].sc_v =	( VectB[1].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					VectB[4].sc_u = VectB[2].sc_u =	( VectB[2].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					VectB[4].sc_v = VectB[2].sc_v =	( VectB[2].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
				}

				*((DWORD *)&VectB[0].pos.z) =
				*((DWORD *)&VectB[1].pos.z) =
				*((DWORD *)&VectB[2].pos.z) =
				*((DWORD *)&VectB[3].pos.z) =
				*((DWORD *)&VectB[4].pos.z) =
				*((DWORD *)&VectB[5].pos.z) = drawz;

				// eNX`[`悷
				ADD4VERTEX_BLENDTEX

				if( BlendGraphNoIncFlag == FALSE )
				{
					BlendDrawTex ++ ;
				}
			}
		}
		break ;

	case VERTEXTYPE_TEX :	// uheNX`gpȂ
		// eNX`[̐JԂ
		if( DrawTexNum == 1 && FastCode == 1 )
		{
			if( SinCosNone == 0 )
			{
				// _f[^
				GETVERTEX_QUAD( Vect )
				
				TexVect = DrawTex->Vertex ;

				Vect[0].color = 
				Vect[3].color = ( DWORD )DiffuseColor ;

				Vect[4].u = Vect[2].u = Vect[0].u = TexVect[0].u ;
				Vect[5].u = Vect[3].u = Vect[1].u = TexVect[1].u ;
				Vect[5].v = Vect[1].v = Vect[0].v = TexVect[0].v ;
				Vect[4].v = Vect[3].v = Vect[2].v = TexVect[2].v ;

				XBuf[0] = ( TexVect[0].x - CenX ) * ExtendRateX ;		// OtBbNW̕␳ + gvZ
				YBuf[0] = ( TexVect[0].y - CenY ) * ExtendRate ;
				XBuf[1] = XBuf[0] * Cos - YBuf[0] * Sin ;					// ]vZ + XN[Wpӓ
				YBuf[1] = XBuf[0] * Sin + YBuf[0] * Cos ;
				Vect[0].pos.x =  XBuf[1] + xf ;
				Vect[0].pos.y =  YBuf[1] + yf ;
				Vect[3].pos.x = -XBuf[1] + xf ;
				Vect[3].pos.y = -YBuf[1] + yf ;
				
				XBuf[0] = ( TexVect[1].x - CenX ) * ExtendRateX ;		// OtBbNW̕␳ + gvZ
				YBuf[0] = ( TexVect[1].y - CenY ) * ExtendRate ;
				XBuf[1] = XBuf[0] * Cos - YBuf[0] * Sin ;					// ]vZ + XN[Wpӓ
				YBuf[1] = XBuf[0] * Sin + YBuf[0] * Cos ;
				Vect[5].pos.x = Vect[1].pos.x =  XBuf[1] + xf ;
				Vect[5].pos.y = Vect[1].pos.y =  YBuf[1] + yf ;
				Vect[4].pos.x = Vect[2].pos.x = -XBuf[1] + xf ;
				Vect[4].pos.y = Vect[2].pos.y = -YBuf[1] + yf ;

				*((DWORD *)&Vect[0].pos.z) =
				*((DWORD *)&Vect[1].pos.z) =
				*((DWORD *)&Vect[2].pos.z) =
				*((DWORD *)&Vect[3].pos.z) =
				*((DWORD *)&Vect[4].pos.z) =
				*((DWORD *)&Vect[5].pos.z) = drawz;

				if( AlwaysCheck )
				{
					if( ( ( ( *((DWORD *)&Vect[0].pos.x) == *((DWORD *)&Vect[2].pos.x) ) ||
							( ( Vect[0].pos.x > Vect[2].pos.x ) && ( Vect[0].pos.x < Vect[2].pos.x + 0.01f ) ) ||
							( ( Vect[2].pos.x > Vect[0].pos.x ) && ( Vect[2].pos.x < Vect[0].pos.x + 0.01f ) ) ) &&
							_FABS( Vect[0].pos.x - _FTOL( Vect[0].pos.x ) ) < 0.0001f ) ||
						( ( ( *((DWORD *)&Vect[0].pos.x) == *((DWORD *)&Vect[1].pos.x) ) ||
							( ( Vect[0].pos.x > Vect[1].pos.x ) && ( Vect[0].pos.x < Vect[1].pos.x + 0.01f ) ) ||
							( ( Vect[1].pos.x > Vect[0].pos.x ) && ( Vect[1].pos.x < Vect[0].pos.x + 0.01f ) ) ) &&
							_FABS( Vect[0].pos.x - _FTOL( Vect[0].pos.x ) ) < 0.0001f ) )
					{
						Vect[0].pos.x -= 0.5f;
						Vect[1].pos.x -= 0.5f;
						Vect[2].pos.x -= 0.5f;
						Vect[3].pos.x -= 0.5f;
						Vect[4].pos.x -= 0.5f;
						Vect[5].pos.x -= 0.5f;
					}

					if( ( ( ( *((DWORD *)&Vect[0].pos.y) == *((DWORD *)&Vect[2].pos.y) ) ||
							( ( Vect[0].pos.y > Vect[2].pos.y ) && ( Vect[0].pos.y < Vect[2].pos.y + 0.01f ) ) ||
							( ( Vect[2].pos.y > Vect[0].pos.y ) && ( Vect[2].pos.y < Vect[0].pos.y + 0.01f ) ) ) &&
							_FABS( Vect[0].pos.y - _FTOL( Vect[0].pos.y ) ) < 0.0001f ) ||
						( ( ( *((DWORD *)&Vect[0].pos.y) == *((DWORD *)&Vect[1].pos.y) ) ||
							( ( Vect[0].pos.y > Vect[1].pos.y ) && ( Vect[0].pos.y < Vect[1].pos.y + 0.01f ) ) ||
							( ( Vect[1].pos.y > Vect[0].pos.y ) && ( Vect[1].pos.y < Vect[0].pos.y + 0.01f ) ) ) &&
							_FABS( Vect[0].pos.y - _FTOL( Vect[0].pos.y ) ) < 0.0001f ) )
					{
						Vect[0].pos.y -= 0.5f;
						Vect[1].pos.y -= 0.5f;
						Vect[2].pos.y -= 0.5f;
						Vect[3].pos.y -= 0.5f;
						Vect[4].pos.y -= 0.5f;
						Vect[5].pos.y -= 0.5f;
					}
				}
				else
				if( AngleCheck )
				{
					if( hx &&
						( *((DWORD *)&Vect[0].pos.x) == *((DWORD *)&Vect[2].pos.x) ) ||
						( ( Vect[0].pos.x > Vect[2].pos.x - 0.01f ) && ( Vect[0].pos.x < Vect[2].pos.x + 0.01f ) ) ||
						( ( Vect[2].pos.x > Vect[0].pos.x - 0.01f ) && ( Vect[2].pos.x < Vect[0].pos.x + 0.01f ) ) ||
						( *((DWORD *)&Vect[0].pos.x) == *((DWORD *)&Vect[1].pos.x) ) ||
						( ( Vect[0].pos.x > Vect[1].pos.x - 0.01f ) && ( Vect[0].pos.x < Vect[1].pos.x + 0.01f ) ) ||
						( ( Vect[1].pos.x > Vect[0].pos.x - 0.01f ) && ( Vect[1].pos.x < Vect[0].pos.x + 0.01f ) ) )
					{
						Vect[0].pos.x -= 0.5f;
						Vect[1].pos.x -= 0.5f;
						Vect[2].pos.x -= 0.5f;
						Vect[3].pos.x -= 0.5f;
						Vect[4].pos.x -= 0.5f;
						Vect[5].pos.x -= 0.5f;
					}

					if( hy &&
						( *((DWORD *)&Vect[0].pos.y) == *((DWORD *)&Vect[1].pos.y) ) ||
						( ( Vect[0].pos.y > Vect[1].pos.y - 0.01f ) && ( Vect[0].pos.y < Vect[1].pos.y + 0.01f ) ) ||
						( ( Vect[1].pos.y > Vect[0].pos.y - 0.01f ) && ( Vect[1].pos.y < Vect[0].pos.y + 0.01f ) ) ||
						( *((DWORD *)&Vect[0].pos.y) == *((DWORD *)&Vect[2].pos.y) ) ||
						( ( Vect[0].pos.y > Vect[2].pos.y - 0.01f ) && ( Vect[0].pos.y < Vect[2].pos.y + 0.01f ) ) ||
						( ( Vect[2].pos.y > Vect[0].pos.y - 0.01f ) && ( Vect[2].pos.y < Vect[0].pos.y + 0.01f ) ) )
					{
						Vect[0].pos.y -= 0.5f;
						Vect[1].pos.y -= 0.5f;
						Vect[2].pos.y -= 0.5f;
						Vect[3].pos.y -= 0.5f;
						Vect[4].pos.y -= 0.5f;
						Vect[5].pos.y -= 0.5f;
					}
				}

				if( GRH.UseAlphaChDrawShader )
				{
					Vect[0].sc_u = ( Vect[0].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					Vect[0].sc_v = ( Vect[0].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					Vect[1].sc_u = ( Vect[1].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					Vect[1].sc_v = ( Vect[1].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					Vect[2].sc_u = ( Vect[2].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					Vect[2].sc_v = ( Vect[2].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					Vect[3].sc_u = ( Vect[3].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					Vect[3].sc_v = ( Vect[3].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					Vect[4].sc_u = ( Vect[4].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					Vect[4].sc_v = ( Vect[4].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					Vect[5].sc_u = ( Vect[5].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					Vect[5].sc_v = ( Vect[5].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
				}

				// eNX`[`悷
				ADD4VERTEX_TEX
			}
			else
			{
				// _f[^
				GETVERTEX_QUAD( Vect )
				
				TexVect = DrawTex->Vertex ;

				Vect[0].color = 
				Vect[3].color = ( DWORD )DiffuseColor ;

				Vect[4].u = Vect[2].u = Vect[0].u = TexVect[0].u ;
				Vect[5].u = Vect[3].u = Vect[1].u = TexVect[1].u ;
				Vect[5].v = Vect[1].v = Vect[0].v = TexVect[0].v ;
				Vect[4].v = Vect[3].v = Vect[2].v = TexVect[2].v ;

				XBuf[0] = ( TexVect[0].x - CenX ) * ExtendRateX ;		// OtBbNW̕␳ + gvZ
				YBuf[0] = ( TexVect[0].y - CenY ) * ExtendRate ;
				Vect[0].pos.x =  XBuf[0] + xf ;
				Vect[0].pos.y =  YBuf[0] + yf ;
				Vect[3].pos.x = -XBuf[0] + xf ;
				Vect[3].pos.y = -YBuf[0] + yf ;
				
				XBuf[0] = ( TexVect[1].x - CenX ) * ExtendRateX ;		// OtBbNW̕␳ + gvZ
				YBuf[0] = ( TexVect[1].y - CenY ) * ExtendRate ;
				Vect[5].pos.x = Vect[1].pos.x =  XBuf[0] + xf ;
				Vect[5].pos.y = Vect[1].pos.y =  YBuf[0] + yf ;
				Vect[4].pos.x = Vect[2].pos.x = -XBuf[0] + xf ;
				Vect[4].pos.y = Vect[2].pos.y = -YBuf[0] + yf ;

				if( GRH.UseAlphaChDrawShader )
				{
					Vect[0].sc_u =					( Vect[0].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					Vect[0].sc_v =					( Vect[0].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					Vect[3].sc_u =					( Vect[3].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					Vect[3].sc_v =					( Vect[3].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					Vect[5].sc_u = Vect[1].sc_u =	( Vect[1].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					Vect[5].sc_v = Vect[1].sc_v =	( Vect[1].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					Vect[4].sc_u = Vect[2].sc_u =	( Vect[2].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					Vect[4].sc_v = Vect[2].sc_v =	( Vect[2].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
				}

				*((DWORD *)&Vect[0].pos.z) =
				*((DWORD *)&Vect[1].pos.z) =
				*((DWORD *)&Vect[2].pos.z) =
				*((DWORD *)&Vect[3].pos.z) =
				*((DWORD *)&Vect[4].pos.z) =
				*((DWORD *)&Vect[5].pos.z) = drawz;

				// eNX`[`悷
				ADD4VERTEX_TEX
			}
		}
		else
		{
			if( SinCosNone == 0 )
			{
				// eNX`[̐JԂ
				i = 0 ;
				for(;;)
				{
					// _f[^
					GETVERTEX_QUAD( Vect )
					
					TexVect = DrawTex->Vertex ;

					Vect[0].color = 
					Vect[3].color = ( DWORD )DiffuseColor ;

					Vect[4].u = Vect[2].u = Vect[0].u = TexVect[0].u ;
					Vect[5].u = Vect[3].u = Vect[1].u = TexVect[1].u ;
					Vect[5].v = Vect[1].v = Vect[0].v = TexVect[0].v ;
					Vect[4].v = Vect[3].v = Vect[2].v = TexVect[2].v ;

					XBuf[0] = ( TexVect[0].x - CenX ) * ExtendRateX ;		// OtBbNW̕␳ + gvZ
					YBuf[0] = ( TexVect[0].y - CenY ) * ExtendRate ;
					XBuf[1] = XBuf[0] * Cos - YBuf[0] * Sin ;					// ]vZ + XN[Wpӓ
					YBuf[1] = XBuf[0] * Sin + YBuf[0] * Cos ;
					Vect[0].pos.x =  XBuf[1] + xf ;
					Vect[0].pos.y =  YBuf[1] + yf ;

					XBuf[0] = ( TexVect[1].x - CenX ) * ExtendRateX ;		// OtBbNW̕␳ + gvZ
					YBuf[0] = ( TexVect[1].y - CenY ) * ExtendRate ;
					XBuf[1] = XBuf[0] * Cos - YBuf[0] * Sin ;					// ]vZ + XN[Wpӓ
					YBuf[1] = XBuf[0] * Sin + YBuf[0] * Cos ;
					Vect[5].pos.x = Vect[1].pos.x =  XBuf[1] + xf ;
					Vect[5].pos.y = Vect[1].pos.y =  YBuf[1] + yf ;

					XBuf[0] = ( TexVect[2].x - CenX ) * ExtendRateX ;		// OtBbNW̕␳ + gvZ
					YBuf[0] = ( TexVect[2].y - CenY ) * ExtendRate ;
					XBuf[1] = XBuf[0] * Cos - YBuf[0] * Sin ;					// ]vZ + XN[Wpӓ
					YBuf[1] = XBuf[0] * Sin + YBuf[0] * Cos ;
					Vect[4].pos.x = Vect[2].pos.x =  XBuf[1] + xf ;
					Vect[4].pos.y = Vect[2].pos.y =  YBuf[1] + yf ;

					XBuf[0] = ( TexVect[3].x - CenX ) * ExtendRateX ;		// OtBbNW̕␳ + gvZ
					YBuf[0] = ( TexVect[3].y - CenY ) * ExtendRate ;
					XBuf[1] = XBuf[0] * Cos - YBuf[0] * Sin ;					// ]vZ + XN[Wpӓ
					YBuf[1] = XBuf[0] * Sin + YBuf[0] * Cos ;
					Vect[3].pos.x =  XBuf[1] + xf ;
					Vect[3].pos.y =  YBuf[1] + yf ;

					*((DWORD *)&Vect[0].pos.z) =
					*((DWORD *)&Vect[1].pos.z) =
					*((DWORD *)&Vect[2].pos.z) =
					*((DWORD *)&Vect[3].pos.z) =
					*((DWORD *)&Vect[4].pos.z) =
					*((DWORD *)&Vect[5].pos.z) = drawz;

					if( AlwaysCheck )
					{
						float f;

						f = _FABS( Vect[0].pos.x - _FTOL( Vect[0].pos.x ) );
						if( ( ( ( *((DWORD *)&Vect[0].pos.x) == *((DWORD *)&Vect[2].pos.x) ) ||
							    ( ( Vect[0].pos.x >= Vect[2].pos.x - 0.01f ) && ( Vect[0].pos.x < Vect[2].pos.x + 0.01f ) ) ||
							    ( ( Vect[2].pos.x >= Vect[0].pos.x - 0.01f ) && ( Vect[2].pos.x < Vect[0].pos.x + 0.01f ) ) ) &&
							    ( f < 0.001f || f > 0.999f ) ) ||
							( ( ( *((DWORD *)&Vect[0].pos.x) == *((DWORD *)&Vect[1].pos.x) ) ||
							    ( ( Vect[0].pos.x >= Vect[1].pos.x - 0.01f ) && ( Vect[0].pos.x < Vect[1].pos.x + 0.01f ) ) ||
							    ( ( Vect[1].pos.x >= Vect[0].pos.x - 0.01f ) && ( Vect[1].pos.x < Vect[0].pos.x + 0.01f ) ) ) &&
							    ( f < 0.001f || f > 0.999f ) ) )
						{
							Vect[0].pos.x -= 0.5f;
							Vect[1].pos.x -= 0.5f;
							Vect[2].pos.x -= 0.5f;
							Vect[3].pos.x -= 0.5f;
							Vect[4].pos.x -= 0.5f;
							Vect[5].pos.x -= 0.5f;
						}

						f = _FABS( Vect[0].pos.y - _FTOL( Vect[0].pos.y ) );
						if( ( ( ( *((DWORD *)&Vect[0].pos.y) == *((DWORD *)&Vect[2].pos.y) ) ||
							    ( ( Vect[0].pos.y >= Vect[2].pos.y - 0.01f ) && ( Vect[0].pos.y < Vect[2].pos.y + 0.01f ) ) ||
							    ( ( Vect[2].pos.y >= Vect[0].pos.y - 0.01f ) && ( Vect[2].pos.y < Vect[0].pos.y + 0.01f ) ) ) &&
							    ( f < 0.001f || f > 0.999f ) ) ||
							( ( ( *((DWORD *)&Vect[0].pos.y) == *((DWORD *)&Vect[1].pos.y) ) ||
							    ( ( Vect[0].pos.y >= Vect[1].pos.y - 0.01f ) && ( Vect[0].pos.y < Vect[1].pos.y + 0.01f ) ) ||
							    ( ( Vect[1].pos.y >= Vect[0].pos.y - 0.01f ) && ( Vect[1].pos.y < Vect[0].pos.y + 0.01f ) ) ) &&
							    ( f < 0.001f || f > 0.999f ) ) )
						{
							Vect[0].pos.y -= 0.5f;
							Vect[1].pos.y -= 0.5f;
							Vect[2].pos.y -= 0.5f;
							Vect[3].pos.y -= 0.5f;
							Vect[4].pos.y -= 0.5f;
							Vect[5].pos.y -= 0.5f;
						}
					}
					else
					if( AngleCheck )
					{
						float f;

						if( hx )
						{
							f = _FABS( Vect[0].pos.x - _FTOL( Vect[0].pos.x ) );
							if( ( ( ( *((DWORD *)&Vect[0].pos.x) == *((DWORD *)&Vect[2].pos.x) ) ||
									( ( Vect[0].pos.x >= Vect[2].pos.x - 0.01f ) && ( Vect[0].pos.x < Vect[2].pos.x + 0.01f ) ) ||
									( ( Vect[2].pos.x >= Vect[0].pos.x - 0.01f ) && ( Vect[2].pos.x < Vect[0].pos.x + 0.01f ) ) ) &&
									( f < 0.001f || f > 0.999f ) ) ||
								( ( ( *((DWORD *)&Vect[0].pos.x) == *((DWORD *)&Vect[1].pos.x) ) ||
									( ( Vect[0].pos.x >= Vect[1].pos.x - 0.01f ) && ( Vect[0].pos.x < Vect[1].pos.x + 0.01f ) ) ||
									( ( Vect[1].pos.x >= Vect[0].pos.x - 0.01f ) && ( Vect[1].pos.x < Vect[0].pos.x + 0.01f ) ) ) &&
									( f < 0.001f || f > 0.999f ) ) )
							{
								Vect[0].pos.x -= 0.5f;
								Vect[1].pos.x -= 0.5f;
								Vect[2].pos.x -= 0.5f;
								Vect[3].pos.x -= 0.5f;
								Vect[4].pos.x -= 0.5f;
								Vect[5].pos.x -= 0.5f;
							}
						}

						if( hy )
						{
							f = _FABS( Vect[0].pos.y - _FTOL( Vect[0].pos.y ) );
							if( ( ( ( *((DWORD *)&Vect[0].pos.y) == *((DWORD *)&Vect[2].pos.y) ) ||
									( ( Vect[0].pos.y >= Vect[2].pos.y - 0.01f ) && ( Vect[0].pos.y < Vect[2].pos.y + 0.01f ) ) ||
									( ( Vect[2].pos.y >= Vect[0].pos.y - 0.01f ) && ( Vect[2].pos.y < Vect[0].pos.y + 0.01f ) ) ) &&
									( f < 0.001f || f > 0.999f ) ) ||
								( ( ( *((DWORD *)&Vect[0].pos.y) == *((DWORD *)&Vect[1].pos.y) ) ||
									( ( Vect[0].pos.y >= Vect[1].pos.y - 0.01f ) && ( Vect[0].pos.y < Vect[1].pos.y + 0.01f ) ) ||
									( ( Vect[1].pos.y >= Vect[0].pos.y - 0.01f ) && ( Vect[1].pos.y < Vect[0].pos.y + 0.01f ) ) ) &&
									( f < 0.001f || f > 0.999f ) ) )
							{
								Vect[0].pos.y -= 0.5f;
								Vect[1].pos.y -= 0.5f;
								Vect[2].pos.y -= 0.5f;
								Vect[3].pos.y -= 0.5f;
								Vect[4].pos.y -= 0.5f;
								Vect[5].pos.y -= 0.5f;
							}
						}
					}

					if( GRH.UseAlphaChDrawShader )
					{
						Vect[0].sc_u = ( Vect[0].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
						Vect[0].sc_v = ( Vect[0].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
						Vect[1].sc_u = ( Vect[1].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
						Vect[1].sc_v = ( Vect[1].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
						Vect[2].sc_u = ( Vect[2].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
						Vect[2].sc_v = ( Vect[2].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
						Vect[3].sc_u = ( Vect[3].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
						Vect[3].sc_v = ( Vect[3].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
						Vect[4].sc_u = ( Vect[4].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
						Vect[4].sc_v = ( Vect[4].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
						Vect[5].sc_u = ( Vect[5].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
						Vect[5].sc_v = ( Vect[5].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					}

					// eNX`[`悷
					ADD4VERTEX_TEX

					i ++ ;
					if( i >= DrawTexNum ) break ;

					// `悷eNX`[̃Zbg
					DrawTex ++ ;
					SetTextureHardware( DrawTex->Tex->Texture ) ;
					RefreshBlendStateHardware() ;
				}
			}
			else
			{
				// eNX`[̐JԂ
				i = 0 ;
				for(;;)
				{
					// _f[^
					GETVERTEX_QUAD( Vect )
					
					TexVect = DrawTex->Vertex ;

					Vect[0].color = 
					Vect[3].color = ( DWORD )DiffuseColor ;

					Vect[4].u = Vect[2].u = Vect[0].u = TexVect[0].u ;
					Vect[5].u = Vect[3].u = Vect[1].u = TexVect[1].u ;
					Vect[5].v = Vect[1].v = Vect[0].v = TexVect[0].v ;
					Vect[4].v = Vect[3].v = Vect[2].v = TexVect[2].v ;

					Vect[0].pos.x =                 ( TexVect[0].x - CenX ) * ExtendRateX + xf;	// OtBbNW̕␳ + gvZ
					Vect[0].pos.y =                 ( TexVect[0].y - CenY ) * ExtendRate  + yf;

					Vect[5].pos.x = Vect[1].pos.x = ( TexVect[1].x - CenX ) * ExtendRateX + xf;	// OtBbNW̕␳ + gvZ
					Vect[5].pos.y = Vect[1].pos.y = ( TexVect[1].y - CenY ) * ExtendRate  + yf;

					Vect[4].pos.x = Vect[2].pos.x = ( TexVect[2].x - CenX ) * ExtendRateX + xf;	// OtBbNW̕␳ + gvZ
					Vect[4].pos.y = Vect[2].pos.y = ( TexVect[2].y - CenY ) * ExtendRate  + yf;

					Vect[3].pos.x =                 ( TexVect[3].x - CenX ) * ExtendRateX + xf;	// OtBbNW̕␳ + gvZ
					Vect[3].pos.y =                 ( TexVect[3].y - CenY ) * ExtendRate  + yf;

					*((DWORD *)&Vect[0].pos.z) =
					*((DWORD *)&Vect[1].pos.z) =
					*((DWORD *)&Vect[2].pos.z) =
					*((DWORD *)&Vect[3].pos.z) =
					*((DWORD *)&Vect[4].pos.z) =
					*((DWORD *)&Vect[5].pos.z) = drawz;

					if( GRH.UseAlphaChDrawShader )
					{
						Vect[0].sc_u =					( Vect[0].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
						Vect[0].sc_v =					( Vect[0].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
						Vect[3].sc_u =					( Vect[3].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
						Vect[3].sc_v =					( Vect[3].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
						Vect[5].sc_u = Vect[1].sc_u =	( Vect[1].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
						Vect[5].sc_v = Vect[1].sc_v =	( Vect[1].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
						Vect[4].sc_u = Vect[2].sc_u =	( Vect[2].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
						Vect[4].sc_v = Vect[2].sc_v =	( Vect[2].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					}

					// eNX`[`悷
					ADD4VERTEX_TEX

					i ++ ;
					if( i >= DrawTexNum ) break ;

					// `悷eNX`[̃Zbg
					DrawTex ++ ;
					SetTextureHardware( DrawTex->Tex->Texture ) ;
					RefreshBlendStateHardware() ;
				}
			}
		}
		break ;
	}

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawModiGraph
static int  DrawModiGraphHardware( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, IMAGEDATA2 *Image2, IMAGEDATA2 *BlendImage2, int TransFlag, bool SimpleDrawFlag )
{
	if( x1 == x3 && x2 == x4 && y1 == y2 && y3 == y4 ) return DrawExtendGraphHardware( x1, y1, x4, y4, ( float )x1, ( float )y1, ( float )x4, ( float )y4, Image2, BlendImage2, TransFlag, TRUE ) ; 

	// uheNX`gpA^֐gptOĂȂ
	// s`֐gp
	if( GRH.UseOldDrawModiGraphCodeFlag == FALSE && GBASE.BlendGraph <= 0 )
		return DrawModiGraphFHardware( (float)x1, (float)y1, (float)x2, (float)y2, (float)x3, (float)y3, (float)x4, (float)y4, Image2, BlendImage2, TransFlag, SimpleDrawFlag ) ;

	VERTEX_2D VectData[ 4 ], VectBuf, *Vect ;
	VERTEX_BLENDTEX_2D VectDataB[ 4 ], VectBufB, *VectB ;
	IMAGEDATA2_HARD_DRAW *DrawTex ;
	IMAGEDATA2_HARD_DRAW *BlendDrawTex = NULL ;
	IMAGEDATA2_HARD_VERT *TexVect ;
	IMAGEDATA2_HARD_VERT *BlendTexVect ;
	float GraphSizeX, GraphSizeY ;
	float XBuf, YBuf ;
	int DrawTexNum ;
	unsigned char *VectType ;
	int i, j ; 
	int BlendGraphNoIncFlag ;
	float Reverse0, Reverse1 ;
	float ExRate1X1, ExRate1Y1, ExRate2X1, ExRate2Y1 ;
	float ExRate1X2, ExRate1Y2, ExRate2X2, ExRate2Y2 ;
	int DiffuseColor ;
	float  xf1, yf1, xf4, yf4;
	DWORD drawz ;
	int Flag ;

	if( GraphicsDevice_IsValid() == 0 || GRH.FlipSkipFlag ) return -1 ;

	// obt@ɂ܂_o
	RenderVertexHardware() ;

	// `̏
	if( GRH.BeginSceneFlag == FALSE ) BeginScene() ;
	Flag = TransFlag | DRAWPREP_VECTORINT ;
	DRAWPREP_TEX( Image2->Orig, Image2->Hard.Draw[ 0 ].Tex->Texture, Flag )

	GraphSizeX = ( float )Image2->Width ;  GraphSizeY = ( float )Image2->Height ;
	ExRate1X1 = ( x2 - x1 ) /  GraphSizeX ;  ExRate1X2 = ( x3 - x1 ) /  GraphSizeY ;
	ExRate1Y1 = ( y3 - y1 ) /  GraphSizeY ;  ExRate1Y2 = ( y2 - y1 ) /  GraphSizeX ;
	ExRate2X1 = ( x3 - x4 ) / -GraphSizeX ;  ExRate2X2 = ( x2 - x4 ) / -GraphSizeY ;
	ExRate2Y1 = ( y2 - y4 ) / -GraphSizeY ;  ExRate2Y2 = ( y3 - y4 ) / -GraphSizeX ;
	xf1 = (float)x1 - 0.5F ; yf1 = (float)y1 - 0.5F ;
	xf4 = (float)x4 - 0.5F ; yf4 = (float)y4 - 0.5F ; 

	// _f[^擾îƂF̃Zbĝ݁j
	DiffuseColor = GRH.DiffuseColor ;

	// yobt@ɏނylZbg
	drawz = *((DWORD *)&GBASE.DrawZ);

	// `̐Zbg
	DrawTexNum = Image2->Hard.DrawNum ;

	// `̐uh摜ƈقȂĂOԖڂ̃eNX`gp
	BlendGraphNoIncFlag = FALSE ;
	if( BlendImage2 != NULL && BlendImage2->Hard.DrawNum != Image2->Hard.DrawNum )
	{
		BlendGraphNoIncFlag = TRUE ;
	}

	// `z̃AhXZbgĂ
	DrawTex = Image2->Hard.Draw ;
	if( BlendImage2 != NULL )
	{
		BlendDrawTex = BlendImage2->Hard.Draw ;
	}

	// _^Cvɂď𕪊
	switch( GRH.VertexType )
	{
	case VERTEXTYPE_BLENDTEX :	// uheNX`gp
		// FVFݒ
		SETFVF( VERTEXFVF_BLENDTEX_2D )

		// eNX`[̐JԂ
		for( i = 0 ; i < DrawTexNum ; i ++, DrawTex ++ )
		{
			// `悷eNX`[̃Zbg
			if( GRH.RenderTexture != DrawTex->Tex->Texture || GRH.BlendTexture != BlendDrawTex->Tex->Texture )
			{
				if( GRH.RenderTexture != DrawTex->Tex->Texture  )
					SetTextureHardware( DrawTex->Tex->Texture ) ;
				if( GRH.BlendTexture != BlendDrawTex->Tex->Texture )
					SetBlendTextureHardware( BlendDrawTex->Tex->Texture, BlendDrawTex->Tex->TexWidth, BlendDrawTex->Tex->TexHeight );
				RefreshBlendStateHardware() ;
			}

			// _f[^Zbg
			VectDataB[0].specular =
			VectDataB[1].specular =
			VectDataB[2].specular =
			VectDataB[3].specular = 0xffffffff ;

			VectDataB[0].color =
			VectDataB[1].color =
			VectDataB[2].color =
			VectDataB[3].color = (DWORD)DiffuseColor ;

			*((DWORD *)&VectDataB[0].pos.z) =
			*((DWORD *)&VectDataB[1].pos.z) =
			*((DWORD *)&VectDataB[2].pos.z) =
			*((DWORD *)&VectDataB[3].pos.z) = drawz ;

			VectDataB[0].rhw =
			VectDataB[1].rhw =
			VectDataB[2].rhw =
			VectDataB[3].rhw = 1.0F ;

			VectType = DrawTex->VertType ;
			VectB = VectDataB ;
			TexVect = DrawTex->Vertex ;
			BlendTexVect = BlendDrawTex->Vertex ;

			for( j = 0 ; j < 4 ; j ++, VectB ++, TexVect ++ )
			{
				// _W̎Zo
				if( *VectType ++ )
				{
					// Op̏㑤
					VectB->pos.x = ( TexVect->x * ExRate1X1 ) + ( TexVect->y * ExRate1X2 ) + xf1 ;
					VectB->pos.y = ( TexVect->y * ExRate1Y1 ) + ( TexVect->x * ExRate1Y2 ) + yf1 ;
				} 
				else
				{
					// Op̉
					XBuf = TexVect->x - GraphSizeX ;  YBuf = TexVect->y - GraphSizeY ;
					VectB->pos.x = ( XBuf * ExRate2X1 ) + ( YBuf * ExRate2X2 ) + xf4 ;
					VectB->pos.y = ( YBuf * ExRate2Y1 ) + ( XBuf * ExRate2Y2 ) + yf4 ;
				}

				VectB->u1 = ( TexVect->x - BlendTexVect->x + GBASE.BlendGraphX ) * GRH.InvBlendTextureWidth ;
				VectB->v1 = ( TexVect->y - BlendTexVect->y + GBASE.BlendGraphY ) * GRH.InvBlendTextureHeight ;

				VectB->u2 = TexVect->u ;
				VectB->v2 = TexVect->v ;
			}

			if( GRH.UseAlphaChDrawShader )
			{
				VectDataB[0].sc_u = ( VectDataB[0].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
				VectDataB[0].sc_v = ( VectDataB[0].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
				VectDataB[1].sc_u = ( VectDataB[1].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
				VectDataB[1].sc_v = ( VectDataB[1].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
				VectDataB[2].sc_u = ( VectDataB[2].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
				VectDataB[2].sc_v = ( VectDataB[2].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
				VectDataB[3].sc_u = ( VectDataB[3].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
				VectDataB[3].sc_v = ( VectDataB[3].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
			}

			// ]菈
			Reverse0 =  ( VectDataB[ 1 ].pos.x - VectDataB[ 0 ].pos.x ) * ( VectDataB[ 2 ].pos.y - VectDataB[ 0 ].pos.y ) -
						( VectDataB[ 2 ].pos.x - VectDataB[ 0 ].pos.x ) * ( VectDataB[ 1 ].pos.y - VectDataB[ 0 ].pos.y ) ;
			Reverse1 = -( VectDataB[ 1 ].pos.x - VectDataB[ 3 ].pos.x ) * ( VectDataB[ 2 ].pos.y - VectDataB[ 3 ].pos.y ) +
						( VectDataB[ 1 ].pos.y - VectDataB[ 3 ].pos.y ) * ( VectDataB[ 2 ].pos.x - VectDataB[ 3 ].pos.x ) ;
			if( Reverse0 <= 0 && Reverse1 <= 0 )
			{
				VectBufB = VectDataB[ 1 ] ; VectDataB[ 1 ] = VectDataB[ 2 ] ; VectDataB[ 2 ] = VectBufB ;
			}

			// `I
			if( Reverse0 * Reverse1 >= 0 )
			{
				// v~eBu̕`
				GraphicsDevice_DrawPrimitiveUP( D_D3DPT_TRIANGLESTRIP, 2, VectDataB, sizeof( VERTEX_BLENDTEX_2D ) ) ;
			}
			else
			{
				// w]̕␳
				if( Reverse0 < 0 ) 
				{
					VectBufB = VectDataB[ 1 ] ; VectDataB[ 1 ] = VectDataB[ 2 ] ; VectDataB[ 2 ] = VectBufB ;
				}

				// v~eBu̕`
				GraphicsDevice_DrawPrimitiveUP( D_D3DPT_TRIANGLESTRIP, 2, VectDataB, sizeof( VERTEX_BLENDTEX_2D ) ) ;
	//			GRH.Direct3DDeviceObject->DrawPrimitive( D_D3DPT_TRIANGLESTRIP, VERTEXFVF_2D, VectData,     3, 0 ) ;
	//			GRH.Direct3DDeviceObject->DrawPrimitive( D_D3DPT_TRIANGLESTRIP, VERTEXFVF_2D, &VectData[1], 3, 0 ) ;
			}

			if( BlendGraphNoIncFlag == FALSE )
			{
				BlendDrawTex ++ ;
			}
		}
		break ;

	case VERTEXTYPE_TEX :	// uheNX`gpȂ
		// FVFݒ
		SETFVF( VERTEXFVF_2D )

		// eNX`[̐JԂ
		for( i = 0 ; i < DrawTexNum ; i ++, DrawTex ++ )
		{
			// `悷eNX`[̃Zbg
			if( GRH.RenderTexture != DrawTex->Tex->Texture )
			{
				SetTextureHardware( DrawTex->Tex->Texture ) ;
				RefreshBlendStateHardware() ;
			}

			TexVect = DrawTex->Vertex ;

			// _f[^Zbg
			VectData[ 0 ].pos.x = TexVect[ 0 ].x ;
			VectData[ 0 ].pos.y = TexVect[ 0 ].y ;
			VectData[ 1 ].pos.x = TexVect[ 1 ].x ;
			VectData[ 1 ].pos.y = TexVect[ 1 ].y ;
			VectData[ 2 ].pos.x = TexVect[ 2 ].x ;
			VectData[ 2 ].pos.y = TexVect[ 2 ].y ;
			VectData[ 3 ].pos.x = TexVect[ 3 ].x ;
			VectData[ 3 ].pos.y = TexVect[ 3 ].y ;

			VectData[ 0 ].u = TexVect[ 0 ].u ;
			VectData[ 0 ].v = TexVect[ 0 ].v ;
			VectData[ 1 ].u = TexVect[ 1 ].u ;
			VectData[ 1 ].v = TexVect[ 1 ].v ;
			VectData[ 2 ].u = TexVect[ 2 ].u ;
			VectData[ 2 ].v = TexVect[ 2 ].v ;
			VectData[ 3 ].u = TexVect[ 3 ].u ;
			VectData[ 3 ].v = TexVect[ 3 ].v ;

			VectData[0].color =
			VectData[1].color =
			VectData[2].color =
			VectData[3].color = DiffuseColor ;

			*((DWORD *)&VectData[0].pos.z) = 
			*((DWORD *)&VectData[1].pos.z) = 
			*((DWORD *)&VectData[2].pos.z) = 
			*((DWORD *)&VectData[3].pos.z) = drawz;

			VectType = DrawTex->VertType ;
			Vect = VectData ;

			for( j = 0 ; j < 4 ; j ++, Vect ++ )
			{
				// _W̎Zo
				if( *VectType ++ )
				{
					// Op̏㑤
					XBuf = Vect->pos.x ;  YBuf = Vect->pos.y ;
					Vect->pos.x = ( XBuf * ExRate1X1 ) + ( YBuf * ExRate1X2 ) + xf1 ;
					Vect->pos.y = ( YBuf * ExRate1Y1 ) + ( XBuf * ExRate1Y2 ) + yf1 ;
				} 
				else
				{
					// Op̉
					XBuf = Vect->pos.x - GraphSizeX ;  YBuf = Vect->pos.y - GraphSizeY ;
					Vect->pos.x = ( XBuf * ExRate2X1 ) + ( YBuf * ExRate2X2 ) + xf4 ;
					Vect->pos.y = ( YBuf * ExRate2Y1 ) + ( XBuf * ExRate2Y2 ) + yf4 ;
				}
			}

			if( GRH.UseAlphaChDrawShader )
			{
				VectData[0].sc_u = ( VectData[0].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
				VectData[0].sc_v = ( VectData[0].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
				VectData[1].sc_u = ( VectData[1].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
				VectData[1].sc_v = ( VectData[1].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
				VectData[2].sc_u = ( VectData[2].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
				VectData[2].sc_v = ( VectData[2].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
				VectData[3].sc_u = ( VectData[3].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
				VectData[3].sc_v = ( VectData[3].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
			}

			// ]菈
			Reverse0 =  ( VectData[ 1 ].pos.x - VectData[ 0 ].pos.x ) * ( VectData[ 2 ].pos.y - VectData[ 0 ].pos.y ) -
						( VectData[ 2 ].pos.x - VectData[ 0 ].pos.x ) * ( VectData[ 1 ].pos.y - VectData[ 0 ].pos.y ) ;
			Reverse1 = -( VectData[ 1 ].pos.x - VectData[ 3 ].pos.x ) * ( VectData[ 2 ].pos.y - VectData[ 3 ].pos.y ) +
						( VectData[ 1 ].pos.y - VectData[ 3 ].pos.y ) * ( VectData[ 2 ].pos.x - VectData[ 3 ].pos.x ) ;
			if( Reverse0 <= 0 && Reverse1 <= 0 )
			{
				VectBuf = VectData[ 1 ] ; VectData[ 1 ] = VectData[ 2 ] ; VectData[ 2 ] = VectBuf ;
			}

			// `I
			if( Reverse0 * Reverse1 >= 0 )
			{
				// v~eBu̕`
				GraphicsDevice_DrawPrimitiveUP( D_D3DPT_TRIANGLESTRIP, 2, VectData, sizeof( VERTEX_2D ) ) ;
			}
			else
			{
				// w]̕␳
				if( Reverse0 < 0 ) 
				{
					VectBuf = VectData[ 1 ] ; VectData[ 1 ] = VectData[ 2 ] ; VectData[ 2 ] = VectBuf ;
				}

				// v~eBu̕`
				GraphicsDevice_DrawPrimitiveUP( D_D3DPT_TRIANGLESTRIP, 2, VectData, sizeof( VERTEX_2D ) ) ;
	//			GRH.Direct3DDeviceObject->DrawPrimitive( D_D3DPT_TRIANGLESTRIP, VERTEXFVF_2D, VectData,     3, 0 ) ;
	//			GRH.Direct3DDeviceObject->DrawPrimitive( D_D3DPT_TRIANGLESTRIP, VERTEXFVF_2D, &VectData[1], 3, 0 ) ;
			}
		}
		break ;
	}

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawModiGraphF
static int  DrawModiGraphFHardware( float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, IMAGEDATA2 *Image2, IMAGEDATA2 *BlendImage2, int TransFlag, bool SimpleDrawFlag )
{
	int Flag ;

	if( GraphicsDevice_IsValid() == 0 || GRH.FlipSkipFlag ) return -1 ;

	// uheNX`t̏ꍇ͓sȂ`֐gp
	if( GBASE.BlendGraph > 0 ) return DrawModiGraphHardware( _FTOL( x1 ), _FTOL( y1 ), _FTOL( x2 ), _FTOL( y2 ), _FTOL( x3 ), _FTOL( y3 ), _FTOL( x4 ), _FTOL( y4 ), Image2, BlendImage2, TransFlag, SimpleDrawFlag ) ;

	// `̏
	if( GRH.BeginSceneFlag == FALSE ) BeginScene() ;
	Flag = TransFlag ;
	DRAWPREP_TEX( Image2->Orig, Image2->Hard.Draw[ 0 ].Tex->Texture, Flag )

	// eNX`[P݂̂̏ꍇ͏𕪊
	if( Image2->Hard.DrawNum == 1 )
	{
		// ̂܂ܕ`
		DrawModiTexHardware( x1, y1, x2, y2, x3, y3, x4, y4, &Image2->Hard.Draw[ 0 ], false ) ;
	}
	else
	{
		IMAGEDATA2_HARD_DRAW *DrawTex ;
		IMAGEDATA2_HARD_VERT *TexVect ;
		int DrawTexNum ;
		int i, j ;
		double xx1, yy1, xx2, yy2, xx3, yy3, xx4, yy4, xt1, yt1, xt2, yt2 ;
		double w, h, r ;
		float x[4], y[4], *xp, *yp ;

		xx1 = x2 - x1 ; xx2 = x4 - x3 ;
		yy1 = y2 - y1 ; yy2 = y4 - y3 ;

		xx3 = x3 - x1 ; xx4 = x4 - x2 ;
		yy3 = y3 - y1 ; yy4 = y4 - y2 ;
		
//		w = 1.0F / (float)Image2->Width ;
//		h = 1.0F / (float)Image2->Height ;
		w = 1.0F / (double)Image2->Width ;
		h = 1.0F / (double)Image2->Height ;

		// `̐Zbg
		DrawTexNum = Image2->Hard.DrawNum ;

		// `z̃AhXZbgĂ
		DrawTex = Image2->Hard.Draw ;

		// eNX`[̐JԂ
		for( i = 0 ; i < DrawTexNum ; i ++, DrawTex ++ )
		{
			// eNX`[̃f[^AhX擾
			TexVect = DrawTex->Vertex ;

			// WZo
			xp = x ;
			yp = y ;
			for( j = 0 ; j < 4 ; j ++, TexVect ++ )
			{
				r = TexVect->y * h ;
				xt1 = x1 + xx3 * r ;	yt1 = y1 + yy3 * r ;
				xt2 = x2 + xx4 * r ;	yt2 = y2 + yy4 * r ;

				r = TexVect->x * w ;
				*xp++ = (float)( ( xt2 - xt1 ) * r + xt1 ) ;
				*yp++ = (float)( ( yt2 - yt1 ) * r + yt1 ) ;
			}

			// `
			DrawModiTexHardware( x[0], y[0], x[1], y[1], x[2], y[2], x[3], y[3], DrawTex, false ) ;
		}
	}

	// I
	return 0 ;
}

// eNX`ό`ĕ`悷
static void DrawModiTexHardware( float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, IMAGEDATA2_HARD_DRAW *DrawTex, bool SimpleDrawFlag )
{
	IMAGEDATA2_HARD_VERT *TexVect ;
	VERTEX_2D *vec ; 
	VERTEX_2D VectBuf[2] ;
	float xx1, yy1, xx2, yy2, xx3, yy3, xx4, yy4/*, r1, r2, r3, r4*/ ;
//	float xtmp1, ytmp1, xtmp2, ytmp2 ;
	int c, f1, f2, DiffuseColor ;
	float Reverse0, Reverse1;
	DWORD drawz ;

	// `悷eNX`[̃Zbg
	if( GRH.RenderTexture != DrawTex->Tex->Texture )
	{
		SetTextureHardware( DrawTex->Tex->Texture ) ;
		RefreshBlendStateHardware() ;
	}

	// _f[^擾îƂF̃Zbĝ݁j
	DiffuseColor = GRH.DiffuseColor ;

	// yobt@ɏނylZbg
	drawz = *((DWORD *)&GBASE.DrawZ);

	TexVect = DrawTex->Vertex ;

	// ]p
	Reverse0 =  ( x2 - x1 ) * ( y3 - y1 ) - ( x3 - x1 ) * ( y2 - y1 ) ;
	Reverse1 = -( x2 - x4 ) * ( y3 - y4 ) + ( y2 - y4 ) * ( x3 - x4 ) ;

	if( SimpleDrawFlag ) goto R1 ;

	// slӌ`ȏ̕ό`NĂȂ畁ʂ̏s
	f1 = f2 = c = 0 ;
	xx1 = x2 - x1 ; xx2 = x4 - x3 ;
	yy1 = y2 - y1 ; yy2 = y4 - y3 ;

	xx3 = x3 - x1 ; xx4 = x4 - x2 ;
	yy3 = y3 - y1 ; yy4 = y4 - y2 ;

	if( _FABS( xx1 - xx2 ) < 1.0F && _FABS( yy1 - yy2 ) < 1.0F ) c ++, f1 = 1 ;
	if( _FABS( xx3 - xx4 ) < 1.0F && _FABS( yy3 - yy4 ) < 1.0F ) c ++, f2 = 1 ;
	if( c == 2 ) goto R1 ;

/*
	// `SȎRlp`𔻒
	f1 = f2 = c = 0 ;
	r1 = _SQRT( xx1 * xx1 + yy1 * yy1 ) ;	xtmp1 = xx1 / r1 ;	ytmp1 = yy1 / r1 ;
	r2 = _SQRT( xx2 * xx2 + yy2 * yy2 ) ;	xtmp2 = xx2 / r2 ;	ytmp2 = yy2 / r2 ;
	if( _FABS( xtmp1 - xtmp2 ) < 0.001F && _FABS( ytmp1 - ytmp2 ) < 0.001F ) c ++, f1 = 1 ;
	
	r3 = _SQRT( xx3 * xx3 + yy3 * yy3 ) ;	xtmp1 = xx3 / r3 ;	ytmp1 = yy3 / r3 ;
	r4 = _SQRT( xx4 * xx4 + yy4 * yy4 ) ;	xtmp2 = xx4 / r4 ;	ytmp2 = yy4 / r4 ;
	if( _FABS( xtmp1 - xtmp2 ) < 0.001F && _FABS( ytmp1 - ytmp2 ) < 0.001F ) c ++, f2 = 1 ;
*/

	{
#define TDIVNUM		5
#define TDN			(1 + ( 1 << TDIVNUM ))
#define ADJUSTUV	(0.001f)
		int DivNum, tdn ;
		static VERTEX_2D VectData2[TDN * TDN] ;
		VERTEX_2D *v ;
		float xxx1, yyy1, xxx2, yyy2, xxx3, yyy3 ;
		float adx1, ady1, adx2, ady2, adx3, ady3, adtu, adtv, tu, tv ; 
		int i, j ;
		float adjust_u_l, adjust_u_r, adjust_v_t, adjust_v_b ;

		// 摜̏ꍇׂ̉摜̃sNZȂ߂̕␳tul쐬
		{
			if( TexVect[ 0 ].u < 0.000001f )
			{
				adjust_u_l = 0.0f ;
			}
			else
			{
				adjust_u_l =  ( TexVect[ 3 ].u - TexVect[ 0 ].u ) / ( TexVect[ 3 ].x - TexVect[ 0 ].x ) * ADJUSTUV ;
			}

			if( TexVect[ 3 ].u > 0.99999f )
			{
				adjust_u_r = 0.0f ;
			}
			else
			{
				adjust_u_r = -( TexVect[ 3 ].u - TexVect[ 0 ].u ) / ( TexVect[ 3 ].x - TexVect[ 0 ].x ) * ADJUSTUV ;
			}

			if( TexVect[ 0 ].v < 0.000001f )
			{
				adjust_v_t = 0.0f ;
			}
			else
			{
				adjust_v_t =  ( TexVect[ 3 ].v - TexVect[ 0 ].v ) / ( TexVect[ 3 ].y - TexVect[ 0 ].y ) * ADJUSTUV ;
			}

			if( TexVect[ 3 ].v > 0.99999f )
			{
				adjust_v_b = 0.0f ;
			}
			else
			{
				adjust_v_b = -( TexVect[ 3 ].v - TexVect[ 0 ].v ) / ( TexVect[ 3 ].y - TexVect[ 0 ].y ) * ADJUSTUV ;
			}
		}

		// ̎Zo
		{
			float v1x, v1y, v2x, v2y ;
			float rate ;
			const float Table[] = { 2.0F, 1.0F, 0.6F, 0.1F, 0.05F } ;

			v1x = x4 - x1 ;		v1y = y4 - y1 ;
			v2x = x3 - x2 ;		v2y = y3 - y2 ;
			rate = (float)( 
				( _SQRT( v1x * v1x + v1y * v1y ) + _SQRT( v2x * v2x + v2y * v2y ) ) /
				( ( _SQRT( (float)( GBASE.DrawSizeX * GBASE.DrawSizeX + 
						GBASE.DrawSizeY * GBASE.DrawSizeY ) ) * 2 ) ) ) ;
			tdn = 8 ;
			if( tdn < 8 ) tdn = 8 ;
			else if( tdn > TDN ) tdn = TDN ;
			for( DivNum = TDIVNUM ; DivNum > 0 && rate < Table[TDIVNUM - DivNum] ; DivNum -- ){}
		}

		// Rlp`
		adx1 = xx3 / ( tdn - 1 ) ;	ady1 = yy3 / ( tdn - 1 ) ;
		adx2 = xx4 / ( tdn - 1 ) ;	ady2 = yy4 / ( tdn - 1 ) ;
		xxx1 = x1 ;		yyy1 = y1 ;
		xxx2 = x2 ;		yyy2 = y2 ;
		adtu = ( ( TexVect[3].u + adjust_u_r ) - ( TexVect[0].u + adjust_u_l ) ) / ( tdn - 1 ) ;
		adtv = ( ( TexVect[3].v + adjust_v_b ) - ( TexVect[0].v + adjust_v_t ) ) / ( tdn - 1 ) ;
		tv = TexVect[0].v + adjust_v_t ;
		v = VectData2 ;
		for( i = 0 ; i < tdn ; i ++, tv += adtv,
									 xxx1 += adx1, yyy1 += ady1,
									 xxx2 += adx2, yyy2 += ady2 )
		{
			adx3 = ( xxx2 - xxx1 ) / ( tdn - 1 ) ;
			ady3 = ( yyy2 - yyy1 ) / ( tdn - 1 ) ;

//			xxx3 = xxx1 - 0.5F ;	yyy3 = yyy1 - 0.5F ;
			xxx3 = xxx1 ;
			yyy3 = yyy1 ;
			tu = TexVect[0].u + adjust_u_l ;
			for( j = 0 ; j < tdn ; j ++, tu += adtu,
										 xxx3 += adx3, yyy3 += ady3, v ++ )
			{
				v->pos.x = (float)xxx3 ;
				v->pos.y = (float)yyy3 ;
				*((DWORD *)&v->pos.z) = drawz ;
				v->rhw   = 1.0F ;
				v->u     = (float)tu ;
				v->v     = (float)tv ;
				v->color = DiffuseColor ;
			}
		}

		if( GRH.UseAlphaChDrawShader )
		{
			int loop_num ;

			loop_num = tdn * tdn ;
			v = VectData2 ;
			for( i = 0 ; i < loop_num ; i ++, v ++ )
			{
				v->sc_u = ( v->pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
				v->sc_v = ( v->pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
			}
		}

		// _ǉ
		SetPlaneVertexHardware( VectData2, tdn, tdn ) ;

#undef TDIVNUM
#undef TDN
	}

	return ;
		
R1 :
	// ʂɕ`
	GETVERTEX_QUAD( vec )

	vec[0].color =
	vec[3].color = DiffuseColor ;

	vec[0].pos.x = x1 ;	
	vec[5].pos.x = vec[1].pos.x = x2 ;	
	vec[4].pos.x = vec[2].pos.x = x3 ;
	vec[3].pos.x = x4 ;
	
	vec[0].pos.y = y1 ;
	vec[5].pos.y = vec[1].pos.y = y2 ;
	vec[4].pos.y = vec[2].pos.y = y3 ;
	vec[3].pos.y = y4 ;

	vec[4].u = vec[2].u = vec[0].u = TexVect[0].u + 0.0625f / DrawTex->Tex->TexWidth ;
	vec[5].u = vec[3].u = vec[1].u = TexVect[1].u - 0.0625f / DrawTex->Tex->TexWidth ;
	vec[5].v = vec[1].v = vec[0].v = TexVect[0].v + 0.0625f / DrawTex->Tex->TexHeight ;
	vec[4].v = vec[3].v = vec[2].v = TexVect[2].v - 0.0625f / DrawTex->Tex->TexHeight ;

	if( GRH.UseAlphaChDrawShader )
	{
		vec[ 0 ].sc_u =					( vec[ 0 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		vec[ 0 ].sc_v =					( vec[ 0 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
		vec[ 5 ].sc_u = vec[ 1 ].sc_u = ( vec[ 1 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		vec[ 5 ].sc_v = vec[ 1 ].sc_v = ( vec[ 1 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
		vec[ 4 ].sc_u = vec[ 2 ].sc_u = ( vec[ 2 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		vec[ 4 ].sc_v = vec[ 2 ].sc_v = ( vec[ 2 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
		vec[ 3 ].sc_u =					( vec[ 3 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		vec[ 3 ].sc_v =					( vec[ 3 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
	}

	*((DWORD *)&vec[0].pos.z) =
	*((DWORD *)&vec[1].pos.z) =
	*((DWORD *)&vec[2].pos.z) =
	*((DWORD *)&vec[3].pos.z) =
	*((DWORD *)&vec[4].pos.z) =
	*((DWORD *)&vec[5].pos.z) = drawz;

	if( Reverse0 <= 0  &&  Reverse1 <= 0 )
	{
		VectBuf[ 0 ] = vec[ 1 ] ;
		VectBuf[ 1 ] = vec[ 4 ] ;
		vec[ 1 ]     = vec[ 2 ] ;
		vec[ 4 ]     = vec[ 5 ] ;
		vec[ 2 ]     = VectBuf[ 0 ] ;
		vec[ 5 ]     = VectBuf[ 1 ] ;
	}

	ADD4VERTEX_TEX
}

// n[hEGAANZ[^gp DrawFillBox
static int DrawFillBoxHardware( int x1, int y1, int x2, int y2, int Color )
{
	VERTEX_NOTEX_2D *vec ;
	RECT drect ;
	int Red, Green, Blue, Flag ;
	DWORD drawz;

	if( GraphicsDevice_IsValid() == 0 || GRH.FlipSkipFlag ) return -1 ;

	// ]
	{
		int b ;

		if( x1 > x2 ){ b = x1 ; x1 = x2 ; x2 = b ; }
		if( y1 > y2 ){ b = y1 ; y1 = y2 ; y2 = b ; }
	}
	
	// NbsO
	{
		drect.left   = x1 ;
		drect.right  = x2 ;
		drect.top    = y1 ;
		drect.bottom = y2 ;
		RectClipping( &drect, &GBASE.DrawArea ) ;
		if( drect.left == drect.right || drect.top == drect.bottom ) return 0 ;
	}

	// `̏
	BeginScene() ;
	Flag = DRAWPREP_DIFFUSERGB ;
	DRAWPREP_NOTEX( Flag ) ;

	// F̑Xe[^X̃Zbg
	NS_GetColor2( Color, &Red, &Green, &Blue ) ;
	Color = ( ( ( ( ( 	GRH.DiffuseColor & 0x00ff0000 ) >> 16 ) * Red 	) / 255 ) << 16 ) |
			( ( ( ( ( 	GRH.DiffuseColor & 0x0000ff00 ) >> 8  ) * Green ) / 255 ) << 8 ) |
			( ( ( ( 	GRH.DiffuseColor & 0x000000ff )       ) * Blue 	) / 255 ) | 
			( 			GRH.DiffuseColor & 0xff000000 ) ;

	// yobt@ɏނylZbg
	drawz = *((DWORD *)&GBASE.DrawZ);

	// _f[^̃Zbg
	GETVERTEX_QUAD( vec )
	
	vec[0].color =
	vec[3].color = Color ;
	
	vec[4].pos.x = vec[2].pos.x = vec[0].pos.x = (float)drect.left   ;
	vec[5].pos.x = vec[3].pos.x = vec[1].pos.x = (float)drect.right  ;
	vec[5].pos.y = vec[1].pos.y = vec[0].pos.y = (float)drect.top    ;
	vec[4].pos.y = vec[3].pos.y = vec[2].pos.y = (float)drect.bottom ;

	if( GRH.UseAlphaChDrawShader )
	{
		vec[ 4 ].sc_u = vec[ 2 ].sc_u = vec[ 0 ].sc_u = ( vec[ 0 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		vec[ 5 ].sc_u = vec[ 3 ].sc_u = vec[ 1 ].sc_u = ( vec[ 1 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		vec[ 5 ].sc_v = vec[ 1 ].sc_v = vec[ 0 ].sc_v = ( vec[ 0 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
		vec[ 4 ].sc_v = vec[ 3 ].sc_v = vec[ 2 ].sc_v = ( vec[ 2 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
	}

	*((DWORD *)&vec[0].pos.z) =
	*((DWORD *)&vec[1].pos.z) =
	*((DWORD *)&vec[2].pos.z) =
	*((DWORD *)&vec[3].pos.z) =
	*((DWORD *)&vec[4].pos.z) =
	*((DWORD *)&vec[5].pos.z) = drawz;

	// _f[^̏o
	ADD4VERTEX_NOTEX

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawLineBox
static int DrawLineBoxHardware( int x1, int y1, int x2, int y2, int Color )
{
	VERTEX_NOTEX_2D *VectData ;
	int Red, Green, Blue ;
	float fx1, fx2, fy1, fy2 ;
	int Flag;
	DWORD drawz ;

//	RenderVertexHardware( D3D.Direct3DDeviceHandle ) ;

	if( GraphicsDevice_IsValid() == 0 || GRH.FlipSkipFlag ) return -1 ;

	// `̏
	if( GRH.BeginSceneFlag == FALSE ) BeginScene() ;
	if( GRH.RenderTexture != NULL ) SetTextureHardware( NULL ) ;
	Flag = DRAWPREP_DIFFUSERGB ;
	DRAWPREP_NOTEX( Flag ) ;

	// yobt@ɏނylZbg
	drawz = *((DWORD *)&GBASE.DrawZ);

	// F̑Xe[^X̃Zbg
	NS_GetColor2( Color, &Red, &Green, &Blue ) ;
	Color = ( ( ( ( (	GRH.DiffuseColor & 0xff0000 ) >> 16 ) * Red )	/ 255 ) << 16 ) |
			( ( ( ( (	GRH.DiffuseColor & 0x00ff00 ) >> 8  ) * Green )	/ 255 ) << 8 ) |
			( ( ( (		GRH.DiffuseColor & 0x0000ff )       ) * Blue )	/ 255 ) | 
			(			GRH.DiffuseColor & 0xff000000 ) ;

	// ]
	{
		int bx, by ;

		if( x1 > x2 || y1 > y2 )
		{
			bx = x1 ; by = y1 ;
			x1 = x2 ; y1 = y2 ;
			x2 = bx ; y2 = by ;
		}
	}

	fx1 = (float)x1 ;
	fy1 = (float)y1 ;
	fx2 = (float)x2 ;
	fy2 = (float)y2 ;

	GETVERTEX_LINEBOX( VectData ) ;
	VectData[ 0].color = VectData[ 1].color = VectData[ 2].color = VectData[ 3].color = VectData[ 4].color = VectData[ 5].color =
	VectData[ 6].color = VectData[ 7].color = VectData[ 8].color = VectData[ 9].color = VectData[10].color = VectData[11].color =
	VectData[12].color = VectData[13].color = VectData[14].color = VectData[15].color = VectData[16].color = VectData[17].color =
	VectData[18].color = VectData[19].color = VectData[20].color = VectData[21].color = VectData[22].color = VectData[23].color = Color ;

	*((DWORD *)&VectData[ 0].pos.z) = *((DWORD *)&VectData[ 1].pos.z) = *((DWORD *)&VectData[ 2].pos.z) = *((DWORD *)&VectData[ 3].pos.z) = *((DWORD *)&VectData[ 4].pos.z) = *((DWORD *)&VectData[ 5].pos.z) =
	*((DWORD *)&VectData[ 6].pos.z) = *((DWORD *)&VectData[ 7].pos.z) = *((DWORD *)&VectData[ 8].pos.z) = *((DWORD *)&VectData[ 9].pos.z) = *((DWORD *)&VectData[10].pos.z) = *((DWORD *)&VectData[11].pos.z) =
	*((DWORD *)&VectData[12].pos.z) = *((DWORD *)&VectData[13].pos.z) = *((DWORD *)&VectData[14].pos.z) = *((DWORD *)&VectData[15].pos.z) = *((DWORD *)&VectData[16].pos.z) = *((DWORD *)&VectData[17].pos.z) =
	*((DWORD *)&VectData[18].pos.z) = *((DWORD *)&VectData[19].pos.z) = *((DWORD *)&VectData[20].pos.z) = *((DWORD *)&VectData[21].pos.z) = *((DWORD *)&VectData[22].pos.z) = *((DWORD *)&VectData[23].pos.z) = drawz;

	VectData[0].pos.x = fx1			; VectData[0].pos.y = fy1		 ;
	VectData[1].pos.x = fx2			; VectData[1].pos.y = fy1		 ;
	VectData[2].pos.x = fx1			; VectData[2].pos.y = fy1 + 1.0f ;

	VectData[3].pos.x = fx2			; VectData[3].pos.y = fy1 + 1.0f ;
	VectData[4].pos.x = fx1			; VectData[4].pos.y = fy1 + 1.0f ;
	VectData[5].pos.x = fx2			; VectData[5].pos.y = fy1		 ;

	if( GRH.UseAlphaChDrawShader )
	{
		VectData[ 0 ].sc_u = ( VectData[ 0 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		VectData[ 0 ].sc_v = ( VectData[ 0 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
		VectData[ 1 ].sc_u = ( VectData[ 1 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		VectData[ 1 ].sc_v = ( VectData[ 1 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
		VectData[ 2 ].sc_u = ( VectData[ 2 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		VectData[ 2 ].sc_v = ( VectData[ 2 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
		VectData[ 3 ].sc_u = ( VectData[ 3 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		VectData[ 3 ].sc_v = ( VectData[ 3 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
		VectData[ 4 ].sc_u = ( VectData[ 4 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		VectData[ 4 ].sc_v = ( VectData[ 4 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
		VectData[ 5 ].sc_u = ( VectData[ 5 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		VectData[ 5 ].sc_v = ( VectData[ 5 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
	}

	VectData += 6 ;


	VectData[0].pos.x = fx2 - 1.0f	; VectData[0].pos.y = fy1 + 1.0f ;
	VectData[1].pos.x = fx2			; VectData[1].pos.y = fy1 + 1.0f ;
	VectData[2].pos.x = fx2	- 1.0f	; VectData[2].pos.y = fy2		 ;

	VectData[3].pos.x = fx2			; VectData[3].pos.y = fy2		 ;
	VectData[4].pos.x = fx2 - 1.0f	; VectData[4].pos.y = fy2		 ;
	VectData[5].pos.x = fx2			; VectData[5].pos.y = fy1 + 1.0f ;

	if( GRH.UseAlphaChDrawShader )
	{
		VectData[ 0 ].sc_u = ( VectData[ 0 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		VectData[ 0 ].sc_v = ( VectData[ 0 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
		VectData[ 1 ].sc_u = ( VectData[ 1 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		VectData[ 1 ].sc_v = ( VectData[ 1 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
		VectData[ 2 ].sc_u = ( VectData[ 2 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		VectData[ 2 ].sc_v = ( VectData[ 2 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
		VectData[ 3 ].sc_u = ( VectData[ 3 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		VectData[ 3 ].sc_v = ( VectData[ 3 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
		VectData[ 4 ].sc_u = ( VectData[ 4 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		VectData[ 4 ].sc_v = ( VectData[ 4 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
		VectData[ 5 ].sc_u = ( VectData[ 5 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		VectData[ 5 ].sc_v = ( VectData[ 5 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
	}

	VectData += 6 ;


	VectData[0].pos.x = fx1			; VectData[0].pos.y = fy1 + 1.0f ;
	VectData[1].pos.x = fx1 + 1.0f	; VectData[1].pos.y = fy1 + 1.0f ;
	VectData[2].pos.x = fx1			; VectData[2].pos.y = fy2		 ;

	VectData[3].pos.x = fx1 + 1.0f	; VectData[3].pos.y = fy2		 ;
	VectData[4].pos.x = fx1			; VectData[4].pos.y = fy2		 ;
	VectData[5].pos.x = fx1 + 1.0f	; VectData[5].pos.y = fy1 + 1.0f ;

	if( GRH.UseAlphaChDrawShader )
	{
		VectData[ 0 ].sc_u = ( VectData[ 0 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		VectData[ 0 ].sc_v = ( VectData[ 0 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
		VectData[ 1 ].sc_u = ( VectData[ 1 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		VectData[ 1 ].sc_v = ( VectData[ 1 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
		VectData[ 2 ].sc_u = ( VectData[ 2 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		VectData[ 2 ].sc_v = ( VectData[ 2 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
		VectData[ 3 ].sc_u = ( VectData[ 3 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		VectData[ 3 ].sc_v = ( VectData[ 3 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
		VectData[ 4 ].sc_u = ( VectData[ 4 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		VectData[ 4 ].sc_v = ( VectData[ 4 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
		VectData[ 5 ].sc_u = ( VectData[ 5 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		VectData[ 5 ].sc_v = ( VectData[ 5 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
	}

	VectData += 6 ;


	VectData[0].pos.x = fx1 + 1.0f	; VectData[0].pos.y = fy2 - 1.0f ;
	VectData[1].pos.x = fx2 - 1.0f	; VectData[1].pos.y = fy2 - 1.0f ;
	VectData[2].pos.x = fx1 + 1.0f	; VectData[2].pos.y = fy2		 ;

	VectData[3].pos.x = fx2 - 1.0f	; VectData[3].pos.y = fy2		 ;
	VectData[4].pos.x = fx1 + 1.0f	; VectData[4].pos.y = fy2		 ;
	VectData[5].pos.x = fx2 - 1.0f	; VectData[5].pos.y = fy2 - 1.0f ;

	if( GRH.UseAlphaChDrawShader )
	{
		VectData[ 0 ].sc_u = ( VectData[ 0 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		VectData[ 0 ].sc_v = ( VectData[ 0 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
		VectData[ 1 ].sc_u = ( VectData[ 1 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		VectData[ 1 ].sc_v = ( VectData[ 1 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
		VectData[ 2 ].sc_u = ( VectData[ 2 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		VectData[ 2 ].sc_v = ( VectData[ 2 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
		VectData[ 3 ].sc_u = ( VectData[ 3 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		VectData[ 3 ].sc_v = ( VectData[ 3 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
		VectData[ 4 ].sc_u = ( VectData[ 4 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		VectData[ 4 ].sc_v = ( VectData[ 4 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
		VectData[ 5 ].sc_u = ( VectData[ 5 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		VectData[ 5 ].sc_v = ( VectData[ 5 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
	}

	VectData += 6 ;

	// _̒ǉ
	ADD4VERTEX_LINEBOX

/*
	fx1 = (float)x1 ;
	fy1 = (float)y1 ;
	fx2 = (float)( x2 - 1 ) ;
	fy2 = (float)( y2 - 1 ) ;

	GETVERTEX_LINEBOX( VectData ) ;
	VectData[0].color = 
	VectData[1].color = 
	VectData[2].color = 
	VectData[3].color = 
	VectData[4].color = 
	VectData[5].color = 
	VectData[6].color = 
	VectData[7].color = Color ;

	*((DWORD *)&VectData[0].pos.z) =
	*((DWORD *)&VectData[1].pos.z) =
	*((DWORD *)&VectData[2].pos.z) =
	*((DWORD *)&VectData[3].pos.z) =
	*((DWORD *)&VectData[4].pos.z) =
	*((DWORD *)&VectData[5].pos.z) =
	*((DWORD *)&VectData[6].pos.z) =
	*((DWORD *)&VectData[7].pos.z) = drawz;

	// W̃Zbg
	VectData[0].pos.x = fx1			; VectData[0].pos.y = fy1		;
	VectData[1].pos.x = fx2 - 0.1F	; VectData[1].pos.y = fy1		;

	VectData[2].pos.x = fx2			; VectData[2].pos.y = fy1		;
	VectData[3].pos.x = fx2			; VectData[3].pos.y = fy2 - 0.1F ;

	VectData[4].pos.x = fx1			; VectData[4].pos.y = fy2		;
	VectData[5].pos.x = fx2 + 0.9F	; VectData[5].pos.y = fy2		;

	VectData[6].pos.x = fx1			; VectData[6].pos.y = fy1 + 1.0F ;
	VectData[7].pos.x = fx1			; VectData[7].pos.y = fy2 - 0.1F ;

	// _̒ǉ
	ADD4VERTEX_LINEBOX
*/

//	// lp`̕`
//	Get3DDevice( D3D.Direct3DDeviceHandle )->DrawPrimitive( D_D3DPT_LINELIST, VERTEXFVF_NOTEX_2D, VectData, 2 * 4, 0 ) ;

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawChipMap
static int	DrawChipMapHardware( int Sx, int Sy, int XNum, int YNum, const int *MapData, int MapDataPitch, int /*ChipTypeNum*/, const int *ChipGrHandle, int TransFlag )
{
	IMAGEDATA2 *Image2 ;
	IMAGEDATA2 *BlendImage2 ;
	int i, j ;
	int x, y, Width, Height ;
	const int *MP ;

	if( GraphicsDevice_IsValid() == 0 || GRH.FlipSkipFlag ) return -1 ;

	// `̏
	if( GRAPHCHK( ChipGrHandle[ 0 ], Image2 ) )
		return -1 ;
	BlendImage2 = NULL ;
	if( GBASE.BlendGraph > 0 )
	{
		GRAPHCHK( GBASE.BlendGraph, BlendImage2 ) ;
	}

	Width = Image2->Width ;
	Height = Image2->Height ;

	// ʂ for Ń[v`
	y = Sy ;
	MP = MapData ;
	for( i = 0 ; i < YNum ; i ++, y += Height )
	{
		x = Sx ;
		for( j = 0 ; j < XNum ; j ++, x += Width, MP ++ )
		{
			if( *MP == -1 ) continue ;

			if( GRAPHCHK( ChipGrHandle[ *MP ], Image2 ) )
				return -1 ;

			DrawGraphHardware( x, y, ( float )x, ( float )y, Image2, BlendImage2, TransFlag, TRUE ) ;
		}
		MP += MapDataPitch - XNum ;
	}

	// I
	return 0 ;
}

/*
x1,y1,x2,y2@ʒA^C\肵̈
Tx,Ty@@@@ψʁ@@@@@@@@@@@@摜́Aǂ̍W^C\Jn邩B
ExtRate@@@摜̊g嗦@@@@@@@@u1vɂƁA摜̂܂܂̑傫Ń^C\肷B
Angle@@@@摜̉]px@@@@@@@u0vɂƁA]ȂŃ^C\肷B
GrHandle@@ 摜̃nh
TransFlag@@߃tO
*/

// n[hEGAANZ[^gp DrawTile
static int	DrawTileHardware( int x1, int y1, int x2, int y2, int Tx, int Ty, double ExtRate, double Angle, IMAGEDATA2 *Image2, IMAGEDATA2 *BlendImage2, int TransFlag )
{
	double MaxLength ;
	float Width, Height, f, Sin, Cos, Sin2, Cos2 ;
	float CenX, CenY, x, y, BaseX, BaseY ;
	float xAddX, xAddY, yAddX, yAddY ;
	int temp, Num, i, j ;
	RECT DrawRect ;
	float FExtRate, FAngle ;

	FExtRate = (float)ExtRate ;
	FAngle = (float)Angle ;

	if( ExtRate <= 0.0 ) ExtRate = 0.0001 ;
	if( x1 > x2 ){ temp = x2 ; x2 = x1 ; x1 = temp ; }
	if( y1 > y2 ){ temp = y2 ; y2 = y1 ; y1 = temp ; }
	Tx %= Image2->Width ;
	Ty %= Image2->Height ;

	// iޒlvZ
	_SINCOS( FAngle, &Sin, &Cos ) ;
	xAddX = Image2->Width * Cos * FExtRate ;
	xAddY = Image2->Height * Sin * FExtRate ;

	_SINCOS( FAngle + DX_PI_F / 2.0F, &Sin2, &Cos2 ) ;
	yAddX = Image2->Width * Cos2 * FExtRate ;
	yAddY = Image2->Height * Sin2 * FExtRate ;

	// `敝𓾂
	Width = (float)( x2 - x1 ) ;
	Height = (float)( y2 - y1 ) ;

	// ő咷𓾂
	MaxLength = _SQRT( Width * Width + Height * Height ) ;

	// `𓾂
	{
		int k ;

		k = Image2->Width > Image2->Height ? Image2->Height : Image2->Width ;
		Num = _DTOL( MaxLength / ( k * ExtRate ) + 2 ) ;
		if( Num % 2 == 0 ) Num ++ ;
	}

	// `撆S_𓾂
	CenX = x1 + Width / 2 ;
	CenY = y1 + Height / 2 ;

	// `\͈͂ύX
	DrawRect = GBASE.DrawArea ;
	NS_SetDrawArea( x1, y1, x2, y2 ) ;

	// `JnW𓾂
	BaseX = ( -Tx - ( Num * Image2->Width  ) / 2 ) * FExtRate ;
	BaseY = ( -Ty - ( Num * Image2->Height ) / 2 ) * FExtRate ;

	f = BaseX * Cos - BaseY * Sin ;
	BaseY = BaseX * Sin + BaseY * Cos + CenY ;
	BaseX = f + CenX ;

	// `Jn
	for( i = 0 ; i < Num ; i ++, BaseX += yAddX, BaseY += yAddY )
	{
		x = BaseX ;
		y = BaseY ;
		for( j = 0 ; j < Num ; j ++, x += xAddX, y += xAddY )
		{
			DrawModiGraphFHardware(
				x, y,
				x + xAddX, y + xAddY,
				x + yAddX, y + yAddY,
				x + xAddX + yAddX, y + xAddY + yAddY,
				Image2, BlendImage2, TransFlag, true ) ;
		}
	}

	// `\͈͂ɖ߂
	NS_SetDrawArea( DrawRect.left, DrawRect.top, DrawRect.right, DrawRect.bottom ) ;

	return 0 ;
}

static int DrawPrimitiveHardware( const VERTEX_3D *Vertex, int VertexNum, int PrimitiveType, IMAGEDATA2 *Image2, int TransFlag )
{
	int Flag ;

	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	// `̏
	RenderVertexHardware() ;
	BeginScene() ;
	SetBlendTextureHardware( NULL ) ;

	// `tÕZbg
	Flag = TransFlag | DRAWPREP_GOURAUDSHADE | DRAWPREP_PERSPECTIVE | DRAWPREP_DIFFUSERGB | DRAWPREP_DIFFUSEALPHA | DRAWPREP_FOG | DRAWPREP_3D | DRAWPREP_TEXADDRESS | DRAWPREP_CULLING ;

	// `̏
	if( Image2 )
	{
		DRAWPREP_TEX( Image2->Orig, Image2->Hard.Draw[ 0 ].Tex->Texture, Flag )
	}
	else
	{
		DRAWPREP_NOTEX( Flag )
	}

	// `
	SETFVF( VERTEXFVF_3D )
	GraphicsDevice_DrawPrimitiveUP( ( D_D3DPRIMITIVETYPE )PrimitiveType, GETPRIMNUM( PrimitiveType, VertexNum ), Vertex, sizeof( VERTEX_3D ) ) ;

	// I
	return 0 ;
}

static int	DrawIndexedPrimitiveHardware( const VERTEX_3D *Vertex, int VertexNum, const WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA2 *Image2, int TransFlag )
{
	int Flag ;

	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	// `̏
	RenderVertexHardware() ;
	BeginScene() ;
	SetBlendTextureHardware( NULL ) ;

	Flag = TransFlag | DRAWPREP_GOURAUDSHADE | DRAWPREP_PERSPECTIVE | DRAWPREP_DIFFUSERGB | DRAWPREP_DIFFUSEALPHA | DRAWPREP_FOG | DRAWPREP_3D | DRAWPREP_TEXADDRESS | DRAWPREP_CULLING ;
	if( Image2 )
	{
		DRAWPREP_TEX( Image2->Orig, Image2->Hard.Draw[ 0 ].Tex->Texture, Flag )
	}
	else
	{
		DRAWPREP_NOTEX( Flag )
	}

	// `
	SETFVF( VERTEXFVF_3D )
	GraphicsDevice_DrawIndexedPrimitiveUP( ( D_D3DPRIMITIVETYPE )PrimitiveType, 0, VertexNum, GETPRIMNUM( PrimitiveType, IndexNum ), Indices, D_D3DFMT_INDEX16, Vertex, sizeof( VERTEX_3D ) ) ;

	// I
	return 0 ;
}

static int DrawPrimitiveLightHardware( const VERTEX3D *Vertex, int VertexNum, int PrimitiveType, IMAGEDATA2 *Image2, int TransFlag )
{
	int Flag ;

	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	// `̏
	RenderVertexHardware() ;
	BeginScene() ;
	SetBlendTextureHardware( NULL ) ;

	Flag = TransFlag | DRAWPREP_GOURAUDSHADE | DRAWPREP_PERSPECTIVE | DRAWPREP_DIFFUSERGB | DRAWPREP_DIFFUSEALPHA | DRAWPREP_FOG | DRAWPREP_LIGHTING | DRAWPREP_SPECULAR | DRAWPREP_3D | DRAWPREP_TEXADDRESS | DRAWPREP_CULLING ;
	if( Image2 )
	{
		DRAWPREP_TEX( Image2->Orig, Image2->Hard.Draw[ 0 ].Tex->Texture, Flag )
	}
	else
	{
		DRAWPREP_NOTEX( Flag )
	}

	// `
	SETFVF( VERTEXFVF_3D_LIGHT )
	GraphicsDevice_DrawPrimitiveUP( ( D_D3DPRIMITIVETYPE )PrimitiveType, GETPRIMNUM( PrimitiveType, VertexNum ), Vertex, sizeof( VERTEX3D ) ) ;

	// I
	return 0 ;
}

static int DrawIndexedPrimitiveLightHardware( const VERTEX3D *Vertex, int VertexNum, const WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA2 *Image2, int TransFlag )
{
	int Flag ;

	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	// `̏
	RenderVertexHardware() ;
	BeginScene() ;
	SetBlendTextureHardware( NULL ) ;

	Flag = TransFlag | DRAWPREP_GOURAUDSHADE | DRAWPREP_PERSPECTIVE | DRAWPREP_DIFFUSERGB | DRAWPREP_DIFFUSEALPHA | DRAWPREP_FOG | DRAWPREP_LIGHTING | DRAWPREP_SPECULAR | DRAWPREP_3D | DRAWPREP_TEXADDRESS | DRAWPREP_CULLING ;
	if( Image2 )
	{
		DRAWPREP_TEX( Image2->Orig, Image2->Hard.Draw[ 0 ].Tex->Texture, Flag )
	}
	else
	{
		DRAWPREP_NOTEX( Flag )
	}

	// `
	SETFVF( VERTEXFVF_3D_LIGHT )
	GraphicsDevice_DrawIndexedPrimitiveUP( ( D_D3DPRIMITIVETYPE )PrimitiveType, 0, VertexNum, GETPRIMNUM( PrimitiveType, IndexNum ), Indices, D_D3DFMT_INDEX16, Vertex, sizeof( VERTEX3D ) ) ;

	// I
	return 0 ;
}

static int	DrawPrimitiveLight_UseVertexBufferHardware( 
	VERTEXBUFFERHANDLEDATA *VertexBuffer,
	int						PrimitiveType,
	int						StartVertex,
	int						UseVertexNum,
	IMAGEDATA2 *			Image2,
	int						TransFlag 
)
{
	int Flag ;
	int PrimitiveCount ;

	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	// `̏
	RenderVertexHardware() ;
	BeginScene() ;
	SetBlendTextureHardware( NULL ) ;

	Flag = TransFlag | DRAWPREP_GOURAUDSHADE | DRAWPREP_PERSPECTIVE | DRAWPREP_DIFFUSERGB | DRAWPREP_DIFFUSEALPHA | DRAWPREP_FOG | DRAWPREP_LIGHTING | DRAWPREP_SPECULAR | DRAWPREP_3D | DRAWPREP_TEXADDRESS | DRAWPREP_CULLING ;
	if( Image2 )
	{
		DRAWPREP_TEX( Image2->Orig, Image2->Hard.Draw[ 0 ].Tex->Texture, Flag )
	}
	else
	{
		DRAWPREP_NOTEX( Flag )
	}

	// FVF̃ZbgAbv
	switch( VertexBuffer->Type )
	{
	case DX_VERTEX_TYPE_NORMAL_3D:
		SETFVF( VERTEXFVF_3D_LIGHT )
		break;
	}

	// v~eBu̐擾
	PrimitiveCount = GETPRIMNUM( PrimitiveType, UseVertexNum ) ;

	// `
	if( VertexBuffer->Direct3DBuffer != NULL )
	{
		GraphicsDevice_SetStreamSource(
			0,
			VertexBuffer->Direct3DBuffer,
			0,
			VertexBuffer->UnitSize ) ;

		GraphicsDevice_DrawPrimitive(
			( D_D3DPRIMITIVETYPE )PrimitiveType,
			StartVertex,
			PrimitiveCount ) ;
	}
	else
	{
		GraphicsDevice_DrawPrimitiveUP(
			( D_D3DPRIMITIVETYPE )PrimitiveType,
			PrimitiveCount,
			( BYTE * )VertexBuffer->Buffer + StartVertex * VertexBuffer->UnitSize,
			VertexBuffer->UnitSize ) ;
	}

	// I
	return 0 ;
}

static int DrawIndexedPrimitiveLight_UseVertexBufferHardware(
	VERTEXBUFFERHANDLEDATA *	VertexBuffer,
	INDEXBUFFERHANDLEDATA *		IndexBuffer,
	int							PrimitiveType,
	int							BaseVertex,
	int							StartVertex,
	int							UseVertexNum,
	int							StartIndex,
	int							UseIndexNum,
	IMAGEDATA2 *				Image2,
	int							TransFlag
)
{
	int Flag ;
	int PrimitiveCount ;
	D_D3DFORMAT IndexFormat ;

	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	// `̏
	RenderVertexHardware() ;
	BeginScene() ;
	SetBlendTextureHardware( NULL ) ;

	Flag = TransFlag | DRAWPREP_GOURAUDSHADE | DRAWPREP_PERSPECTIVE | DRAWPREP_DIFFUSERGB | DRAWPREP_DIFFUSEALPHA | DRAWPREP_FOG | DRAWPREP_LIGHTING | DRAWPREP_SPECULAR | DRAWPREP_3D | DRAWPREP_TEXADDRESS | DRAWPREP_CULLING ;
	if( Image2 )
	{
		DRAWPREP_TEX( Image2->Orig, Image2->Hard.Draw[ 0 ].Tex->Texture, Flag )
	}
	else
	{
		DRAWPREP_NOTEX( Flag )
	}

	// FVF̃ZbgAbv
	switch( VertexBuffer->Type )
	{
	case DX_VERTEX_TYPE_NORMAL_3D:
		SETFVF( VERTEXFVF_3D_LIGHT )
		break ;
	}

	// CfbNX^CvZbg
	IndexFormat = D_D3DFMT_INDEX16 ;
	switch( IndexBuffer->Type )
	{
	case DX_INDEX_TYPE_16BIT:
		IndexFormat = D_D3DFMT_INDEX16 ;
		break ;

	case DX_INDEX_TYPE_32BIT:
		IndexFormat = D_D3DFMT_INDEX32 ;
		break ;
	}

	// v~eBu̐擾
	PrimitiveCount = GETPRIMNUM( PrimitiveType, UseIndexNum ) ;

	// `
	if( VertexBuffer->Direct3DBuffer != NULL &&
		IndexBuffer->Direct3DBuffer  != NULL )
	{
		GraphicsDevice_SetStreamSource(
			0,
			VertexBuffer->Direct3DBuffer,
			0,
			VertexBuffer->UnitSize ) ;
		GraphicsDevice_SetIndices( IndexBuffer->Direct3DBuffer ) ;

		GraphicsDevice_DrawIndexedPrimitive(
			( D_D3DPRIMITIVETYPE )PrimitiveType,
			BaseVertex,
			StartVertex,
			UseVertexNum,
			StartIndex,
			PrimitiveCount ) ;
	}
	else
	{
		GraphicsDevice_DrawIndexedPrimitiveUP(
			( D_D3DPRIMITIVETYPE )PrimitiveType,
			StartVertex,
			UseVertexNum,
			PrimitiveCount,
			( BYTE * )IndexBuffer->Buffer + StartIndex * IndexBuffer->UnitSize,
			IndexFormat, 
			( BYTE * )VertexBuffer->Buffer + BaseVertex * VertexBuffer->UnitSize,
			VertexBuffer->UnitSize ) ;
	}

	// I
	return 0 ;
}

static int DrawPrimitive2DHardware( VERTEX_2D *Vertex, int VertexNum, int PrimitiveType, IMAGEDATA2 *Image2, int TransFlag, int BillboardFlag, int Is3D, int TurnFlag, int TextureNo )
{
	int Flag ;
	int i ;
	VERTEX_2D *Vert ;

	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	// `̏
	RenderVertexHardware() ;
	BeginScene() ;
	SetBlendTextureHardware( NULL ) ;

	if( BillboardFlag == TRUE )
	{
		Flag = TransFlag | ( Is3D ? DRAWPREP_3D | DRAWPREP_FOG : 0 ) | DRAWPREP_TEXADDRESS ;
	}
	else
	{
		Flag = TransFlag | ( Is3D ? DRAWPREP_3D | DRAWPREP_FOG : 0 ) | DRAWPREP_GOURAUDSHADE | DRAWPREP_PERSPECTIVE | DRAWPREP_DIFFUSERGB | DRAWPREP_DIFFUSEALPHA | DRAWPREP_TEXADDRESS | DRAWPREP_CULLING ;
	}
	if( Image2 )
	{
		DRAWPREP_TEX( Image2->Orig, Image2->Hard.Draw[ TextureNo ].Tex->Texture, Flag )
	}
	else
	{
		DRAWPREP_NOTEX( Flag )
	}

	// r{[h̏ꍇ͂tulT[tFXf[^擾
	if( BillboardFlag == TRUE )
	{
		float tu1, tv1, tu2, tv2 ;
		int Num ;
		
		Vert = Vertex ;
		Num = VertexNum / 6 ;
		tu1 = Image2->Hard.Draw[ 0 ].Vertex[ 0 ].u ;
		tv1 = Image2->Hard.Draw[ 0 ].Vertex[ 0 ].v ;
		tu2 = Image2->Hard.Draw[ 0 ].Vertex[ 3 ].u ;
		tv2 = Image2->Hard.Draw[ 0 ].Vertex[ 3 ].v ;
		for( i = 0 ; i < Num ; i ++, Vert += 6 )
		{
			if( TurnFlag )
			{
				Vert[ 0 ].u = tu2 ;
				Vert[ 1 ].u = tu1 ;
				Vert[ 2 ].u = tu2 ;
				Vert[ 3 ].u = tu1 ;
			}
			else
			{
				Vert[ 0 ].u = tu1 ;
				Vert[ 1 ].u = tu2 ;
				Vert[ 2 ].u = tu1 ;
				Vert[ 3 ].u = tu2 ;
			}
			Vert[ 0 ].v = tv1 ;
			Vert[ 1 ].v = tv1 ;
			Vert[ 2 ].v = tv2 ;
			Vert[ 3 ].v = tv2 ;

			Vert[ 4 ].u = Vert[ 2 ].u ;
			Vert[ 4 ].v = Vert[ 2 ].v ;
			Vert[ 5 ].u = Vert[ 1 ].u ;
			Vert[ 5 ].v = Vert[ 1 ].v ;
		}
	}

	if( GRH.UseAlphaChDrawShader )
	{
		Vert = Vertex ;
		for( i = 0 ; i < VertexNum ; i ++, Vert ++ )
		{
			Vert->sc_u = ( Vert->pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
			Vert->sc_v = ( Vert->pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
		}
	}

	// `
	SETFVF( VERTEXFVF_2D )
	GraphicsDevice_DrawPrimitiveUP( ( D_D3DPRIMITIVETYPE )PrimitiveType, GETPRIMNUM( PrimitiveType, VertexNum ), Vertex, sizeof( VERTEX_2D ) ) ;

	// I
	return 0 ;
}

static int	DrawIndexedPrimitive2DHardware( VERTEX_2D *Vertex, int VertexNum, WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA2 *Image2, int TransFlag )
{
	int Flag ;
	int i ;

	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	// `̏
	RenderVertexHardware() ;
	BeginScene() ;
	SetBlendTextureHardware( NULL ) ;

	Flag = TransFlag | DRAWPREP_GOURAUDSHADE | DRAWPREP_PERSPECTIVE | DRAWPREP_DIFFUSERGB | DRAWPREP_DIFFUSEALPHA | DRAWPREP_TEXADDRESS | DRAWPREP_CULLING ;
	if( Image2 )
	{
		DRAWPREP_TEX( Image2->Orig, Image2->Hard.Draw[ 0 ].Tex->Texture, Flag )
	}
	else
	{
		DRAWPREP_NOTEX( Flag )
	}

	if( GRH.UseAlphaChDrawShader )
	{
		for( i = 0 ; i < VertexNum ; i ++ )
		{
			Vertex[ i ].sc_u = ( Vertex[ i ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
			Vertex[ i ].sc_v = ( Vertex[ i ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
		}
	}

	// `
	SETFVF( VERTEXFVF_2D )
	GraphicsDevice_DrawIndexedPrimitiveUP( ( D_D3DPRIMITIVETYPE )PrimitiveType, 0, VertexNum, GETPRIMNUM( PrimitiveType, IndexNum ), Indices, D_D3DFMT_INDEX16, Vertex, sizeof( VERTEX_2D ) ) ;

	// I
	return 0 ;
}

static int DrawPrimitive2DUserHardware( const VERTEX2D *Vertex, int VertexNum, int PrimitiveType, IMAGEDATA2 *Image2, int TransFlag, int Is3D, int TurnFlag, int TextureNo )
{
	int Flag ;

	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	// `̏
	RenderVertexHardware() ;
	BeginScene() ;
	SetBlendTextureHardware( NULL ) ;

	Flag = TransFlag | ( Is3D ? DRAWPREP_3D | DRAWPREP_FOG : 0 ) | DRAWPREP_GOURAUDSHADE | DRAWPREP_PERSPECTIVE | DRAWPREP_DIFFUSERGB | DRAWPREP_DIFFUSEALPHA | DRAWPREP_TEXADDRESS | DRAWPREP_CULLING ;
	if( Image2 )
	{
		DRAWPREP_TEX( Image2->Orig, Image2->Hard.Draw[ TextureNo ].Tex->Texture, Flag )
	}
	else
	{
		DRAWPREP_NOTEX( Flag )
	}

	// `
	SETFVF( VERTEXFVF_2D_USER )
	GraphicsDevice_DrawPrimitiveUP( ( D_D3DPRIMITIVETYPE )PrimitiveType, GETPRIMNUM( PrimitiveType, VertexNum ), Vertex, sizeof( VERTEX2D ) ) ;

	// I
	return 0 ;
}

static int DrawPrimitive2DUserHardware_Billboard( VERTEX2D *Vertex, int VertexNum, int PrimitiveType, IMAGEDATA2 *Image2, int TransFlag, int Is3D, int TurnFlag, int TextureNo )
{
	int Flag ;
	int i ;
	VERTEX2D *Vert ;

	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	// `̏
	RenderVertexHardware() ;
	BeginScene() ;
	SetBlendTextureHardware( NULL ) ;

	Flag = TransFlag | ( Is3D ? DRAWPREP_3D | DRAWPREP_FOG : 0 ) | DRAWPREP_TEXADDRESS ;
	if( Image2 )
	{
		DRAWPREP_TEX( Image2->Orig, Image2->Hard.Draw[ TextureNo ].Tex->Texture, Flag )
	}
	else
	{
		DRAWPREP_NOTEX( Flag )
	}

	// r{[h̏ꍇ͂tulT[tFXf[^擾
	{
		float tu1, tv1, tu2, tv2 ;
		int Num ;
		
		Vert = Vertex ;
		Num = VertexNum / 6 ;
		tu1 = Image2->Hard.Draw[ 0 ].Vertex[ 0 ].u ;
		tv1 = Image2->Hard.Draw[ 0 ].Vertex[ 0 ].v ;
		tu2 = Image2->Hard.Draw[ 0 ].Vertex[ 3 ].u ;
		tv2 = Image2->Hard.Draw[ 0 ].Vertex[ 3 ].v ;
		for( i = 0 ; i < Num ; i ++, Vert += 6 )
		{
			if( TurnFlag )
			{
				Vert[ 0 ].u = tu2 ;
				Vert[ 1 ].u = tu1 ;
				Vert[ 2 ].u = tu2 ;
				Vert[ 3 ].u = tu1 ;
			}
			else
			{
				Vert[ 0 ].u = tu1 ;
				Vert[ 1 ].u = tu2 ;
				Vert[ 2 ].u = tu1 ;
				Vert[ 3 ].u = tu2 ;
			}
			Vert[ 0 ].v = tv1 ;
			Vert[ 1 ].v = tv1 ;
			Vert[ 2 ].v = tv2 ;
			Vert[ 3 ].v = tv2 ;

			Vert[ 4 ].u = Vert[ 2 ].u ;
			Vert[ 4 ].v = Vert[ 2 ].v ;
			Vert[ 5 ].u = Vert[ 1 ].u ;
			Vert[ 5 ].v = Vert[ 1 ].v ;
		}
	}

	// `
	SETFVF( VERTEXFVF_2D_USER )
	GraphicsDevice_DrawPrimitiveUP( ( D_D3DPRIMITIVETYPE )PrimitiveType, GETPRIMNUM( PrimitiveType, VertexNum ), Vertex, sizeof( VERTEX2D ) ) ;

	// I
	return 0 ;
}

static int	DrawIndexedPrimitive2DUserHardware( const VERTEX2D *Vertex, int VertexNum, const WORD *Indices, int IndexNum, int PrimitiveType, IMAGEDATA2 *Image2, int TransFlag )
{
	int Flag ;

	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	// `̏
	RenderVertexHardware() ;
	BeginScene() ;
	SetBlendTextureHardware( NULL ) ;

	Flag = TransFlag | DRAWPREP_GOURAUDSHADE | DRAWPREP_PERSPECTIVE | DRAWPREP_DIFFUSERGB | DRAWPREP_DIFFUSEALPHA | DRAWPREP_TEXADDRESS | DRAWPREP_CULLING ;
	if( Image2 )
	{
		DRAWPREP_TEX( Image2->Orig, Image2->Hard.Draw[ 0 ].Tex->Texture, Flag )
	}
	else
	{
		DRAWPREP_NOTEX( Flag )
	}

	// `
	SETFVF( VERTEXFVF_2D_USER )
	GraphicsDevice_DrawIndexedPrimitiveUP( ( D_D3DPRIMITIVETYPE )PrimitiveType, 0, VertexNum, GETPRIMNUM( PrimitiveType, IndexNum ), Indices, D_D3DFMT_INDEX16, Vertex, sizeof( VERTEX2D ) ) ;

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawLine
static int	DrawLineHardware( int x1, int y1, int x2, int y2, int Color )
{
	VERTEX_NOTEX_2D *VectData ;
	int Red, Green, Blue, Flag ;
	DWORD drawz ;

	if( GraphicsDevice_IsValid() == 0 ) return -1 ; 

	if( x2 - x1 == 0 && y2 - y1 == 0 ) return 0 ; 

	// `̏
	if( GRH.BeginSceneFlag == FALSE ) BeginScene() ;
	if( GRH.RenderTexture != NULL ) SetTextureHardware( NULL ) ;
	Flag = DRAWPREP_DIFFUSERGB ;
	DRAWPREP_NOTEX( Flag )

	// yobt@ɏނylZbg
	drawz = *((DWORD *)&GBASE.DrawZ);

	// FZbg
	GETVERTEX_LINE( VectData ) ;
	NS_GetColor2( Color, &Red, &Green, &Blue ) ;
	Color = ( ( ( ( (	GRH.DiffuseColor & 0xff0000 ) >> 16 ) * Red )	/ 255 ) << 16 ) |
			( ( ( ( (	GRH.DiffuseColor & 0x00ff00 ) >> 8  ) * Green )	/ 255 ) << 8 ) |
			( ( ( (		GRH.DiffuseColor & 0x0000ff )       ) * Blue )	/ 255 ) | 
			(			GRH.DiffuseColor & 0xff000000 ) ;
	VectData[ 0 ].color = Color ;
	VectData[ 1 ].color = Color ;
	*((DWORD *)&VectData[ 0 ].pos.z) = drawz;
	*((DWORD *)&VectData[ 1 ].pos.z) = drawz;

	// WZbg
	VectData[ 0 ].pos.x = ( float )( x1 ) ;
	VectData[ 0 ].pos.y = ( float )( y1 ) ;

	VectData[ 1 ].pos.x = ( float )( x2 ) ;
	VectData[ 1 ].pos.y = ( float )( y2 ) ;

	// W̕␳
	if( x1 == x2 ) VectData[ 1 ].pos.y += y2 > y1 ? -0.1F : 0.1F ;
	if( y1 == y2 ) VectData[ 1 ].pos.x += x2 > x1 ? -0.1F : 0.1F ;

	if( GRH.UseAlphaChDrawShader )
	{
		VectData[ 0 ].sc_u = ( VectData[ 0 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		VectData[ 0 ].sc_v = ( VectData[ 0 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
		VectData[ 1 ].sc_u = ( VectData[ 1 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		VectData[ 1 ].sc_v = ( VectData[ 1 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
	}

	// _̒ǉ
	ADD4VERTEX_LINE

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawLine3D
static int	DrawLine3DHardware( VECTOR Pos1, VECTOR Pos2, int Color, int DrawFlag, RECT *DrawArea )
{
	VERTEX_NOTEX_3D *VectData ;
	int Red, Green, Blue, Flag ;

	if( DrawFlag )
	{
		if( GraphicsDevice_IsValid() == 0 ) return -1 ; 

		// `̏
		if( GRH.BeginSceneFlag == FALSE ) BeginScene() ;
		if( GRH.RenderTexture != NULL ) SetTextureHardware( NULL ) ;

		Flag = DRAWPREP_DIFFUSERGB | DRAWPREP_3D | DRAWPREP_FOG ;
		DRAWPREP_NOTEX( Flag )

		GETVERTEX_LINE3D( VectData ) ;

		// FZbg
		NS_GetColor2( Color, &Red, &Green, &Blue ) ;
		Color = ( ( ( ( (	GRH.DiffuseColor & 0xff0000 ) >> 16 ) * Red )	/ 255 ) << 16 ) |
				( ( ( ( (	GRH.DiffuseColor & 0x00ff00 ) >> 8  ) * Green )	/ 255 ) << 8 ) |
				( ( ( (		GRH.DiffuseColor & 0x0000ff )       ) * Blue )	/ 255 ) | 
				(			GRH.DiffuseColor & 0xff000000 ) ;
		*( ( int * )&VectData[ 0 ].b ) = Color ;
		*( ( int * )&VectData[ 1 ].b ) = Color ;

		// WZbg
		VectData[ 0 ].pos = Pos1 ;
		VectData[ 1 ].pos = Pos2 ;

		// _̒ǉ
		ADD4VERTEX_LINE3D
	}
	else
	{
		VERTEX_2D TempVect[ 2 ] ;
		float dleft, dright, dtop, dbottom ;

		dleft   = -100000000.0f ;
		dright  =  100000000.0f ;
		dtop    = -100000000.0f ;
		dbottom =  100000000.0f ;

		// XN[Wɕϊ
		TempVect[0].pos.x = Pos1.x * GBASE.BlendMatrix.m[0][0] + Pos1.y * GBASE.BlendMatrix.m[1][0] + Pos1.z * GBASE.BlendMatrix.m[2][0] + GBASE.BlendMatrix.m[3][0]  ;
		TempVect[0].pos.y = Pos1.x * GBASE.BlendMatrix.m[0][1] + Pos1.y * GBASE.BlendMatrix.m[1][1] + Pos1.z * GBASE.BlendMatrix.m[2][1] + GBASE.BlendMatrix.m[3][1]  ;
		TempVect[0].pos.z = Pos1.x * GBASE.BlendMatrix.m[0][2] + Pos1.y * GBASE.BlendMatrix.m[1][2] + Pos1.z * GBASE.BlendMatrix.m[2][2] + GBASE.BlendMatrix.m[3][2]  ;
		TempVect[0].rhw   = Pos1.x * GBASE.BlendMatrix.m[0][3] + Pos1.y * GBASE.BlendMatrix.m[1][3] + Pos1.z * GBASE.BlendMatrix.m[2][3] + GBASE.BlendMatrix.m[3][3]  ;

		TempVect[1].pos.x = Pos2.x * GBASE.BlendMatrix.m[0][0] + Pos2.y * GBASE.BlendMatrix.m[1][0] + Pos2.z * GBASE.BlendMatrix.m[2][0] + GBASE.BlendMatrix.m[3][0]  ;
		TempVect[1].pos.y = Pos2.x * GBASE.BlendMatrix.m[0][1] + Pos2.y * GBASE.BlendMatrix.m[1][1] + Pos2.z * GBASE.BlendMatrix.m[2][1] + GBASE.BlendMatrix.m[3][1]  ;
		TempVect[1].pos.z = Pos2.x * GBASE.BlendMatrix.m[0][2] + Pos2.y * GBASE.BlendMatrix.m[1][2] + Pos2.z * GBASE.BlendMatrix.m[2][2] + GBASE.BlendMatrix.m[3][2]  ;
		TempVect[1].rhw   = Pos2.x * GBASE.BlendMatrix.m[0][3] + Pos2.y * GBASE.BlendMatrix.m[1][3] + Pos2.z * GBASE.BlendMatrix.m[2][3] + GBASE.BlendMatrix.m[3][3]  ;

		TempVect[0].rhw = 1.0F / TempVect[0].rhw ;
		TempVect[0].pos.x *= TempVect[0].rhw ;
		TempVect[0].pos.y *= TempVect[0].rhw ;
		TempVect[0].pos.z *= TempVect[0].rhw ;

		TempVect[1].rhw = 1.0F / TempVect[1].rhw ;
		TempVect[1].pos.x *= TempVect[1].rhw ;
		TempVect[1].pos.y *= TempVect[1].rhw ;
		TempVect[1].pos.z *= TempVect[1].rhw ;

		if( dright  > TempVect[ 0 ].pos.x ) dright  = TempVect[ 0 ].pos.x ;
		if( dright  > TempVect[ 1 ].pos.x ) dright  = TempVect[ 1 ].pos.x ;

		if( dleft   < TempVect[ 0 ].pos.x ) dleft   = TempVect[ 0 ].pos.x ;
		if( dleft   < TempVect[ 1 ].pos.x ) dleft   = TempVect[ 1 ].pos.x ;

		if( dbottom > TempVect[ 0 ].pos.y ) dbottom = TempVect[ 0 ].pos.y ;
		if( dbottom > TempVect[ 1 ].pos.y ) dbottom = TempVect[ 1 ].pos.y ;

		if( dtop    < TempVect[ 0 ].pos.y ) dtop    = TempVect[ 0 ].pos.y ;
		if( dtop    < TempVect[ 1 ].pos.y ) dtop    = TempVect[ 1 ].pos.y ;

		DrawArea->left   = _FTOL( dleft   ) - 1 ;
		DrawArea->right  = _FTOL( dright  ) + 1 ;
		DrawArea->top    = _FTOL( dtop    ) - 1 ;
		DrawArea->bottom = _FTOL( dbottom ) + 1 ;
	}

	// I
	return 0 ;
}

#define DX_CIRCLE_THICKNESS_R_MAX_LEFT_CHECK									\
	if( y1 >= DrawRect.top && y1 < DrawRect.bottom )							\
	{																			\
		if( ( CirclePos[ y1 ][ 4 ] & 1 ) == 0 || CirclePos[ y1 ][ 0 ] > x1 )	\
		{																		\
			CirclePos[ y1 ][ 4 ] |= 1 ;											\
			CirclePos[ y1 ][ 0 ] = x1 ;											\
		}																		\
	}

#define DX_CIRCLE_THICKNESS_R_MAX_RIGHT_CHECK									\
	if( y1 >= DrawRect.top && y1 < DrawRect.bottom )							\
	{																			\
		if( ( CirclePos[ y1 ][ 4 ] & 2 ) == 0 || CirclePos[ y1 ][ 1 ] < x1 )	\
		{																		\
			CirclePos[ y1 ][ 4 ] |= 2 ;											\
			CirclePos[ y1 ][ 1 ] = x1 ;											\
		}																		\
	}

#define DX_CIRCLE_THICKNESS_R_MIN_LEFT_CHECK									\
	if( y1 >= DrawRect.top && y1 < DrawRect.bottom )							\
	{																			\
		if( ( CirclePos[ y1 ][ 4 ] & 4 ) == 0 || CirclePos[ y1 ][ 2 ] < x1 )	\
		{																		\
			CirclePos[ y1 ][ 4 ] |= 4 ;											\
			CirclePos[ y1 ][ 2 ] = x1 ;											\
		}																		\
	}

#define DX_CIRCLE_THICKNESS_R_MIN_RIGHT_CHECK									\
	if( y1 >= DrawRect.top && y1 < DrawRect.bottom )							\
	{																			\
		if( ( CirclePos[ y1 ][ 4 ] & 8 ) == 0 || CirclePos[ y1 ][ 3 ] > x1 )	\
		{																		\
			CirclePos[ y1 ][ 4 ] |= 8 ;											\
			CirclePos[ y1 ][ 3 ] = x1 ;											\
		}																		\
	}

// ̕t~̕`p_擾֐
static int	GetCircle_ThicknessDrawPosition( int x, int y, int r, int Thickness, short ( *CirclePos )[ 5 ] )
{
	int rmax, rmin ;
	int x1, y1 ;
	int Dx, Dy, F ;
	RECT DrawRect ;

	DrawRect = GBASE.DrawArea ;

	// ȇZo
	rmax = r + Thickness / 2 ;
	rmin = r - Thickness / 2 ;
	if( rmax - rmin + 1 > Thickness )
	{
		rmin ++ ;
	}

	// O~̍WXg쐬
	{
		// lZbg
		Dx = rmax ; Dy = 0 ; F = -2 * rmax + 3 ;

		// ŏ̓_
		{
			x1 = -Dx + x ; y1 = Dy + y ;
			DX_CIRCLE_THICKNESS_R_MAX_LEFT_CHECK ;
			x1 = Dx + x ;  
			DX_CIRCLE_THICKNESS_R_MAX_RIGHT_CHECK ;

			x1 = Dy + x ; y1 = Dx + y ;
			DX_CIRCLE_THICKNESS_R_MAX_LEFT_CHECK ;
			DX_CIRCLE_THICKNESS_R_MAX_RIGHT_CHECK ;

			x1 = Dy + x ; y1 = -Dx + y;
			DX_CIRCLE_THICKNESS_R_MAX_LEFT_CHECK ;
			DX_CIRCLE_THICKNESS_R_MAX_RIGHT_CHECK ;

			// Wf[^i߂
			if( F >= 0 )
			{
				Dx -- ;
				F -= 4 * Dx ;
			}	

			Dy ++ ;
			F += 4 * Dy + 2 ;
		}

		while( Dx >= Dy )
		{
			x1 = -Dx + x ; y1 = Dy + y ;
			DX_CIRCLE_THICKNESS_R_MAX_LEFT_CHECK ;
			x1 = Dx + x ;  
			DX_CIRCLE_THICKNESS_R_MAX_RIGHT_CHECK ;

			x1 = Dy + x ; y1 = Dx + y ;
			DX_CIRCLE_THICKNESS_R_MAX_RIGHT_CHECK ;
			x1 = -Dy + x ; 
			DX_CIRCLE_THICKNESS_R_MAX_LEFT_CHECK ;
		
			x1 = Dx + x ; y1 = -Dy + y;
			DX_CIRCLE_THICKNESS_R_MAX_RIGHT_CHECK ;
			x1 = -Dx + x ; 
			DX_CIRCLE_THICKNESS_R_MAX_LEFT_CHECK ;

			x1 = Dy + x ; y1 = -Dx + y;
			DX_CIRCLE_THICKNESS_R_MAX_RIGHT_CHECK ;
			x1 = -Dy + x ; 
			DX_CIRCLE_THICKNESS_R_MAX_LEFT_CHECK ;

			// Wf[^i߂
			if( F >= 0 )
			{
				Dx -- ;
				F -= 4 * Dx ;
			}

			Dy ++ ;
			F += 4 * Dy + 2 ;
		}
	}

	// ~̍WXg쐬
	{
		// lZbg
		Dx = rmin ; Dy = 0 ; F = -2 * rmin + 3 ;

		// ŏ̓_
		{
			x1 = -Dx + x ; y1 = Dy + y ;
			DX_CIRCLE_THICKNESS_R_MIN_LEFT_CHECK ;
			x1 = Dx + x ;  
			DX_CIRCLE_THICKNESS_R_MIN_RIGHT_CHECK ;

			x1 = Dy + x ; y1 = Dx + y ;
			DX_CIRCLE_THICKNESS_R_MIN_LEFT_CHECK ;
			DX_CIRCLE_THICKNESS_R_MIN_RIGHT_CHECK ;

			x1 = Dy + x ; y1 = -Dx + y;
			DX_CIRCLE_THICKNESS_R_MIN_LEFT_CHECK ;
			DX_CIRCLE_THICKNESS_R_MIN_RIGHT_CHECK ;

			// Wf[^i߂
			if( F >= 0 )
			{
				Dx -- ;
				F -= 4 * Dx ;
			}	

			Dy ++ ;
			F += 4 * Dy + 2 ;
		}

		while( Dx >= Dy )
		{
			x1 = -Dx + x ; y1 = Dy + y ;
			DX_CIRCLE_THICKNESS_R_MIN_LEFT_CHECK ;
			x1 = Dx + x ;  
			DX_CIRCLE_THICKNESS_R_MIN_RIGHT_CHECK ;

			x1 = Dy + x ; y1 = Dx + y ;
			DX_CIRCLE_THICKNESS_R_MIN_RIGHT_CHECK ;
			x1 = -Dy + x ; 
			DX_CIRCLE_THICKNESS_R_MIN_LEFT_CHECK ;
		
			x1 = Dx + x ; y1 = -Dy + y;
			DX_CIRCLE_THICKNESS_R_MIN_RIGHT_CHECK ;
			x1 = -Dx + x ; 
			DX_CIRCLE_THICKNESS_R_MIN_LEFT_CHECK ;

			x1 = Dy + x ; y1 = -Dx + y;
			DX_CIRCLE_THICKNESS_R_MIN_RIGHT_CHECK ;
			x1 = -Dy + x ; 
			DX_CIRCLE_THICKNESS_R_MIN_LEFT_CHECK ;

			// Wf[^i߂
			if( F >= 0 )
			{
				Dx -- ;
				F -= 4 * Dx ;
			}

			Dy ++ ;
			F += 4 * Dy + 2 ;
		}
	}

	// I
	return 0 ;
}

// ̕tȉ~̕`p_擾֐
static int	GetOval_ThicknessDrawPosition( int x, int y, int rx, int ry, int Thickness, short ( *CirclePos )[ 5 ] )
{
	int x1, y1 ;
	int Dx, Dy, F, H, Df, yc, xc, rc, r ;
	int rxmax, rymax ;
	int rxmin, rymin ;
	RECT DrawRect ;

	DrawRect = GBASE.DrawArea ;

	// ȇZo
	rxmax = rx + Thickness / 2 ;
	rxmin = rx - Thickness / 2 ;
	if( rxmax - rxmin + 1 > Thickness )
	{
		rxmin ++ ;
	}
	rymax = ry + Thickness / 2 ;
	rymin = ry - Thickness / 2 ;
	if( rymax - rymin + 1 > Thickness )
	{
		rymin ++ ;
	}

	// O~̍WXg쐬
	{
		if( rxmax >= rymax )
		{
			// lZbg
			rc = ( rxmax * rxmax ) / rymax ;

			xc = 0 ; yc = 0 ;
			r = rxmax ;
			Df = 2 ;
	
			Dx = r ;
			Dy = 0;
			F = -2 * r + 1 + 2 * 1;
			H = -4 * r + 2 + 1;

			// ŏ̓_`
			{
				x1 = -Dx + x ; y1 = Dy + y ;
				DX_CIRCLE_THICKNESS_R_MAX_LEFT_CHECK ;
				x1 = Dx + x ;  
				DX_CIRCLE_THICKNESS_R_MAX_RIGHT_CHECK ;

				Df = 0 ;

				// Wf[^i߂
				if( F < 0 )
				{
					yc += rymax ;
					if( yc >= rc )
					{
						Dy ++ ;
						yc -= rc ;
						Df = 1 ;
					}
					F += 4 * Dy + 2 ;
					H += 4 * Dy;
				}
				else
				{
					Df = 1 ;

					if( H>=0 )
					{
						Dx--;
						F -= 4 * Dx;
						H -= 4 * Dx - 2 ;
					}
					else
					{
						Dx--;	
						yc += rymax ;
						if( yc >= rc )
						{
							Dy ++ ;
							yc -= rc ;
							Df = 1 ;
						}
						F += 4 * Dy - 4 * Dx + 2 ;
						H += 4 * Dy - 4 * Dx + 2 ;
					}
				}
			}

			while( Dx > 0 )
			{
				if( Df )
				{
					x1 = -Dx + x ; y1 = Dy + y ;
					DX_CIRCLE_THICKNESS_R_MAX_LEFT_CHECK ;
					x1 = Dx + x ;  
					DX_CIRCLE_THICKNESS_R_MAX_RIGHT_CHECK ;

					x1 = -Dx + x ; y1 = -Dy + y ;
					DX_CIRCLE_THICKNESS_R_MAX_LEFT_CHECK ;
					x1 = Dx + x ;  
					DX_CIRCLE_THICKNESS_R_MAX_RIGHT_CHECK ;
				}

				Df = 0 ;

				// Wf[^i߂
				if( F < 0 )
				{
					yc += rymax ;
					if( yc >= rc )
					{
						Dy ++ ;
						yc -= rc ;
						Df = 1 ;
					}
					F += 4 * Dy + 2 ;
					H += 4 * Dy;
				}
				else
				{
					Df = 1 ;

					if( H>=0 )
					{
						Dx--;
						F -= 4 * Dx;
						H -= 4 * Dx - 2 ;
					}
					else
					{
						Dx--;	
						yc += rymax ;
						if( yc >= rc )
						{
							Dy ++ ;
							yc -= rc ;
							Df = 1 ;
						}
						F += 4 * Dy - 4 * Dx + 2 ;
						H += 4 * Dy - 4 * Dx + 2 ;
					}
				}
			}

			// Ō̓_`
			x1 = Dx + x ; y1 = -Dy + y;
			DX_CIRCLE_THICKNESS_R_MAX_RIGHT_CHECK ;

			x1 = -Dx + x ; y1 = Dy + y ;
			DX_CIRCLE_THICKNESS_R_MAX_LEFT_CHECK ;
		}
		else
		{
			// lZbg
			rc = ( rymax * rymax ) / rxmax ;

			xc = 0 ; yc = 0 ;
			r = rxmax ;
			Df = 2 ;
	
			Dx = r ;
			Dy = 0;
			F = -2 * r + 1 + 2 * 1;
			H = -4 * r + 2 + 1;

			// ŏ̓_`
			{
				x1 = -Dx + x ; y1 = Dy + y ;
				DX_CIRCLE_THICKNESS_R_MAX_LEFT_CHECK ;
				x1 = Dx + x ;  
				DX_CIRCLE_THICKNESS_R_MAX_RIGHT_CHECK ;

				Df = 0 ;

				// Wf[^i߂
				if( F < 0 )
				{
					Df = 1 ;

					Dy ++ ;
					F += 4 * Dy + 2 ;
					H += 4 * Dy;
				}
				else
				{
					if( H>=0 )
					{
						xc += rxmax ;
						if( xc >= rc )
						{
							Dx--;
							xc -= rc ;
							Df = 1 ;
						}
						F -= 4 * Dx;
						H -= 4 * Dx - 2 ;
					}
					else
					{
						Df = 1 ;

						xc += rxmax ;
						if( xc >= rc )
						{
							Dx--;
							xc -= rc ;
						}

						Dy ++ ;
						F += 4 * Dy - 4 * Dx + 2 ;
						H += 4 * Dy - 4 * Dx + 2 ;
					}
				}
			}

			while( Dx > 0 )
			{
				if( Df )
				{
					x1 = -Dx + x ; y1 = Dy + y ;
					DX_CIRCLE_THICKNESS_R_MAX_LEFT_CHECK ;
					x1 = Dx + x ;  
					DX_CIRCLE_THICKNESS_R_MAX_RIGHT_CHECK ;

					x1 = -Dx + x ; y1 = -Dy + y ;
					DX_CIRCLE_THICKNESS_R_MAX_LEFT_CHECK ;
					x1 = Dx + x ;  
					DX_CIRCLE_THICKNESS_R_MAX_RIGHT_CHECK ;
				}

				Df = 0 ;

				// Wf[^i߂
				if( F < 0 )
				{
					Df = 1 ;

					Dy ++ ;
					F += 4 * Dy + 2 ;
					H += 4 * Dy;
				}
				else
				{
					if( H>=0 )
					{
						xc += rxmax ;
						if( xc >= rc )
						{
							Dx--;
							xc -= rc ;
							Df = 1 ;
						}
						F -= 4 * Dx;
						H -= 4 * Dx - 2 ;
					}
					else
					{
						Df = 1 ;

						xc += rxmax ;
						if( xc >= rc )
						{
							Dx--;
							xc -= rc ;
						}

						Dy ++ ;
						F += 4 * Dy - 4 * Dx + 2 ;
						H += 4 * Dy - 4 * Dx + 2 ;
					}
				}
			}

			// Ō̓_`
			x1 = Dx + x ; y1 = -Dy + y;
			DX_CIRCLE_THICKNESS_R_MAX_RIGHT_CHECK ;

			x1 = -Dx + x ; y1 = Dy + y ;
			DX_CIRCLE_THICKNESS_R_MAX_LEFT_CHECK ;
		}
	}

	// ~̍WXg쐬
	{
		if( rxmin >= rymin )
		{
			// lZbg
			rc = ( rxmin * rxmin ) / rymin ;

			xc = 0 ; yc = 0 ;
			r = rxmin ;
			Df = 2 ;
	
			Dx = r ;
			Dy = 0;
			F = -2 * r + 1 + 2 * 1;
			H = -4 * r + 2 + 1;

			// ŏ̓_`
			{
				x1 = -Dx + x ; y1 = Dy + y ;
				DX_CIRCLE_THICKNESS_R_MIN_LEFT_CHECK ;
				x1 = Dx + x ;  
				DX_CIRCLE_THICKNESS_R_MIN_RIGHT_CHECK ;

				Df = 0 ;

				// Wf[^i߂
				if( F < 0 )
				{
					yc += rymin ;
					if( yc >= rc )
					{
						Dy ++ ;
						yc -= rc ;
						Df = 1 ;
					}
					F += 4 * Dy + 2 ;
					H += 4 * Dy;
				}
				else
				{
					Df = 1 ;

					if( H>=0 )
					{
						Dx--;
						F -= 4 * Dx;
						H -= 4 * Dx - 2 ;
					}
					else
					{
						Dx--;	
						yc += rymin ;
						if( yc >= rc )
						{
							Dy ++ ;
							yc -= rc ;
							Df = 1 ;
						}
						F += 4 * Dy - 4 * Dx + 2 ;
						H += 4 * Dy - 4 * Dx + 2 ;
					}
				}
			}

			while( Dx > 0 )
			{
				if( Df )
				{
					x1 = -Dx + x ; y1 = Dy + y ;
					DX_CIRCLE_THICKNESS_R_MIN_LEFT_CHECK ;
					x1 = Dx + x ;  
					DX_CIRCLE_THICKNESS_R_MIN_RIGHT_CHECK ;

					x1 = -Dx + x ; y1 = -Dy + y ;
					DX_CIRCLE_THICKNESS_R_MIN_LEFT_CHECK ;
					x1 = Dx + x ;  
					DX_CIRCLE_THICKNESS_R_MIN_RIGHT_CHECK ;
				}

				Df = 0 ;

				// Wf[^i߂
				if( F < 0 )
				{
					yc += rymin ;
					if( yc >= rc )
					{
						Dy ++ ;
						yc -= rc ;
						Df = 1 ;
					}
					F += 4 * Dy + 2 ;
					H += 4 * Dy;
				}
				else
				{
					Df = 1 ;

					if( H>=0 )
					{
						Dx--;
						F -= 4 * Dx;
						H -= 4 * Dx - 2 ;
					}
					else
					{
						Dx--;	
						yc += rymin ;
						if( yc >= rc )
						{
							Dy ++ ;
							yc -= rc ;
							Df = 1 ;
						}
						F += 4 * Dy - 4 * Dx + 2 ;
						H += 4 * Dy - 4 * Dx + 2 ;
					}
				}
			}

			// Ō̓_`
			x1 = Dx + x ; y1 = -Dy + y;
			DX_CIRCLE_THICKNESS_R_MIN_RIGHT_CHECK ;

			x1 = -Dx + x ; y1 = Dy + y ;
			DX_CIRCLE_THICKNESS_R_MIN_LEFT_CHECK ;
		}
		else
		{
			// lZbg
			rc = ( rymin * rymin ) / rxmin ;

			xc = 0 ; yc = 0 ;
			r = rxmin ;
			Df = 2 ;
	
			Dx = r ;
			Dy = 0;
			F = -2 * r + 1 + 2 * 1;
			H = -4 * r + 2 + 1;

			// ŏ̓_`
			{
				x1 = -Dx + x ; y1 = Dy + y ;
				DX_CIRCLE_THICKNESS_R_MIN_LEFT_CHECK ;
				x1 = Dx + x ;  
				DX_CIRCLE_THICKNESS_R_MIN_RIGHT_CHECK ;

				Df = 0 ;

				// Wf[^i߂
				if( F < 0 )
				{
					Df = 1 ;

					Dy ++ ;
					F += 4 * Dy + 2 ;
					H += 4 * Dy;
				}
				else
				{
					if( H>=0 )
					{
						xc += rxmin ;
						if( xc >= rc )
						{
							Dx--;
							xc -= rc ;
							Df = 1 ;
						}
						F -= 4 * Dx;
						H -= 4 * Dx - 2 ;
					}
					else
					{
						Df = 1 ;

						xc += rxmin ;
						if( xc >= rc )
						{
							Dx--;
							xc -= rc ;
						}

						Dy ++ ;
						F += 4 * Dy - 4 * Dx + 2 ;
						H += 4 * Dy - 4 * Dx + 2 ;
					}
				}
			}

			while( Dx > 0 )
			{
				if( Df )
				{
					x1 = -Dx + x ; y1 = Dy + y ;
					DX_CIRCLE_THICKNESS_R_MIN_LEFT_CHECK ;
					x1 = Dx + x ;  
					DX_CIRCLE_THICKNESS_R_MIN_RIGHT_CHECK ;

					x1 = -Dx + x ; y1 = -Dy + y ;
					DX_CIRCLE_THICKNESS_R_MIN_LEFT_CHECK ;
					x1 = Dx + x ;  
					DX_CIRCLE_THICKNESS_R_MIN_RIGHT_CHECK ;
				}

				Df = 0 ;

				// Wf[^i߂
				if( F < 0 )
				{
					Df = 1 ;

					Dy ++ ;
					F += 4 * Dy + 2 ;
					H += 4 * Dy;
				}
				else
				{
					if( H>=0 )
					{
						xc += rxmin ;
						if( xc >= rc )
						{
							Dx--;
							xc -= rc ;
							Df = 1 ;
						}
						F -= 4 * Dx;
						H -= 4 * Dx - 2 ;
					}
					else
					{
						Df = 1 ;

						xc += rxmin ;
						if( xc >= rc )
						{
							Dx--;
							xc -= rc ;
						}

						Dy ++ ;
						F += 4 * Dy - 4 * Dx + 2 ;
						H += 4 * Dy - 4 * Dx + 2 ;
					}
				}
			}

			// Ō̓_`
			x1 = Dx + x ; y1 = -Dy + y;
			DX_CIRCLE_THICKNESS_R_MIN_RIGHT_CHECK ;

			x1 = -Dx + x ; y1 = Dy + y ;
			DX_CIRCLE_THICKNESS_R_MIN_LEFT_CHECK ;
		}
	}

	// I
	return 0 ;
}


#define CIRCLE_VERTEX_NUM			(2000)

#define DX_3D_CIRCLE_THICKNESS												\
	if( x1 < DrawRect.left      ) x1 = DrawRect.left ;						\
	if( x2 > DrawRect.right - 1 ) x2 = DrawRect.right - 1 ;					\
																			\
	VectBuf[ VectNum ].pos.x  = ( float )x1 ;								\
	VectBuf[ VectNum ].pos.y  = y1f ;										\
	VectBuf[ VectNum ].color = Color ;										\
	VectBuf[ VectNum ].rhw   = 1.0f ;										\
	*((DWORD *)&VectBuf[ VectNum ].pos.z) = drawz ;							\
	VectNum ++ ;															\
																			\
	VectBuf[ VectNum ].pos.x =  ( float )( x2 + 1 ) ;						\
	VectBuf[ VectNum ].pos.y =  y1f ;										\
	VectBuf[ VectNum ].color = Color ;										\
	VectBuf[ VectNum ].rhw   = 1.0f ;										\
	*((DWORD *)&VectBuf[ VectNum ].pos.z) = drawz ;							\
	VectNum  ++ ;															\
																			\
	if( VectNum >= CIRCLE_VERTEX_NUM )										\
	{																		\
		if( GRH.UseAlphaChDrawShader )										\
		{																	\
			for( j = 0 ; j < VectNum ; j ++ )								\
			{																\
				VectBuf[ j ].sc_u = ( VectBuf[ j ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;\
				VectBuf[ j ].sc_v = ( VectBuf[ j ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;\
			}																\
		}																	\
		GraphicsDevice_DrawPrimitiveUP( D_D3DPT_LINELIST, VectNum / 2, VectBuf, sizeof( VERTEX_NOTEX_2D ) ) ;\
		VectNum = 0 ;														\
	}																		

// n[hEGAANZ[^gp DrawCircle( w肠 )
static int	DrawCircle_ThicknessHardware( int x, int y, int r, int Color, int Thickness )
{
	VERTEX_NOTEX_2D *VectBuf ;
	int VectNum ;
	short ( *CirclePos )[ 5 ] ;
	int Red, Green, Blue, Flag ;
	RECT DrawRect ;
	DWORD drawz ;
	int i ;
	int j ;
	int x1, x2 ;
	float y1f ;

	// Qȉ牽I
	if( Thickness < 2 )
	{
		return -1 ;
	}

	RenderVertexHardware() ;

	if( GraphicsDevice_IsValid() == 0 ) return -1 ; 

	// `p̊m
	if( AllocCommonBuffer( 0, sizeof( VERTEX_NOTEX_2D ) * CIRCLE_VERTEX_NUM ) < 0 )
	{
		return -1 ;
	}
	VectBuf = ( VERTEX_NOTEX_2D * )GRH.CommonBuffer[ 0 ] ;

	// `̏
	BeginScene() ;
	Flag = DRAWPREP_DIFFUSERGB ;
	DRAWPREP_NOTEX( Flag )

	// yobt@ɏނylZbg
	drawz = *((DWORD *)&GBASE.DrawZ);

	// ␳
	DrawRect = GBASE.DrawArea ;

	NS_GetColor2( Color, &Red, &Green, &Blue ) ;
	Color = ( ( ( ( (	GRH.DiffuseColor & 0x00ff0000 ) >> 16 ) * Red )		/ 255 ) << 16 ) |
			( ( ( ( (	GRH.DiffuseColor & 0x0000ff00 ) >> 8  ) * Green )	/ 255 ) << 8 ) |
			( ( ( (		GRH.DiffuseColor & 0x000000ff )       ) * Blue )	/ 255 ) | 
			(			GRH.DiffuseColor & 0xff000000 ) ;

	// FVF ̕ύX
	SETFVF( VERTEXFVF_NOTEX_2D )

	// ~̍Wobt@擾
	if( AllocCommonBuffer( 1, sizeof( short ) * 5 * DrawRect.bottom ) < 0 )
	{
		return -1 ;
	}
	CirclePos = ( short (*)[ 5 ] )GRH.CommonBuffer[ 1 ] ;
	_MEMSET( CirclePos, 0, sizeof( short ) * 5 * DrawRect.bottom ) ;

	// ~̍WXg쐬
	GetCircle_ThicknessDrawPosition( x, y, r, Thickness, CirclePos ) ;

	// `揈
	VectNum = 0 ;
	for( i = DrawRect.top ; i < DrawRect.bottom ; i ++ )
	{
		if( CirclePos[ i ][ 4 ] == 0 )
		{
			continue ;
		}

		y1f = ( float )i ;

		if( ( CirclePos[ i ][ 4 ] & ( 4 | 8 ) ) == 0 || CirclePos[ i ][ 2 ] >= CirclePos[ i ][ 3 ] )
		{
			x1 = CirclePos[ i ][ 0 ] ;
			x2 = CirclePos[ i ][ 1 ] ;
			DX_3D_CIRCLE_THICKNESS
		}
		else
		{
			x1 = CirclePos[ i ][ 0 ] ;
			x2 = CirclePos[ i ][ 2 ] ;
			DX_3D_CIRCLE_THICKNESS

			x1 = CirclePos[ i ][ 3 ] ;
			x2 = CirclePos[ i ][ 1 ] ;
			DX_3D_CIRCLE_THICKNESS
		}
	}
	if( VectNum )
	{
		if( GRH.UseAlphaChDrawShader )
		{
			for( j = 0 ; j < VectNum ; j ++ )
			{
				VectBuf[ j ].sc_u = ( VectBuf[ j ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
				VectBuf[ j ].sc_v = ( VectBuf[ j ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
			}
		}

		GraphicsDevice_DrawPrimitiveUP( D_D3DPT_LINELIST, VectNum / 2, VectBuf, sizeof( VERTEX_NOTEX_2D ) ) ;
	}

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawOval( w肠 )
static int	DrawOval_ThicknessHardware( int x, int y, int rx, int ry, int Color, int Thickness )
{
	VERTEX_NOTEX_2D *VectBuf ;
	int VectNum ;
	short ( *CirclePos )[ 5 ] ;
	int Red, Green, Blue, Flag ;
	RECT DrawRect ;
	DWORD drawz ;
	int i ;
	int j ;
	int x1, x2 ;
	float y1f ;

	// Qȉ牽I
	if( Thickness < 2 )
	{
		return -1 ;
	}

	RenderVertexHardware() ;

	if( GraphicsDevice_IsValid() == 0 ) return -1 ; 

	// `p̊m
	if( AllocCommonBuffer( 0, sizeof( VERTEX_NOTEX_2D ) * CIRCLE_VERTEX_NUM ) < 0 )
	{
		return -1 ;
	}
	VectBuf = ( VERTEX_NOTEX_2D * )GRH.CommonBuffer[ 0 ] ;

	// `̏
	BeginScene() ;
	Flag = DRAWPREP_DIFFUSERGB ;
	DRAWPREP_NOTEX( Flag )

	// yobt@ɏނylZbg
	drawz = *((DWORD *)&GBASE.DrawZ);

	// ␳
	DrawRect = GBASE.DrawArea ;

	NS_GetColor2( Color, &Red, &Green, &Blue ) ;
	Color = ( ( ( ( (	GRH.DiffuseColor & 0x00ff0000 ) >> 16 ) * Red )		/ 255 ) << 16 ) |
			( ( ( ( (	GRH.DiffuseColor & 0x0000ff00 ) >> 8  ) * Green )	/ 255 ) << 8 ) |
			( ( ( (		GRH.DiffuseColor & 0x000000ff )       ) * Blue )	/ 255 ) | 
			(			GRH.DiffuseColor & 0xff000000 ) ;

	// FVF ̕ύX
	SETFVF( VERTEXFVF_NOTEX_2D )

	// ~̍Wobt@擾
	if( AllocCommonBuffer( 1, sizeof( short ) * 5 * DrawRect.bottom ) < 0 )
	{
		return -1 ;
	}
	CirclePos = ( short (*)[ 5 ] )GRH.CommonBuffer[ 1 ] ;
	_MEMSET( CirclePos, 0, sizeof( short ) * 5 * DrawRect.bottom ) ;

	// ȉ~̍WXg쐬
	GetOval_ThicknessDrawPosition( x, y, rx, ry, Thickness, CirclePos ) ;

	// `揈
	VectNum = 0 ;
	for( i = DrawRect.top ; i < DrawRect.bottom ; i ++ )
	{
		if( CirclePos[ i ][ 4 ] == 0 )
		{
			continue ;
		}

		y1f = ( float )i ;

		if( ( CirclePos[ i ][ 4 ] & ( 4 | 8 ) ) == 0 || CirclePos[ i ][ 2 ] >= CirclePos[ i ][ 3 ] )
		{
			x1 = CirclePos[ i ][ 0 ] ;
			x2 = CirclePos[ i ][ 1 ] ;
			DX_3D_CIRCLE_THICKNESS
		}
		else
		{
			x1 = CirclePos[ i ][ 0 ] ;
			x2 = CirclePos[ i ][ 2 ] ;
			DX_3D_CIRCLE_THICKNESS

			x1 = CirclePos[ i ][ 3 ] ;
			x2 = CirclePos[ i ][ 1 ] ;
			DX_3D_CIRCLE_THICKNESS
		}
	}
	if( VectNum )
	{
		if( GRH.UseAlphaChDrawShader )
		{
			for( j = 0 ; j < VectNum ; j ++ )
			{
				VectBuf[ j ].sc_u = ( VectBuf[ j ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
				VectBuf[ j ].sc_v = ( VectBuf[ j ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
			}
		}

		GraphicsDevice_DrawPrimitiveUP( D_D3DPT_LINELIST, VectNum / 2, VectBuf, sizeof( VERTEX_NOTEX_2D ) ) ;
	}

	// I
	return 0 ;
}


#define DX_3D_CIRCLE																\
			if( !( ( x2 < DrawRect.left ) || ( x1 >= DrawRect.right  ) ||				\
			       ( y1 < DrawRect.top  ) || ( y1 >= DrawRect.bottom ) || LineDrawBuf[ y1 ] ) )			\
			{																			\
				if( x1 < DrawRect.left ) x1 = DrawRect.left ;							\
				if( x2 > DrawRect.right - 1 ) x2 = DrawRect.right - 1 ;					\
																						\
				VectBuf[ VectNum ].pos.x  = ( float )x1 ;								\
				VectBuf[ VectNum ].pos.y  = ( float )y1 ;								\
				VectBuf[ VectNum ].color = Color ;										\
				VectBuf[ VectNum ].rhw   = 1.0f ;										\
				*((DWORD *)&VectBuf[ VectNum ].pos.z) = drawz ;							\
				VectNum ++ ;															\
				LineDrawBuf[y1] = TRUE ;												\
																						\
				VectBuf[ VectNum ].pos.x =  ( float )( x2 + 1 );						\
				VectBuf[ VectNum ].pos.y =  ( float )y1 ;								\
				VectBuf[ VectNum ].color = Color ;										\
				VectBuf[ VectNum ].rhw   = 1.0f ;										\
				*((DWORD *)&VectBuf[ VectNum ].pos.z) = drawz ;							\
				VectNum  ++ ;															\
																						\
				if( VectNum >= CIRCLE_VERTEX_NUM )										\
				{																		\
					if( GRH.UseAlphaChDrawShader )										\
					{																	\
						for( i = 0 ; i < VectNum ; i ++ )								\
						{																\
							VectBuf[ i ].sc_u = ( VectBuf[ i ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;\
							VectBuf[ i ].sc_v = ( VectBuf[ i ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;\
						}																\
					}																	\
					GraphicsDevice_DrawPrimitiveUP( D_D3DPT_LINELIST, VectNum / 2, VectBuf, sizeof( VERTEX_NOTEX_2D ) ) ;\
					VectNum = 0 ;														\
				}																		\
			}

#define DX_3D_CIRCLE_PSET															\
			if( !( ( ( unsigned int )( x1 ) >= ( unsigned int )( DrawRect.right ) ) ||	\
				( y1 < DrawRect.top ) || ( y1 >= DrawRect.bottom ) ) )					\
			{																			\
				VectBuf[ VectNum ].pos.x  = ( float )x1 ;								\
				VectBuf[ VectNum ].pos.y  = ( float )y1 ;								\
				VectBuf[ VectNum ].color = Color ;										\
				VectBuf[ VectNum ].rhw   = 1.0f ;										\
				*((DWORD *)&VectBuf[ VectNum ].pos.z) = drawz ;							\
				VectNum ++ ;															\
																						\
				if( VectNum >= CIRCLE_VERTEX_NUM )										\
				{																		\
					if( GRH.UseAlphaChDrawShader )										\
					{																	\
						for( i = 0 ; i < VectNum ; i ++ )								\
						{																\
							VectBuf[ i ].sc_u = ( VectBuf[ i ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;\
							VectBuf[ i ].sc_v = ( VectBuf[ i ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;\
						}																\
					}																	\
					GraphicsDevice_DrawPrimitiveUP( D_D3DPT_POINTLIST, VectNum, VectBuf, sizeof( VERTEX_NOTEX_2D ) ) ;\
					VectNum = 0 ;														\
				}																		\
			}

// n[hEGAANZ[^gp DrawCircle
static int	DrawCircleHardware( int x, int y, int r, int Color, int FillFlag )
{
	VERTEX_NOTEX_2D *VectBuf ;
	int VectNum ;
	BYTE *LineDrawBuf ;
	int Red, Green, Blue, Flag ;
	RECT DrawRect ;
	DWORD drawz;

	RenderVertexHardware() ;

	if( GraphicsDevice_IsValid() == 0 ) return -1 ; 

	// `p̊m
	if( AllocCommonBuffer( 0, sizeof( VERTEX_NOTEX_2D ) * CIRCLE_VERTEX_NUM ) < 0 )
	{
		return -1 ;
	}
	VectBuf = ( VERTEX_NOTEX_2D * )GRH.CommonBuffer[ 0 ] ;

	// `̏
	BeginScene() ;
	Flag = DRAWPREP_DIFFUSERGB ;
	DRAWPREP_NOTEX( Flag )

	// yobt@ɏނylZbg
	drawz = *((DWORD *)&GBASE.DrawZ);

	// ␳
	DrawRect = GBASE.DrawArea ;

	NS_GetColor2( Color, &Red, &Green, &Blue ) ;
	Color = ( ( ( ( (	GRH.DiffuseColor & 0x00ff0000 ) >> 16 ) * Red )		/ 255 ) << 16 ) |
			( ( ( ( (	GRH.DiffuseColor & 0x0000ff00 ) >> 8  ) * Green )	/ 255 ) << 8 ) |
			( ( ( (		GRH.DiffuseColor & 0x000000ff )       ) * Blue )	/ 255 ) | 
			(			GRH.DiffuseColor & 0xff000000 ) ;

	// FVF ̕ύX
	SETFVF( VERTEXFVF_NOTEX_2D )

	// `揈
	{
		int Dx, Dy, F, i, j ;
		int x1, x2, y1 ;

		// lZbg
		Dx = r ; Dy = 0 ; F = -2 * r + 3 ;
		VectNum = 0 ;

		j = 0 ;
		// `Jn
		if( FillFlag )
		{
			if( AllocCommonBuffer( 1, DrawRect.bottom ) < 0 )
			{
				return DxLib_Error( DXSTRING( _T( "̊mۂɎs܂ in G_D3D_DrawCircle" ) ) ) ;
			}
			LineDrawBuf = ( BYTE * )GRH.CommonBuffer[ 1 ] ;
			_MEMSET( LineDrawBuf, 0, DrawRect.bottom ) ;

			// ŏ̃C`
			{
				x2 = Dx + x ; x1 = -Dx + x ; y1 = Dy + y ;
				DX_3D_CIRCLE ;

				// Wf[^i߂
				if( F >= 0 )
				{
					x2 = Dy + x ; x1 = -Dy + x ; y1 = Dx + y ;
					DX_3D_CIRCLE ;
					x2 = Dy + x ; x1 = -Dy + x ; y1 = -Dx + y;
					DX_3D_CIRCLE ;

					Dx -- ;
					F -= 4 * Dx ;
				}	

				Dy ++ ;
				F += 4 * Dy + 2 ;
			}

			while( Dx >= Dy )
			{
				x2 = Dx + x ; x1 = -Dx + x ; y1 = Dy + y ;
				DX_3D_CIRCLE ;
				x2 = Dx + x ; x1 = -Dx + x ; y1 = -Dy + y;
				DX_3D_CIRCLE ;

				// Wf[^i߂
				if( F >= 0 )
				{
					x2 = Dy + x ; x1 = -Dy + x ; y1 = Dx + y ;
					DX_3D_CIRCLE ;
					x2 = Dy + x ; x1 = -Dy + x ; y1 = -Dx + y;
					DX_3D_CIRCLE ;

					Dx -- ;
					F -= 4 * Dx ;
				}

				Dy ++ ;
				F += 4 * Dy + 2 ;
			}
			if( VectNum )
			{
				if( GRH.UseAlphaChDrawShader )
				{
					for( i = 0 ; i < VectNum ; i ++ )
					{
						VectBuf[ i ].sc_u = ( VectBuf[ i ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
						VectBuf[ i ].sc_v = ( VectBuf[ i ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					}
				}

				GraphicsDevice_DrawPrimitiveUP( D_D3DPT_LINELIST, VectNum / 2, VectBuf, sizeof( VERTEX_NOTEX_2D ) ) ;
			}
		}
		else
		{
			// ŏ̓_`
			{
				x1 = -Dx + x ; y1 = Dy + y ;
				DX_3D_CIRCLE_PSET ;
				x1 = Dx + x ;  
				DX_3D_CIRCLE_PSET ;

				x1 = Dy + x ; y1 = Dx + y ;
				DX_3D_CIRCLE_PSET ;

				x1 = Dy + x ; y1 = -Dx + y;
				DX_3D_CIRCLE_PSET ;

				// Wf[^i߂
				if( F >= 0 )
				{
					Dx -- ;
					F -= 4 * Dx ;
				}	

				Dy ++ ;
				F += 4 * Dy + 2 ;
			}

			while( Dx >= Dy )
			{
				x1 = -Dx + x ; y1 = Dy + y ;
				DX_3D_CIRCLE_PSET ;
				x1 = Dx + x ;  
				DX_3D_CIRCLE_PSET ;

				x1 = Dy + x ; y1 = Dx + y ;
				DX_3D_CIRCLE_PSET ;
				x1 = -Dy + x ; 
				DX_3D_CIRCLE_PSET ;
			
				x1 = Dx + x ; y1 = -Dy + y;
				DX_3D_CIRCLE_PSET ;
				x1 = -Dx + x ; 
				DX_3D_CIRCLE_PSET ;

				x1 = Dy + x ; y1 = -Dx + y;
				DX_3D_CIRCLE_PSET ;
				x1 = -Dy + x ; 
				DX_3D_CIRCLE_PSET ;

				// Wf[^i߂
				if( F >= 0 )
				{
					Dx -- ;
					F -= 4 * Dx ;
				}

				Dy ++ ;
				F += 4 * Dy + 2 ;
			}
			if( VectNum )
			{
				if( GRH.UseAlphaChDrawShader )
				{
					for( i = 0 ; i < VectNum ; i ++ )
					{
						VectBuf[ i ].sc_u = ( VectBuf[ i ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
						VectBuf[ i ].sc_v = ( VectBuf[ i ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					}
				}

				GraphicsDevice_DrawPrimitiveUP( D_D3DPT_POINTLIST, VectNum, VectBuf, sizeof( VERTEX_NOTEX_2D ) ) ;
			}
		}
	}

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawOval
static int	DrawOvalHardware( int x, int y, int rx, int ry, int Color, int FillFlag )
{
	VERTEX_NOTEX_2D *VectBuf ;
	int VectNum ;
	BYTE *LineDrawBuf ;
//	VERTEX_NOTEX_2D *VectData ;
//	int i, j, r2 ;
//	float xd, x2, y2 ;
//	float d, yd ;
	int Red, Green, Blue, Flag ;
	RECT DrawRect ;
	DWORD drawz;

	RenderVertexHardware() ;

	if( GraphicsDevice_IsValid() == 0 ) return -1 ; 
	if( !rx || !ry ) return -1 ;

	// `p̊m
	if( AllocCommonBuffer( 0, sizeof( VERTEX_NOTEX_2D ) * CIRCLE_VERTEX_NUM ) < 0 )
	{
		return -1 ;
	}
	VectBuf = ( VERTEX_NOTEX_2D * )GRH.CommonBuffer[ 0 ] ;

	// `̏
	BeginScene() ;
	SetTextureHardware( NULL ) ;
	Flag = DRAWPREP_DIFFUSERGB ;
	DRAWPREP_NOTEX( Flag )

	// ␳
	if( rx < 0 ) rx *= -1 ;
	if( ry < 0 ) ry *= -1 ;
	DrawRect = GBASE.DrawArea ;

	NS_GetColor2( Color, &Red, &Green, &Blue ) ;
	Color = ( ( ( ( (	GRH.DiffuseColor & 0x00ff0000 ) >> 16 ) * Red )		/ 255 ) << 16 ) |
			( ( ( ( (	GRH.DiffuseColor & 0x0000ff00 ) >> 8  ) * Green )	/ 255 ) << 8 ) |
			( ( ( (		GRH.DiffuseColor & 0x000000ff )       ) * Blue )	/ 255 ) | 
			(			GRH.DiffuseColor & 0xff000000 ) ;

	// yobt@ɏނylZbg
	drawz = *((DWORD *)&GBASE.DrawZ);

	// FVF ̕ύX
	SETFVF( VERTEXFVF_NOTEX_2D )

	VectNum = 0 ;

	// `揈
	{
		int Dx, Dy, F, H, j, i ;
		int x1, x2, y1, Df ;
		int yc, xc, rc, r ;

		j = 0 ;
		// `Jn
		if( FillFlag )
		{
			if( AllocCommonBuffer( 1, DrawRect.bottom ) < 0 )
			{
				return DxLib_Error( DXSTRING( _T( "̊mۂɎs܂ in G_D3D_DrawCircle" ) ) ) ;
			}
			LineDrawBuf = ( BYTE * )GRH.CommonBuffer[ 1 ] ;
			_MEMSET( LineDrawBuf, 0, DrawRect.bottom ) ;

			if( rx >= ry )
			{
				// lZbg
				rc = ( rx * rx ) / ry ;

				xc = 0 ; yc = 0 ;
				r = rx ;
				Df = 1 ;
		
				Dx = r ;
				Dy = 0;
				F = -2 * r + 1 + 2 * 1;
				H = -4 * r + 2 + 1;

				// ŏ̐`
				{
					x1 = -Dx + x ; x2 = Dx + x ; y1 = Dy + y ;
					DX_3D_CIRCLE ;

					Df = 0 ;

					// Wf[^i߂
					if( F < 0 )
					{
						yc += ry ;
						if( yc >= rc )
						{
							Dy ++ ;
							yc -= rc ;
							Df = 1 ;
						}
						F += 4 * Dy + 2 ;
						H += 4 * Dy;
					}
					else
					{
						Df = 1 ;

						if( H>=0 )
						{
							Dx--;
							F -= 4 * Dx;
							H -= 4 * Dx - 2 ;
						}
						else
						{
							Dx--;	
							yc += ry ;
							if( yc >= rc )
							{
								Dy ++ ;
								yc -= rc ;
								Df = 1 ;
							}
							F += 4 * Dy - 4 * Dx + 2 ;
							H += 4 * Dy - 4 * Dx + 2 ;
						}
					}
				}

				while( Dx > 0 )
				{
					if( Df )
					{
						x1 = -Dx + x ; x2 = Dx + x ; y1 = Dy + y ;
						DX_3D_CIRCLE ;

						y1 = -Dy + y ;
						DX_3D_CIRCLE ;
					}

					Df = 0 ;

					// Wf[^i߂
					if( F < 0 )
					{
						yc += ry ;
						if( yc >= rc )
						{
							Dy ++ ;
							yc -= rc ;
							Df = 1 ;
						}
						F += 4 * Dy + 2 ;
						H += 4 * Dy;
					}
					else
					{
						if( H>=0 )
						{
							Dx--;
							F -= 4 * Dx;
							H -= 4 * Dx - 2 ;
						}
						else
						{
							Dx--;	
							yc += ry ;
							if( yc >= rc )
							{
								Dy ++ ;
								yc -= rc ;
								Df = 1 ;
							}
							F += 4 * Dy - 4 * Dx + 2 ;
							H += 4 * Dy - 4 * Dx + 2 ;
						}
					}
				}

				// Ō̐`
				x1 = -Dx + x ; x2 = Dx + x ; y1 = -Dy + y;
				DX_3D_CIRCLE ;
			}
			else
			{
				// lZbg
				rc = ( ry * ry ) / rx ;

				xc = 0 ; yc = 0 ;
				r = rx ;
				Df = 2 ;
		
				Dx = r ;
				Dy = 0;
				F = -2 * r + 1 + 2 * 1;
				H = -4 * r + 2 + 1;

				// ŏ̐`
				{
					x1 = -Dx + x ; x2 = Dx + x ; y1 = Dy + y ;
					DX_3D_CIRCLE ;

					Df = 0 ;

					// Wf[^i߂
					if( F < 0 )
					{
						Df = 1 ;

						Dy ++ ;
						F += 4 * Dy + 2 ;
						H += 4 * Dy;
					}
					else
					{
						if( H>=0 )
						{
							xc += rx ;
							if( xc >= rc )
							{
								Dx--;
								xc -= rc ;
							}
							F -= 4 * Dx;
							H -= 4 * Dx - 2 ;
						}
						else
						{
							Df = 1 ;

							xc += rx ;
							if( xc >= rc )
							{
								Dx--;
								xc -= rc ;
							}

							Dy ++ ;
							F += 4 * Dy - 4 * Dx + 2 ;
							H += 4 * Dy - 4 * Dx + 2 ;
						}
					}
				}

				while( Dx > 0 )
				{
					if( Df )
					{
						x1 = -Dx + x ; x2 = Dx + x ; y1 = Dy + y ;
						DX_3D_CIRCLE ;

						y1 = -Dy + y ;
						DX_3D_CIRCLE ;
					}

					Df = 0 ;

					// Wf[^i߂
					if( F < 0 )
					{
						Df = 1 ;

						Dy ++ ;
						F += 4 * Dy + 2 ;
						H += 4 * Dy;
					}
					else
					{
						if( H>=0 )
						{
							xc += rx ;
							if( xc >= rc )
							{
								Dx--;
								xc -= rc ;
							}
							F -= 4 * Dx;
							H -= 4 * Dx - 2 ;
						}
						else
						{
							Df = 1 ;

							xc += rx ;
							if( xc >= rc )
							{
								Dx--;
								xc -= rc ;
							}

							Dy ++ ;
							F += 4 * Dy - 4 * Dx + 2 ;
							H += 4 * Dy - 4 * Dx + 2 ;
						}
					}
				}

				// Ō̐`
				x1 = -Dx + x ; x2 = Dx + x ; y1 = -Dy + y;
				DX_3D_CIRCLE ;
			}
			if( VectNum )
			{
				if( GRH.UseAlphaChDrawShader )
				{
					for( i = 0 ; i < VectNum ; i ++ )
					{
						VectBuf[ i ].sc_u = ( VectBuf[ i ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
						VectBuf[ i ].sc_v = ( VectBuf[ i ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					}
				}
				GraphicsDevice_DrawPrimitiveUP( D_D3DPT_LINELIST, VectNum / 2, VectBuf, sizeof( VERTEX_NOTEX_2D ) ) ;
			}
		}
		else
		{
			if( rx >= ry )
			{
				// lZbg
				rc = ( rx * rx ) / ry ;

				xc = 0 ; yc = 0 ;
				r = rx ;
				Df = 2 ;
		
				Dx = r ;
				Dy = 0;
				F = -2 * r + 1 + 2 * 1;
				H = -4 * r + 2 + 1;

				// ŏ̓_`
				{
					x1 = -Dx + x ; y1 = Dy + y ;
					DX_3D_CIRCLE_PSET ;
					x1 = Dx + x ;  
					DX_3D_CIRCLE_PSET ;

					Df = 0 ;

					// Wf[^i߂
					if( F < 0 )
					{
						yc += ry ;
						if( yc >= rc )
						{
							Dy ++ ;
							yc -= rc ;
							Df = 1 ;
						}
						F += 4 * Dy + 2 ;
						H += 4 * Dy;
					}
					else
					{
						Df = 1 ;

						if( H>=0 )
						{
							Dx--;
							F -= 4 * Dx;
							H -= 4 * Dx - 2 ;
						}
						else
						{
							Dx--;	
							yc += ry ;
							if( yc >= rc )
							{
								Dy ++ ;
								yc -= rc ;
								Df = 1 ;
							}
							F += 4 * Dy - 4 * Dx + 2 ;
							H += 4 * Dy - 4 * Dx + 2 ;
						}
					}
				}

				while( Dx > 0 )
				{
					if( Df )
					{
						x1 = -Dx + x ; y1 = Dy + y ;
						DX_3D_CIRCLE_PSET ;
						x1 = Dx + x ;  
						DX_3D_CIRCLE_PSET ;

						x1 = -Dx + x ; y1 = -Dy + y ;
						DX_3D_CIRCLE_PSET ;
						x1 = Dx + x ;  
						DX_3D_CIRCLE_PSET ;
					}

					Df = 0 ;

					// Wf[^i߂
					if( F < 0 )
					{
						yc += ry ;
						if( yc >= rc )
						{
							Dy ++ ;
							yc -= rc ;
							Df = 1 ;
						}
						F += 4 * Dy + 2 ;
						H += 4 * Dy;
					}
					else
					{
						Df = 1 ;

						if( H>=0 )
						{
							Dx--;
							F -= 4 * Dx;
							H -= 4 * Dx - 2 ;
						}
						else
						{
							Dx--;	
							yc += ry ;
							if( yc >= rc )
							{
								Dy ++ ;
								yc -= rc ;
								Df = 1 ;
							}
							F += 4 * Dy - 4 * Dx + 2 ;
							H += 4 * Dy - 4 * Dx + 2 ;
						}
					}
				}

				// Ō̓_`
				x1 = Dx + x ; y1 = -Dy + y;
				DX_3D_CIRCLE_PSET ;

				x1 = -Dx + x ; y1 = Dy + y ;
				DX_3D_CIRCLE_PSET ;
			}
			else
			{
				// lZbg
				rc = ( ry * ry ) / rx ;

				xc = 0 ; yc = 0 ;
				r = rx ;
				Df = 2 ;
		
				Dx = r ;
				Dy = 0;
				F = -2 * r + 1 + 2 * 1;
				H = -4 * r + 2 + 1;

				// ŏ̓_`
				{
					x1 = -Dx + x ; y1 = Dy + y ;
					DX_3D_CIRCLE_PSET ;
					x1 = Dx + x ;  
					DX_3D_CIRCLE_PSET ;

					Df = 0 ;

					// Wf[^i߂
					if( F < 0 )
					{
						Df = 1 ;

						Dy ++ ;
						F += 4 * Dy + 2 ;
						H += 4 * Dy;
					}
					else
					{
						if( H>=0 )
						{
							xc += rx ;
							if( xc >= rc )
							{
								Dx--;
								xc -= rc ;
								Df = 1 ;
							}
							F -= 4 * Dx;
							H -= 4 * Dx - 2 ;
						}
						else
						{
							Df = 1 ;

							xc += rx ;
							if( xc >= rc )
							{
								Dx--;
								xc -= rc ;
							}

							Dy ++ ;
							F += 4 * Dy - 4 * Dx + 2 ;
							H += 4 * Dy - 4 * Dx + 2 ;
						}
					}
				}

				while( Dx > 0 )
				{
					if( Df )
					{
						x1 = -Dx + x ; y1 = Dy + y ;
						DX_3D_CIRCLE_PSET ;
						x1 = Dx + x ;  
						DX_3D_CIRCLE_PSET ;

						x1 = -Dx + x ; y1 = -Dy + y ;
						DX_3D_CIRCLE_PSET ;
						x1 = Dx + x ;  
						DX_3D_CIRCLE_PSET ;
					}

					Df = 0 ;

					// Wf[^i߂
					if( F < 0 )
					{
						Df = 1 ;

						Dy ++ ;
						F += 4 * Dy + 2 ;
						H += 4 * Dy;
					}
					else
					{
						if( H>=0 )
						{
							xc += rx ;
							if( xc >= rc )
							{
								Dx--;
								xc -= rc ;
								Df = 1 ;
							}
							F -= 4 * Dx;
							H -= 4 * Dx - 2 ;
						}
						else
						{
							Df = 1 ;

							xc += rx ;
							if( xc >= rc )
							{
								Dx--;
								xc -= rc ;
							}

							Dy ++ ;
							F += 4 * Dy - 4 * Dx + 2 ;
							H += 4 * Dy - 4 * Dx + 2 ;
						}
					}
				}

				// Ō̓_`
				x1 = Dx + x ; y1 = -Dy + y;
				DX_3D_CIRCLE_PSET ;

				x1 = -Dx + x ; y1 = Dy + y ;
				DX_3D_CIRCLE_PSET ;
			}
			if( VectNum )
			{
				if( GRH.UseAlphaChDrawShader )
				{
					for( i = 0 ; i < VectNum ; i ++ )
					{
						VectBuf[ i ].sc_u = ( VectBuf[ i ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
						VectBuf[ i ].sc_v = ( VectBuf[ i ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					}
				}
				GraphicsDevice_DrawPrimitiveUP( D_D3DPT_POINTLIST, VectNum, VectBuf, sizeof( VERTEX_NOTEX_2D ) ) ;
			}
		}
	}

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawTriangle3D
static int	DrawTriangle3DHardware( VECTOR Pos1, VECTOR Pos2, VECTOR Pos3, int Color, int FillFlag, int DrawFlag, RECT *DrawArea )
{
	VERTEX_NOTEX_3D *vec ; 
	int Red, Green, Blue ;
	int Flag ;

	if( DrawFlag )
	{
		if( GraphicsDevice_IsValid() == 0 ) return -1 ;

		// `̏
		if( GRH.BeginSceneFlag == FALSE ) BeginScene() ;
		if( GRH.RenderTexture != NULL ) SetTextureHardware( NULL ) ;

		Flag = DRAWPREP_DIFFUSERGB | DRAWPREP_3D | DRAWPREP_FOG | DRAWPREP_CULLING ;
		DRAWPREP_NOTEX( Flag )

		// F̑Xe[^X̃Zbg
		NS_GetColor2( Color, &Red, &Green, &Blue ) ;
		Color = ( ( ( ( (	GRH.DiffuseColor & 0x00ff0000 ) >> 16 ) * Red )		/ 255 ) << 16 ) |
				( ( ( ( (	GRH.DiffuseColor & 0x0000ff00 ) >> 8  ) * Green )	/ 255 ) << 8 ) |
				( ( ( (		GRH.DiffuseColor & 0x000000ff )       ) * Blue )	/ 255 ) | 
				(			GRH.DiffuseColor & 0xff000000 ) ;

		// Cǂŏ𕪊
		if( FillFlag )
		{
			GETVERTEX_TRIANGLE3D( vec ) ;

			*( ( DWORD * )&vec[ 0 ].b ) =
			*( ( DWORD * )&vec[ 1 ].b ) =
			*( ( DWORD * )&vec[ 2 ].b ) = ( DWORD )Color ;
			vec[ 0 ].pos = Pos1 ;
			vec[ 1 ].pos = Pos2 ;
			vec[ 2 ].pos = Pos3 ;

			ADD3VERTEX_NOTEX3D
		}
		else
		{
			GETVERTEX_LINETRIANGLE3D( vec )

			*( ( DWORD * )&vec[ 0 ].b ) =
			*( ( DWORD * )&vec[ 1 ].b ) =
			*( ( DWORD * )&vec[ 2 ].b ) =
			*( ( DWORD * )&vec[ 3 ].b ) =
			*( ( DWORD * )&vec[ 4 ].b ) =
			*( ( DWORD * )&vec[ 5 ].b ) = ( DWORD )Color ;

			vec[ 0 ].pos = Pos1 ;
			vec[ 1 ].pos = Pos2 ;
			vec[ 2 ].pos = Pos2 ;
			vec[ 3 ].pos = Pos3 ;
			vec[ 4 ].pos = Pos3 ;
			vec[ 5 ].pos = Pos1 ;

			ADD4VERTEX_LINETRIANGLE3D
		}
	}
	else
	{
		VERTEX_2D TempVect[ 3 ] ;
		float dleft, dright, dtop, dbottom ;

		dleft   =  100000000.0f ;
		dright  = -100000000.0f ;
		dtop    =  100000000.0f ;
		dbottom = -100000000.0f ;

		// XN[Wɕϊ
		TempVect[0].pos.x = Pos1.x * GBASE.BlendMatrix.m[0][0] + Pos1.y * GBASE.BlendMatrix.m[1][0] + Pos1.z * GBASE.BlendMatrix.m[2][0] + GBASE.BlendMatrix.m[3][0]  ;
		TempVect[0].pos.y = Pos1.x * GBASE.BlendMatrix.m[0][1] + Pos1.y * GBASE.BlendMatrix.m[1][1] + Pos1.z * GBASE.BlendMatrix.m[2][1] + GBASE.BlendMatrix.m[3][1]  ;
		TempVect[0].pos.z = Pos1.x * GBASE.BlendMatrix.m[0][2] + Pos1.y * GBASE.BlendMatrix.m[1][2] + Pos1.z * GBASE.BlendMatrix.m[2][2] + GBASE.BlendMatrix.m[3][2]  ;
		TempVect[0].rhw   = Pos1.x * GBASE.BlendMatrix.m[0][3] + Pos1.y * GBASE.BlendMatrix.m[1][3] + Pos1.z * GBASE.BlendMatrix.m[2][3] + GBASE.BlendMatrix.m[3][3]  ;

		TempVect[1].pos.x = Pos2.x * GBASE.BlendMatrix.m[0][0] + Pos2.y * GBASE.BlendMatrix.m[1][0] + Pos2.z * GBASE.BlendMatrix.m[2][0] + GBASE.BlendMatrix.m[3][0]  ;
		TempVect[1].pos.y = Pos2.x * GBASE.BlendMatrix.m[0][1] + Pos2.y * GBASE.BlendMatrix.m[1][1] + Pos2.z * GBASE.BlendMatrix.m[2][1] + GBASE.BlendMatrix.m[3][1]  ;
		TempVect[1].pos.z = Pos2.x * GBASE.BlendMatrix.m[0][2] + Pos2.y * GBASE.BlendMatrix.m[1][2] + Pos2.z * GBASE.BlendMatrix.m[2][2] + GBASE.BlendMatrix.m[3][2]  ;
		TempVect[1].rhw   = Pos2.x * GBASE.BlendMatrix.m[0][3] + Pos2.y * GBASE.BlendMatrix.m[1][3] + Pos2.z * GBASE.BlendMatrix.m[2][3] + GBASE.BlendMatrix.m[3][3]  ;

		TempVect[2].pos.x = Pos3.x * GBASE.BlendMatrix.m[0][0] + Pos3.y * GBASE.BlendMatrix.m[1][0] + Pos3.z * GBASE.BlendMatrix.m[2][0] + GBASE.BlendMatrix.m[3][0]  ;
		TempVect[2].pos.y = Pos3.x * GBASE.BlendMatrix.m[0][1] + Pos3.y * GBASE.BlendMatrix.m[1][1] + Pos3.z * GBASE.BlendMatrix.m[2][1] + GBASE.BlendMatrix.m[3][1]  ;
		TempVect[2].pos.z = Pos3.x * GBASE.BlendMatrix.m[0][2] + Pos3.y * GBASE.BlendMatrix.m[1][2] + Pos3.z * GBASE.BlendMatrix.m[2][2] + GBASE.BlendMatrix.m[3][2]  ;
		TempVect[2].rhw   = Pos3.x * GBASE.BlendMatrix.m[0][3] + Pos3.y * GBASE.BlendMatrix.m[1][3] + Pos3.z * GBASE.BlendMatrix.m[2][3] + GBASE.BlendMatrix.m[3][3]  ;

		TempVect[0].rhw = 1.0F / TempVect[0].rhw ;
		TempVect[0].pos.x *= TempVect[0].rhw ;
		TempVect[0].pos.y *= TempVect[0].rhw ;
		TempVect[0].pos.z *= TempVect[0].rhw ;

		TempVect[1].rhw = 1.0F / TempVect[1].rhw ;
		TempVect[1].pos.x *= TempVect[1].rhw ;
		TempVect[1].pos.y *= TempVect[1].rhw ;
		TempVect[1].pos.z *= TempVect[1].rhw ;

		TempVect[2].rhw = 1.0F / TempVect[2].rhw ;
		TempVect[2].pos.x *= TempVect[2].rhw ;
		TempVect[2].pos.y *= TempVect[2].rhw ;
		TempVect[2].pos.z *= TempVect[2].rhw ;

		if( dright  < TempVect[ 0 ].pos.x ) dright  = TempVect[ 0 ].pos.x ;
		if( dright  < TempVect[ 1 ].pos.x ) dright  = TempVect[ 1 ].pos.x ;
		if( dright  < TempVect[ 2 ].pos.x ) dright  = TempVect[ 2 ].pos.x ;

		if( dleft   > TempVect[ 0 ].pos.x ) dleft   = TempVect[ 0 ].pos.x ;
		if( dleft   > TempVect[ 1 ].pos.x ) dleft   = TempVect[ 1 ].pos.x ;
		if( dleft   > TempVect[ 2 ].pos.x ) dleft   = TempVect[ 2 ].pos.x ;

		if( dbottom < TempVect[ 0 ].pos.y ) dbottom = TempVect[ 0 ].pos.y ;
		if( dbottom < TempVect[ 1 ].pos.y ) dbottom = TempVect[ 1 ].pos.y ;
		if( dbottom < TempVect[ 2 ].pos.y ) dbottom = TempVect[ 2 ].pos.y ;

		if( dtop    > TempVect[ 0 ].pos.y ) dtop    = TempVect[ 0 ].pos.y ;
		if( dtop    > TempVect[ 1 ].pos.y ) dtop    = TempVect[ 1 ].pos.y ;
		if( dtop    > TempVect[ 2 ].pos.y ) dtop    = TempVect[ 2 ].pos.y ;

		DrawArea->left   = _FTOL( dleft   ) - 1 ;
		DrawArea->right  = _FTOL( dright  ) + 1 ;
		DrawArea->top    = _FTOL( dtop    ) - 1 ;
		DrawArea->bottom = _FTOL( dbottom ) + 1 ;
	}

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawTriangle
static int	DrawTriangleHardware( int x1, int y1, int x2, int y2, int x3, int y3, int Color, int FillFlag )
{
	VERTEX_NOTEX_2D *vec ; 
	int Red, Green, Blue ;
	int Flag ;
	int sx1, sx2, sy1, sy2 ;
	DWORD drawz;

	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	// `̏
	BeginScene() ;
	SetTextureHardware( NULL ) ;
	Flag = DRAWPREP_DIFFUSERGB ;
	DRAWPREP_NOTEX( Flag )

	// yobt@ɏނylZbg
	drawz = *((DWORD *)&GBASE.DrawZ);

	// F̑Xe[^X̃Zbg
	NS_GetColor2( Color, &Red, &Green, &Blue ) ;
	Color = ( ( ( ( (	GRH.DiffuseColor & 0x00ff0000 ) >> 16 ) * Red )		/ 255 ) << 16 ) |
			( ( ( ( (	GRH.DiffuseColor & 0x0000ff00 ) >> 8  ) * Green )	/ 255 ) << 8 ) |
			( ( ( (		GRH.DiffuseColor & 0x000000ff )       ) * Blue )	/ 255 ) | 
			(			GRH.DiffuseColor & 0xff000000 ) ;

	// Cǂŏ𕪊
	if( FillFlag )
	{
		GETVERTEX_TRIANGLE( vec ) ;

		vec[ 0 ].color = Color ;

		vec[ 0 ].pos.x = ( float )x1 ; vec[ 0 ].pos.y = ( float )y1 ;

		// JOLɂȂĂꍇ̓JOȂ悤ɂ
		switch( GBASE.CullMode )
		{
		case 0 :	// JOȂ
			vec[ 1 ].pos.x = ( float )x2 ; vec[ 1 ].pos.y = ( float )y2 ;
			vec[ 2 ].pos.x = ( float )x3 ; vec[ 2 ].pos.y = ( float )y3 ;
			break ;

		case 1 :	// JO
			sx1 = x2 - x1 ;		sy1 = y2 - y1 ;
			sx2 = x3 - x1 ;		sy2 = y3 - y1 ;
			if( sx1 * sy2 - sy1 * sx2 > 0 )
			{
				vec[ 1 ].pos.x = ( float )x2 ; vec[ 1 ].pos.y = ( float )y2 ;
				vec[ 2 ].pos.x = ( float )x3 ; vec[ 2 ].pos.y = ( float )y3 ;
			}
			else
			{
				vec[ 1 ].pos.x = ( float )x3 ; vec[ 1 ].pos.y = ( float )y3 ;
				vec[ 2 ].pos.x = ( float )x2 ; vec[ 2 ].pos.y = ( float )y2 ;
			}
			break ;

		case 2 :	// EJO
			sx1 = x2 - x1 ;		sy1 = y2 - y1 ;
			sx2 = x3 - x1 ;		sy2 = y3 - y1 ;
			if( sx1 * sy2 - sy1 * sx2 < 0 )
			{
				vec[ 1 ].pos.x = ( float )x2 ; vec[ 1 ].pos.y = ( float )y2 ;
				vec[ 2 ].pos.x = ( float )x3 ; vec[ 2 ].pos.y = ( float )y3 ;
			}
			else
			{
				vec[ 1 ].pos.x = ( float )x3 ; vec[ 1 ].pos.y = ( float )y3 ;
				vec[ 2 ].pos.x = ( float )x2 ; vec[ 2 ].pos.y = ( float )y2 ;
			}
			break ;
		}

		*( ( DWORD * )&vec[ 0 ].pos.z ) =
		*( ( DWORD * )&vec[ 1 ].pos.z ) =
		*( ( DWORD * )&vec[ 2 ].pos.z ) = drawz ;

		if( GRH.UseAlphaChDrawShader )
		{
			vec[ 0 ].sc_u = ( vec[ 0 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
			vec[ 0 ].sc_v = ( vec[ 0 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
			vec[ 1 ].sc_u = ( vec[ 1 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
			vec[ 1 ].sc_v = ( vec[ 1 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
			vec[ 2 ].sc_u = ( vec[ 2 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
			vec[ 2 ].sc_v = ( vec[ 2 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
		}

		ADD3VERTEX_NOTEX
	}
	else
	{
		GETVERTEX_LINETRIANGLE( vec )

		vec[ 0 ].color =
		vec[ 1 ].color =
		vec[ 2 ].color =
		vec[ 3 ].color =
		vec[ 4 ].color =
		vec[ 5 ].color = Color ;

		vec[ 0 ].pos.x = ( float )x1 ; vec[ 0 ].pos.y = ( float )y1 ;
		vec[ 1 ].pos.x = ( float )x2 ; vec[ 1 ].pos.y = ( float )y2 ;
		vec[ 2 ].pos.x = ( float )x2 ; vec[ 2 ].pos.y = ( float )y2 ;
		vec[ 3 ].pos.x = ( float )x3 ; vec[ 3 ].pos.y = ( float )y3 ;
		vec[ 4 ].pos.x = ( float )x3 ; vec[ 4 ].pos.y = ( float )y3 ;
		vec[ 5 ].pos.x = ( float )x1 ; vec[ 5 ].pos.y = ( float )y1 ;
		*( ( DWORD * )&vec[ 0 ].pos.z ) =
		*( ( DWORD * )&vec[ 1 ].pos.z ) =
		*( ( DWORD * )&vec[ 2 ].pos.z ) =
		*( ( DWORD * )&vec[ 3 ].pos.z ) =
		*( ( DWORD * )&vec[ 4 ].pos.z ) =
		*( ( DWORD * )&vec[ 5 ].pos.z ) = drawz ;

		if( GRH.UseAlphaChDrawShader )
		{
			vec[ 0 ].sc_u = ( vec[ 0 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
			vec[ 0 ].sc_v = ( vec[ 0 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
			vec[ 1 ].sc_u = ( vec[ 1 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
			vec[ 1 ].sc_v = ( vec[ 1 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
			vec[ 2 ].sc_u = ( vec[ 2 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
			vec[ 2 ].sc_v = ( vec[ 2 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
			vec[ 3 ].sc_u = ( vec[ 3 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
			vec[ 3 ].sc_v = ( vec[ 3 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
			vec[ 4 ].sc_u = ( vec[ 4 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
			vec[ 4 ].sc_v = ( vec[ 4 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
			vec[ 5 ].sc_u = ( vec[ 5 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
			vec[ 5 ].sc_v = ( vec[ 5 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
		}

		ADD4VERTEX_LINETRIANGLE
	}

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawQuadrangle
static int DrawQuadrangleHardware( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, int Color, int FillFlag )
{
	VERTEX_NOTEX_2D VectData[ 5 ], *Vect ; 
	int Red, Green, Blue ;
	int i, Flag ;
	DWORD drawz;

	RenderVertexHardware() ;

	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	// `̏
	BeginScene() ;
	Flag = DRAWPREP_DIFFUSERGB ;
	DRAWPREP_NOTEX( Flag )

	// yobt@ɏނylZbg
	drawz = *((DWORD *)&GBASE.DrawZ);

	// F̑Xe[^X̃Zbg
	NS_GetColor2( Color, &Red, &Green, &Blue ) ;
	Color = ( ( ( ( (	GRH.DiffuseColor & 0x00ff0000 ) >> 16 ) * Red )		/ 255 ) << 16 ) |
			( ( ( ( (	GRH.DiffuseColor & 0x0000ff00 ) >> 8  ) * Green )	/ 255 ) << 8 ) |
			( ( ( (		GRH.DiffuseColor & 0x000000ff )       ) * Blue )	/ 255 ) | 
			(			GRH.DiffuseColor & 0xff000000 ) ;
	Vect = VectData ;
	for( i = 0 ; i < 5 ; i ++, Vect ++ )
	{
		Vect->color = Color ;
		Vect->rhw   = 1.0f ;
		*((DWORD *)&Vect->pos.z) = drawz ;
	}

	// FVF ̃Zbg
	SETFVF( VERTEXFVF_NOTEX_2D )

	// hԂǂŏ𕪊
	if( FillFlag )
	{
		// hԂ̏ꍇ
		VectData[ 0 ].pos.x = ( float )x1 ; VectData[ 0 ].pos.y = ( float )y1 ;
		VectData[ 1 ].pos.x = ( float )x2 ; VectData[ 1 ].pos.y = ( float )y2 ;
		VectData[ 2 ].pos.x = ( float )x4 ; VectData[ 2 ].pos.y = ( float )y4 ;
		VectData[ 3 ].pos.x = ( float )x3 ; VectData[ 3 ].pos.y = ( float )y3 ;

		if( GRH.UseAlphaChDrawShader )
		{
			VectData[ 0 ].sc_u = ( VectData[ 0 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
			VectData[ 0 ].sc_v = ( VectData[ 0 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
			VectData[ 1 ].sc_u = ( VectData[ 1 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
			VectData[ 1 ].sc_v = ( VectData[ 1 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
			VectData[ 2 ].sc_u = ( VectData[ 2 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
			VectData[ 2 ].sc_v = ( VectData[ 2 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
			VectData[ 3 ].sc_u = ( VectData[ 3 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
			VectData[ 3 ].sc_v = ( VectData[ 3 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
		}

		// ]
		{
			double Reverse0, Reverse1 ;
			VERTEX_NOTEX_2D VectTemp ;

			Reverse0 =  ( VectData[ 1 ].pos.x - VectData[ 0 ].pos.x ) * ( VectData[ 2 ].pos.y - VectData[ 0 ].pos.y ) -
					    ( VectData[ 2 ].pos.x - VectData[ 0 ].pos.x ) * ( VectData[ 1 ].pos.y - VectData[ 0 ].pos.y ) ;
			Reverse1 = -( VectData[ 1 ].pos.x - VectData[ 3 ].pos.x ) * ( VectData[ 2 ].pos.y - VectData[ 3 ].pos.y ) +
						( VectData[ 1 ].pos.y - VectData[ 3 ].pos.y ) * ( VectData[ 2 ].pos.x - VectData[ 3 ].pos.x ) ;
			if( Reverse0 <= 0 && Reverse1 <= 0 )
			{
				VectTemp = VectData[ 1 ] ; VectData[ 1 ] = VectData[ 2 ] ; VectData[ 2 ] = VectTemp ;
			}

			if( Reverse0 * Reverse1 >= 0 )
			{
				// v~eBu̕`
				GraphicsDevice_DrawPrimitiveUP( D_D3DPT_TRIANGLESTRIP, 2, VectData, sizeof( VERTEX_NOTEX_2D ) ) ;
			}
			else
			{
				// w]̕␳
				if( Reverse0 < 0 ) 
				{
					VectTemp = VectData[ 1 ] ; VectData[ 1 ] = VectData[ 2 ] ; VectData[ 2 ] = VectTemp ;
				}

				// v~eBu̕`
				GraphicsDevice_DrawPrimitiveUP( D_D3DPT_TRIANGLESTRIP, 2, VectData, sizeof( VERTEX_NOTEX_2D ) ) ;
			}
		}
	}
	else
	{
		// hԂł͖ꍇ
		VectData[ 0 ].pos.x = ( float )x1 ; VectData[ 0 ].pos.y = ( float )y1 ;
		VectData[ 1 ].pos.x = ( float )x2 ; VectData[ 1 ].pos.y = ( float )y2 ;
		VectData[ 2 ].pos.x = ( float )x3 ; VectData[ 2 ].pos.y = ( float )y3 ;
		VectData[ 3 ].pos.x = ( float )x4 ; VectData[ 3 ].pos.y = ( float )y4 ;
		VectData[ 4 ].pos.x = ( float )x1 ; VectData[ 4 ].pos.y = ( float )y1 ;

		// v~eBu̕`
		GraphicsDevice_DrawPrimitiveUP( D_D3DPT_LINESTRIP, 4, VectData, sizeof( VERTEX_NOTEX_2D ) ) ;
	}

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawPixel3D
static int DrawPixel3DHardware( VECTOR Pos, int Color, int DrawFlag, RECT *DrawArea )
{
	VERTEX_NOTEX_3D *VectData ; 
	int Red, Green, Blue ;
	int Flag ;

	if( DrawFlag )
	{
		if( GraphicsDevice_IsValid() == 0 ) return -1 ;

		// `̏
		if( GRH.BeginSceneFlag == FALSE ) BeginScene() ;
		if( GRH.RenderTexture != NULL ) SetTextureHardware( NULL ) ;

		Flag = DRAWPREP_DIFFUSERGB | DRAWPREP_3D | DRAWPREP_FOG ;
		DRAWPREP_NOTEX( Flag )

		// F̑Xe[^X̃Zbg
		GETVERTEX_POINT3D( VectData ) ;

		NS_GetColor2( Color, &Red, &Green, &Blue ) ;
		if( GRH.DiffuseColor == 0xffffffff )
		{
			*( ( DWORD * )&VectData->b ) = ( DWORD )( 0xff000000 | ( Red << 16 ) | ( Green << 8 ) | Blue ) ;
		}
		else
		{
			*( ( DWORD * )&VectData->b ) =	( ( ( ( (	GRH.DiffuseColor & 0x00ff0000 ) >> 16 ) * Red   )	/ 255 ) << 16 ) |
											( ( ( ( (	GRH.DiffuseColor & 0x0000ff00 ) >> 8  ) * Green )	/ 255 ) << 8  ) |
											( ( ( (		GRH.DiffuseColor & 0x000000ff )       ) * Blue  )	/ 255 ) | 
											(			GRH.DiffuseColor & 0xff000000 ) ;
		}

		// W̃Zbg
		VectData->pos = Pos ;

		// _̒ǉ
		ADD4VERTEX_POINT3D
	}
	else
	{
		VERTEX_2D TempVect ;

		// XN[Wɕϊ
		TempVect.pos.x = Pos.x * GBASE.BlendMatrix.m[0][0] + Pos.y * GBASE.BlendMatrix.m[1][0] + Pos.z * GBASE.BlendMatrix.m[2][0] + GBASE.BlendMatrix.m[3][0]  ;
		TempVect.pos.y = Pos.x * GBASE.BlendMatrix.m[0][1] + Pos.y * GBASE.BlendMatrix.m[1][1] + Pos.z * GBASE.BlendMatrix.m[2][1] + GBASE.BlendMatrix.m[3][1]  ;
		TempVect.pos.z = Pos.x * GBASE.BlendMatrix.m[0][2] + Pos.y * GBASE.BlendMatrix.m[1][2] + Pos.z * GBASE.BlendMatrix.m[2][2] + GBASE.BlendMatrix.m[3][2]  ;
		TempVect.rhw   = Pos.x * GBASE.BlendMatrix.m[0][3] + Pos.y * GBASE.BlendMatrix.m[1][3] + Pos.z * GBASE.BlendMatrix.m[2][3] + GBASE.BlendMatrix.m[3][3]  ;

		TempVect.rhw = 1.0F / TempVect.rhw ;
		TempVect.pos.x *= TempVect.rhw ;
		TempVect.pos.y *= TempVect.rhw ;
		TempVect.pos.z *= TempVect.rhw ;

		DrawArea->left   = _FTOL( TempVect.pos.x ) - 1 ;
		DrawArea->right  = _FTOL( TempVect.pos.x ) + 1 ;
		DrawArea->top    = _FTOL( TempVect.pos.y ) - 1 ;
		DrawArea->bottom = _FTOL( TempVect.pos.y ) + 1 ;
	}

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawPixel
static int	DrawPixelHardware( int x, int y, int Color )
{
	VERTEX_NOTEX_2D *VectData ;
	int Red, Green, Blue, Flag ;

	if( GraphicsDevice_IsValid() == 0 ) return -1 ; 

	// `̏
	if( GRH.BeginSceneFlag == FALSE ) BeginScene() ;
	Flag = DRAWPREP_DIFFUSERGB ;
	DRAWPREP_NOTEX( Flag )

	// F̑Xe[^X̃Zbg
	GETVERTEX_POINT( VectData ) ;

	if( GRH.DiffuseColor == 0xffffffff )
	{
		NS_GetColor2( Color, &Red, &Green, &Blue ) ;
		VectData->color = 0xff000000 | ( Red << 16 ) | ( Green << 8 ) | Blue ;
	}
	else
	{
		NS_GetColor2( Color, &Red, &Green, &Blue ) ;
		VectData->color =	( ( ( ( (	GRH.DiffuseColor & 0x00ff0000 ) >> 16 ) * Red   )	/ 255 ) << 16 ) |
							( ( ( ( (	GRH.DiffuseColor & 0x0000ff00 ) >> 8  ) * Green )	/ 255 ) << 8  ) |
							( ( ( (		GRH.DiffuseColor & 0x000000ff )       ) * Blue  )	/ 255 ) | 
							(			GRH.DiffuseColor & 0xff000000 ) ;
	}

	// W̃Zbg
	VectData->pos.x = ( float )x ;
	VectData->pos.y = ( float )y ;
	VectData->pos.z = GBASE.DrawZ;

	if( GRH.UseAlphaChDrawShader )
	{
		VectData->sc_u = ( VectData->pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
		VectData->sc_v = ( VectData->pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
	}

	// _̒ǉ
	ADD4VERTEX_POINT

	// I
	return 0 ;
}

// n[hEGAANZ[^gp DrawPixelSet
#define SetDrawNum (1000)
static int	DrawPixelSetHardware( const POINTDATA *PointData, int Num )
{
	int i, j, k ;
	static VERTEX_NOTEX_2D VectData[ SetDrawNum ], *Vect ;
	COLORDATA ColorData ;
	int MaxRed, MaxGreen, MaxBlue ; 
	int Color, Flag ;
	DWORD drawz;

	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	RenderVertexHardware() ;

	// `̏
	BeginScene() ;
	Flag = DRAWPREP_DIFFUSERGB ;
	DRAWPREP_NOTEX( Flag )

	// yobt@ɏނylZbg
	drawz = *((DWORD *)&GBASE.DrawZ);

	// xNg{Xe[^X擾
	ColorData = *( ( COLORDATA * )NS_GetDispColorData() ) ;
	
	MaxRed		= ( 1 << ColorData.RedWidth	) - 1 ; 
	MaxGreen	= ( 1 << ColorData.GreenWidth ) - 1 ;
	MaxBlue		= ( 1 << ColorData.BlueWidth ) - 1 ; 

	j = 0 ;
	Vect = VectData ;

	// FVF ̃Zbg
	SETFVF( VERTEXFVF_NOTEX_2D )

	for( i = 0 ; i < Num ; i ++, PointData ++ )
	{
		// F̑Xe[^X̃Zbg
		Color = PointData->color ;
		Vect->color = ( PointData->pal << 24 ) |
						( ( ( ( ( ( Color & ColorData.RedMask	) >> ColorData.RedLoc	) << 8 ) - 1 ) / MaxRed		) << 16 ) |
						( ( ( ( ( ( Color & ColorData.GreenMask	) >> ColorData.GreenLoc	) << 8 ) - 1 ) / MaxGreen	) << 8 ) |
						( ( ( ( ( ( Color & ColorData.BlueMask	) >> ColorData.BlueLoc	) << 8 ) - 1 ) / MaxBlue	) ) ; 
		Vect->rhw	= 1.0f ;
		*((DWORD *)&Vect->pos.z) = drawz ;

		// W̃ZbgEChEڕ`掞␳
		Vect->pos.x = ( float )PointData->x ;
		Vect->pos.y = ( float )PointData->y ;

		j ++ ;
		Vect ++ ;
		if( j == SetDrawNum )
		{
			if( GRH.UseAlphaChDrawShader )
			{
				for( k = 0 ; k < j ; k ++ )
				{
					VectData[ k ].sc_u = ( VectData[ k ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					VectData[ k ].sc_v = ( VectData[ k ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
				}
			}

			// `
			GraphicsDevice_DrawPrimitiveUP( D_D3DPT_POINTLIST, j, VectData, sizeof( VERTEX_NOTEX_2D ) ) ;
			j = 0 ;
			Vect = VectData ;
		}
	}

	if( j != 0 )
	{
		// `
		GraphicsDevice_DrawPrimitiveUP( D_D3DPT_POINTLIST, j, VectData, sizeof( VERTEX_NOTEX_2D ) ) ;
	}

	// I
	return 0;
}

// n[hEGAANZ[^gp DrawLineSet
static int	DrawLineSetHardware( const LINEDATA *LineData, int Num )
{
	int i, j, k, l ;
	static VERTEX_NOTEX_2D VectData[ SetDrawNum ], *Vect ;
	COLORDATA ColorData ;
	int MaxRed, MaxGreen, MaxBlue ; 
	int Color, Flag ;
	DWORD drawz;

	if( GraphicsDevice_IsValid() == 0 ) return -1 ;

	RenderVertexHardware() ;

	// `̏
	BeginScene() ;
	Flag = DRAWPREP_DIFFUSERGB ;
	DRAWPREP_NOTEX( Flag )

	// yobt@ɏނylZbg
	drawz = *((DWORD *)&GBASE.DrawZ);

	// xNg{Xe[^X擾
	ColorData = *( ( COLORDATA * )NS_GetDispColorData() ) ;
	
	MaxRed		= ( 1 << ColorData.RedWidth	) - 1 ; 
	MaxGreen	= ( 1 << ColorData.GreenWidth ) - 1 ;
	MaxBlue		= ( 1 << ColorData.BlueWidth ) - 1 ; 

	j = 0 ;
	Vect = VectData ;

	// FVF ̐ݒ
	SETFVF( VERTEXFVF_NOTEX_2D )

	for( i = 0 ; i < Num ; i ++, LineData ++ )
	{
		// F̑Xe[^X̃Zbg
		Color = LineData->color ;
		Vect[0].color = ( LineData->pal << 24 ) |
						( ( ( ( ( ( Color & ColorData.RedMask	) >> ColorData.RedLoc	) << 8 ) - 1 ) / MaxRed		) << 16 ) |
						( ( ( ( ( ( Color & ColorData.GreenMask	) >> ColorData.GreenLoc	) << 8 ) - 1 ) / MaxGreen	) << 8 ) |
						( ( ( ( ( ( Color & ColorData.BlueMask	) >> ColorData.BlueLoc	) << 8 ) - 1 ) / MaxBlue	) ) ; 
		Vect[1].color = Vect[0].color ;
		Vect[0].rhw	  =
		Vect[1].rhw   = 1.0f ;
		*((DWORD *)&Vect[0].pos.z) =
		*((DWORD *)&Vect[1].pos.z) = drawz;
 
		// W̃ZbgEChEڕ`掞␳
		Vect[0].pos.x = ( float )LineData->x1 ;
		Vect[0].pos.y = ( float )LineData->y1 ;
		Vect[1].pos.x = ( float )LineData->x2 ;
		Vect[1].pos.y = ( float )LineData->y2 ;

		j ++ ;
		Vect += 2 ;
		if( j * 2 == SetDrawNum )
		{
			if( GRH.UseAlphaChDrawShader )
			{
				l = 0 ;
				for( k = 0 ; k < j ; k ++, l += 2 )
				{
					VectData[ l + 0 ].sc_u = ( VectData[ l + 0 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					VectData[ l + 0 ].sc_v = ( VectData[ l + 0 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
					VectData[ l + 1 ].sc_u = ( VectData[ l + 1 ].pos.x + 0.5f ) * GRH.RenderTargetTextureInvWidth ;
					VectData[ l + 1 ].sc_v = ( VectData[ l + 1 ].pos.y + 0.5f ) * GRH.RenderTargetTextureInvHeight ;
				}
			}

			// `
			GraphicsDevice_DrawPrimitiveUP( D_D3DPT_LINELIST, j, VectData, sizeof( VERTEX_NOTEX_2D ) ) ;
			j = 0 ;
			Vect = VectData ;
		}
	}

	if( j != 0 )
	{
		// `
		GraphicsDevice_DrawPrimitiveUP( D_D3DPT_LINELIST, j, VectData, sizeof( VERTEX_NOTEX_2D ) ) ;
	}

	// I
	return 0;
}

// \tgEGA_O DrawGraph
static int  DrawGraphSoftware( int x, int y, IMAGEDATA2 *Image2, int TransFlag )
{
	DrawMemImg( GRS.TargetMemImg, &Image2->Soft.MemImg, x, y, TransFlag, GRS.BlendMemImg ) ;

	// I
	return 0 ;
}

// \tgEGA_O DrawExtendGraph
static int  DrawExtendGraphSoftware( int x1, int y1, int x2, int y2, IMAGEDATA2 *Image2, int TransFlag )
{
	RECT Rect ;

	Rect.left   = x1 ;
	Rect.top    = y1 ;
	Rect.right  = x2 ;
	Rect.bottom = y2 ;

	DrawEnlargeMemImg( GRS.TargetMemImg, &Image2->Soft.MemImg, &Rect, TransFlag, GRS.BlendMemImg ) ;

	// I
	return 0 ;
}

// \tgEGA_O DrawRotaGraph
static int  DrawRotaGraphSoftware( float x, float y, double ExRate, double Angle, IMAGEDATA2 *Image2, int TransFlag, int TurnFlag )
{
	DrawRotationMemImg( GRS.TargetMemImg, &Image2->Soft.MemImg,
		_FTOL( x ), _FTOL( y ), ( float )Angle, ( float )ExRate, TransFlag, TurnFlag, GRS.BlendMemImg ) ;

	// I
	return 0 ;
}

static int	DrawPolySoftware( DX_POINTDATA *p, IMAGEDATA2 *Image2, int TransFlag, int Color )
{
	DrawBasicPolygonMemImg( GRS.TargetMemImg, Image2 ? &Image2->Soft.MemImg : NULL, 
							p, TransFlag, GRS.BlendMemImg, Color ) ;

	// I
	return 0 ;
}

// \tgEGA_O DrawModiGraph
static int  DrawModiGraphSoftware( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, IMAGEDATA2 *Image2, int TransFlag )
{
	DX_POINTDATA p[4] ;

	p[0].x = x1 ;		p[0].y = y1 ;		p[0].u = 0 ;				p[0].v = 0 ;
	p[1].x = x2 ;		p[1].y = y2 ;		p[1].u = Image2->Width ;	p[1].v = 0 ;
	p[2].x = x3 ;		p[2].y = y3 ;		p[2].u = 0 ;				p[2].v = Image2->Height ;
	p[3].x = x4 ;		p[3].y = y4 ;		p[3].u = Image2->Width ;	p[3].v = Image2->Height ;

	DrawPolySoftware( &p[0], Image2, TransFlag, 0 ) ;
	DrawPolySoftware( &p[1], Image2, TransFlag, 0 ) ;

	// I
	return 0 ;
}

// \tgEGA_O DrawModiGraphF
static int  DrawModiGraphFSoftware( float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, IMAGEDATA2 *Image2, int TransFlag )
{
	return DrawModiGraphSoftware( _FTOL( x1 ), _FTOL( y1 ), _FTOL( x2 ), _FTOL( y2 ), _FTOL( x3 ), _FTOL( y3 ), _FTOL( x4 ), _FTOL( y4 ), Image2, TransFlag ) ;
}

// \tgEGA_O DrawFillBox
static int  DrawFillBoxSoftware( int x1, int y1, int x2, int y2, int Color )
{
	RECT DestRect ;

	DestRect.left   = x1 ;
	DestRect.top    = y1 ;
	DestRect.right  = x2 ;
	DestRect.bottom = y2 ;

	DrawFillBoxMemImg( GRS.TargetMemImg, &DestRect, Color ) ;

	// I
	return 0 ;
}

// \tgEGA_O DrawLine
static int	DrawLineSoftware( int x1, int y1, int x2, int y2, int Color )
{
	DrawLineMemImg( GRS.TargetMemImg, x1, y1, x2, y2, Color ) ;

	// I
	return 0 ;
}

// \tgEGA_O DrawLineBox
static int  DrawLineBoxSoftware( int x1, int y1, int x2, int y2, int Color )
{
	LINEDATA Line[4] ;

	Line[0].x1 = x1 ;		Line[0].y1 = y1 ;		Line[0].x2 = x2 - 1 ;	Line[0].y2 = y1 ;
	Line[1].x1 = x2 - 1 ;	Line[1].y1 = y1 ;		Line[1].x2 = x2 - 1 ;	Line[1].y2 = y2 - 1 ;
	Line[2].x1 = x2 - 1 ;	Line[2].y1 = y2 - 1 ;	Line[2].x2 = x1 ;		Line[2].y2 = y2 - 1 ;
	Line[3].x1 = x1 ;		Line[3].y1 = y2 - 1 ;	Line[3].x2 = x1 ;		Line[3].y2 = y1 ;
	Line[3].color = Line[2].color = Line[1].color = Line[0].color = Color ;
	Line[3].pal   = Line[2].pal   = Line[1].pal   = Line[0].pal   = GBASE.BlendParam ;

	return DrawLineSetSoftware( Line, 4 ) ;
}

// \tgEGA_O DrawCircle( w肠 )
static int	DrawCircle_ThicknessSoftware( int x, int y, int r, int Color, int Thickness )
{
	int i ;
	RECT DrawRect ;
	short ( *CirclePos )[ 5 ] ;
	int x1, x2, y1 ;

	DrawRect = GBASE.DrawArea ;

	// ~̍Wobt@擾
	if( AllocCommonBuffer( 1, sizeof( short ) * 5 * DrawRect.bottom ) < 0 )
	{
		return -1 ;
	}
	CirclePos = ( short (*)[ 5 ] )GRH.CommonBuffer[ 1 ] ;
	_MEMSET( CirclePos, 0, sizeof( short ) * 5 * DrawRect.bottom ) ;

	// ~̍WXg쐬
	GetCircle_ThicknessDrawPosition( x, y, r, Thickness, CirclePos ) ;

	// `揈
	for( i = DrawRect.top ; i < DrawRect.bottom ; i ++ )
	{
		if( CirclePos[ i ][ 4 ] == 0 )
		{
			continue ;
		}

		y1 = i ;

		if( ( CirclePos[ i ][ 4 ] & ( 4 | 8 ) ) == 0 || CirclePos[ i ][ 2 ] >= CirclePos[ i ][ 3 ] )
		{
			x1 = CirclePos[ i ][ 0 ] ;
			x2 = CirclePos[ i ][ 1 ] ;
			DrawLineMemImg( GRS.TargetMemImg, x1, y1, x2 + 1, y1, Color ) ;
		}
		else
		{
			x1 = CirclePos[ i ][ 0 ] ;
			x2 = CirclePos[ i ][ 2 ] ;
			DrawLineMemImg( GRS.TargetMemImg, x1, y1, x2 + 1, y1, Color ) ;

			x1 = CirclePos[ i ][ 3 ] ;
			x2 = CirclePos[ i ][ 1 ] ;
			DrawLineMemImg( GRS.TargetMemImg, x1, y1, x2 + 1, y1, Color ) ;
		}
	}

	// I
	return 0 ;
}

// \tgEGA_O DrawOval( w肠 )
static int	DrawOval_ThicknessSoftware( int x, int y, int rx, int ry, int Color, int Thickness )
{
	int i ;
	RECT DrawRect ;
	short ( *CirclePos )[ 5 ] ;
	int x1, x2, y1 ;

	DrawRect = GBASE.DrawArea ;

	// ~̍Wobt@擾
	if( AllocCommonBuffer( 1, sizeof( short ) * 5 * DrawRect.bottom ) < 0 )
	{
		return -1 ;
	}
	CirclePos = ( short (*)[ 5 ] )GRH.CommonBuffer[ 1 ] ;
	_MEMSET( CirclePos, 0, sizeof( short ) * 5 * DrawRect.bottom ) ;

	// ~̍WXg쐬
	GetOval_ThicknessDrawPosition( x, y, rx, ry, Thickness, CirclePos ) ;

	// `揈
	for( i = DrawRect.top ; i < DrawRect.bottom ; i ++ )
	{
		if( CirclePos[ i ][ 4 ] == 0 )
		{
			continue ;
		}

		y1 = i ;

		if( ( CirclePos[ i ][ 4 ] & ( 4 | 8 ) ) == 0 || CirclePos[ i ][ 2 ] >= CirclePos[ i ][ 3 ] )
		{
			x1 = CirclePos[ i ][ 0 ] ;
			x2 = CirclePos[ i ][ 1 ] ;
			DrawLineMemImg( GRS.TargetMemImg, x1, y1, x2 + 1, y1, Color ) ;
		}
		else
		{
			x1 = CirclePos[ i ][ 0 ] ;
			x2 = CirclePos[ i ][ 2 ] ;
			DrawLineMemImg( GRS.TargetMemImg, x1, y1, x2 + 1, y1, Color ) ;

			x1 = CirclePos[ i ][ 3 ] ;
			x2 = CirclePos[ i ][ 1 ] ;
			DrawLineMemImg( GRS.TargetMemImg, x1, y1, x2 + 1, y1, Color ) ;
		}
	}

	// I
	return 0 ;
}

// \tgEGA_O DrawCircle
static int	DrawCircleSoftware( int x, int y, int r, int Color, int FillFlag )
{
	DrawCircleMemImg( GRS.TargetMemImg, x, y, r, Color, FillFlag ) ;

	// I
	return 0 ;
}

// \tgEGA_O DrawOval
static int	DrawOvalSoftware( int x, int y, int rx, int ry, int Color, int FillFlag )
{
	DrawOvalMemImg( GRS.TargetMemImg, x, y, rx, ry, Color, FillFlag ) ;

	// I
	return 0 ;
}

// \tgEGA_O DrawTriangle
static int	DrawTriangleSoftware( int x1, int y1, int x2, int y2, int x3, int y3, int Color, int FillFlag )
{
	// hԂłȂŏ𕪊
	if( FillFlag == TRUE )
	{
		// hԂ̏ꍇ
		DX_POINTDATA p[3] ;

		p[0].x = x1 ;		p[0].y = y1 ;
		p[1].x = x2 ;		p[1].y = y2 ;
		p[2].x = x3 ;		p[2].y = y3 ;
	
		return DrawPolySoftware( p, NULL, FALSE, Color ) ;
	}
	else
	{
		LINEDATA Line[3] ;
		
		Line[0].x1 = x1 ;	Line[0].y1 = y1 ;	Line[0].x2 = x2 ;	Line[0].y2 = y2 ;
		Line[1].x1 = x2 ;	Line[1].y1 = y2 ;	Line[1].x2 = x3 ;	Line[1].y2 = y3 ;
		Line[2].x1 = x3 ;	Line[2].y1 = y3 ;	Line[2].x2 = x1 ;	Line[2].y2 = y1 ;
		Line[2].color = Line[1].color = Line[0].color = Color ;
		Line[2].pal   = Line[1].pal   = Line[0].pal   = GBASE.BlendParam ;
		return DrawLineSetSoftware( Line, 3 ) ;
	}
}

// \tgEGA_O DrawQuadrangle
static int	DrawQuadrangleSoftware( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, int Color, int FillFlag )
{
	// hԂłȂŏ𕪊
	if( FillFlag == TRUE )
	{
		// hԂ̏ꍇ

		DX_POINTDATA p[3] ;

		p[0].x = x1 ;		p[0].y = y1 ;
		p[1].x = x2 ;		p[1].y = y2 ;
		p[2].x = x4 ;		p[2].y = y4 ;
		DrawPolySoftware( p, NULL, FALSE, Color ) ;

		p[0].x = x3 ;		p[0].y = y3 ;
		p[1].x = x4 ;		p[1].y = y4 ;
		p[2].x = x2 ;		p[2].y = y2 ;
		return DrawPolySoftware( p, NULL, FALSE, Color ) ;
	}
	else
	{
		LINEDATA Line[4] ;
		
		Line[0].x1 = x1 ;	Line[0].y1 = y1 ;	Line[0].x2 = x2 ;	Line[0].y2 = y2 ;
		Line[1].x1 = x2 ;	Line[1].y1 = y2 ;	Line[1].x2 = x3 ;	Line[1].y2 = y3 ;
		Line[2].x1 = x3 ;	Line[2].y1 = y3 ;	Line[2].x2 = x4 ;	Line[2].y2 = y4 ;
		Line[3].x1 = x4 ;	Line[3].y1 = y4 ;	Line[3].x2 = x1 ;	Line[3].y2 = y1 ;
		Line[3].color = Line[2].color = Line[1].color = Line[0].color = Color ;
		Line[3].pal   = Line[2].pal   = Line[1].pal   = Line[0].pal   = GBASE.BlendParam ;
		return DrawLineSetSoftware( Line, 4 ) ;
	}
}


// \tgEGA_O DrawPixel
static int	DrawPixelSoftware( int x, int y, int Color )
{
	DrawPixelMemImg( GRS.TargetMemImg, x, y, Color ) ;

	// I
	return 0 ;
}

// \tgEGA_O DrawChipMap
static int	DrawChipMapSoftware( int Sx, int Sy, int XNum, int YNum, const int *MapData, int MapDataPitch, int /*ChipTypeNum*/, const int *ChipGrHandle, int TransFlag )
{
	int x, y, i, j, Width, Height, Pitch2 ;
	const int *MP ;
	IMAGEDATA2 *Image2 ;

	if( GRAPHCHK( ChipGrHandle[ 0 ], Image2 ) )
		return -1 ;

	Width = Image2->Width ;
	Height = Image2->Height ;

	Pitch2 = MapDataPitch - XNum ;

	// ʂ for Ń[v`
	y = Sy ;
	MP = MapData ;
	for( i = 0 ; i < YNum ; i ++, y += Height )
	{
		x = Sx ;
		for( j = 0 ; j < XNum ; j ++, x += Width, MP ++ )
		{
			if( *MP == -1 ) continue ;

			if( GRAPHCHK( ChipGrHandle[ *MP ], Image2 ) )
				return -1 ;

			DrawGraphSoftware( x, y, Image2, TransFlag ) ;
		}
		MP += Pitch2 ;
	}

	// I
	return 0 ;
}

// \tgEGA_O DrawTile
static int	DrawTileSoftware( int x1, int y1, int x2, int y2, int Tx, int Ty, double ExtRate, double Angle, IMAGEDATA2 *Image2, int TransFlag )
{
	double MaxLength ;
	float Width, Height, f, Sin, Cos ;
	float CenX, CenY, x, y, BaseX, BaseY ;
	float xAddX, xAddY, yAddX, yAddY ;
	int temp, Num, i, j ;
	RECT DrawRect ;
	float FAngle, FExtRate, Sin2, Cos2 ;

	FAngle = ( float )Angle ;
	FExtRate = ( float )ExtRate ;

	if( ExtRate <= 0.0 ) ExtRate = 0.0001 ;
	if( x1 > x2 ){ temp = x2 ; x2 = x1 ; x1 = temp ; }
	if( y1 > y2 ){ temp = y2 ; y2 = y1 ; y1 = temp ; }
	Tx %= Image2->Width ;
	Ty %= Image2->Height ;

	_SINCOS( FAngle, &Sin, &Cos ) ;
//	Sin = (float)sin( Angle ) ;
//	Cos = (float)cos( Angle ) ;

	// iޒlvZ
	xAddX = Image2->Width * Cos * FExtRate ;
	xAddY = Image2->Width * Sin * FExtRate ;

	_SINCOS( FAngle + DX_PI_F / 2.0F, &Sin2, &Cos2 ) ;
	yAddX = Image2->Height * Cos2 * FExtRate ;
	yAddY = Image2->Height * Sin2 * FExtRate ;

	// `敝𓾂
	Width = (float)( x2 - x1 ) ;
	Height = (float)( y2 - y1 ) ;

	// ő咷𓾂
	MaxLength = _SQRT( Width * Width + Height * Height ) ;

	// `𓾂
	{
		int k ;

		k = Image2->Width > Image2->Height ? Image2->Height : Image2->Width ;
		Num = _DTOL( MaxLength / ( k * ExtRate ) + 2 ) ;
		if( Num % 2 == 0 ) Num ++ ;
	}

	// `撆S_𓾂
	CenX = x1 + Width / 2 ;
	CenY = y1 + Height / 2 ;

	// `\͈͂ύX
	DrawRect = GBASE.DrawArea ;
	NS_SetDrawArea( x1, y1, x2, y2 ) ;

	// `JnW𓾂
	BaseX = ( -Tx - ( Num * Image2->Width  ) / 2 ) * FExtRate ;
	BaseY = ( -Ty - ( Num * Image2->Height ) / 2 ) * FExtRate ;

	f = BaseX * Cos - BaseY * Sin ;
	BaseY = BaseX * Sin + BaseY * Cos + CenY ;
	BaseX = f + CenX ;

	// `Jn
	for( i = 0 ; i < Num ; i ++, BaseX += yAddX, BaseY += yAddY )
	{
		x = BaseX ;
		y = BaseY ;
		for( j = 0 ; j < Num ; j ++, x += xAddX, y += xAddY )
		{
			if( Angle == 0.0 )
			{
				if( ExtRate == 0.0 )
				{
					DrawGraphSoftware( _FTOL( x ), _FTOL( y ), Image2, TransFlag ) ;
				}
				else
				{
					DrawExtendGraphSoftware( _FTOL( x ), _FTOL( y ),
											 _FTOL( x + xAddX ),
											 _FTOL( y + yAddY ), Image2, TransFlag ) ;
				}
			}
			else
			{
				DrawModiGraphSoftware( _FTOL( x ), _FTOL( y ),
								_FTOL( x + xAddX ), _FTOL( y + xAddY ),
								_FTOL( x + yAddX ), _FTOL( y + yAddY ),
								_FTOL( x + xAddX + yAddX ), _FTOL( y + xAddY + yAddY ),
								Image2, TransFlag ) ;
			}
		}
	}

	// `\͈͂ɖ߂
	NS_SetDrawArea( DrawRect.left, DrawRect.top, DrawRect.right, DrawRect.bottom ) ;

	return 0 ;
}

// \tgEGA_O DrawPixelSet
static int	DrawPixelSetSoftware( const POINTDATA *PointData, int Num )
{
	DrawPixelSetMemImg( GRS.TargetMemImg, PointData, Num ) ;

	// I
	return 0 ;
}

// \tgEGA_O DrawLineSet
static int	DrawLineSetSoftware( const LINEDATA *LineData, int Num )
{
	DrawLineSetMemImg( GRS.TargetMemImg, LineData, Num ) ;

	// I
	return 0 ;
}

// foCXXgɍ폜tOĂOtBbN폜
static int DeleteDeviceLostDeleteGraph( void )
{
	int i ;
	IMAGEDATA2 *Image2 ;

	if( HandleManageArray[ DX_HANDLETYPE_GRAPH ].InitializeFlag )
	{
		for( i = HandleManageArray[ DX_HANDLETYPE_GRAPH ].AreaMin ; i <= HandleManageArray[ DX_HANDLETYPE_GRAPH ].AreaMax ; i ++ )
		{
			Image2 = ( IMAGEDATA2 * )HandleManageArray[ DX_HANDLETYPE_GRAPH ].Handle[ i ] ;

			if( Image2 == NULL ) continue ;
			if( Image2->Orig == NULL ) continue ;
			if( Image2->DeviceLostDeleteFlag == FALSE ) continue ;

			SubHandle( Image2->HandleInfo.Handle ) ;
		}
	}

	// I
	return 0 ;
}

// TuobNobt@gp鏀s( 0:  -1:s )
static int SetupSubBackBuffer()
{
	// ɃTuobNobt@쐬Ăꍇ͉Ȃ
	if( GRH.SubBackBufferSurface != NULL ) return 0 ;

	// `foĂ
	RenderVertexHardware() ;
	EndScene() ;

	// TuobNobt@̍쐬
	if( CreateSubBackBufferSurface() == -1 )
		return -1 ;

	// {obNobt@̓e]
	GraphicsDevice_StretchRect( GRH.BackBufferSurface, NULL, GRH.SubBackBufferSurface, NULL, D_D3DTEXF_NONE ) ;

	// _O^[Qbg̕ύX
	GRH.InitializeFlag = TRUE ;
	SetRenderTargetHardware( GRH.SubBackBufferSurface ) ;
	GRH.InitializeFlag = FALSE ;

	// I
	return 0 ;
}

// SetDrawBright ̈
extern void FASTCALL SetDrawBrightToOneParam( DWORD Bright )
{
	Bright &= 0xffffff ;
	if( GBASE.bDrawBright == Bright ) return ;

	// Pxۑ
	GBASE.bDrawBright = Bright ;
	SetMemImgDrawBright( Bright ) ;
	GRH.DrawPrepAlwaysFlag = TRUE ;

	// Direct3D ɐݒ𔽉f
	if( GRA2.ValidHardWare )
	{
		// fBt[YJ[̍XV
		GRH.DiffuseColor = GetDiffuseColor() ;
	}
}

// ⏕֐
extern void FASTCALL BlendModeSub_Pre( RECT *DrawRect )
{
	DWORD Bright, Cr, BlendParam ;

	Cr = NS_GetColor( 255,255,255 ) ;
	Bright = GBASE.bDrawBright ;
	BlendParam = GBASE.BlendParam ;

	SetDrawBrightToOneParam( 0xffffff ) ;
	NS_SetDrawBlendMode( DX_BLENDMODE_SUB, 255 ) ;

	DrawFillBoxHardware( DrawRect->left, DrawRect->top, DrawRect->right, DrawRect->bottom, Cr ) ;

	SetDrawBrightToOneParam( Bright ) ;
	NS_SetDrawBlendMode( DX_BLENDMODE_SUB2, BlendParam ) ;
}

extern void FASTCALL BlendModeSub_Post( RECT *DrawRect )
{
	DWORD Bright, Cr, BlendParam ;

	Cr = NS_GetColor( 255,255,255 ) ;
	Bright = GBASE.bDrawBright ;
	BlendParam = GBASE.BlendParam ;

	SetDrawBrightToOneParam( 0xffffff ) ;
	NS_SetDrawBlendMode( DX_BLENDMODE_SUB, 255 ) ; 
	
	DrawFillBoxHardware( DrawRect->left, DrawRect->top, DrawRect->right, DrawRect->bottom, Cr ) ;

	SetDrawBrightToOneParam( Bright ) ;
	NS_SetDrawBlendMode( DX_BLENDMODE_SUB, BlendParam ) ;
}

extern void FASTCALL AlphaChDraw_Pre( RECT *DrawRect )
{
	RenderVertexHardware() ;
	GraphicsDevice_StretchRect( GRH.RenderTargetSurface, DrawRect, GRH.RenderTargetCopySurface, DrawRect, D_D3DTEXF_NONE ) ;
}

extern int GetWorkTexture( DWORD TexSizeW, DWORD TexSizeH, DWORD HandleIndex )
{
	IMAGEDATA2 *Image ;
	DWORD TexSizeBig ;
	DWORD NPow ;
	int TexSize ;

	TexSizeBig = TexSizeW > TexSizeH ? TexSizeW : TexSizeH ;
	for( NPow = 0 ; ( DWORD )( 1 << NPow ) < TexSizeBig ; NPow ++ ){}
	TexSize = ( int )( 1 << NPow ) ;

	if( GRAPHCHK( GRH.WorkDrawValidGrHandle[ NPow ][ HandleIndex ], Image ) )
	{
		SETUP_GRAPHHANDLE_GPARAM GParam ;

		InitSetupGraphHandleGParam_Normal_DrawValid_NoneZBuffer( &GParam, 32, TRUE ) ;

		GRH.WorkDrawValidGrHandle[ NPow ][ HandleIndex ] = MakeGraph_UseGParam( &GParam, TexSize, TexSize, FALSE, FALSE ) ;
		if( GRH.WorkDrawValidGrHandle[ NPow ][ HandleIndex ] < 0 )
		{
			DXST_ERRORLOGFMT_ADD(( _T( "Ɨp`\eNX`̍쐬Ɏs܂ Size:%dx%d" ), TexSize, TexSize )) ;
			return -1 ;
		}
	}

	return GRH.WorkDrawValidGrHandle[ NPow ][ HandleIndex ] ;
}

extern int SetUseAutoMipMap( int UseFlag, int MaxLevel )
{
	if( UseFlag == TRUE )
	{
		GRH.MipMapCount = MaxLevel ;
	}
	else
	{
		GRH.MipMapCount = 0 ;
	}

	// I
	return 0 ;
}

// w̃eNX`[TCY肭
static int ListUpTexSize( int Size, short *SizeList, int NotDivFlag, int Pow2Flag, int MaxTextureSize )
{
	int DivNum ;
	int TexSize, GraphSize, MaxTexSize ;

	// őTCYZbg
	MaxTexSize = MaxTextureSize != 0 ? MaxTextureSize : GRH.MaxTextureSize ;

	// Q̂ł͂Ȃėǂꍇ͎w̃TCYőeNX`TCYȉ炻̂܂ܕԂ
	if( Pow2Flag == FALSE && ( GRH.TextureSizePow2 == FALSE || GRH.TextureSizeNonPow2Conditional ) )
	{
		if( Size <= MaxTexSize )
		{
			if( SizeList ) SizeList[ 0 ] = ( short )Size ;
			return 1 ;
		}
	}

	// sŏTCỸeNX`菬ꍇ͍ŏTCYZbgĂPԂ
	if( MIN_TEXTURE_SIZE >= Size )
	{
		if( SizeList ) SizeList[ 0 ] = MIN_TEXTURE_SIZE ;
		return 1 ;
	}

	// Pԍŏ̃eNX`[͎wTCYɎ܂o邾傫eNX`[ɂ
	DivNum = 0 ;
	TexSize = MaxTexSize ;
	while( TexSize > MIN_TEXTURE_SIZE )
	{
		if( TexSize <= Size ) break ;
		TexSize >>= 1 ;
	}

	// sȂꍇ͈ꖇŎ߂ꍇ͎߂ďI
	if( NotDivFlag != FALSE )
	{
		if( ( TexSize << 1 ) <= MaxTexSize )
		{
			if( TexSize < Size ) TexSize <<= 1 ;
			if( SizeList ) SizeList[ 0 ] = ( short )TexSize ;
			return 1 ;
		}
	}
	else
	// sw̏ꍇł쐬摜̃TCY
	// ʂƓA[U[w̃TCYꍇ
	// ȂׂsȂ
	if( MaxTextureSize == 0 )
	{
		if( Size <= GRA2.MainScreenSizeX )
		{
			if( ( TexSize << 1 ) <= MaxTexSize )
			{
				if( TexSize < Size ) TexSize <<= 1 ;
				if( SizeList ) SizeList[ 0 ] = ( short )TexSize ;
				return 1 ;
			}
		}
	}

	// 
	GraphSize = Size ;
	for(;;)
	{
		if( SizeList ) SizeList[ DivNum ] = ( short )TexSize ;
		GraphSize -= TexSize ;

		if( GraphSize <= 0 ) break ;

		// eNX`[TCYQ{ɂقꍇ𔻒
		if( ( GraphSize > TexSize * 3 / 4 ) && ( TexSize < MaxTexSize ) )
		{
			if( SizeList ) SizeList[ DivNum ] = ( short )( TexSize << 1 ) ;
			break ;
		}
		else
		{
			// eNX`[̃TCYcOtBbNTCYɍ킹ĕ␳
			if( GraphSize < TexSize )
			{
				while( GraphSize < TexSize  &&  TexSize > MIN_TEXTURE_SIZE )
				{
					TexSize = TexSize >> 1 ;
				}
				DivNum ++ ; 
				continue ;
			}
		}
		DivNum ++ ;
	}

	// Ō̃TCYAŌ̈ÕTCYƓꍇ
	// Ō̈ÕTCYQ{ɂĕ炷
	if( DivNum > 0 && SizeList[ DivNum - 1 ] == SizeList[ DivNum ] &&
		( SizeList[ DivNum - 1 ] << 1 ) <= MaxTexSize )
	{
		DivNum -- ;
		SizeList[ DivNum ] <<= 1 ;
	}

	// Ԃ
	return DivNum + 1 ;
}

// OtBbNXVXȅ
extern int InitializeGraphics2( void )
{
	// ɏς݂̏ꍇ͉Ȃ
	if( GRA2.InitializeFlag == TRUE ) return 0 ;

	// ʂ̐ݒ
	if( GRA2.MainScreenSizeX == 0 || GRA2.MainScreenSizeY == 0 )
	{
		SetMainScreenSize( DEFAULT_SCREEN_SIZE_X, DEFAULT_SCREEN_SIZE_Y ) ;
	}

	if( GRA2.MainScreenColorBitDepth == 0 )
	{
		GRA2.MainScreenColorBitDepth = DEFAULT_COLOR_BITDEPTH ;
		SetMemImgDefaultColorType( 0 ) ;
	}

#ifdef __WINDOWS__
	if( GRA2.MainScreenSizeX == 320 && GRA2.MainScreenSizeY == 240 && NS_GetWindowModeFlag() == FALSE )
	{
		GRH.FullScreenEmulation320x240 = TRUE ;
		SetMainScreenSize( 640, 480 ) ;
	}
#endif // __WINDOWS__

	// VF[_[萔
	InitializeShaderConstantInfoSet( &GRH.ShaderConstantInfo ) ;
	SetUseShaderContantInfoState( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTSET_MASK_LIB ) ;

	// DirectX ̏
	if( InitializeDirectX() == -1 )
		goto ERR ;

	// OtBbNnhǗ̏
	InitializeHandleManage( DX_HANDLETYPE_GRAPH, sizeof( IMAGEDATA2 ), MAX_IMAGE_NUM, InitializeGraphHandle, TerminateGraphHandle, DXSTRING( _T( "OtBbN" ) ) ) ;

	// VF[_[nhǗ̏
	InitializeHandleManage( DX_HANDLETYPE_SHADER, sizeof( SHADERHANDLEDATA ), MAX_SHADER_NUM, InitializeShaderHandle, TerminateShaderHandle, DXSTRING( _T( "VF[_[" ) ) ) ;

	// _obt@nhǗ̏
	InitializeHandleManage( DX_HANDLETYPE_VERTEX_BUFFER, sizeof( VERTEXBUFFERHANDLEDATA ), MAX_VERTEX_BUFFER_NUM, InitializeVertexBufferHandle, TerminateVertexBufferHandle, DXSTRING( _T( "_obt@" ) ) ) ;

	// CfbNXobt@nhǗ̏
	InitializeHandleManage( DX_HANDLETYPE_INDEX_BUFFER, sizeof( INDEXBUFFERHANDLEDATA ), MAX_INDEX_BUFFER_NUM, InitializeIndexBufferHandle, TerminateIndexBufferHandle, DXSTRING( _T( "CfbNXobt@" ) ) ) ;

	// ς݃tO𗧂Ă
	GRA2.InitializeFlag = TRUE ;

	// n[hEGAANZ[^gpłꍇ
	// n[hEGAANZ[^̏s
	if( GRA2.ValidHardWare == TRUE )
	{
		InitializeHardware() ;
	}
	else
	// ȊȌꍇ̓\tgEGA_Ȍs
	{
		InitializeSoftware() ;
	}

	// OtBbN`{f[^̏
	InitializeGraphicsBase() ;

	// MEMIMG ̏
	InitializeMemImgManage() ;

#ifndef DX_NON_FONT
	// tHg̏s
	InitFontManage() ;
#endif

#ifndef DX_NON_MASK
	// }XN̏
	InitializeMask() ;
#endif

	// foCX̐ݒtbV
	RefreshRenderStateHardware() ;

#ifndef DX_NON_FILTER
	// sNZVF[_[gpꍇ͏o͐eNX`ƂĎgpł邩ǂ̃`FbNs
	GRH.ValidRenderTargetInputTexture = FALSE ;
	if( GRA2.ValidHardWare == TRUE && GRH.UseShader == TRUE )
	{
		int TempScreen ;
		BASEIMAGE TempInImage ;
		BASEIMAGE TempOutImage ;
		BASEIMAGE TempScreenImage ;
		RECT LockRect ;
		int i, j, s, count ;
		int r, g, b, a ;
		const int rgb[ 4 * 3 ] =
		{
			204, 168,  80,
			128, 100, 245,
			 66, 222, 143,
			 34, 255,  78,
		} ;
		SETUP_GRAPHHANDLE_GPARAM GParam ;

		InitSetupGraphHandleGParam( &GParam ) ;
		GParam.DrawValidImageCreateFlag = TRUE ;
		GParam.DrawValidAlphaImageCreateFlag = FALSE ;
		GParam.CubeMapTextureCreateFlag = FALSE ;
		TempScreen = MakeGraph_UseGParam( &GParam, 8, 8, FALSE, FALSE ) ;
		NS_CreateXRGB8ColorBaseImage( 8, 8, &TempInImage ) ;
		NS_CreateXRGB8ColorBaseImage( 8, 8, &TempOutImage ) ;

		j = 0 ;
		for( i = 0 ; i < 4 ; i ++, j += 3 )
		{
			NS_SetPixelBaseImage( &TempInImage, i, i, rgb[ j + 0 ], rgb[ j + 1 ], rgb[ j + 2 ], 255 ) ;
		}

		NS_BltBmpOrGraphImageToGraph( NULL, NULL, NULL, FALSE, &TempInImage, NULL, 0, 0, TempScreen ) ;
		GRH.ValidRenderTargetInputTexture = TRUE ;
		NS_GraphFilter( TempScreen, DX_GRAPH_FILTER_INVERT ) ;
		GRH.ValidRenderTargetInputTexture = FALSE ;
		LockRect.left   = 0 ;
		LockRect.top    = 0 ;
		LockRect.right  = 8 ;
		LockRect.bottom = 8 ;
		if( LockDrawScreenBuffer( &LockRect, &TempScreenImage, TempScreen, 0, TRUE, 0 ) != -1 )
		{
			NS_BltBaseImage( 0, 0, &TempScreenImage, &TempOutImage ) ;
			UnlockDrawScreenBuffer() ;

			count = 0 ;
			j = 0 ;
			for( i = 0 ; i < 4 ; i ++, j += 3 )
			{
				NS_GetPixelBaseImage( &TempOutImage, i, i, &r, &g, &b, &a ) ;
				s = r - ( 255 - rgb[ j + 0 ] ) ; if( s >= -1 && s <= 1 ) count ++ ;
				s = g - ( 255 - rgb[ j + 1 ] ) ; if( s >= -1 && s <= 1 ) count ++ ;
				s = b - ( 255 - rgb[ j + 2 ] ) ; if( s >= -1 && s <= 1 ) count ++ ;
			}
			if( count == 4 * 3 )
			{
				GRH.ValidRenderTargetInputTexture = TRUE ;
			}
		}
		NS_DeleteGraph( TempScreen ) ;
		NS_ReleaseBaseImage( &TempInImage ) ;
		NS_ReleaseBaseImage( &TempOutImage ) ;
	}
#endif // DX_NON_FILTER

	// I
	return 0 ;

	// G[
ERR:
	TerminateGraphics2() ;

	return -1;
}

// OtBbNVXěn
extern int TerminateGraphics2( void )
{
#ifndef DX_NON_FONT
	// tHgLbV̊ǗnI
	TermFontManage() ;
#endif

	// Ɍnς݂̏ꍇ͉Ȃ
	if( GRA2.InitializeFlag == FALSE ) return 0 ;

#ifndef DX_NON_MASK
	// }XŇn
	TerminateMask() ;
#endif

#ifndef DX_NON_MODEL
	// ׂẴf폜
	NS_MV1InitModel() ;
	MV1InitModelBase() ;
#endif

	// SẲ摜폜
	NS_InitGraph() ;

	// ׂĂ̒_f[^ƃCfbNXf[^폜
	NS_InitVertexBuffer() ;
	NS_InitIndexBuffer() ;

	// SẴVF[_[폜
	NS_InitShader() ;

	// CgSč폜
	NS_DeleteLightHandleAll() ;
	NS_DeleteLightHandle( GBASE.Light.DefaultHandle ) ;
	GBASE.Light.DefaultHandle = -1 ;

	// DirectX ̌n
	TerminateDirectX() ;

	// \tgEGA_O@\̌n
	TerminateSoftware() ;

	// VF[_[R[ȟn
	ShaderCodeTerminate() ;

	// _ꎞIɕۑ郁̈̉
	if( GBASE.TempVertexBuffer )
	{
		DXFREE( GBASE.TempVertexBuffer ) ;
		GBASE.TempVertexBuffer = NULL ;
		GBASE.TempVertexBufferSize = 0 ;
	}

	// _obt@nhǗ̌n
	TerminateHandleManage( DX_HANDLETYPE_VERTEX_BUFFER ) ;

	// CfbNXobt@nhǗ̌n
	TerminateHandleManage( DX_HANDLETYPE_INDEX_BUFFER ) ;

	// VF[_[nhǗ̌n
	TerminateHandleManage( DX_HANDLETYPE_SHADER ) ;

	// OtBbNnhǗ̌n
	TerminateHandleManage( DX_HANDLETYPE_GRAPH ) ;

	// ėpobt@̉
	TerminateCommonBuffer() ;

	// ς݃tO|
	GRA2.InitializeFlag = FALSE ;

	// I
	return 0 ;
}




// w̃OtBbNf[^폜
extern	int NS_DeleteGraph( int GrHandle, int )
{
	return SubHandle( GrHandle ) ;
}

// w̃OtBbNnhƁAOtBbNf[^hĂOtBbNnh( DerivationGraph ŔhnhALoadDivGraph ǂݍō쐬ꂽ̃nh )xɍ폜
extern	int NS_DeleteSharingGraph( int GrHandle )
{
	IMAGEDATA2_ORIG *Orig ;
	IMAGEDATA2 *Image2, **TmpImage2 ;
	bool BreakFlag ;

	// G[
	if( GRAPHCHK( GrHandle, Image2 ) )
		return -1 ;

	// OtBbNf[^hĂnhSč폜
	Orig = Image2->Orig ;
	BreakFlag = false ;
	for( TmpImage2 = ( IMAGEDATA2 ** )&HandleManageArray[ DX_HANDLETYPE_GRAPH ].Handle[ HandleManageArray[ DX_HANDLETYPE_GRAPH ].AreaMin ] ; ; TmpImage2 ++ )
	{
		if( *TmpImage2 == NULL ) continue ;

		if( ( *TmpImage2 )->Orig == Orig )
		{
			BreakFlag = Orig->RefCount == 1 ;
			NS_DeleteGraph( ( *TmpImage2 )->HandleInfo.Handle ) ;
			if( BreakFlag ) break ;
		}
	}

	// I
	return 0 ;
}

// LȃOtBbN̐擾
extern	int NS_GetGraphNum( void )
{
	return HandleManageArray[ DX_HANDLETYPE_GRAPH ].Num ;
}

// ɗĂtÕ|C^Zbg
extern	int NS_SetGraphLostFlag( int GrHandle, int *LostFlag )
{
	IMAGEDATA2 *Image2 ;

	// G[
	if( GRAPHCHK( GrHandle, Image2 ) )
		return -1 ;

	Image2->LostFlag = LostFlag ;
	if( LostFlag != NULL ) *LostFlag = FALSE ;

	// I
	return 0 ;
}

// 摜f[^̏
extern	int NS_InitGraph( int )
{
	int Result ;

	// OtBbNnhSč폜
	Result = AllHandleSub( DX_HANDLETYPE_GRAPH ) ;

	// VXeeNX`̉
	ReleaseSysMemTextureAll() ;

	// I
	return Result ;
}


// 摜f[^̓]
extern	int NS_BltBmpToGraph( const COLORDATA *BmpColorData, HBITMAP RgbBmp, HBITMAP AlphaBmp, int CopyPointX, int CopyPointY, int GrHandle )
{
	return NS_BltBmpOrGraphImageToGraph( BmpColorData, RgbBmp, AlphaBmp,
											TRUE, NULL, NULL,
											CopyPointX, CopyPointY, GrHandle ) ;
}

// 摜ւ̂alo̓]
extern	int NS_BltBmpToDivGraph( const COLORDATA *BmpColorData, HBITMAP RgbBmp, HBITMAP AlphaBmp, int AllNum, int XNum, int YNum, int Width, int Height, const int *GrHandle, int ReverseFlag )
{
	return NS_BltBmpOrGraphImageToDivGraph( BmpColorData, RgbBmp, AlphaBmp,
												TRUE, NULL, NULL,
												AllNum, XNum, YNum, Width, Height, GrHandle, ReverseFlag ) ;
}



// BltBmpOrGraphImageToGraph ̓֐
extern int BltBmpOrGraphImageToGraphBase(
	const COLORDATA *SrcColorData,
	HBITMAP RgbBmp,
	HBITMAP AlphaBmp,
	int BmpFlag,
	const BASEIMAGE *RgbImage,
	const BASEIMAGE *AlphaImage,
	int CopyPointX,
	int CopyPointY,
	int GrHandle,
	int UseTransColorConvAlpha,
	int ASyncThread
)
{
	IMAGEDATA2 *Image2 ;
	IMAGEDATA2_ORIG *Orig ;
	RECT SrcRect ;

	if( GRA2.InitializeFlag == FALSE ) return -1 ;

	// G[
	if( ASyncThread )
	{
		if( GRAPHCHK_ASYNC( GrHandle, Image2 ) )
			return -1 ;
	}
	else
	{
		if( GRAPHCHK( GrHandle, Image2 ) )
			return -1 ;
	}
	Orig = Image2->Orig ;

	// ]`̏
	SrcRect.left   = CopyPointX ;
	SrcRect.top    = CopyPointY ;
	SrcRect.right  = CopyPointX + Image2->Width ;
	SrcRect.bottom = CopyPointY + Image2->Height ;

	// gp̈ۑ
	Image2->UseBaseX = SrcRect.left ;
	Image2->UseBaseY = SrcRect.top ; 

	// 摜̓]
	return BltBmpOrBaseImageToGraph3(
				SrcColorData,
				RgbBmp,
				AlphaBmp,
				&SrcRect,
				0,
				0,
				GrHandle,
				BmpFlag,
				RgbImage,
				AlphaImage,
				Orig->FormatDesc.BlendGraphFlag,
				UseTransColorConvAlpha,
				FALSE,
				ASyncThread
			) ;
}

// alo  GraphImage 摜ɓ]
extern int NS_BltBmpOrGraphImageToGraph(
	const COLORDATA *BmpColorData,
	HBITMAP RgbBmp,
	HBITMAP AlphaBmp,
	int BmpFlag,
	const BASEIMAGE *RgbImage,
	const BASEIMAGE *AlphaImage,
	int CopyPointX,
	int CopyPointY,
	int GrHandle )
{
	int Result ;

	Result = BltBmpOrGraphImageToGraphBase( 
				BmpColorData,
				RgbBmp,
				AlphaBmp,
				BmpFlag,
				RgbImage,
				AlphaImage,
				CopyPointX,
				CopyPointY,
				GrHandle,
				GBASE.NotUseTransColor ? FALSE : TRUE
			) ;

	if( Result == 0 )
	{
		if( BmpFlag )
		{
			SetGraphBaseInfo( GrHandle, NULL, BmpColorData, RgbBmp, AlphaBmp, NULL, 0, NULL, 0, NULL, NULL, FALSE, -1, FALSE ) ;
		}
		else
		{
			SetGraphBaseInfo( GrHandle, NULL, NULL, NULL, NULL, NULL, 0, NULL, 0, RgbImage, AlphaImage, FALSE, -1, FALSE ) ;
		}
	}

	return Result ;
}

// BltBmpOrGraphImageToGraph2 ̓֐
extern int BltBmpOrGraphImageToGraph2Base(
	const COLORDATA *BmpColorData,
	HBITMAP RgbBmp,
	HBITMAP AlphaBmp,
	int BmpFlag,
	const BASEIMAGE *RgbImage,
	const BASEIMAGE *AlphaImage,
	const RECT *SrcRect,
	int DestX,
	int DestY,
	int GrHandle )
{
	IMAGEDATA2 *Image2 ;
	IMAGEDATA2_ORIG *Orig ;

	if( GRA2.InitializeFlag == FALSE ) return -1 ;

	// G[
	if( GRAPHCHK_ASYNC( GrHandle, Image2 ) )
		return -1 ;
	Orig = Image2->Orig ;

	// gp̈ۑ
	if( SrcRect == NULL )
	{
		Image2->UseBaseX = 0 ;
		Image2->UseBaseY = 0 ; 
	}
	else
	{
		Image2->UseBaseX = SrcRect->left - DestX ;
		Image2->UseBaseY = SrcRect->top  - DestY ; 
	}

	// 摜̓]
	return BltBmpOrBaseImageToGraph3(
				BmpColorData,
				RgbBmp,
				AlphaBmp,
				SrcRect,
				DestX,
				DestY,
				GrHandle,
				BmpFlag,
				RgbImage,
				AlphaImage, 
				Orig->FormatDesc.BlendGraphFlag,
				GBASE.NotUseTransColor ? FALSE : TRUE ) ;
}

// alo  GraphImage 摜ɓ]
extern	int NS_BltBmpOrGraphImageToGraph2(
	const COLORDATA *BmpColorData,
	HBITMAP RgbBmp,
	HBITMAP AlphaBmp,
	int BmpFlag,
	const BASEIMAGE *RgbImage,
	const BASEIMAGE *AlphaImage,
	const RECT *SrcRect,
	int DestX,
	int DestY,
	int GrHandle )
{
	// 摜̓]
	return BltBmpOrGraphImageToGraph2Base(
				BmpColorData,
				RgbBmp,
				AlphaBmp,
				BmpFlag,
				RgbImage,
				AlphaImage,
				SrcRect,
				DestX,
				DestY,
				GrHandle ) ;
}

// BltBmpOrGraphImageToDivGraph ̓֐
extern int BltBmpOrGraphImageToDivGraphBase(
	const COLORDATA *BmpColorData,
	HBITMAP RgbBmp,
	HBITMAP AlphaBmp,
	int BmpFlag,
	const BASEIMAGE *RgbImage,
	const BASEIMAGE *AlphaImage,
	int AllNum,
	int XNum,
	int /*YNum*/,
	int Width,
	int Height,
	const int *GrHandle,
	int ReverseFlag,
	int UseTransColorConvAlpha,
	int ASyncThread
)
{
	IMAGEDATA2 *Image2, *DivImage2 ;
	IMAGEDATA2_ORIG *Orig ;
	RECT Rect ;
	int i, Count, x, y ;

	if( GRA2.InitializeFlag == FALSE ) return -1 ;

	// G[
	if( ASyncThread )
	{
		if( GRAPHCHK_ASYNC( GrHandle[ 0 ], Image2 ) )
			return -1 ;
	}
	else
	{
		if( GRAPHCHK( GrHandle[ 0 ], Image2 ) )
			return -1 ;
	}
	Orig = Image2->Orig ;

	// ŏ̉摜Ƀt@CZbg
	Image2->UseBaseX = 0 ;
	Image2->UseBaseY = 0 ;

	// t@CɏZbgȂ炷ׂẲ摜
	// IWi摜gpĂ邩ׂ
	Count = 1 ;
	x = 0 ;
	y = 0 ;
	for( i = 1 ; i < AllNum ; i ++ )
	{
		// 摜̃AhX擾
		if( ASyncThread )
		{
			if( GRAPHCHK_ASYNC( GrHandle[ i ], DivImage2 ) )
				return -1 ;
		}
		else
		{
			if( GRAPHCHK( GrHandle[ i ], DivImage2 ) )
				return -1 ;
		}

		// IWi摜gpĂ邩ǂׂ
		if( DivImage2->Orig == Orig ) Count ++ ;

		// t@CZbg
		DivImage2->UseBaseX = ReverseFlag ? ( ( XNum - 1 ) - x ) * Width : x * Width ;
		DivImage2->UseBaseY = y * Height ;
		x ++ ;
		if( x == XNum )
		{
			x = 0 ;
			y ++ ;
		}
	}

	// ׂẴOtBbNnhIWi摜
	// gpĂ邩ǂŏ𕪊
	if( AllNum == Count )
	{
		// IWi摜gpĂꍇ

		// IWi摜ŏ̃OtBbNnhɓ]
		Rect.left   = 0 ;
		Rect.right  = Image2->Orig->Width ;
		Rect.top    = 0 ;
		Rect.bottom = Image2->Orig->Height ;
		BltBmpOrBaseImageToGraph3(
			BmpColorData,
			RgbBmp, AlphaBmp,
			&Rect,
			0, 0,
			GrHandle[ 0 ],
			BmpFlag,
			RgbImage, AlphaImage,
			Orig->FormatDesc.BlendGraphFlag,
			UseTransColorConvAlpha,
			TRUE,
			ASyncThread
		) ;
	}
	else
	{
		// IWi摜gpĂȂꍇ

		// ׂẴOtBbNnhɌʂɓ]
		for( i = 0 ; i < AllNum ; i ++ )
		{
			// 摜̃AhX擾
			if( ASyncThread )
			{
				if( GRAPHCHK_ASYNC( GrHandle[ i ], DivImage2 ) )
					return -1 ;
			}
			else
			{
				if( GRAPHCHK( GrHandle[ i ], DivImage2 ) )
					return -1 ;
			}

			// ]`̃Zbg
			Rect.left = DivImage2->UseBaseX ;
			Rect.top  = DivImage2->UseBaseY ;
			Rect.right = Rect.left + DivImage2->Width ;
			Rect.bottom = Rect.top + DivImage2->Height ;

			// 摜]
			BltBmpOrBaseImageToGraph3(
				BmpColorData,
				RgbBmp, AlphaBmp,
				&Rect,
				0, 0,
				GrHandle[ i ],
				BmpFlag,
				RgbImage, AlphaImage,
				Orig->FormatDesc.BlendGraphFlag,
				UseTransColorConvAlpha,
				FALSE,
				ASyncThread
			) ;
		}
	}

	// I
	return 0 ;
}

// 摜ւ alo  GraphImage ̓]
extern	int NS_BltBmpOrGraphImageToDivGraph(
	const COLORDATA *BmpColorData,
	HBITMAP RgbBmp,
	HBITMAP AlphaBmp,
	int BmpFlag,
	const BASEIMAGE *RgbImage,
	const BASEIMAGE *AlphaImage,
	int AllNum,
	int XNum,
	int YNum,
	int Width,
	int Height,
	const int *GrHandle,
	int ReverseFlag )
{
	int Result ;
	int i ;

	if( GRA2.InitializeFlag == FALSE ) return -1 ;

	// ]
	Result = BltBmpOrGraphImageToDivGraphBase( BmpColorData, RgbBmp, AlphaBmp, BmpFlag, RgbImage, AlphaImage, AllNum, XNum, YNum, Width, Height, GrHandle, ReverseFlag, GBASE.NotUseTransColor ? FALSE : TRUE, FALSE ) ;

	// ŏ̉摜Ƀt@CZbg
	if( BmpFlag )
	{
		SetGraphBaseInfo( GrHandle[ 0 ], NULL, BmpColorData, RgbBmp, AlphaBmp, NULL, 0, NULL, 0, NULL, NULL, FALSE, -1, FALSE ) ;
	}
	else
	{
		SetGraphBaseInfo( GrHandle[ 0 ], NULL, NULL, NULL, NULL, NULL, 0, NULL, 0, RgbImage, AlphaImage, FALSE, -1, FALSE ) ;
	}
	for( i = 1 ; i < AllNum ; i ++ )
	{
		SetGraphBaseInfo( GrHandle[ i ], NULL, NULL, NULL, NULL, NULL, 0, NULL, 0, NULL, NULL, FALSE, GrHandle[ 0 ], FALSE ) ;
	}

	// I
	return Result ;
}






#ifndef DX_NON_MOVIE

extern int LoadBmpToGraph_OpenMovie_UseGParam(
	LOADGRAPH_GPARAM *GParam,
	int GrHandle,
	const TCHAR *GraphName,
	int TextureFlag,
	int SurfaceMode,
	int ASyncThread
)
{
	int MovieHandle ;
	int Width, Height ;
	MOVIEGRAPH *Movie;
	IMAGEDATA2 *Image2 ;

	// [r[OtBbNƂĈƂĂ݂
	MovieHandle = OpenMovie_UseGParam( &GParam->OpenMovieGParam, GraphName, &Width, &Height, SurfaceMode, ASyncThread ) ;
	if( MovieHandle < 0 )
	{
		DXST_ERRORLOGFMT_ADD(( _T( "EL̃OtBbNt@C̃[hɎs܂F%s \n" ), GraphName )) ;
		return -1 ;
	}

	Movie = GetMovieData( MovieHandle );

	// ʂ̃J[rbgfvXƑΉ悤ɃZbgAyтuq`lgpZbg
	GParam->CreateGraphGParam.InitHandleGParam.CreateImageColorBitDepth = NS_GetColorBitDepth() ;
	GParam->CreateGraphGParam.InitHandleGParam.CreateImageChannelBitDepth = 0 ;
	GParam->CreateGraphGParam.InitHandleGParam.NotUseDivFlag = TRUE ;
	GParam->CreateGraphGParam.InitHandleGParam.AlphaTestImageCreateFlag = FALSE ;
	GParam->CreateGraphGParam.InitHandleGParam.CubeMapTextureCreateFlag = FALSE ;
	GParam->CreateGraphGParam.InitHandleGParam.UseManagedTextureFlag = FALSE ;
#ifndef DX_NON_OGGTHEORA
	if( Movie->TheoraFlag && Movie->RightAlpha == FALSE )
	{
		GParam->CreateGraphGParam.InitHandleGParam.DrawValidImageCreateFlag = TRUE ;
	}
#endif

	// ǂ݂񂾃rbg}bṽTCỸOtBbNf[^쐬
	// E`lƂĈꍇ̓`lt摜ɂ
	if( SetupGraphHandle_UseGParam(
			&GParam->CreateGraphGParam.InitHandleGParam,
			GrHandle,
			Movie->RightAlpha ? Width / 2 : Width,
			Height,
			TextureFlag,
			Movie->RightAlpha,
			FALSE,
			DX_BASEIMAGE_FORMAT_NORMAL,
			-1,
			ASyncThread
		) == -1 )
	{
		DXST_ERRORLOGFMT_ADD(( _T( "EL̃OtBbNt@C̊i[pOtBbN̈̍쐬Ɏs܂F%s" ), GraphName )) ;
		return -1 ;
	}

	Image2 = GetGraphData2( GrHandle, ASyncThread ) ;
	if( Image2 )
	{
		// [r[̃nhZbg
		Image2->MovieHandle = MovieHandle ;

		// R[obN֐Zbg
		SetCallbackMovie( MovieHandle, ( void (*)( MOVIEGRAPH *, void * ) )UpdateGraphMovie, ( void * )( DWORD_PTR )GrHandle ) ;
	}

	// I
	return 0 ;
}

#endif


// t@Cǂݍ񂾉摜ēxǂݍ
extern	int NS_ReloadFileGraphAll( void )
{
	DefaultRestoreGraphFunction() ;

	// I
	return 0 ;
}






// OtBbN`֌W֐

// ʂ̏Ԃ(ClearDrawScreen̋)
extern int NS_ClsDrawScreen( void )
{
	return NS_ClearDrawScreen() ;
}

// ʂ̂yobt@̏Ԃ
extern int NS_ClearDrawScreenZBuffer( const RECT *ClearRect )
{
	// `FbN
	if( ClearRect && ( ClearRect->left < 0 || ClearRect->top < 0 ) )
		ClearRect = NULL ;

	// n[hEGA@\gĂ邩ǂŏ𕪊
	if( GRA2.ValidHardWare )
	{
		// n[hEGA̋@\gĂꍇ

		if( GraphicsDevice_IsValid() == 0 || GRH.FlipSkipFlag ) return 0 ;

		// `̏I
		RenderVertexHardware() ;
		EndScene() ;

		// yobt@݂ꍇ͂yobt@
		if( GRH.ZBufferSurface )
		{
			D_D3DVIEWPORT9 Viewport ;
			D_D3DRECT D3DRect ;

			// r[|[gT[tFXŜɂ
			_MEMSET( &Viewport, 0, sizeof( Viewport ) ) ;
			Viewport.X		= 0 ;
			Viewport.Y		= 0 ;
			Viewport.Width	= GBASE.DrawSizeX ;
			Viewport.Height	= GBASE.DrawSizeY ;
			Viewport.MinZ	= 0.0f ;
			Viewport.MaxZ	= 1.0f ;
			SetViewportHardware( &Viewport ) ;

			// NA
			if( ClearRect )
			{
				D3DRect.x1 = ClearRect->left ;
				D3DRect.y1 = ClearRect->top ;
				D3DRect.x2 = ClearRect->right ;
				D3DRect.y2 = ClearRect->bottom ;
				GraphicsDevice_Clear( 1, &D3DRect, D_D3DCLEAR_ZBUFFER, 0, 1.0f, 0 ) ;
			}
			else
			{
				GraphicsDevice_Clear( 0, NULL, D_D3DCLEAR_ZBUFFER, 0, 1.0f, 0 ) ;
			}

			// r[|[g͈̔͂ɖ߂
			Viewport.X		= GBASE.DrawArea.left ;
			Viewport.Y		= GBASE.DrawArea.top ;
			Viewport.Width	= GBASE.DrawArea.right  - GBASE.DrawArea.left ;
			Viewport.Height	= GBASE.DrawArea.bottom - GBASE.DrawArea.top  ;
			SetViewportHardware( &Viewport ) ;
		}
	}
	else
	{
		// \tgEGA_Ȍꍇ͉Ȃ
	}

	// I
	return 0 ;
}

// ʂ̏Ԃ
extern	int NS_ClearDrawScreen( const RECT *ClearRect )
{
//	HRESULT hr ;
//	RECT Rect ;
	IMAGEDATA2 *Image2 ;

	// tXN[}XNsĂꍇ̓}XN`̌ʂ𔽉f
	MASK_FULLSCREEN_MASKUPDATE

	// `FbN
	if( ClearRect && ( ClearRect->left < 0 || ClearRect->top < 0 ) )
		ClearRect = NULL ;

	// `摜̉摜擾
	if( GRAPHCHKFULL( GBASE.TargetScreen[ 0 ], Image2 ) )
		Image2 = NULL ;

	// n[hEGA@\gĂ邩ǂŏ𕪊
	if( GRA2.ValidHardWare )
	{
		D_D3DRECT D3DRect ;
		D_D3DVIEWPORT9 Viewport ;
		DWORD ClearColor ;
//		HRESULT hr ;

		// n[hEGA̋@\gĂꍇ
		DX_DIRECT3DSURFACE9 *TargetSurface ;
		D_D3DFORMAT TargetFormat ;

		if( GraphicsDevice_IsValid() == 0 || GRH.FlipSkipFlag ) return 0 ;

		// `̏I
		RenderVertexHardware() ;
		EndScene() ;

		// `\摜gpĂꍇ͕`\摜
		if( Image2 )
		{
			TargetSurface = Image2->Orig->Hard.Tex[ 0 ].Surface[ GBASE.TargetScreenSurface[ 0 ] ] ;
			TargetFormat = GRH.TextureFormat[ Image2->Orig->ColorFormat ] ;
		}
		else
		// TuobNobt@LɂȂĂꍇ̓TuobNobt@
		{
			TargetSurface = GRH.SubBackBufferSurface ? GRH.SubBackBufferSurface : GRH.BackBufferSurface ;
			TargetFormat = GRH.ScreenFormat ;
		}

		// `ΏۃT[tFXύX
#ifndef DX_NON_MASK
		if( MASKD.MaskValidFlag && MASKD.MaskScreenSurface )
		{
			SetRenderTargetHardware( TargetSurface ) ;
		}
#endif

		// r[|[gT[tFXŜɂ
		_MEMSET( &Viewport, 0, sizeof( Viewport ) ) ;
		Viewport.X		= 0 ;
		Viewport.Y		= 0 ;
		Viewport.Width	= GBASE.DrawSizeX ;
		Viewport.Height	= GBASE.DrawSizeY ;
		Viewport.MinZ	= 0.0f ;
		Viewport.MaxZ	= 1.0f ;
		SetViewportHardware( &Viewport ) ;

		// p[^Zbg
		if( ClearRect )
		{
			D3DRect.x1 = ClearRect->left ;
			D3DRect.y1 = ClearRect->top ;
			D3DRect.x2 = ClearRect->right ;
			D3DRect.y2 = ClearRect->bottom ;
		}

//		GraphicsDevice_ColorFill( TargetSurface, NULL, NS_GetColor3( GetD3DFormatColorData( TargetFormat ), GRA2.BackgroundRed, GRA2.BackgroundGreen, GRA2.BackgroundBlue, 0 ) ) ;
//		hr = GraphicsDevice_ColorFill( TargetSurface, ClearRect, ( GRA2.BackgroundRed << 16 ) | ( GRA2.BackgroundGreen << 8 ) | GRA2.BackgroundBlue ) ;
		ClearColor = ( GRA2.BackgroundRed << 16 ) | ( GRA2.BackgroundGreen << 8 ) | GRA2.BackgroundBlue ;
		if( ClearRect )
		{
			GraphicsDevice_Clear( 1, &D3DRect, D_D3DCLEAR_TARGET, ClearColor, 1.0f, 0 ) ;
		}
		else
		{
			GraphicsDevice_Clear( 0, NULL, D_D3DCLEAR_TARGET, ClearColor, 1.0f, 0 ) ;
		}

		// yobt@݂ꍇ͂yobt@
		if( GRH.ZBufferSurface )
		{
			// NA
			if( ClearRect )
			{
				GraphicsDevice_Clear( 1, &D3DRect, D_D3DCLEAR_ZBUFFER, 0, 1.0f, 0 ) ;
			}
			else
			{
				GraphicsDevice_Clear( 0, NULL, D_D3DCLEAR_ZBUFFER, 0, 1.0f, 0 ) ;
			}
		}

		// `ΏۃT[tFXɖ߂
#ifndef DX_NON_MASK
		if( MASKD.MaskValidFlag && MASKD.MaskScreenSurface )
		{
			SetRenderTargetHardware( MASKD.MaskScreenSurface ) ;
		}
#endif

		// r[|[g͈̔͂ɖ߂
		Viewport.X		= GBASE.DrawArea.left ;
		Viewport.Y		= GBASE.DrawArea.top ;
		Viewport.Width	= GBASE.DrawArea.right  - GBASE.DrawArea.left ;
		Viewport.Height	= GBASE.DrawArea.bottom - GBASE.DrawArea.top  ;
		SetViewportHardware( &Viewport ) ;
	}
	else
	{
		// \tgEGA_Ȍꍇ
		MEMIMG *ClearTarget ;

		// `\摜̏ꍇ͂̉摜NA
		ClearTarget = Image2 ? &Image2->Soft.MemImg : &GRS.MainBufferMemImg ;
		ClearMemImg( ClearTarget, ClearRect, NS_GetColor3( ClearTarget->Base->ColorDataP, GRA2.BackgroundRed, GRA2.BackgroundGreen, GRA2.BackgroundBlue, 0 ) ) ;
	}

	// I
	return 0 ;
}

// CEChẼobNOEhJ[ݒ肷
extern int NS_SetBackgroundColor( int Red, int Green, int Blue )
{
	// F̕ۑ
	GRA2.BackgroundRed   = Red;
	GRA2.BackgroundGreen = Green;
	GRA2.BackgroundBlue  = Blue;

	// obNOEhJ[Lǂ̃tO𗧂Ă
	GRA2.EnableBackgroundColor = TRUE;

	// I
	return 0;
}

// alot@Cǂ݂ŉʂɕ`悷
extern	int NS_LoadGraphScreen( int x, int y, const TCHAR *GraphName, int TransFlag )
{
	int GrHandle ;
	LOADGRAPH_GPARAM GParam ;
	
	if( GBASE.NotDrawFlag ) return 0 ;

	// OtBbNǂ݂
	InitLoadGraphGParam( &GParam ) ;
	GrHandle = LoadBmpToGraph_UseGParam( &GParam, FALSE, -1, GraphName, TRUE, FALSE, DX_MOVIESURFACE_NORMAL, FALSE ) ;
	if( GrHandle < 0 ) return -1 ;

	// OtBbN̕`
	NS_DrawGraph( x, y, GrHandle, TransFlag ) ;

	// OtBbN̍폜
	NS_DeleteGraph( GrHandle ) ;

	// I
	return 0 ;
}

// OtBbN̕`
#define SETDRAWRECTCODE\
	SETRECT( GRH.DrawRect, x, y, x + Image2->Width, y + Image2->Height )\
	DRAWRECT_DRAWAREA_CLIP
extern	int NS_DrawGraph( int x, int y, int GrHandle, int TransFlag )
{
	IMAGEDATA2 *Image2 ;
	IMAGEDATA2 *BlendImage2 ;
	int Ret ;

	// 
	if( DxSysData.DxLib_InitializeFlag == FALSE ) return -1 ;

	// `ݒ肪Ăꍇ͉I
	if( GBASE.NotDrawFlag || GBASE.NotDrawFlagInSetDrawArea )
		return 0 ;

	// G[
	if( GRAPHCHK( GrHandle, Image2 ) )
		return -1 ;
	BlendImage2 = NULL ;
	if( GBASE.BlendGraph > 0 )
	{
		GRAPHCHK( GBASE.BlendGraph, BlendImage2 ) ;

		// uheNX`gpꍇA`摜G[
		if( CheckBlendGraphSize( Image2 ) ) return -1 ;
	}

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

#ifndef DX_NON_MOVIE
	if( Image2->MovieHandle != -1 )
		UpdateMovie( Image2->MovieHandle, FALSE ) ;
#endif

	// `
	DRAW_DEF( 
		DrawGraphHardware( x, y, ( float )x, ( float )y, Image2, BlendImage2, TransFlag, TRUE ),
		DrawGraphSoftware( x, y,                         Image2,              TransFlag       ),
		SETDRAWRECTCODE,
		Ret,
		Image2->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}

// OtBbN̕`
extern	int NS_DrawGraphF( float xf, float yf, int GrHandle, int TransFlag )
{
	IMAGEDATA2 *Image2 ;
	IMAGEDATA2 *BlendImage2 ;
	int Ret = -1 ;
	int x, y ;

	x = _FTOL( xf ) ;
	y = _FTOL( yf ) ;

	if( GBASE.NotDrawFlag || GBASE.NotDrawFlagInSetDrawArea )
		return 0 ;

	// G[
	if( GRAPHCHK( GrHandle, Image2 ) )
		return -1 ;
	BlendImage2 = NULL ;
	if( GBASE.BlendGraph > 0 )
	{
		GRAPHCHK( GBASE.BlendGraph, BlendImage2 ) ;

		// uheNX`gpꍇA`摜G[
		if( CheckBlendGraphSize( Image2 ) ) return -1 ;
	}

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

#ifndef DX_NON_MOVIE
	if( Image2->MovieHandle != -1 )
		UpdateMovie( Image2->MovieHandle, FALSE ) ;
#endif

	// `
	DRAW_DEF(
		DrawGraphHardware( x, y, xf, yf, Image2, BlendImage2, TransFlag, FALSE ),
		DrawGraphSoftware( x, y,         Image2,              TransFlag        ),
		SETDRAWRECTCODE,
		Ret,
		Image2->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}
#undef SETDRAWRECTCODE

// OtBbN̊gk`
#define SETDRAWRECTCODE\
	SETRECT( GRH.DrawRect, x1, y1, x2, y2 ) ;\
	if( x1 > x2 ){ GRH.DrawRect.left = x2 ; GRH.DrawRect.right = x1; }\
	if( y1 > y2 ){ GRH.DrawRect.top = y2 ; GRH.DrawRect.bottom = y1; }\
	DRAWRECT_DRAWAREA_CLIP

extern	int NS_DrawExtendGraph( int x1, int y1, int x2, int y2, int GrHandle, int TransFlag )
{
	IMAGEDATA2 *Image2 ;
	IMAGEDATA2 *BlendImage2 ;
	int Ret = -1 ;
	
	if( GBASE.NotDrawFlag || GBASE.NotDrawFlagInSetDrawArea )
		return 0 ;

	// G[
	if( GRAPHCHK( GrHandle, Image2 ) )
		return -1 ;
	BlendImage2 = NULL ;
	if( GBASE.BlendGraph > 0 )
	{
		GRAPHCHK( GBASE.BlendGraph, BlendImage2 ) ;

		// uheNX`gpꍇA`摜G[
		if( CheckBlendGraphSize( Image2 ) ) return -1 ;
	}

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

#ifndef DX_NON_MOVIE
	if( Image2->MovieHandle != -1 )
		UpdateMovie( Image2->MovieHandle, FALSE ) ;
#endif

	// eNX`̏ꍇƂȊOŏ𕪊
	DRAW_DEF(
		DrawExtendGraphHardware( x1, y1, x2, y2, (float)x1, (float)y1, (float)x2, (float)y2, Image2, BlendImage2, TransFlag, TRUE ),
		DrawExtendGraphSoftware( x1, y1, x2, y2,                                             Image2,              TransFlag       ),
		SETDRAWRECTCODE,
		Ret,
		Image2->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}

// OtBbN̊gk`
extern	int NS_DrawExtendGraphF( float x1f, float y1f, float x2f, float y2f, int GrHandle, int TransFlag )
{
	IMAGEDATA2 *Image2 ;
	IMAGEDATA2 *BlendImage2 ;
	int Ret = -1 ;
	int x1, y1, x2, y2 ;
	
	x1 = _FTOL( x1f ) ;
	y1 = _FTOL( y1f ) ;
	x2 = _FTOL( x2f ) ;
	y2 = _FTOL( y2f ) ;

	if( GBASE.NotDrawFlag || GBASE.NotDrawFlagInSetDrawArea )
		return 0 ;

	// G[
	if( GRAPHCHK( GrHandle, Image2 ) )
		return -1 ;
	BlendImage2 = NULL ;
	if( GBASE.BlendGraph > 0 )
	{
		GRAPHCHK( GBASE.BlendGraph, BlendImage2 ) ;

		// uheNX`gpꍇA`摜G[
		if( CheckBlendGraphSize( Image2 ) ) return -1 ;
	}

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

#ifndef DX_NON_MOVIE
	if( Image2->MovieHandle != -1 )
		UpdateMovie( Image2->MovieHandle, FALSE ) ;
#endif

	// `
	DRAW_DEF(
		DrawExtendGraphHardware( x1, y1, x2, y2, x1f, y1f, x2f, y2f, Image2, BlendImage2, TransFlag, FALSE ),
		DrawExtendGraphSoftware( x1, y1, x2, y2,                     Image2,              TransFlag        ),
		SETDRAWRECTCODE,
		Ret,
		Image2->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}

#undef SETDRAWRECTCODE


// OtBbN̉]`
#define SETDRAWRECTCODE\
	int Width, Height ;\
	int i ;\
	float SinF, CosF ;\
	double xb, Lx, Ly ;\
	double px[4], py[4] ;\
	double Sin, Cos ;\
	double MaxMin[4] ; /* 0:MinX 1:MinY 2:MaxX 3:MaxY */\
\
	Lx = x ; Ly = y ;\
\
	_SINCOS( (float)Angle, &SinF, &CosF ) ;\
	Sin = (double)SinF ;\
	Cos = (double)CosF ;\
\
	Width = Image2->Width / 2 ;\
	Height = Image2->Height / 2 ;\
\
	px[0] = -Width ;				py[0] = -Height ;\
	px[1] = Image2->Width - Width ;	py[1] = -Height ;\
	px[2] = -Width ;				py[2] = Image2->Height - Height ;\
	px[3] = Image2->Width - Width ;	py[3] = Image2->Height - Height ;\
\
	xb = px[0] ;\
	px[0] = ( xb * Cos - py[0] * Sin ) * ExRate + Lx ;\
	py[0] = ( xb * Sin + py[0] * Cos ) * ExRate + Ly ;\
	MaxMin[0] = px[0] ;\
	MaxMin[1] = py[0] ;\
	MaxMin[2] = px[0] ;\
	MaxMin[3] = py[0] ;\
	for( i = 1 ; i < 4 ; i ++ )\
	{\
		xb = px[i] ;\
		px[i] = ( xb * Cos - py[i] * Sin ) * ExRate + Lx ;\
		py[i] = ( xb * Sin + py[i] * Cos ) * ExRate + Ly ;\
\
		if( MaxMin[0] > px[i] ) MaxMin[0] = px[i];\
		if( MaxMin[2] < px[i] ) MaxMin[2] = px[i];\
		if( MaxMin[1] > py[i] ) MaxMin[1] = py[i];\
		if( MaxMin[3] < py[i] ) MaxMin[3] = py[i];\
	}\
\
	MaxMin[0] -= 5.0F ; MaxMin[1] -= 5.0F ;\
	MaxMin[2] += 5.0F ; MaxMin[3] += 5.0F ; \
\
	_DTOL4( MaxMin, (int *)&GRH.DrawRect ) ;\
	DRAWRECT_DRAWAREA_CLIP

extern	int NS_DrawRotaGraph( int x, int y, double ExRate, double Angle, int GrHandle, int TransFlag, int TurnFlag )
{
	IMAGEDATA2 *Image2 ;
	IMAGEDATA2 *BlendImage2 ;
	int Ret = -1 ;

	if( GBASE.NotDrawFlag || GBASE.NotDrawFlagInSetDrawArea )
		return 0 ;

	// G[
	if( GRAPHCHK( GrHandle, Image2 ) )
		return -1 ;
	BlendImage2 = NULL ;
	if( GBASE.BlendGraph > 0 )
	{
		GRAPHCHK( GBASE.BlendGraph, BlendImage2 ) ;

		// uheNX`gpꍇA`摜G[
		if( CheckBlendGraphSize( Image2 ) ) return -1 ;
	}

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

#ifndef DX_NON_MOVIE
	if( Image2->MovieHandle != -1 )
		UpdateMovie( Image2->MovieHandle, FALSE ) ;
#endif

	// `
	DRAW_DEF(
		DrawRotaGraphHardware( x, y, (float)x, (float)y, ExRate, Angle, Image2, BlendImage2, TransFlag, TurnFlag, TRUE ),
		DrawRotaGraphSoftware(       (float)x, (float)y, ExRate, Angle, Image2,              TransFlag, TurnFlag       ),
		SETDRAWRECTCODE,
		Ret,
		Image2->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}

// OtBbN̉]`
extern	int NS_DrawRotaGraphF( float xf, float yf, double ExRate, double Angle, int GrHandle, int TransFlag, int TurnFlag )
{
	IMAGEDATA2 *Image2 ;
	IMAGEDATA2 *BlendImage2 ;
	int Ret = -1 ;
	int x, y ;
	
	x = _FTOL( xf ) ;
	y = _FTOL( yf ) ;

	if( GBASE.NotDrawFlag || GBASE.NotDrawFlagInSetDrawArea )
		return 0 ;

	// G[
	if( GRAPHCHK( GrHandle, Image2 ) )
		return -1 ;
	BlendImage2 = NULL ;
	if( GBASE.BlendGraph > 0 )
	{
		GRAPHCHK( GBASE.BlendGraph, BlendImage2 ) ;

		// uheNX`gpꍇA`摜G[
		if( CheckBlendGraphSize( Image2 ) ) return -1 ;
	}

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

#ifndef DX_NON_MOVIE
	if( Image2->MovieHandle != -1 )
		UpdateMovie( Image2->MovieHandle, FALSE ) ;
#endif

	// `
	DRAW_DEF(
		DrawRotaGraphHardware( x, y, xf, yf, ExRate, Angle, Image2, BlendImage2, TransFlag, TurnFlag, FALSE ),
		DrawRotaGraphSoftware(       xf, yf, ExRate, Angle, Image2,              TransFlag, TurnFlag        ),
		SETDRAWRECTCODE,
		Ret,
		Image2->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}

#undef SETDRAWRECTCODE

// OtBbN̉]`Q
extern	int NS_DrawRotaGraph2( int x, int y, int cx, int cy, double ExtRate, double Angle, int GrHandle, int TransFlag, int TurnFlag )
{
	int w, h ;

	NS_GetGraphSize( GrHandle, &w,&h ) ;

	if( Angle == 0.0 && ExtRate == 1.0 )
	{
		if( TurnFlag )	return NS_DrawTurnGraph( x - cx, y - cy, GrHandle, TransFlag ) ;
		else			return NS_DrawGraph( x - cx, y - cy, GrHandle, TransFlag ) ;
	}
	else
	{
		return NS_DrawRotaGraph2F( ( float )x, ( float )y, ( float )cx, ( float )cy, ExtRate, Angle, GrHandle, TransFlag, TurnFlag ) ;
	}
}

// OtBbN̉]`Q
extern	int NS_DrawRotaGraph2F( float xf, float yf, float cxf, float cyf, double ExtRate, double Angle, int GrHandle, int TransFlag, int TurnFlag )
{
#if 1
	int w, h ;

	NS_GetGraphSize( GrHandle, &w,&h ) ;

	if( Angle == 0.0 )
	{
		if( ExtRate == 1.0 )
		{
			if( TurnFlag )	return NS_DrawTurnGraphF( xf - cxf, yf - cyf, GrHandle, TransFlag ) ;
			else			return NS_DrawGraphF( xf - cxf, yf - cyf, GrHandle, TransFlag ) ;
		}
		else
		{
			float numF[ 4 ] ;

			numF[ 0 ] = xf - ( cxf * ( float )ExtRate ) ;
			numF[ 1 ] = yf - ( cyf * ( float )ExtRate ) ;
			numF[ 2 ] = numF[ 0 ] + ( w * ( float )ExtRate ) ;
			numF[ 3 ] = numF[ 1 ] + ( h * ( float )ExtRate ) ;
			if( TurnFlag )
			{
				float d ;

				d = numF[ 0 ] ; numF[ 0 ] = numF[ 2 ] ; numF[ 2 ] = d ;
			}
			return NS_DrawExtendGraphF( numF[0], numF[1],
										numF[2], numF[3],
										 GrHandle, TransFlag ) ;
		}
	}
	else
	{
		float dcx, dcy ;
		float Sin, Cos ;
		float bcx, bcy ;

		bcx = ( -cxf + ( float )w * 0.5F ) * ( float )ExtRate ;
		bcy = ( -cyf + ( float )h * 0.5F ) * ( float )ExtRate ;

		_SINCOS( ( float )Angle, &Sin, &Cos ) ;
		dcx = bcx * Cos - bcy * Sin ;
		dcy = bcx * Sin + bcy * Cos ;

		return NS_DrawRotaGraphF( xf + dcx, yf + dcy, ExtRate, Angle, GrHandle, TransFlag, TurnFlag ) ; 
	}
#else
/*
	double xx[4],yy[4];
	int xxi[4], yyi[4] ;
	int w, h, i, Result ;
	double xb, yb, xd, yd ;
	double Sin, Cos ;
	float SinF, CosF ;

	NS_GetGraphSize( GrHandle, &w,&h ) ;

	xx[0] = (   - cx )	* ExtRate ;	yy[0] = (   - cy )	* ExtRate ;
	xx[1] = ( w - cx )	* ExtRate ;	yy[1] = yy[0] ;
	xx[2] = xx[0] ;					yy[2] = ( h - cy )	* ExtRate ;
	xx[3] = xx[1] ;					yy[3] = yy[2] ;

	_SINCOS( (float)Angle, &SinF, &CosF ) ;
	Sin = (double)SinF ;
	Cos = (double)CosF ;
//	Sin = sin( Angle ) ;
//	Cos = cos( Angle ) ;
	xd = (double)x ;
	yd = (double)y ;
	for( i = 0 ; i < 4 ; i ++ )
	{
		xb = xx[i] * Cos - yy[i] * Sin ;
		yb = xx[i] * Sin + yy[i] * Cos ;
		xx[i] = xb + xd ;
		yy[i] = yb + yd ;
	}

	if( TurnFlag )
	{
		double d ;

		d = xx[0] ; xx[0] = xx[1] ; xx[1] = d ;
		d = xx[2] ; xx[2] = xx[3] ; xx[3] = d ;
		d = yy[0] ; yy[0] = yy[1] ; yy[1] = d ;
		d = yy[2] ; yy[2] = yy[3] ; yy[3] = d ;
	}

	_DTOL4( xx, xxi ) ;
	_DTOL4( yy, yyi ) ;
	Result = NS_DrawModiGraph( xxi[0],yyi[0], xxi[1],yyi[1], xxi[3],yyi[3], xxi[2],yyi[2], GrHandle, TransFlag ) ;

	return Result ;
*/
#endif
}

// OtBbN̉]`R
extern	int NS_DrawRotaGraph3( int x, int y, int cx, int cy, double ExtRateX, double ExtRateY, double Angle, int GrHandle, int TransFlag, int TurnFlag )
{
	if( Angle == 0.0 && ExtRateX == 1.0 && ExtRateY == 1.0 )
	{
		int w, h ;

		NS_GetGraphSize( GrHandle, &w,&h ) ;

		if( TurnFlag )	return NS_DrawTurnGraph( x - cx, y - cy, GrHandle, TransFlag ) ;
		else			return NS_DrawGraph( x - cx, y - cy, GrHandle, TransFlag ) ;
	}
	else
	{
		return NS_DrawRotaGraph3F( ( float )x, ( float )y, ( float )cx, ( float )cy, ExtRateX, ExtRateY, Angle, GrHandle, TransFlag, TurnFlag ) ;
	}
}

// OtBbN̉]`R
extern	int NS_DrawRotaGraph3F( float xf, float yf, float cxf, float cyf, double ExtRateX, double ExtRateY, double Angle, int GrHandle, int TransFlag, int TurnFlag )
{
	int w, h ;

	NS_GetGraphSize( GrHandle, &w,&h ) ;

	if( Angle == 0.0 )
	{
		if( ExtRateX == 1.0 && ExtRateY == 1.0 )
		{
			if( TurnFlag )	return NS_DrawTurnGraphF( xf - cxf, yf - cyf, GrHandle, TransFlag ) ;
			else			return NS_DrawGraphF( xf - cxf, yf - cyf, GrHandle, TransFlag ) ;
		}
		else
		{
			float numF[ 4 ] ;

			numF[ 0 ] = xf - ( cxf * ( float )ExtRateX ) ;
			numF[ 1 ] = yf - ( cyf * ( float )ExtRateY ) ;
			numF[ 2 ] = numF[ 0 ] + ( w * ( float )ExtRateX ) ;
			numF[ 3 ] = numF[ 1 ] + ( h * ( float )ExtRateY ) ;
			if( TurnFlag )
			{
				float d ;

				d = numF[ 0 ] ; numF[ 0 ] = numF[ 2 ] ; numF[ 2 ] = d ;
			}
			return NS_DrawExtendGraphF( numF[0], numF[1],
										numF[2], numF[3],
										 GrHandle, TransFlag ) ;
		}
	}
	else
	{
		if( ExtRateX == 1.0 && ExtRateY == 1.0 )
		{
			float dcx, dcy ;
			float Sin, Cos ;
			float bcx, bcy ;

			bcx = ( -cxf + ( float )w * 0.5F ) ;
			bcy = ( -cyf + ( float )h * 0.5F ) ;

			_SINCOS( ( float )Angle, &Sin, &Cos ) ;
			dcx = bcx * Cos - bcy * Sin ;
			dcy = bcx * Sin + bcy * Cos ;

			return NS_DrawRotaGraphF( xf + dcx, yf + dcy, 1.0, Angle, GrHandle, TransFlag, TurnFlag ) ; 
		}
		else
		{
			float xx[ 4 ], yy[ 4 ] ;
			int w, h, i ;
			float SinF, CosF ;
			float xb, yb ;

			NS_GetGraphSize( GrHandle, &w,&h ) ;

			xx[0] = (   - cxf )	* ( float )ExtRateX ;	yy[0] = (   - cyf )	* ( float )ExtRateY ;
			xx[1] = ( w - cxf )	* ( float )ExtRateX ;	yy[1] = yy[0] ;
			xx[2] = xx[0] ;								yy[2] = ( h - cyf )	* ( float )ExtRateY ;
			xx[3] = xx[1] ;								yy[3] = yy[2] ;

			_SINCOS( ( float )Angle, &SinF, &CosF ) ;
			for( i = 0 ; i < 4 ; i ++ )
			{
				xb = xx[ i ] * CosF - yy[ i ] * SinF ;
				yb = xx[ i ] * SinF + yy[ i ] * CosF ;
				xx[ i ] = xb + xf ;
				yy[ i ] = yb + yf ;
			}

			if( TurnFlag )
			{
				float d ;

				d = xx[ 0 ] ; xx[ 0 ] = xx[ 1 ] ; xx[ 1 ] = d ;
				d = xx[ 2 ] ; xx[ 2 ] = xx[ 3 ] ; xx[ 3 ] = d ;
				d = yy[ 0 ] ; yy[ 0 ] = yy[ 1 ] ; yy[ 1 ] = d ;
				d = yy[ 2 ] ; yy[ 2 ] = yy[ 3 ] ; yy[ 3 ] = d ;
			}

			return DrawModiGraphFBase( xx[0], yy[0], xx[1], yy[1], xx[3], yy[3], xx[2], yy[2], GrHandle, TransFlag, true ) ;
		}
	}
}

#define SETDRAWRECTCODE\
	int x[ 4 ], y[ 4 ], MaxX, MaxY, MinX, MinY ;\
	int i, ix, iy ;\
\
	x[ 0 ] = x1 ; x[ 1 ] = x2 ; x[ 2 ] = x3 ; x[ 3 ] = x4 ;\
	y[ 0 ] = y1 ; y[ 1 ] = y2 ; y[ 2 ] = y3 ; y[ 3 ] = y4 ;\
\
	MaxX = 0 ; MaxY = 0 ;\
	MinX = 0xffffff ; MinY = 0xffffff ;\
\
	for( i = 0 ; i < 4 ; i ++ )\
	{\
		ix = x[ i ] ; iy = y[ i ] ;\
		if( ix > MaxX ) MaxX = ix ; if( iy > MaxY ) MaxY = iy ;\
		if( ix < MinX ) MinX = ix ; if( iy < MinY ) MinY = iy ;\
	}\
\
	SETRECT( GRH.DrawRect, MinX, MinY, MaxX, MaxY ) ;\
	DRAWRECT_DRAWAREA_CLIP

static int DrawModiGraphBase( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, int GrHandle, int TransFlag, bool SimpleDrawFlag )
{
	IMAGEDATA2 *Image2 ;
	IMAGEDATA2 *BlendImage2 ;
	int Ret = -1 ;

	if( GBASE.NotDrawFlag || GBASE.NotDrawFlagInSetDrawArea )
		return 0 ;

	// G[
	if( GRAPHCHK( GrHandle, Image2 ) )
		return -1 ;
	BlendImage2 = NULL ;
	if( GBASE.BlendGraph > 0 )
	{
		GRAPHCHK( GBASE.BlendGraph, BlendImage2 ) ;

		// uheNX`gpꍇA`摜G[
		if( CheckBlendGraphSize( Image2 ) ) return -1 ;
	}

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

#ifndef DX_NON_MOVIE
	if( Image2->MovieHandle != -1 )
		UpdateMovie( Image2->MovieHandle, FALSE ) ;
#endif

	// `
	DRAW_DEF(
		DrawModiGraphHardware( x1, y1, x2, y2, x4, y4, x3, y3, Image2, BlendImage2, TransFlag, SimpleDrawFlag ),
		DrawModiGraphSoftware( x1, y1, x2, y2, x4, y4, x3, y3, Image2,              TransFlag                 ),
		SETDRAWRECTCODE,
		Ret,
		Image2->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}

#undef SETDRAWRECTCODE

// 摜̎Rό``
extern	int NS_DrawModiGraph( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, int GrHandle, int TransFlag )
{
	return DrawModiGraphBase( x1, y1, x2, y2, x3, y3, x4, y4, GrHandle, TransFlag, false ) ;
}

#define SETDRAWRECTCODE\
	int x[4], y[4], MaxX, MaxY, MinX, MinY ;\
	int i, ix, iy ;\
\
	x[ 0 ] = _FTOL( x1 ) ; x[ 1 ] = _FTOL( x2 ) ; x[ 2 ] = _FTOL( x3 ) ; x[ 3 ] = _FTOL( x4 ) ;\
	y[ 0 ] = _FTOL( y1 ) ; y[ 1 ] = _FTOL( y2 ) ; y[ 2 ] = _FTOL( y3 ) ; y[ 3 ] = _FTOL( y4 ) ;\
\
	MaxX = 0 ; MaxY = 0 ;\
	MinX = 0xffffff ; MinY = 0xffffff ;\
\
	for( i = 0 ; i < 4 ; i ++ )\
	{\
		ix = x[ i ] ; iy = y[ i ] ;\
		if( ix > MaxX ) MaxX = ix ; if( iy > MaxY ) MaxY = iy ;\
		if( ix < MinX ) MinX = ix ; if( iy < MinY ) MinY = iy ;\
	}\
\
	SETRECT( GRH.DrawRect, MinX, MinY, MaxX, MaxY ) ;

static int DrawModiGraphFBase( float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, int GrHandle, int TransFlag, bool SimpleDrawFlag )
{
	IMAGEDATA2 *Image2 ;
	IMAGEDATA2 *BlendImage2 ;
	int Ret = -1 ;

	if( GBASE.NotDrawFlag || GBASE.NotDrawFlagInSetDrawArea )
		return 0 ;

	// G[
	if( GRAPHCHK( GrHandle, Image2 ) )
		return -1 ;
	BlendImage2 = NULL ;
	if( GBASE.BlendGraph > 0 )
	{
		GRAPHCHK( GBASE.BlendGraph, BlendImage2 ) ;

		// uheNX`gpꍇA`摜G[
		if( CheckBlendGraphSize( Image2 ) ) return -1 ;
	}

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

#ifndef DX_NON_MOVIE
	if( Image2->MovieHandle != -1 )
		UpdateMovie( Image2->MovieHandle, FALSE ) ;
#endif

	// `
	DRAW_DEF(
		DrawModiGraphFHardware( x1, y1, x2, y2, x4, y4, x3, y3, Image2, BlendImage2, TransFlag, SimpleDrawFlag ),
		DrawModiGraphFSoftware( x1, y1, x2, y2, x4, y4, x3, y3, Image2,              TransFlag                 ),
		SETDRAWRECTCODE,
		Ret,
		Image2->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}

#undef SETDRAWRECTCODE

// 摜̎Rό``( float  )
extern	int NS_DrawModiGraphF( float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, int GrHandle, int TransFlag )
{
	return DrawModiGraphFBase( x1, y1, x2, y2, x3, y3, x4, y4, GrHandle, TransFlag, false ) ;
}

// 摜̍E]`
extern	int NS_DrawTurnGraph( int x, int y, int GrHandle, int TransFlag )
{
	IMAGEDATA2 *Image2 ;

	// G[
	if( GRAPHCHK( GrHandle, Image2 ) )
		return -1 ;

	return NS_DrawExtendGraph( Image2->Width + x, y, x, y + Image2->Height, GrHandle, TransFlag ) ;
}

// 摜̍E]`
extern	int NS_DrawTurnGraphF( float xf, float yf, int GrHandle, int TransFlag )
{
	IMAGEDATA2 *Image2 ;

	// G[
	if( GRAPHCHK( GrHandle, Image2 ) )
		return -1 ;

	return NS_DrawExtendGraphF( Image2->Width + xf, yf, xf, yf + Image2->Height, GrHandle, TransFlag ) ;
}

// `bvOtBbNg}bv`
#define SETDRAWRECTCODE\
	SETRECT( GRH.DrawRect, Sx, Sy, Sx + XNum * Image2->Width , Sy + YNum * Image2->Height )\
	DRAWRECT_DRAWAREA_CLIP
extern	int NS_DrawChipMap( int Sx, int Sy, int XNum, int YNum, const int *MapData, int ChipTypeNum, int MapDataPitch, const int *ChipGrHandle, int TransFlag )
{
	IMAGEDATA2 *Image2 ;
	int Ret = -1 ;

	if( GBASE.NotDrawFlag || GBASE.NotDrawFlagInSetDrawArea )
		return 0 ;

	// G[
	if( GRAPHCHK( ChipGrHandle[0], Image2 ) )
		return -1 ;

	CheckActiveState() ;

	// `
	DRAW_DEF(
		DrawChipMapHardware( Sx, Sy, XNum, YNum, MapData, MapDataPitch, ChipTypeNum, ChipGrHandle, TransFlag ),
		DrawChipMapSoftware( Sx, Sy, XNum, YNum, MapData, MapDataPitch, ChipTypeNum, ChipGrHandle, TransFlag ),
		SETDRAWRECTCODE,
		Ret,
		Image2->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}
#undef SETDRAWRECTCODE

// `bvOtBbNg}bv`
// int MapWidth, MapHeight : }bvf[^Ŝ̕ƍ
// int *MapData : }bvf[^i[ꂽAhX
// int ChipTypeNum : }bvɎg`bv̎ނ̐
// int *ChipGrHandle : `bṽOtBbNz̃AhX
// int TransFlag : ߐF̗L
// int MapDrawX, MapDrawY : `悷}bv̋N_ƂȂ鍶W
// int MapDrawWidth, MapDrawHeight : N_W`悷}bv̕ƍ
// int ScreenX, ScreenY : }bv`悷ʏ̍W
extern	int NS_DrawChipMap( int MapWidth, int MapHeight, const int *MapData, int ChipTypeNum, const int *ChipGrHandle, int TransFlag, int MapDrawPointX, int MapDrawPointY, int MapDrawWidth, int MapDrawHeight, int ScreenX, int ScreenY )
{
	int Width, Height ;
	int Result ;
	
	// `bvOtBbÑTCY𓾂
	NS_GetGraphSize( ChipGrHandle[0], &Width, &Height ) ;

	// }bv񂪂͂ݏoꍇ̕␳
	if( MapDrawPointX + MapDrawWidth > MapWidth ) 
		MapDrawWidth -= ( MapDrawPointX + MapDrawWidth ) - MapWidth ;

	if( MapDrawPointY + MapDrawHeight > MapHeight ) 
		MapDrawHeight -= ( MapDrawPointY + MapDrawHeight ) - MapHeight ; 

	if( MapDrawPointX < 0 )
	{
		ScreenX = -MapDrawPointX * Width ;
		MapDrawWidth += MapDrawPointX ; 
		MapDrawPointX = 0 ;
	}
	if( MapDrawPointY < 0 )
	{
		ScreenY = -MapDrawPointY * Height ;
		MapDrawHeight += MapDrawPointY ; 
		MapDrawPointY = 0 ;
	}

	// }bv`
	Result = NS_DrawChipMap( ScreenX, ScreenY, MapDrawWidth, MapDrawHeight,
							 MapData + MapDrawPointX + MapDrawPointY * MapWidth, MapWidth, ChipTypeNum, ChipGrHandle, TransFlag ) ;
						 
	return Result ;
}

// OtBbNẅɃ^Cɕ`悷
#define SETDRAWRECTCODE\
	SETRECT( GRH.DrawRect, x1, y1, x2, y2 )\
	DRAWRECT_DRAWAREA_CLIP
extern	int NS_DrawTile( int x1, int y1, int x2, int y2, int Tx, int Ty, double ExtRate, double Angle, int GrHandle, int TransFlag )
{
	IMAGEDATA2 *Image2 ;
	IMAGEDATA2 *BlendImage2 ;
	int Ret = -1 ;

	// G[
	if( GRAPHCHK( GrHandle, Image2 ) )
		return -1 ;
	if( x1 == x2 || y1 == y2 ) return 0 ;

	BlendImage2 = NULL ;
	if( GBASE.BlendGraph > 0 )
	{
		GRAPHCHK( GBASE.BlendGraph, BlendImage2 ) ;
	}

	CheckActiveState() ;

	// `
	DRAW_DEF(
		DrawTileHardware( x1, y1, x2, y2, Tx, Ty, ExtRate, Angle, Image2, BlendImage2, TransFlag ),
		DrawTileSoftware( x1, y1, x2, y2, Tx, Ty, ExtRate, Angle, Image2,              TransFlag ),
		SETDRAWRECTCODE,
		Ret,
		Image2->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}
#undef SETDRAWRECTCODE

// OtBbN̎w`݂̂`
extern	int NS_DrawRectGraph( int DestX, int DestY, int SrcX, int SrcY, int Width, int Height, int GraphHandle, int TransFlag, int TurnFlag )
{
	RECT MotoDrawRect ;
	RECTF MotoDrawRectF ;
	int hr ;

	// TCY
	if( Width <= 0 || Height <= 0 )
		return -1 ;

	// w``oȂ悤ɂ
	MotoDrawRect = GBASE.DrawArea ;
	MotoDrawRectF = GBASE.DrawAreaF ;
	SETRECT( GBASE.DrawArea, DestX, DestY, DestX + Width, DestY + Height ) ;
	RectClipping( &GBASE.DrawArea, &MotoDrawRect ) ;
	SetMemImgDrawArea( &GBASE.DrawArea ) ;
	GBASE.DrawAreaF.left   = ( float )GBASE.DrawArea.left ;
	GBASE.DrawAreaF.top    = ( float )GBASE.DrawArea.top ;
	GBASE.DrawAreaF.right  = ( float )GBASE.DrawArea.right ;
	GBASE.DrawAreaF.bottom = ( float )GBASE.DrawArea.bottom ;

	// OtBbN̕`
	if( TurnFlag )
	{
		IMAGEDATA2 *Image2 ;

		// G[
		if( GRAPHCHK( GraphHandle, Image2 ) )
			return -1 ;

		hr = NS_DrawTurnGraph( DestX - ( Image2->Width - SrcX - Width ), DestY - SrcY, GraphHandle, TransFlag ) ;
	}
	else
	{
		hr = NS_DrawGraph( DestX - SrcX, DestY - SrcY, GraphHandle, TransFlag ) ;
	}

	// ``ɖ߂
	GBASE.DrawArea = MotoDrawRect ;
	SetMemImgDrawArea( &MotoDrawRect ) ;
	GBASE.DrawAreaF = MotoDrawRectF ;

	// I
	return hr ;
}

// OtBbN̎w`݂̂g`
extern	int NS_DrawRectExtendGraph( int DestX1, int DestY1, int DestX2, int DestY2, int SrcX, int SrcY, int SrcWidth, int SrcHeight, int GraphHandle, int TransFlag )
{
	RECT MotoDrawRect ;
	RECTF MotoDrawRectF ;
	int hr, tmp ;
	int x1, y1, x2, y2 ;	
	bool RevX, RevY ;
	int DestWidth, DestHeight ;
	double exX, exY ;
	IMAGEDATA2 *Image2 ;

	// TCY
	if( SrcWidth <= 0 || SrcHeight <= 0 )
		return -1 ;
	
	// G[
	if( GRAPHCHK( GraphHandle, Image2 ) )
		return -1 ;

	// ]
	{
		if( DestX2 < DestX1 )
		{
			RevX = true ;
			tmp = DestX1 ; DestX1 = DestX2 ; DestX2 = tmp ;
		}
		else
		{
			RevX = false ;
		}
		
		if( DestY2 < DestY1 )
		{
			RevY = true ;
			tmp = DestY1 ; DestY1 = DestY2 ; DestY2 = tmp ;
		}
		else
		{
			RevY = false ;
		}
	}

	// w``oȂ悤ɂ
	MotoDrawRect = GBASE.DrawArea ;
	MotoDrawRectF = GBASE.DrawAreaF ;
	SETRECT( GBASE.DrawArea, DestX1, DestY1, DestX2, DestY2 ) ;
	RectClipping( &GBASE.DrawArea, &MotoDrawRect ) ;
	SetMemImgDrawArea( &GBASE.DrawArea ) ;
	GBASE.DrawAreaF.left   = (float)GBASE.DrawArea.left ;
	GBASE.DrawAreaF.top    = (float)GBASE.DrawArea.top ;
	GBASE.DrawAreaF.right  = (float)GBASE.DrawArea.right ;
	GBASE.DrawAreaF.bottom = (float)GBASE.DrawArea.bottom ;

	// OtBbN̕`
	{
		DestWidth = DestX2 - DestX1 ;
		DestHeight = DestY2 - DestY1 ;
		exX = (double)DestWidth / SrcWidth ;
		exY = (double)DestHeight / SrcHeight ;
		if( RevX == true )
		{
			x1 = DestX2 + _DTOL( SrcX * exX ) ;
			x2 = DestX2 - _DTOL( ( Image2->Width - SrcX ) * exX ) ;
		}
		else
		{
			x1 = DestX1 - _DTOL( SrcX * exX ) ;
			x2 = DestX1 + _DTOL( ( Image2->Width - SrcX ) * exX ) ;
		}

		if( RevY == true )
		{
			y1 = DestY2 + _DTOL( SrcY * exY ) ;
			y2 = DestY2 - _DTOL( ( Image2->Height - SrcY ) * exY ) ;
		}
		else
		{
			y1 = DestY1 - _DTOL( SrcY * exY ) ;
			y2 = DestY1 + _DTOL( ( Image2->Height - SrcY ) * exY ) ;
		}
		hr = NS_DrawExtendGraph( x1, y1, x2, y2, GraphHandle, TransFlag ) ;
	}

	// ``ɖ߂
	GBASE.DrawArea = MotoDrawRect ;
	SetMemImgDrawArea( &MotoDrawRect ) ;
	GBASE.DrawAreaF = MotoDrawRectF ;

	// I
	return hr ;
}




// Qc|S`悷
#define SETDRAWRECTCODE\
	float MinX, MinY, MaxX, MaxY ;\
	const VERTEX *Vert ;\
\
	MinX =  100000000.0F ;\
	MinY =  100000000.0F ;\
	MaxX = -100000000.0F ;\
	MaxY = -100000000.0F ;\
	Vert = Vertex ;\
	for( i = 0 ; i < VertexNum ; i ++, Vert ++ )\
	{\
		if( Vert->x - 1.0F < MinX ) MinX = Vert->x - 1.0F ;\
		if( Vert->x + 1.0F > MaxX ) MaxX = Vert->x + 1.0F ;\
\
		if( Vert->y - 1.0F < MinY ) MinY = Vert->y - 1.0F ;\
		if( Vert->y + 1.0F > MaxY ) MaxY = Vert->y + 1.0F ;\
	}\
\
	GRH.DrawRect.left   = _FTOL( MinX ) ;\
	GRH.DrawRect.top    = _FTOL( MinY ) ;\
	GRH.DrawRect.right  = _FTOL( MaxX ) ;\
	GRH.DrawRect.bottom = _FTOL( MaxY ) ;\
	DRAWRECT_DRAWAREA_CLIP

extern	int NS_DrawPolygonBase( const VERTEX *Vertex, int VertexNum, int PrimitiveType, int GrHandle, int TransFlag, int UVScaling )
{
	IMAGEDATA2 *Image2 ;
	VERTEX_2D *TransVert = NULL ;
	VERTEX_2D *DestP ;
	int Ret, i, Flag ;
	float UPos = 0.0f, VPos = 0.0f, UScale = 1.0f, VScale = 1.0f ;

	Ret = -1;

	// G[
	Image2 = NULL ;
	if( GrHandle != DX_NONE_GRAPH )
	{
		if( GRAPHCHK( GrHandle, Image2 ) )
			return -1 ;

		Flag = Image2->Orig->FormatDesc.TextureFlag ;

		// 摜̃TCYŏQ̂悾tu␳͂Ȃ
		if( UVScaling )
		{
			if( Image2->Orig->FormatDesc.TextureFlag == FALSE ||
				( Image2->Hard.DrawNum == 1 && 
				  Image2->Hard.Draw->Tex->TexWidth  == Image2->Hard.Draw->Width &&
				  Image2->Hard.Draw->Tex->TexHeight == Image2->Hard.Draw->Height ) )
			{
				UVScaling = FALSE ;
			}
		}
	}
	else
	{
		Flag = GRA2.ValidHardWare ;
		UVScaling = FALSE ;
	}

	CheckActiveState() ;

#ifndef DX_NON_MOVIE
	if( GrHandle != DX_NONE_GRAPH )
		UpdateMovie( Image2->MovieHandle, FALSE ) ;
#endif

	// UVXP[Osꍇ͂Ńf[^Zo
	if( UVScaling )
	{
		UPos = ( float )Image2->Hard.Draw->UsePosX  / Image2->Hard.Draw->Tex->TexWidth ;
		VPos = ( float )Image2->Hard.Draw->UsePosY  / Image2->Hard.Draw->Tex->TexHeight ;
		UScale = ( float )Image2->Hard.Draw->Width  / Image2->Hard.Draw->Tex->TexWidth ;
		VScale = ( float )Image2->Hard.Draw->Height / Image2->Hard.Draw->Tex->TexHeight ;
	}

	// _̏o͐mۂ
	TransVert = ( VERTEX_2D * )DXALLOC( sizeof( VERTEX_2D ) * VertexNum ) ;
	if( TransVert == NULL ) return -1 ;

	// _ϊs
	if( GBASE.DrawBright.Red != 255 || GBASE.DrawBright.Green != 255 || GBASE.DrawBright.Blue != 255 ||
		( GBASE.BlendMode != DX_BLENDMODE_NOBLEND && GBASE.BlendParam != 255 ) )
	{
		DWORD *RedTable, *GreenTable, *BlueTable, *AlphaTable ;

		// e[upӂ
		RedTable   = MemImgManage.RateTable[GBASE.DrawBright.Red] ;
		GreenTable = MemImgManage.RateTable[GBASE.DrawBright.Green] ;
		BlueTable  = MemImgManage.RateTable[GBASE.DrawBright.Blue] ;
		AlphaTable = MemImgManage.RateTable[GBASE.BlendParam] ;
		if( GBASE.BlendMode == DX_BLENDMODE_NOBLEND ) AlphaTable = MemImgManage.RateTable[255] ;

		// _ϊ
		if( UVScaling )
		{
			DestP = TransVert ;
			for( i = 0 ; i < VertexNum ; i ++, DestP ++, Vertex ++ )
			{
				DestP->pos.x = Vertex->x ;
				DestP->pos.y = Vertex->y ;
				DestP->pos.z = GBASE.DrawZ ;
				DestP->rhw = 1.0F ;
				((BYTE *)&DestP->color)[0] = (BYTE)BlueTable [Vertex->b] ;
				((BYTE *)&DestP->color)[1] = (BYTE)GreenTable[Vertex->g] ;
				((BYTE *)&DestP->color)[2] = (BYTE)RedTable  [Vertex->r] ;
				((BYTE *)&DestP->color)[3] = (BYTE)AlphaTable[Vertex->a] ;
				DestP->u = Vertex->u * UScale + UPos ;
				DestP->v = Vertex->v * VScale + VPos ;
			}
		}
		else
		{
			DestP = TransVert ;
			for( i = 0 ; i < VertexNum ; i ++, DestP ++, Vertex ++ )
			{
				DestP->pos.x = Vertex->x ;
				DestP->pos.y = Vertex->y ;
				DestP->pos.z = GBASE.DrawZ ;
				DestP->rhw = 1.0F ;
				((BYTE *)&DestP->color)[0] = (BYTE)BlueTable [Vertex->b] ;
				((BYTE *)&DestP->color)[1] = (BYTE)GreenTable[Vertex->g] ;
				((BYTE *)&DestP->color)[2] = (BYTE)RedTable  [Vertex->r] ;
				((BYTE *)&DestP->color)[3] = (BYTE)AlphaTable[Vertex->a] ;
				DestP->u = Vertex->u ;
				DestP->v = Vertex->v ;
			}
		}
	}
	else
	{
		// _ϊ
		if( UVScaling )
		{
			DestP = TransVert ;
			for( i = 0 ; i < VertexNum ; i ++, DestP ++, Vertex ++ )
			{
				DestP->pos.x = Vertex->x ;
				DestP->pos.y = Vertex->y ;
				DestP->pos.z = GBASE.DrawZ ;
				DestP->rhw = 1.0F ;
				DestP->color = *( ( DWORD * )&Vertex->b ) ;
				DestP->u = Vertex->u * UScale + UPos ;
				DestP->v = Vertex->v * VScale + VPos ;
			}
		}
		else
		{
			DestP = TransVert ;
			for( i = 0 ; i < VertexNum ; i ++, DestP ++, Vertex ++ )
			{
				DestP->pos.x = Vertex->x ;
				DestP->pos.y = Vertex->y ;
				DestP->pos.z = GBASE.DrawZ ;
				DestP->rhw = 1.0F ;
				DestP->color = *( ( DWORD * )&Vertex->b ) ;
				DestP->u = Vertex->u ;
				DestP->v = Vertex->v ;
			}
		}
	}

	DRAW_DEF(
		DrawPrimitive2DHardware( TransVert, VertexNum, PrimitiveType, Image2, TransFlag, FALSE, FALSE, FALSE, 0 ),
		0,
		SETDRAWRECTCODE,
		Ret,
		Flag
	)

	if( TransVert != NULL )
	{
		DXFREE( TransVert ) ;
		TransVert = NULL ;
	}

	// I
	return Ret ;
}

#undef SETDRAWRECTCODE

// Qc|S`悷
extern	int NS_DrawPolygon( const VERTEX *Vertex, int PolygonNum, int GrHandle, int TransFlag, int UVScaling )
{
	return NS_DrawPolygonBase( Vertex, PolygonNum * 3, DX_PRIMTYPE_TRIANGLELIST, GrHandle, TransFlag,  UVScaling ) ;
}

// Rc|S`悷
extern	int NS_DrawPolygon3DBase( const VERTEX_3D *Vertex, int VertexNum, int PrimitiveType, int GrHandle, int TransFlag )
{
	IMAGEDATA2 *Image2 ;
	int Ret, i, Flag ;
	const VERTEX_3D *UseVertex ;

	Ret = -1;

	// G[
	Image2 = NULL ;
	if( GrHandle != DX_NONE_GRAPH )
	{
		if( GRAPHCHK( GrHandle, Image2 ) )
			return -1 ;
		Flag = Image2->Orig->FormatDesc.TextureFlag ;
	}
	else
	{
		Flag = GRA2.ValidHardWare ;
	}

	CheckActiveState() ;

#ifndef DX_NON_MOVIE
	if( GrHandle != DX_NONE_GRAPH )
		UpdateMovie( Image2->MovieHandle, FALSE ) ;
#endif

	// sn[hEGAɔf
	ApplyLibMatrixToHardware() ;

	// F̕ϊKvȏꍇ͂ŏ
	if( GBASE.DrawBright.Red   != 255 ||
		GBASE.DrawBright.Green != 255 ||
		GBASE.DrawBright.Blue  != 255 ||
		( GBASE.BlendMode != DX_BLENDMODE_NOBLEND && GBASE.BlendParam != 255 ) )
	{
		DWORD *RedTable, *GreenTable, *BlueTable, *AlphaTable ;
		const VERTEX_3D *sv ;
		VERTEX_3D *dv ;
		int Size ;

		// e[upӂ
		RedTable   = MemImgManage.RateTable[GBASE.DrawBright.Red] ;
		GreenTable = MemImgManage.RateTable[GBASE.DrawBright.Green] ;
		BlueTable  = MemImgManage.RateTable[GBASE.DrawBright.Blue] ;
		AlphaTable = MemImgManage.RateTable[GBASE.BlendParam] ;
		if( GBASE.BlendMode == DX_BLENDMODE_NOBLEND ) AlphaTable = MemImgManage.RateTable[255] ;

		// _f[^i[郁̈悪Ȃꍇ͊mۂ
		Size = sizeof( VERTEX_3D ) * VertexNum ;
		if( GBASE.TempVertexBufferSize < Size )
		{
			if( GBASE.TempVertexBuffer )
			{
				DXFREE( GBASE.TempVertexBuffer ) ;
				GBASE.TempVertexBufferSize = 0 ;
			}
			GBASE.TempVertexBuffer = DXALLOC( Size ) ;
			if( GBASE.TempVertexBuffer == NULL )
				return -1 ;
			GBASE.TempVertexBufferSize = Size ;
		}

		// ꎞobt@ɕϊȂ]
		sv = Vertex;
		dv = ( VERTEX_3D * )GBASE.TempVertexBuffer ;
		for( i = 0 ; i < VertexNum ; i ++, sv ++, dv ++ )
		{
			dv->pos = sv->pos ;
			dv->u = sv->u ;
			dv->v = sv->v ;
			dv->b = ( BYTE )BlueTable [ sv->b ] ;
			dv->g = ( BYTE )GreenTable[ sv->g ] ;
			dv->r = ( BYTE )RedTable  [ sv->r ] ;
			dv->a = ( BYTE )AlphaTable[ sv->a ] ;
		}
		UseVertex = ( VERTEX_3D * )GBASE.TempVertexBuffer ;
	}
	else
	{
		UseVertex = Vertex ;
	}
	
	DRAW_DEF(
		DrawPrimitiveHardware( UseVertex, VertexNum, PrimitiveType, Image2, TransFlag ),
		0,
		GRH.DrawRect = GBASE.DrawArea ;,
		Ret,
		Flag
	)

	return Ret ;
}

// Rc|S`悷(CfbNX)
extern	int NS_DrawPolygonIndexed3DBase( const VERTEX_3D *Vertex, int VertexNum, const unsigned short *Indices, int IndexNum, int PrimitiveType, int GrHandle, int TransFlag )
{
	IMAGEDATA2 *Image2 ;
	int Ret, i, Flag ;
	const VERTEX_3D *UseVertex ;

	Ret = -1;

	// G[
	Image2 = NULL ;
	if( GrHandle != DX_NONE_GRAPH )
	{
		if( GRAPHCHK( GrHandle, Image2 ) )
			return -1 ;
		Flag = Image2->Orig->FormatDesc.TextureFlag ;
	}
	else
	{
		Flag = GRA2.ValidHardWare ;
	}

	CheckActiveState() ;

#ifndef DX_NON_MOVIE
	if( GrHandle != DX_NONE_GRAPH )
		UpdateMovie( Image2->MovieHandle, FALSE ) ;
#endif

	// sn[hEGAɔf
	ApplyLibMatrixToHardware() ;

	// F̕ϊKvȏꍇ͂ŏ
	if( GBASE.DrawBright.Red   != 255 ||
		GBASE.DrawBright.Green != 255 ||
		GBASE.DrawBright.Blue  != 255 ||
		( GBASE.BlendMode != DX_BLENDMODE_NOBLEND && GBASE.BlendParam != 255 ) )
	{
		DWORD *RedTable, *GreenTable, *BlueTable, *AlphaTable ;
		const VERTEX_3D *sv ;
		VERTEX_3D *dv ;
		int Size ;

		// e[upӂ
		RedTable   = MemImgManage.RateTable[GBASE.DrawBright.Red] ;
		GreenTable = MemImgManage.RateTable[GBASE.DrawBright.Green] ;
		BlueTable  = MemImgManage.RateTable[GBASE.DrawBright.Blue] ;
		AlphaTable = MemImgManage.RateTable[GBASE.BlendParam] ;
		if( GBASE.BlendMode == DX_BLENDMODE_NOBLEND ) AlphaTable = MemImgManage.RateTable[255] ;

		// _f[^i[郁̈悪Ȃꍇ͊mۂ
		Size = sizeof( VERTEX_3D ) * VertexNum ;
		if( GBASE.TempVertexBufferSize < Size )
		{
			if( GBASE.TempVertexBuffer )
			{
				DXFREE( GBASE.TempVertexBuffer ) ;
				GBASE.TempVertexBufferSize = 0 ;
			}
			GBASE.TempVertexBuffer = DXALLOC( Size ) ;
			if( GBASE.TempVertexBuffer == NULL )
				return -1 ;
			GBASE.TempVertexBufferSize = Size ;
		}

		// ꎞobt@ɕϊȂ]
		sv = Vertex;
		dv = ( VERTEX_3D * )GBASE.TempVertexBuffer ;
		for( i = 0 ; i < VertexNum ; i ++, sv ++, dv ++ )
		{
			dv->pos = sv->pos ;
			dv->u = sv->u ;
			dv->v = sv->v ;
			dv->b = ( BYTE )BlueTable [ sv->b ] ;
			dv->g = ( BYTE )GreenTable[ sv->g ] ;
			dv->r = ( BYTE )RedTable  [ sv->r ] ;
			dv->a = ( BYTE )AlphaTable[ sv->a ] ;
		}
		UseVertex = ( VERTEX_3D * )GBASE.TempVertexBuffer ;
	}
	else
	{
		UseVertex = Vertex ;
	}
	
	DRAW_DEF(
		DrawIndexedPrimitiveHardware( UseVertex, VertexNum, Indices, IndexNum, PrimitiveType, Image2, TransFlag ),
		0,
		GRH.DrawRect = GBASE.DrawArea ;,
		Ret,
		Flag
	)

	return Ret ;
}

// Rc|S`悷
extern	int NS_DrawPolygon3D( const VERTEX_3D *Vertex, int PolygonNum, int GrHandle, int TransFlag )
{
	return NS_DrawPolygon3DBase( Vertex, PolygonNum * 3, DX_PRIMTYPE_TRIANGLELIST, GrHandle, TransFlag ) ;
}

// Qc|S`悷
extern int NS_DrawPolygon2D( const VERTEX2D *Vertex, int PolygonNum, int GrHandle, int TransFlag )
{
	return NS_DrawPrimitive2D( Vertex, PolygonNum * 3, DX_PRIMTYPE_TRIANGLELIST, GrHandle, TransFlag ) ;
}

// Qcv~eBu`悷
extern int NS_DrawPrimitive2D( const VERTEX2D *Vertex, int VertexNum, int PrimitiveType, int GrHandle, int TransFlag )
{
	IMAGEDATA2 *Image2 ;
	int Ret, i, Flag ;
	const VERTEX2D *UseVertex ;

	Ret = -1;

	// G[
	Image2 = NULL ;
	if( GrHandle != DX_NONE_GRAPH )
	{
		if( GRAPHCHK( GrHandle, Image2 ) )
			return -1 ;
		Flag = Image2->Orig->FormatDesc.TextureFlag ;
	}
	else
	{
		Flag = GRA2.ValidHardWare ;
	}

	CheckActiveState() ;

#ifndef DX_NON_MOVIE
	if( GrHandle != DX_NONE_GRAPH )
		UpdateMovie( Image2->MovieHandle, FALSE ) ;
#endif

	// F̕ϊKvȏꍇ͂ŏ
	if( GBASE.DrawBright.Red   != 255 ||
		GBASE.DrawBright.Green != 255 ||
		GBASE.DrawBright.Blue  != 255 ||
		( GBASE.BlendMode != DX_BLENDMODE_NOBLEND && GBASE.BlendParam != 255 ) )
	{
		DWORD *RedTable, *GreenTable, *BlueTable, *AlphaTable ;
		const VERTEX2D *sv ;
		VERTEX2D *dv ;
		int Size ;

		// e[upӂ
		RedTable   = MemImgManage.RateTable[GBASE.DrawBright.Red] ;
		GreenTable = MemImgManage.RateTable[GBASE.DrawBright.Green] ;
		BlueTable  = MemImgManage.RateTable[GBASE.DrawBright.Blue] ;
		AlphaTable = MemImgManage.RateTable[GBASE.BlendParam] ;
		if( GBASE.BlendMode == DX_BLENDMODE_NOBLEND ) AlphaTable = MemImgManage.RateTable[255] ;

		// _f[^i[郁̈悪Ȃꍇ͊mۂ
		Size = sizeof( VERTEX2D ) * VertexNum ;
		if( GBASE.TempVertexBufferSize < Size )
		{
			if( GBASE.TempVertexBuffer )
			{
				DXFREE( GBASE.TempVertexBuffer ) ;
				GBASE.TempVertexBufferSize = 0 ;
			}
			GBASE.TempVertexBuffer = DXALLOC( Size ) ;
			if( GBASE.TempVertexBuffer == NULL )
				return -1 ;
			GBASE.TempVertexBufferSize = Size ;
		}

		// ꎞobt@ɕϊȂ]
		sv = Vertex;
		dv = ( VERTEX2D * )GBASE.TempVertexBuffer ;
		for( i = 0 ; i < VertexNum ; i ++, sv ++, dv ++ )
		{
			dv->pos = sv->pos ;
			dv->rhw = sv->rhw ;
			dv->dif.b = ( BYTE )BlueTable [ sv->dif.b ] ;
			dv->dif.g = ( BYTE )GreenTable[ sv->dif.g ] ;
			dv->dif.r = ( BYTE )RedTable  [ sv->dif.r ] ;
			dv->dif.a = ( BYTE )AlphaTable[ sv->dif.a ] ;
			dv->u = sv->u ;
			dv->v = sv->v ;
		}
		UseVertex = ( VERTEX2D * )GBASE.TempVertexBuffer ;
	}
	else
	{
		UseVertex = Vertex ;
	}
	
	DRAW_DEF(
		DrawPrimitive2DUserHardware( UseVertex, VertexNum, PrimitiveType, Image2, TransFlag, FALSE, FALSE, 0 ),
		0,
		GRH.DrawRect = GBASE.DrawArea ;,
		Ret,
		Flag
	)

	return Ret ;
}

// Qc|S`悷( _CfbNXgp )
extern int NS_DrawPolygonIndexed2D( const VERTEX2D  *Vertex, int VertexNum, const unsigned short *Indices, int PolygonNum, int GrHandle, int TransFlag )
{
	return NS_DrawPrimitiveIndexed2D( Vertex, VertexNum, Indices, PolygonNum * 3, DX_PRIMTYPE_TRIANGLELIST, GrHandle, TransFlag ) ;
}

// Qcv~eBu`悷(CfbNX)
extern int NS_DrawPrimitiveIndexed2D( const VERTEX2D *Vertex, int VertexNum, const unsigned short *Indices, int IndexNum, int PrimitiveType, int GrHandle, int TransFlag )
{
	IMAGEDATA2 *Image2 ;
	int Ret, i, Flag ;
	const VERTEX2D *UseVertex ;

	Ret = -1;

	// G[
	Image2 = NULL ;
	if( GrHandle != DX_NONE_GRAPH )
	{
		if( GRAPHCHK( GrHandle, Image2 ) )
			return -1 ;
		Flag = Image2->Orig->FormatDesc.TextureFlag ;
	}
	else
	{
		Flag = GRA2.ValidHardWare ;
	}

	CheckActiveState() ;

#ifndef DX_NON_MOVIE
	if( GrHandle != DX_NONE_GRAPH )
		UpdateMovie( Image2->MovieHandle, FALSE ) ;
#endif

	// sn[hEGAɔf
	ApplyLibMatrixToHardware() ;

	// F̕ϊKvȏꍇ͂ŏ
	if( GBASE.DrawBright.Red   != 255 ||
		GBASE.DrawBright.Green != 255 ||
		GBASE.DrawBright.Blue  != 255 ||
		( GBASE.BlendMode != DX_BLENDMODE_NOBLEND && GBASE.BlendParam != 255 ) )
	{
		DWORD *RedTable, *GreenTable, *BlueTable, *AlphaTable ;
		const VERTEX2D *sv ;
		VERTEX2D *dv ;
		int Size ;

		// e[upӂ
		RedTable   = MemImgManage.RateTable[GBASE.DrawBright.Red] ;
		GreenTable = MemImgManage.RateTable[GBASE.DrawBright.Green] ;
		BlueTable  = MemImgManage.RateTable[GBASE.DrawBright.Blue] ;
		AlphaTable = MemImgManage.RateTable[GBASE.BlendParam] ;
		if( GBASE.BlendMode == DX_BLENDMODE_NOBLEND ) AlphaTable = MemImgManage.RateTable[255] ;

		// _f[^i[郁̈悪Ȃꍇ͊mۂ
		Size = sizeof( VERTEX2D ) * VertexNum ;
		if( GBASE.TempVertexBufferSize < Size )
		{
			if( GBASE.TempVertexBuffer )
			{
				DXFREE( GBASE.TempVertexBuffer ) ;
				GBASE.TempVertexBufferSize = 0 ;
			}
			GBASE.TempVertexBuffer = DXALLOC( Size ) ;
			if( GBASE.TempVertexBuffer == NULL )
				return -1 ;
			GBASE.TempVertexBufferSize = Size ;
		}

		// ꎞobt@ɕϊȂ]
		sv = Vertex;
		dv = ( VERTEX2D * )GBASE.TempVertexBuffer ;
		for( i = 0 ; i < VertexNum ; i ++, sv ++, dv ++ )
		{
			dv->pos = sv->pos ;
			dv->rhw = sv->rhw ;
			dv->dif.b = ( BYTE )BlueTable [ sv->dif.b ] ;
			dv->dif.g = ( BYTE )GreenTable[ sv->dif.g ] ;
			dv->dif.r = ( BYTE )RedTable  [ sv->dif.r ] ;
			dv->dif.a = ( BYTE )AlphaTable[ sv->dif.a ] ;
			dv->u = sv->u ;
			dv->v = sv->v ;
		}
		UseVertex = ( VERTEX2D * )GBASE.TempVertexBuffer ;
	}
	else
	{
		UseVertex = Vertex ;
	}
	
	DRAW_DEF(
		DrawIndexedPrimitive2DUserHardware( UseVertex, VertexNum, Indices, IndexNum, PrimitiveType, Image2, TransFlag ),
		0,
		GRH.DrawRect = GBASE.DrawArea ;,
		Ret,
		Flag
	)

	return Ret ;
}

// Rc|S`悷
extern int NS_DrawPrimitive3D( const VERTEX3D *Vertex, int VertexNum, int PrimitiveType, int GrHandle, int TransFlag )
{
	IMAGEDATA2 *Image2 ;
	int Ret, i, Flag ;
	const VERTEX3D *UseVertex ;

	Ret = -1;

	// G[
	Image2 = NULL ;
	if( GrHandle != DX_NONE_GRAPH )
	{
		if( GRAPHCHK( GrHandle, Image2 ) )
			return -1 ;
		Flag = Image2->Orig->FormatDesc.TextureFlag ;
	}
	else
	{
		Flag = GRA2.ValidHardWare ;
	}

	CheckActiveState() ;

#ifndef DX_NON_MOVIE
	if( GrHandle != DX_NONE_GRAPH )
		UpdateMovie( Image2->MovieHandle, FALSE ) ;
#endif

	// sn[hEGAɔf
	ApplyLibMatrixToHardware() ;

	// F̕ϊKvȏꍇ͂ŏ
	if( GBASE.DrawBright.Red   != 255 ||
		GBASE.DrawBright.Green != 255 ||
		GBASE.DrawBright.Blue  != 255 ||
		( GBASE.BlendMode != DX_BLENDMODE_NOBLEND && GBASE.BlendParam != 255 ) )
	{
		DWORD *RedTable, *GreenTable, *BlueTable, *AlphaTable ;
		const VERTEX3D *sv ;
		VERTEX3D *dv ;
		int Size ;

		// e[upӂ
		RedTable   = MemImgManage.RateTable[GBASE.DrawBright.Red] ;
		GreenTable = MemImgManage.RateTable[GBASE.DrawBright.Green] ;
		BlueTable  = MemImgManage.RateTable[GBASE.DrawBright.Blue] ;
		AlphaTable = MemImgManage.RateTable[GBASE.BlendParam] ;
		if( GBASE.BlendMode == DX_BLENDMODE_NOBLEND ) AlphaTable = MemImgManage.RateTable[255] ;

		// _f[^i[郁̈悪Ȃꍇ͊mۂ
		Size = sizeof( VERTEX3D ) * VertexNum ;
		if( GBASE.TempVertexBufferSize < Size )
		{
			if( GBASE.TempVertexBuffer )
			{
				DXFREE( GBASE.TempVertexBuffer ) ;
				GBASE.TempVertexBufferSize = 0 ;
			}
			GBASE.TempVertexBuffer = DXALLOC( Size ) ;
			if( GBASE.TempVertexBuffer == NULL )
				return -1 ;
			GBASE.TempVertexBufferSize = Size ;
		}

		// ꎞobt@ɕϊȂ]
		sv = Vertex;
		dv = ( VERTEX3D * )GBASE.TempVertexBuffer ;
		for( i = 0 ; i < VertexNum ; i ++, sv ++, dv ++ )
		{
			dv->pos = sv->pos ;
			dv->norm = sv->norm ;
			dv->dif.b = ( BYTE )BlueTable [ sv->dif.b ] ;
			dv->dif.g = ( BYTE )GreenTable[ sv->dif.g ] ;
			dv->dif.r = ( BYTE )RedTable  [ sv->dif.r ] ;
			dv->dif.a = ( BYTE )AlphaTable[ sv->dif.a ] ;
			dv->spc.b = ( BYTE )BlueTable [ sv->spc.b ] ;
			dv->spc.g = ( BYTE )GreenTable[ sv->spc.g ] ;
			dv->spc.r = ( BYTE )RedTable  [ sv->spc.r ] ;
			dv->spc.a = ( BYTE )AlphaTable[ sv->spc.a ] ;
			dv->u = sv->u ;
			dv->v = sv->v ;
			dv->su = sv->su ;
			dv->sv = sv->sv ;
		}
		UseVertex = ( VERTEX3D * )GBASE.TempVertexBuffer ;
	}
	else
	{
		UseVertex = Vertex ;
	}
	
	DRAW_DEF(
		DrawPrimitiveLightHardware( UseVertex, VertexNum, PrimitiveType, Image2, TransFlag ),
		0,
		GRH.DrawRect = GBASE.DrawArea ;,
		Ret,
		Flag
	)

	return Ret ;
}

// Rc|S`悷(CfbNX)
extern int NS_DrawPrimitiveIndexed3D( const VERTEX3D *Vertex, int VertexNum, const unsigned short *Indices, int IndexNum, int PrimitiveType, int GrHandle, int TransFlag )
{
	IMAGEDATA2 *Image2 ;
	int Ret, i, Flag ;
	const VERTEX3D *UseVertex ;

	Ret = -1;

	// G[
	Image2 = NULL ;
	if( GrHandle != DX_NONE_GRAPH )
	{
		if( GRAPHCHK( GrHandle, Image2 ) )
			return -1 ;
		Flag = Image2->Orig->FormatDesc.TextureFlag ;
	}
	else
	{
		Flag = GRA2.ValidHardWare ;
	}

	CheckActiveState() ;

#ifndef DX_NON_MOVIE
	if( GrHandle != DX_NONE_GRAPH )
		UpdateMovie( Image2->MovieHandle, FALSE ) ;
#endif

	// sn[hEGAɔf
	ApplyLibMatrixToHardware() ;

	// F̕ϊKvȏꍇ͂ŏ
	if( GBASE.DrawBright.Red   != 255 ||
		GBASE.DrawBright.Green != 255 ||
		GBASE.DrawBright.Blue  != 255 ||
		( GBASE.BlendMode != DX_BLENDMODE_NOBLEND && GBASE.BlendParam != 255 ) )
	{
		DWORD *RedTable, *GreenTable, *BlueTable, *AlphaTable ;
		const VERTEX3D *sv ;
		VERTEX3D *dv ;
		int Size ;

		// e[upӂ
		RedTable   = MemImgManage.RateTable[GBASE.DrawBright.Red] ;
		GreenTable = MemImgManage.RateTable[GBASE.DrawBright.Green] ;
		BlueTable  = MemImgManage.RateTable[GBASE.DrawBright.Blue] ;
		AlphaTable = MemImgManage.RateTable[GBASE.BlendParam] ;
		if( GBASE.BlendMode == DX_BLENDMODE_NOBLEND ) AlphaTable = MemImgManage.RateTable[255] ;

		// _f[^i[郁̈悪Ȃꍇ͊mۂ
		Size = sizeof( VERTEX3D ) * VertexNum ;
		if( GBASE.TempVertexBufferSize < Size )
		{
			if( GBASE.TempVertexBuffer )
			{
				DXFREE( GBASE.TempVertexBuffer ) ;
				GBASE.TempVertexBufferSize = 0 ;
			}
			GBASE.TempVertexBuffer = DXALLOC( Size ) ;
			if( GBASE.TempVertexBuffer == NULL )
				return -1 ;
			GBASE.TempVertexBufferSize = Size ;
		}

		// ꎞobt@ɕϊȂ]
		sv = Vertex;
		dv = ( VERTEX3D * )GBASE.TempVertexBuffer ;
		for( i = 0 ; i < VertexNum ; i ++, sv ++, dv ++ )
		{
			dv->pos = sv->pos ;
			dv->norm = sv->norm ;
			dv->dif.b = ( BYTE )BlueTable [ sv->dif.b ] ;
			dv->dif.g = ( BYTE )GreenTable[ sv->dif.g ] ;
			dv->dif.r = ( BYTE )RedTable  [ sv->dif.r ] ;
			dv->dif.a = ( BYTE )AlphaTable[ sv->dif.a ] ;
			dv->spc.b = ( BYTE )BlueTable [ sv->spc.b ] ;
			dv->spc.g = ( BYTE )GreenTable[ sv->spc.g ] ;
			dv->spc.r = ( BYTE )RedTable  [ sv->spc.r ] ;
			dv->spc.a = ( BYTE )AlphaTable[ sv->spc.a ] ;
			dv->u = sv->u ;
			dv->v = sv->v ;
			dv->su = sv->su ;
			dv->sv = sv->sv ;
		}
		UseVertex = ( VERTEX3D * )GBASE.TempVertexBuffer ;
	}
	else
	{
		UseVertex = Vertex ;
	}
	
	DRAW_DEF(
		DrawIndexedPrimitiveLightHardware( UseVertex, VertexNum, Indices, IndexNum, PrimitiveType, Image2, TransFlag ),
		0,
		GRH.DrawRect = GBASE.DrawArea ;,
		Ret,
		Flag
	)

	return Ret ;
}

// _obt@gpĂRcv~eBu`悷
extern int NS_DrawPrimitive3D_UseVertexBuffer( int VertexBufHandle, int PrimitiveType  /* DX_PRIMTYPE_TRIANGLELIST  */, int GrHandle, int TransFlag )
{
	IMAGEDATA2 *Image2 ;
	VERTEXBUFFERHANDLEDATA *VertexBuffer ;
	int Ret, Flag ;

	Ret = -1;

	// G[
	Image2 = NULL ;
	if( GrHandle != DX_NONE_GRAPH )
	{
		if( GRAPHCHK( GrHandle, Image2 ) )
			return -1 ;
		Flag = Image2->Orig->FormatDesc.TextureFlag ;
	}
	else
	{
		Flag = GRA2.ValidHardWare ;
	}
	VertexBuffer = NULL ;
	if( VERTEXBUFFERCHK( VertexBufHandle, VertexBuffer ) )
		return -1 ;

	CheckActiveState() ;

#ifndef DX_NON_MOVIE
	if( GrHandle != DX_NONE_GRAPH )
		UpdateMovie( Image2->MovieHandle, FALSE ) ;
#endif

	// sn[hEGAɔf
	ApplyLibMatrixToHardware() ;

	DRAW_DEF(
		DrawPrimitiveLight_UseVertexBufferHardware( VertexBuffer, PrimitiveType, 0, VertexBuffer->Num, Image2, TransFlag ),
		0,
		GRH.DrawRect = GBASE.DrawArea ;,
		Ret,
		Flag
	)

	return Ret ;
}

// _obt@gpĂRcv~eBu`悷
extern int NS_DrawPrimitive3D_UseVertexBuffer2( int VertexBufHandle, int PrimitiveType  /* DX_PRIMTYPE_TRIANGLELIST  */, int StartVertex, int UseVertexNum, int GrHandle, int TransFlag )
{
	IMAGEDATA2 *Image2 ;
	VERTEXBUFFERHANDLEDATA *VertexBuffer ;
	int Ret, Flag ;

	Ret = -1;

	// G[
	Image2 = NULL ;
	if( GrHandle != DX_NONE_GRAPH )
	{
		if( GRAPHCHK( GrHandle, Image2 ) )
			return -1 ;
		Flag = Image2->Orig->FormatDesc.TextureFlag ;
	}
	else
	{
		Flag = GRA2.ValidHardWare ;
	}
	VertexBuffer = NULL ;
	if( VERTEXBUFFERCHK( VertexBufHandle, VertexBuffer ) )
		return -1 ;

	CheckActiveState() ;

#ifndef DX_NON_MOVIE
	if( GrHandle != DX_NONE_GRAPH )
		UpdateMovie( Image2->MovieHandle, FALSE ) ;
#endif

	// sn[hEGAɔf
	ApplyLibMatrixToHardware() ;

	DRAW_DEF(
		DrawPrimitiveLight_UseVertexBufferHardware( VertexBuffer, PrimitiveType, StartVertex, UseVertexNum, Image2, TransFlag ),
		0,
		GRH.DrawRect = GBASE.DrawArea ;,
		Ret,
		Flag
	)

	return Ret ;
}

// _obt@ƃCfbNXobt@gpĂRcv~eBu`悷
extern int NS_DrawPrimitiveIndexed3D_UseVertexBuffer( int VertexBufHandle, int IndexBufHandle, int PrimitiveType  /* DX_PRIMTYPE_TRIANGLELIST  */, int GrHandle, int TransFlag )
{
	IMAGEDATA2 *Image2 ;
	VERTEXBUFFERHANDLEDATA *VertexBuffer ;
	INDEXBUFFERHANDLEDATA *IndexBuffer ;
	int Ret, Flag ;

	Ret = -1;

	// G[
	Image2 = NULL ;
	if( GrHandle != DX_NONE_GRAPH )
	{
		if( GRAPHCHK( GrHandle, Image2 ) )
			return -1 ;
		Flag = Image2->Orig->FormatDesc.TextureFlag ;
	}
	else
	{
		Flag = GRA2.ValidHardWare ;
	}
	VertexBuffer = NULL ;
	if( VERTEXBUFFERCHK( VertexBufHandle, VertexBuffer ) )
		return -1 ;
	if( INDEXBUFFERCHK( IndexBufHandle, IndexBuffer ) )
		return -1 ;

	CheckActiveState() ;

#ifndef DX_NON_MOVIE
	if( GrHandle != DX_NONE_GRAPH )
		UpdateMovie( Image2->MovieHandle, FALSE ) ;
#endif

	// sn[hEGAɔf
	ApplyLibMatrixToHardware() ;

	DRAW_DEF(
		DrawIndexedPrimitiveLight_UseVertexBufferHardware( VertexBuffer, IndexBuffer, PrimitiveType, 0, 0, VertexBuffer->Num, 0, IndexBuffer->Num, Image2, TransFlag ),
		0,
		GRH.DrawRect = GBASE.DrawArea ;,
		Ret,
		Flag
	)

	return Ret ;
}

// _obt@ƃCfbNXobt@gpĂRcv~eBu`悷
extern int NS_DrawPrimitiveIndexed3D_UseVertexBuffer2( int VertexBufHandle, int IndexBufHandle, int PrimitiveType  /* DX_PRIMTYPE_TRIANGLELIST  */, int BaseVertex, int StartVertex, int UseVertexNum, int StartIndex, int UseIndexNum, int GrHandle, int TransFlag )
{
	IMAGEDATA2 *Image2 ;
	VERTEXBUFFERHANDLEDATA *VertexBuffer ;
	INDEXBUFFERHANDLEDATA *IndexBuffer ;
	int Ret, Flag ;

	Ret = -1;

	// G[
	Image2 = NULL ;
	if( GrHandle != DX_NONE_GRAPH )
	{
		if( GRAPHCHK( GrHandle, Image2 ) )
			return -1 ;
		Flag = Image2->Orig->FormatDesc.TextureFlag ;
	}
	else
	{
		Flag = GRA2.ValidHardWare ;
	}
	VertexBuffer = NULL ;
	if( VERTEXBUFFERCHK( VertexBufHandle, VertexBuffer ) )
		return -1 ;
	if( INDEXBUFFERCHK( IndexBufHandle, IndexBuffer ) )
		return -1 ;

	CheckActiveState() ;

#ifndef DX_NON_MOVIE
	if( GrHandle != DX_NONE_GRAPH )
		UpdateMovie( Image2->MovieHandle, FALSE ) ;
#endif

	// sn[hEGAɔf
	ApplyLibMatrixToHardware() ;

	DRAW_DEF(
		DrawIndexedPrimitiveLight_UseVertexBufferHardware( VertexBuffer, IndexBuffer, PrimitiveType, BaseVertex, StartVertex, UseVertexNum, StartIndex, UseIndexNum, Image2, TransFlag ),
		0,
		GRH.DrawRect = GBASE.DrawArea ;,
		Ret,
		Flag
	)

	return Ret ;
}



// Rc|S`悷
extern int NS_DrawPolygon3D( const VERTEX3D *Vertex, int PolygonNum, int GrHandle, int TransFlag )
{
	return NS_DrawPrimitive3D( Vertex, PolygonNum * 3, DX_PRIMTYPE_TRIANGLELIST, GrHandle, TransFlag ) ;
}

// Rc|S`悷(CfbNX)
extern int NS_DrawPolygonIndexed3D( const VERTEX3D *Vertex, int VertexNum, const unsigned short *Indices, int PolygonNum, int GrHandle, int TransFlag )
{
	return NS_DrawPrimitiveIndexed3D( Vertex, VertexNum, Indices, PolygonNum * 3, DX_PRIMTYPE_TRIANGLELIST, GrHandle, TransFlag ) ;
}

// _obt@gpĂRc|S`悷
extern int NS_DrawPolygon3D_UseVertexBuffer( int VertexBufHandle, int GrHandle, int TransFlag )
{
	return NS_DrawPrimitive3D_UseVertexBuffer( VertexBufHandle, DX_PRIMTYPE_TRIANGLELIST, GrHandle, TransFlag ) ;
}

// _obt@ƃCfbNXobt@gpĂRc|S`悷
extern int NS_DrawPolygonIndexed3D_UseVertexBuffer( int VertexBufHandle, int IndexBufHandle, int GrHandle, int TransFlag )
{
	return NS_DrawPrimitiveIndexed3D_UseVertexBuffer( VertexBufHandle, IndexBufHandle, DX_PRIMTYPE_TRIANGLELIST, GrHandle, TransFlag ) ;
}

// ⏕֐

// OtBbN̂Rc`
#define SETDRAWRECTCODE\
	float MinX, MinY, MaxX, MaxY ;\
\
	MinX =  100000000.0F ;\
	MinY =  100000000.0F ;\
	MaxX = -100000000.0F ;\
	MaxY = -100000000.0F ;\
	for( i = 0 ; i < 4 ; i ++ )\
	{\
		if( TransVert[i].pos.x - 1.0F < MinX ) MinX = TransVert[i].pos.x - 1.0F ;\
		if( TransVert[i].pos.x + 1.0F > MaxX ) MaxX = TransVert[i].pos.x + 1.0F ;\
\
		if( TransVert[i].pos.y - 1.0F < MinY ) MinY = TransVert[i].pos.y - 1.0F ;\
		if( TransVert[i].pos.y + 1.0F > MaxY ) MaxY = TransVert[i].pos.y + 1.0F ;\
	}\
\
	GRH.DrawRect.left   = _FTOL( MinX ) ;\
	GRH.DrawRect.top    = _FTOL( MinY ) ;\
	GRH.DrawRect.right  = _FTOL( MaxX ) ;\
	GRH.DrawRect.bottom = _FTOL( MaxY ) ;\
	DRAWRECT_DRAWAREA_CLIP

extern	int NS_DrawGraph3D( float x, float y, float z, int GrHandle, int TransFlag )
{
	IMAGEDATA2 *Image2 ;
	int Ret = -1, i ;
	VERTEX_2D TransVert[6] ;

	if( GBASE.NotDrawFlag || GBASE.NotDrawFlagInSetDrawArea )
		return 0 ;

	// G[
	if( GRAPHCHK( GrHandle, Image2 ) )
		return -1 ;

	CheckActiveState() ;

#ifndef DX_NON_MOVIE
	if( GrHandle != DX_NONE_GRAPH )
		UpdateMovie( Image2->MovieHandle, FALSE ) ;
#endif

	// sn[hEGAɔf
	ApplyLibMatrixToHardware() ;

	// Wϊs
	{
		MATRIX *TransMatrix ;

		TransMatrix = &GBASE.BlendMatrix ;

		// _Zbg
		{
			VECTOR SrcVec[4], Pos ;
			VERTEX_2D DestVec[4] ;
			float SizeX, SizeY ;
			
			// r{[ĥS_𓾂
			SizeX = ( float )Image2->Width  * 0.5F ;
			SizeY = ( float )Image2->Height * 0.5F ;
			Pos.x = x ;	Pos.y = y ;	Pos.z = z ;
			SrcVec[0].x = -SizeX ;	SrcVec[0].y =  SizeY ;	SrcVec[0].z = 0.0F ;
			SrcVec[1].x =  SizeX ;	SrcVec[1].y =  SizeY ;	SrcVec[1].z = 0.0F ;
			SrcVec[2].x = -SizeX ;	SrcVec[2].y = -SizeY ;	SrcVec[2].z = 0.0F ;
			SrcVec[3].x =  SizeX ;	SrcVec[3].y = -SizeY ;	SrcVec[3].z = 0.0F ;

			// Wϊ
			for( i = 0 ; i < 4 ; i ++ )
			{
				// r{[hW[hW֕ϊ
				_VectorTransformToBillboard( &SrcVec[i], &Pos ) ;

				// XN[Wɕϊ
				DestVec[i].rhw = 1.0F ;
				VectorTransform4( &DestVec[i].pos,  &DestVec[i].rhw,
									      &SrcVec[i],  &DestVec[i].rhw, TransMatrix ) ;
				DestVec[i].rhw = 1.0F / DestVec[i].rhw ;
				DestVec[i].pos.x *= DestVec[i].rhw ;
				DestVec[i].pos.y *= DestVec[i].rhw ;
				DestVec[i].pos.z *= DestVec[i].rhw ;
			}
									            
			// _̃Zbg
			TransVert[0].pos = DestVec[0].pos ;
			TransVert[1].pos = DestVec[1].pos ;
			TransVert[2].pos = DestVec[2].pos ;
			TransVert[3].pos = DestVec[3].pos ;
			TransVert[0].rhw = DestVec[0].rhw ;
			TransVert[1].rhw = DestVec[1].rhw ;
			TransVert[2].rhw = DestVec[2].rhw ;
			TransVert[3].rhw = DestVec[3].rhw ;

			((BYTE *)&TransVert[0].color)[0] = (BYTE)GBASE.DrawBright.Blue ;
			((BYTE *)&TransVert[0].color)[1] = (BYTE)GBASE.DrawBright.Green ;
			((BYTE *)&TransVert[0].color)[2] = (BYTE)GBASE.DrawBright.Red ;
			((BYTE *)&TransVert[0].color)[3] = (BYTE)GBASE.BlendParam ;
			TransVert[1].color =
			TransVert[2].color =
			TransVert[3].color = TransVert[0].color ;

			TransVert[0].u = 0.0F ;	TransVert[0].v = 0.0F ;
			TransVert[1].u = 1.0F ;	TransVert[1].v = 0.0F ;
			TransVert[2].u = 0.0F ;	TransVert[2].v = 1.0F ;
			TransVert[3].u = 1.0F ;	TransVert[3].v = 1.0F ;

			TransVert[4] = TransVert[2] ;
			TransVert[5] = TransVert[1] ;
		}
	}

	// `
	DRAW_DEF(
		DrawPrimitive2DHardware( TransVert, 6, DX_PRIMTYPE_TRIANGLELIST, Image2, TransFlag, TRUE, TRUE, FALSE, 0 ),
		0,
		SETDRAWRECTCODE,
		Ret,
		Image2->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}

// OtBbN̊gRc`
extern	int NS_DrawExtendGraph3D( float x, float y, float z, double ExRateX, double ExRateY, int GrHandle, int TransFlag )
{
	IMAGEDATA2 *Image2 ;
	int Ret = -1, i ;
	VERTEX_2D TransVert[6] ;

	if( GBASE.NotDrawFlag || GBASE.NotDrawFlagInSetDrawArea )
		return 0 ;

	// G[
	if( GRAPHCHK( GrHandle, Image2 ) )
		return -1 ;

	CheckActiveState() ;

#ifndef DX_NON_MOVIE
	if( GrHandle != DX_NONE_GRAPH )
		UpdateMovie( Image2->MovieHandle ) ;
#endif

	// sn[hEGAɔf
	ApplyLibMatrixToHardware() ;

	// Wϊs
	{
		MATRIX *TransMatrix ;

		TransMatrix = &GBASE.BlendMatrix ;

		// _Zbg
		{
			VECTOR SrcVec[4], Pos ;
			VERTEX_2D DestVec[4] ;
			float SizeX, SizeY ;
			
			// r{[ĥS_𓾂
			SizeX = ( float )Image2->Width  * ( float )ExRateX * 0.5F ;
			SizeY = ( float )Image2->Height * ( float )ExRateY * 0.5F ;
			Pos.x = x ;	Pos.y = y ;	Pos.z = z ;
			SrcVec[0].x = -SizeX ;	SrcVec[0].y =  SizeY ;	SrcVec[0].z = 0.0F ;
			SrcVec[1].x =  SizeX ;	SrcVec[1].y =  SizeY ;	SrcVec[1].z = 0.0F ;
			SrcVec[2].x = -SizeX ;	SrcVec[2].y = -SizeY ;	SrcVec[2].z = 0.0F ;
			SrcVec[3].x =  SizeX ;	SrcVec[3].y = -SizeY ;	SrcVec[3].z = 0.0F ;

			// Wϊ
			for( i = 0 ; i < 4 ; i ++ )
			{
				// r{[hW[hW֕ϊ
				_VectorTransformToBillboard( &SrcVec[i], &Pos ) ;

				// XN[Wɕϊ
				DestVec[i].rhw = 1.0F ;
				VectorTransform4( &DestVec[i].pos,  &DestVec[i].rhw,
									      &SrcVec[i],  &DestVec[i].rhw, TransMatrix ) ;
				DestVec[i].rhw = 1.0F / DestVec[i].rhw ;
				DestVec[i].pos.x *= DestVec[i].rhw ;
				DestVec[i].pos.y *= DestVec[i].rhw ;
				DestVec[i].pos.z *= DestVec[i].rhw ;
			}
									            
			// _̃Zbg
			TransVert[0].pos = DestVec[0].pos ;
			TransVert[1].pos = DestVec[1].pos ;
			TransVert[2].pos = DestVec[2].pos ;
			TransVert[3].pos = DestVec[3].pos ;
			TransVert[0].rhw = DestVec[0].rhw ;
			TransVert[1].rhw = DestVec[1].rhw ;
			TransVert[2].rhw = DestVec[2].rhw ;
			TransVert[3].rhw = DestVec[3].rhw ;

			((BYTE *)&TransVert[0].color)[0] = (BYTE)GBASE.DrawBright.Blue ;
			((BYTE *)&TransVert[0].color)[1] = (BYTE)GBASE.DrawBright.Green ;
			((BYTE *)&TransVert[0].color)[2] = (BYTE)GBASE.DrawBright.Red ;
			((BYTE *)&TransVert[0].color)[3] = (BYTE)GBASE.BlendParam ;
			TransVert[1].color =
			TransVert[2].color =
			TransVert[3].color = TransVert[0].color ;

			TransVert[0].u = 0.0F ;	TransVert[0].v = 0.0F ;
			TransVert[1].u = 1.0F ;	TransVert[1].v = 0.0F ;
			TransVert[2].u = 0.0F ;	TransVert[2].v = 1.0F ;
			TransVert[3].u = 1.0F ;	TransVert[3].v = 1.0F ;

			TransVert[4] = TransVert[2] ;
			TransVert[5] = TransVert[1] ;
		}
	}

	// `
	DRAW_DEF(
		DrawPrimitive2DHardware( TransVert, 6, DX_PRIMTYPE_TRIANGLELIST, Image2, TransFlag, TRUE, TRUE, FALSE, 0 ),
		0,
		SETDRAWRECTCODE,
		Ret,
		Image2->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}

// OtBbN̉]Rc`
extern	int NS_DrawRotaGraph3D( float x, float y, float z, double ExRate, double Angle, int GrHandle, int TransFlag, int TurnFlag )
{
	IMAGEDATA2 *Image2 ;
	int Ret = -1, i ;
	VERTEX_2D TransVert[6] ;
	float Sin, Cos ;
	float ExtendRate = ( float )ExRate ; 
	float ExtendRateX ;
	float XBuf, YBuf ;

	if( GBASE.NotDrawFlag || GBASE.NotDrawFlagInSetDrawArea )
		return 0 ;

	// G[
	if( GRAPHCHK( GrHandle, Image2 ) )
		return -1 ;

	CheckActiveState() ;

#ifndef DX_NON_MOVIE
	if( GrHandle != DX_NONE_GRAPH )
		UpdateMovie( Image2->MovieHandle ) ;
#endif

	// sn[hEGAɔf
	ApplyLibMatrixToHardware() ;

	// Wϊs
	{
		MATRIX *TransMatrix ;

		TransMatrix = &GBASE.BlendMatrix ;

		// _Zbg
		{
			VECTOR SrcVec[4], Pos ;
			VERTEX_2D DestVec[4], VectBuf ;
			float SizeX, SizeY ;

			// ]l̊g嗦Zbg
			ExtendRateX = ( ( TurnFlag == TRUE ) ? -1.0f : 1.0f ) * ExtendRate ;

			// r{[ĥS_𓾂
			{
				SizeX = Image2->Width  * 0.5F * ExtendRateX ;
				SizeY = Image2->Height * 0.5F * ExtendRate  ;
				Pos.x = x ;	Pos.y = y ;	Pos.z = z ;
				SrcVec[0].x = -SizeX ;	SrcVec[0].y =  SizeY ;	SrcVec[0].z = 0.0F ;
				SrcVec[1].x =  SizeX ;	SrcVec[1].y =  SizeY ;	SrcVec[1].z = 0.0F ;
				SrcVec[2].x = -SizeX ;	SrcVec[2].y = -SizeY ;	SrcVec[2].z = 0.0F ;
				SrcVec[3].x =  SizeX ;	SrcVec[3].y = -SizeY ;	SrcVec[3].z = 0.0F ;

				// ]
				_SINCOS( (float)Angle, &Sin, &Cos ) ;
				for( i = 0 ; i < 4 ; i ++ )
				{
					XBuf = SrcVec[i].x ;
					YBuf = SrcVec[i].y ;

					SrcVec[i].x = XBuf * Cos - YBuf * Sin ;	
					SrcVec[i].y = XBuf * Sin + YBuf * Cos ;
				}
			}

			// Wϊ
			for( i = 0 ; i < 4 ; i ++ )
			{
				// r{[hW[hW֕ϊ
				_VectorTransformToBillboard( &SrcVec[i], &Pos ) ;

				// XN[Wɕϊ
				DestVec[i].rhw = 1.0F ;
				VectorTransform4( &DestVec[i].pos,  &DestVec[i].rhw,
									      &SrcVec[i],  &DestVec[i].rhw, TransMatrix ) ;
				DestVec[i].rhw = 1.0F / DestVec[i].rhw ;
				DestVec[i].pos.x *= DestVec[i].rhw ;
				DestVec[i].pos.y *= DestVec[i].rhw ;
				DestVec[i].pos.z *= DestVec[i].rhw ;
			}
									            
			// _̃Zbg
			TransVert[0].pos = DestVec[0].pos ;
			TransVert[1].pos = DestVec[1].pos ;
			TransVert[2].pos = DestVec[2].pos ;
			TransVert[3].pos = DestVec[3].pos ;
			TransVert[0].rhw = DestVec[0].rhw ;
			TransVert[1].rhw = DestVec[1].rhw ;
			TransVert[2].rhw = DestVec[2].rhw ;
			TransVert[3].rhw = DestVec[3].rhw ;

			((BYTE *)&TransVert[0].color)[0] = (BYTE)GBASE.DrawBright.Blue ;
			((BYTE *)&TransVert[0].color)[1] = (BYTE)GBASE.DrawBright.Green ;
			((BYTE *)&TransVert[0].color)[2] = (BYTE)GBASE.DrawBright.Red ;
			((BYTE *)&TransVert[0].color)[3] = (BYTE)GBASE.BlendParam ;
			TransVert[1].color =
			TransVert[2].color =
			TransVert[3].color = TransVert[0].color ;

			TransVert[0].u = 0.0F ;	TransVert[0].v = 0.0F ;
			TransVert[1].u = 1.0F ;	TransVert[1].v = 0.0F ;
			TransVert[2].u = 0.0F ;	TransVert[2].v = 1.0F ;
			TransVert[3].u = 1.0F ;	TransVert[3].v = 1.0F ;

			TransVert[4] = TransVert[2] ;
			TransVert[5] = TransVert[1] ;

			// ]
			if( TurnFlag == TRUE )
			{
				VectBuf = TransVert[ 1 ] ; TransVert[ 1 ] = TransVert[ 2 ] ; TransVert[ 2 ] = VectBuf ;
			}

			TransVert[4] = TransVert[2] ;
			TransVert[5] = TransVert[1] ;
		}
	}

	// `
	DRAW_DEF(
		DrawPrimitive2DHardware( TransVert, 6, DX_PRIMTYPE_TRIANGLELIST, Image2, TransFlag, TRUE, TRUE, FALSE, 0 ),
		0,
		SETDRAWRECTCODE,
		Ret,
		Image2->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}

// OtBbN̉]Rc`(]Sw^)
extern	int NS_DrawRota2Graph3D( float x, float y, float z, float cx, float cy, double ExtRateX, double ExtRateY, double Angle, int GrHandle, int TransFlag, int TurnFlag )
{
	IMAGEDATA2 *Image2 ;
	int Ret = -1, i ;
	VERTEX_2D TransVert[6] ;
	float Sin, Cos ;
	float ExtendRateX = ( float )ExtRateX ; 
	float ExtendRateY = ( float )ExtRateY ; 
	float XBuf, YBuf ;

	if( GBASE.NotDrawFlag || GBASE.NotDrawFlagInSetDrawArea )
		return 0 ;

	// G[
	if( GRAPHCHK( GrHandle, Image2 ) )
		return -1 ;

	CheckActiveState() ;

#ifndef DX_NON_MOVIE
	if( GrHandle != DX_NONE_GRAPH )
		UpdateMovie( Image2->MovieHandle ) ;
#endif

	// sn[hEGAɔf
	ApplyLibMatrixToHardware() ;

	// Wϊs
	{
		MATRIX *TransMatrix ;

		TransMatrix = &GBASE.BlendMatrix ;

		// _Zbg
		{
			VECTOR SrcVec[4], Pos ;
			VERTEX_2D DestVec[4], VectBuf ;
			float SizeX, SizeY ;
			
			// r{[ĥS_𓾂
			{
				SizeX = (float)Image2->Width ;
				SizeY = (float)Image2->Height ;
				Pos.x = x ;	Pos.y = y ;	Pos.z = z ;
				if( TurnFlag == TRUE )
				{
					SrcVec[0].x = ( -cx + SizeX ) * ExtendRateX ;	SrcVec[0].y = ( -cy + SizeY ) * ExtendRateY ;	SrcVec[0].z = 0.0F ;
					SrcVec[1].x = -cx             * ExtendRateX ;	SrcVec[1].y = ( -cy + SizeY ) * ExtendRateY ;	SrcVec[1].z = 0.0F ;
					SrcVec[2].x = ( -cx + SizeX ) * ExtendRateX ;	SrcVec[2].y = -cy             * ExtendRateY ;	SrcVec[2].z = 0.0F ;
					SrcVec[3].x = -cx             * ExtendRateX ;	SrcVec[3].y = -cy             * ExtendRateY ;	SrcVec[3].z = 0.0F ;
				}
				else
				{
					SrcVec[0].x = -cx             * ExtendRateX ;	SrcVec[0].y = ( -cy + SizeY ) * ExtendRateY ;	SrcVec[0].z = 0.0F ;
					SrcVec[1].x = ( -cx + SizeX ) * ExtendRateX ;	SrcVec[1].y = ( -cy + SizeY ) * ExtendRateY ;	SrcVec[1].z = 0.0F ;
					SrcVec[2].x = -cx             * ExtendRateX ;	SrcVec[2].y = -cy             * ExtendRateY ;	SrcVec[2].z = 0.0F ;
					SrcVec[3].x = ( -cx + SizeX ) * ExtendRateX ;	SrcVec[3].y = -cy             * ExtendRateY ;	SrcVec[3].z = 0.0F ;
				}

				// ]
				_SINCOS( (float)Angle, &Sin, &Cos ) ;
				for( i = 0 ; i < 4 ; i ++ )
				{
					XBuf = SrcVec[i].x ;
					YBuf = SrcVec[i].y ;

					SrcVec[i].x = XBuf * Cos - YBuf * Sin ;	
					SrcVec[i].y = XBuf * Sin + YBuf * Cos ;
				}
			}

			// Wϊ
			for( i = 0 ; i < 4 ; i ++ )
			{
				// r{[hW[hW֕ϊ
				_VectorTransformToBillboard( &SrcVec[i], &Pos ) ;

				// XN[Wɕϊ
				DestVec[i].rhw = 1.0F ;
				VectorTransform4( &DestVec[i].pos,  &DestVec[i].rhw,
									      &SrcVec[i],  &DestVec[i].rhw, TransMatrix ) ;
				DestVec[i].rhw = 1.0F / DestVec[i].rhw ;
				DestVec[i].pos.x *= DestVec[i].rhw ;
				DestVec[i].pos.y *= DestVec[i].rhw ;
				DestVec[i].pos.z *= DestVec[i].rhw ;
			}
									            
			// _̃Zbg
			TransVert[0].pos = DestVec[0].pos ;
			TransVert[1].pos = DestVec[1].pos ;
			TransVert[2].pos = DestVec[2].pos ;
			TransVert[3].pos = DestVec[3].pos ;
			TransVert[0].rhw = DestVec[0].rhw ;
			TransVert[1].rhw = DestVec[1].rhw ;
			TransVert[2].rhw = DestVec[2].rhw ;
			TransVert[3].rhw = DestVec[3].rhw ;

			((BYTE *)&TransVert[0].color)[0] = (BYTE)GBASE.DrawBright.Blue ;
			((BYTE *)&TransVert[0].color)[1] = (BYTE)GBASE.DrawBright.Green ;
			((BYTE *)&TransVert[0].color)[2] = (BYTE)GBASE.DrawBright.Red ;
			((BYTE *)&TransVert[0].color)[3] = (BYTE)GBASE.BlendParam ;
			TransVert[1].color =
			TransVert[2].color =
			TransVert[3].color = TransVert[0].color ;

			TransVert[0].u = 0.0F ;	TransVert[0].v = 0.0F ;
			TransVert[1].u = 1.0F ;	TransVert[1].v = 0.0F ;
			TransVert[2].u = 0.0F ;	TransVert[2].v = 1.0F ;
			TransVert[3].u = 1.0F ;	TransVert[3].v = 1.0F ;

			TransVert[4] = TransVert[2] ;
			TransVert[5] = TransVert[1] ;

			// ]
			if( TurnFlag == TRUE )
			{
				VectBuf = TransVert[ 1 ] ; TransVert[ 1 ] = TransVert[ 2 ] ; TransVert[ 2 ] = VectBuf ;
			}

			TransVert[4] = TransVert[2] ;
			TransVert[5] = TransVert[1] ;
		}
	}

	// `
	DRAW_DEF(
		DrawPrimitive2DHardware( TransVert, 6, DX_PRIMTYPE_TRIANGLELIST, Image2, TransFlag, TRUE, TRUE, FALSE, 0 ),
		0,
		SETDRAWRECTCODE,
		Ret,
		Image2->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}

#undef SETDRAWRECTCODE

// OtBbN̎Rό`Rc`
extern int NS_DrawModiBillboard3D( VECTOR Pos, float x1, float y1, float x2, float y2, float x3, float y3, float x4, float y4, int GrHandle, int TransFlag )
{
	IMAGEDATA2 *Image2 ;
	IMAGEDATA2 *BlendImage2 ;
	int Ret ;

	// 
	if( DxSysData.DxLib_InitializeFlag == FALSE ) return -1 ;

	// `ݒ肪Ăꍇ͉I
	if( GBASE.NotDrawFlag || GBASE.NotDrawFlagInSetDrawArea )
		return 0 ;

	// G[
	if( GRAPHCHK( GrHandle, Image2 ) )
		return -1 ;
	BlendImage2 = NULL ;
	if( GBASE.BlendGraph > 0 )
	{
		GRAPHCHK( GBASE.BlendGraph, BlendImage2 ) ;

		// uheNX`gpꍇA`摜G[
		if( CheckBlendGraphSize( Image2 ) ) return -1 ;
	}

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

#ifndef DX_NON_MOVIE
	if( Image2->MovieHandle != -1 )
		UpdateMovie( Image2->MovieHandle, FALSE ) ;
#endif

	// `
	DRAW_DEF(
		DrawModiBillboard3DHardware( Pos, x1, y1, x2, y2, x3, y3, x4, y4, Image2, BlendImage2, TransFlag ),
		0,
		GRH.DrawRect = GBASE.DrawArea ;,
		Ret,
		Image2->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}

// RcԏɃOtBbN`
extern int NS_DrawBillboard3D( VECTOR Pos, float cx, float cy, float Size, float Angle, int GrHandle, int TransFlag, int TurnFlag )
{
	IMAGEDATA2 *Image2 ;
	IMAGEDATA2 *BlendImage2 ;
	int Ret ;

	// 
	if( DxSysData.DxLib_InitializeFlag == FALSE ) return -1 ;

	// `ݒ肪Ăꍇ͉I
	if( GBASE.NotDrawFlag || GBASE.NotDrawFlagInSetDrawArea )
		return 0 ;

	// G[
	if( GRAPHCHK( GrHandle, Image2 ) )
		return -1 ;
	BlendImage2 = NULL ;
	if( GBASE.BlendGraph > 0 )
	{
		GRAPHCHK( GBASE.BlendGraph, BlendImage2 ) ;

		// uheNX`gpꍇA`摜G[
		if( CheckBlendGraphSize( Image2 ) ) return -1 ;
	}

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

#ifndef DX_NON_MOVIE
	if( Image2->MovieHandle != -1 )
		UpdateMovie( Image2->MovieHandle, FALSE ) ;
#endif

	// `
	DRAW_DEF(
		DrawBillboard3DHardware( Pos, cx, cy, Size, Angle, Image2, BlendImage2, TransFlag, TurnFlag ),
		0,
		GRH.DrawRect = GBASE.DrawArea ;,
		Ret,
		Image2->Orig->FormatDesc.TextureFlag
	)

	// I
	return Ret ;
}


// Rc̎Op``悷
extern int NS_DrawTriangle3D( VECTOR Pos1, VECTOR Pos2, VECTOR Pos3, int Color, int FillFlag )
{
	int Ret ;
	int Flag ;

	// 
	if( DxSysData.DxLib_InitializeFlag == FALSE ) return -1 ;

	// `ݒ肪Ăꍇ͉I
	if( GBASE.NotDrawFlag || GBASE.NotDrawFlagInSetDrawArea )
		return 0 ;

	// uheNX`͎gpłȂ
	if( GBASE.BlendGraph > 0 )
		return -1 ;

	Flag = GRA2.ValidHardWare ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// `
	DRAW_DEF(
		DrawTriangle3DHardware( Pos1, Pos2, Pos3, Color, FillFlag, TRUE, NULL ),
		0,
		GRH.DrawRect = GBASE.DrawArea ;,
		Ret,
		Flag
	)

	// I
	return Ret ;
}


// Rc̓_`悷
extern int NS_DrawPixel3D( VECTOR Pos, int Color )
{
	int Ret ;
	int Flag ;

	// 
	if( DxSysData.DxLib_InitializeFlag == FALSE ) return -1 ;

	// `ݒ肪Ăꍇ͉I
	if( GBASE.NotDrawFlag || GBASE.NotDrawFlagInSetDrawArea )
		return 0 ;

	// uheNX`͎gpłȂ
	if( GBASE.BlendGraph > 0 )
		return -1 ;

	Flag = GRA2.ValidHardWare ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// `
	DRAW_DEF(
		DrawPixel3DHardware( Pos, Color, TRUE, NULL ),
		0,
		GRH.DrawRect = GBASE.DrawArea ;,
		Ret,
		Flag
	)

	// I
	return Ret ;
}

// Rc̐`悷
extern int NS_DrawLine3D( VECTOR Pos1, VECTOR Pos2, int Color )
{
	int Ret ;
	int Flag ;

	// 
	if( DxSysData.DxLib_InitializeFlag == FALSE ) return -1 ;

	// `ݒ肪Ăꍇ͉I
	if( GBASE.NotDrawFlag || GBASE.NotDrawFlagInSetDrawArea )
		return 0 ;

	// uheNX`͎gpłȂ
	if( GBASE.BlendGraph > 0 )
		return -1 ;

	Flag = GRA2.ValidHardWare ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// `
	DRAW_DEF(
		DrawLine3DHardware( Pos1, Pos2, Color, TRUE, NULL ),
		0,
		GRH.DrawRect = GBASE.DrawArea ;,
		Ret,
		Flag
	)

	// I
	return Ret ;
}

// FillGraph ̃O[oϐɃANZXȂo[W
extern int FillGraph_UseGParam(
	int GrHandle,
	int Red,
	int Green,
	int Blue,
	int Alpha,
	int ASyncThread
)
{
	IMAGEDATA2 *Image2 ;
	IMAGEDATA2_ORIG *Orig ;
	IMAGEDATA2_HARD_DRAW *DrawTex ;
	int i ;
	DWORD Code ;
	RECT Rect ;

	// G[
	if( ASyncThread )
	{
		if( GRAPHCHK_ASYNC( GrHandle, Image2 ) )
			return -1 ;
	}
	else
	{
		if( GRAPHCHK( GrHandle, Image2 ) )
			return -1 ;
	}
	Orig = Image2->Orig ;

	// l̕␳
	if( Red   < 0 ) Red   = 0 ; else if( Red   > 255 ) Red   = 255 ;
	if( Green < 0 ) Green = 0 ; else if( Green > 255 ) Green = 255 ;
	if( Blue  < 0 ) Blue  = 0 ; else if( Blue  > 255 ) Blue  = 255 ;
	if( Alpha < 0 ) Alpha = 0 ; else if( Alpha > 255 ) Alpha = 255 ;

	// eNX`ǂŏ𕪊
	if( Image2->Orig->FormatDesc.TextureFlag )
	{
		// eNX`̏ꍇ

		// foCXG[
		if( GraphicsDevice_IsValid() == 0 ) return -1 ;

		// J[R[h̍쐬
		Code = ( Alpha << 24 ) | ( Red << 16 ) | ( Green << 8 ) | ( Blue << 0 ) ;

		// `̐JԂ
		if( Image2->Orig->FormatDesc.DrawValidFlag )
		{
			DrawTex = Image2->Hard.Draw ;
			for( i = 0 ; i < Image2->Hard.DrawNum ; i ++, DrawTex ++ )
			{
				// gpwFœhԂ
				Rect.left = DrawTex->UsePosX ;
				Rect.top  = DrawTex->UsePosY ;
				Rect.right = DrawTex->UsePosX + DrawTex->Width ;
				Rect.bottom = DrawTex->UsePosY + DrawTex->Height ;
				GraphicsDevice_ColorFill_ASync( DrawTex->Tex->Surface[ 0 ], &Rect, Code, ASyncThread ) ;
			}
		}
	}
	else
	{
		// eNX`ł͂Ȃꍇ

		// DrawFillBoxMemImg œhԂ
		Rect.left   = 0 ;
		Rect.top    = 0 ;
		Rect.right  = Image2->Width ;
		Rect.bottom = Image2->Height ;
		DrawFillBoxMemImg( &Image2->Soft.MemImg, &Rect, NS_GetColor( Red, Green, Blue ) ) ; 
	}

	// I
	return 0 ;
}

// OtBbN̐FœhԂ
extern	int NS_FillGraph( int GrHandle, int Red, int Green, int Blue, int Alpha )
{
	return FillGraph_UseGParam( GrHandle, Red, Green, Blue, Alpha, FALSE ) ;
}

// wt̕`
static int DrawLine_Thickness( int x1, int y1, int x2, int y2, int Color, int Thickness )
{
	VERTEX vert[4];
	VECTOR v, p1, p2;
	int r, g, b;
	float f;

	if( Thickness <= 0 || Thickness == 1 )
	{
		return NS_DrawLine( x1, y1, x2, y2, Color, 1 ) ;
	}
	else
	{
		if( x1 == x2 && Thickness % 2 == 1 )
		{
			int x ;

			x = x1 - Thickness / 2 ;
			return NS_DrawBox( x, y1, x + Thickness, y2, Color, TRUE ) ;
		}
		else
		if( y1 == y2 && Thickness % 2 == 1 )
		{
			int y ;

			y = y1 - Thickness / 2 ;
			return NS_DrawBox( x1, y, x2, y + Thickness, Color, TRUE ) ;
		}
	}

	if( GRA2.ValidHardWare )
	{
		p1.x = (float)x1;
		p1.y = (float)y1;
		p2.x = (float)x2;
		p2.y = (float)y2;

		v.x = (    p2.y - p1.y   );
		v.y = ( -( p2.x - p1.x ) );
		f = ( 1.0f / _SQRT( v.x * v.x + v.y * v.y ) ) * ( (float)Thickness / 2.0f );
		v.x *= f;
		v.y *= f;

		NS_GetColor2( Color, &r, &g, &b );
		vert[0].u = 0.0f;
		vert[0].v = 0.0f;
		vert[0].r = (unsigned char)r;
		vert[0].g = (unsigned char)g;
		vert[0].b = (unsigned char)b;
		vert[0].a = (unsigned char)255;
		vert[1] =
		vert[2] =
		vert[3] = vert[0];

		vert[0].x = p1.x + v.x;
		vert[0].y = p1.y + v.y;
		vert[1].x = p2.x + v.x;
		vert[1].y = p2.y + v.y;
		vert[2].x = p1.x - v.x;
		vert[2].y = p1.y - v.y;
		vert[3].x = p2.x - v.x;
		vert[3].y = p2.y - v.y;

		NS_DrawPolygonBase( vert, 4, DX_PRIMTYPE_TRIANGLESTRIP, DX_NONE_GRAPH, FALSE );
	}
	else
	{
		v.x = ( float )(    y2 - y1   );
		v.y = ( float )( -( x2 - x1 ) );
		f = ( 1.0f / _SQRT( v.x * v.x + v.y * v.y ) ) * ( (float)Thickness / 2.0f ) ;
		v.x *= f ;
		v.y *= f ;

		DrawQuadrangleSoftware( 
			_FTOL( x1 + v.x ),
			_FTOL( y1 + v.y ),
			_FTOL( x2 + v.x ),
			_FTOL( y2 + v.y ),
			_FTOL( x2 - v.x ),
			_FTOL( y2 - v.y ),
			_FTOL( x1 - v.x ),
			_FTOL( y1 - v.y ), Color, TRUE ) ;
	}

	// I
	return 0;
}

// `
#define SETDRAWRECTCODE\
	SETRECT( GRH.DrawRect, x1, y1, x2, y2 ) ;\
	if( x1 > x2 ){ GRH.DrawRect.left = x2 ; GRH.DrawRect.right  = x1; }\
	if( y1 > y2 ){ GRH.DrawRect.top  = y2 ; GRH.DrawRect.bottom = y1; }\
	GRH.DrawRect.left   -= Thickness ;\
	GRH.DrawRect.top    -= Thickness ;\
	GRH.DrawRect.right  += 1 + Thickness ;\
	GRH.DrawRect.bottom += 1 + Thickness ;\
	DRAWRECT_DRAWAREA_CLIP

extern	int NS_DrawLine( int x1, int y1, int x2, int y2, int Color, int Thickness )
{
	int Ret = -1 ;
	int Flag ;

	// Pȏ̏ꍇ͑wt`s
	if( Thickness > 1 )
		return DrawLine_Thickness( x1, y1, x2, y2, Color, Thickness ) ;

	if( GBASE.NotDrawFlag || GBASE.NotDrawFlagInSetDrawArea )
		return 0 ;

	Flag = GRA2.ValidHardWare ;

	CheckActiveState() ;

	DRAW_DEF(
		DrawLineHardware( x1, y1, x2, y2, Color ),
		DrawLineSoftware( x1, y1, x2, y2, Color ),
		SETDRAWRECTCODE,
		Ret,
		Flag
	)

	// I
	return Ret ;
}

#undef SETDRAWRECTCODE

// lp`̕`
extern	int NS_DrawBox( int x1, int y1, int x2, int y2, int Color, int FillFlag )
{
	int Ret ;
	
	if( FillFlag )	Ret = NS_DrawFillBox( x1, y1, x2, y2, Color ) ;
	else			Ret = NS_DrawLineBox( x1, y1, x2, y2, Color ) ;

	// I
	return Ret ;
}

// ĝlp`
#define SETDRAWRECTCODE\
	if( x1 < x2 ){ GRH.DrawRect.left = x1 ; GRH.DrawRect.right = x2; }\
	if( y1 < y2 ){ GRH.DrawRect.top = y1 ; GRH.DrawRect.bottom = y2; }\
\
	SETRECT( GRH.DrawRect, x1, y1, x2, y2 ) ;\
	DRAWRECT_DRAWAREA_CLIP

extern	int NS_DrawFillBox( int x1, int y1, int x2, int y2, int Color )
{
	int Ret = -1 ;
	int Flag ;
	
	if( GBASE.NotDrawFlag || GBASE.NotDrawFlagInSetDrawArea )
		return 0 ;
	
	Flag = GRA2.ValidHardWare ;

	CheckActiveState() ;

	// `
	DRAW_DEF(
		DrawFillBoxHardware( x1, y1, x2, y2, Color ),
		DrawFillBoxSoftware( x1, y1, x2, y2, Color ),
		SETDRAWRECTCODE,
		Ret,
		Flag
	)

	// I
	return Ret ;
}

// lp`̕` 
extern	int NS_DrawLineBox( int x1, int y1, int x2, int y2, int Color )
{
	int Ret = -1 ;
	int Flag ;

	if( GBASE.NotDrawFlag || GBASE.NotDrawFlagInSetDrawArea )
		return 0 ;
	
	Flag = GRA2.ValidHardWare ;

	CheckActiveState() ;

	// `
	DRAW_DEF(
		DrawLineBoxHardware( x1, y1, x2, y2, Color ),
		DrawLineBoxSoftware( x1, y1, x2, y2, Color ),
		SETDRAWRECTCODE,
		Ret,
		Flag
	)

	// I
	return Ret ;
}

#undef SETDRAWRECTCODE

// ~`
#define SETDRAWRECTCODE\
	SETRECT( GRH.DrawRect, x - r - 1, y - r - 1, x + r + 1, y + r + 1 )\
	DRAWRECT_DRAWAREA_CLIP
extern	int NS_DrawCircle( int x, int y, int r, int Color, int FillFlag, int Thickness )
{
	int Ret = -1 ;
	int Flag ;

	if( GBASE.NotDrawFlag || GBASE.NotDrawFlagInSetDrawArea )
		return 0 ;
	
	Flag = GRA2.ValidHardWare ;

	CheckActiveState() ;

	if( r < 0 ) return 0 ;

	// `
	if( Thickness == 1 )
	{
		DRAW_DEF(
			DrawCircleHardware( x, y, r, Color, FillFlag ),
			DrawCircleSoftware( x, y, r, Color, FillFlag ),
			SETDRAWRECTCODE,
			Ret,
			Flag
		)
	}
	else
	{
		DRAW_DEF(
			DrawCircle_ThicknessHardware( x, y, r, Color, Thickness ),
			DrawCircle_ThicknessSoftware( x, y, r, Color, Thickness ),
			SETDRAWRECTCODE,
			Ret,
			Flag
		)
	}

	// I
	return Ret ;
}
#undef SETDRAWRECTCODE

// ȉ~`
#define SETDRAWRECTCODE\
	SETRECT( GRH.DrawRect, x - rx - 1, y - ry - 1, x + rx + 1, y + ry + 1 )\
	DRAWRECT_DRAWAREA_CLIP
extern	int NS_DrawOval( int x, int y, int rx, int ry, int Color, int FillFlag, int Thickness )
{
	int Ret = -1 ;
	int Flag ;

	if( GBASE.NotDrawFlag || GBASE.NotDrawFlagInSetDrawArea )
		return 0 ;

	Flag = GRA2.ValidHardWare ;

	CheckActiveState() ;

	if( rx < 0 || ry < 0 ) return 0 ;

	// `
	if( Thickness == 1 )
	{
		DRAW_DEF(
			DrawOvalHardware( x, y, rx, ry, Color, FillFlag ),
			DrawOvalSoftware( x, y, rx, ry, Color, FillFlag ),
			SETDRAWRECTCODE,
			Ret,
			Flag
		)
	}
	else
	{
		DRAW_DEF(
			DrawOval_ThicknessHardware( x, y, rx, ry, Color, Thickness ),
			DrawOval_ThicknessSoftware( x, y, rx, ry, Color, Thickness ),
			SETDRAWRECTCODE,
			Ret,
			Flag
		)
	}

	// I
	return Ret ;
}
#undef SETDRAWRECTCODE

// Op`̕`
#define SETDRAWRECTCODE\
	int x[ 3 ], y[ 3 ], MaxX, MaxY, MinX, MinY ;\
	int i, ix, iy ;\
\
	x[ 0 ] = x1 ; x[ 1 ] = x2 ; x[ 2 ] = x3 ;\
	y[ 0 ] = y1 ; y[ 1 ] = y2 ; y[ 2 ] = y3 ;\
\
	MaxX = 0 ; MaxY = 0 ;\
	MinX = 0xffffff ; MinY = 0xffffff ;\
\
	for( i = 0 ; i < 3 ; i ++ )\
	{\
		ix = x[ i ] ; iy = y[ i ] ;\
		if( ix > MaxX ) MaxX = ix ; if( iy > MaxY ) MaxY = iy ;\
		if( ix < MinX ) MinX = ix ; if( iy < MinY ) MinY = iy ;\
	}\
\
	SETRECT( GRH.DrawRect, MinX, MinY, MaxX, MaxY ) ;\
	DRAWRECT_DRAWAREA_CLIP

extern	int NS_DrawTriangle( int x1, int y1, int x2, int y2, int x3, int y3, int Color, int FillFlag )
{
	int Ret = -1 ;
	int Flag ;

	if( GBASE.NotDrawFlag || GBASE.NotDrawFlagInSetDrawArea )
		return 0 ;
	
	Flag = GRA2.ValidHardWare ;

	CheckActiveState() ;

	// `
	DRAW_DEF(
		DrawTriangleHardware( x1, y1, x2, y2, x3, y3, Color, FillFlag ),
		DrawTriangleSoftware( x1, y1, x2, y2, x3, y3, Color, FillFlag ),
		SETDRAWRECTCODE,
		Ret,
		Flag
	)

	// I
	return Ret ;
}

#undef SETDRAWRECTCODE

// lp`̕`
#define SETDRAWRECTCODE\
	int x[ 4 ], y[ 4 ], MaxX, MaxY, MinX, MinY ;\
	int i, ix, iy ;\
\
	x[ 0 ] = x1 ; x[ 1 ] = x2 ; x[ 2 ] = x3 ; x[ 3 ] = x4 ;\
	y[ 0 ] = y1 ; y[ 1 ] = y2 ; y[ 2 ] = y3 ; y[ 3 ] = y4 ;\
\
	MaxX = 0 ; MaxY = 0 ;\
	MinX = 0xffffff ; MinY = 0xffffff ;\
\
	for( i = 0 ; i < 4 ; i ++ )\
	{\
		ix = x[ i ] ; iy = y[ i ] ;\
		if( ix > MaxX ) MaxX = ix ; if( iy > MaxY ) MaxY = iy ;\
		if( ix < MinX ) MinX = ix ; if( iy < MinY ) MinY = iy ;\
	}\
\
	SETRECT( GRH.DrawRect, MinX, MinY, MaxX, MaxY ) ;\
	DRAWRECT_DRAWAREA_CLIP

extern	int NS_DrawQuadrangle( int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, int Color, int FillFlag )
{
	int Ret = -1 ;
	int Flag ;

	if( GBASE.NotDrawFlag || GBASE.NotDrawFlagInSetDrawArea )
		return 0 ;
	
	Flag = GRA2.ValidHardWare ;

	CheckActiveState() ;

	// `
	DRAW_DEF(
		DrawQuadrangleHardware( x1, y1, x2, y2, x3, y3, x4, y4, Color, FillFlag ),
		DrawQuadrangleSoftware( x1, y1, x2, y2, x3, y3, x4, y4, Color, FillFlag ),
		SETDRAWRECTCODE,
		Ret,
		Flag
	)

	// I
	return Ret ;
}

#undef SETDRAWRECTCODE

// _`悷
#define SETDRAWRECTCODE\
	SETRECT( GRH.DrawRect, x, y, x + 1, y + 1 )\
	DRAWRECT_DRAWAREA_CLIP
extern 	int NS_DrawPixel( int x, int y, int Color )
{
	int Ret = -1 ;
	int Flag ;

	if( GBASE.NotDrawFlag || GBASE.NotDrawFlagInSetDrawArea )
		return 0 ;
	
	Flag = GRA2.ValidHardWare ;

	CheckActiveState() ;

	// `
//	if( GBASE.NotUseBasicGraphDraw3DDeviceMethodFlag ) Flag = FALSE ;
	DRAW_DEF(
		DrawPixelHardware( x, y, Color ),
		DrawPixelSoftware( x, y, Color ),
		SETDRAWRECTCODE,
		Ret,
		Flag
	)

	// I
	return Ret ;
}
#undef SETDRAWRECTCODE

// _̏W`
#define SETDRAWRECTCODE\
	SETRECT( GRH.DrawRect, 0, 0, GBASE.DrawSizeX, GBASE.DrawSizeY )\
	DRAWRECT_DRAWAREA_CLIP
extern 	int NS_DrawPixelSet( const POINTDATA *PointData, int Num )
{
	int Ret = -1 ;
	int Flag ;

	if( GBASE.NotDrawFlag || GBASE.NotDrawFlagInSetDrawArea )
		return 0 ;

	Flag = GRA2.ValidHardWare ;

	CheckActiveState() ;

	// `
	DRAW_DEF(
		DrawPixelSetHardware( PointData, Num  ),
		DrawPixelSetSoftware( PointData, Num  ),
		SETDRAWRECTCODE,
		Ret,
		Flag
	)

	// I
	return Ret ;
}
#undef SETDRAWRECTCODE

// ̏W`
#define SETDRAWRECTCODE\
	SETRECT( GRH.DrawRect, 0, 0, GBASE.DrawSizeX, GBASE.DrawSizeY )\
	DRAWRECT_DRAWAREA_CLIP
extern	int NS_DrawLineSet( const LINEDATA *LineData, int Num )
{
	int Ret = -1 ;
	int Flag ;

	if( GBASE.NotDrawFlag || GBASE.NotDrawFlagInSetDrawArea )
		return 0 ;
	
	Flag = GRA2.ValidHardWare ;

	CheckActiveState() ;

	// `
	DRAW_DEF(
		DrawLineSetHardware( LineData, Num ),
		DrawLineSetSoftware( LineData, Num ),
		SETDRAWRECTCODE,
		Ret,
		Flag
	)

	// I
	return Ret ;
}
#undef SETDRAWRECTCODE












// _obt@֌W֐

// _obt@nh̃ZbgAbvs
extern int SetupVertexBufferHandle( int VertexBufHandle, int VertexNum, int VertexType /* DX_VERTEX_TYPE_NORMAL_3D  */ )
{
	VERTEXBUFFERHANDLEDATA *VertexBuffer ;
	int VertexSize ;
	int FVF ;

	// G[
	if( VERTEXBUFFERCHK( VertexBufHandle, VertexBuffer ) )
		return -1 ;

	// ΉĂȂ^Cv̏ꍇ̓G[
	switch( VertexType )
	{
	case DX_VERTEX_TYPE_NORMAL_3D :
		VertexSize = sizeof( VERTEX3D ) ;
		FVF = VERTEXFVF_3D_LIGHT ;
		break ;

	case DX_VERTEX_TYPE_SHADER_3D :
		VertexSize = sizeof( VERTEX3DSHADER ) ;

		// VF[_[gȂꍇ͎s
		if( GRH.UseShader == FALSE )
			return -1 ;

		FVF = VERTEXFVF_3D_LIGHT ;
		break ;

	default :
		DXST_ERRORLOG_ADD( _T( "_^Cv̒lsł\n" ) ) ;
		return -1 ;
	}

	// _n[hEGAŏꍇ̂ Direct3D9VertexBuffer 쐬
	if( GRH.VertexHardwareProcess || GRH.ValidVertexShader )
	{
		// _obt@쐬
		if( GraphicsDevice_CreateVertexBuffer_ASync( 
				VertexSize * VertexNum,
				D_D3DUSAGE_WRITEONLY,
				FVF,
				D_D3DPOOL_DEFAULT,
				&VertexBuffer->Direct3DBuffer
			) < 0 )
		{
			DXST_ERRORLOG_ADD( _T( "_obt@̍쐬Ɏs܂\n" ) ) ;
			return -1 ;
		}
	}

	// f[^̈mۂ
	if( ReallocHandle( VertexBufHandle, sizeof( VERTEXBUFFERHANDLEDATA ) + VertexSize * VertexNum + 32 ) < 0 )
	{
		DXST_ERRORLOG_ADD( _T( "̊mۂɎs܂" ) ) ;
		return -1 ;
	}
	VertexBuffer = ( VERTEXBUFFERHANDLEDATA * )GetHandleInfo( VertexBufHandle ) ;

	// VXe̒_f[^ۑAhXZbg
	VertexBuffer->Buffer = ( void * )( ( ( DWORD_PTR )VertexBuffer + sizeof( VERTEXBUFFERHANDLEDATA ) + 31 ) / 32 * 32 ) ;

	// ^Cvۑ
	VertexBuffer->Type = VertexType ;

	// _f[^ӂ̃oCgۑ
	VertexBuffer->UnitSize = VertexSize ;

	// _ۑ
	VertexBuffer->Num = VertexNum ;

	// I
	return 0 ;
}

// _obt@nh̏
extern int InitializeVertexBufferHandle( HANDLEINFO * )
{
	// ɉȂ
	return 0 ;
}

// _obt@nȟn
extern int TerminateVertexBufferHandle( HANDLEINFO *HandleInfo )
{
	VERTEXBUFFERHANDLEDATA *VertexBuffer = ( VERTEXBUFFERHANDLEDATA * )HandleInfo ;

	// _obt@̉
	if( VertexBuffer->Direct3DBuffer )
	{
		Graphics_ObjectRelease( VertexBuffer->Direct3DBuffer ) ;
		VertexBuffer->Direct3DBuffer = NULL ;
	}

	// I
	return 0 ;
}

// _obt@쐬( -1:G[  0ȏ:_obt@nh )
extern int NS_CreateVertexBuffer( int VertexNum, int VertexType /* DX_VERTEX_TYPE_NORMAL_3D  */ )
{
	int NewHandle ;

	// Vnh쐬
	NewHandle = AddHandle( DX_HANDLETYPE_VERTEX_BUFFER ) ;
	if( NewHandle < 0 )
		return -1 ;

	// nh̃ZbgAbv
	if( SetupVertexBufferHandle( NewHandle, VertexNum, VertexType ) < 0 )
	{
		SubHandle( NewHandle ) ;
		return -1 ;
	}

	// nhԂ
	return NewHandle ;
}

// _obt@폜
extern int NS_DeleteVertexBuffer( int VertexBufHandle )
{
	return SubHandle( VertexBufHandle ) ;
}

// ׂĂ̒_obt@폜
extern int NS_InitVertexBuffer()
{
	return AllHandleSub( DX_HANDLETYPE_VERTEX_BUFFER ) ;
}

// _obt@ɒ_f[^]
extern int NS_SetVertexBufferData( int SetIndex, const void *VertexData, int VertexNum, int VertexBufHandle )
{
	VERTEXBUFFERHANDLEDATA *VertexBuffer ;
	void *pBuffer ;

	// G[
	if( VERTEXBUFFERCHK( VertexBufHandle, VertexBuffer ) )
		return -1 ;

	// G[`FbN
	if( VertexBuffer->Num < SetIndex + VertexNum || SetIndex < 0 )
		return -1 ;

	// Direct3DVertexBuffer9 ꍇ͒_obt@ɓ]
	if( VertexBuffer->Direct3DBuffer )
	{
		// obt@̃bN
		if( GraphicsVertexBuffer_Lock(
				VertexBuffer->Direct3DBuffer, 
				SetIndex * VertexBuffer->UnitSize,
				VertexNum * VertexBuffer->UnitSize,
				&pBuffer,
				0 ) != D_D3D_OK )
		{
			DXST_ERRORLOG_ADD( _T( "_obt@̃bNɎs܂\n" ) ) ;
			return -1 ;
		}

		// obt@փf[^]
		_MEMCPY( pBuffer, VertexData, VertexNum * VertexBuffer->UnitSize ) ;

		// obt@̃AbN
		GraphicsVertexBuffer_Unlock( VertexBuffer->Direct3DBuffer ) ;
	}

	// VXẽobt@ւ]
	_MEMCPY( ( BYTE * )VertexBuffer->Buffer + SetIndex * VertexBuffer->UnitSize, VertexData, VertexNum * VertexBuffer->UnitSize ) ;

	// I
	return 0 ;
}

// CfbNXobt@nh̃ZbgAbvs
extern int SetupIndexBufferHandle( int IndexBufHandle, int IndexNum, int IndexType /* DX_INDEX_TYPE_16BIT  */ )
{
	INDEXBUFFERHANDLEDATA *IndexBuffer ;
	int IndexSize ;
	D_D3DFORMAT Format ;

	// G[
	if( INDEXBUFFERCHK( IndexBufHandle, IndexBuffer ) )
		return -1 ;

	// ΉĂȂ^Cv̏ꍇ̓G[
	switch( IndexType )
	{
	case DX_INDEX_TYPE_16BIT :
		IndexSize = sizeof( WORD ) ;
		Format = D_D3DFMT_INDEX16 ;
		break ;

	case DX_INDEX_TYPE_32BIT :
		IndexSize = sizeof( DWORD ) ;
		Format = D_D3DFMT_INDEX32 ;
		break ;

	default :
		DXST_ERRORLOG_ADD( _T( "CfbNX^Cv̒lsł\n" ) ) ;
		return -1 ;
	}

	// _n[hEGAŏꍇ̂ Direct3D9IndexBuffer 쐬
	if( GRH.VertexHardwareProcess || GRH.ValidVertexShader )
	{
		// CfbNXobt@쐬
		if( GraphicsDevice_CreateIndexBuffer_ASync( 
				IndexSize * IndexNum,
				D_D3DUSAGE_WRITEONLY,
				Format,
				D_D3DPOOL_DEFAULT,
				&IndexBuffer->Direct3DBuffer
			) < 0 )
		{
			DXST_ERRORLOG_ADD( _T( "CfbNXobt@̍쐬Ɏs܂\n" ) ) ;
			return -1 ;
		}
	}

	// f[^̈mۂ
	if( ReallocHandle( IndexBufHandle, sizeof( INDEXBUFFERHANDLEDATA ) + IndexSize * IndexNum + 32 ) < 0 )
	{
		DXST_ERRORLOG_ADD( _T( "̊mۂɎs܂" ) ) ;
		return -1 ;
	}
	IndexBuffer = ( INDEXBUFFERHANDLEDATA * )GetHandleInfo( IndexBufHandle ) ;

	// VXẽCfbNXf[^ۑAhXZbg
	IndexBuffer->Buffer = ( void * )( ( ( DWORD_PTR )IndexBuffer + sizeof( INDEXBUFFERHANDLEDATA ) + 31 ) / 32 * 32 ) ;

	// ^Cvۑ
	IndexBuffer->Type = IndexType ;

	// CfbNXf[^ӂ̃oCgۑ
	IndexBuffer->UnitSize = IndexSize ;

	// CfbNXۑ
	IndexBuffer->Num = IndexNum ;

	// I
	return 0 ;
}

// CfbNXobt@nh̏
extern int InitializeIndexBufferHandle( HANDLEINFO * )
{
	// ɉȂ
	return 0 ;
}

// CfbNXobt@nȟn
extern int TerminateIndexBufferHandle( HANDLEINFO *HandleInfo )
{
	INDEXBUFFERHANDLEDATA *IndexBuffer = ( INDEXBUFFERHANDLEDATA * )HandleInfo ;

	// CfbNXobt@̉
	if( IndexBuffer->Direct3DBuffer )
	{
		Graphics_ObjectRelease( IndexBuffer->Direct3DBuffer ) ;
		IndexBuffer->Direct3DBuffer = NULL ;
	}

	// I
	return 0 ;
}

// VF[_[萔gp̈
extern int InitializeShaderConstantUseArea( SHADERCONSTANT_USEAREA *UseArea, int TotalSize )
{
	_MEMSET( UseArea, 0, sizeof( SHADERCONSTANT_USEAREA ) ) ;

	// Ǘ̈̃TCYݒ
	UseArea->TotalSize = TotalSize ;

	// I
	return 0 ;
}

// VF[_[萔gp̈ύX
extern int SetShaderConstantUseArea( SHADERCONSTANT_USEAREA *UseArea, int IsUse, int Index, int Num )
{
	SHADERCONST_ONE_USEAREA *OneArea ;
	int i ;
	int j ;
	int StartIndex ;
	int EndPlusOneIndex ;
	int Bottom ;
	int NoHit ;

	// ύXO牽Ȃ
	if( Num == 0 )
		return 0 ;

	StartIndex = Index ;
	EndPlusOneIndex = Index + Num ;

	// SĂȂ𒲂ׂ
	Bottom = TRUE ;
	NoHit = FALSE ;
	OneArea = UseArea->AreaInfo ;
	i = 0 ;
	while( i < UseArea->AreaInfoNum && OneArea->Start > EndPlusOneIndex )
	{
		i ++ ;
		OneArea ++ ;
	}
	if( i != UseArea->AreaInfoNum )
	{
		Bottom = FALSE ;

		// Ƃ܂ŃAhXi߂
		OneArea = UseArea->AreaInfo ;
		i = 0 ;
		while( i < UseArea->AreaInfoNum && OneArea->EndPlusOne <= StartIndex )
		{
			i ++ ;
			OneArea ++ ;
		}

		// ͈̔͂ɐGĂ邩`FbN
		if( OneArea->Start > EndPlusOneIndex )
		{
			NoHit = TRUE ;
		}
	}

	// gp̈悪̂ǂŏ𕪊
	if( IsUse == FALSE )
	{
		// ꍇ

		// ȂI
		if( i == UseArea->AreaInfoNum || NoHit )
			return 0 ;

		// ŏɈ͈͓Ɏ܂ꍇ͔͈͏̐
		if( OneArea->Start      < StartIndex &&
			OneArea->EndPlusOne > EndPlusOneIndex )
		{
			_MEMMOVE( OneArea + 1, OneArea, sizeof( SHADERCONST_ONE_USEAREA ) * ( UseArea->AreaInfoNum - i ) ) ;
			OneArea[ 0 ].EndPlusOne = ( WORD )StartIndex ;
			OneArea[ 1 ].Start = ( WORD )EndPlusOneIndex ;
			UseArea->AreaInfoNum ++ ;
			return 0 ;
		}

		// ŏɈ͈͓̊JnʒuƓȂꍇ̓TCY𒲐
		if( OneArea->Start < StartIndex )
		{
			OneArea->EndPlusOne = ( WORD )StartIndex ;
			OneArea ++ ;
			i ++ ;
		}

		// ہX܂܂Ă܂͈͂̐𒲂ׂ
		j = 0 ;
		while( i < UseArea->AreaInfoNum && OneArea[ j ].EndPlusOne <= EndPlusOneIndex )
		{
			j ++ ;
			i ++ ;
		}

		// ہX܂܂Ă܂͈͏폜
		if( j > 0 && UseArea->AreaInfoNum - i > 0 )
		{
			_MEMMOVE( OneArea, OneArea + j, sizeof( SHADERCONST_ONE_USEAREA ) * ( UseArea->AreaInfoNum - i ) ) ;
		}
		UseArea->AreaInfoNum -= j ;

		// c肪ꍇŔ͈͂Ăꍇ͔͈͂̊Jnʒu炷
		if( UseArea->AreaInfoNum > 0 && OneArea->Start < EndPlusOneIndex )
		{
			OneArea->Start = ( WORD )EndPlusOneIndex ;
		}
	}
	else
	{
		// ꍇ

		// Ȃ͈͏ǉ
		if( i == UseArea->AreaInfoNum )
		{
			// O͈̔͂ƐڂĂO͈̔͏L
			if( i > 0 && OneArea[ -1 ].EndPlusOne == StartIndex )
			{
				OneArea[ -1 ].EndPlusOne = ( WORD )EndPlusOneIndex ;
			}
			else
			{
				if( Bottom )
				{
					OneArea = UseArea->AreaInfo ;
					_MEMMOVE( OneArea + 1, OneArea, sizeof( SHADERCONST_ONE_USEAREA ) * UseArea->AreaInfoNum ) ;
				}
				OneArea->Start = ( WORD )StartIndex ;
				OneArea->EndPlusOne = ( WORD )EndPlusOneIndex ;
				UseArea->AreaInfoNum ++ ;
			}

			return 0 ;
		}
		if( NoHit )
		{
			// O͈̔͂ƐڂĂO͈̔͏L
			if( i > 0 && OneArea[ -1 ].EndPlusOne == StartIndex )
			{
				OneArea[ -1 ].EndPlusOne = ( WORD )EndPlusOneIndex ;
			}
			else
			{
				_MEMMOVE( OneArea + 1, OneArea, sizeof( SHADERCONST_ONE_USEAREA ) * ( UseArea->AreaInfoNum - i ) ) ;
				OneArea->Start = ( WORD )StartIndex ;
				OneArea->EndPlusOne = ( WORD )EndPlusOneIndex ;
				UseArea->AreaInfoNum ++ ;
			}
			return 0 ;
		}

		// ŏ̈O͈̔͏ƐڂĂꍇ͑ΏۂO͈̔͏ɂ
		if( i > 0 && OneArea[ -1 ].EndPlusOne == StartIndex )
		{
			OneArea -- ;
			i -- ;
		}

		// ŏɈ͈͏̊JnʒuJnʒuႩL
		if( OneArea->Start > StartIndex )
		{
			OneArea->Start = ( WORD )StartIndex ;
		}

		// ŏɈ͈͏Ɏ܂ꍇ͂ŏI
		if( OneArea->EndPlusOne >= EndPlusOneIndex )
			return 0 ;

		// ܂Ȃꍇ͔͈͂L
		OneArea->EndPlusOne = ( WORD )EndPlusOneIndex ;
		StartIndex = OneArea->Start ;

		// ȍ~͈̔͏ŊہXĂ͈͂̐𒲂ׂ
		OneArea ++ ;
		i ++ ;
		j = 0 ;
		while( i < UseArea->AreaInfoNum && OneArea[ j ].EndPlusOne <= EndPlusOneIndex )
		{
			j ++ ;
			i ++ ;
		}

		// c肪ꍇŔ͈͂Ă͈͂ǉč폜
		if( i < UseArea->AreaInfoNum && OneArea[ j ].Start <= EndPlusOneIndex )
		{
			OneArea[ -1 ].EndPlusOne = OneArea[ j ].EndPlusOne ;
			j ++ ;
			i ++ ;
		}

		// ͈͏폜
		if( j > 0 && UseArea->AreaInfoNum - i > 0 )
		{
			_MEMMOVE( OneArea, OneArea + j, sizeof( SHADERCONST_ONE_USEAREA ) * ( UseArea->AreaInfoNum - i ) ) ;
		}
		UseArea->AreaInfoNum -= j ;
	}

	// I
	return 0 ;
}

// VF[_[萔gp̈񂩂gp}bv쐬
extern int CreateUseAreaMap( SHADERCONSTANT_USEAREA *UseArea, BYTE *Map, BYTE SetNumber )
{
	int i, j ;
	SHADERCONST_ONE_USEAREA *AInfo ;

	AInfo = UseArea->AreaInfo ;
	for( i = 0 ; i < UseArea->AreaInfoNum ; i ++, AInfo ++ )
	{
		for( j = AInfo->Start ; j < AInfo->EndPlusOne ; j ++ )
		{
			Map[ j ] = SetNumber ;
		}
	}

	// I
	return 0 ;
}

// CfbNXobt@쐬( -1:G[@0ȏFCfbNXobt@nh )
extern int NS_CreateIndexBuffer( int IndexNum, int IndexType /* DX_INDEX_TYPE_16BIT  */  )
{
	int NewHandle ;

	// Vnh쐬
	NewHandle = AddHandle( DX_HANDLETYPE_INDEX_BUFFER ) ;
	if( NewHandle < 0 )
		return -1 ;

	// nh̃ZbgAbv
	if( SetupIndexBufferHandle( NewHandle, IndexNum, IndexType ) < 0 )
	{
		SubHandle( NewHandle ) ;
		return -1 ;
	}

	// nhԂ
	return NewHandle ;
}

// CfbNXobt@폜
extern int NS_DeleteIndexBuffer( int IndexBufHandle )
{
	return SubHandle( IndexBufHandle ) ;
}

// ׂẴCfbNXobt@폜
extern int NS_InitIndexBuffer()
{
	return AllHandleSub( DX_HANDLETYPE_INDEX_BUFFER ) ;
}

// CfbNXobt@ɃCfbNXf[^]
extern int NS_SetIndexBufferData( int SetIndex, const void *IndexData, int IndexNum, int IndexBufHandle )
{
	INDEXBUFFERHANDLEDATA *IndexBuffer ;
	void *pBuffer ;

	// G[
	if( INDEXBUFFERCHK( IndexBufHandle, IndexBuffer ) )
		return -1 ;

	// G[`FbN
	if( IndexBuffer->Num < SetIndex + IndexNum || SetIndex < 0 )
		return -1 ;

	// Direct3DIndexBuffer9 f[^]
	if( IndexBuffer->Direct3DBuffer )
	{
		// obt@̃bN
		if( GraphicsIndexBuffer_Lock(
				IndexBuffer->Direct3DBuffer, 
				SetIndex * IndexBuffer->UnitSize,
				IndexNum * IndexBuffer->UnitSize,
				&pBuffer,
				0 ) != D_D3D_OK )
		{
			DXST_ERRORLOG_ADD( _T( "CfbNXobt@̃bNɎs܂\n" ) ) ;
			return -1 ;
		}

		// obt@փf[^]
		_MEMCPY( pBuffer, IndexData, IndexNum * IndexBuffer->UnitSize ) ;

		// obt@̃AbN
		GraphicsIndexBuffer_Unlock( IndexBuffer->Direct3DBuffer ) ;
	}

	// VXẽobt@ւ]
	_MEMCPY( ( BYTE * )IndexBuffer->Buffer + SetIndex * IndexBuffer->UnitSize, IndexData, IndexNum * IndexBuffer->UnitSize ) ;

	// I
	return 0 ;
}

// OtBbNXfoCXΉĂxɕ`łv~eBu̍ő吔擾
extern int NS_GetMaxPrimitiveCount( void )
{
	return GRH.MaxPrimitiveCount ;
}

// OtBbNXfoCXΉĂxɎgp邱Ƃ̂łő咸_擾
extern int NS_GetMaxVertexIndex( void )
{
	return GRH.DeviceCaps.MaxVertexIndex ;
}














// VF[_[֌W֐

// VF[_[nh쐬
extern int CreateShaderHandle( void )
{
	if( GRA2.InitializeFlag == FALSE )
		return -1 ;

	// VF[_gȂꍇ͎s
	if( GRH.UseShader == FALSE )
		return -1 ;

	return AddHandle( DX_HANDLETYPE_SHADER ) ;
}

// CreateShader ̎֐
static int CreateShader_Static(
	int ShaderHandle,
	int IsVertexShader,
	void *Image,
	int ImageSize,
	int ImageAfterFree,
	int ASyncThread
)
{
	SHADERHANDLEDATA *pShader ;
	DX_DIRECT3DPIXELSHADER9 *PixelShader = NULL ;
	DX_DIRECT3DVERTEXSHADER9 *VertexShader = NULL ;

	// G[
	if( ASyncThread )
	{
		if( SHADERCHK_ASYNC( ShaderHandle, pShader ) )
			return -1 ;
	}
	else
	{
		if( SHADERCHK( ShaderHandle, pShader ) )
			return -1 ;
	}

	// VF[_[쐬
	if( IsVertexShader )
	{
		if( GraphicsDevice_CreateVertexShader_ASync( ( DWORD * )Image, &VertexShader, ASyncThread ) != D_D3D_OK )
		{
			DXST_ERRORLOG_ADD( _T( "_VF[_[̍쐬Ɏs܂\n" ) ) ;
			goto ERR ;
		}
	}
	else
	{
		if( GraphicsDevice_CreatePixelShader_ASync( ( DWORD * )Image, &PixelShader, ASyncThread ) != D_D3D_OK )
		{
			DXST_ERRORLOG_ADD( _T( "_VF[_[̍쐬Ɏs܂\n" ) ) ;
			goto ERR ;
		}
	}

	// oCiC[Wۑ郁̈̊m
	pShader->FunctionCode = DXCALLOC( ImageSize ) ;
	if( pShader->FunctionCode == NULL )
	{
		DXST_ERRORLOG_ADD( _T( "̊mۂɎs܂" ) ) ;
		goto ERR ;
	}

	// oCiC[Wۑ
	_MEMCPY( pShader->FunctionCode, Image, ImageSize ) ;

	// _VF[_[ǂۑ
	pShader->IsVertexShader = IsVertexShader ? TRUE : FALSE ;

	// ⏕񂪂邩ǂ𒲂ׂ
	if( ( ( BYTE * )pShader->FunctionCode )[ 4 ] == 0xfe && ( ( BYTE * )pShader->FunctionCode )[ 5 ] == 0xff )
	{
		// ꍇ

		// 萔z̃AhXۑ
		pShader->ConstantInfo = ( D_D3DXSHADER_CONSTANTINFO * )( ( BYTE * )pShader->FunctionCode + 0x28 ) ;

		// 萔̐ۑ
		pShader->ConstantNum = *( ( DWORD * )( ( BYTE * )pShader->FunctionCode + 0x18 ) ) ;
	}
	else
	{
		// ꍇ

		// 萔z̃AhX
		pShader->ConstantInfo = NULL ;

		// ƂăANZXł萔͂O
		pShader->ConstantNum = 0 ;
	}

	// VF[_[̃AhXۑ
	if( IsVertexShader )
	{
		pShader->VertexShader = VertexShader ;
	}
	else
	{
		pShader->PixelShader = PixelShader ;
	}

	// ɉׂ̃tOĂ
	if( ImageAfterFree )
	{
		DXFREE( Image ) ;
	}

	// I
	return 0 ;

ERR :
	if( VertexShader )
	{
		Graphics_ObjectRelease_ASync( VertexShader, ASyncThread ) ;
	}

	if( PixelShader )
	{
		Graphics_ObjectRelease_ASync( PixelShader, ASyncThread ) ;
	}

	// ɉׂ̃tOĂ
	if( ImageAfterFree )
	{
		DXFREE( Image ) ;
	}

	return -1 ;
}

#ifndef DX_NON_ASYNCLOAD

// CreateShader ̔񓯊ǂݍ݃XbhĂ΂֐
static void CreateShader_ASync( ASYNCLOADDATA_COMMON *AParam )
{
	int ShaderHandle ;
	int IsVertexShader ;
	void *Image ;
	int ImageSize ;
	int ImageAfterFree ;
	int Addr ;
	int Result ;

	Addr = 0 ;
	ShaderHandle = GetASyncLoadParamInt( AParam->Data, &Addr ) ;
	IsVertexShader = GetASyncLoadParamInt( AParam->Data, &Addr ) ;
	Image = GetASyncLoadParamVoidP( AParam->Data, &Addr ) ;
	ImageSize = GetASyncLoadParamInt( AParam->Data, &Addr ) ;
	ImageAfterFree = GetASyncLoadParamInt( AParam->Data, &Addr ) ;

	Result = CreateShader_Static( ShaderHandle, IsVertexShader, Image, ImageSize, ImageAfterFree, TRUE ) ;
	DecASyncLoadCount( ShaderHandle ) ;
	if( Result < 0 )
	{
		NS_DeleteShader( ShaderHandle ) ;
	}
}

#endif // DX_NON_ASYNCLOAD

// VF[_[nh쐬
extern int CreateShader_UseGParam(
	int IsVertexShader,
	void *Image,
	int ImageSize,
	int ImageAfterFree,
	int ASyncLoadFlag,
	int ASyncThread
)
{
	int ShaderHandle = -1 ;

	// VF[_gȂꍇ͎s
	if( GraphicsDevice_IsValid() == 0 || GRH.UseShader == FALSE )
		return -1 ;

	ShaderHandle = CreateShaderHandle() ;
	if( ShaderHandle == -1 )
		goto ERR ;

#ifndef DX_NON_ASYNCLOAD
	if( ASyncLoadFlag && ASyncThread == FALSE )
	{
		ASYNCLOADDATA_COMMON *AParam = NULL ;
		int Addr ;

		// p[^ɕKvȃ̃TCYZo
		Addr = 0 ;
		AddASyncLoadParamInt( NULL, &Addr, ShaderHandle ) ;
		AddASyncLoadParamInt( NULL, &Addr, IsVertexShader ) ;
		AddASyncLoadParamConstVoidP( NULL, &Addr, Image ) ;
		AddASyncLoadParamInt( NULL, &Addr, ImageSize ) ;
		AddASyncLoadParamInt( NULL, &Addr, ImageAfterFree ) ;

		// ̊m
		AParam = AllocASyncLoadDataMemory( Addr ) ;
		if( AParam == NULL )
			goto ERR ;

		// ɕKvȏZbg
		AParam->ProcessFunction = CreateShader_ASync ;
		Addr = 0 ;
		AddASyncLoadParamInt( AParam->Data, &Addr, ShaderHandle ) ;
		AddASyncLoadParamInt( AParam->Data, &Addr, IsVertexShader ) ;
		AddASyncLoadParamConstVoidP( AParam->Data, &Addr, Image ) ;
		AddASyncLoadParamInt( AParam->Data, &Addr, ImageSize ) ;
		AddASyncLoadParamInt( AParam->Data, &Addr, ImageAfterFree ) ;

		// f[^ǉ
		if( AddASyncLoadData( AParam ) < 0 )
		{
			DXFREE( AParam ) ;
			AParam = NULL ;
			goto ERR ;
		}

		// 񓯊ǂݍ݃JEgCNg
		IncASyncLoadCount( ShaderHandle, AParam->Index ) ;
	}
	else
#endif // DX_NON_ASYNCLOAD
	{
		if( CreateShader_Static( ShaderHandle, IsVertexShader, Image, ImageSize, ImageAfterFree, ASyncThread ) < 0 )
			goto ERR ;
	}

	// nhԂ
	return ShaderHandle ;

ERR :
	NS_DeleteShader( ShaderHandle ) ;
	ShaderHandle = -1 ;

	// I
	return -1 ;
}

// VF[_[nh̏
extern int InitializeShaderHandle( HANDLEINFO * )
{
	// ɉ邱ƂȂ
	return 0 ;
}

// VF[_[nȟn
extern int TerminateShaderHandle( HANDLEINFO *HandleInfo )
{
	SHADERHANDLEDATA *Shader = ( SHADERHANDLEDATA * )HandleInfo ;

	// gpVF[_[ƂăZbgĂO
	if( GRH.UserShaderRenderInfo.SetVertexShaderHandle == HandleInfo->Handle )
	{
		NS_SetUseVertexShader( -1 ) ;
	}
	if( GRH.UserShaderRenderInfo.SetPixelShaderHandle == HandleInfo->Handle )
	{
		NS_SetUsePixelShader( -1 ) ;
	}

	// VF[_[̃oCif[^
	if( Shader->FunctionCode != NULL )
	{
		DXFREE( Shader->FunctionCode ) ;
		Shader->FunctionCode = NULL ;
	}

	// VF[_[̉
	if( Shader->IsVertexShader )
	{
		if( Shader->VertexShader )
		{
			Graphics_ObjectRelease( Shader->VertexShader ) ;
			Shader->VertexShader = NULL ;
		}
	}
	else
	{
		if( Shader->PixelShader )
		{
			Graphics_ObjectRelease( Shader->PixelShader ) ;
			Shader->PixelShader = NULL ;
		}
	}

	// I
	return 0 ;
}

// gpłVF[_[̃o[W擾( 0=gȂ  200=VF[_[fQDOgp\  300=VF[_[fRDOgp\ )
extern int NS_GetValidShaderVersion( void )
{
	D_D3DCAPS9 DevCaps ;

	// VF[_gȂꍇ͂OԂ
	if( GraphicsDevice_IsValid() != 0 && GRH.UseShader == FALSE )
		return 0 ;

	// \͂擾
	Graphics_GetDeviceCaps( GRH.ValidAdapterNumber ? GRH.UseAdapterNumber : D_D3DADAPTER_DEFAULT, D_D3DDEVTYPE_HAL, &DevCaps ) ;

	if( ( DevCaps.VertexShaderVersion & 0xffff ) < 0x200 &&
		( DevCaps.PixelShaderVersion  & 0xffff ) < 0x200 )
	{
		return 0 ;
	}
	else
	if( ( DevCaps.VertexShaderVersion & 0xffff ) >= 0x300 &&
		( DevCaps.PixelShaderVersion  & 0xffff ) >= 0x300 )
	{
		return 300 ;
	}
	else
	{
		return 200 ;
	}
}

// LoadShader ̎֐
static int LoadShader_Static( int ShaderHandle, int IsVertexShader, const TCHAR *FileName, int ASyncThread )
{
	SHADERHANDLEDATA *pShader ;
	DWORD_PTR fp ;
	LONGLONG size ;
	void *buffer ;

	// G[
	if( ASyncThread )
	{
		if( SHADERCHK_ASYNC( ShaderHandle, pShader ) )
			return -1 ;
	}
	else
	{
		if( SHADERCHK( ShaderHandle, pShader ) )
			return -1 ;
	}

	fp = FOPEN( FileName ) ;
	if( fp == 0 ) return -1 ;
	FSEEK( fp, 0, SEEK_END ) ;
	size = FTELL( fp ) ;
	FSEEK( fp, 0, SEEK_SET ) ;
	buffer = DXALLOC( ( size_t )size ) ;
	if( buffer == NULL )
	{
		DXST_ERRORLOG_ADD( _T( "VF[_[̃oCif[^i[郁̈̊mۂɎs܂\n" ) ) ;
		return -1 ;
	}
	FREAD( buffer, size, 1, fp ) ;
	FCLOSE( fp ) ;

	return CreateShader_Static( ShaderHandle, IsVertexShader, buffer, ( int )size, TRUE, ASyncThread ) ;
}

#ifndef DX_NON_ASYNCLOAD

// LoadShader ̔񓯊ǂݍ݃XbhĂ΂֐
static void LoadShader_ASync( ASYNCLOADDATA_COMMON *AParam )
{
	int ShaderHandle ;
	int IsVertexShader ;
	const TCHAR *FileName ;
	int Addr ;
	int Result ;

	Addr = 0 ;
	ShaderHandle = GetASyncLoadParamInt( AParam->Data, &Addr ) ;
	IsVertexShader = GetASyncLoadParamInt( AParam->Data, &Addr ) ;
	FileName = GetASyncLoadParamString( AParam->Data, &Addr ) ;

	Result = LoadShader_Static( ShaderHandle, IsVertexShader, FileName, TRUE ) ;
	DecASyncLoadCount( ShaderHandle ) ;
	if( Result < 0 )
	{
		NS_DeleteShader( ShaderHandle ) ;
	}
}

#endif // DX_NON_ASYNCLOAD

// VF[_[oCit@Cǂݍ
extern int LoadShader_UseGParam( int IsVertexShader, const TCHAR *FileName, int ASyncLoadFlag )
{
	int ShaderHandle = -1 ;

	// VF[_gȂꍇ͎s
	if( GraphicsDevice_IsValid() == 0 || GRH.UseShader == FALSE )
		return -1 ;

	ShaderHandle = CreateShaderHandle() ;
	if( ShaderHandle == -1 )
		goto ERR ;

#ifndef DX_NON_ASYNCLOAD
	if( ASyncLoadFlag )
	{
		ASYNCLOADDATA_COMMON *AParam = NULL ;
		int Addr ;
		TCHAR FullPath[ 1024 ] ;

		ConvertFullPathT_( FileName, FullPath ) ;

		// p[^ɕKvȃ̃TCYZo
		Addr = 0 ;
		AddASyncLoadParamInt( NULL, &Addr, ShaderHandle ) ;
		AddASyncLoadParamInt( NULL, &Addr, IsVertexShader ) ;
		AddASyncLoadParamString( NULL, &Addr, FullPath ) ;

		// ̊m
		AParam = AllocASyncLoadDataMemory( Addr ) ;
		if( AParam == NULL )
			goto ERR ;

		// ɕKvȏZbg
		AParam->ProcessFunction = LoadShader_ASync ;
		Addr = 0 ;
		AddASyncLoadParamInt( AParam->Data, &Addr, ShaderHandle ) ;
		AddASyncLoadParamInt( AParam->Data, &Addr, IsVertexShader ) ;
		AddASyncLoadParamString( AParam->Data, &Addr, FullPath ) ;

		// f[^ǉ
		if( AddASyncLoadData( AParam ) < 0 )
		{
			DXFREE( AParam ) ;
			AParam = NULL ;
			goto ERR ;
		}

		// 񓯊ǂݍ݃JEgCNg
		IncASyncLoadCount( ShaderHandle, AParam->Index ) ;
	}
	else
#endif // DX_NON_ASYNCLOAD
	{
		if( LoadShader_Static( ShaderHandle, IsVertexShader, FileName, FALSE ) < 0 )
			goto ERR ;
	}

	// nhԂ
	return ShaderHandle ;

ERR :
	NS_DeleteShader( ShaderHandle ) ;
	ShaderHandle = -1 ;

	// I
	return -1 ;
}

// _VF[_[oCit@Cǂݍݒ_VF[_[nh쐬( ߂l -1:G[  -1ȊO:VF[_[nh )
extern int NS_LoadVertexShader( const TCHAR *FileName )
{
	return LoadShader_UseGParam( TRUE, FileName, GetASyncLoadFlag() ) ;
}

// ԏɑ݂钸_VF[_[oCi璸_VF[_[nh쐬( ߂l -1:G[  -1ȊO:VF[_[nh )
extern int NS_LoadVertexShaderFromMem( const void *ImageAddress, int ImageSize )
{
	return CreateShader_UseGParam( TRUE, ( void * )ImageAddress, ImageSize, FALSE, GetASyncLoadFlag() ) ;
}

// sNZVF[_[oCit@Cǂݍ݃sNZVF[_[nh쐬( ߂l -1:G[  -1ȊO:VF[_[nh )
extern int NS_LoadPixelShader( const TCHAR *FileName )
{
	return LoadShader_UseGParam( FALSE, FileName, GetASyncLoadFlag() ) ;
}

// ԏɑ݂sNZVF[_[oCisNZVF[_[nh쐬( ߂l -1:G[  -1ȊO:VF[_[nh )
extern int NS_LoadPixelShaderFromMem( const void *ImageAddress, int ImageSize )
{
	return CreateShader_UseGParam( FALSE, ( void * )ImageAddress, ImageSize, FALSE, GetASyncLoadFlag() ) ;
}

// VF[_[nh̍폜
extern int NS_DeleteShader( int ShaderHandle )
{
	return SubHandle( ShaderHandle ) ;
}

// VF[_[nhSč폜
extern int NS_InitShader( void )
{
	if( GRA2.InitializeFlag == FALSE ) return 0 ;

	return AllHandleSub( DX_HANDLETYPE_SHADER ) ;
}


// VF[_[̒萔𓾂
extern	D_D3DXSHADER_CONSTANTINFO *GetShaderConstInfo( SHADERHANDLEDATA *Shader, const TCHAR *ConstantName )
{
	D_D3DXSHADER_CONSTANTINFO *Info ;
	int i ;

	// w̖O萔{
	Info = Shader->ConstantInfo ;

#ifdef UNICODE
	char ConstantNameA[ 512 ] ;

	WCharToMBChar( CP_ACP, ( DXWCHAR * )ConstantName, ConstantNameA, 512 ) ;
	for( i = 0 ; i < Shader->ConstantNum ; i ++, Info ++ )
	{
		if( _STRCMP( ConstantNameA, ( char * )Shader->FunctionCode + Info->Name + 12 ) == 0 )
			break ;
	}

#else

	for( i = 0 ; i < Shader->ConstantNum ; i ++, Info ++ )
	{
		if( _STRCMP( ConstantName, ( char * )Shader->FunctionCode + Info->Name + 12 ) == 0 )
			break ;
	}

#endif

	if( i == Shader->ConstantNum )
		return NULL ;

	// Ԃ
	return Info ;
}

// w̖O萔gpVF[_[萔̔ԍ擾
extern	int			NS_GetConstIndexToShader( const TCHAR *ConstantName, int ShaderHandle )
{
	SHADERHANDLEDATA *Shader ;
	D_D3DXSHADER_CONSTANTINFO *Info ;

	// G[
	if( SHADERCHK( ShaderHandle, Shader ) )
		return -1 ;

	// w̖O萔{
	Info = GetShaderConstInfo( Shader, ConstantName ) ;

	// G[
	if( Info == NULL )
		return -1 ;

	// gpĂ郌WX^ԍԂ
	return ( int )Info->RegisterIndex ;
}

// w̖O萔gpVF[_[萔̐擾
extern int NS_GetConstCountToShader( const TCHAR *ConstantName, int ShaderHandle )
{
	SHADERHANDLEDATA *Shader ;
	D_D3DXSHADER_CONSTANTINFO *Info ;

	// G[
	if( SHADERCHK( ShaderHandle, Shader ) )
		return -1 ;

	// w̖O萔{
	Info = GetShaderConstInfo( Shader, ConstantName ) ;

	// G[
	if( Info == NULL )
		return -1 ;

	// gpĂ郌WX^Ԃ
	return ( int )Info->RegisterCount ;
}

// w̖O_萔̃ftHgp[^i[Ă郁AhX擾
extern	const FLOAT4 *NS_GetConstDefaultParamFToShader( const TCHAR *ConstantName, int ShaderHandle )
{
	SHADERHANDLEDATA *Shader ;
	D_D3DXSHADER_CONSTANTINFO *Info ;

	// G[
	if( SHADERCHK( ShaderHandle, Shader ) )
		return NULL ;


	// w̖O萔{
	Info = GetShaderConstInfo( Shader, ConstantName ) ;

	// G[
	if( Info == NULL )
		return NULL ;

	// ĂftHgp[^ꍇ̓G[
	if( Info->DefaultValue == 0 )
		return NULL ;

	// ftHgp[^̂ʒuԂ
	return ( FLOAT4 * )( ( char * )Shader->FunctionCode + Info->DefaultValue + 12 ) ;
}

// _VF[_[ float ^萔ݒ肷
extern int NS_SetVSConstSF( int ConstantIndex, float Param )
{
	FLOAT4 ParamF4 ;

	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex >= 256 )
		return -1 ;

	// 萔XV
	ParamF4.x = Param ;
	ParamF4.y = Param ;
	ParamF4.z = Param ;
	ParamF4.w = Param ;
	SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_VS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, &ParamF4, 1, TRUE ) ;

	// I
	return 0 ;
}

// _VF[_[ float ^萔ݒ肷
extern int NS_SetVSConstF( int ConstantIndex, FLOAT4 Param )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex >= 256 )
		return -1 ;

	// 萔XV
	SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_VS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, &Param, 1, TRUE ) ;

	// I
	return 0 ;
}

// _VF[_[ float ^萔ɍsݒ肷
extern	int			NS_SetVSConstFMtx( int ConstantIndex, MATRIX Param )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + 4 > 256 )
		return -1 ;

	// 萔XV
	SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_VS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ( FLOAT4 * )&Param, 4, TRUE ) ;

	// I
	return 0 ;
}

// _VF[_[ float ^萔ɓ]usݒ肷
extern	int			NS_SetVSConstFMtxT( int ConstantIndex, MATRIX Param )
{
	MATRIX Transpose ;

	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + 4 > 256 )
		return -1 ;

	// 萔XV
	CreateTransposeMatrix( &Transpose, &Param ) ;
	SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_VS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ( FLOAT4 * )&Transpose, 4, TRUE ) ;

	// I
	return 0 ;
}

// _VF[_[ int ^萔ݒ肷
extern	int			NS_SetVSConstSI( int ConstantIndex, int Param )
{
	INT4 ParamI4 ;

	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex >= 16 )
		return -1 ;

	// 萔XV
	ParamI4.x = Param ;
	ParamI4.y = Param ;
	ParamI4.z = Param ;
	ParamI4.w = Param ;
	SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_VS_INT, DX_SHADERCONSTANTSET_USER, ConstantIndex, &ParamI4, 1, TRUE ) ;

	// I
	return 0 ;
}

// _VF[_[ int ^萔ݒ肷
extern	int			NS_SetVSConstI( int ConstantIndex, INT4 Param )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex >= 16 )
		return -1 ;

	// 萔XV
	SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_VS_INT, DX_SHADERCONSTANTSET_USER, ConstantIndex, &Param, 1, TRUE ) ;

	// I
	return 0 ;
}

// _VF[_[ BOOL ^萔ݒ肷
extern	int			NS_SetVSConstB( int ConstantIndex, BOOL Param )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex >= 16 )
		return -1 ;

	// 萔XV
	SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_VS_BOOL, DX_SHADERCONSTANTSET_USER, ConstantIndex, &Param, 1, TRUE ) ;

	// I
	return 0 ;
}

// _VF[_[ float ^萔ݒ肷( zgĘAԃCfbNXɈxɐݒ )
extern	int			NS_SetVSConstSFArray( int ConstantIndex, const float *ParamArray, int ParamNum )
{
	FLOAT4 ParamArrayF4[ 256 ] ;
	int i ;

	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum > 256 )
		return -1 ;

	// zɃf[^Zbg
	for( i = 0 ; i < ParamNum ; i ++ )
	{
		ParamArrayF4[ i ].x = ParamArray[ i ] ;
		ParamArrayF4[ i ].y = ParamArray[ i ] ;
		ParamArrayF4[ i ].z = ParamArray[ i ] ;
		ParamArrayF4[ i ].w = ParamArray[ i ] ;
	}

	// 萔XV
	SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_VS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamArrayF4, ParamNum, TRUE ) ;

	// I
	return 0 ;
}

// _VF[_[ float ^萔ݒ肷( zgĘAԃCfbNXɈxɐݒ )
extern	int			NS_SetVSConstFArray( int ConstantIndex, const FLOAT4 *ParamArray, int ParamNum )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum > 256 )
		return -1 ;

	// 萔XV
	SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_VS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamArray, ParamNum, TRUE ) ;

	// I
	return 0 ;
}

// _VF[_[ float ^萔ɍsݒ肷( zgĘAԃCfbNXɈxɐݒ )
extern	int			NS_SetVSConstFMtxArray( int ConstantIndex, const MATRIX *ParamArray, int ParamNum )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum * 4 > 256 )
		return -1 ;

	// 萔XV
	SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_VS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamArray, ParamNum * 4, TRUE ) ;

	// I
	return 0 ;
}

// _VF[_[ float ^萔ɓ]usݒ肷( zgĘAԃCfbNXɈxɐݒ )
extern	int			NS_SetVSConstFMtxTArray( int ConstantIndex, const MATRIX *ParamArray, int ParamNum )
{
	MATRIX Transpose[ 256 / 4 ] ;
	int i ;

	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum * 4 > 256 )
		return -1 ;

	// 萔XV
	for( i = 0 ; i < ParamNum ; i ++ )
	{
		Transpose[ i ].m[ 0 ][ 0 ] = ParamArray[ i ].m[ 0 ][ 0 ] ;
		Transpose[ i ].m[ 1 ][ 0 ] = ParamArray[ i ].m[ 0 ][ 1 ] ;
		Transpose[ i ].m[ 2 ][ 0 ] = ParamArray[ i ].m[ 0 ][ 2 ] ;
		Transpose[ i ].m[ 3 ][ 0 ] = ParamArray[ i ].m[ 0 ][ 3 ] ;

		Transpose[ i ].m[ 0 ][ 1 ] = ParamArray[ i ].m[ 1 ][ 0 ] ;
		Transpose[ i ].m[ 1 ][ 1 ] = ParamArray[ i ].m[ 1 ][ 1 ] ;
		Transpose[ i ].m[ 2 ][ 1 ] = ParamArray[ i ].m[ 1 ][ 2 ] ;
		Transpose[ i ].m[ 3 ][ 1 ] = ParamArray[ i ].m[ 1 ][ 3 ] ;

		Transpose[ i ].m[ 0 ][ 2 ] = ParamArray[ i ].m[ 2 ][ 0 ] ;
		Transpose[ i ].m[ 1 ][ 2 ] = ParamArray[ i ].m[ 2 ][ 1 ] ;
		Transpose[ i ].m[ 2 ][ 2 ] = ParamArray[ i ].m[ 2 ][ 2 ] ;
		Transpose[ i ].m[ 3 ][ 2 ] = ParamArray[ i ].m[ 2 ][ 3 ] ;

		Transpose[ i ].m[ 0 ][ 3 ] = ParamArray[ i ].m[ 3 ][ 0 ] ;
		Transpose[ i ].m[ 1 ][ 3 ] = ParamArray[ i ].m[ 3 ][ 1 ] ;
		Transpose[ i ].m[ 2 ][ 3 ] = ParamArray[ i ].m[ 3 ][ 2 ] ;
		Transpose[ i ].m[ 3 ][ 3 ] = ParamArray[ i ].m[ 3 ][ 3 ] ;
	}
	SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_VS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, Transpose, ParamNum * 4, TRUE ) ;

	// I
	return 0 ;
}

// _VF[_[ int ^萔ݒ肷( zgĘAԃCfbNXɈxɐݒ )
extern	int			NS_SetVSConstSIArray( int ConstantIndex, const int *ParamArray, int ParamNum )
{
	INT4 ParamArrayI4[ 16 ] ;
	int i ;

	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum > 16 )
		return -1 ;

	// z̃Zbg
	for( i = 0 ; i < ParamNum ; i ++ )
	{
		ParamArrayI4[ i ].x = ParamArray[ i ] ;
		ParamArrayI4[ i ].y = ParamArray[ i ] ;
		ParamArrayI4[ i ].z = ParamArray[ i ] ;
		ParamArrayI4[ i ].w = ParamArray[ i ] ;
	}

	// 萔XV
	SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_VS_INT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamArrayI4, ParamNum, TRUE ) ;

	// I
	return 0 ;
}

// _VF[_[ int ^萔ݒ肷( zgĘAԃCfbNXɈxɐݒ )
extern	int			NS_SetVSConstIArray( int ConstantIndex, const INT4 *ParamArray, int ParamNum )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum > 16 )
		return -1 ;

	// 萔XV
	SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_VS_INT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamArray, ParamNum, TRUE ) ;

	// I
	return 0 ;
}

// _VF[_[ BOOL ^萔ݒ肷( zgĘAԃCfbNXɈxɐݒ )
extern	int			NS_SetVSConstBArray( int ConstantIndex, const BOOL *ParamArray, int ParamNum )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum > 16 )
		return -1 ;

	// 萔XV
	SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_VS_BOOL, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamArray, ParamNum, TRUE ) ;

	// I
	return 0 ;
}

// _VF[_[ float ^萔̐ݒZbg
extern	int			NS_ResetVSConstF( int ConstantIndex, int ParamNum )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum > 256 )
		return -1 ;

	// 萔Zbg
	ResetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_VS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamNum ) ;

	// I
	return 0 ;
}

// _VF[_[ int ^萔̐ݒZbg
extern	int			NS_ResetVSConstI( int ConstantIndex, int ParamNum )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum > 16 )
		return -1 ;

	// 萔Zbg
	ResetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_VS_INT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamNum ) ;

	// I
	return 0 ;
}

// _VF[_[ BOOL ^萔̐ݒZbg
extern	int			NS_ResetVSConstB( int ConstantIndex, int ParamNum )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum > 16 )
		return -1 ;

	// 萔Zbg
	ResetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_VS_BOOL, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamNum ) ;

	// I
	return 0 ;
}

// sNZVF[_[ float ^萔ݒ肷
extern	int			NS_SetPSConstSF( int ConstantIndex, float Param )
{
	FLOAT4 ParamF4 ;

	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex >= 224 )
		return -1 ;

	// 萔XV
	ParamF4.x = Param ;
	ParamF4.y = Param ;
	ParamF4.z = Param ;
	ParamF4.w = Param ;
	SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, &ParamF4, 1, TRUE ) ;

	// I
	return 0 ;
}

// sNZVF[_[ float ^萔ݒ肷
extern	int			NS_SetPSConstF( int ConstantIndex, FLOAT4 Param )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex >= 224 )
		return -1 ;

	// 萔XV
	SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, &Param, 1, TRUE ) ;

	// I
	return 0 ;
}

// sNZVF[_[ float ^萔ɍsݒ肷
extern	int			NS_SetPSConstFMtx( int ConstantIndex, MATRIX Param )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + 4 > 224 )
		return -1 ;

	// 萔XV
	SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ( FLOAT4 * )&Param, 4, TRUE ) ;

	// I
	return 0 ;
}

// sNZVF[_[ float ^萔ɓ]usݒ肷
extern	int			NS_SetPSConstFMtxT( int ConstantIndex, MATRIX Param )
{
	MATRIX Transpose ;

	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + 4 > 224 )
		return -1 ;

	// 萔XV
	CreateTransposeMatrix( &Transpose, &Param ) ;
	SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ( FLOAT4 * )&Transpose, 4, TRUE ) ;

	// I
	return 0 ;
}


// sNZVF[_[ int ^萔ݒ肷
extern	int			NS_SetPSConstSI( int ConstantIndex, int Param )
{
	INT4 ParamI4 ;

	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex >= 16 )
		return -1 ;

	// 萔XV
	ParamI4.x = Param ;
	ParamI4.y = Param ;
	ParamI4.z = Param ;
	ParamI4.w = Param ;
	SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_INT, DX_SHADERCONSTANTSET_USER, ConstantIndex, &ParamI4, 1, TRUE ) ;

	// I
	return 0 ;
}

// sNZVF[_[ int ^萔ݒ肷
extern	int			NS_SetPSConstI( int ConstantIndex, INT4 Param )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex >= 16 )
		return -1 ;

	// 萔XV
	SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_INT, DX_SHADERCONSTANTSET_USER, ConstantIndex, &Param, 1, TRUE ) ;

	// I
	return 0 ;
}

// sNZVF[_[ BOOL ^萔ݒ肷
extern	int			NS_SetPSConstB( int ConstantIndex, BOOL Param )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex >= 16 )
		return -1 ;

	// 萔XV
	SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_BOOL, DX_SHADERCONSTANTSET_USER, ConstantIndex, &Param, 1, TRUE ) ;

	// I
	return 0 ;
}

// sNZVF[_[ float ^萔ݒ肷( zgĘAԃCfbNXɈxɐݒ )
extern	int			NS_SetPSConstSFArray( int ConstantIndex, const float *ParamArray, int ParamNum )
{
	FLOAT4 ParamArrayF4[ 256 ] ;
	int i ;

	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum > 224 )
		return -1 ;

	// zɃZbg
	for( i = 0 ; i < ParamNum ; i ++ )
	{
		ParamArrayF4[ i ].x = ParamArray[ i ] ;
		ParamArrayF4[ i ].y = ParamArray[ i ] ;
		ParamArrayF4[ i ].z = ParamArray[ i ] ;
		ParamArrayF4[ i ].w = ParamArray[ i ] ;
	}

	// 萔XV
	SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamArrayF4, ParamNum, TRUE ) ;

	// I
	return 0 ;
}

// sNZVF[_[ float ^萔ݒ肷( zgĘAԃCfbNXɈxɐݒ )
extern	int			NS_SetPSConstFArray( int ConstantIndex, const FLOAT4 *ParamArray, int ParamNum )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum > 224 )
		return -1 ;

	// 萔XV
	SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamArray, ParamNum, TRUE ) ;

	// I
	return 0 ;
}

// sNZVF[_[ float ^萔ɍsݒ肷( zgĘAԃCfbNXɈxɐݒ )
extern	int			NS_SetPSConstFMtxArray( int ConstantIndex, const MATRIX *ParamArray, int ParamNum )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum * 4 > 224 )
		return -1 ;

	// 萔XV
	SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamArray, ParamNum * 4, TRUE ) ;

	// I
	return 0 ;
}

// sNZVF[_[ float ^萔ɓ]usݒ肷( zgĘAԃCfbNXɈxɐݒ )
extern	int			NS_SetPSConstFMtxTArray( int ConstantIndex, const MATRIX *ParamArray, int ParamNum )
{
	int i ;
	MATRIX Transpose[ 224 / 4 ] ;

	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum * 4 > 224 )
		return -1 ;

	// 萔XV
	for( i = 0 ; i < ParamNum ; i ++ )
	{
		Transpose[ i ].m[ 0 ][ 0 ] = ParamArray[ i ].m[ 0 ][ 0 ] ;
		Transpose[ i ].m[ 1 ][ 0 ] = ParamArray[ i ].m[ 0 ][ 1 ] ;
		Transpose[ i ].m[ 2 ][ 0 ] = ParamArray[ i ].m[ 0 ][ 2 ] ;
		Transpose[ i ].m[ 3 ][ 0 ] = ParamArray[ i ].m[ 0 ][ 3 ] ;

		Transpose[ i ].m[ 0 ][ 1 ] = ParamArray[ i ].m[ 1 ][ 0 ] ;
		Transpose[ i ].m[ 1 ][ 1 ] = ParamArray[ i ].m[ 1 ][ 1 ] ;
		Transpose[ i ].m[ 2 ][ 1 ] = ParamArray[ i ].m[ 1 ][ 2 ] ;
		Transpose[ i ].m[ 3 ][ 1 ] = ParamArray[ i ].m[ 1 ][ 3 ] ;

		Transpose[ i ].m[ 0 ][ 2 ] = ParamArray[ i ].m[ 2 ][ 0 ] ;
		Transpose[ i ].m[ 1 ][ 2 ] = ParamArray[ i ].m[ 2 ][ 1 ] ;
		Transpose[ i ].m[ 2 ][ 2 ] = ParamArray[ i ].m[ 2 ][ 2 ] ;
		Transpose[ i ].m[ 3 ][ 2 ] = ParamArray[ i ].m[ 2 ][ 3 ] ;

		Transpose[ i ].m[ 0 ][ 3 ] = ParamArray[ i ].m[ 3 ][ 0 ] ;
		Transpose[ i ].m[ 1 ][ 3 ] = ParamArray[ i ].m[ 3 ][ 1 ] ;
		Transpose[ i ].m[ 2 ][ 3 ] = ParamArray[ i ].m[ 3 ][ 2 ] ;
		Transpose[ i ].m[ 3 ][ 3 ] = ParamArray[ i ].m[ 3 ][ 3 ] ;
	}
	SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, Transpose, ParamNum * 4, TRUE ) ;

	// I
	return 0 ;
}

// sNZVF[_[ int ^萔ݒ肷( zgĘAԃCfbNXɈxɐݒ )
extern	int			NS_SetPSConstSIArray( int ConstantIndex, const int *ParamArray, int ParamNum )
{
	INT4 ParamArrayI4[ 16 ] ;
	int i ;

	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum > 16 )
		return -1 ;

	// zɃp[^Zbg
	for( i = 0 ; i < ParamNum ; i ++ )
	{
		ParamArrayI4[ i ].x = ParamArray[ i ] ;
		ParamArrayI4[ i ].y = ParamArray[ i ] ;
		ParamArrayI4[ i ].z = ParamArray[ i ] ;
		ParamArrayI4[ i ].w = ParamArray[ i ] ;
	}

	// 萔XV
	SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_INT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamArrayI4, ParamNum, TRUE ) ;

	// I
	return 0 ;
}

// sNZVF[_[ int ^萔ݒ肷( zgĘAԃCfbNXɈxɐݒ )
extern	int			NS_SetPSConstIArray( int ConstantIndex, const INT4 *ParamArray, int ParamNum )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum > 16 )
		return -1 ;

	// 萔XV
	SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_INT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamArray, ParamNum, TRUE ) ;

	// I
	return 0 ;
}

// sNZVF[_[ BOOL ^萔ݒ肷( zgĘAԃCfbNXɈxɐݒ )
extern	int			NS_SetPSConstBArray( int ConstantIndex, const BOOL *ParamArray, int ParamNum )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum > 16 )
		return -1 ;

	// 萔XV
	SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_BOOL, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamArray, ParamNum, TRUE ) ;

	// I
	return 0 ;
}

// sNZVF[_[ float ^萔̐ݒZbg
extern	int			NS_ResetPSConstF( int ConstantIndex, int ParamNum )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum > 256 )
		return -1 ;

	// 萔Zbg
	ResetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamNum ) ;

	// I
	return 0 ;
}

// sNZVF[_[ int ^萔̐ݒZbg
extern	int			NS_ResetPSConstI( int ConstantIndex, int ParamNum )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum > 16 )
		return -1 ;

	// 萔Zbg
	ResetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_INT, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamNum ) ;

	// I
	return 0 ;
}

// sNZVF[_[ BOOL ^萔̐ݒZbg
extern	int			NS_ResetPSConstB( int ConstantIndex, int ParamNum )
{
	// VF[_[gȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return 0 ;

	// ͈͉z`FbN
	if( ConstantIndex < 0 || ConstantIndex + ParamNum > 16 )
		return -1 ;

	// 萔Zbg
	ResetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_BOOL, DX_SHADERCONSTANTSET_USER, ConstantIndex, ParamNum ) ;

	// I
	return 0 ;
}

// VF[_[`ł̕`ݒ肷
extern int NS_SetRenderTargetToShader( int TargetIndex, int DrawScreen, int SurfaceIndex )
{
	IMAGEDATA2 *Image2 ;
	IMAGEDATA2 *OldImage2 ;

	// ^[QbgCfbNX͈̔̓`FbN
	if( TargetIndex < 0 || TargetIndex >= GRH.RenderTargetNum )
		return -1 ;

	// lꍇ͉I
//	if( GBASE.TargetScreen[ TargetIndex ] == DrawScreen && GBASE.TargetScreenSurface[ TargetIndex ] == SurfaceIndex )
//		return 0 ;

	// ^[QbgOŃT[tFXCfbNXȌꍇ SetDrawScreen ɔC
	if( TargetIndex == 0 && SurfaceIndex == 0 )
	{
		return NS_SetDrawScreen( DrawScreen ) ;
	}

	// n[hEGAœ삵ĂȂꍇ͉Ȃ
	if( GRA2.ValidHardWare == FALSE )
		return -1 ;

	// ^[QbgOȊȌꍇ̓VF[_[gpłȂꍇ͉Ȃ
	if( GRH.UseShader == FALSE )
		return -1 ;

	// foCXɂȂĂ牽I
	if( GraphicsDevice_IsValid() == 0 )
		return -1 ;

	// `揈IĂ
	RenderVertexHardware() ;
	EndScene() ;

	// ZbgĂeNX`[O
	SetTextureHardware( NULL ) ;

	// ܂ł̕`̉摜̎擾
	if( GRAPHCHKFULL( GBASE.TargetScreen[ TargetIndex ], OldImage2 ) )
	{
		OldImage2 = NULL ;
	}
	else
	{
		// ܂ł̕`悪_O^[QbgT[tFXꍇ̓_O^[QbgeNX`ɓ]
		if( OldImage2->Hard.Draw[ 0 ].Tex->RenderTargetSurface )
		{
			UpdateDrawTexture( OldImage2->Hard.Draw[ 0 ].Tex, GBASE.TargetScreenSurface[ TargetIndex ] ) ;
		}
	}

	// 摜ǂ𔻒
	if( GRAPHCHKFULL( DrawScreen, Image2 ) )
	{
		// 摜ł͂Ȃꍇ͕`Ώۂ𖳌ɂ
		GBASE.TargetScreen[ TargetIndex ] = 0 ;
		GBASE.TargetScreenSurface[ TargetIndex ] = 0 ;
		SetRenderTargetHardware( NULL, TargetIndex ) ;
		return 0 ;
	}

	// 摜ꍇ͕`\ł͖ꍇ̓G[
	if( Image2->Orig->FormatDesc.DrawValidFlag == FALSE )
		return -1 ;

	// 摜nhۑ
	GBASE.TargetScreen[ TargetIndex ] = DrawScreen ;
	GBASE.TargetScreenSurface[ TargetIndex ] = SurfaceIndex ;

	// `ɐlނǂ̃tOXV
	RefreshAlphaChDrawMode() ;

	// `Zbg
	if( Image2->Hard.Draw[ 0 ].Tex->RenderTargetSurface )
	{
		SetRenderTargetHardware( Image2->Hard.Draw[ 0 ].Tex->RenderTargetSurface, TargetIndex ) ;
	}
	else
	{
		SetRenderTargetHardware( Image2->Hard.Draw[ 0 ].Tex->Surface[ SurfaceIndex ], TargetIndex ) ;
	}

	// I
	return 0 ;
}

// VF[_[`ŎgpOtBbNݒ肷
extern	int			NS_SetUseTextureToShader( int StageIndex, int GraphHandle )
{
	// L͈̓`FbN
	if( StageIndex < 0 || StageIndex >= 16 )
		return -1 ;

	// OtBbNnh`FbN
	if( GraphHandle != -1 )
	{
		IMAGEDATA2 *Image2 ;

		if( GRAPHCHK( GraphHandle, Image2 ) )
			return -1 ;

		// nhۑ
		GRH.UserShaderRenderInfo.SetTextureGraphHandle[ StageIndex ] = GraphHandle ;
	}
	else
	{
		// nhZbg
		GRH.UserShaderRenderInfo.SetTextureGraphHandle[ StageIndex ] = 0 ;
	}

	// I
	return 0 ;
}

// VF[_[`Ɏgp钸_VF[_[ݒ肷
extern	int			NS_SetUseVertexShader( int ShaderHandle )
{
	SHADERHANDLEDATA *VertexShader ;

	if( ShaderHandle > 0 && ( SHADERCHK( ShaderHandle, VertexShader ) || VertexShader->IsVertexShader == FALSE ) )
		return -1 ;

	// nhZbg
	GRH.UserShaderRenderInfo.SetVertexShaderHandle = ShaderHandle <= 0 ? 0 : ShaderHandle ;

	// I
	return 0 ;
}

// VF[_[`ɎgpsNZVF[_[ݒ肷
extern	int			NS_SetUsePixelShader( int ShaderHandle )
{
	SHADERHANDLEDATA *PixelShader ;

	if( ShaderHandle > 0 && ( SHADERCHK( ShaderHandle, PixelShader ) || PixelShader->IsVertexShader == TRUE ) )
		return -1 ;

	// nhZbg
	GRH.UserShaderRenderInfo.SetPixelShaderHandle = ShaderHandle <= 0 ? 0 : ShaderHandle  ;

	// I
	return 0 ;
}


// |S̒_̐ڐƏ]@tuWvZăZbg
extern int NS_CalcPolygonBinormalAndTangentsToShader( VERTEX3DSHADER *Vertex, int PolygonNum )
{
	unsigned short *Indices ;
	int IndexNum ;
	int i ;
	int Result ;

	IndexNum = PolygonNum * 3 ;

	Indices = ( unsigned short * )DXALLOC( IndexNum * sizeof( unsigned short ) ) ;
	if( Indices == NULL )
	{
		DXST_ERRORLOGFMT_ADD( ( _T( "_CfbNXi[郁̈̊mۂɎs܂\n" ) ) ) ;
		return -1 ;
	}

	// _CfbNXZbg
	for( i = 0 ; i < IndexNum ; i ++ )
	{
		Indices[ i ] = ( unsigned short )i ;
	}

	// ڐƏ]@vZ
	Result = NS_CalcPolygonIndexedBinormalAndTangentsToShader( Vertex, IndexNum, Indices, PolygonNum ) ;

	// _CfbNXi[Ă̈J
	DXFREE( Indices ) ;

	// I
	return Result ;
}



// |S̒_̐ڐƏ]@tuWvZăZbg(CfbNX)
extern int NS_CalcPolygonIndexedBinormalAndTangentsToShader( VERTEX3DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int PolygonNum )
{
	int i ;
	VECTOR v1, v2, vt, du, dv, vb, vn ;
	BYTE *UseFlag ;
	const unsigned short *Index ;
	int IndexNum ;
	VERTEX3DSHADER *Vert[ 3 ] ;

	// gpĂ钸_̃e[u쐬
	{
		UseFlag = ( BYTE * )DXALLOC( sizeof( BYTE ) * VertexNum ) ;
		if( UseFlag == NULL )
		{
			DXST_ERRORLOGFMT_ADD( ( _T( "_̐ڐƏ]@̍쐬ƂɕKvȃ̈̊mۂɎs܂\n" ) ) ) ;
			return -1 ;
		}
		_MEMSET( UseFlag, 0, VertexNum ) ;

		IndexNum = PolygonNum * 3 ;
		for( i = 0 ; i < IndexNum ; i ++ )
		{
			UseFlag[ Indices[ i ] ] = 1 ;
		}
	}

	// ڐƏ]@̏
	for( i = 0 ; i < VertexNum ; i ++ )
	{
		if( UseFlag[ i ] == 0 ) continue ;
		Vertex[ i ].binorm.x = 0.0f ;
		Vertex[ i ].binorm.y = 0.0f ;
		Vertex[ i ].binorm.z = 0.0f ;
		Vertex[ i ].tan.x = 0.0f ;
		Vertex[ i ].tan.y = 0.0f ;
		Vertex[ i ].tan.z = 0.0f ;
	}

	// SĂ̖ʂ̐JԂ
	Index = Indices ;
	for( i = 0 ; i < PolygonNum ; i ++, Index += 3 )
	{
		Vert[ 0 ] = &Vertex[ Index[ 0 ] ] ;
		Vert[ 1 ] = &Vertex[ Index[ 1 ] ] ;
		Vert[ 2 ] = &Vertex[ Index[ 2 ] ] ;

		v1.x = Vert[ 1 ]->pos.x - Vert[ 0 ]->pos.x ;
		v1.y = Vert[ 1 ]->u - Vert[ 0 ]->u ;
		v1.z = Vert[ 1 ]->v - Vert[ 0 ]->v ;

		v2.x = Vert[ 2 ]->pos.x - Vert[ 0 ]->pos.x ;
		v2.y = Vert[ 2 ]->u - Vert[ 0 ]->u ;
		v2.z = Vert[ 2 ]->v - Vert[ 0 ]->v ;

		vt = VCross( v1, v2 ) ;
		du.x = 1.0f ;
		if( VDot( vt, vt ) >= 0.0000001f )
		{
			du.x = -vt.y / vt.x ;
			dv.x = -vt.z / vt.x ;
		}

		v1.x = Vert[ 1 ]->pos.y - Vert[ 0 ]->pos.y ;
		v2.x = Vert[ 2 ]->pos.y - Vert[ 0 ]->pos.y ;

		vt = VCross( v1, v2 ) ;
		du.y = 1.0f ;
		if( VDot( vt, vt ) >= 0.0000001f )
		{
			du.y = -vt.y / vt.x ;
			dv.y = -vt.z / vt.x ;
		}

		v1.x = Vert[ 1 ]->pos.z - Vert[ 0 ]->pos.z ;
		v2.x = Vert[ 2 ]->pos.z - Vert[ 0 ]->pos.z ;

		vt = VCross( v1, v2 ) ;
		du.z = 1.0f ;
		if( VDot( vt, vt ) >= 0.0000001f )
		{
			du.z = -vt.y / vt.x ;
			dv.z = -vt.z / vt.x ;
		}

		VectorAdd( &Vert[ 0 ]->tan, &Vert[ 0 ]->tan, &du ) ;
		VectorAdd( &Vert[ 1 ]->tan, &Vert[ 1 ]->tan, &du ) ;
		VectorAdd( &Vert[ 2 ]->tan, &Vert[ 2 ]->tan, &du ) ;

		VectorAdd( &Vert[ 0 ]->binorm, &Vert[ 0 ]->binorm, &dv ) ;
		VectorAdd( &Vert[ 1 ]->binorm, &Vert[ 1 ]->binorm, &dv ) ;
		VectorAdd( &Vert[ 2 ]->binorm, &Vert[ 2 ]->binorm, &dv ) ;
	}

	// @̎ZoƐK
	for( i = 0 ; i < VertexNum ; i ++ )
	{
		if( UseFlag[ i ] == 0 ) continue ;

		vt = VNorm( Vertex[ i ].tan ) ;
		vn = VNorm( VCross( vt, Vertex[ i ].binorm ) ) ;
		vb = VNorm( VCross( vn, vt ) ) ;

		// K
		Vertex[ i ].tan    = vt ;
		Vertex[ i ].binorm = vb ;
	}

	// ̉
	DXFREE( UseFlag ) ;

	// I
	return 0 ;
}


// VF[_[`p`OZbgAbv֐
__inline void DrawPreparationToShader( int ParamFlag, int UseVertexShaderNo, int Is2D, int UseLibSubShaderConst )
{
	DIRECT3DBLENDINFO BlendInfo ;
	int i, Flag ;

	// {IȃZbgAbv
	Flag = ParamFlag | DRAWPREP_SPECULAR | DRAWPREP_NOTSHADERRESET | DRAWPREP_TEXADDRESS | DRAWPREP_NOBLENDSETTING | ( Is2D ? 0 : DRAWPREP_CULLING ) ;
	DRAWPREP_NOTEX( Flag )

	// [U[ݒ̃VF[_[萔Lɂ
	if( UseLibSubShaderConst )
	{
		SetUseShaderContantInfoState( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTSET_MASK_LIB | DX_SHADERCONSTANTSET_MASK_LIB_SUB ) ;
	}
	else
	{
		SetUseShaderContantInfoState( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTSET_MASK_LIB | DX_SHADERCONSTANTSET_MASK_USER ) ;
	}

	// _tH[}bg̓Zbg
	GRH.SetVD = NULL ;
	GRH.SetFVF = 0 ;

	// uh[h͎OŃZbgAbv
	{
		BlendInfo.SeparateAlphaBlendEnable = FALSE ;
		BlendInfo.SrcBlendAlpha = -1 ;
		BlendInfo.DestBlendAlpha = -1 ;
		BlendInfo.BlendOpAlpha = -1 ;

		// At@eXgp[^Lȏꍇ͂D悷
		if( GBASE.AlphaTestMode != -1 )
		{
			BlendInfo.AlphaTestEnable = TRUE ;
			BlendInfo.AlphaFunc = GBASE.AlphaTestMode ;
			BlendInfo.AlphaRef = GBASE.AlphaTestParam ;
		}
		else
		{
			// ftHg̃At@eXg̐ݒZbg
			BlendInfo.AlphaTestEnable = TRUE ;
			BlendInfo.AlphaRef = 0 ;
			BlendInfo.AlphaFunc = D_D3DCMP_GREATER ;
		}

		// o͐Ƃ̃uhZbg
		BlendInfo.AlphaBlendEnable = GBASE.BlendMode != DX_BLENDMODE_NOBLEND && GBASE.BlendMode != DX_BLENDMODE_XOR ;
		BlendInfo.DestBlend = __RGBBlendStateTable[ GBASE.BlendMode ][ RGB_BLENDSTATE_TABLE_DESTBLEND ] ;
		BlendInfo.SrcBlend  = __RGBBlendStateTable[ GBASE.BlendMode ][ RGB_BLENDSTATE_TABLE_SRCBLEND ] ;
		BlendInfo.BlendOp   = __RGBBlendStateTable[ GBASE.BlendMode ][ RGB_BLENDSTATE_TABLE_BLENDOP ] ;
		BlendInfo.FactorColor = 0xffffffff ;

		// Zuhw D3DRS_BLENDOP gp\ȏꍇ 14Ԗڂ̃uh[hgp
		if( GBASE.BlendMode == DX_BLENDMODE_SUB && GRH.ValidDestBlendOp )
		{
			BlendInfo.DestBlend = __RGBBlendStateTable[ DX_BLENDMODE_SUB1 ][ RGB_BLENDSTATE_TABLE_DESTBLEND ] ;
			BlendInfo.SrcBlend  = __RGBBlendStateTable[ DX_BLENDMODE_SUB1 ][ RGB_BLENDSTATE_TABLE_SRCBLEND ] ;
			BlendInfo.BlendOp   = __RGBBlendStateTable[ DX_BLENDMODE_SUB1 ][ RGB_BLENDSTATE_TABLE_BLENDOP ] ;
			BlendInfo.FactorColor = 0xffffffff ;
		}

		// gpeNX`
		BlendInfo.UseTextureStageNum = 0 ;
		for( i = 0 ; i < 8 ; i ++ )
		{
			BlendInfo.TextureStageInfo[ i ].Texture = ( void * )( DWORD_PTR )GRH.UserShaderRenderInfo.SetTextureGraphHandle[ i ] ;
			BlendInfo.TextureStageInfo[ i ].TextureCoordIndex = i ;
			if( GRH.UserShaderRenderInfo.SetTextureGraphHandle[ i ] == 0 ) continue ;
			BlendInfo.UseTextureStageNum = i + 1 ;
		}

		// ݒ𔽉f
		D_SetUserBlendInfo( &BlendInfo, TRUE, TRUE ) ;

		// gpeNX`WZbg
		D_ResetTextureCoord() ;
	}

	// _VF[_[gp邩ǂŏ𕪊
	if( UseVertexShaderNo >= 0 )
	{
		// gp钸_f[^tH[}bgXV
		if( GRH.SetVD != GRH.UserShaderDeclaration[ UseVertexShaderNo ] )
		{
			GRH.SetVD = GRH.UserShaderDeclaration[ UseVertexShaderNo ] ;
			GraphicsDevice_SetVertexDeclaration( GRH.SetVD ) ;
			GRH.SetFVF = 0 ;
		}

		// gp钸_VF[_[XV
		SetDeviceVertexShaderToHandle( GRH.UserShaderRenderInfo.SetVertexShaderHandle ) ;
	}
	else
	{
		// gpȂꍇ͒_VF[_[Zbg
		if( GRH.SetVS != NULL )
		{
			GRH.SetVS = NULL ;
			GRH.SetFVF = 0 ;
			GraphicsDevice_SetVertexShader( NULL ) ;
		}

		// _f[^`Zbg
		if( Is2D )
		{
			SETFVF( VERTEXFVF_SHADER_2D ) 
		}
		else
		{
			SETFVF( VERTEXFVF_SHADER_3D ) 
		}
	}

	// gpsNZVF[_[XV
	SetDevicePixelShaderToHandle( GRH.UserShaderRenderInfo.SetPixelShaderHandle ) ;
}

// VF[_[gĂQc|S`悷
extern	int			NS_DrawPolygon2DToShader( const VERTEX2DSHADER *Vertex, int PolygonNum )
{
	if( GraphicsDevice_IsValid() == 0 ) return -1 ;
	if( GRH.UseShader == FALSE ) return -1 ;

	// `̏
	RenderVertexHardware() ;
	BeginScene() ;
	DrawPreparationToShader( DRAWPREP_GOURAUDSHADE | DRAWPREP_PERSPECTIVE, -1, TRUE, FALSE ) ;

	// `
	GraphicsDevice_DrawPrimitiveUP( D_D3DPT_TRIANGLELIST, PolygonNum, Vertex, sizeof( VERTEX2DSHADER ) ) ;

	// I
	return 0 ;
}

// VF[_[gĂRc|S`悷
extern	int			NS_DrawPolygon3DToShader( const VERTEX3DSHADER *Vertex, int PolygonNum )
{
	if( GraphicsDevice_IsValid() == 0 ) return -1 ;
	if( GRH.UseShader == FALSE ) return -1 ;

	// `̏
	RenderVertexHardware() ;
	BeginScene() ;
	DrawPreparationToShader( DRAWPREP_3D | DRAWPREP_GOURAUDSHADE | DRAWPREP_FOG | DRAWPREP_PERSPECTIVE | DRAWPREP_LIGHTING, DX_VERTEX_TYPE_SHADER_3D, FALSE, FALSE ) ;

	// sn[hEGAɔf
	ApplyLibMatrixToHardware() ;

	// `
	GraphicsDevice_DrawPrimitiveUP( D_D3DPT_TRIANGLELIST, PolygonNum, Vertex, sizeof( VERTEX3DSHADER ) ) ;

	// I
	return 0 ;
}

// VF[_[gĂQc|S`悷(CfbNX)
extern	int			NS_DrawPolygonIndexed2DToShader( const VERTEX2DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int PolygonNum )
{
	if( GraphicsDevice_IsValid() == 0 ) return -1 ;
	if( GRH.UseShader == FALSE ) return -1 ;

	// `̏
	RenderVertexHardware() ;
	BeginScene() ;
	DrawPreparationToShader( DRAWPREP_GOURAUDSHADE | DRAWPREP_PERSPECTIVE, -1, TRUE, FALSE ) ;

	// `
	GraphicsDevice_DrawIndexedPrimitiveUP( D_D3DPT_TRIANGLELIST, 0, VertexNum, PolygonNum, Indices, D_D3DFMT_INDEX16, Vertex, sizeof( VERTEX2DSHADER ) ) ;

	// I
	return 0 ;
}

// VF[_[gĂRc|S`悷(CfbNX)
extern	int			NS_DrawPolygonIndexed3DToShader( const VERTEX3DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int PolygonNum )
{
	if( GraphicsDevice_IsValid() == 0 ) return -1 ;
	if( GRH.UseShader == FALSE ) return -1 ;

	// `̏
	RenderVertexHardware() ;
	BeginScene() ;
	DrawPreparationToShader( DRAWPREP_3D | DRAWPREP_GOURAUDSHADE | DRAWPREP_FOG | DRAWPREP_PERSPECTIVE | DRAWPREP_LIGHTING, DX_VERTEX_TYPE_SHADER_3D, FALSE, FALSE ) ;

	// sn[hEGAɔf
	ApplyLibMatrixToHardware() ;

	// `
	GraphicsDevice_DrawIndexedPrimitiveUP( D_D3DPT_TRIANGLELIST, 0, VertexNum, PolygonNum, Indices, D_D3DFMT_INDEX16, Vertex, sizeof( VERTEX3DSHADER ) ) ;

	// I
	return 0 ;
}

// VF[_[gĂQcv~eBu`悷
extern	int			NS_DrawPrimitive2DToShader( const VERTEX2DSHADER *Vertex, int VertexNum, int PrimitiveType )
{
	if( GraphicsDevice_IsValid() == 0 ) return -1 ;
	if( GRH.UseShader == FALSE ) return -1 ;

	// `̏
	RenderVertexHardware() ;
	BeginScene() ;
	DrawPreparationToShader( DRAWPREP_GOURAUDSHADE | DRAWPREP_PERSPECTIVE, -1, TRUE, FALSE ) ;

	// `
	GraphicsDevice_DrawPrimitiveUP( ( D_D3DPRIMITIVETYPE )PrimitiveType, GETPRIMNUM( PrimitiveType, VertexNum ), Vertex, sizeof( VERTEX2DSHADER ) ) ;

	// I
	return 0 ;
}

// VF[_[gĂRcv~eBu`悷
extern	int			NS_DrawPrimitive3DToShader( const VERTEX3DSHADER *Vertex, int VertexNum, int PrimitiveType )
{
	if( GraphicsDevice_IsValid() == 0 ) return -1 ;
	if( GRH.UseShader == FALSE ) return -1 ;

	// `̏
	RenderVertexHardware() ;
	BeginScene() ;
	DrawPreparationToShader( DRAWPREP_3D | DRAWPREP_GOURAUDSHADE | DRAWPREP_FOG | DRAWPREP_PERSPECTIVE | DRAWPREP_LIGHTING, DX_VERTEX_TYPE_SHADER_3D, FALSE, FALSE ) ;

	// sn[hEGAɔf
	ApplyLibMatrixToHardware() ;

	// `
	GraphicsDevice_DrawPrimitiveUP( ( D_D3DPRIMITIVETYPE )PrimitiveType, GETPRIMNUM( PrimitiveType, VertexNum ), Vertex, sizeof( VERTEX3DSHADER ) ) ;

	// I
	return 0 ;
}

// VF[_[gĂQcv~eBu`悷(CfbNX)
extern	int			NS_DrawPrimitiveIndexed2DToShader( const VERTEX2DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int IndexNum, int PrimitiveType )
{
	if( GraphicsDevice_IsValid() == 0 ) return -1 ;
	if( GRH.UseShader == FALSE ) return -1 ;

	// `̏
	RenderVertexHardware() ;
	BeginScene() ;
	DrawPreparationToShader( DRAWPREP_GOURAUDSHADE | DRAWPREP_PERSPECTIVE, -1, TRUE, FALSE ) ;

	// `
	GraphicsDevice_DrawIndexedPrimitiveUP( ( D_D3DPRIMITIVETYPE )PrimitiveType, 0, VertexNum, GETPRIMNUM( PrimitiveType, IndexNum ), Indices, D_D3DFMT_INDEX16, Vertex, sizeof( VERTEX2DSHADER ) ) ;

	// I
	return 0 ;
}

// VF[_[gĂRcv~eBu`悷(CfbNX)
extern	int			NS_DrawPrimitiveIndexed3DToShader( const VERTEX3DSHADER *Vertex, int VertexNum, const unsigned short *Indices, int IndexNum, int PrimitiveType )
{
	if( GraphicsDevice_IsValid() == 0 ) return -1 ;
	if( GRH.UseShader == FALSE ) return -1 ;

	// `̏
	RenderVertexHardware() ;
	BeginScene() ;
	DrawPreparationToShader( DRAWPREP_3D | DRAWPREP_GOURAUDSHADE | DRAWPREP_FOG | DRAWPREP_PERSPECTIVE | DRAWPREP_LIGHTING, DX_VERTEX_TYPE_SHADER_3D, FALSE, FALSE ) ;

	// sn[hEGAɔf
	ApplyLibMatrixToHardware() ;

	// `
	GraphicsDevice_DrawIndexedPrimitiveUP( ( D_D3DPRIMITIVETYPE )PrimitiveType, 0, VertexNum, GETPRIMNUM( PrimitiveType, IndexNum ), Indices, D_D3DFMT_INDEX16, Vertex, sizeof( VERTEX3DSHADER ) ) ;

	// I
	return 0 ;
}

// VF[_[gĂRc|S`悷( _obt@gp )
extern	int			NS_DrawPolygon3DToShader_UseVertexBuffer( int VertexBufHandle )
{
	return NS_DrawPrimitive3DToShader_UseVertexBuffer( VertexBufHandle, DX_PRIMTYPE_TRIANGLELIST ) ;
}

// VF[_[gĂRc|S`悷( _obt@ƃCfbNXobt@gp )
extern	int			NS_DrawPolygonIndexed3DToShader_UseVertexBuffer( int VertexBufHandle, int IndexBufHandle )
{
	return NS_DrawPrimitiveIndexed3DToShader_UseVertexBuffer( VertexBufHandle, IndexBufHandle, DX_PRIMTYPE_TRIANGLELIST ) ;
}

// VF[_[gĂRcv~eBu`悷( _obt@gp )
extern	int			NS_DrawPrimitive3DToShader_UseVertexBuffer( int VertexBufHandle, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ )
{
	VERTEXBUFFERHANDLEDATA *VertexBuffer ;

	// G[
	if( VERTEXBUFFERCHK( VertexBufHandle, VertexBuffer ) )
		return -1 ;

	return NS_DrawPrimitive3DToShader_UseVertexBuffer2( VertexBufHandle, PrimitiveType, 0, VertexBuffer->Num ) ;
}

// VF[_[gĂRcv~eBu`悷( _obt@gp )
extern	int			NS_DrawPrimitive3DToShader_UseVertexBuffer2( int VertexBufHandle, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */, int StartVertex, int UseVertexNum )
{
	VERTEXBUFFERHANDLEDATA *VertexBuffer ;
	int PrimitiveCount ;

	// G[
	if( VERTEXBUFFERCHK( VertexBufHandle, VertexBuffer ) )
		return -1 ;

	// sn[hEGAɔf
	ApplyLibMatrixToHardware() ;

	// `̏
	RenderVertexHardware() ;
	BeginScene() ;
	DrawPreparationToShader( DRAWPREP_3D | DRAWPREP_GOURAUDSHADE | DRAWPREP_FOG | DRAWPREP_PERSPECTIVE | DRAWPREP_LIGHTING, VertexBuffer->Type, FALSE, FALSE ) ;

	// v~eBu̐擾
	PrimitiveCount = GETPRIMNUM( PrimitiveType, UseVertexNum ) ;

	// `
	if( VertexBuffer->Direct3DBuffer != NULL )
	{
		GraphicsDevice_SetStreamSource(
			0,
			VertexBuffer->Direct3DBuffer,
			0,
			VertexBuffer->UnitSize ) ;

		GraphicsDevice_DrawPrimitive(
			( D_D3DPRIMITIVETYPE )PrimitiveType,
			StartVertex,
			PrimitiveCount ) ;
	}
	else
	{
		GraphicsDevice_DrawPrimitiveUP(
			( D_D3DPRIMITIVETYPE )PrimitiveType,
			PrimitiveCount,
			( BYTE * )VertexBuffer->Buffer + StartVertex * VertexBuffer->UnitSize,
			VertexBuffer->UnitSize ) ;
	}

	// I
	return 0 ;
}

// VF[_[gĂRcv~eBu`悷( _obt@ƃCfbNXobt@gp )
extern	int			NS_DrawPrimitiveIndexed3DToShader_UseVertexBuffer( int VertexBufHandle, int IndexBufHandle, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */ )
{
	VERTEXBUFFERHANDLEDATA *VertexBuffer ;
	INDEXBUFFERHANDLEDATA *IndexBuffer ;

	// G[
	if( VERTEXBUFFERCHK( VertexBufHandle, VertexBuffer ) )
		return -1 ;
	if( INDEXBUFFERCHK( IndexBufHandle, IndexBuffer ) )
		return -1 ;

	return NS_DrawPrimitiveIndexed3DToShader_UseVertexBuffer2( VertexBufHandle, IndexBufHandle, PrimitiveType, 0, 0, VertexBuffer->Num, 0, IndexBuffer->Num ) ;
}

// VF[_[gĂRcv~eBu`悷( _obt@ƃCfbNXobt@gp )
extern	int			NS_DrawPrimitiveIndexed3DToShader_UseVertexBuffer2( int VertexBufHandle, int IndexBufHandle, int PrimitiveType /* DX_PRIMTYPE_TRIANGLELIST  */, int BaseVertex, int StartVertex, int UseVertexNum, int StartIndex, int UseIndexNum )
{
	VERTEXBUFFERHANDLEDATA *VertexBuffer ;
	INDEXBUFFERHANDLEDATA *IndexBuffer ;
	int PrimitiveCount ;
	D_D3DFORMAT IndexFormat ;

	// G[
	if( VERTEXBUFFERCHK( VertexBufHandle, VertexBuffer ) )
		return -1 ;
	if( INDEXBUFFERCHK( IndexBufHandle, IndexBuffer ) )
		return -1 ;

	// sn[hEGAɔf
	ApplyLibMatrixToHardware() ;

	// `̏
	RenderVertexHardware() ;
	BeginScene() ;
	DrawPreparationToShader( DRAWPREP_3D | DRAWPREP_GOURAUDSHADE | DRAWPREP_FOG | DRAWPREP_PERSPECTIVE | DRAWPREP_LIGHTING, VertexBuffer->Type, FALSE, FALSE ) ;

	// CfbNX^CvZbg
	IndexFormat = D_D3DFMT_INDEX16 ;
	switch( IndexBuffer->Type )
	{
	case DX_INDEX_TYPE_16BIT:
		IndexFormat = D_D3DFMT_INDEX16 ;
		break ;

	case DX_INDEX_TYPE_32BIT:
		IndexFormat = D_D3DFMT_INDEX32 ;
		break ;
	}

	// v~eBu̐擾
	PrimitiveCount = GETPRIMNUM( PrimitiveType, UseIndexNum ) ;

	// `
	if( VertexBuffer->Direct3DBuffer != NULL &&
		IndexBuffer->Direct3DBuffer  != NULL )
	{
		GraphicsDevice_SetStreamSource(
			0,
			VertexBuffer->Direct3DBuffer,
			0,
			VertexBuffer->UnitSize ) ;
		GraphicsDevice_SetIndices( IndexBuffer->Direct3DBuffer ) ;

		GraphicsDevice_DrawIndexedPrimitive(
			( D_D3DPRIMITIVETYPE )PrimitiveType,
			BaseVertex,
			StartVertex,
			UseVertexNum,
			StartIndex,
			PrimitiveCount ) ;
	}
	else
	{
		GraphicsDevice_DrawIndexedPrimitiveUP(
			( D_D3DPRIMITIVETYPE )PrimitiveType,
			StartVertex,
			UseVertexNum,
			PrimitiveCount,
			( BYTE * )IndexBuffer->Buffer + StartIndex * IndexBuffer->UnitSize,
			IndexFormat, 
			( BYTE * )VertexBuffer->Buffer + BaseVertex * VertexBuffer->UnitSize,
			VertexBuffer->UnitSize ) ;
	}

	// I
	return 0 ;
}


#ifndef DX_NON_FILTER


// 摜ɃtB^[s
extern int NS_GraphFilter( int GrHandle, int FilterType /* DX_GRAPH_FILTER_GAUSS_H  */ , ... )
{
	int Result ;
	va_list VaList ;
	int W, H ;

	va_start( VaList, FilterType ) ;

	NS_GetGraphSize( GrHandle, &W, &H ) ;

	Result = GraphFilterRectBltBase( FALSE, GrHandle, -1, GrHandle, 0, FilterType, 0, 0, W, H, 0, 0, FALSE, 0, 0, VaList ) ;

	va_end( VaList ) ;

	return Result ;
}

// 摜̃tB^[t]s
extern int NS_GraphFilterBlt( int SrcGrHandle, int DestGrHandle, int FilterType, ... )
{
	int Result ;
	va_list VaList ;
	int SrcW, SrcH ;

	va_start( VaList, FilterType ) ;

	NS_GetGraphSize( SrcGrHandle, &SrcW, &SrcH ) ;

	Result = GraphFilterRectBltBase( FALSE, SrcGrHandle, -1, DestGrHandle, 0, FilterType, 0, 0, SrcW, SrcH, 0, 0, FALSE, 0, 0, VaList ) ;

	va_end( VaList ) ;

	return Result ;
}

// 摜̃tB^[t]s( `w )
extern int NS_GraphFilterRectBlt( int SrcGrHandle, int DestGrHandle, int SrcX1, int SrcY1, int SrcX2, int SrcY2, int DestX, int DestY, int FilterType, ... )
{
	int Result ;
	va_list VaList ;

	va_start( VaList, FilterType ) ;

	Result = GraphFilterRectBltBase( FALSE, SrcGrHandle, -1, DestGrHandle, 0, FilterType, SrcX1, SrcY1, SrcX2, SrcY2, 0, 0, FALSE, DestX, DestY, VaList ) ;

	va_end( VaList ) ;

	return Result ;
}

// ̉摜uh
extern	int	NS_GraphBlend( int GrHandle, int BlendGrHandle, int BlendRatio, int BlendType, ... )
{
	int Result ;
	va_list VaList ;
	int W, H ;

	va_start( VaList, BlendType ) ;

	NS_GetGraphSize( GrHandle, &W, &H ) ;

	Result = GraphFilterRectBltBase( TRUE, GrHandle, BlendGrHandle, GrHandle, BlendRatio, BlendType, 0, 0, W, H, 0, 0, FALSE, 0, 0, VaList ) ;

	va_end( VaList ) ;

	return Result ;
}

// ̉摜uhČʂw̉摜ɏo͂
extern	int	NS_GraphBlendBlt( int SrcGrHandle, int BlendGrHandle, int DestGrHandle, int BlendRatio, int BlendType, ... )
{
	int Result ;
	va_list VaList ;
	int SrcW, SrcH ;

	va_start( VaList, BlendType ) ;

	NS_GetGraphSize( SrcGrHandle, &SrcW, &SrcH ) ;

	Result = GraphFilterRectBltBase( TRUE, SrcGrHandle, BlendGrHandle, DestGrHandle, BlendRatio, BlendType, 0, 0, SrcW, SrcH, 0, 0, FALSE, 0, 0, VaList ) ;

	va_end( VaList ) ;

	return Result ;
}

// ̉摜uhČʂw̉摜ɏo͂( `w )
extern	int	NS_GraphBlendRectBlt( int SrcGrHandle, int BlendGrHandle, int DestGrHandle, int SrcX1, int SrcY1, int SrcX2, int SrcY2, int BlendX, int BlendY, int DestX, int DestY, int BlendRatio, int BlendType, ... )
{
	int Result ;
	va_list VaList ;

	va_start( VaList, BlendType ) ;

	Result = GraphFilterRectBltBase( TRUE, SrcGrHandle, BlendGrHandle, DestGrHandle, BlendRatio, BlendType, SrcX1, SrcY1, SrcX2, SrcY2, BlendX, BlendY, TRUE, DestX, DestY, VaList ) ;

	va_end( VaList ) ;

	return Result ;
}


static int GraphFilterDestGraphSetup( GRAPHFILTER_INFO *Info, int PassNum, int UseWorkScreen, int *UseSrcGrHandle, int *UseDestGrHandle )
{
	IMAGEDATA2 *SrcImage2 ;
	IMAGEDATA2 *DestImage2 ;
	IMAGEDATA2 *TempSrcImage2 = NULL ;
	int TexSizeW ;
	int TexSizeH ;
	int SrcEqDestOrDestNonDrawValidHandle ;
	int AlwaysUseDestWorkHandle ;
	int UseDestWorkHandleIndex ;
	int UseSrcWorkHandleIndex ;
	int SrcGraphDivFlag ;

	if( GRAPHCHK( Info->SrcGrHandle, SrcImage2 ) )
		return -1 ;

	if( GRAPHCHK( Info->DestGrHandle, DestImage2 ) )
		return -1 ;

	UseSrcWorkHandleIndex = 0 ;

	// VF[_[gȂꍇ͍Ɨp摜͎gpȂ
	if( GRH.UseShader == FALSE )
	{
		*UseDestGrHandle = Info->DestGrHandle ;
	}
	else
	{
		if( ( UseWorkScreen == 1 && Info->SrcGrHandle == Info->DestGrHandle ) ||
			DestImage2->Orig->FormatDesc.DrawValidFlag == FALSE )
		{
			SrcEqDestOrDestNonDrawValidHandle = TRUE ;
		}
		else
		{
			SrcEqDestOrDestNonDrawValidHandle = FALSE ;
		}

		if( UseWorkScreen == 1 &&
			( ( Info->Pass % 2 == 0 && PassNum % 2 == 0 ) ||
			  ( Info->Pass % 2 == 1 && PassNum % 2 == 1 ) ) )
		{
			AlwaysUseDestWorkHandle = TRUE ;
		}
		else
		{
			AlwaysUseDestWorkHandle = FALSE ;
		}

		if(
			Info->Pass == 0 &&
			(
			  SrcImage2->Hard.DrawNum != 1 ||
			  SrcImage2->Hard.Draw[ 0 ].UsePosX != 0 ||
			  SrcImage2->Hard.Draw[ 0 ].UsePosY != 0
			)
		  )
		{
			SrcGraphDivFlag = TRUE ;
		}
		else
		{
			SrcGraphDivFlag = FALSE ;
		}

		if( SrcEqDestOrDestNonDrawValidHandle || AlwaysUseDestWorkHandle )
		{
			if( AlwaysUseDestWorkHandle == FALSE && SrcEqDestOrDestNonDrawValidHandle == TRUE )
			{
				UseDestWorkHandleIndex = 1 ;
				UseSrcWorkHandleIndex = 0 ;
			}
			else
			{
				UseDestWorkHandleIndex = 0 ;
				UseSrcWorkHandleIndex = 1 ;
			}

			if( SrcGraphDivFlag )
			{
				TexSizeW = SrcImage2->Width ;
				TexSizeH = SrcImage2->Height ;
			}
			else
			{
				NS_GetGraphTextureSize( Info->SrcGrHandle, &TexSizeW, &TexSizeH ) ;
			}

			*UseDestGrHandle = GetWorkTexture( ( DWORD )TexSizeW, ( DWORD )TexSizeH, ( DWORD )UseDestWorkHandleIndex ) ;
			if( *UseDestGrHandle < 0 )
				return -1 ;
		}
		else
		{
			*UseDestGrHandle = Info->DestGrHandle ;
		}

		if( SrcGraphDivFlag )
		{
			VERTEX_2D Vert[ 4 ] ;
			IMAGEDATA2_HARD_VERT *TexVect ;
			int i ;

			TexSizeW = SrcImage2->Width ;
			TexSizeH = SrcImage2->Height ;

			*UseSrcGrHandle = GetWorkTexture( ( DWORD )TexSizeW, ( DWORD )TexSizeH, ( DWORD )UseSrcWorkHandleIndex ) ;
			if( *UseSrcGrHandle < 0 )
				return -1 ;

			GRAPHCHK( *UseSrcGrHandle, TempSrcImage2 ) ;
			SetRenderTargetHardware( TempSrcImage2->Hard.Draw[ 0 ].Tex->Surface[ 0 ] ) ;

			Vert[ 0 ].rhw = 1.0f ;
			Vert[ 1 ].rhw = 1.0f ;
			Vert[ 2 ].rhw = 1.0f ;
			Vert[ 3 ].rhw = 1.0f ;
			Vert[ 0 ].color = 0xffffffff ;
			Vert[ 1 ].color = 0xffffffff ;
			Vert[ 2 ].color = 0xffffffff ;
			Vert[ 3 ].color = 0xffffffff ;
			for( i = 0 ; i < SrcImage2->Hard.DrawNum ; i ++ )
			{
				TexVect = SrcImage2->Hard.Draw[ i ].Vertex ;

				Vert[ 0 ].pos.x = TexVect[ 0 ].x - 0.5f ;
				Vert[ 0 ].pos.y = TexVect[ 0 ].y - 0.5f ;
				Vert[ 0 ].pos.z = 0.0f ;
				Vert[ 0 ].u = TexVect[ 0 ].u ;
				Vert[ 0 ].v = TexVect[ 0 ].v ;
				Vert[ 1 ].pos.x = TexVect[ 1 ].x - 0.5f ;
				Vert[ 1 ].pos.y = TexVect[ 1 ].y - 0.5f ;
				Vert[ 1 ].pos.z = 0.0f ;
				Vert[ 1 ].u = TexVect[ 1 ].u ;
				Vert[ 1 ].v = TexVect[ 1 ].v ;
				Vert[ 2 ].pos.x = TexVect[ 2 ].x - 0.5f ;
				Vert[ 2 ].pos.y = TexVect[ 2 ].y - 0.5f ;
				Vert[ 2 ].u = TexVect[ 2 ].u ;
				Vert[ 2 ].v = TexVect[ 2 ].v ;
				Vert[ 2 ].pos.z = 0.0f ;
				Vert[ 3 ].pos.x = TexVect[ 3 ].x - 0.5f ;
				Vert[ 3 ].pos.y = TexVect[ 3 ].y - 0.5f ;
				Vert[ 3 ].pos.z = 0.0f ;
				Vert[ 3 ].u = TexVect[ 3 ].u ;
				Vert[ 3 ].v = TexVect[ 3 ].v ;
				DrawPrimitive2DHardware( Vert, 4, DX_PRIMTYPE_TRIANGLESTRIP, SrcImage2, TRUE, FALSE, FALSE, FALSE, i ) ;
			}
		}
	}

	return 0 ;
}

static int GraphFilterDestGraphUpdate( GRAPHFILTER_INFO *Info, int UseWorkScreen, int UseDestGrHandle, int FilterResult )
{
	if( FilterResult >= 0 )
	{
		if( GRH.UseShader == TRUE )
		{
			if( ( UseWorkScreen == 1 && Info->SrcGrHandle == Info->DestGrHandle ) ||
				UseDestGrHandle != Info->DestGrHandle )
			{
				GetDrawScreenGraphBase( UseDestGrHandle, 0, Info->DestX, Info->DestY, Info->DestX + Info->SrcX2 - Info->SrcX1, Info->DestY + Info->SrcY2 - Info->SrcY1, Info->DestX, Info->DestY, Info->DestGrHandle ) ;
			}
		}
	}

	return 0 ;
}

static int	GraphFilter_BasePolygonDraw( GRAPHFILTER_INFO *Info, int ScaleDivNum )
{
	VERTEX2DSHADER Vert[ 4 ] ;
	IMAGEDATA2 *SrcImage2 ;
	IMAGEDATA2 *BlendImage2 ;
	IMAGEDATA2 *DestImage2 ;
	float SrcX1F, SrcX2F, SrcY1F, SrcY2F ;
	float SrcX1TexF, SrcX2TexF, SrcY1TexF, SrcY2TexF ;
	int SrcWidth, SrcHeight ;
	float DestX1F, DestX2F, DestY1F, DestY2F ;
	float BlendX1TexF, BlendX2TexF, BlendY1TexF, BlendY2TexF ;

	if( GRAPHCHK( Info->SrcGrHandle, SrcImage2 ) )
		return -1 ;

	if( GRAPHCHK( Info->DestGrHandle, DestImage2 ) )
		return -1 ;

	SetRenderTargetHardware( CheckMultiSampleDrawValidGraph( Info->DestGrHandle ) ?
								DestImage2->Hard.Draw[ 0 ].Tex->RenderTargetSurface :
								DestImage2->Hard.Draw[ 0 ].Tex->Surface[ 0 ] ) ;

	SrcX1F = ( float )Info->SrcX1 ;
	SrcX2F = ( float )Info->SrcX2 ;
	SrcY1F = ( float )Info->SrcY1 ;
	SrcY2F = ( float )Info->SrcY2 ;
	SrcWidth  = Info->SrcX2 - Info->SrcX1 ;
	SrcHeight = Info->SrcY2 - Info->SrcY1 ;

	if( ScaleDivNum != 1 )
	{
		DestX1F = ( float )  Info->DestX                             - 0.5f ;
		DestX2F = ( float )( Info->DestX + SrcWidth  / ScaleDivNum ) - 0.5f ;
		DestY1F = ( float )  Info->DestY                             - 0.5f ;
		DestY2F = ( float )( Info->DestY + SrcHeight / ScaleDivNum ) - 0.5f ;
	}
	else
	{
		DestX1F = ( float )  Info->DestX               - 0.5f ;
		DestX2F = ( float )( Info->DestX + SrcWidth  ) - 0.5f ;
		DestY1F = ( float )  Info->DestY               - 0.5f ;
		DestY2F = ( float )( Info->DestY + SrcHeight ) - 0.5f ;
	}

	SrcX1TexF = SrcX1F / SrcImage2->Orig->Hard.Tex[ 0 ].TexWidth ;
	SrcX2TexF = SrcX2F / SrcImage2->Orig->Hard.Tex[ 0 ].TexWidth ;
	SrcY1TexF = SrcY1F / SrcImage2->Orig->Hard.Tex[ 0 ].TexHeight ;
	SrcY2TexF = SrcY2F / SrcImage2->Orig->Hard.Tex[ 0 ].TexHeight ;

	Vert[ 0 ].pos = VGet( DestX1F, DestY1F, 0.0f ) ;
	Vert[ 1 ].pos = VGet( DestX2F, DestY1F, 0.0f ) ;
	Vert[ 2 ].pos = VGet( DestX1F, DestY2F, 0.0f ) ;
	Vert[ 3 ].pos = VGet( DestX2F, DestY2F, 0.0f ) ;
	Vert[ 0 ].u = SrcX1TexF ; Vert[ 0 ].v = SrcY1TexF ;
	Vert[ 1 ].u = SrcX2TexF ; Vert[ 1 ].v = SrcY1TexF ;
	Vert[ 2 ].u = SrcX1TexF ; Vert[ 2 ].v = SrcY2TexF ;
	Vert[ 3 ].u = SrcX2TexF ; Vert[ 3 ].v = SrcY2TexF ;
	Vert[ 0 ].rhw = 1.0f ;
	Vert[ 1 ].rhw = 1.0f ;
	Vert[ 2 ].rhw = 1.0f ;
	Vert[ 3 ].rhw = 1.0f ;

	if( Info->IsBlend )
	{
		if( GRAPHCHK( Info->BlendGrHandle, BlendImage2 ) )
			return -1 ;

		if( Info->BlendPosEnable )
		{
			BlendX1TexF = ( float )  Info->BlendX               / BlendImage2->Orig->Hard.Tex[ 0 ].TexWidth ;
			BlendX2TexF = ( float )( Info->BlendX + SrcWidth )  / BlendImage2->Orig->Hard.Tex[ 0 ].TexWidth ;
			BlendY1TexF = ( float )  Info->BlendY               / BlendImage2->Orig->Hard.Tex[ 0 ].TexHeight ;
			BlendY2TexF = ( float )( Info->BlendY + SrcHeight ) / BlendImage2->Orig->Hard.Tex[ 0 ].TexHeight ;
		}
		else
		{
			BlendX1TexF = BlendImage2->Hard.Draw[ 0 ].Vertex[ 0 ].u ;
			BlendX2TexF = BlendImage2->Hard.Draw[ 0 ].Vertex[ 1 ].u ;
			BlendY1TexF = BlendImage2->Hard.Draw[ 0 ].Vertex[ 0 ].v ;
			BlendY2TexF = BlendImage2->Hard.Draw[ 0 ].Vertex[ 2 ].v ;
		}
		Vert[ 0 ].su = BlendX1TexF ; Vert[ 0 ].sv = BlendY1TexF ;
		Vert[ 1 ].su = BlendX2TexF ; Vert[ 1 ].sv = BlendY1TexF ;
		Vert[ 2 ].su = BlendX1TexF ; Vert[ 2 ].sv = BlendY2TexF ;
		Vert[ 3 ].su = BlendX2TexF ; Vert[ 3 ].sv = BlendY2TexF ;

		NS_SetUseTextureToShader( 1, Info->BlendGrHandle ) ;
	}

	NS_SetUseTextureToShader( 0, Info->SrcGrHandle ) ;

	// `̏
	RenderVertexHardware() ;
	BeginScene() ;
	DrawPreparationToShader( 0, FALSE, TRUE, TRUE ) ;

	// `
	SETFVF( VERTEXFVF_SHADER_2D )
	GraphicsDevice_DrawPrimitiveUP( ( D_D3DPRIMITIVETYPE )DX_PRIMTYPE_TRIANGLESTRIP, GETPRIMNUM( DX_PRIMTYPE_TRIANGLESTRIP, 4 ), Vert, sizeof( VERTEX2DSHADER ) ) ;

	if( CheckMultiSampleDrawValidGraph( Info->DestGrHandle ) )
	{
		EndScene() ;
		UpdateDrawTexture( DestImage2->Hard.Draw[ 0 ].Tex, 0 ) ;
	}

	// I
	return 0 ;
}

static int GraphFilter_GetSoftImage( int GrHandle, BASEIMAGE *BaseImage, RECT *GetRect )
{
	RECT TempRect ;
	int Width, Height ;
	BASEIMAGE SurfaceImage ;
	IMAGEDATA2 *Image2 ;
	IMAGEDATA2_HARD_DRAW *HardDraw ;
	RECT SrcRect ;
	RECT DestRect ;
	int i ;
	int temp ;

	if( GRAPHCHK( GrHandle, Image2 ) )
		return -1 ;

	if( GetRect == NULL )
	{
		NS_GetGraphSize( GrHandle, &Width, &Height ) ;

		TempRect.left = 0 ;
		TempRect.right = Width ;
		TempRect.top = 0 ;
		TempRect.bottom = Height ;

		GetRect = &TempRect ;
	}
	else
	{
		Width = GetRect->right - GetRect->left ;
		Height = GetRect->bottom - GetRect->top ;
	}

	if( NS_CreateARGB8ColorBaseImage( Width, Height, BaseImage ) < 0 )
		return -1 ;

	if( Image2->Orig->FormatDesc.TextureFlag )
	{
		HardDraw = Image2->Hard.Draw ;
		for( i = 0 ; i < Image2->Hard.DrawNum ; i ++, HardDraw ++ )
		{
			SrcRect.left   = HardDraw->UsePosX ;
			SrcRect.right  = HardDraw->UsePosX + HardDraw->Width ;
			SrcRect.top    = HardDraw->UsePosY ;
			SrcRect.bottom = HardDraw->UsePosY + HardDraw->Height ;

			DestRect.left   = HardDraw->DrawPosX ;
			DestRect.right  = HardDraw->DrawPosX + HardDraw->Width ;
			DestRect.top    = HardDraw->DrawPosY ;
			DestRect.bottom = HardDraw->DrawPosY + HardDraw->Height ;

			if( DestRect.left   >= GetRect->right ||
				DestRect.right  <= GetRect->left ||
				DestRect.top    >= GetRect->bottom ||
				DestRect.bottom <= GetRect->top )
				continue ;

			if( DestRect.left < GetRect->left )
			{
				temp = GetRect->left - DestRect.left ;
				SrcRect.left += temp ;
				DestRect.left += temp ;
			}
			if( DestRect.right > GetRect->right )
			{
				temp = DestRect.right - GetRect->right ;
				SrcRect.right -= temp ;
				DestRect.right -= temp ;
			}
			if( DestRect.top < GetRect->top )
			{
				temp = GetRect->top - DestRect.top ;
				SrcRect.top += temp ;
				DestRect.top += temp ;
			}
			if( DestRect.bottom > GetRect->bottom )
			{
				temp = DestRect.bottom - GetRect->bottom ;
				SrcRect.bottom -= temp ;
				DestRect.bottom -= temp ;
			}

			if( LockDrawScreenBuffer( &SrcRect, &SurfaceImage, GrHandle, 0, TRUE, i ) < 0 )
			{
				NS_ReleaseBaseImage( BaseImage ) ;
				return -1 ;
			}

			NS_BltBaseImage( 0, 0, SrcRect.right - SrcRect.left, SrcRect.bottom - SrcRect.top, DestRect.left, DestRect.top, &SurfaceImage, BaseImage ) ;
			UnlockDrawScreenBuffer() ;
		}
	}
	else
	{
		if( LockDrawScreenBuffer( GetRect, &SurfaceImage, GrHandle, 0, TRUE, 0 ) < 0 )
		{
			NS_ReleaseBaseImage( BaseImage ) ;
			return -1 ;
		}

		NS_BltBaseImage( 0, 0, Width, Height, 0, 0, &SurfaceImage, BaseImage ) ;
		UnlockDrawScreenBuffer() ;
	}


	// I
	return 0 ;
}

static int	GraphFilter_SoftImageSetup( GRAPHFILTER_INFO *Info, int DestDiscard, int DestWidth, int DestHeight )
{
	RECT Rect ;
	int SrcWidth ;
	int SrcHeight ;

	SrcWidth = Info->SrcX2 - Info->SrcX1 ;
	SrcHeight = Info->SrcY2 - Info->SrcY1 ;

	if( DestWidth < 0 || DestHeight < 0 )
	{
		DestWidth = SrcWidth ;
		DestHeight = SrcHeight ;
	}
	Info->DestWidth = DestWidth ;
	Info->DestHeight = DestHeight ;

	Info->SrcImage.GraphData = NULL ;
	Info->BlendImage.GraphData = NULL ;
	Info->DestImage.GraphData = NULL ;

	Rect.left   = Info->SrcX1 ;
	Rect.right  = Info->SrcX2 ;
	Rect.top    = Info->SrcY1 ;
	Rect.bottom = Info->SrcY2 ;

	if( GraphFilter_GetSoftImage( Info->SrcGrHandle, &Info->SrcImage, &Rect ) < 0 )
		goto ERR ;

	if( Info->IsBlend )
	{
		if( GraphFilter_GetSoftImage( Info->BlendGrHandle, &Info->BlendImage, &Rect ) < 0 )
			goto ERR ;
	}

	if( DestDiscard )
	{
		if( NS_CreateARGB8ColorBaseImage( Info->DestWidth, Info->DestHeight, &Info->DestImage ) < 0 )
			goto ERR ;
	}
	else
	{
		Rect.left   = Info->DestX ;
		Rect.right  = Info->DestX + Info->DestWidth ;
		Rect.top    = Info->DestY ;
		Rect.bottom = Info->DestY + Info->DestHeight ;
		if( GraphFilter_GetSoftImage( Info->DestGrHandle, &Info->DestImage, &Rect ) < 0 )
			goto ERR ;
	}

	// I
	return 0 ;

ERR :
	if( Info->SrcImage.GraphData )
		NS_ReleaseBaseImage( &Info->SrcImage ) ;

	if( Info->BlendImage.GraphData )
		NS_ReleaseBaseImage( &Info->BlendImage ) ;

	if( Info->DestImage.GraphData )
		NS_ReleaseBaseImage( &Info->DestImage ) ;

	return -1 ;
}

static int	GraphFilter_SoftImageTerminate( GRAPHFILTER_INFO *Info )
{
	if( Info->SrcImage.GraphData )
		NS_ReleaseBaseImage( &Info->SrcImage ) ;

	if( Info->BlendImage.GraphData )
		NS_ReleaseBaseImage( &Info->BlendImage ) ;

	if( Info->DestImage.GraphData )
	{
		RECT Rect ;

		Rect.left   = 0 ;
		Rect.top    = 0 ;
		Rect.right  = Info->DestWidth ;
		Rect.bottom = Info->DestHeight ;
		BltBmpOrBaseImageToGraph3( NULL, NULL, NULL, &Rect, Info->DestX, Info->DestY, Info->DestGrHandle, FALSE, &Info->DestImage, NULL, FALSE, FALSE, FALSE ) ;
/*
		if( Info->UseTempDestImage )
		{
			if( Info->TempDestImage.GraphData )
			{
				NS_BltBaseImage( 0, 0, Info->DestWidth, Info->DestHeight, 0, 0, &Info->TempDestImage, &Info->DestImage ) ;
			}
		}

		UnlockDrawScreenBuffer() ;
*/
	}

	if( Info->DestImage.GraphData )
		NS_ReleaseBaseImage( &Info->DestImage ) ;

	return 0 ;
}

// 摜̃tB^[t]s( ψt )
extern int GraphFilterRectBltBase( int IsBlend, int SrcGrHandle, int BlendGrHandle, int DestGrHandle, int BlendRatio, int FilterOrBlendType, int SrcX1, int SrcY1, int SrcX2, int SrcY2, int BlendX, int BlendY, int BlendPosEnable, int DestX, int DestY, va_list ParamList )
{
	LIBSHADER_DRAWPARAMTEMP DrawParamTemp ;
	IMAGEDATA2 *SrcImage2 ;
	IMAGEDATA2 *DestImage2 ;
	IMAGEDATA2 *BlendImage2 = NULL ;
	IMAGEDATA2 *TargetScreenImage2 ;
	int UseDestGrHandle = -1 ;
	int UseSrcGrHandle ;
	int Width, Height ;
	int FilterResult = -1 ;
	int Pass ;
	int PassNum = -1 ;
	int UseWorkScreen ;
	GRAPHFILTER_INFO Info ;
	float BlendRatioF ;
	int Down_Scale_DivNum = 0 ;

	// G[
	if( GRAPHCHK( SrcGrHandle, SrcImage2 ) )
		return -1 ;

	if( GRAPHCHK( DestGrHandle, DestImage2 ) )
		return -1 ;

	TargetScreenImage2 = NULL ;
	if( CheckMultiSampleDrawValidGraph( GBASE.TargetScreen[ 0 ] ) )
	{
		if( GRAPHCHK( GBASE.TargetScreen[ 0 ], TargetScreenImage2 ) )
			TargetScreenImage2 = NULL ;
	}

	if( SrcX2 <= SrcX1 ||
		SrcY2 <= SrcY1 ) return -1 ;

	if( IsBlend )
	{
		if( GRAPHCHK( BlendGrHandle, BlendImage2 ) )
			return -1 ;

		if( FilterOrBlendType < 0 || FilterOrBlendType >= DX_GRAPH_BLEND_NUM )
			return -1;
	}
	else
	{
		if( FilterOrBlendType < 0 || FilterOrBlendType >= DX_GRAPH_FILTER_NUM )
			return -1;
	}

	// l̕␳
	if( BlendRatio < 0 )
	{
		BlendRatio = 0 ;
	}
	else
	if( BlendRatio > 255 )
	{
		BlendRatio = 255 ;
	}
	BlendRatioF = BlendRatio / 255.0f ;

	// W̕␳
	if( SrcX1 < 0 )
	{
		DestX += -SrcX1 ;
		BlendX += -SrcX1 ;
		SrcX1 = 0 ;
	}
	if( SrcY1 < 0 )
	{
		DestY += -SrcY1 ;
		BlendY += -SrcY1 ;
		SrcY1 = 0 ;
	}
	if( DestX < 0 )
	{
		SrcX1 += -DestX ;
		BlendX += -DestX ;
		DestX = 0 ;
	}
	if( DestY < 0 )
	{
		SrcY1 += -DestY ;
		BlendY += -DestY ;
		DestY = 0 ;
	}
	if( SrcX2 <= SrcX1 ||
		SrcY2 <= SrcY1 ) return 0 ;
	if( SrcX2 > SrcImage2->Width )
	{
		SrcX2 = SrcImage2->Width ;
	}
	if( SrcY2 > SrcImage2->Height )
	{
		SrcY2 = SrcImage2->Height ;
	}
	if( SrcX1 >= SrcImage2->Width ||
		SrcY1 >= SrcImage2->Height ||
		SrcX2 <= 0 ||
		SrcY2 <= 0 ||
		DestX >= DestImage2->Width ||
		DestY >= DestImage2->Height )
		return 0 ;

	Width = SrcX2 - SrcX1 ;
	Height = SrcY2 - SrcY1 ;
	if( Width <= 0 ||
		Height <= 0 )
		return 0 ;

	if( IsBlend == FALSE && FilterOrBlendType == DX_GRAPH_FILTER_DOWN_SCALE )
	{
		Down_Scale_DivNum = va_arg( ParamList, int ) ;

		if( DestX + Width / Down_Scale_DivNum > DestImage2->Width )
		{
			Width = ( DestImage2->Width - DestX ) * Down_Scale_DivNum ;
			SrcX2 = SrcX1 + Width ;
		}
		if( DestY + Height / Down_Scale_DivNum > DestImage2->Height )
		{
			Height = ( DestImage2->Height - DestY ) * Down_Scale_DivNum ;
			SrcY2 = SrcY1 + Height ;
		}
	}
	else
	{
		if( DestX + Width > DestImage2->Width )
		{
			Width = DestImage2->Width - DestX ;
			SrcX2 = SrcX1 + Width ;
		}
		if( DestY + Height > DestImage2->Height )
		{
			Height = DestImage2->Height - DestY ;
			SrcY2 = SrcY1 + Height ;
		}
	}
	if( Width <= 0 ||
		Height <= 0 )
		return 0 ;
	
	// `悪_O^[Qbgp̃T[tFXgpĂāA`̉摜uhŎgꍇ͂ŃT[tFXAbvf[g
	if( TargetScreenImage2 != NULL &&
		( GBASE.TargetScreen[ 0 ] == SrcGrHandle ||
		  GBASE.TargetScreen[ 0 ] == DestGrHandle ||
		  ( IsBlend && GBASE.TargetScreen[ 0 ] == BlendGrHandle ) ) )
	{
		EndScene() ;
		UpdateDrawTexture( &TargetScreenImage2->Orig->Hard.Tex[ 0 ], GBASE.TargetScreenSurface[ 0 ] ) ;
	}

	// ̃Zbg
	Info.IsBlend = IsBlend ;
	Info.FilterOrBlendType = FilterOrBlendType ;
	Info.BlendGrHandle = BlendGrHandle ;
	Info.BlendRatio = BlendRatioF ;
	Info.SrcX1 = SrcX1 ;
	Info.SrcY1 = SrcY1 ;
	Info.SrcX2 = SrcX2 ;
	Info.SrcY2 = SrcY2 ;
	Info.BlendX = BlendX ;
	Info.BlendY = BlendY ;
	Info.BlendPosEnable = BlendPosEnable ;
	Info.DestX = DestX ;
	Info.DestY = DestY ;

	// tB^[̈擾
	int			Gauss_PixelWidth = 0 ;
	float		Gauss_Param = 0.0f ;
	int			Bright_Clip_CmpType = 0 ;
	float		Bright_Clip_CmpParam = 0.0f ;
	int			Bright_Clip_ClipFillFlag = 0 ;
	COLOR_F		Bright_Clip_ClipFillColor = { 0.0f } ;
	int			Hsb_HueType = 0 ;
	float		Hsb_Hue = 0.0f ;
	float		Hsb_Saturation = 0.0f ;
	float		Hsb_Bright = 0.0f ;
	float		Mono_Cb = 0.0f ;
	float		Mono_Cr = 0.0f ;
	float		Lv_Min = 0.0f ;
	float		Lv_Max = 0.0f ;
	float		Lv_Gamma = 0.0f ;
	float		Lv_AfterMin = 0.0f ;
	float		Lv_AfterMax = 0.0f ;
	float		TC_Threshold = 0.0f ;
	COLOR_F		TC_LowColor = { 0.0f } ;
	COLOR_F		TC_HighColor = { 0.0f } ;
	int			GM_MapGrHandle = 0 ;
	int			GM_Reverse = 0 ;

	int			TempR = 0, TempG = 0, TempB = 0, TempA = 0 ;

	int			RGBA_R = 0 ;
	int			RGBA_G = 0 ;
	int			RGBA_B = 0 ;
	int			RGBA_A = 0 ;
	if( IsBlend )
	{
		switch( FilterOrBlendType )
		{
		case DX_GRAPH_BLEND_RGBA_SELECT_MIX :
			RGBA_R = va_arg( ParamList, int ) ;
			RGBA_G = va_arg( ParamList, int ) ;
			RGBA_B = va_arg( ParamList, int ) ;
			RGBA_A = va_arg( ParamList, int ) ;
			break ;
		}

		// pX̐擾
		if( PassNum == -1 )
		{
			PassNum = GraphBlendPassNum_Table[ FilterOrBlendType ] ;
		}

		// ƗpeNX`gp邩ǂ擾
		UseWorkScreen = GraphBlendUseWorkScreen_Table[ FilterOrBlendType ] ;
	}
	else
	{
		switch( FilterOrBlendType )
		{
		case DX_GRAPH_FILTER_MONO :
			Mono_Cb = ( float )va_arg( ParamList, int ) * 100.0f / 255.0f ;
			Mono_Cr = ( float )va_arg( ParamList, int ) * 100.0f / 255.0f ;
			break ;

		case DX_GRAPH_FILTER_GAUSS :
			Gauss_PixelWidth = va_arg( ParamList, int ) ;
			Gauss_Param = ( float )va_arg( ParamList, int ) / 100.0f ;
			break ;

		case DX_GRAPH_FILTER_DOWN_SCALE :
//			Down_Scale_DivNum = va_arg( ParamList, int ) ;
			break ;

		case DX_GRAPH_FILTER_BRIGHT_CLIP :
			Bright_Clip_CmpType = va_arg( ParamList, int ) ;
			Bright_Clip_CmpParam = ( float )va_arg( ParamList, int ) ;
			Bright_Clip_ClipFillFlag = va_arg( ParamList, int ) ;
			if( Bright_Clip_ClipFillFlag )
			{
				NS_GetColor2( va_arg( ParamList, int ), &TempR, &TempG, &TempB ) ;
				TempA = va_arg( ParamList, int ) ;
				Bright_Clip_ClipFillColor = NS_GetColorF( TempR / 255.0f, TempG / 255.0f, TempB / 255.0f, TempA / 255.0f ) ;
			}
			break ;

		case DX_GRAPH_FILTER_HSB :
			Hsb_HueType = va_arg( ParamList, int ) ;
			Hsb_Hue = ( float )va_arg( ParamList, int ) ;
			Hsb_Saturation = ( float )va_arg( ParamList, int ) * 100.0f / 255.0f ;
			Hsb_Bright  = ( float )va_arg( ParamList, int ) * 100.0f / 255.0f ;

			if( Hsb_HueType == 1 )
			{
				PassNum = 1 ;
			}
			break ;

		case DX_GRAPH_FILTER_LEVEL :
			Lv_Min = ( float )va_arg( ParamList, int ) ;
			Lv_Max = ( float )va_arg( ParamList, int ) ;
			Lv_Gamma = ( float )va_arg( ParamList, int ) / 100.0f ;
			Lv_AfterMin = ( float )va_arg( ParamList, int ) ;
			Lv_AfterMax = ( float )va_arg( ParamList, int ) ;
			break ;

		case DX_GRAPH_FILTER_TWO_COLOR :
			TC_Threshold = ( float )va_arg( ParamList, int ) ;

			NS_GetColor2( va_arg( ParamList, int ), &TempR, &TempG, &TempB ) ;
			TempA = va_arg( ParamList, int ) ;
			TC_LowColor = NS_GetColorF( TempR / 255.0f, TempG / 255.0f, TempB / 255.0f, TempA / 255.0f ) ;

			NS_GetColor2( va_arg( ParamList, int ), &TempR, &TempG, &TempB ) ;
			TempA = va_arg( ParamList, int ) ;
			TC_HighColor = NS_GetColorF( TempR / 255.0f, TempG / 255.0f, TempB / 255.0f, TempA / 255.0f ) ;
			break ;

		case DX_GRAPH_FILTER_GRADIENT_MAP :
			GM_MapGrHandle = va_arg( ParamList, int ) ;
			GM_Reverse = va_arg( ParamList, int ) ;

			if( TargetScreenImage2 != NULL && GM_MapGrHandle == GBASE.TargetScreen[ 0 ] )
			{
				EndScene() ;
				UpdateDrawTexture( &TargetScreenImage2->Orig->Hard.Tex[ 0 ], GBASE.TargetScreenSurface[ 0 ] ) ;
			}
			break ;

		case DX_GRAPH_FILTER_PREMUL_ALPHA :
			break ;

		case DX_GRAPH_FILTER_INTERP_ALPHA :
			break ;
		}

		// pX̐擾
		if( PassNum == -1 )
		{
			PassNum = GraphFilterPassNum_Table[ FilterOrBlendType ] ;
		}

		// ƗpeNX`gp邩ǂ擾
		UseWorkScreen = GraphFilterUseWorkScreen_Table[ FilterOrBlendType ] ;
	}
	if( SrcX1 != DestX || SrcY1 != DestY || GRH.ValidRenderTargetInputTexture == FALSE )
	{
		UseWorkScreen = 1 ;
	}

	// VF[_[gȂꍇ͕KPpXŏI
	if( GRH.UseShader == FALSE )
	{
		PassNum = 1 ;
	}

	if( GRH.BeginSceneFlag == FALSE ) BeginScene() ;

	// p[^̕ۑ
	LibShader_PushBaseDrawParam( &DrawParamTemp ) ;

	// [v̊Jn
	UseSrcGrHandle = SrcGrHandle ;
	for( Pass = 0 ; Pass < PassNum ; Pass ++ )
	{
		Info.Pass = Pass ;

		// o͐̃ZbgAbv
		Info.SrcGrHandle = SrcGrHandle ;
		Info.DestGrHandle = DestGrHandle ;
		if( GraphFilterDestGraphSetup( &Info, PassNum, UseWorkScreen, &UseSrcGrHandle, &UseDestGrHandle ) < 0 )
			break ;

		if( GRAPHCHK( UseDestGrHandle, DestImage2 ) )
			break ;

		// ̃Zbg
		Info.SrcGrHandle = UseSrcGrHandle ;
		Info.DestGrHandle = UseDestGrHandle ;

		if( IsBlend )
		{
			// uh^Cvɂď𕪊
			switch( FilterOrBlendType )
			{
			case DX_GRAPH_BLEND_RGBA_SELECT_MIX :
				FilterResult = GraphBlend_RGBA_Select_Mix( &Info, RGBA_R, RGBA_G, RGBA_B, RGBA_A ) ; 
				break ;

			case DX_GRAPH_BLEND_NORMAL :
			case DX_GRAPH_BLEND_MULTIPLE :
			case DX_GRAPH_BLEND_DIFFERENCE :
			case DX_GRAPH_BLEND_ADD :
			case DX_GRAPH_BLEND_SCREEN :
			case DX_GRAPH_BLEND_OVERLAY :
			case DX_GRAPH_BLEND_DODGE :
			case DX_GRAPH_BLEND_BURN :
			case DX_GRAPH_BLEND_DARKEN :
			case DX_GRAPH_BLEND_LIGHTEN :
			case DX_GRAPH_BLEND_SOFTLIGHT :
			case DX_GRAPH_BLEND_HARDLIGHT :
			case DX_GRAPH_BLEND_EXCLUSION :
			case DX_GRAPH_BLEND_NORMAL_ALPHACH :
			case DX_GRAPH_BLEND_ADD_ALPHACH :
			case DX_GRAPH_BLEND_MULTIPLE_A_ONLY :
				FilterResult = GraphBlend_Basic( &Info ) ;
				break ;
			}
		}
		else
		{
			// tB^[ɂď𕪊
			switch( FilterOrBlendType )
			{
			case DX_GRAPH_FILTER_MONO :
				FilterResult = GraphFilter_Mono( &Info, Mono_Cb, Mono_Cr ) ;
				break ;

			case DX_GRAPH_FILTER_GAUSS :
				FilterResult = GraphFilter_Gauss( &Info, Gauss_PixelWidth, Gauss_Param ) ; 
				break ;

			case DX_GRAPH_FILTER_DOWN_SCALE :
				FilterResult = GraphFilter_Down_Scale( &Info, Down_Scale_DivNum ) ;
				break ;

			case DX_GRAPH_FILTER_BRIGHT_CLIP :
				FilterResult = GraphFilter_Bright_Clip( &Info, Bright_Clip_CmpType, Bright_Clip_CmpParam, Bright_Clip_ClipFillFlag, &Bright_Clip_ClipFillColor ) ;
				break ;

			case DX_GRAPH_FILTER_HSB :
				FilterResult = GraphFilter_HSB( &Info, Hsb_HueType, Hsb_Hue, Hsb_Saturation, Hsb_Bright ) ;
				break ;

			case DX_GRAPH_FILTER_INVERT :
				FilterResult = GraphFilter_Invert( &Info ) ;
				break ;

			case DX_GRAPH_FILTER_LEVEL :
				FilterResult = GraphFilter_Level( &Info, Lv_Min, Lv_Max, Lv_Gamma, Lv_AfterMin, Lv_AfterMax ) ;
				break ;

			case DX_GRAPH_FILTER_TWO_COLOR :
				FilterResult = GraphFilter_TwoColor( &Info, TC_Threshold, &TC_LowColor, &TC_HighColor ) ;
				break ;

			case DX_GRAPH_FILTER_GRADIENT_MAP :
				FilterResult = GraphFilter_GradientMap( &Info, GM_MapGrHandle, GM_Reverse ) ;
				break ;

			case DX_GRAPH_FILTER_PREMUL_ALPHA :
				FilterResult = GraphFilter_PremulAlpha( &Info ) ;
				break ;

			case DX_GRAPH_FILTER_INTERP_ALPHA :
				FilterResult = GraphFilter_InterpAlpha( &Info ) ;
				break ;
			}
		}

		// o͌̕ύX
		UseSrcGrHandle = UseDestGrHandle ;
	}

	// p[^̕A
	LibShader_PopBaseDrawParam( &DrawParamTemp ) ;

	// o͐̍XV
	Info.SrcGrHandle = SrcGrHandle ;
	Info.DestGrHandle = DestGrHandle ;
	GraphFilterDestGraphUpdate( &Info, UseWorkScreen, UseDestGrHandle, FilterResult ) ;

	// I
	return Pass == PassNum ? 0 : -1 ;
}

static int GraphFilter_Mono( GRAPHFILTER_INFO *Info, float Cb, float Cr )
{
	// l␳
	Cb /= 200.0f ;
	if( Cb < -0.5f )
	{
		Cb = -0.5f ;
	}
	else
	if( Cb > 0.5f )
	{
		Cb = 0.5f ;
	}

	Cr /= 200.0f ;
	if( Cr < -0.5f )
	{
		Cr = -0.5f ;
	}
	else
	if( Cr > 0.5f )
	{
		Cr = 0.5f ;
	}

	// VF[_[g邩ǂŏ𕪊
	if( GRH.UseShader == TRUE )
	{
		static const char *PsoFileName[ 1 ] =
		{
			"Mono.pso",
		};
		LIBSHADER_DRAWPARAMTEMP DrawParamTemp ;
		FLOAT4 ParamF4[ 2 ] ;

		NS_SetDrawMode( DX_DRAWMODE_NEAREST ) ;

		// gpVF[_[̃ZbgAbv
		if( GRH.ShaderCode.MonoPS < 0 )
		{
			GRH.ShaderCode.MonoPS = MemLoadShaderCode( PsoFileName[ 0 ], false ) ;
			if( GRH.ShaderCode.MonoPS < 0 )
			{
				DXST_ERRORLOGFMT_ADD(( _T( "tB^[pVF[_[̍쐬Ɏs܂ %s" ), PsoFileName[ 0 ] )) ;
				return -1 ;
			}
			NS_SetDeleteHandleFlag( GRH.ShaderCode.MonoPS, &GRH.ShaderCode.MonoPS ) ;
		}

		LibShader_PushShaderParam( &DrawParamTemp, 1 ) ;

		ParamF4[ 0 ].x = 0.29900f ;
		ParamF4[ 0 ].y = 0.58700f ;
		ParamF4[ 0 ].z = 0.11400f ;
		ParamF4[ 0 ].w = 0.0f ;
		ParamF4[ 1 ].x = 1.40200f * Cr ;
		ParamF4[ 1 ].y = 0.34414f * Cb - 0.71414f * Cr ;
		ParamF4[ 1 ].z = 1.77200f * Cb ;
		ParamF4[ 1 ].w = 0.0f ;
		SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, ParamF4, 2, FALSE ) ;

		NS_SetUsePixelShader( GRH.ShaderCode.MonoPS ) ;

		GraphFilter_BasePolygonDraw( Info ) ;

		LibShader_PopShaderParam( &DrawParamTemp ) ;

		ResetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, 2 ) ;
	}
	else
	{
		// VF[_[gȂꍇ

		BYTE *Src ;
		BYTE *Dest ;
		DWORD i ;
		DWORD Width ;
		DWORD Height ;
		DWORD SrcAddPitch ;
		DWORD DestAddPitch ;
		int Y ;
		int RAdd ;
		int GAdd ;
		int BAdd ;
		int R, G, B ;

		RAdd = _FTOL( ( 1.40200f * Cr                 ) * 255.0f * 4096.0f ) ;
		GAdd = _FTOL( ( 0.34414f * Cb - 0.71414f * Cr ) * 255.0f * 4096.0f ) ;
		BAdd = _FTOL( ( 1.77200f * Cb                 ) * 255.0f * 4096.0f ) ;

		if( GraphFilter_SoftImageSetup( Info ) < 0 )
			return -1 ;

		Src = ( BYTE * )Info->SrcImage.GraphData ;
		Dest = ( BYTE * )Info->DestImage.GraphData ;

		Width  = Info->SrcX2 - Info->SrcX1 ;
		Height = Info->SrcY2 - Info->SrcY1 ;

		SrcAddPitch  = Info->SrcImage.Pitch  - Width * 4 ;
		DestAddPitch = Info->DestImage.Pitch - Width * 4 ;

		do
		{
			i = Width ;
			do
			{
				Y = Src[ 0 ] * ( int )( 0.114f * 4096.0f ) +
					Src[ 1 ] * ( int )( 0.587f * 4096.0f ) +
					Src[ 2 ] * ( int )( 0.299f * 4096.0f ) ;
				B = ( Y + BAdd ) >> 12 ;
				G = ( Y + GAdd ) >> 12 ;
				R = ( Y + RAdd ) >> 12 ;
				if( B < 0 ) B = 0 ; else if( B > 255 ) B = 255 ;
				if( G < 0 ) G = 0 ; else if( G > 255 ) G = 255 ;
				if( R < 0 ) R = 0 ; else if( R > 255 ) R = 255 ;

				Dest[ 0 ] = ( BYTE )B ;
				Dest[ 1 ] = ( BYTE )G ;
				Dest[ 2 ] = ( BYTE )R ;
				Dest[ 3 ] = Src[ 3 ] ;

				Src  += 4 ;
				Dest += 4 ;
			}while( -- i ) ;

			Src  += SrcAddPitch ;
			Dest += DestAddPitch ;
		}while( -- Height ) ;

		GraphFilter_SoftImageTerminate( Info ) ;
	}

	// I
	return 0 ;
}

static int GraphFilter_Gauss( GRAPHFILTER_INFO *Info, int PixelWidth, float Param )
{
	static int PrevPixelWidth ;
	static float PrevParam ;
	static float Table[ 16 ] ;
	int WeightNum ;

	// PixelWidth ̕␳
	if( PixelWidth <= 8 )
	{
		PixelWidth = 8 ;
	}
	else
	if( PixelWidth <= 16 )
	{
		PixelWidth = 16 ;
	}
	else
	{
		PixelWidth = 32 ;
	}
	WeightNum = PixelWidth / 2 ;

	if( Param >= 0.0000001f )
	{
		float Temp ;

		Temp = PrevParam - Param ;
		if( Temp > 0.0002f || Temp < -0.0002f || PrevPixelWidth != PixelWidth )
		{
			float Total ;
			int i ;

			PrevParam = Param ;
			PrevPixelWidth = PixelWidth ;

			Total = 0.0f ;
			for( i = 0 ; i < WeightNum ; i ++ )
			{
				Table[ i ] = _EXPF( -0.5f * ( float )( i * i ) / Param ) ;
				if( i == 0 )
				{
					Total += Table[ i ] ;
				}
				else
				{
					Total += 2.0f * Table[ i ] ;
				}
			}

			for( i = 0 ; i < WeightNum ; i ++ )
				Table[ i ] /= Total ;
		}
	}

	// VF[_[g邩ǂŏ𕪊
	if( GRH.UseShader == TRUE )
	{
		static const char *PsoFileName[] =
		{
			"Gauss_08Pixel_PS.pso",
			"Gauss_16Pixel_PS.pso",
			"Gauss_32Pixel_PS.pso"
		} ;
		IMAGEDATA2 *SrcImage2 ;
		LIBSHADER_DRAWPARAMTEMP DrawParamTemp ;
		int UseShader = 0 ;
		FLOAT4 ParamF4[ 21 ] ;

		if( GRAPHCHK( Info->SrcGrHandle, SrcImage2 ) )
			return -1 ;

		// PixelWidth ɂăVF[_[ύX
		switch( PixelWidth )
		{
		case 8  : UseShader = 0 ; break ;
		case 16 : UseShader = 1 ; break ;
		case 32 : UseShader = 2 ; break ;
		}

		if( Param < 0.0000001f )
		{
			IMAGEDATA2 *DestImage2 ;

			if( GRAPHCHK( Info->DestGrHandle, DestImage2 ) )
				return -1 ;

			SetRenderTargetHardware( CheckMultiSampleDrawValidGraph( Info->DestGrHandle ) ?
										DestImage2->Hard.Draw[ 0 ].Tex->RenderTargetSurface :
										DestImage2->Hard.Draw[ 0 ].Tex->Surface[ 0 ] ) ;
			NS_DrawGraph( 0, 0, Info->SrcGrHandle, FALSE ) ;
			if( CheckMultiSampleDrawValidGraph( Info->DestGrHandle ) )
			{
				EndScene() ;
				UpdateDrawTexture( DestImage2->Hard.Draw[ 0 ].Tex, 0 ) ;
			}
		}
		else
		{
			// gpVF[_[̃ZbgAbv
			if( GRH.ShaderCode.Gauss_PS[ UseShader ] < 0 )
			{
				GRH.ShaderCode.Gauss_PS[ UseShader ] = MemLoadShaderCode( PsoFileName[ UseShader ], false ) ;
				if( GRH.ShaderCode.Gauss_PS[ UseShader ] < 0 )
				{
					DXST_ERRORLOGFMT_ADD(( _T( "tB^[pVF[_[̍쐬Ɏs܂ %s" ), PsoFileName[ UseShader ] )) ;
					return -1 ;
				}
				NS_SetDeleteHandleFlag( GRH.ShaderCode.Gauss_PS[ UseShader ], &GRH.ShaderCode.Gauss_PS[ UseShader ] ) ;
			}

			LibShader_PushShaderParam( &DrawParamTemp, 1 ) ;

			ParamF4[  0 ].x = ( float )SrcImage2->Orig->Hard.Tex[ 0 ].TexWidth ;
			ParamF4[  0 ].y = ( float )SrcImage2->Orig->Hard.Tex[ 0 ].TexHeight ;
			ParamF4[  1 ].x = Table[ 0 ] ;
			ParamF4[  1 ].y = Table[ 1 ] ;
			ParamF4[  1 ].z = Table[ 2 ] ;
			ParamF4[  1 ].w = Table[ 3 ] ;
			ParamF4[  2 ].x = Table[ 4 ] ;
			ParamF4[  2 ].y = Table[ 5 ] ;
			ParamF4[  2 ].z = Table[ 6 ] ;
			ParamF4[  2 ].w = Table[ 7 ] ;
			ParamF4[  3 ].x = Table[ 8 ] ;
			ParamF4[  3 ].y = Table[ 9 ] ;
			ParamF4[  3 ].z = Table[ 10 ] ;
			ParamF4[  3 ].w = Table[ 11 ] ;
			ParamF4[  4 ].x = Table[ 12 ] ;
			ParamF4[  4 ].y = Table[ 13 ] ;
			ParamF4[  4 ].z = Table[ 14 ] ;
			ParamF4[  4 ].w = Table[ 15 ] ;

			// pXɂď𕪊
			switch( Info->Pass )
			{
			case 0 :
				ParamF4[  5 ].x =  0.0f / ParamF4[  0 ].x ; ParamF4[  5 ].y =  0.0f ; ParamF4[  5 ].z =  0.0f ; ParamF4[  5 ].w =  0.0f ;
				ParamF4[  6 ].x =  1.5f / ParamF4[  0 ].x ; ParamF4[  6 ].y =  0.0f ; ParamF4[  6 ].z =  0.0f ; ParamF4[  6 ].w =  0.0f ;
				ParamF4[  7 ].x =  3.5f / ParamF4[  0 ].x ; ParamF4[  7 ].y =  0.0f ; ParamF4[  7 ].z =  0.0f ; ParamF4[  7 ].w =  0.0f ;
				ParamF4[  8 ].x =  5.5f / ParamF4[  0 ].x ; ParamF4[  8 ].y =  0.0f ; ParamF4[  8 ].z =  0.0f ; ParamF4[  8 ].w =  0.0f ;
				ParamF4[  9 ].x =  7.5f / ParamF4[  0 ].x ; ParamF4[  9 ].y =  0.0f ; ParamF4[  9 ].z =  0.0f ; ParamF4[  9 ].w =  0.0f ;
				ParamF4[ 10 ].x =  9.5f / ParamF4[  0 ].x ; ParamF4[ 10 ].y =  0.0f ; ParamF4[ 10 ].z =  0.0f ; ParamF4[ 10 ].w =  0.0f ;
				ParamF4[ 11 ].x = 11.5f / ParamF4[  0 ].x ; ParamF4[ 11 ].y =  0.0f ; ParamF4[ 11 ].z =  0.0f ; ParamF4[ 11 ].w =  0.0f ;
				ParamF4[ 12 ].x = 13.5f / ParamF4[  0 ].x ; ParamF4[ 12 ].y =  0.0f ; ParamF4[ 12 ].z =  0.0f ; ParamF4[ 12 ].w =  0.0f ;
				ParamF4[ 13 ].x = 15.5f / ParamF4[  0 ].x ; ParamF4[ 13 ].y =  0.0f ; ParamF4[ 13 ].z =  0.0f ; ParamF4[ 13 ].w =  0.0f ;
				ParamF4[ 14 ].x = 17.5f / ParamF4[  0 ].x ; ParamF4[ 14 ].y =  0.0f ; ParamF4[ 14 ].z =  0.0f ; ParamF4[ 14 ].w =  0.0f ;
				ParamF4[ 15 ].x = 19.5f / ParamF4[  0 ].x ; ParamF4[ 15 ].y =  0.0f ; ParamF4[ 15 ].z =  0.0f ; ParamF4[ 15 ].w =  0.0f ;
				ParamF4[ 16 ].x = 21.5f / ParamF4[  0 ].x ; ParamF4[ 16 ].y =  0.0f ; ParamF4[ 16 ].z =  0.0f ; ParamF4[ 16 ].w =  0.0f ;
				ParamF4[ 17 ].x = 23.5f / ParamF4[  0 ].x ; ParamF4[ 17 ].y =  0.0f ; ParamF4[ 17 ].z =  0.0f ; ParamF4[ 17 ].w =  0.0f ;
				ParamF4[ 18 ].x = 25.5f / ParamF4[  0 ].x ; ParamF4[ 18 ].y =  0.0f ; ParamF4[ 18 ].z =  0.0f ; ParamF4[ 18 ].w =  0.0f ;
				ParamF4[ 19 ].x = 27.5f / ParamF4[  0 ].x ; ParamF4[ 19 ].y =  0.0f ; ParamF4[ 19 ].z =  0.0f ; ParamF4[ 19 ].w =  0.0f ;
				ParamF4[ 20 ].x = 29.5f / ParamF4[  0 ].x ; ParamF4[ 20 ].y =  0.0f ; ParamF4[ 20 ].z =  0.0f ; ParamF4[ 20 ].w =  0.0f ;
				break ;

			case 1 :
				ParamF4[  5 ].y =  0.0f / ParamF4[  0 ].y ; ParamF4[  5 ].x =  0.0f ; ParamF4[  5 ].z =  0.0f ; ParamF4[  5 ].w =  0.0f ;
				ParamF4[  6 ].y =  1.5f / ParamF4[  0 ].y ; ParamF4[  6 ].x =  0.0f ; ParamF4[  6 ].z =  0.0f ; ParamF4[  6 ].w =  0.0f ;
				ParamF4[  7 ].y =  3.5f / ParamF4[  0 ].y ; ParamF4[  7 ].x =  0.0f ; ParamF4[  7 ].z =  0.0f ; ParamF4[  7 ].w =  0.0f ;
				ParamF4[  8 ].y =  5.5f / ParamF4[  0 ].y ; ParamF4[  8 ].x =  0.0f ; ParamF4[  8 ].z =  0.0f ; ParamF4[  8 ].w =  0.0f ;
				ParamF4[  9 ].y =  7.5f / ParamF4[  0 ].y ; ParamF4[  9 ].x =  0.0f ; ParamF4[  9 ].z =  0.0f ; ParamF4[  9 ].w =  0.0f ;
				ParamF4[ 10 ].y =  9.5f / ParamF4[  0 ].y ; ParamF4[ 10 ].x =  0.0f ; ParamF4[ 10 ].z =  0.0f ; ParamF4[ 10 ].w =  0.0f ;
				ParamF4[ 11 ].y = 11.5f / ParamF4[  0 ].y ; ParamF4[ 11 ].x =  0.0f ; ParamF4[ 11 ].z =  0.0f ; ParamF4[ 11 ].w =  0.0f ;
				ParamF4[ 12 ].y = 13.5f / ParamF4[  0 ].y ; ParamF4[ 12 ].x =  0.0f ; ParamF4[ 12 ].z =  0.0f ; ParamF4[ 12 ].w =  0.0f ;
				ParamF4[ 13 ].y = 15.5f / ParamF4[  0 ].y ; ParamF4[ 13 ].x =  0.0f ; ParamF4[ 13 ].z =  0.0f ; ParamF4[ 13 ].w =  0.0f ;
				ParamF4[ 14 ].y = 17.5f / ParamF4[  0 ].y ; ParamF4[ 14 ].x =  0.0f ; ParamF4[ 14 ].z =  0.0f ; ParamF4[ 14 ].w =  0.0f ;
				ParamF4[ 15 ].y = 19.5f / ParamF4[  0 ].y ; ParamF4[ 15 ].x =  0.0f ; ParamF4[ 15 ].z =  0.0f ; ParamF4[ 15 ].w =  0.0f ;
				ParamF4[ 16 ].y = 21.5f / ParamF4[  0 ].y ; ParamF4[ 16 ].x =  0.0f ; ParamF4[ 16 ].z =  0.0f ; ParamF4[ 16 ].w =  0.0f ;
				ParamF4[ 17 ].y = 23.5f / ParamF4[  0 ].y ; ParamF4[ 17 ].x =  0.0f ; ParamF4[ 17 ].z =  0.0f ; ParamF4[ 17 ].w =  0.0f ;
				ParamF4[ 18 ].y = 25.5f / ParamF4[  0 ].y ; ParamF4[ 18 ].x =  0.0f ; ParamF4[ 18 ].z =  0.0f ; ParamF4[ 18 ].w =  0.0f ;
				ParamF4[ 19 ].y = 27.5f / ParamF4[  0 ].y ; ParamF4[ 19 ].x =  0.0f ; ParamF4[ 19 ].z =  0.0f ; ParamF4[ 19 ].w =  0.0f ;
				ParamF4[ 20 ].y = 29.5f / ParamF4[  0 ].y ; ParamF4[ 20 ].x =  0.0f ; ParamF4[ 20 ].z =  0.0f ; ParamF4[ 20 ].w =  0.0f ;
				break ;
			}

			SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, ParamF4, 21, FALSE ) ;

			NS_SetUsePixelShader( GRH.ShaderCode.Gauss_PS[ UseShader ] ) ;

			GraphFilter_BasePolygonDraw( Info ) ;

			LibShader_PopShaderParam( &DrawParamTemp ) ;

			ResetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, 21 ) ;

			if( Info->Pass == 0 )
			{
				VERTEX2D Vert[ 4 ] ;
				float Width ;
				float Height ;
				int TexWidth ;
				int TexHeight ;

				GetGraphTextureSize( Info->DestGrHandle, &TexWidth, &TexHeight ) ;
				Width  = ( float )( Info->SrcX2 - Info->SrcX1 ) ;
				Height = ( float )( Info->SrcY2 - Info->SrcY1 ) ;
				Vert[ 0 ].pos.x = Info->DestX			- 0.5f ;	Vert[ 0 ].pos.y = Info->DestY + Height	- 0.5f ;	Vert[ 0 ].pos.z = 0.0f ;	Vert[ 0 ].rhw = 1.0f ;
				Vert[ 1 ].pos.x = Info->DestX + Width	- 0.5f ;	Vert[ 1 ].pos.y = Info->DestY + Height	- 0.5f ;	Vert[ 1 ].pos.z = 0.0f ;	Vert[ 1 ].rhw = 1.0f ;
				Vert[ 2 ].pos.x = Info->DestX			- 0.5f ;	Vert[ 2 ].pos.y = TexHeight				- 0.5f ;	Vert[ 2 ].pos.z = 0.0f ;	Vert[ 2 ].rhw = 1.0f ;
				Vert[ 3 ].pos.x = Info->DestX + Width	- 0.5f ;	Vert[ 3 ].pos.y = TexHeight				- 0.5f ;	Vert[ 3 ].pos.z = 0.0f ;	Vert[ 3 ].rhw = 1.0f ;
				Vert[ 0 ].u = Info->DestX             / ( float )TexWidth ;	Vert[ 0 ].v = ( float )( Info->DestY + Height - 1 ) / TexHeight ;
				Vert[ 1 ].u = ( Info->DestX + Width ) / ( float )TexWidth ;	Vert[ 1 ].v = Vert[ 0 ].v ;
				Vert[ 2 ].u = Vert[ 0 ].u ;									Vert[ 2 ].v = Vert[ 0 ].v ;
				Vert[ 3 ].u = Vert[ 1 ].u ;									Vert[ 3 ].v = Vert[ 0 ].v ;
				Vert[ 0 ].dif = GetColorU8( 255,255,255,255 ) ;
				Vert[ 1 ].dif = Vert[ 0 ].dif ;
				Vert[ 2 ].dif = Vert[ 0 ].dif ;
				Vert[ 3 ].dif = Vert[ 0 ].dif ;
				NS_DrawPrimitive2D( Vert, 4, DX_PRIMTYPE_TRIANGLESTRIP, Info->DestGrHandle, FALSE ) ;
			}
		}
	}
	else
	{
		// VF[_[gȂꍇ

		BYTE *Src ;
		BYTE *Dest ;
		BYTE *MinSrc ;
		BYTE *MaxSrc ;
		BYTE *MinSrcStart ;
		BYTE *MaxSrcStart ;
		DWORD i, j ;
		DWORD Width ;
		DWORD Height ;
		DWORD SrcPitch ;
		DWORD SrcAddPitch ;
		DWORD DestAddPitch ;
		int iTable[ 16 ] ;
		BYTE RGBA[ 64 ][ 4 ] ;
		BASEIMAGE WorkImage ;

		for( i = 0 ; i < ( DWORD )WeightNum ; i ++ )
		{
			iTable[ i ] = _FTOL( Table[ i ] * 65536.0f ) ;
		}

		Width  = Info->SrcX2 - Info->SrcX1 ;
		Height = Info->SrcY2 - Info->SrcY1 ;

		if( GraphFilter_SoftImageSetup( Info ) < 0 )
		{
			NS_ReleaseBaseImage( &WorkImage ) ;
			return -1 ;
		}

		if( Param < 0.0000001f )
		{
			Src = ( BYTE * )Info->SrcImage.GraphData ;
			Dest = ( BYTE * )Info->DestImage.GraphData ;

			SrcAddPitch  = Info->SrcImage.Pitch  - Width * 4 ;
			DestAddPitch = Info->DestImage.Pitch - Width * 4 ;

			do
			{
				i = Width ;
				do
				{
					*( ( DWORD * )Dest ) = *( ( DWORD * )Src ) ;

					Src  += 4 ;
					Dest += 4 ;
				}while( -- i ) ;

				Src  += SrcAddPitch ;
				Dest += DestAddPitch ;
			}while( -- Height ) ;
		}
		else
		{
			if( NS_CreateARGB8ColorBaseImage( Width, Height, &WorkImage ) >= 0 )
			{
				Src = ( BYTE * )Info->SrcImage.GraphData ;
				Dest = ( BYTE * )WorkImage.GraphData ;

				SrcAddPitch  = Info->SrcImage.Pitch  - Width * 4 ;
				DestAddPitch = WorkImage.Pitch       - Width * 4 ;

				switch( PixelWidth )
				{
				case 8 :
					for( j = 0 ; j < Height ; j ++ )
					{
						MinSrc = Src ;
						MaxSrc = Src + 4 * ( Width - 1 ) ;
						for( i = 0 ; i < Width ; i ++ )
						{
							*( ( DWORD * )RGBA[  0 ] ) = *( ( DWORD * )Src ) ;
							*( ( DWORD * )RGBA[  1 ] ) = i < 1          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 1 ) ;
							*( ( DWORD * )RGBA[  2 ] ) = i < 2          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 2 ) ;
							*( ( DWORD * )RGBA[  3 ] ) = i + 1 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 1 ) ;
							*( ( DWORD * )RGBA[  4 ] ) = i + 2 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 2 ) ;
							*( ( DWORD * )RGBA[  5 ] ) = i < 3          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 3 ) ;
							*( ( DWORD * )RGBA[  6 ] ) = i < 4          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 4 ) ;
							*( ( DWORD * )RGBA[  7 ] ) = i + 3 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 3 ) ;
							*( ( DWORD * )RGBA[  8 ] ) = i + 4 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 4 ) ;
							*( ( DWORD * )RGBA[  9 ] ) = i < 5          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 5 ) ;
							*( ( DWORD * )RGBA[ 10 ] ) = i < 6          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 6 ) ;
							*( ( DWORD * )RGBA[ 11 ] ) = i + 5 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 5 ) ;
							*( ( DWORD * )RGBA[ 12 ] ) = i + 6 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 6 ) ;

							Dest[ 0 ] = ( BYTE )(
								( RGBA[ 0 ][ 0 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 0 ] + RGBA[  2 ][ 0 ] + RGBA[  3 ][ 0 ] + RGBA[  4 ][ 0 ] ) * iTable[ 1 ] +
									  ( RGBA[  5 ][ 0 ] + RGBA[  6 ][ 0 ] + RGBA[  7 ][ 0 ] + RGBA[  8 ][ 0 ] ) * iTable[ 2 ] +
									  ( RGBA[  9 ][ 0 ] + RGBA[ 10 ][ 0 ] + RGBA[ 11 ][ 0 ] + RGBA[ 12 ][ 0 ] ) * iTable[ 3 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 1 ] = ( BYTE )(
								( RGBA[ 0 ][ 1 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 1 ] + RGBA[  2 ][ 1 ] + RGBA[  3 ][ 1 ] + RGBA[  4 ][ 1 ] ) * iTable[ 1 ] +
									  ( RGBA[  5 ][ 1 ] + RGBA[  6 ][ 1 ] + RGBA[  7 ][ 1 ] + RGBA[  8 ][ 1 ] ) * iTable[ 2 ] +
									  ( RGBA[  9 ][ 1 ] + RGBA[ 10 ][ 1 ] + RGBA[ 11 ][ 1 ] + RGBA[ 12 ][ 1 ] ) * iTable[ 3 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 2 ] = ( BYTE )(
								( RGBA[ 0 ][ 2 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 2 ] + RGBA[  2 ][ 2 ] + RGBA[  3 ][ 2 ] + RGBA[  4 ][ 2 ] ) * iTable[ 1 ] +
									  ( RGBA[  5 ][ 2 ] + RGBA[  6 ][ 2 ] + RGBA[  7 ][ 2 ] + RGBA[  8 ][ 2 ] ) * iTable[ 2 ] +
									  ( RGBA[  9 ][ 2 ] + RGBA[ 10 ][ 2 ] + RGBA[ 11 ][ 2 ] + RGBA[ 12 ][ 2 ] ) * iTable[ 3 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 3 ] = ( BYTE )(
								( RGBA[ 0 ][ 3 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 3 ] + RGBA[  2 ][ 3 ] + RGBA[  3 ][ 3 ] + RGBA[  4 ][ 3 ] ) * iTable[ 1 ] +
									  ( RGBA[  5 ][ 3 ] + RGBA[  6 ][ 3 ] + RGBA[  7 ][ 3 ] + RGBA[  8 ][ 3 ] ) * iTable[ 2 ] +
									  ( RGBA[  9 ][ 3 ] + RGBA[ 10 ][ 3 ] + RGBA[ 11 ][ 3 ] + RGBA[ 12 ][ 3 ] ) * iTable[ 3 ] ) >> 1 ) ) >> 16 ) ;

							Src  += 4 ;
							Dest += 4 ;
						}

						Src  += SrcAddPitch ;
						Dest += DestAddPitch ;
					}
					break ;

				case 16 :
					for( j = 0 ; j < Height ; j ++ )
					{
						MinSrc = Src ;
						MaxSrc = Src + 4 * ( Width - 1 ) ;
						for( i = 0 ; i < Width ; i ++ )
						{
							*( ( DWORD * )RGBA[  0 ] ) = *( ( DWORD * )Src ) ;
							*( ( DWORD * )RGBA[  1 ] ) = i <  1          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  1 ) ;
							*( ( DWORD * )RGBA[  2 ] ) = i <  2          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  2 ) ;
							*( ( DWORD * )RGBA[  3 ] ) = i +  1 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  1 ) ;
							*( ( DWORD * )RGBA[  4 ] ) = i +  2 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  2 ) ;
							*( ( DWORD * )RGBA[  5 ] ) = i <  3          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  3 ) ;
							*( ( DWORD * )RGBA[  6 ] ) = i <  4          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  4 ) ;
							*( ( DWORD * )RGBA[  7 ] ) = i +  3 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  3 ) ;
							*( ( DWORD * )RGBA[  8 ] ) = i +  4 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  4 ) ;
							*( ( DWORD * )RGBA[  9 ] ) = i <  5          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  5 ) ;
							*( ( DWORD * )RGBA[ 10 ] ) = i <  6          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  6 ) ;
							*( ( DWORD * )RGBA[ 11 ] ) = i +  5 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  5 ) ;
							*( ( DWORD * )RGBA[ 12 ] ) = i +  6 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  6 ) ;
							*( ( DWORD * )RGBA[ 13 ] ) = i <  7          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  7 ) ;
							*( ( DWORD * )RGBA[ 14 ] ) = i <  8          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  8 ) ;
							*( ( DWORD * )RGBA[ 15 ] ) = i +  7 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  7 ) ;
							*( ( DWORD * )RGBA[ 16 ] ) = i +  8 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  8 ) ;
							*( ( DWORD * )RGBA[ 17 ] ) = i <  9          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  9 ) ;
							*( ( DWORD * )RGBA[ 18 ] ) = i < 10          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 10 ) ;
							*( ( DWORD * )RGBA[ 19 ] ) = i +  9 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  9 ) ;
							*( ( DWORD * )RGBA[ 20 ] ) = i + 10 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 10 ) ;
							*( ( DWORD * )RGBA[ 21 ] ) = i < 11          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 11 ) ;
							*( ( DWORD * )RGBA[ 22 ] ) = i < 12          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 12 ) ;
							*( ( DWORD * )RGBA[ 23 ] ) = i + 11 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 11 ) ;
							*( ( DWORD * )RGBA[ 24 ] ) = i + 12 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 12 ) ;
							*( ( DWORD * )RGBA[ 25 ] ) = i < 13          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 13 ) ;
							*( ( DWORD * )RGBA[ 26 ] ) = i < 14          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 14 ) ;
							*( ( DWORD * )RGBA[ 27 ] ) = i + 13 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 13 ) ;
							*( ( DWORD * )RGBA[ 28 ] ) = i + 14 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 14 ) ;

							Dest[ 0 ] = ( BYTE )(
								( RGBA[ 0 ][ 0 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 0 ] + RGBA[  2 ][ 0 ] + RGBA[  3 ][ 0 ] + RGBA[  4 ][ 0 ] ) * iTable[ 1 ] +
									  ( RGBA[  5 ][ 0 ] + RGBA[  6 ][ 0 ] + RGBA[  7 ][ 0 ] + RGBA[  8 ][ 0 ] ) * iTable[ 2 ] +
									  ( RGBA[  9 ][ 0 ] + RGBA[ 10 ][ 0 ] + RGBA[ 11 ][ 0 ] + RGBA[ 12 ][ 0 ] ) * iTable[ 3 ] +
									  ( RGBA[ 13 ][ 0 ] + RGBA[ 14 ][ 0 ] + RGBA[ 15 ][ 0 ] + RGBA[ 16 ][ 0 ] ) * iTable[ 4 ] +
									  ( RGBA[ 17 ][ 0 ] + RGBA[ 18 ][ 0 ] + RGBA[ 19 ][ 0 ] + RGBA[ 20 ][ 0 ] ) * iTable[ 5 ] +
									  ( RGBA[ 21 ][ 0 ] + RGBA[ 22 ][ 0 ] + RGBA[ 23 ][ 0 ] + RGBA[ 24 ][ 0 ] ) * iTable[ 6 ] +
									  ( RGBA[ 25 ][ 0 ] + RGBA[ 26 ][ 0 ] + RGBA[ 27 ][ 0 ] + RGBA[ 28 ][ 0 ] ) * iTable[ 7 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 1 ] = ( BYTE )(
								( RGBA[ 0 ][ 1 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 1 ] + RGBA[  2 ][ 1 ] + RGBA[  3 ][ 1 ] + RGBA[  4 ][ 1 ] ) * iTable[ 1 ] +
									  ( RGBA[  5 ][ 1 ] + RGBA[  6 ][ 1 ] + RGBA[  7 ][ 1 ] + RGBA[  8 ][ 1 ] ) * iTable[ 2 ] +
									  ( RGBA[  9 ][ 1 ] + RGBA[ 10 ][ 1 ] + RGBA[ 11 ][ 1 ] + RGBA[ 12 ][ 1 ] ) * iTable[ 3 ] +
									  ( RGBA[ 13 ][ 1 ] + RGBA[ 14 ][ 1 ] + RGBA[ 15 ][ 1 ] + RGBA[ 16 ][ 1 ] ) * iTable[ 4 ] +
									  ( RGBA[ 17 ][ 1 ] + RGBA[ 18 ][ 1 ] + RGBA[ 19 ][ 1 ] + RGBA[ 20 ][ 1 ] ) * iTable[ 5 ] +
									  ( RGBA[ 21 ][ 1 ] + RGBA[ 22 ][ 1 ] + RGBA[ 23 ][ 1 ] + RGBA[ 24 ][ 1 ] ) * iTable[ 6 ] +
									  ( RGBA[ 25 ][ 1 ] + RGBA[ 26 ][ 1 ] + RGBA[ 27 ][ 1 ] + RGBA[ 28 ][ 1 ] ) * iTable[ 7 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 2 ] = ( BYTE )(
								( RGBA[ 0 ][ 2 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 2 ] + RGBA[  2 ][ 2 ] + RGBA[  3 ][ 2 ] + RGBA[  4 ][ 2 ] ) * iTable[ 1 ] +
									  ( RGBA[  5 ][ 2 ] + RGBA[  6 ][ 2 ] + RGBA[  7 ][ 2 ] + RGBA[  8 ][ 2 ] ) * iTable[ 2 ] +
									  ( RGBA[  9 ][ 2 ] + RGBA[ 10 ][ 2 ] + RGBA[ 11 ][ 2 ] + RGBA[ 12 ][ 2 ] ) * iTable[ 3 ] +
									  ( RGBA[ 13 ][ 2 ] + RGBA[ 14 ][ 2 ] + RGBA[ 15 ][ 2 ] + RGBA[ 16 ][ 2 ] ) * iTable[ 4 ] +
									  ( RGBA[ 17 ][ 2 ] + RGBA[ 18 ][ 2 ] + RGBA[ 19 ][ 2 ] + RGBA[ 20 ][ 2 ] ) * iTable[ 5 ] +
									  ( RGBA[ 21 ][ 2 ] + RGBA[ 22 ][ 2 ] + RGBA[ 23 ][ 2 ] + RGBA[ 24 ][ 2 ] ) * iTable[ 6 ] +
									  ( RGBA[ 25 ][ 2 ] + RGBA[ 26 ][ 2 ] + RGBA[ 27 ][ 2 ] + RGBA[ 28 ][ 2 ] ) * iTable[ 7 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 3 ] = ( BYTE )(
								( RGBA[ 0 ][ 3 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 3 ] + RGBA[  2 ][ 3 ] + RGBA[  3 ][ 3 ] + RGBA[  4 ][ 3 ] ) * iTable[ 1 ] +
									  ( RGBA[  5 ][ 3 ] + RGBA[  6 ][ 3 ] + RGBA[  7 ][ 3 ] + RGBA[  8 ][ 3 ] ) * iTable[ 2 ] +
									  ( RGBA[  9 ][ 3 ] + RGBA[ 10 ][ 3 ] + RGBA[ 11 ][ 3 ] + RGBA[ 12 ][ 3 ] ) * iTable[ 3 ] +
									  ( RGBA[ 13 ][ 3 ] + RGBA[ 14 ][ 3 ] + RGBA[ 15 ][ 3 ] + RGBA[ 16 ][ 3 ] ) * iTable[ 4 ] +
									  ( RGBA[ 17 ][ 3 ] + RGBA[ 18 ][ 3 ] + RGBA[ 19 ][ 3 ] + RGBA[ 20 ][ 3 ] ) * iTable[ 5 ] +
									  ( RGBA[ 21 ][ 3 ] + RGBA[ 22 ][ 3 ] + RGBA[ 23 ][ 3 ] + RGBA[ 24 ][ 3 ] ) * iTable[ 6 ] +
									  ( RGBA[ 25 ][ 3 ] + RGBA[ 26 ][ 3 ] + RGBA[ 27 ][ 3 ] + RGBA[ 28 ][ 3 ] ) * iTable[ 7 ] ) >> 1 ) ) >> 16 ) ;

							Src  += 4 ;
							Dest += 4 ;
						}

						Src  += SrcAddPitch ;
						Dest += DestAddPitch ;
					}
					break ;

				case 32 :
					for( j = 0 ; j < Height ; j ++ )
					{
						MinSrc = Src ;
						MaxSrc = Src + 4 * ( Width - 1 ) ;
						for( i = 0 ; i < Width ; i ++ )
						{
							*( ( DWORD * )RGBA[  0 ] ) = *( ( DWORD * )Src ) ;
							*( ( DWORD * )RGBA[  1 ] ) = i <  1          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  1 ) ;
							*( ( DWORD * )RGBA[  2 ] ) = i <  2          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  2 ) ;
							*( ( DWORD * )RGBA[  3 ] ) = i +  1 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  1 ) ;
							*( ( DWORD * )RGBA[  4 ] ) = i +  2 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  2 ) ;
							*( ( DWORD * )RGBA[  5 ] ) = i <  3          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  3 ) ;
							*( ( DWORD * )RGBA[  6 ] ) = i <  4          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  4 ) ;
							*( ( DWORD * )RGBA[  7 ] ) = i +  3 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  3 ) ;
							*( ( DWORD * )RGBA[  8 ] ) = i +  4 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  4 ) ;
							*( ( DWORD * )RGBA[  9 ] ) = i <  5          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  5 ) ;
							*( ( DWORD * )RGBA[ 10 ] ) = i <  6          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  6 ) ;
							*( ( DWORD * )RGBA[ 11 ] ) = i +  5 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  5 ) ;
							*( ( DWORD * )RGBA[ 12 ] ) = i +  6 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  6 ) ;
							*( ( DWORD * )RGBA[ 13 ] ) = i <  7          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  7 ) ;
							*( ( DWORD * )RGBA[ 14 ] ) = i <  8          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  8 ) ;
							*( ( DWORD * )RGBA[ 15 ] ) = i +  7 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  7 ) ;
							*( ( DWORD * )RGBA[ 16 ] ) = i +  8 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  8 ) ;
							*( ( DWORD * )RGBA[ 17 ] ) = i <  9          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  9 ) ;
							*( ( DWORD * )RGBA[ 18 ] ) = i < 10          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 10 ) ;
							*( ( DWORD * )RGBA[ 19 ] ) = i +  9 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  9 ) ;
							*( ( DWORD * )RGBA[ 20 ] ) = i + 10 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 10 ) ;
							*( ( DWORD * )RGBA[ 21 ] ) = i < 11          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 11 ) ;
							*( ( DWORD * )RGBA[ 22 ] ) = i < 12          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 12 ) ;
							*( ( DWORD * )RGBA[ 23 ] ) = i + 11 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 11 ) ;
							*( ( DWORD * )RGBA[ 24 ] ) = i + 12 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 12 ) ;
							*( ( DWORD * )RGBA[ 25 ] ) = i < 13          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 13 ) ;
							*( ( DWORD * )RGBA[ 26 ] ) = i < 14          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 14 ) ;
							*( ( DWORD * )RGBA[ 27 ] ) = i + 13 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 13 ) ;
							*( ( DWORD * )RGBA[ 28 ] ) = i + 14 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 14 ) ;
							*( ( DWORD * )RGBA[ 29 ] ) = i < 15          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 15 ) ;
							*( ( DWORD * )RGBA[ 30 ] ) = i < 16          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 16 ) ;
							*( ( DWORD * )RGBA[ 31 ] ) = i + 15 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 15 ) ;
							*( ( DWORD * )RGBA[ 32 ] ) = i + 16 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 16 ) ;
							*( ( DWORD * )RGBA[ 33 ] ) = i < 17          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 17 ) ;
							*( ( DWORD * )RGBA[ 34 ] ) = i < 18          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 18 ) ;
							*( ( DWORD * )RGBA[ 35 ] ) = i + 17 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 17 ) ;
							*( ( DWORD * )RGBA[ 36 ] ) = i + 18 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 18 ) ;
							*( ( DWORD * )RGBA[ 37 ] ) = i < 19          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 19 ) ;
							*( ( DWORD * )RGBA[ 38 ] ) = i < 20          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 20 ) ;
							*( ( DWORD * )RGBA[ 39 ] ) = i + 19 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 19 ) ;
							*( ( DWORD * )RGBA[ 40 ] ) = i + 20 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 20 ) ;
							*( ( DWORD * )RGBA[ 41 ] ) = i < 21          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 21 ) ;
							*( ( DWORD * )RGBA[ 42 ] ) = i < 22          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 22 ) ;
							*( ( DWORD * )RGBA[ 43 ] ) = i + 21 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 21 ) ;
							*( ( DWORD * )RGBA[ 44 ] ) = i + 22 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 22 ) ;
							*( ( DWORD * )RGBA[ 45 ] ) = i < 23          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 23 ) ;
							*( ( DWORD * )RGBA[ 46 ] ) = i < 24          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 24 ) ;
							*( ( DWORD * )RGBA[ 47 ] ) = i + 23 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 23 ) ;
							*( ( DWORD * )RGBA[ 48 ] ) = i + 24 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 24 ) ;
							*( ( DWORD * )RGBA[ 49 ] ) = i < 25          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 25 ) ;
							*( ( DWORD * )RGBA[ 50 ] ) = i < 26          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 26 ) ;
							*( ( DWORD * )RGBA[ 51 ] ) = i + 25 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 25 ) ;
							*( ( DWORD * )RGBA[ 52 ] ) = i + 26 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 26 ) ;
							*( ( DWORD * )RGBA[ 53 ] ) = i < 27          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 27 ) ;
							*( ( DWORD * )RGBA[ 54 ] ) = i < 28          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 28 ) ;
							*( ( DWORD * )RGBA[ 55 ] ) = i + 27 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 27 ) ;
							*( ( DWORD * )RGBA[ 56 ] ) = i + 28 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 28 ) ;
							*( ( DWORD * )RGBA[ 57 ] ) = i < 29          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 29 ) ;
							*( ( DWORD * )RGBA[ 58 ] ) = i < 30          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 30 ) ;
							*( ( DWORD * )RGBA[ 59 ] ) = i + 29 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 29 ) ;
							*( ( DWORD * )RGBA[ 60 ] ) = i + 30 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 30 ) ;

							Dest[ 0 ] = ( BYTE )(
								( RGBA[ 0 ][ 0 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 0 ] + RGBA[  2 ][ 0 ] + RGBA[  3 ][ 0 ] + RGBA[  4 ][ 0 ] ) * iTable[  1 ] +
									  ( RGBA[  5 ][ 0 ] + RGBA[  6 ][ 0 ] + RGBA[  7 ][ 0 ] + RGBA[  8 ][ 0 ] ) * iTable[  2 ] +
									  ( RGBA[  9 ][ 0 ] + RGBA[ 10 ][ 0 ] + RGBA[ 11 ][ 0 ] + RGBA[ 12 ][ 0 ] ) * iTable[  3 ] +
									  ( RGBA[ 13 ][ 0 ] + RGBA[ 14 ][ 0 ] + RGBA[ 15 ][ 0 ] + RGBA[ 16 ][ 0 ] ) * iTable[  4 ] +
									  ( RGBA[ 17 ][ 0 ] + RGBA[ 18 ][ 0 ] + RGBA[ 19 ][ 0 ] + RGBA[ 20 ][ 0 ] ) * iTable[  5 ] +
									  ( RGBA[ 21 ][ 0 ] + RGBA[ 22 ][ 0 ] + RGBA[ 23 ][ 0 ] + RGBA[ 24 ][ 0 ] ) * iTable[  6 ] +
									  ( RGBA[ 25 ][ 0 ] + RGBA[ 26 ][ 0 ] + RGBA[ 27 ][ 0 ] + RGBA[ 28 ][ 0 ] ) * iTable[  7 ] +
									  ( RGBA[ 29 ][ 0 ] + RGBA[ 30 ][ 0 ] + RGBA[ 31 ][ 0 ] + RGBA[ 32 ][ 0 ] ) * iTable[  8 ] +
									  ( RGBA[ 33 ][ 0 ] + RGBA[ 34 ][ 0 ] + RGBA[ 35 ][ 0 ] + RGBA[ 36 ][ 0 ] ) * iTable[  9 ] +
									  ( RGBA[ 37 ][ 0 ] + RGBA[ 38 ][ 0 ] + RGBA[ 39 ][ 0 ] + RGBA[ 40 ][ 0 ] ) * iTable[ 10 ] +
									  ( RGBA[ 41 ][ 0 ] + RGBA[ 42 ][ 0 ] + RGBA[ 43 ][ 0 ] + RGBA[ 44 ][ 0 ] ) * iTable[ 11 ] +
									  ( RGBA[ 45 ][ 0 ] + RGBA[ 46 ][ 0 ] + RGBA[ 47 ][ 0 ] + RGBA[ 48 ][ 0 ] ) * iTable[ 12 ] +
									  ( RGBA[ 49 ][ 0 ] + RGBA[ 50 ][ 0 ] + RGBA[ 51 ][ 0 ] + RGBA[ 52 ][ 0 ] ) * iTable[ 13 ] +
									  ( RGBA[ 53 ][ 0 ] + RGBA[ 54 ][ 0 ] + RGBA[ 55 ][ 0 ] + RGBA[ 56 ][ 0 ] ) * iTable[ 14 ] +
									  ( RGBA[ 57 ][ 0 ] + RGBA[ 58 ][ 0 ] + RGBA[ 59 ][ 0 ] + RGBA[ 60 ][ 0 ] ) * iTable[ 15 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 1 ] = ( BYTE )(
								( RGBA[ 0 ][ 1 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 1 ] + RGBA[  2 ][ 1 ] + RGBA[  3 ][ 1 ] + RGBA[  4 ][ 1 ] ) * iTable[  1 ] +
									  ( RGBA[  5 ][ 1 ] + RGBA[  6 ][ 1 ] + RGBA[  7 ][ 1 ] + RGBA[  8 ][ 1 ] ) * iTable[  2 ] +
									  ( RGBA[  9 ][ 1 ] + RGBA[ 10 ][ 1 ] + RGBA[ 11 ][ 1 ] + RGBA[ 12 ][ 1 ] ) * iTable[  3 ] +
									  ( RGBA[ 13 ][ 1 ] + RGBA[ 14 ][ 1 ] + RGBA[ 15 ][ 1 ] + RGBA[ 16 ][ 1 ] ) * iTable[  4 ] +
									  ( RGBA[ 17 ][ 1 ] + RGBA[ 18 ][ 1 ] + RGBA[ 19 ][ 1 ] + RGBA[ 20 ][ 1 ] ) * iTable[  5 ] +
									  ( RGBA[ 21 ][ 1 ] + RGBA[ 22 ][ 1 ] + RGBA[ 23 ][ 1 ] + RGBA[ 24 ][ 1 ] ) * iTable[  6 ] +
									  ( RGBA[ 25 ][ 1 ] + RGBA[ 26 ][ 1 ] + RGBA[ 27 ][ 1 ] + RGBA[ 28 ][ 1 ] ) * iTable[  7 ] +
									  ( RGBA[ 29 ][ 1 ] + RGBA[ 30 ][ 1 ] + RGBA[ 31 ][ 1 ] + RGBA[ 32 ][ 1 ] ) * iTable[  8 ] +
									  ( RGBA[ 33 ][ 1 ] + RGBA[ 34 ][ 1 ] + RGBA[ 35 ][ 1 ] + RGBA[ 36 ][ 1 ] ) * iTable[  9 ] +
									  ( RGBA[ 37 ][ 1 ] + RGBA[ 38 ][ 1 ] + RGBA[ 39 ][ 1 ] + RGBA[ 40 ][ 1 ] ) * iTable[ 10 ] +
									  ( RGBA[ 41 ][ 1 ] + RGBA[ 42 ][ 1 ] + RGBA[ 43 ][ 1 ] + RGBA[ 44 ][ 1 ] ) * iTable[ 11 ] +
									  ( RGBA[ 45 ][ 1 ] + RGBA[ 46 ][ 1 ] + RGBA[ 47 ][ 1 ] + RGBA[ 48 ][ 1 ] ) * iTable[ 12 ] +
									  ( RGBA[ 49 ][ 1 ] + RGBA[ 50 ][ 1 ] + RGBA[ 51 ][ 1 ] + RGBA[ 52 ][ 1 ] ) * iTable[ 13 ] +
									  ( RGBA[ 53 ][ 1 ] + RGBA[ 54 ][ 1 ] + RGBA[ 55 ][ 1 ] + RGBA[ 56 ][ 1 ] ) * iTable[ 14 ] +
									  ( RGBA[ 57 ][ 1 ] + RGBA[ 58 ][ 1 ] + RGBA[ 59 ][ 1 ] + RGBA[ 60 ][ 1 ] ) * iTable[ 15 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 2 ] = ( BYTE )(
								( RGBA[ 0 ][ 2 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 2 ] + RGBA[  2 ][ 2 ] + RGBA[  3 ][ 2 ] + RGBA[  4 ][ 2 ] ) * iTable[  1 ] +
									  ( RGBA[  5 ][ 2 ] + RGBA[  6 ][ 2 ] + RGBA[  7 ][ 2 ] + RGBA[  8 ][ 2 ] ) * iTable[  2 ] +
									  ( RGBA[  9 ][ 2 ] + RGBA[ 10 ][ 2 ] + RGBA[ 11 ][ 2 ] + RGBA[ 12 ][ 2 ] ) * iTable[  3 ] +
									  ( RGBA[ 13 ][ 2 ] + RGBA[ 14 ][ 2 ] + RGBA[ 15 ][ 2 ] + RGBA[ 16 ][ 2 ] ) * iTable[  4 ] +
									  ( RGBA[ 17 ][ 2 ] + RGBA[ 18 ][ 2 ] + RGBA[ 19 ][ 2 ] + RGBA[ 20 ][ 2 ] ) * iTable[  5 ] +
									  ( RGBA[ 21 ][ 2 ] + RGBA[ 22 ][ 2 ] + RGBA[ 23 ][ 2 ] + RGBA[ 24 ][ 2 ] ) * iTable[  6 ] +
									  ( RGBA[ 25 ][ 2 ] + RGBA[ 26 ][ 2 ] + RGBA[ 27 ][ 2 ] + RGBA[ 28 ][ 2 ] ) * iTable[  7 ] +
									  ( RGBA[ 29 ][ 2 ] + RGBA[ 30 ][ 2 ] + RGBA[ 31 ][ 2 ] + RGBA[ 32 ][ 2 ] ) * iTable[  8 ] +
									  ( RGBA[ 33 ][ 2 ] + RGBA[ 34 ][ 2 ] + RGBA[ 35 ][ 2 ] + RGBA[ 36 ][ 2 ] ) * iTable[  9 ] +
									  ( RGBA[ 37 ][ 2 ] + RGBA[ 38 ][ 2 ] + RGBA[ 39 ][ 2 ] + RGBA[ 40 ][ 2 ] ) * iTable[ 10 ] +
									  ( RGBA[ 41 ][ 2 ] + RGBA[ 42 ][ 2 ] + RGBA[ 43 ][ 2 ] + RGBA[ 44 ][ 2 ] ) * iTable[ 11 ] +
									  ( RGBA[ 45 ][ 2 ] + RGBA[ 46 ][ 2 ] + RGBA[ 47 ][ 2 ] + RGBA[ 48 ][ 2 ] ) * iTable[ 12 ] +
									  ( RGBA[ 49 ][ 2 ] + RGBA[ 50 ][ 2 ] + RGBA[ 51 ][ 2 ] + RGBA[ 52 ][ 2 ] ) * iTable[ 13 ] +
									  ( RGBA[ 53 ][ 2 ] + RGBA[ 54 ][ 2 ] + RGBA[ 55 ][ 2 ] + RGBA[ 56 ][ 2 ] ) * iTable[ 14 ] +
									  ( RGBA[ 57 ][ 2 ] + RGBA[ 58 ][ 2 ] + RGBA[ 59 ][ 2 ] + RGBA[ 60 ][ 2 ] ) * iTable[ 15 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 3 ] = ( BYTE )(
								( RGBA[ 0 ][ 3 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 3 ] + RGBA[  2 ][ 3 ] + RGBA[  3 ][ 3 ] + RGBA[  4 ][ 3 ] ) * iTable[  1 ] +
									  ( RGBA[  5 ][ 3 ] + RGBA[  6 ][ 3 ] + RGBA[  7 ][ 3 ] + RGBA[  8 ][ 3 ] ) * iTable[  2 ] +
									  ( RGBA[  9 ][ 3 ] + RGBA[ 10 ][ 3 ] + RGBA[ 11 ][ 3 ] + RGBA[ 12 ][ 3 ] ) * iTable[  3 ] +
									  ( RGBA[ 13 ][ 3 ] + RGBA[ 14 ][ 3 ] + RGBA[ 15 ][ 3 ] + RGBA[ 16 ][ 3 ] ) * iTable[  4 ] +
									  ( RGBA[ 17 ][ 3 ] + RGBA[ 18 ][ 3 ] + RGBA[ 19 ][ 3 ] + RGBA[ 20 ][ 3 ] ) * iTable[  5 ] +
									  ( RGBA[ 21 ][ 3 ] + RGBA[ 22 ][ 3 ] + RGBA[ 23 ][ 3 ] + RGBA[ 24 ][ 3 ] ) * iTable[  6 ] +
									  ( RGBA[ 25 ][ 3 ] + RGBA[ 26 ][ 3 ] + RGBA[ 27 ][ 3 ] + RGBA[ 28 ][ 3 ] ) * iTable[  7 ] +
									  ( RGBA[ 29 ][ 3 ] + RGBA[ 30 ][ 3 ] + RGBA[ 31 ][ 3 ] + RGBA[ 32 ][ 3 ] ) * iTable[  8 ] +
									  ( RGBA[ 33 ][ 3 ] + RGBA[ 34 ][ 3 ] + RGBA[ 35 ][ 3 ] + RGBA[ 36 ][ 3 ] ) * iTable[  9 ] +
									  ( RGBA[ 37 ][ 3 ] + RGBA[ 38 ][ 3 ] + RGBA[ 39 ][ 3 ] + RGBA[ 40 ][ 3 ] ) * iTable[ 10 ] +
									  ( RGBA[ 41 ][ 3 ] + RGBA[ 42 ][ 3 ] + RGBA[ 43 ][ 3 ] + RGBA[ 44 ][ 3 ] ) * iTable[ 11 ] +
									  ( RGBA[ 45 ][ 3 ] + RGBA[ 46 ][ 3 ] + RGBA[ 47 ][ 3 ] + RGBA[ 48 ][ 3 ] ) * iTable[ 12 ] +
									  ( RGBA[ 49 ][ 3 ] + RGBA[ 50 ][ 3 ] + RGBA[ 51 ][ 3 ] + RGBA[ 52 ][ 3 ] ) * iTable[ 13 ] +
									  ( RGBA[ 53 ][ 3 ] + RGBA[ 54 ][ 3 ] + RGBA[ 55 ][ 3 ] + RGBA[ 56 ][ 3 ] ) * iTable[ 14 ] +
									  ( RGBA[ 57 ][ 3 ] + RGBA[ 58 ][ 3 ] + RGBA[ 59 ][ 3 ] + RGBA[ 60 ][ 3 ] ) * iTable[ 15 ] ) >> 1 ) ) >> 16 ) ;

							Src  += 4 ;
							Dest += 4 ;
						}

						Src  += SrcAddPitch ;
						Dest += DestAddPitch ;
					}
					break ;
				}

				Src = ( BYTE * )WorkImage.GraphData ;
				Dest = ( BYTE * )Info->DestImage.GraphData ;
				MinSrcStart = Src ;
				MaxSrcStart = Src + WorkImage.Pitch * ( Height - 1 ) ;

				SrcPitch     = WorkImage.Pitch ;
				SrcAddPitch  = WorkImage.Pitch       - Width * 4 ;
				DestAddPitch = Info->DestImage.Pitch - Width * 4 ;

				switch( PixelWidth )
				{
				case 8 :
					for( j = 0 ; j < Height ; j ++ )
					{
						MinSrc = MinSrcStart ;
						MaxSrc = MaxSrcStart ;

						for( i = 0 ; i < Width ; i ++ )
						{
							*( ( DWORD * )RGBA[  0 ] ) = *( ( DWORD * )Src ) ;
							*( ( DWORD * )RGBA[  1 ] ) = j < 1           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 1 ) ) ;
							*( ( DWORD * )RGBA[  2 ] ) = j < 2           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 2 ) ) ;
							*( ( DWORD * )RGBA[  3 ] ) = j + 1 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 1 ) ) ;
							*( ( DWORD * )RGBA[  4 ] ) = j + 2 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 2 ) ) ;
							*( ( DWORD * )RGBA[  5 ] ) = j < 3           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 3 ) ) ;
							*( ( DWORD * )RGBA[  6 ] ) = j < 4           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 4 ) ) ;
							*( ( DWORD * )RGBA[  7 ] ) = j + 3 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 3 ) ) ;
							*( ( DWORD * )RGBA[  8 ] ) = j + 4 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 4 ) ) ;
							*( ( DWORD * )RGBA[  9 ] ) = j < 5           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 5 ) ) ;
							*( ( DWORD * )RGBA[ 10 ] ) = j < 6           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 6 ) ) ;
							*( ( DWORD * )RGBA[ 11 ] ) = j + 5 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 5 ) ) ;
							*( ( DWORD * )RGBA[ 12 ] ) = j + 6 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 6 ) ) ;

							Dest[ 0 ] = ( BYTE )(
								( RGBA[ 0 ][ 0 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 0 ] + RGBA[  2 ][ 0 ] + RGBA[  3 ][ 0 ] + RGBA[  4 ][ 0 ] ) * iTable[ 1 ] +
									  ( RGBA[  5 ][ 0 ] + RGBA[  6 ][ 0 ] + RGBA[  7 ][ 0 ] + RGBA[  8 ][ 0 ] ) * iTable[ 2 ] +
									  ( RGBA[  9 ][ 0 ] + RGBA[ 10 ][ 0 ] + RGBA[ 11 ][ 0 ] + RGBA[ 12 ][ 0 ] ) * iTable[ 3 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 1 ] = ( BYTE )(
								( RGBA[ 0 ][ 1 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 1 ] + RGBA[  2 ][ 1 ] + RGBA[  3 ][ 1 ] + RGBA[  4 ][ 1 ] ) * iTable[ 1 ] +
									  ( RGBA[  5 ][ 1 ] + RGBA[  6 ][ 1 ] + RGBA[  7 ][ 1 ] + RGBA[  8 ][ 1 ] ) * iTable[ 2 ] +
									  ( RGBA[  9 ][ 1 ] + RGBA[ 10 ][ 1 ] + RGBA[ 11 ][ 1 ] + RGBA[ 12 ][ 1 ] ) * iTable[ 3 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 2 ] = ( BYTE )(
								( RGBA[ 0 ][ 2 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 2 ] + RGBA[  2 ][ 2 ] + RGBA[  3 ][ 2 ] + RGBA[  4 ][ 2 ] ) * iTable[ 1 ] +
									  ( RGBA[  5 ][ 2 ] + RGBA[  6 ][ 2 ] + RGBA[  7 ][ 2 ] + RGBA[  8 ][ 2 ] ) * iTable[ 2 ] +
									  ( RGBA[  9 ][ 2 ] + RGBA[ 10 ][ 2 ] + RGBA[ 11 ][ 2 ] + RGBA[ 12 ][ 2 ] ) * iTable[ 3 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 3 ] = ( BYTE )(
								( RGBA[ 0 ][ 3 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 3 ] + RGBA[  2 ][ 3 ] + RGBA[  3 ][ 3 ] + RGBA[  4 ][ 3 ] ) * iTable[ 1 ] +
									  ( RGBA[  5 ][ 3 ] + RGBA[  6 ][ 3 ] + RGBA[  7 ][ 3 ] + RGBA[  8 ][ 3 ] ) * iTable[ 2 ] +
									  ( RGBA[  9 ][ 3 ] + RGBA[ 10 ][ 3 ] + RGBA[ 11 ][ 3 ] + RGBA[ 12 ][ 3 ] ) * iTable[ 3 ] ) >> 1 ) ) >> 16 ) ;

							MinSrc += 4 ;
							MaxSrc += 4 ;
							Src  += 4 ;
							Dest += 4 ;
						}

						Src  += SrcAddPitch ;
						Dest += DestAddPitch ;
					}
					break ;

				case 16 :
					for( j = 0 ; j < Height ; j ++ )
					{
						MinSrc = MinSrcStart ;
						MaxSrc = MaxSrcStart ;

						for( i = 0 ; i < Width ; i ++ )
						{
							*( ( DWORD * )RGBA[  0 ] ) = *( ( DWORD * )Src ) ;
							*( ( DWORD * )RGBA[  1 ] ) = j <  1           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  1 ) ) ;
							*( ( DWORD * )RGBA[  2 ] ) = j <  2           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  2 ) ) ;
							*( ( DWORD * )RGBA[  3 ] ) = j +  1 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  1 ) ) ;
							*( ( DWORD * )RGBA[  4 ] ) = j +  2 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  2 ) ) ;
							*( ( DWORD * )RGBA[  5 ] ) = j <  3           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  3 ) ) ;
							*( ( DWORD * )RGBA[  6 ] ) = j <  4           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  4 ) ) ;
							*( ( DWORD * )RGBA[  7 ] ) = j +  3 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  3 ) ) ;
							*( ( DWORD * )RGBA[  8 ] ) = j +  4 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  4 ) ) ;
							*( ( DWORD * )RGBA[  9 ] ) = j <  5           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  5 ) ) ;
							*( ( DWORD * )RGBA[ 10 ] ) = j <  6           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  6 ) ) ;
							*( ( DWORD * )RGBA[ 11 ] ) = j +  5 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  5 ) ) ;
							*( ( DWORD * )RGBA[ 12 ] ) = j +  6 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  6 ) ) ;
							*( ( DWORD * )RGBA[ 13 ] ) = j <  7           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  7 ) ) ;
							*( ( DWORD * )RGBA[ 14 ] ) = j <  8           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  8 ) ) ;
							*( ( DWORD * )RGBA[ 15 ] ) = j +  7 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  7 ) ) ;
							*( ( DWORD * )RGBA[ 16 ] ) = j +  8 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  8 ) ) ;
							*( ( DWORD * )RGBA[ 17 ] ) = j <  9           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  9 ) ) ;
							*( ( DWORD * )RGBA[ 18 ] ) = j < 10           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 10 ) ) ;
							*( ( DWORD * )RGBA[ 19 ] ) = j +  9 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  9 ) ) ;
							*( ( DWORD * )RGBA[ 20 ] ) = j + 10 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 10 ) ) ;
							*( ( DWORD * )RGBA[ 21 ] ) = j < 11           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 11 ) ) ;
							*( ( DWORD * )RGBA[ 22 ] ) = j < 12           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 12 ) ) ;
							*( ( DWORD * )RGBA[ 23 ] ) = j + 11 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 11 ) ) ;
							*( ( DWORD * )RGBA[ 24 ] ) = j + 12 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 12 ) ) ;
							*( ( DWORD * )RGBA[ 25 ] ) = j < 13           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 13 ) ) ;
							*( ( DWORD * )RGBA[ 26 ] ) = j < 14           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 14 ) ) ;
							*( ( DWORD * )RGBA[ 27 ] ) = j + 13 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 13 ) ) ;
							*( ( DWORD * )RGBA[ 28 ] ) = j + 14 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 14 ) ) ;

							Dest[ 0 ] = ( BYTE )(
								( RGBA[ 0 ][ 0 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 0 ] + RGBA[  2 ][ 0 ] + RGBA[  3 ][ 0 ] + RGBA[  4 ][ 0 ] ) * iTable[ 1 ] +
									  ( RGBA[  5 ][ 0 ] + RGBA[  6 ][ 0 ] + RGBA[  7 ][ 0 ] + RGBA[  8 ][ 0 ] ) * iTable[ 2 ] +
									  ( RGBA[  9 ][ 0 ] + RGBA[ 10 ][ 0 ] + RGBA[ 11 ][ 0 ] + RGBA[ 12 ][ 0 ] ) * iTable[ 3 ] +
									  ( RGBA[ 13 ][ 0 ] + RGBA[ 14 ][ 0 ] + RGBA[ 15 ][ 0 ] + RGBA[ 16 ][ 0 ] ) * iTable[ 4 ] +
									  ( RGBA[ 17 ][ 0 ] + RGBA[ 18 ][ 0 ] + RGBA[ 19 ][ 0 ] + RGBA[ 20 ][ 0 ] ) * iTable[ 5 ] +
									  ( RGBA[ 21 ][ 0 ] + RGBA[ 22 ][ 0 ] + RGBA[ 23 ][ 0 ] + RGBA[ 24 ][ 0 ] ) * iTable[ 6 ] +
									  ( RGBA[ 25 ][ 0 ] + RGBA[ 26 ][ 0 ] + RGBA[ 27 ][ 0 ] + RGBA[ 28 ][ 0 ] ) * iTable[ 7 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 1 ] = ( BYTE )(
								( RGBA[ 0 ][ 1 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 1 ] + RGBA[  2 ][ 1 ] + RGBA[  3 ][ 1 ] + RGBA[  4 ][ 1 ] ) * iTable[ 1 ] +
									  ( RGBA[  5 ][ 1 ] + RGBA[  6 ][ 1 ] + RGBA[  7 ][ 1 ] + RGBA[  8 ][ 1 ] ) * iTable[ 2 ] +
									  ( RGBA[  9 ][ 1 ] + RGBA[ 10 ][ 1 ] + RGBA[ 11 ][ 1 ] + RGBA[ 12 ][ 1 ] ) * iTable[ 3 ] +
									  ( RGBA[ 13 ][ 1 ] + RGBA[ 14 ][ 1 ] + RGBA[ 15 ][ 1 ] + RGBA[ 16 ][ 1 ] ) * iTable[ 4 ] +
									  ( RGBA[ 17 ][ 1 ] + RGBA[ 18 ][ 1 ] + RGBA[ 19 ][ 1 ] + RGBA[ 20 ][ 1 ] ) * iTable[ 5 ] +
									  ( RGBA[ 21 ][ 1 ] + RGBA[ 22 ][ 1 ] + RGBA[ 23 ][ 1 ] + RGBA[ 24 ][ 1 ] ) * iTable[ 6 ] +
									  ( RGBA[ 25 ][ 1 ] + RGBA[ 26 ][ 1 ] + RGBA[ 27 ][ 1 ] + RGBA[ 28 ][ 1 ] ) * iTable[ 7 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 2 ] = ( BYTE )(
								( RGBA[ 0 ][ 2 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 2 ] + RGBA[  2 ][ 2 ] + RGBA[  3 ][ 2 ] + RGBA[  4 ][ 2 ] ) * iTable[ 1 ] +
									  ( RGBA[  5 ][ 2 ] + RGBA[  6 ][ 2 ] + RGBA[  7 ][ 2 ] + RGBA[  8 ][ 2 ] ) * iTable[ 2 ] +
									  ( RGBA[  9 ][ 2 ] + RGBA[ 10 ][ 2 ] + RGBA[ 11 ][ 2 ] + RGBA[ 12 ][ 2 ] ) * iTable[ 3 ] +
									  ( RGBA[ 13 ][ 2 ] + RGBA[ 14 ][ 2 ] + RGBA[ 15 ][ 2 ] + RGBA[ 16 ][ 2 ] ) * iTable[ 4 ] +
									  ( RGBA[ 17 ][ 2 ] + RGBA[ 18 ][ 2 ] + RGBA[ 19 ][ 2 ] + RGBA[ 20 ][ 2 ] ) * iTable[ 5 ] +
									  ( RGBA[ 21 ][ 2 ] + RGBA[ 22 ][ 2 ] + RGBA[ 23 ][ 2 ] + RGBA[ 24 ][ 2 ] ) * iTable[ 6 ] +
									  ( RGBA[ 25 ][ 2 ] + RGBA[ 26 ][ 2 ] + RGBA[ 27 ][ 2 ] + RGBA[ 28 ][ 2 ] ) * iTable[ 7 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 3 ] = ( BYTE )(
								( RGBA[ 0 ][ 3 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 3 ] + RGBA[  2 ][ 3 ] + RGBA[  3 ][ 3 ] + RGBA[  4 ][ 3 ] ) * iTable[ 1 ] +
									  ( RGBA[  5 ][ 3 ] + RGBA[  6 ][ 3 ] + RGBA[  7 ][ 3 ] + RGBA[  8 ][ 3 ] ) * iTable[ 2 ] +
									  ( RGBA[  9 ][ 3 ] + RGBA[ 10 ][ 3 ] + RGBA[ 11 ][ 3 ] + RGBA[ 12 ][ 3 ] ) * iTable[ 3 ] +
									  ( RGBA[ 13 ][ 3 ] + RGBA[ 14 ][ 3 ] + RGBA[ 15 ][ 3 ] + RGBA[ 16 ][ 3 ] ) * iTable[ 4 ] +
									  ( RGBA[ 17 ][ 3 ] + RGBA[ 18 ][ 3 ] + RGBA[ 19 ][ 3 ] + RGBA[ 20 ][ 3 ] ) * iTable[ 5 ] +
									  ( RGBA[ 21 ][ 3 ] + RGBA[ 22 ][ 3 ] + RGBA[ 23 ][ 3 ] + RGBA[ 24 ][ 3 ] ) * iTable[ 6 ] +
									  ( RGBA[ 25 ][ 3 ] + RGBA[ 26 ][ 3 ] + RGBA[ 27 ][ 3 ] + RGBA[ 28 ][ 3 ] ) * iTable[ 7 ] ) >> 1 ) ) >> 16 ) ;

							MinSrc += 4 ;
							MaxSrc += 4 ;
							Src  += 4 ;
							Dest += 4 ;
						}

						Src  += SrcAddPitch ;
						Dest += DestAddPitch ;
					}
					break ;

				case 32 :
					for( j = 0 ; j < Height ; j ++ )
					{
						MinSrc = MinSrcStart ;
						MaxSrc = MaxSrcStart ;

						for( i = 0 ; i < Width ; i ++ )
						{
							*( ( DWORD * )RGBA[  0 ] ) = *( ( DWORD * )Src ) ;
							*( ( DWORD * )RGBA[  1 ] ) = j <  1           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  1 ) ) ;
							*( ( DWORD * )RGBA[  2 ] ) = j <  2           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  2 ) ) ;
							*( ( DWORD * )RGBA[  3 ] ) = j +  1 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  1 ) ) ;
							*( ( DWORD * )RGBA[  4 ] ) = j +  2 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  2 ) ) ;
							*( ( DWORD * )RGBA[  5 ] ) = j <  3           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  3 ) ) ;
							*( ( DWORD * )RGBA[  6 ] ) = j <  4           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  4 ) ) ;
							*( ( DWORD * )RGBA[  7 ] ) = j +  3 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  3 ) ) ;
							*( ( DWORD * )RGBA[  8 ] ) = j +  4 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  4 ) ) ;
							*( ( DWORD * )RGBA[  9 ] ) = j <  5           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  5 ) ) ;
							*( ( DWORD * )RGBA[ 10 ] ) = j <  6           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  6 ) ) ;
							*( ( DWORD * )RGBA[ 11 ] ) = j +  5 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  5 ) ) ;
							*( ( DWORD * )RGBA[ 12 ] ) = j +  6 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  6 ) ) ;
							*( ( DWORD * )RGBA[ 13 ] ) = j <  7           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  7 ) ) ;
							*( ( DWORD * )RGBA[ 14 ] ) = j <  8           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  8 ) ) ;
							*( ( DWORD * )RGBA[ 15 ] ) = j +  7 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  7 ) ) ;
							*( ( DWORD * )RGBA[ 16 ] ) = j +  8 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  8 ) ) ;
							*( ( DWORD * )RGBA[ 17 ] ) = j <  9           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  9 ) ) ;
							*( ( DWORD * )RGBA[ 18 ] ) = j < 10           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 10 ) ) ;
							*( ( DWORD * )RGBA[ 19 ] ) = j +  9 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  9 ) ) ;
							*( ( DWORD * )RGBA[ 20 ] ) = j + 10 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 10 ) ) ;
							*( ( DWORD * )RGBA[ 21 ] ) = j < 11           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 11 ) ) ;
							*( ( DWORD * )RGBA[ 22 ] ) = j < 12           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 12 ) ) ;
							*( ( DWORD * )RGBA[ 23 ] ) = j + 11 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 11 ) ) ;
							*( ( DWORD * )RGBA[ 24 ] ) = j + 12 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 12 ) ) ;
							*( ( DWORD * )RGBA[ 25 ] ) = j < 13           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 13 ) ) ;
							*( ( DWORD * )RGBA[ 26 ] ) = j < 14           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 14 ) ) ;
							*( ( DWORD * )RGBA[ 27 ] ) = j + 13 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 13 ) ) ;
							*( ( DWORD * )RGBA[ 28 ] ) = j + 14 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 14 ) ) ;
							*( ( DWORD * )RGBA[ 29 ] ) = j < 15           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 15 ) ) ;
							*( ( DWORD * )RGBA[ 30 ] ) = j < 16           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 16 ) ) ;
							*( ( DWORD * )RGBA[ 31 ] ) = j + 15 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 15 ) ) ;
							*( ( DWORD * )RGBA[ 32 ] ) = j + 16 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 16 ) ) ;
							*( ( DWORD * )RGBA[ 33 ] ) = j < 17           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 17 ) ) ;
							*( ( DWORD * )RGBA[ 34 ] ) = j < 18           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 18 ) ) ;
							*( ( DWORD * )RGBA[ 35 ] ) = j + 17 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 17 ) ) ;
							*( ( DWORD * )RGBA[ 36 ] ) = j + 18 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 18 ) ) ;
							*( ( DWORD * )RGBA[ 37 ] ) = j < 19           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 19 ) ) ;
							*( ( DWORD * )RGBA[ 38 ] ) = j < 20           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 20 ) ) ;
							*( ( DWORD * )RGBA[ 39 ] ) = j + 19 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 19 ) ) ;
							*( ( DWORD * )RGBA[ 40 ] ) = j + 20 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 20 ) ) ;
							*( ( DWORD * )RGBA[ 41 ] ) = j < 21           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 21 ) ) ;
							*( ( DWORD * )RGBA[ 42 ] ) = j < 22           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 22 ) ) ;
							*( ( DWORD * )RGBA[ 43 ] ) = j + 21 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 21 ) ) ;
							*( ( DWORD * )RGBA[ 44 ] ) = j + 22 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 22 ) ) ;
							*( ( DWORD * )RGBA[ 45 ] ) = j < 23           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 23 ) ) ;
							*( ( DWORD * )RGBA[ 46 ] ) = j < 24           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 24 ) ) ;
							*( ( DWORD * )RGBA[ 47 ] ) = j + 23 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 23 ) ) ;
							*( ( DWORD * )RGBA[ 48 ] ) = j + 24 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 24 ) ) ;
							*( ( DWORD * )RGBA[ 49 ] ) = j < 25           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 25 ) ) ;
							*( ( DWORD * )RGBA[ 50 ] ) = j < 26           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 26 ) ) ;
							*( ( DWORD * )RGBA[ 51 ] ) = j + 25 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 25 ) ) ;
							*( ( DWORD * )RGBA[ 52 ] ) = j + 26 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 26 ) ) ;
							*( ( DWORD * )RGBA[ 53 ] ) = j < 27           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 27 ) ) ;
							*( ( DWORD * )RGBA[ 54 ] ) = j < 28           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 28 ) ) ;
							*( ( DWORD * )RGBA[ 55 ] ) = j + 27 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 27 ) ) ;
							*( ( DWORD * )RGBA[ 56 ] ) = j + 28 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 28 ) ) ;
							*( ( DWORD * )RGBA[ 57 ] ) = j < 29           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 29 ) ) ;
							*( ( DWORD * )RGBA[ 58 ] ) = j < 30           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 30 ) ) ;
							*( ( DWORD * )RGBA[ 59 ] ) = j + 29 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 29 ) ) ;
							*( ( DWORD * )RGBA[ 60 ] ) = j + 30 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 30 ) ) ;

							Dest[ 0 ] = ( BYTE )(
								( RGBA[ 0 ][ 0 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 0 ] + RGBA[  2 ][ 0 ] + RGBA[  3 ][ 0 ] + RGBA[  4 ][ 0 ] ) * iTable[  1 ] +
									  ( RGBA[  5 ][ 0 ] + RGBA[  6 ][ 0 ] + RGBA[  7 ][ 0 ] + RGBA[  8 ][ 0 ] ) * iTable[  2 ] +
									  ( RGBA[  9 ][ 0 ] + RGBA[ 10 ][ 0 ] + RGBA[ 11 ][ 0 ] + RGBA[ 12 ][ 0 ] ) * iTable[  3 ] +
									  ( RGBA[ 13 ][ 0 ] + RGBA[ 14 ][ 0 ] + RGBA[ 15 ][ 0 ] + RGBA[ 16 ][ 0 ] ) * iTable[  4 ] +
									  ( RGBA[ 17 ][ 0 ] + RGBA[ 18 ][ 0 ] + RGBA[ 19 ][ 0 ] + RGBA[ 20 ][ 0 ] ) * iTable[  5 ] +
									  ( RGBA[ 21 ][ 0 ] + RGBA[ 22 ][ 0 ] + RGBA[ 23 ][ 0 ] + RGBA[ 24 ][ 0 ] ) * iTable[  6 ] +
									  ( RGBA[ 25 ][ 0 ] + RGBA[ 26 ][ 0 ] + RGBA[ 27 ][ 0 ] + RGBA[ 28 ][ 0 ] ) * iTable[  7 ] +
									  ( RGBA[ 29 ][ 0 ] + RGBA[ 30 ][ 0 ] + RGBA[ 31 ][ 0 ] + RGBA[ 32 ][ 0 ] ) * iTable[  8 ] +
									  ( RGBA[ 33 ][ 0 ] + RGBA[ 34 ][ 0 ] + RGBA[ 35 ][ 0 ] + RGBA[ 36 ][ 0 ] ) * iTable[  9 ] +
									  ( RGBA[ 37 ][ 0 ] + RGBA[ 38 ][ 0 ] + RGBA[ 39 ][ 0 ] + RGBA[ 40 ][ 0 ] ) * iTable[ 10 ] +
									  ( RGBA[ 41 ][ 0 ] + RGBA[ 42 ][ 0 ] + RGBA[ 43 ][ 0 ] + RGBA[ 44 ][ 0 ] ) * iTable[ 11 ] +
									  ( RGBA[ 45 ][ 0 ] + RGBA[ 46 ][ 0 ] + RGBA[ 47 ][ 0 ] + RGBA[ 48 ][ 0 ] ) * iTable[ 12 ] +
									  ( RGBA[ 49 ][ 0 ] + RGBA[ 50 ][ 0 ] + RGBA[ 51 ][ 0 ] + RGBA[ 52 ][ 0 ] ) * iTable[ 13 ] +
									  ( RGBA[ 53 ][ 0 ] + RGBA[ 54 ][ 0 ] + RGBA[ 55 ][ 0 ] + RGBA[ 56 ][ 0 ] ) * iTable[ 14 ] +
									  ( RGBA[ 57 ][ 0 ] + RGBA[ 58 ][ 0 ] + RGBA[ 59 ][ 0 ] + RGBA[ 60 ][ 0 ] ) * iTable[ 15 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 1 ] = ( BYTE )(
								( RGBA[ 0 ][ 1 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 1 ] + RGBA[  2 ][ 1 ] + RGBA[  3 ][ 1 ] + RGBA[  4 ][ 1 ] ) * iTable[  1 ] +
									  ( RGBA[  5 ][ 1 ] + RGBA[  6 ][ 1 ] + RGBA[  7 ][ 1 ] + RGBA[  8 ][ 1 ] ) * iTable[  2 ] +
									  ( RGBA[  9 ][ 1 ] + RGBA[ 10 ][ 1 ] + RGBA[ 11 ][ 1 ] + RGBA[ 12 ][ 1 ] ) * iTable[  3 ] +
									  ( RGBA[ 13 ][ 1 ] + RGBA[ 14 ][ 1 ] + RGBA[ 15 ][ 1 ] + RGBA[ 16 ][ 1 ] ) * iTable[  4 ] +
									  ( RGBA[ 17 ][ 1 ] + RGBA[ 18 ][ 1 ] + RGBA[ 19 ][ 1 ] + RGBA[ 20 ][ 1 ] ) * iTable[  5 ] +
									  ( RGBA[ 21 ][ 1 ] + RGBA[ 22 ][ 1 ] + RGBA[ 23 ][ 1 ] + RGBA[ 24 ][ 1 ] ) * iTable[  6 ] +
									  ( RGBA[ 25 ][ 1 ] + RGBA[ 26 ][ 1 ] + RGBA[ 27 ][ 1 ] + RGBA[ 28 ][ 1 ] ) * iTable[  7 ] +
									  ( RGBA[ 29 ][ 1 ] + RGBA[ 30 ][ 1 ] + RGBA[ 31 ][ 1 ] + RGBA[ 32 ][ 1 ] ) * iTable[  8 ] +
									  ( RGBA[ 33 ][ 1 ] + RGBA[ 34 ][ 1 ] + RGBA[ 35 ][ 1 ] + RGBA[ 36 ][ 1 ] ) * iTable[  9 ] +
									  ( RGBA[ 37 ][ 1 ] + RGBA[ 38 ][ 1 ] + RGBA[ 39 ][ 1 ] + RGBA[ 40 ][ 1 ] ) * iTable[ 10 ] +
									  ( RGBA[ 41 ][ 1 ] + RGBA[ 42 ][ 1 ] + RGBA[ 43 ][ 1 ] + RGBA[ 44 ][ 1 ] ) * iTable[ 11 ] +
									  ( RGBA[ 45 ][ 1 ] + RGBA[ 46 ][ 1 ] + RGBA[ 47 ][ 1 ] + RGBA[ 48 ][ 1 ] ) * iTable[ 12 ] +
									  ( RGBA[ 49 ][ 1 ] + RGBA[ 50 ][ 1 ] + RGBA[ 51 ][ 1 ] + RGBA[ 52 ][ 1 ] ) * iTable[ 13 ] +
									  ( RGBA[ 53 ][ 1 ] + RGBA[ 54 ][ 1 ] + RGBA[ 55 ][ 1 ] + RGBA[ 56 ][ 1 ] ) * iTable[ 14 ] +
									  ( RGBA[ 57 ][ 1 ] + RGBA[ 58 ][ 1 ] + RGBA[ 59 ][ 1 ] + RGBA[ 60 ][ 1 ] ) * iTable[ 15 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 2 ] = ( BYTE )(
								( RGBA[ 0 ][ 2 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 2 ] + RGBA[  2 ][ 2 ] + RGBA[  3 ][ 2 ] + RGBA[  4 ][ 2 ] ) * iTable[  1 ] +
									  ( RGBA[  5 ][ 2 ] + RGBA[  6 ][ 2 ] + RGBA[  7 ][ 2 ] + RGBA[  8 ][ 2 ] ) * iTable[  2 ] +
									  ( RGBA[  9 ][ 2 ] + RGBA[ 10 ][ 2 ] + RGBA[ 11 ][ 2 ] + RGBA[ 12 ][ 2 ] ) * iTable[  3 ] +
									  ( RGBA[ 13 ][ 2 ] + RGBA[ 14 ][ 2 ] + RGBA[ 15 ][ 2 ] + RGBA[ 16 ][ 2 ] ) * iTable[  4 ] +
									  ( RGBA[ 17 ][ 2 ] + RGBA[ 18 ][ 2 ] + RGBA[ 19 ][ 2 ] + RGBA[ 20 ][ 2 ] ) * iTable[  5 ] +
									  ( RGBA[ 21 ][ 2 ] + RGBA[ 22 ][ 2 ] + RGBA[ 23 ][ 2 ] + RGBA[ 24 ][ 2 ] ) * iTable[  6 ] +
									  ( RGBA[ 25 ][ 2 ] + RGBA[ 26 ][ 2 ] + RGBA[ 27 ][ 2 ] + RGBA[ 28 ][ 2 ] ) * iTable[  7 ] +
									  ( RGBA[ 29 ][ 2 ] + RGBA[ 30 ][ 2 ] + RGBA[ 31 ][ 2 ] + RGBA[ 32 ][ 2 ] ) * iTable[  8 ] +
									  ( RGBA[ 33 ][ 2 ] + RGBA[ 34 ][ 2 ] + RGBA[ 35 ][ 2 ] + RGBA[ 36 ][ 2 ] ) * iTable[  9 ] +
									  ( RGBA[ 37 ][ 2 ] + RGBA[ 38 ][ 2 ] + RGBA[ 39 ][ 2 ] + RGBA[ 40 ][ 2 ] ) * iTable[ 10 ] +
									  ( RGBA[ 41 ][ 2 ] + RGBA[ 42 ][ 2 ] + RGBA[ 43 ][ 2 ] + RGBA[ 44 ][ 2 ] ) * iTable[ 11 ] +
									  ( RGBA[ 45 ][ 2 ] + RGBA[ 46 ][ 2 ] + RGBA[ 47 ][ 2 ] + RGBA[ 48 ][ 2 ] ) * iTable[ 12 ] +
									  ( RGBA[ 49 ][ 2 ] + RGBA[ 50 ][ 2 ] + RGBA[ 51 ][ 2 ] + RGBA[ 52 ][ 2 ] ) * iTable[ 13 ] +
									  ( RGBA[ 53 ][ 2 ] + RGBA[ 54 ][ 2 ] + RGBA[ 55 ][ 2 ] + RGBA[ 56 ][ 2 ] ) * iTable[ 14 ] +
									  ( RGBA[ 57 ][ 2 ] + RGBA[ 58 ][ 2 ] + RGBA[ 59 ][ 2 ] + RGBA[ 60 ][ 2 ] ) * iTable[ 15 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 3 ] = ( BYTE )(
								( RGBA[ 0 ][ 3 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 3 ] + RGBA[  2 ][ 3 ] + RGBA[  3 ][ 3 ] + RGBA[  4 ][ 3 ] ) * iTable[  1 ] +
									  ( RGBA[  5 ][ 3 ] + RGBA[  6 ][ 3 ] + RGBA[  7 ][ 3 ] + RGBA[  8 ][ 3 ] ) * iTable[  2 ] +
									  ( RGBA[  9 ][ 3 ] + RGBA[ 10 ][ 3 ] + RGBA[ 11 ][ 3 ] + RGBA[ 12 ][ 3 ] ) * iTable[  3 ] +
									  ( RGBA[ 13 ][ 3 ] + RGBA[ 14 ][ 3 ] + RGBA[ 15 ][ 3 ] + RGBA[ 16 ][ 3 ] ) * iTable[  4 ] +
									  ( RGBA[ 17 ][ 3 ] + RGBA[ 18 ][ 3 ] + RGBA[ 19 ][ 3 ] + RGBA[ 20 ][ 3 ] ) * iTable[  5 ] +
									  ( RGBA[ 21 ][ 3 ] + RGBA[ 22 ][ 3 ] + RGBA[ 23 ][ 3 ] + RGBA[ 24 ][ 3 ] ) * iTable[  6 ] +
									  ( RGBA[ 25 ][ 3 ] + RGBA[ 26 ][ 3 ] + RGBA[ 27 ][ 3 ] + RGBA[ 28 ][ 3 ] ) * iTable[  7 ] +
									  ( RGBA[ 29 ][ 3 ] + RGBA[ 30 ][ 3 ] + RGBA[ 31 ][ 3 ] + RGBA[ 32 ][ 3 ] ) * iTable[  8 ] +
									  ( RGBA[ 33 ][ 3 ] + RGBA[ 34 ][ 3 ] + RGBA[ 35 ][ 3 ] + RGBA[ 36 ][ 3 ] ) * iTable[  9 ] +
									  ( RGBA[ 37 ][ 3 ] + RGBA[ 38 ][ 3 ] + RGBA[ 39 ][ 3 ] + RGBA[ 40 ][ 3 ] ) * iTable[ 10 ] +
									  ( RGBA[ 41 ][ 3 ] + RGBA[ 42 ][ 3 ] + RGBA[ 43 ][ 3 ] + RGBA[ 44 ][ 3 ] ) * iTable[ 11 ] +
									  ( RGBA[ 45 ][ 3 ] + RGBA[ 46 ][ 3 ] + RGBA[ 47 ][ 3 ] + RGBA[ 48 ][ 3 ] ) * iTable[ 12 ] +
									  ( RGBA[ 49 ][ 3 ] + RGBA[ 50 ][ 3 ] + RGBA[ 51 ][ 3 ] + RGBA[ 52 ][ 3 ] ) * iTable[ 13 ] +
									  ( RGBA[ 53 ][ 3 ] + RGBA[ 54 ][ 3 ] + RGBA[ 55 ][ 3 ] + RGBA[ 56 ][ 3 ] ) * iTable[ 14 ] +
									  ( RGBA[ 57 ][ 3 ] + RGBA[ 58 ][ 3 ] + RGBA[ 59 ][ 3 ] + RGBA[ 60 ][ 3 ] ) * iTable[ 15 ] ) >> 1 ) ) >> 16 ) ;

							MinSrc += 4 ;
							MaxSrc += 4 ;
							Src  += 4 ;
							Dest += 4 ;
						}

						Src  += SrcAddPitch ;
						Dest += DestAddPitch ;
					}
					break ;
				}

				NS_ReleaseBaseImage( &WorkImage ) ;
			}
		}

		GraphFilter_SoftImageTerminate( Info ) ;
	}

	// I
	return 0 ;
}

static int GraphFilter_Down_Scale( GRAPHFILTER_INFO *Info, int DivNum )
{
	// p[^␳
	if( DivNum <= 2 )
	{
		DivNum = 2 ;
	}
	else
	if( DivNum <= 4 )
	{
		DivNum = 4 ;
	}
	else
	{
		DivNum = 8 ;
	}

	// VF[_[g邩ǂŏ𕪊
	if( GRH.UseShader == TRUE )
	{
		static const char *PsoFileName[ 3 ] =
		{
			"DownScaleX2.pso",
			"DownScaleX4.pso",
			"DownScaleX8.pso",
		} ;
		LIBSHADER_DRAWPARAMTEMP DrawParamTemp ;
		IMAGEDATA2 *SrcImage2 ;
		int UseShader = 0 ;
		int UseConstNum = 0 ;
		FLOAT4 ParamF4[ 16 ] ;
		float TextureW ;
		float TextureH ;
		int i ;

		if( GRAPHCHK( Info->SrcGrHandle, SrcImage2 ) )
			return -1 ;

		// gpVF[_[̃ZbgAbv
		switch( DivNum )
		{
		case 2 : UseShader = 0 ; break ;
		case 4 : UseShader = 1 ; break ;
		case 8 : UseShader = 2 ; break ;
		}
		if( GRH.ShaderCode.DownScalePS[ UseShader ] < 0 )
		{
			GRH.ShaderCode.DownScalePS[ UseShader ] = MemLoadShaderCode( PsoFileName[ UseShader ], false ) ;
			if( GRH.ShaderCode.DownScalePS[ UseShader ] < 0 )
			{
				DXST_ERRORLOGFMT_ADD(( _T( "tB^[pVF[_[̍쐬Ɏs܂ %s" ), PsoFileName[ UseShader ] )) ;
				return -1 ;
			}
			NS_SetDeleteHandleFlag( GRH.ShaderCode.DownScalePS[ UseShader ], &GRH.ShaderCode.DownScalePS[ UseShader ] ) ;
		}

		LibShader_PushShaderParam( &DrawParamTemp, 1 ) ;

		switch( DivNum )
		{
		case 2 :
			ParamF4[  0 ].x = 0.0f ; ParamF4[  0 ].y = 0.0f ; ParamF4[  0 ].z = 0.0f ; ParamF4[  0 ].w = 0.0f ;
			UseConstNum = 1 ;
			break ;

		case 4 :
			ParamF4[  0 ].x = -1.0f ; ParamF4[  0 ].y = -1.0f ; ParamF4[  0 ].z = 0.0f ; ParamF4[  0 ].w = 0.0f ;
			ParamF4[  1 ].x =  1.0f ; ParamF4[  1 ].y = -1.0f ; ParamF4[  1 ].z = 0.0f ; ParamF4[  1 ].w = 0.0f ;
			ParamF4[  2 ].x = -1.0f ; ParamF4[  2 ].y =  1.0f ; ParamF4[  2 ].z = 0.0f ; ParamF4[  2 ].w = 0.0f ;
			ParamF4[  3 ].x =  1.0f ; ParamF4[  3 ].y =  1.0f ; ParamF4[  3 ].z = 0.0f ; ParamF4[  3 ].w = 0.0f ;
			UseConstNum = 4 ;
			break ;

		case 8 :
			ParamF4[  0 ].x = -3.0f ; ParamF4[  0 ].y = -3.0f ; ParamF4[  0 ].z = 0.0f ; ParamF4[  0 ].w = 0.0f ;
			ParamF4[  1 ].x = -1.0f ; ParamF4[  1 ].y = -3.0f ; ParamF4[  1 ].z = 0.0f ; ParamF4[  1 ].w = 0.0f ;
			ParamF4[  2 ].x =  1.0f ; ParamF4[  2 ].y = -3.0f ; ParamF4[  2 ].z = 0.0f ; ParamF4[  2 ].w = 0.0f ;
			ParamF4[  3 ].x =  3.0f ; ParamF4[  3 ].y = -3.0f ; ParamF4[  3 ].z = 0.0f ; ParamF4[  3 ].w = 0.0f ;
			ParamF4[  4 ].x = -3.0f ; ParamF4[  4 ].y = -1.0f ; ParamF4[  4 ].z = 0.0f ; ParamF4[  4 ].w = 0.0f ;
			ParamF4[  5 ].x = -1.0f ; ParamF4[  5 ].y = -1.0f ; ParamF4[  5 ].z = 0.0f ; ParamF4[  5 ].w = 0.0f ;
			ParamF4[  6 ].x =  1.0f ; ParamF4[  6 ].y = -1.0f ; ParamF4[  6 ].z = 0.0f ; ParamF4[  6 ].w = 0.0f ;
			ParamF4[  7 ].x =  3.0f ; ParamF4[  7 ].y = -1.0f ; ParamF4[  7 ].z = 0.0f ; ParamF4[  7 ].w = 0.0f ;
			ParamF4[  8 ].x = -3.0f ; ParamF4[  8 ].y =  1.0f ; ParamF4[  8 ].z = 0.0f ; ParamF4[  8 ].w = 0.0f ;
			ParamF4[  9 ].x = -1.0f ; ParamF4[  9 ].y =  1.0f ; ParamF4[  9 ].z = 0.0f ; ParamF4[  9 ].w = 0.0f ;
			ParamF4[ 10 ].x =  1.0f ; ParamF4[ 10 ].y =  1.0f ; ParamF4[ 10 ].z = 0.0f ; ParamF4[ 10 ].w = 0.0f ;
			ParamF4[ 11 ].x =  3.0f ; ParamF4[ 11 ].y =  1.0f ; ParamF4[ 11 ].z = 0.0f ; ParamF4[ 11 ].w = 0.0f ;
			ParamF4[ 12 ].x = -3.0f ; ParamF4[ 12 ].y =  3.0f ; ParamF4[ 12 ].z = 0.0f ; ParamF4[ 12 ].w = 0.0f ;
			ParamF4[ 13 ].x = -1.0f ; ParamF4[ 13 ].y =  3.0f ; ParamF4[ 13 ].z = 0.0f ; ParamF4[ 13 ].w = 0.0f ;
			ParamF4[ 14 ].x =  1.0f ; ParamF4[ 14 ].y =  3.0f ; ParamF4[ 14 ].z = 0.0f ; ParamF4[ 14 ].w = 0.0f ;
			ParamF4[ 15 ].x =  3.0f ; ParamF4[ 15 ].y =  3.0f ; ParamF4[ 15 ].z = 0.0f ; ParamF4[ 15 ].w = 0.0f ;
			UseConstNum = 16 ;
			break ;
		}
		TextureW = ( float )SrcImage2->Orig->Hard.Tex[ 0 ].TexWidth ;
		TextureH = ( float )SrcImage2->Orig->Hard.Tex[ 0 ].TexHeight ;
		for( i = 0 ; i < UseConstNum ; i ++ )
		{
			ParamF4[ i ].x /= TextureW ;
			ParamF4[ i ].y /= TextureH ;
		}
		SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, ParamF4, UseConstNum, FALSE ) ;

		NS_SetUsePixelShader( GRH.ShaderCode.DownScalePS[ UseShader ] ) ;

		GraphFilter_BasePolygonDraw( Info, DivNum ) ;

		LibShader_PopShaderParam( &DrawParamTemp ) ;

		ResetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, UseConstNum ) ;
	}
	else
	{
		// VF[_[gȂꍇ

		BYTE *Src ;
		BYTE *Dest ;
		DWORD i ;
		DWORD SrcWidth ;
		DWORD SrcHeight ;
		DWORD Width ;
		DWORD Height ;
		DWORD SrcPitch ;
		DWORD SrcAddPitch ;
		DWORD DestAddPitch ;

		SrcWidth  = Info->SrcX2 - Info->SrcX1 ;
		SrcHeight = Info->SrcY2 - Info->SrcY1 ;
		Width  = SrcWidth  / DivNum ;
		Height = SrcHeight / DivNum ;

		if( GraphFilter_SoftImageSetup( Info, TRUE, Width, Height ) < 0 )
			return -1 ;

		Src = ( BYTE * )Info->SrcImage.GraphData ;
		Dest = ( BYTE * )Info->DestImage.GraphData ;

		SrcPitch = Info->SrcImage.Pitch ;
		DestAddPitch = Info->DestImage.Pitch - Width * 4 ;

		switch( DivNum )
		{
		case 2 :
			SrcAddPitch  = Info->SrcImage.Pitch  - Width * 4 * 2 + SrcPitch ;

			do
			{
				i = Width ;
				do
				{
					Dest[ 0 ] = ( Src[ 0 ] + Src[ 4 ] + Src[ SrcPitch + 0 ] + Src[ SrcPitch + 4 ] ) >> 2 ;
					Dest[ 1 ] = ( Src[ 1 ] + Src[ 5 ] + Src[ SrcPitch + 1 ] + Src[ SrcPitch + 5 ] ) >> 2 ;
					Dest[ 2 ] = ( Src[ 2 ] + Src[ 6 ] + Src[ SrcPitch + 2 ] + Src[ SrcPitch + 6 ] ) >> 2 ;
					Dest[ 3 ] = ( Src[ 3 ] + Src[ 7 ] + Src[ SrcPitch + 3 ] + Src[ SrcPitch + 7 ] ) >> 2 ;

					Src  += 4 * 2 ;
					Dest += 4 ;
				}while( -- i ) ;

				Src  += SrcAddPitch ;
				Dest += DestAddPitch ;
			}while( -- Height ) ;
			break ;

		case 4 :
			SrcAddPitch  = Info->SrcImage.Pitch  - Width * 4 * 4 + SrcPitch * 3 ;

			do
			{
				i = Width ;
				do
				{
					Dest[ 0 ] = (
						Src[                0 ] + Src[                4 ] + Src[                 8 ] + Src[                12 ] +
						Src[ SrcPitch     + 0 ] + Src[ SrcPitch     + 4 ] +	Src[ SrcPitch     +  8 ] + Src[ SrcPitch     + 12 ] +
						Src[ SrcPitch * 2 + 0 ] + Src[ SrcPitch * 2 + 4 ] +	Src[ SrcPitch * 2 +  8 ] + Src[ SrcPitch * 2 + 12 ] +
						Src[ SrcPitch * 3 + 0 ] + Src[ SrcPitch * 3 + 4 ] +	Src[ SrcPitch * 3 +  8 ] + Src[ SrcPitch * 3 + 12 ] ) >> 4 ;
					Dest[ 1 ] = (
						Src[                1 ] + Src[                5 ] + Src[                 9 ] + Src[                13 ] +
						Src[ SrcPitch     + 1 ] + Src[ SrcPitch     + 5 ] +	Src[ SrcPitch     +  9 ] + Src[ SrcPitch     + 13 ] +
						Src[ SrcPitch * 2 + 1 ] + Src[ SrcPitch * 2 + 5 ] +	Src[ SrcPitch * 2 +  9 ] + Src[ SrcPitch * 2 + 13 ] +
						Src[ SrcPitch * 3 + 1 ] + Src[ SrcPitch * 3 + 5 ] +	Src[ SrcPitch * 3 +  9 ] + Src[ SrcPitch * 3 + 13 ] ) >> 4 ;
					Dest[ 2 ] = (
						Src[                2 ] + Src[                6 ] + Src[                10 ] + Src[                14 ] +
						Src[ SrcPitch     + 2 ] + Src[ SrcPitch     + 6 ] +	Src[ SrcPitch     + 10 ] + Src[ SrcPitch     + 14 ] +
						Src[ SrcPitch * 2 + 2 ] + Src[ SrcPitch * 2 + 6 ] +	Src[ SrcPitch * 2 + 10 ] + Src[ SrcPitch * 2 + 14 ] +
						Src[ SrcPitch * 3 + 2 ] + Src[ SrcPitch * 3 + 6 ] +	Src[ SrcPitch * 3 + 10 ] + Src[ SrcPitch * 3 + 14 ] ) >> 4 ;
					Dest[ 3 ] = (
						Src[                3 ] + Src[                7 ] + Src[                11 ] + Src[                15 ] +
						Src[ SrcPitch     + 3 ] + Src[ SrcPitch     + 7 ] +	Src[ SrcPitch     + 11 ] + Src[ SrcPitch     + 15 ] +
						Src[ SrcPitch * 2 + 3 ] + Src[ SrcPitch * 2 + 7 ] +	Src[ SrcPitch * 2 + 11 ] + Src[ SrcPitch * 2 + 15 ] +
						Src[ SrcPitch * 3 + 3 ] + Src[ SrcPitch * 3 + 7 ] +	Src[ SrcPitch * 3 + 11 ] + Src[ SrcPitch * 3 + 15 ] ) >> 4 ;

					Src  += 4 * 4 ;
					Dest += 4 ;
				}while( -- i ) ;

				Src  += SrcAddPitch ;
				Dest += DestAddPitch ;
			}while( -- Height ) ;
			break ;

		case 8 :
			SrcAddPitch  = Info->SrcImage.Pitch  - Width * 4 * 8 + SrcPitch * 7 ;

			do
			{
				i = Width ;
				do
				{
					Dest[ 0 ] = (
						Src[                0 ] + Src[                4 ] + Src[                 8 ] + Src[                12 ] + Src[                16 ] + Src[                20 ] + Src[                24 ] + Src[                28 ] +
						Src[ SrcPitch     + 0 ] + Src[ SrcPitch     + 4 ] +	Src[ SrcPitch     +  8 ] + Src[ SrcPitch     + 12 ] + Src[ SrcPitch     + 16 ] + Src[ SrcPitch     + 20 ] + Src[ SrcPitch     + 24 ] + Src[ SrcPitch     + 28 ] +
						Src[ SrcPitch * 2 + 0 ] + Src[ SrcPitch * 2 + 4 ] +	Src[ SrcPitch * 2 +  8 ] + Src[ SrcPitch * 2 + 12 ] + Src[ SrcPitch * 2 + 16 ] + Src[ SrcPitch * 2 + 20 ] + Src[ SrcPitch * 2 + 24 ] + Src[ SrcPitch * 2 + 28 ] +
						Src[ SrcPitch * 3 + 0 ] + Src[ SrcPitch * 3 + 4 ] +	Src[ SrcPitch * 3 +  8 ] + Src[ SrcPitch * 3 + 12 ] + Src[ SrcPitch * 3 + 16 ] + Src[ SrcPitch * 3 + 20 ] + Src[ SrcPitch * 3 + 24 ] + Src[ SrcPitch * 3 + 28 ] +
						Src[ SrcPitch * 4 + 0 ] + Src[ SrcPitch * 4 + 4 ] +	Src[ SrcPitch * 4 +  8 ] + Src[ SrcPitch * 4 + 12 ] + Src[ SrcPitch * 4 + 16 ] + Src[ SrcPitch * 4 + 20 ] + Src[ SrcPitch * 4 + 24 ] + Src[ SrcPitch * 4 + 28 ] +
						Src[ SrcPitch * 5 + 0 ] + Src[ SrcPitch * 5 + 4 ] +	Src[ SrcPitch * 5 +  8 ] + Src[ SrcPitch * 5 + 12 ] + Src[ SrcPitch * 5 + 16 ] + Src[ SrcPitch * 5 + 20 ] + Src[ SrcPitch * 5 + 24 ] + Src[ SrcPitch * 5 + 28 ] +
						Src[ SrcPitch * 6 + 0 ] + Src[ SrcPitch * 6 + 4 ] +	Src[ SrcPitch * 6 +  8 ] + Src[ SrcPitch * 6 + 12 ] + Src[ SrcPitch * 6 + 16 ] + Src[ SrcPitch * 6 + 20 ] + Src[ SrcPitch * 6 + 24 ] + Src[ SrcPitch * 6 + 28 ] +
						Src[ SrcPitch * 7 + 0 ] + Src[ SrcPitch * 7 + 4 ] +	Src[ SrcPitch * 7 +  8 ] + Src[ SrcPitch * 7 + 12 ] + Src[ SrcPitch * 7 + 16 ] + Src[ SrcPitch * 7 + 20 ] + Src[ SrcPitch * 7 + 24 ] + Src[ SrcPitch * 7 + 28 ] ) >> 6 ;
					Dest[ 1 ] = (
						Src[                1 ] + Src[                5 ] + Src[                 9 ] + Src[                13 ] + Src[                17 ] + Src[                21 ] + Src[                25 ] + Src[                29 ] +
						Src[ SrcPitch     + 1 ] + Src[ SrcPitch     + 5 ] +	Src[ SrcPitch     +  9 ] + Src[ SrcPitch     + 13 ] + Src[ SrcPitch     + 17 ] + Src[ SrcPitch     + 21 ] + Src[ SrcPitch     + 25 ] + Src[ SrcPitch     + 29 ] +
						Src[ SrcPitch * 2 + 1 ] + Src[ SrcPitch * 2 + 5 ] +	Src[ SrcPitch * 2 +  9 ] + Src[ SrcPitch * 2 + 13 ] + Src[ SrcPitch * 2 + 17 ] + Src[ SrcPitch * 2 + 21 ] + Src[ SrcPitch * 2 + 25 ] + Src[ SrcPitch * 2 + 29 ] +
						Src[ SrcPitch * 3 + 1 ] + Src[ SrcPitch * 3 + 5 ] +	Src[ SrcPitch * 3 +  9 ] + Src[ SrcPitch * 3 + 13 ] + Src[ SrcPitch * 3 + 17 ] + Src[ SrcPitch * 3 + 21 ] + Src[ SrcPitch * 3 + 25 ] + Src[ SrcPitch * 3 + 29 ] +
						Src[ SrcPitch * 4 + 1 ] + Src[ SrcPitch * 4 + 5 ] +	Src[ SrcPitch * 4 +  9 ] + Src[ SrcPitch * 4 + 13 ] + Src[ SrcPitch * 4 + 17 ] + Src[ SrcPitch * 4 + 21 ] + Src[ SrcPitch * 4 + 25 ] + Src[ SrcPitch * 4 + 29 ] +
						Src[ SrcPitch * 5 + 1 ] + Src[ SrcPitch * 5 + 5 ] +	Src[ SrcPitch * 5 +  9 ] + Src[ SrcPitch * 5 + 13 ] + Src[ SrcPitch * 5 + 17 ] + Src[ SrcPitch * 5 + 21 ] + Src[ SrcPitch * 5 + 25 ] + Src[ SrcPitch * 5 + 29 ] +
						Src[ SrcPitch * 6 + 1 ] + Src[ SrcPitch * 6 + 5 ] +	Src[ SrcPitch * 6 +  9 ] + Src[ SrcPitch * 6 + 13 ] + Src[ SrcPitch * 6 + 17 ] + Src[ SrcPitch * 6 + 21 ] + Src[ SrcPitch * 6 + 25 ] + Src[ SrcPitch * 6 + 29 ] +
						Src[ SrcPitch * 7 + 1 ] + Src[ SrcPitch * 7 + 5 ] +	Src[ SrcPitch * 7 +  9 ] + Src[ SrcPitch * 7 + 13 ] + Src[ SrcPitch * 7 + 17 ] + Src[ SrcPitch * 7 + 21 ] + Src[ SrcPitch * 7 + 25 ] + Src[ SrcPitch * 7 + 29 ] ) >> 6 ;
					Dest[ 2 ] = (
						Src[                2 ] + Src[                6 ] + Src[                10 ] + Src[                14 ] + Src[                18 ] + Src[                22 ] + Src[                26 ] + Src[                30 ] +
						Src[ SrcPitch     + 2 ] + Src[ SrcPitch     + 6 ] +	Src[ SrcPitch     + 10 ] + Src[ SrcPitch     + 14 ] + Src[ SrcPitch     + 18 ] + Src[ SrcPitch     + 22 ] + Src[ SrcPitch     + 26 ] + Src[ SrcPitch     + 30 ] +
						Src[ SrcPitch * 2 + 2 ] + Src[ SrcPitch * 2 + 6 ] +	Src[ SrcPitch * 2 + 10 ] + Src[ SrcPitch * 2 + 14 ] + Src[ SrcPitch * 2 + 18 ] + Src[ SrcPitch * 2 + 22 ] + Src[ SrcPitch * 2 + 26 ] + Src[ SrcPitch * 2 + 30 ] +
						Src[ SrcPitch * 3 + 2 ] + Src[ SrcPitch * 3 + 6 ] +	Src[ SrcPitch * 3 + 10 ] + Src[ SrcPitch * 3 + 14 ] + Src[ SrcPitch * 3 + 18 ] + Src[ SrcPitch * 3 + 22 ] + Src[ SrcPitch * 3 + 26 ] + Src[ SrcPitch * 3 + 30 ] +
						Src[ SrcPitch * 4 + 2 ] + Src[ SrcPitch * 4 + 6 ] +	Src[ SrcPitch * 4 + 10 ] + Src[ SrcPitch * 4 + 14 ] + Src[ SrcPitch * 4 + 18 ] + Src[ SrcPitch * 4 + 22 ] + Src[ SrcPitch * 4 + 26 ] + Src[ SrcPitch * 4 + 30 ] +
						Src[ SrcPitch * 5 + 2 ] + Src[ SrcPitch * 5 + 6 ] +	Src[ SrcPitch * 5 + 10 ] + Src[ SrcPitch * 5 + 14 ] + Src[ SrcPitch * 5 + 18 ] + Src[ SrcPitch * 5 + 22 ] + Src[ SrcPitch * 5 + 26 ] + Src[ SrcPitch * 5 + 30 ] +
						Src[ SrcPitch * 6 + 2 ] + Src[ SrcPitch * 6 + 6 ] +	Src[ SrcPitch * 6 + 10 ] + Src[ SrcPitch * 6 + 14 ] + Src[ SrcPitch * 6 + 18 ] + Src[ SrcPitch * 6 + 22 ] + Src[ SrcPitch * 6 + 26 ] + Src[ SrcPitch * 6 + 30 ] +
						Src[ SrcPitch * 7 + 2 ] + Src[ SrcPitch * 7 + 6 ] +	Src[ SrcPitch * 7 + 10 ] + Src[ SrcPitch * 7 + 14 ] + Src[ SrcPitch * 7 + 18 ] + Src[ SrcPitch * 7 + 22 ] + Src[ SrcPitch * 7 + 26 ] + Src[ SrcPitch * 7 + 30 ] ) >> 6 ;
					Dest[ 3 ] = (
						Src[                3 ] + Src[                7 ] + Src[                11 ] + Src[                15 ] + Src[                19 ] + Src[                23 ] + Src[                27 ] + Src[                31 ] +
						Src[ SrcPitch     + 3 ] + Src[ SrcPitch     + 7 ] +	Src[ SrcPitch     + 11 ] + Src[ SrcPitch     + 15 ] + Src[ SrcPitch     + 19 ] + Src[ SrcPitch     + 23 ] + Src[ SrcPitch     + 27 ] + Src[ SrcPitch     + 31 ] +
						Src[ SrcPitch * 2 + 3 ] + Src[ SrcPitch * 2 + 7 ] +	Src[ SrcPitch * 2 + 11 ] + Src[ SrcPitch * 2 + 15 ] + Src[ SrcPitch * 2 + 19 ] + Src[ SrcPitch * 2 + 23 ] + Src[ SrcPitch * 2 + 27 ] + Src[ SrcPitch * 2 + 31 ] +
						Src[ SrcPitch * 3 + 3 ] + Src[ SrcPitch * 3 + 7 ] +	Src[ SrcPitch * 3 + 11 ] + Src[ SrcPitch * 3 + 15 ] + Src[ SrcPitch * 3 + 19 ] + Src[ SrcPitch * 3 + 23 ] + Src[ SrcPitch * 3 + 27 ] + Src[ SrcPitch * 3 + 31 ] +
						Src[ SrcPitch * 4 + 3 ] + Src[ SrcPitch * 4 + 7 ] +	Src[ SrcPitch * 4 + 11 ] + Src[ SrcPitch * 4 + 15 ] + Src[ SrcPitch * 4 + 19 ] + Src[ SrcPitch * 4 + 23 ] + Src[ SrcPitch * 4 + 27 ] + Src[ SrcPitch * 4 + 31 ] +
						Src[ SrcPitch * 5 + 3 ] + Src[ SrcPitch * 5 + 7 ] +	Src[ SrcPitch * 5 + 11 ] + Src[ SrcPitch * 5 + 15 ] + Src[ SrcPitch * 5 + 19 ] + Src[ SrcPitch * 5 + 23 ] + Src[ SrcPitch * 5 + 27 ] + Src[ SrcPitch * 5 + 31 ] +
						Src[ SrcPitch * 6 + 3 ] + Src[ SrcPitch * 6 + 7 ] +	Src[ SrcPitch * 6 + 11 ] + Src[ SrcPitch * 6 + 15 ] + Src[ SrcPitch * 6 + 19 ] + Src[ SrcPitch * 6 + 23 ] + Src[ SrcPitch * 6 + 27 ] + Src[ SrcPitch * 6 + 31 ] +
						Src[ SrcPitch * 7 + 3 ] + Src[ SrcPitch * 7 + 7 ] +	Src[ SrcPitch * 7 + 11 ] + Src[ SrcPitch * 7 + 15 ] + Src[ SrcPitch * 7 + 19 ] + Src[ SrcPitch * 7 + 23 ] + Src[ SrcPitch * 7 + 27 ] + Src[ SrcPitch * 7 + 31 ] ) >> 6 ;

					Src  += 4 * 8 ;
					Dest += 4 ;
				}while( -- i ) ;

				Src  += SrcAddPitch ;
				Dest += DestAddPitch ;
			}while( -- Height ) ;
			break ;
		}

		GraphFilter_SoftImageTerminate( Info ) ;
	}

	// I
	return 0 ;
}

// CmpType:r^Cv( DX_CMP_LESS  DX_CMP_GREATER ̂ݎwł܂ )
// CmpParam:rl( 0.0f`255.0f )
// ClipFillFlag:NbvsNZ̐FœhԂ( TRUE:hԂ  FALSE:hԂȂ )
// ClipFillColor:NbvsNZɓhF( GetColorFŎ擾 )
static int GraphFilter_Bright_Clip( GRAPHFILTER_INFO *Info, int CmpType, float CmpParam, int ClipFillFlag, COLOR_F *ClipFillColor )
{
	// l̕␳
	if( CmpType != DX_CMP_LESS && CmpType != DX_CMP_GREATER )
		return -1 ;

	if( ClipFillFlag == TRUE && ClipFillColor == NULL )
		return -1 ;

	CmpParam /= 255.0f ;
	if( CmpParam < 0.0f )
	{
		CmpParam = 0.0f ;
	}
	else
	if( CmpParam > 1.0f )
	{
		CmpParam = 1.0f ;
	}

	// VF[_[g邩ǂŏ𕪊
	if( GRH.UseShader == TRUE )
	{
		static const char *PsoFileName[ 2 ][ 2 ] =
		{
			"BrightClipLess.pso",
			"BrightClipFillLess.pso",
			"BrightClipGreater.pso",
			"BrightClipFillGreater.pso",
		} ;
		LIBSHADER_DRAWPARAMTEMP DrawParamTemp ;
		int UseShader = 0 ;
		int UseFill ;
		FLOAT4 ParamF4[ 3 ] ;

		NS_SetDrawMode( DX_DRAWMODE_NEAREST ) ;

		// gpVF[_[̃ZbgAbv
		UseFill = ClipFillFlag == TRUE ? 1 : 0 ;
		switch( CmpType )
		{
		case DX_CMP_GREATER :
			UseShader = 1 ;
			break ;

		case DX_CMP_LESS :
			UseShader = 0 ;
			break ;
		}
		if( GRH.ShaderCode.BrightClipPS[ UseShader ][ UseFill ] < 0 )
		{
			GRH.ShaderCode.BrightClipPS[ UseShader ][ UseFill ] = MemLoadShaderCode( PsoFileName[ UseShader ][ UseFill ], false ) ;
			if( GRH.ShaderCode.BrightClipPS[ UseShader ][ UseFill ] < 0 )
			{
				DXST_ERRORLOGFMT_ADD(( _T( "tB^[pVF[_[̍쐬Ɏs܂ %s" ), PsoFileName[ UseShader ][ UseFill ] )) ;
				return -1 ;
			}
			NS_SetDeleteHandleFlag( GRH.ShaderCode.BrightClipPS[ UseShader ][ UseFill ], &GRH.ShaderCode.BrightClipPS[ UseShader ][ UseFill ] ) ;
		}

		LibShader_PushShaderParam( &DrawParamTemp, 1 ) ;

		ParamF4[  0 ].x = CmpParam ;
		ParamF4[  0 ].y = CmpParam ;
		ParamF4[  0 ].z = CmpParam ;
		ParamF4[  0 ].w = CmpParam ;
		ParamF4[  1 ].x = 0.299f ;
		ParamF4[  1 ].y = 0.587f ;
		ParamF4[  1 ].z = 0.114f ;
		ParamF4[  1 ].w = 0.0f ;
		if( ClipFillColor != NULL )
		{
			ParamF4[  2 ].x = ClipFillColor->r ;
			ParamF4[  2 ].y = ClipFillColor->g ;
			ParamF4[  2 ].z = ClipFillColor->b ;
			ParamF4[  2 ].w = ClipFillColor->a ;
		}
		SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, ParamF4, 3, FALSE ) ;

		NS_SetUsePixelShader( GRH.ShaderCode.BrightClipPS[ UseShader ][ UseFill ] ) ;

		GraphFilter_BasePolygonDraw( Info ) ;

		LibShader_PopShaderParam( &DrawParamTemp ) ;

		ResetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, 3 ) ;
	}
	else
	{
		// VF[_[gȂꍇ

		BYTE *Src ;
		BYTE *Dest ;
		DWORD i ;
		DWORD Width ;
		DWORD Height ;
		DWORD SrcAddPitch ;
		DWORD DestAddPitch ;
		int Temp ;
		BYTE iClipFillColor[ 4 ] ;
		int iCmpParam ;

		iCmpParam = _FTOL( CmpParam * 255.0f * 4096.0f ) ;

		if( ClipFillColor != NULL )
		{
			Temp = _FTOL( ClipFillColor->b * 255.0f ) ;
			if( Temp < 0 ) Temp = 0 ; else if( Temp > 255 ) Temp = 255 ;
			iClipFillColor[ 0 ] = ( BYTE )Temp ;

			Temp = _FTOL( ClipFillColor->g * 255.0f ) ;
			if( Temp < 0 ) Temp = 0 ; else if( Temp > 255 ) Temp = 255 ;
			iClipFillColor[ 1 ] = ( BYTE )Temp ;

			Temp = _FTOL( ClipFillColor->r * 255.0f ) ;
			if( Temp < 0 ) Temp = 0 ; else if( Temp > 255 ) Temp = 255 ;
			iClipFillColor[ 2 ] = ( BYTE )Temp ;

			Temp = _FTOL( ClipFillColor->a * 255.0f ) ;
			if( Temp < 0 ) Temp = 0 ; else if( Temp > 255 ) Temp = 255 ;
			iClipFillColor[ 3 ] = ( BYTE )Temp ;
		}

		if( GraphFilter_SoftImageSetup( Info, FALSE ) < 0 )
			return -1 ;

		Src = ( BYTE * )Info->SrcImage.GraphData ;
		Dest = ( BYTE * )Info->DestImage.GraphData ;

		Width  = Info->SrcX2 - Info->SrcX1 ;
		Height = Info->SrcY2 - Info->SrcY1 ;

		SrcAddPitch  = Info->SrcImage.Pitch  - Width * 4 ;
		DestAddPitch = Info->DestImage.Pitch - Width * 4 ;

		if( ClipFillFlag )
		{
			if( CmpType == DX_CMP_GREATER )
			{
				do
				{
					i = Width ;
					do
					{
						if( Src[ 0 ] * ( int )( 0.114f * 4096.0f ) +
							Src[ 1 ] * ( int )( 0.587f * 4096.0f ) +
							Src[ 2 ] * ( int )( 0.299f * 4096.0f ) > iCmpParam )
						{
							*( ( DWORD * )Dest ) = *( ( DWORD * )iClipFillColor ) ;
						}
						else
						{
							*( ( DWORD * )Dest ) = *( ( DWORD * )Src ) ;
						}

						Src  += 4 ;
						Dest += 4 ;
					}while( -- i ) ;

					Src  += SrcAddPitch ;
					Dest += DestAddPitch ;
				}while( -- Height ) ;
			}
			else
			{
				do
				{
					i = Width ;
					do
					{
						if( Src[ 0 ] * ( int )( 0.114f * 4096.0f ) +
							Src[ 1 ] * ( int )( 0.587f * 4096.0f ) +
							Src[ 2 ] * ( int )( 0.299f * 4096.0f ) < iCmpParam )
						{
							*( ( DWORD * )Dest ) = *( ( DWORD * )iClipFillColor ) ;
						}
						else
						{
							*( ( DWORD * )Dest ) = *( ( DWORD * )Src ) ;
						}

						Src  += 4 ;
						Dest += 4 ;
					}while( -- i ) ;

					Src  += SrcAddPitch ;
					Dest += DestAddPitch ;
				}while( -- Height ) ;
			}
		}
		else
		{
			if( CmpType == DX_CMP_GREATER )
			{
				do
				{
					i = Width ;
					do
					{
						if( Src[ 0 ] * ( int )( 0.114f * 4096.0f ) +
							Src[ 1 ] * ( int )( 0.587f * 4096.0f ) +
							Src[ 2 ] * ( int )( 0.299f * 4096.0f ) > iCmpParam )
						{
						}
						else
						{
							*( ( DWORD * )Dest ) = *( ( DWORD * )Src ) ;
						}

						Src  += 4 ;
						Dest += 4 ;
					}while( -- i ) ;

					Src  += SrcAddPitch ;
					Dest += DestAddPitch ;
				}while( -- Height ) ;
			}
			else
			{
				do
				{
					i = Width ;
					do
					{
						if( Src[ 0 ] * ( int )( 0.114f * 4096.0f ) +
							Src[ 1 ] * ( int )( 0.587f * 4096.0f ) +
							Src[ 2 ] * ( int )( 0.299f * 4096.0f ) < iCmpParam )
						{
						}
						else
						{
							*( ( DWORD * )Dest ) = *( ( DWORD * )Src ) ;
						}

						Src  += 4 ;
						Dest += 4 ;
					}while( -- i ) ;

					Src  += SrcAddPitch ;
					Dest += DestAddPitch ;
				}while( -- Height ) ;
			}
		}

		GraphFilter_SoftImageTerminate( Info ) ;
	}

	// I
	return 0 ;
}

static int GraphFilter_HSB( GRAPHFILTER_INFO *Info, int HueType, float Hue, float Saturation, float Bright )
{
	// l␳
	Hue = Hue / 360.0f ;
	if( HueType == 0 )
	{
		if( Hue < -0.5f )
		{
			Hue = -0.5f;
		}
		else
		if( Hue > 0.5f )
		{
			Hue = 0.5f;
		}
	}
	else
	{
		if( Hue < 0.0f )
		{
			Hue = 0.0f;
		}
		else
		if( Hue > 1.0f )
		{
			Hue = 1.0f;
		}
	}
	Hue *= 6.0f ;
	Saturation /= 100.0f;
	if( Saturation < -1.0f )
	{
		Saturation = -1.0f;
	}
	else
	if( Saturation > 1.0f )
	{
		Saturation = 1.0f;
	}
	Bright /= 100.0f;

	// VF[_[g邩ǂŏ𕪊
	if( GRH.UseShader == TRUE )
	{
		static const char *PsoFileName[ 3 ] =
		{
			"Hsb_RGB_TO_HSB.pso",
			"Hsb_HSB_TO_RGB.pso",
			"Hsb_HSB_HLOCK.pso",
		} ;
		LIBSHADER_DRAWPARAMTEMP DrawParamTemp ;
		int UseShader ;
		FLOAT4 ParamF4[ 3 ] ;

		NS_SetDrawMode( DX_DRAWMODE_NEAREST ) ;

		// gpVF[_[̃ZbgAbv
		if( HueType == 1 )
		{
			UseShader = 2 ;
		}
		else
		{
			UseShader = Info->Pass ;
		}
		if( GRH.ShaderCode.HsbPS[ UseShader ] < 0 )
		{
			GRH.ShaderCode.HsbPS[ UseShader ] = MemLoadShaderCode( PsoFileName[ UseShader ], false ) ;
			if( GRH.ShaderCode.HsbPS[ UseShader ] < 0 )
			{
				DXST_ERRORLOGFMT_ADD(( _T( "tB^[pVF[_[̍쐬Ɏs܂ %s" ), PsoFileName[ UseShader ] )) ;
				return -1 ;
			}
			NS_SetDeleteHandleFlag( GRH.ShaderCode.HsbPS[ UseShader ], &GRH.ShaderCode.HsbPS[ UseShader ] ) ;
		}

		LibShader_PushShaderParam( &DrawParamTemp, 1 ) ;

		ParamF4[ 0 ].x = Hue ;
		ParamF4[ 0 ].y = Saturation > 0.0f ? Saturation * 5.0f : Saturation ;
		ParamF4[ 0 ].z = Bright ;
		ParamF4[ 0 ].w = 0.0f ;
		ParamF4[ 1 ].x = 0.5f ;
		ParamF4[ 1 ].y = 0.5f ;
		ParamF4[ 1 ].z = 0.5f ;
		ParamF4[ 1 ].w = 0.5f ;
		ParamF4[ 2 ].x = 1.0f ;
		ParamF4[ 2 ].y = 1.0f ;
		ParamF4[ 2 ].z = 1.0f ;
		ParamF4[ 2 ].w = 1.0f ;
		SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, ParamF4, 3, FALSE ) ;

		NS_SetUsePixelShader( GRH.ShaderCode.HsbPS[ UseShader ] ) ;

		GraphFilter_BasePolygonDraw( Info ) ;

		LibShader_PopShaderParam( &DrawParamTemp ) ;

		ResetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, 3 ) ;
	}
	else
	{
		// VF[_[gȂꍇ

		BYTE *Src ;
		BYTE *Dest ;
		DWORD i ;
		DWORD Width ;
		DWORD Height ;
		DWORD SrcAddPitch ;
		DWORD DestAddPitch ;
		int iHue ;
		int iSaturation ;
		int iBright ;
		int iH, iS, iB ;
		int Max ;
		int Min ;
		int Delta ;
		int R, G, B ;

		iHue        = _FTOL( Hue        * 256.0f ) ;
		iSaturation = _FTOL( ( Saturation > 0.0f ? Saturation * 5.0f : Saturation ) * 256.0f ) ;
		iBright     = _FTOL( Bright     * 256.0f ) ;

		if( GraphFilter_SoftImageSetup( Info ) < 0 )
			return -1 ;

		Src = ( BYTE * )Info->SrcImage.GraphData ;
		Dest = ( BYTE * )Info->DestImage.GraphData ;

		Width  = Info->SrcX2 - Info->SrcX1 ;
		Height = Info->SrcY2 - Info->SrcY1 ;

		SrcAddPitch  = Info->SrcImage.Pitch  - Width * 4 ;
		DestAddPitch = Info->DestImage.Pitch - Width * 4 ;

		if( HueType == 1 )
		{
			if( iHue >= 0x600 )
			{
				iHue -= 0x600 ;
			}
			do
			{
				i = Width ;
				do
				{
					B = Src[ 0 ] ;
					G = Src[ 1 ] ;
					R = Src[ 2 ] ;

					if( iBright > 0 )
					{
						B += ( ( 255 - B ) * iBright ) >> 8 ;
						G += ( ( 255 - G ) * iBright ) >> 8 ;
						R += ( ( 255 - R ) * iBright ) >> 8 ;
					}
					else
					{
						B = ( B * ( 256 + iBright ) ) >> 8 ;
						G = ( G * ( 256 + iBright ) ) >> 8 ;
						R = ( R * ( 256 + iBright ) ) >> 8 ;
					}

					Max = R > G ? ( R > B ? R : B ) : ( G > B ? G : B ) ;
					Min = R < G ? ( R < B ? R : B ) : ( G < B ? G : B ) ;
					Delta = Max - Min;

					iB = ( Max + Min ) >> 1 ;
					if( Max == Min )
					{
						iS = 0 ;
					}
					else
					{
						if( iB > 128 )
						{
							iS = 512 - Max - Min; 
						}
						else
						{
							iS = Max + Min;
						}
						iS = ( Delta << 8 ) / iS;
					}

					iH = iHue ;

					iS = ( iS * ( 256 + iSaturation ) ) >> 8 ;
					if( iS > 256 ) iS = 256 ;

					int iHM ;
					iHM = iH & 0xff ;

					if( iH < 0x100 )
					{
						R = 255 ;
						G = iHM ;
						B = 0 ;
					}
					else
					if( iH < 0x200 )
					{
						R = 255 - iHM ;
						G = 255 ;
						B = 0 ;
					}
					else
					if( iH < 0x300 )
					{
						R = 0 ;
						G = 255 ;
						B = iHM ;
					}
					else
					if( iH < 0x400 )
					{
						R = 0 ;
						G = 255 - iHM ;
						B = 255 ;
					}
					else
					if( iH < 0x500 )
					{
						R = iHM ;
						G = 0 ;
						B = 255 ;
					}
					else
					{
						R = 255 ;
						G = 0 ;
						B = 255 - iHM ;
					}

					B += ( ( 128 - B ) * ( 256 - iS ) ) >> 8 ;
					G += ( ( 128 - G ) * ( 256 - iS ) ) >> 8 ;
					R += ( ( 128 - R ) * ( 256 - iS ) ) >> 8 ;

					if( iB <= 128 )
					{
						Dest[ 0 ] = ( BYTE )( ( B * ( iB << 1 ) ) >> 8 ) ;
						Dest[ 1 ] = ( BYTE )( ( G * ( iB << 1 ) ) >> 8 ) ;
						Dest[ 2 ] = ( BYTE )( ( R * ( iB << 1 ) ) >> 8 ) ;
					}
					else
					{
						Dest[ 0 ] = ( BYTE )( B + ( ( ( 255 - B ) * ( ( iB - 128 ) << 1 ) ) >> 8 ) ) ;
						Dest[ 1 ] = ( BYTE )( G + ( ( ( 255 - G ) * ( ( iB - 128 ) << 1 ) ) >> 8 ) ) ;
						Dest[ 2 ] = ( BYTE )( R + ( ( ( 255 - R ) * ( ( iB - 128 ) << 1 ) ) >> 8 ) ) ;
					}

					Dest[ 3 ] = Src[ 3 ] ;

					Src  += 4 ;
					Dest += 4 ;
				}while( -- i ) ;

				Src  += SrcAddPitch ;
				Dest += DestAddPitch ;
			}while( -- Height ) ;
		}
		else
		{
			do
			{
				i = Width ;
				do
				{
					B = Src[ 0 ] ;
					G = Src[ 1 ] ;
					R = Src[ 2 ] ;

					if( iBright > 0 )
					{
						B += ( ( 255 - B ) * iBright ) >> 8 ;
						G += ( ( 255 - G ) * iBright ) >> 8 ;
						R += ( ( 255 - R ) * iBright ) >> 8 ;
					}
					else
					{
						B = ( B * ( 256 + iBright ) ) >> 8 ;
						G = ( G * ( 256 + iBright ) ) >> 8 ;
						R = ( R * ( 256 + iBright ) ) >> 8 ;
					}

					Max = R > G ? ( R > B ? R : B ) : ( G > B ? G : B ) ;
					Min = R < G ? ( R < B ? R : B ) : ( G < B ? G : B ) ;
					Delta = Max - Min;

					iB = ( Max + Min ) >> 1 ;
					if( Max == Min )
					{
						iH = 0 ;
						iS = 0 ;
					}
					else
					{
						int tR, tG, tB ;

						if( iB > 128 )
						{
							iS = 512 - Max - Min; 
						}
						else
						{
							iS = Max + Min;
						}
						iS = ( Delta << 8 ) / iS;

						tB = ( ( Max - B ) << 8 ) / Delta ;
						tG = ( ( Max - G ) << 8 ) / Delta ;
						tR = ( ( Max - R ) << 8 ) / Delta ;
						if( R == Max )
						{
							iH = tB - tG ;
						}
						else
						if( G == Max )
						{
							iH = 0x200 + tR - tB ;
						}
						else
						{
							iH = 0x400 + tG - tR ;
						}
						if( iH < 0 )
						{
							iH += 0x600 ;
						}
					}

					iH += iHue ;
					if( iH < 0 )
					{
						iH += 0x600 ;
					}
					else
					if( iH >= 0x600 )
					{
						iH -= 0x600 ;
					}

					iS = ( iS * ( 256 + iSaturation ) ) >> 8 ;
					if( iS > 256 ) iS = 256 ;

					int iHM ;
					iHM = iH & 0xff ;

					if( iH < 0x100 )
					{
						R = 255 ;
						G = iHM ;
						B = 0 ;
					}
					else
					if( iH < 0x200 )
					{
						R = 255 - iHM ;
						G = 255 ;
						B = 0 ;
					}
					else
					if( iH < 0x300 )
					{
						R = 0 ;
						G = 255 ;
						B = iHM ;
					}
					else
					if( iH < 0x400 )
					{
						R = 0 ;
						G = 255 - iHM ;
						B = 255 ;
					}
					else
					if( iH < 0x500 )
					{
						R = iHM ;
						G = 0 ;
						B = 255 ;
					}
					else
					{
						R = 255 ;
						G = 0 ;
						B = 255 - iHM ;
					}

					B += ( ( 128 - B ) * ( 256 - iS ) ) >> 8 ;
					G += ( ( 128 - G ) * ( 256 - iS ) ) >> 8 ;
					R += ( ( 128 - R ) * ( 256 - iS ) ) >> 8 ;

					if( iB <= 128 )
					{
						Dest[ 0 ] = ( BYTE )( ( B * ( iB << 1 ) ) >> 8 ) ;
						Dest[ 1 ] = ( BYTE )( ( G * ( iB << 1 ) ) >> 8 ) ;
						Dest[ 2 ] = ( BYTE )( ( R * ( iB << 1 ) ) >> 8 ) ;
					}
					else
					{
						Dest[ 0 ] = ( BYTE )( B + ( ( ( 255 - B ) * ( ( iB - 128 ) << 1 ) ) >> 8 ) ) ;
						Dest[ 1 ] = ( BYTE )( G + ( ( ( 255 - G ) * ( ( iB - 128 ) << 1 ) ) >> 8 ) ) ;
						Dest[ 2 ] = ( BYTE )( R + ( ( ( 255 - R ) * ( ( iB - 128 ) << 1 ) ) >> 8 ) ) ;
					}

					Dest[ 3 ] = Src[ 3 ] ;

					Src  += 4 ;
					Dest += 4 ;
				}while( -- i ) ;

				Src  += SrcAddPitch ;
				Dest += DestAddPitch ;
			}while( -- Height ) ;
		}

		GraphFilter_SoftImageTerminate( Info ) ;
	}

	// I
	return 0 ;
}

static int GraphFilter_Invert( GRAPHFILTER_INFO *Info )
{
	// VF[_[g邩ǂŏ𕪊
	if( GRH.UseShader == TRUE )
	{
		static const char *PsoFileName[ 1 ] =
		{
			"Invert.pso",
		} ;
		LIBSHADER_DRAWPARAMTEMP DrawParamTemp ;

		NS_SetDrawMode( DX_DRAWMODE_NEAREST ) ;

		// gpVF[_[̃ZbgAbv
		if( GRH.ShaderCode.InvertPS < 0 )
		{
			GRH.ShaderCode.InvertPS = MemLoadShaderCode( PsoFileName[ 0 ], false ) ;
			if( GRH.ShaderCode.InvertPS < 0 )
			{
				DXST_ERRORLOGFMT_ADD(( _T( "tB^[pVF[_[̍쐬Ɏs܂ %s" ), PsoFileName[ 0 ] )) ;
				return -1 ;
			}
			NS_SetDeleteHandleFlag( GRH.ShaderCode.InvertPS, &GRH.ShaderCode.InvertPS ) ;
		}

		LibShader_PushShaderParam( &DrawParamTemp, 1 ) ;

		NS_SetUsePixelShader( GRH.ShaderCode.InvertPS ) ;

		GraphFilter_BasePolygonDraw( Info ) ;

		LibShader_PopShaderParam( &DrawParamTemp ) ;
	}
	else
	{
		// VF[_[gȂꍇ

		BYTE *Src ;
		BYTE *Dest ;
		DWORD i ;
		DWORD Width ;
		DWORD Height ;
		DWORD SrcAddPitch ;
		DWORD DestAddPitch ;

		if( GraphFilter_SoftImageSetup( Info ) < 0 )
			return -1 ;

		Src = ( BYTE * )Info->SrcImage.GraphData ;
		Dest = ( BYTE * )Info->DestImage.GraphData ;

		Width  = Info->SrcX2 - Info->SrcX1 ;
		Height = Info->SrcY2 - Info->SrcY1 ;

		SrcAddPitch  = Info->SrcImage.Pitch  - Width * 4 ;
		DestAddPitch = Info->DestImage.Pitch - Width * 4 ;

		do
		{
			i = Width ;
			do
			{
				Dest[ 0 ] = 255 - Src[ 0 ] ;
				Dest[ 1 ] = 255 - Src[ 1 ] ;
				Dest[ 2 ] = 255 - Src[ 2 ] ;
				Dest[ 3 ] = Src[ 3 ] ;

				Src  += 4 ;
				Dest += 4 ;
			}while( -- i ) ;

			Src  += SrcAddPitch ;
			Dest += DestAddPitch ;
		}while( -- Height ) ;

		GraphFilter_SoftImageTerminate( Info ) ;
	}

	// I
	return 0 ;
}

static int GraphFilter_Level( GRAPHFILTER_INFO *Info, float Min, float Max, float Gamma, float AfterMin, float AfterMax )
{
	// l␳
	Min /= 255.0f ;
	Max /= 255.0f ;
	AfterMin /= 255.0f ;
	AfterMax /= 255.0f ;
	if( Min < 0.0f )
	{
		Min = 0.0f ;
	}
	else
	if( Min > 1.0f )
	{
		Min = 1.0f ;
	}
	if( Max < 0.0f )
	{
		Max = 0.0f ;
	}
	else
	if( Max > 1.0f )
	{
		Max = 1.0f ;
	}
	if( Gamma < 0.001f )
	{
		Gamma = 0.001f ;
	}
	if( AfterMin < 0.0f )
	{
		AfterMin = 0.0f ;
	}
	else
	if( AfterMin > 1.0f )
	{
		AfterMin = 1.0f ;
	}
	if( AfterMax < 0.0f )
	{
		AfterMax = 0.0f ;
	}
	else
	if( AfterMax > 1.0f )
	{
		AfterMax = 1.0f ;
	}
	if( Min > Max ) Min = Max ;
	if( AfterMin > AfterMax ) AfterMin = AfterMax ;

	// VF[_[g邩ǂŏ𕪊
	if( GRH.UseShader == TRUE )
	{
		static const char *PsoFileName[ 1 ] =
		{
			"Level.pso",
		} ;
		LIBSHADER_DRAWPARAMTEMP DrawParamTemp ;
		FLOAT4 ParamF4[ 1 ] ;
		int Always ;

		// NS_SetDrawMode( DX_DRAWMODE_NEAREST ) ;

		// K}␳e[ũZbgAbv
		Always = FALSE ;
		if( GRH.ShaderCode.GammaTex < 0 )
		{
			SETUP_GRAPHHANDLE_GPARAM GParam ;

			InitSetupGraphHandleGParam_Normal_NonDrawValid( &GParam, 32, FALSE, FALSE ) ;

			GRH.ShaderCode.GammaTex = MakeGraph_UseGParam( &GParam, 256, 1, FALSE, FALSE ) ;
			NS_SetDeleteHandleFlag( GRH.ShaderCode.GammaTex, &GRH.ShaderCode.GammaTex ) ;
			GRH.ShaderCode.PrevGamma = -10000000.0f ;
			Always = TRUE ;
		}
		if( Always == TRUE || _FABS( GRH.ShaderCode.PrevGamma - Gamma ) > 0.0001f )
		{
			BASEIMAGE GammaBaseImage ;
			NS_CreateXRGB8ColorBaseImage( 256, 1, &GammaBaseImage ) ;
			if( GammaBaseImage.GraphData != NULL )
			{
				int i ;
				float Param ;
				float GammaRev ;
				BYTE *Dest ;

				Dest = ( BYTE * )GammaBaseImage.GraphData ;
				GammaRev = 1.0f / Gamma ;
				for( i = 0 ; i < 256 ; i ++, Dest += 4 )
				{
					Param = _POW( ( float )i / 255.0f, GammaRev ) * 255.0f ;
					if( Param > 255.0f )
					{
						*Dest = 255 ;
					}
					else
					{
						*Dest = ( BYTE )_FTOL( Param ) ;
					}
					Dest[ 1 ] = Dest[ 0 ] ;
					Dest[ 2 ] = Dest[ 0 ] ;
					Dest[ 3 ] = Dest[ 0 ] ;
				}
				NS_BltBmpOrGraphImageToGraph( NULL, NULL, NULL, FALSE, &GammaBaseImage, NULL, 0, 0, GRH.ShaderCode.GammaTex ) ;

				GRH.ShaderCode.PrevGamma = Gamma ;

				NS_ReleaseBaseImage( &GammaBaseImage ) ;
			}
		}

		// gpVF[_[̃ZbgAbv
		if( GRH.ShaderCode.LevelPS < 0 )
		{
			GRH.ShaderCode.LevelPS = MemLoadShaderCode( PsoFileName[ 0 ], false ) ;
			if( GRH.ShaderCode.LevelPS < 0 )
			{
				DXST_ERRORLOGFMT_ADD(( _T( "tB^[pVF[_[̍쐬Ɏs܂ %s" ), PsoFileName[ 0 ] )) ;
				return -1 ;
			}
			NS_SetDeleteHandleFlag( GRH.ShaderCode.LevelPS, &GRH.ShaderCode.LevelPS ) ;
		}

		LibShader_PushShaderParam( &DrawParamTemp, 1 ) ;

		ParamF4[ 0 ].x = Min ;
		ParamF4[ 0 ].y = 1.0f / ( Max - Min ) ;
		ParamF4[ 0 ].z = AfterMin ;
		ParamF4[ 0 ].w = AfterMax ;
		SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, ParamF4, 1, FALSE ) ;

		NS_SetUsePixelShader( GRH.ShaderCode.LevelPS ) ;

		NS_SetUseTextureToShader( 1, GRH.ShaderCode.GammaTex ) ;

		GraphFilter_BasePolygonDraw( Info ) ;

		LibShader_PopShaderParam( &DrawParamTemp ) ;

		ResetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, 1 ) ;
	}
	else
	{
		// VF[_[gȂꍇ

		BYTE *Src ;
		BYTE *Dest ;
		DWORD i ;
		DWORD Width ;
		DWORD Height ;
		DWORD SrcAddPitch ;
		DWORD DestAddPitch ;
		int iMin ;
		int iMax ;
		int iMinMaxLen ;
		int iAfterMin ;
		int iAfterMax ;
		int iAfterMinMaxLen ;
		int iAfterMin256 ;
		int R, G, B ;
		static float PrevGamma = -10000000.0f ;
		static int GammaTable[ 256 ] ;

		if( _FABS( PrevGamma - Gamma ) > 0.0001f )
		{
			int i ;
			float Param ;
			float GammaRev ;

			GammaRev = 1.0f / Gamma ;
			for( i = 0 ; i < 256 ; i ++ )
			{
				Param = _POW( ( float )i / 255.0f, GammaRev ) * 255.0f ;
				if( Param > 255.0f )
				{
					GammaTable[ i ] = 255 ;
				}
				else
				{
					GammaTable[ i ] = _FTOL( Param ) ;
				}
			}

			PrevGamma = Gamma ;
		}

		iMin = _FTOL( Min * 255 ) ;
		iMax = _FTOL( Max * 255 ) ;
		iMinMaxLen = iMax - iMin ;
		iAfterMin = _FTOL( AfterMin * 255 ) ;
		iAfterMax = _FTOL( AfterMax * 255 ) ;
		iAfterMinMaxLen = iAfterMax - iAfterMin ;
		iAfterMin256 = iAfterMin << 8 ;

		if( GraphFilter_SoftImageSetup( Info ) < 0 )
			return -1 ;

		Src = ( BYTE * )Info->SrcImage.GraphData ;
		Dest = ( BYTE * )Info->DestImage.GraphData ;

		Width  = Info->SrcX2 - Info->SrcX1 ;
		Height = Info->SrcY2 - Info->SrcY1 ;

		SrcAddPitch  = Info->SrcImage.Pitch  - Width * 4 ;
		DestAddPitch = Info->DestImage.Pitch - Width * 4 ;

		do
		{
			i = Width ;
			do
			{
				B = ( ( Src[ 0 ] - iMin ) << 8 ) / iMinMaxLen;
				B = B < 0 ? GammaTable[ 0 ] : ( B > 255 ?  GammaTable[ 255 ] : GammaTable[ B ] ) ;

				G = ( ( Src[ 1 ] - iMin ) << 8 ) / iMinMaxLen;
				G = G < 0 ? GammaTable[ 0 ] : ( G > 255 ?  GammaTable[ 255 ] : GammaTable[ G ] ) ;

				R = ( ( Src[ 2 ] - iMin ) << 8 ) / iMinMaxLen;
				R = R < 0 ? GammaTable[ 0 ] : ( R > 255 ?  GammaTable[ 255 ] : GammaTable[ R ] ) ;

				Dest[ 0 ] = ( BYTE )( ( iAfterMin256 + iAfterMinMaxLen * B ) >> 8 ) ;
				Dest[ 1 ] = ( BYTE )( ( iAfterMin256 + iAfterMinMaxLen * G ) >> 8 ) ;
				Dest[ 2 ] = ( BYTE )( ( iAfterMin256 + iAfterMinMaxLen * R ) >> 8 ) ;
				Dest[ 3 ] = Src[ 3 ] ;

				Src  += 4 ;
				Dest += 4 ;
			}while( -- i ) ;

			Src  += SrcAddPitch ;
			Dest += DestAddPitch ;
		}while( -- Height ) ;

		GraphFilter_SoftImageTerminate( Info ) ;
	}

	// I
	return 0 ;
}

static int GraphFilter_TwoColor( GRAPHFILTER_INFO *Info, float Threshold, COLOR_F *LowColor, COLOR_F *HighColor )
{
	// l␳
	if( LowColor == NULL || HighColor == NULL )
		return -1 ;

	// VF[_[g邩ǂŏ𕪊
	if( GRH.UseShader == TRUE )
	{
		Threshold /= 255.0f ;

		static const char *PsoFileName[ 1 ] =
		{
			"TwoColor.pso",
		} ;
		LIBSHADER_DRAWPARAMTEMP DrawParamTemp ;
		FLOAT4 ParamF4[ 3 ] ;

		NS_SetDrawMode( DX_DRAWMODE_NEAREST ) ;

		// gpVF[_[̃ZbgAbv
		if( GRH.ShaderCode.TwoColorPS < 0 )
		{
			GRH.ShaderCode.TwoColorPS = MemLoadShaderCode( PsoFileName[ 0 ], false ) ;
			if( GRH.ShaderCode.TwoColorPS < 0 )
			{
				DXST_ERRORLOGFMT_ADD(( _T( "tB^[pVF[_[̍쐬Ɏs܂ %s" ), PsoFileName[ 0 ] )) ;
				return -1 ;
			}
			NS_SetDeleteHandleFlag( GRH.ShaderCode.TwoColorPS, &GRH.ShaderCode.TwoColorPS ) ;
		}

		LibShader_PushShaderParam( &DrawParamTemp, 1 ) ;

		ParamF4[ 0 ].x = 0.29900f ;
		ParamF4[ 0 ].y = 0.58700f ;
		ParamF4[ 0 ].z = 0.11400f ;
		ParamF4[ 0 ].w = Threshold ;
		ParamF4[ 1 ].x = LowColor->r ;
		ParamF4[ 1 ].y = LowColor->g ;
		ParamF4[ 1 ].z = LowColor->b ;
		ParamF4[ 1 ].w = LowColor->a ;
		ParamF4[ 2 ].x = HighColor->r ;
		ParamF4[ 2 ].y = HighColor->g ;
		ParamF4[ 2 ].z = HighColor->b ;
		ParamF4[ 2 ].w = HighColor->a ;
		SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, ParamF4, 3, FALSE ) ;

		NS_SetUsePixelShader( GRH.ShaderCode.TwoColorPS ) ;

		GraphFilter_BasePolygonDraw( Info ) ;

		LibShader_PopShaderParam( &DrawParamTemp ) ;

		ResetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, 3 ) ;
	}
	else
	{
		// VF[_[gȂꍇ

		BYTE *Src ;
		BYTE *Dest ;
		DWORD i ;
		DWORD Width ;
		DWORD Height ;
		DWORD SrcAddPitch ;
		DWORD DestAddPitch ;
		int Temp ;
		int iThreshold ;
		BYTE iLowColor[ 4 ] ;
		BYTE iHighColor[ 4 ] ;

		iThreshold = _FTOL( Threshold * 4096.0f ) ;

		Temp = _FTOL( LowColor->b * 255.0f ) ;
		if( Temp < 0 ) Temp = 0 ; else if( Temp > 255 ) Temp = 255 ;
		iLowColor[ 0 ] = ( BYTE )Temp ;

		Temp = _FTOL( LowColor->g * 255.0f ) ;
		if( Temp < 0 ) Temp = 0 ; else if( Temp > 255 ) Temp = 255 ;
		iLowColor[ 1 ] = ( BYTE )Temp ;

		Temp = _FTOL( LowColor->r * 255.0f ) ;
		if( Temp < 0 ) Temp = 0 ; else if( Temp > 255 ) Temp = 255 ;
		iLowColor[ 2 ] = ( BYTE )Temp ;

		Temp = _FTOL( LowColor->a * 255.0f ) ;
		if( Temp < 0 ) Temp = 0 ; else if( Temp > 255 ) Temp = 255 ;
		iLowColor[ 3 ] = ( BYTE )Temp ;


		Temp = _FTOL( HighColor->b * 255.0f ) ;
		if( Temp < 0 ) Temp = 0 ; else if( Temp > 255 ) Temp = 255 ;
		iHighColor[ 0 ] = ( BYTE )Temp ;

		Temp = _FTOL( HighColor->g * 255.0f ) ;
		if( Temp < 0 ) Temp = 0 ; else if( Temp > 255 ) Temp = 255 ;
		iHighColor[ 1 ] = ( BYTE )Temp ;

		Temp = _FTOL( HighColor->r * 255.0f ) ;
		if( Temp < 0 ) Temp = 0 ; else if( Temp > 255 ) Temp = 255 ;
		iHighColor[ 2 ] = ( BYTE )Temp ;

		Temp = _FTOL( HighColor->a * 255.0f ) ;
		if( Temp < 0 ) Temp = 0 ; else if( Temp > 255 ) Temp = 255 ;
		iHighColor[ 3 ] = ( BYTE )Temp ;


		if( GraphFilter_SoftImageSetup( Info ) < 0 )
			return -1 ;

		Src = ( BYTE * )Info->SrcImage.GraphData ;
		Dest = ( BYTE * )Info->DestImage.GraphData ;

		Width  = Info->SrcX2 - Info->SrcX1 ;
		Height = Info->SrcY2 - Info->SrcY1 ;

		SrcAddPitch  = Info->SrcImage.Pitch  - Width * 4 ;
		DestAddPitch = Info->DestImage.Pitch - Width * 4 ;

		do
		{
			i = Width ;
			do
			{
				if( Src[ 0 ] * ( int )( 0.114f * 4096.0f ) +
					Src[ 1 ] * ( int )( 0.587f * 4096.0f ) +
					Src[ 2 ] * ( int )( 0.299f * 4096.0f ) < iThreshold )
				{
					*( ( DWORD * )Dest ) = *( ( DWORD * )iLowColor ) ;
				}
				else
				{
					*( ( DWORD * )Dest ) = *( ( DWORD * )iHighColor ) ;
				}

				Src  += 4 ;
				Dest += 4 ;
			}while( -- i ) ;

			Src  += SrcAddPitch ;
			Dest += DestAddPitch ;
		}while( -- Height ) ;

		GraphFilter_SoftImageTerminate( Info ) ;
	}

	// I
	return 0 ;
}

static int	GraphFilter_GradientMap( GRAPHFILTER_INFO *Info, int MapGrHandle, int Reverse )
{
	// VF[_[g邩ǂŏ𕪊
	if( GRH.UseShader == TRUE )
	{
		static const char *PsoFileName[ 2 ] =
		{
			"GradientMap.pso",
			"GradientMapRev.pso",
		} ;
		int UseShader ;
		LIBSHADER_DRAWPARAMTEMP DrawParamTemp ;
		FLOAT4 ParamF4[ 1 ] ;

		NS_SetDrawMode( DX_DRAWMODE_NEAREST ) ;

		// gpVF[_[̃ZbgAbv
		UseShader = Reverse ? 1 : 0 ;
		if( GRH.ShaderCode.GradientMapPS[ UseShader ] < 0 )
		{
			GRH.ShaderCode.GradientMapPS[ UseShader ] = MemLoadShaderCode( PsoFileName[ UseShader ], false ) ;
			if( GRH.ShaderCode.GradientMapPS[ UseShader ] < 0 )
			{
				DXST_ERRORLOGFMT_ADD(( _T( "tB^[pVF[_[̍쐬Ɏs܂ %s" ), PsoFileName[ UseShader ] )) ;
				return -1 ;
			}
			NS_SetDeleteHandleFlag( GRH.ShaderCode.GradientMapPS[ UseShader ], &GRH.ShaderCode.GradientMapPS[ UseShader ] ) ;
		}

		LibShader_PushShaderParam( &DrawParamTemp, 2 ) ;

		ParamF4[ 0 ].x = 0.29900f ;
		ParamF4[ 0 ].y = 0.58700f ;
		ParamF4[ 0 ].z = 0.11400f ;
		ParamF4[ 0 ].w = 0.0f ;
		SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, ParamF4, 1, FALSE ) ;

		NS_SetUsePixelShader( GRH.ShaderCode.GradientMapPS[ UseShader ] ) ;

		NS_SetUseTextureToShader( 1, MapGrHandle ) ;

		GraphFilter_BasePolygonDraw( Info ) ;

		LibShader_PopShaderParam( &DrawParamTemp ) ;

		ResetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, 1 ) ;
	}
	else
	{
		// VF[_[gȂꍇ

		BYTE *Src ;
		BYTE *Dest ;
		DWORD i ;
		DWORD Width ;
		DWORD Height ;
		DWORD SrcAddPitch ;
		DWORD DestAddPitch ;
		BASEIMAGE GradImage ;
		DWORD GradMap[ 256 ] ;

		// Of[V}bv̔zZbgAbv
		{
			int GradWidth, GradHeight ;

			if( NS_GetGraphSize( MapGrHandle, &GradWidth, &GradHeight ) < 0 )
				return -1 ;

			if( GraphFilter_GetSoftImage( MapGrHandle, &GradImage, NULL ) < 0 )
				return -1 ;

			if( Reverse )
			{
				for( i = 0 ; i < 256 ; i ++ )
					GradMap[ 255 - i ] = *( ( DWORD * )( ( BYTE * )GradImage.GraphData + GradWidth * i / 256 * 4 ) ) ;
			}
			else
			{
				for( i = 0 ; i < 256 ; i ++ )
					GradMap[ i ] = *( ( DWORD * )( ( BYTE * )GradImage.GraphData + GradWidth * i / 256 * 4 ) ) ;
			}

			NS_ReleaseBaseImage( &GradImage ) ;
		}

		if( GraphFilter_SoftImageSetup( Info ) < 0 )
			return -1 ;

		Src = ( BYTE * )Info->SrcImage.GraphData ;
		Dest = ( BYTE * )Info->DestImage.GraphData ;

		Width  = Info->SrcX2 - Info->SrcX1 ;
		Height = Info->SrcY2 - Info->SrcY1 ;

		SrcAddPitch  = Info->SrcImage.Pitch  - Width * 4 ;
		DestAddPitch = Info->DestImage.Pitch - Width * 4 ;

		do
		{
			i = Width ;
			do
			{
				*( ( DWORD * )Dest ) = GradMap[ ( Src[ 0 ] * ( int )( 0.114f * 4096.0f ) +
												  Src[ 1 ] * ( int )( 0.587f * 4096.0f ) +
												  Src[ 2 ] * ( int )( 0.299f * 4096.0f ) ) >> 12 ] ;

				Src  += 4 ;
				Dest += 4 ;
			}while( -- i ) ;

			Src  += SrcAddPitch ;
			Dest += DestAddPitch ;
		}while( -- Height ) ;

		GraphFilter_SoftImageTerminate( Info ) ;
	}

	// I
	return 0 ;
}

static int	GraphFilter_PremulAlpha( GRAPHFILTER_INFO *Info )
{
	// VF[_[g邩ǂŏ𕪊
	if( GRH.UseShader == TRUE )
	{
		static const char *PsoFileName[ 1 ] =
		{
			"PremultipliedAlpha.pso",
		} ;
		int UseShader ;
		LIBSHADER_DRAWPARAMTEMP DrawParamTemp ;

		NS_SetDrawMode( DX_DRAWMODE_NEAREST ) ;

		// gpVF[_[̃ZbgAbv
		UseShader = 0 ;
		if( GRH.ShaderCode.PreMulAlphaPS < 0 )
		{
			GRH.ShaderCode.PreMulAlphaPS = MemLoadShaderCode( PsoFileName[ UseShader ], false ) ;
			if( GRH.ShaderCode.PreMulAlphaPS < 0 )
			{
				DXST_ERRORLOGFMT_ADD(( _T( "tB^[pVF[_[̍쐬Ɏs܂ %s" ), PsoFileName[ UseShader ] )) ;
				return -1 ;
			}
			NS_SetDeleteHandleFlag( GRH.ShaderCode.PreMulAlphaPS, &GRH.ShaderCode.PreMulAlphaPS ) ;
		}

		LibShader_PushShaderParam( &DrawParamTemp, 1 ) ;

		NS_SetUsePixelShader( GRH.ShaderCode.PreMulAlphaPS ) ;

		GraphFilter_BasePolygonDraw( Info ) ;

		LibShader_PopShaderParam( &DrawParamTemp ) ;
	}
	else
	{
		// VF[_[gȂꍇ

		BYTE *Src ;
		BYTE *Dest ;
		DWORD i ;
		DWORD Width ;
		DWORD Height ;
		DWORD SrcAddPitch ;
		DWORD DestAddPitch ;

		if( GraphFilter_SoftImageSetup( Info ) < 0 )
			return -1 ;

		Src = ( BYTE * )Info->SrcImage.GraphData ;
		Dest = ( BYTE * )Info->DestImage.GraphData ;

		Width  = Info->SrcX2 - Info->SrcX1 ;
		Height = Info->SrcY2 - Info->SrcY1 ;

		SrcAddPitch  = Info->SrcImage.Pitch  - Width * 4 ;
		DestAddPitch = Info->DestImage.Pitch - Width * 4 ;

		do
		{
			i = Width ;
			do
			{
				Dest[ 0 ] = ( Src[ 0 ] * Src[ 3 ] ) >> 8 ;
				Dest[ 1 ] = ( Src[ 1 ] * Src[ 3 ] ) >> 8 ;
				Dest[ 2 ] = ( Src[ 2 ] * Src[ 3 ] ) >> 8 ;
				Dest[ 3 ] = Src[ 3 ] ;

				Src  += 4 ;
				Dest += 4 ;
			}while( -- i ) ;

			Src  += SrcAddPitch ;
			Dest += DestAddPitch ;
		}while( -- Height ) ;

		GraphFilter_SoftImageTerminate( Info ) ;
	}

	// I
	return 0 ;
}

static int	GraphFilter_InterpAlpha( GRAPHFILTER_INFO *Info )
{
	// VF[_[g邩ǂŏ𕪊
	if( GRH.UseShader == TRUE )
	{
		static const char *PsoFileName[ 1 ] =
		{
			"InterpolatedAlpha.pso",
		} ;
		int UseShader ;
		LIBSHADER_DRAWPARAMTEMP DrawParamTemp ;

		NS_SetDrawMode( DX_DRAWMODE_NEAREST ) ;

		// gpVF[_[̃ZbgAbv
		UseShader = 0 ;
		if( GRH.ShaderCode.InterpAlphaPS < 0 )
		{
			GRH.ShaderCode.InterpAlphaPS = MemLoadShaderCode( PsoFileName[ UseShader ], false ) ;
			if( GRH.ShaderCode.InterpAlphaPS < 0 )
			{
				DXST_ERRORLOGFMT_ADD(( _T( "tB^[pVF[_[̍쐬Ɏs܂ %s" ), PsoFileName[ UseShader ] )) ;
				return -1 ;
			}
			NS_SetDeleteHandleFlag( GRH.ShaderCode.InterpAlphaPS, &GRH.ShaderCode.InterpAlphaPS ) ;
		}

		LibShader_PushShaderParam( &DrawParamTemp, 1 ) ;

		NS_SetUsePixelShader( GRH.ShaderCode.InterpAlphaPS ) ;

		GraphFilter_BasePolygonDraw( Info ) ;

		LibShader_PopShaderParam( &DrawParamTemp ) ;
	}
	else
	{
		// VF[_[gȂꍇ

		BYTE *Src ;
		BYTE *Dest ;
		DWORD tmp ;
		DWORD i ;
		DWORD Width ;
		DWORD Height ;
		DWORD SrcAddPitch ;
		DWORD DestAddPitch ;

		if( GraphFilter_SoftImageSetup( Info ) < 0 )
			return -1 ;

		Src = ( BYTE * )Info->SrcImage.GraphData ;
		Dest = ( BYTE * )Info->DestImage.GraphData ;

		Width  = Info->SrcX2 - Info->SrcX1 ;
		Height = Info->SrcY2 - Info->SrcY1 ;

		SrcAddPitch  = Info->SrcImage.Pitch  - Width * 4 ;
		DestAddPitch = Info->DestImage.Pitch - Width * 4 ;

		do
		{
			i = Width ;
			do
			{
				if( Src[ 3 ] == 0 )
				{
					Dest[ 0 ] = 0 ;
					Dest[ 1 ] = 0 ;
					Dest[ 2 ] = 0 ;
				}
				else
				{
					tmp = Src[ 0 ] * 255 / Src[ 3 ] ; Dest[ 0 ] = ( BYTE )( tmp > 255 ? 255 : tmp ) ;
					tmp = Src[ 1 ] * 255 / Src[ 3 ] ; Dest[ 1 ] = ( BYTE )( tmp > 255 ? 255 : tmp ) ;
					tmp = Src[ 2 ] * 255 / Src[ 3 ] ; Dest[ 2 ] = ( BYTE )( tmp > 255 ? 255 : tmp ) ;
				}
				Dest[ 3 ] = Src[ 3 ] ;

				Src  += 4 ;
				Dest += 4 ;
			}while( -- i ) ;

			Src  += SrcAddPitch ;
			Dest += DestAddPitch ;
		}while( -- Height ) ;

		GraphFilter_SoftImageTerminate( Info ) ;
	}

	// I
	return 0 ;
}

static int	GraphBlend_Basic( GRAPHFILTER_INFO *Info )
{
	// VF[_[g邩ǂŏ𕪊
	if( GRH.UseShader == TRUE )
	{
		static const char *PsoFileName[ 17 ] =
		{
			"BasBF_Normal.pso",			// DX_GRAPH_BLEND_NORMAL
			NULL,						// DX_GRAPH_BLEND_RGBA_SELECT_MIX
			"BasBF_Multiple.pso",		// DX_GRAPH_BLEND_MULTIPLE
			"BasBF_Difference.pso",		// DX_GRAPH_BLEND_DIFFERENCE
			"BasBF_Add.pso",			// DX_GRAPH_BLEND_ADD
			"BasBF_Screen.pso",			// DX_GRAPH_BLEND_SCREEN
			"BasBF_Overlay.pso",		// DX_GRAPH_BLEND_OVERLAY
			"BasBF_Dodge.pso",			// DX_GRAPH_BLEND_DODGE
			"BasBF_Burn.pso",			// DX_GRAPH_BLEND_BURN
			"BasBF_Darken.pso",			// DX_GRAPH_BLEND_DARKEN
			"BasBF_Lighten.pso",		// DX_GRAPH_BLEND_LIGHTEN
			"BasBF_SoftLight.pso",		// DX_GRAPH_BLEND_SOFTLIGHT
			"BasBF_HardLight.pso",		// DX_GRAPH_BLEND_HARDLIGHT
			"BasBF_Exclusion.pso",		// DX_GRAPH_BLEND_EXCLUSION
			"BasBF_Normal_AlphaCh.pso",	// DX_GRAPH_BLEND_NORMAL_ALPHACH
			"BasBF_Add_AlphaCh.pso",	// DX_GRAPH_BLEND_ADD_ALPHACH
			"BasBF_Multiple_AOnly.pso",	// DX_GRAPH_BLEND_MULTIPLE_A_ONLY
		} ;
		LIBSHADER_DRAWPARAMTEMP DrawParamTemp ;
		int UseShader ;
		FLOAT4 ParamF4[ 2 ] ;

//		NS_SetDrawMode( DX_DRAWMODE_NEAREST ) ;

		// gpVF[_[̃ZbgAbv
		UseShader = Info->FilterOrBlendType ;
		if( GRH.ShaderCode.BasicBlendPS[ UseShader ] < 0 )
		{
			GRH.ShaderCode.BasicBlendPS[ UseShader ] = MemLoadShaderCode( PsoFileName[ UseShader ], false ) ;
			if( GRH.ShaderCode.BasicBlendPS[ UseShader ] < 0 )
			{
				DXST_ERRORLOGFMT_ADD(( _T( "tB^[pVF[_[̍쐬Ɏs܂ %s" ), PsoFileName[ UseShader ] )) ;
				return -1 ;
			}
			NS_SetDeleteHandleFlag( GRH.ShaderCode.BasicBlendPS[ UseShader ], &GRH.ShaderCode.BasicBlendPS[ UseShader ] ) ;
		}

		LibShader_PushShaderParam( &DrawParamTemp, 2 ) ;

		ParamF4[ 0 ].x = Info->BlendRatio ;
		ParamF4[ 0 ].y = Info->BlendRatio ;
		ParamF4[ 0 ].z = Info->BlendRatio ;
		ParamF4[ 0 ].w = Info->BlendRatio ;
		ParamF4[ 1 ].x = 1.0f ;
		ParamF4[ 1 ].y = 1.0f ;
		ParamF4[ 1 ].z = 1.0f ;
		ParamF4[ 1 ].w = 1.0f ;
		SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, ParamF4, 2, FALSE ) ;

		NS_SetUsePixelShader( GRH.ShaderCode.BasicBlendPS[ UseShader ] ) ;

		GraphFilter_BasePolygonDraw( Info ) ;

		LibShader_PopShaderParam( &DrawParamTemp ) ;

		ResetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, 2 ) ;
	}
	else
	{
		// VF[_[gȂꍇ

		BYTE *Src ;
		BYTE *Blend ;
		BYTE *Dest ;
		DWORD i ;
		DWORD Width ;
		DWORD Height ;
		DWORD SrcAddPitch ;
		DWORD BlendAddPitch ;
		DWORD DestAddPitch ;
		int R, G, B, A ;
		int BlendRatio ;
		int TempBlendRatio ;
		float fRGB[ 4 ] ;
		int iRGB[ 4 ] ;

		fRGB[ 3 ] = 0.0f ;

		if( GraphFilter_SoftImageSetup( Info ) < 0 )
			return -1 ;

		BlendRatio = _FTOL( Info->BlendRatio * 256.0f ) ;

		Src = ( BYTE * )Info->SrcImage.GraphData ;
		Blend = ( BYTE * )Info->BlendImage.GraphData ;
		Dest = ( BYTE * )Info->DestImage.GraphData ;

		Width  = Info->SrcX2 - Info->SrcX1 ;
		Height = Info->SrcY2 - Info->SrcY1 ;

		SrcAddPitch   = Info->SrcImage.Pitch   - Width * 4 ;
		BlendAddPitch = Info->BlendImage.Pitch - Width * 4 ;
		DestAddPitch  = Info->DestImage.Pitch  - Width * 4 ;

		switch( Info->FilterOrBlendType )
		{
		case DX_GRAPH_BLEND_NORMAL :
			{
				do
				{
					i = Width ;
					do
					{
						TempBlendRatio = BlendRatio * Blend[ 3 ] ;
						Dest[ 0 ] = ( BYTE )( ( ( Src[ 0 ] << 16 ) + ( Blend[ 0 ] - Src[ 0 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 1 ] = ( BYTE )( ( ( Src[ 1 ] << 16 ) + ( Blend[ 1 ] - Src[ 1 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 2 ] = ( BYTE )( ( ( Src[ 2 ] << 16 ) + ( Blend[ 2 ] - Src[ 2 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 3 ] = Src[ 3 ] ;

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;

		case DX_GRAPH_BLEND_MULTIPLE :
			{
				do
				{
					i = Width ;
					do
					{
						TempBlendRatio = BlendRatio * Blend[ 3 ] ;
						B = ( Src[ 0 ] * Blend[ 0 ] ) >> 8 ;
						G = ( Src[ 1 ] * Blend[ 1 ] ) >> 8 ;
						R = ( Src[ 2 ] * Blend[ 2 ] ) >> 8 ;
						Dest[ 0 ] = ( BYTE )( ( ( Src[ 0 ] << 16 ) + ( B - Src[ 0 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 1 ] = ( BYTE )( ( ( Src[ 1 ] << 16 ) + ( G - Src[ 1 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 2 ] = ( BYTE )( ( ( Src[ 2 ] << 16 ) + ( R - Src[ 2 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 3 ] = Src[ 3 ] ;

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;

		case DX_GRAPH_BLEND_DIFFERENCE :
			{
				do
				{
					i = Width ;
					do
					{
						TempBlendRatio = BlendRatio * Blend[ 3 ] ;
						B = Src[ 0 ] - Blend[ 0 ] ;
						G = Src[ 1 ] - Blend[ 1 ] ;
						R = Src[ 2 ] - Blend[ 2 ] ;
						if( B < 0 ) B = 0 ;
						if( G < 0 ) G = 0 ;
						if( R < 0 ) R = 0 ;
						Dest[ 0 ] = ( BYTE )( ( ( Src[ 0 ] << 16 ) + ( B - Src[ 0 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 1 ] = ( BYTE )( ( ( Src[ 1 ] << 16 ) + ( G - Src[ 1 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 2 ] = ( BYTE )( ( ( Src[ 2 ] << 16 ) + ( R - Src[ 2 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 3 ] = Src[ 3 ] ;

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;

		case DX_GRAPH_BLEND_ADD :
			{
				do
				{
					i = Width ;
					do
					{
						TempBlendRatio = BlendRatio * Blend[ 3 ] ;
						B = Src[ 0 ] + Blend[ 0 ] ;
						G = Src[ 1 ] + Blend[ 1 ] ;
						R = Src[ 2 ] + Blend[ 2 ] ;
						if( B > 255 ) B = 255 ;
						if( G > 255 ) G = 255 ;
						if( R > 255 ) R = 255 ;
						Dest[ 0 ] = ( BYTE )( ( ( Src[ 0 ] << 16 ) + ( B - Src[ 0 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 1 ] = ( BYTE )( ( ( Src[ 1 ] << 16 ) + ( G - Src[ 1 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 2 ] = ( BYTE )( ( ( Src[ 2 ] << 16 ) + ( R - Src[ 2 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 3 ] = Src[ 3 ] ;

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;

		case DX_GRAPH_BLEND_SCREEN :
			{
				do
				{
					i = Width ;
					do
					{
						TempBlendRatio = BlendRatio * Blend[ 3 ] ;
						B = 255 - ( ( ( 255 - Src[ 0 ] ) * ( 255 - Blend[ 0 ] ) ) >> 8 ) ;
						G = 255 - ( ( ( 255 - Src[ 1 ] ) * ( 255 - Blend[ 1 ] ) ) >> 8 ) ;
						R = 255 - ( ( ( 255 - Src[ 2 ] ) * ( 255 - Blend[ 2 ] ) ) >> 8 ) ;
						if( B > 255 ) B = 255 ;
						if( G > 255 ) G = 255 ;
						if( R > 255 ) R = 255 ;
						Dest[ 0 ] = ( BYTE )( ( ( Src[ 0 ] << 16 ) + ( B - Src[ 0 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 1 ] = ( BYTE )( ( ( Src[ 1 ] << 16 ) + ( G - Src[ 1 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 2 ] = ( BYTE )( ( ( Src[ 2 ] << 16 ) + ( R - Src[ 2 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 3 ] = Src[ 3 ] ;

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;

		case DX_GRAPH_BLEND_OVERLAY :
			{
				do
				{
					i = Width ;
					do
					{
						TempBlendRatio = BlendRatio * Blend[ 3 ] ;

						if( Src[ 0 ] < 128 )
						{
							B = ( Src[ 0 ] * Blend[ 0 ] * 2 ) >> 8 ;
						}
						else
						{
							B = ( ( 2 * ( ( ( Src[ 0 ] + Blend[ 0 ] ) << 8 ) - Src[ 0 ] * Blend[ 0 ] ) ) >> 8 ) - 255 ;
						}
						if( B > 255 ) B = 255 ;

						if( Src[ 1 ] < 128 )
						{
							G = ( Src[ 1 ] * Blend[ 1 ] * 2 ) >> 8 ;
						}
						else
						{
							G = ( ( 2 * ( ( ( Src[ 1 ] + Blend[ 1 ] ) << 8 ) - Src[ 1 ] * Blend[ 1 ] ) ) >> 8 ) - 255 ;
						}
						if( G > 255 ) G = 255 ;

						if( Src[ 2 ] < 128 )
						{
							R = ( Src[ 2 ] * Blend[ 2 ] * 2 ) >> 8 ;
						}
						else
						{
							R = ( ( 2 * ( ( ( Src[ 2 ] + Blend[ 2 ] ) << 8 ) - Src[ 2 ] * Blend[ 2 ] ) ) >> 8 ) - 255 ;
						}
						if( R > 255 ) R = 255 ;

						Dest[ 0 ] = ( BYTE )( ( ( Src[ 0 ] << 16 ) + ( B - Src[ 0 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 1 ] = ( BYTE )( ( ( Src[ 1 ] << 16 ) + ( G - Src[ 1 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 2 ] = ( BYTE )( ( ( Src[ 2 ] << 16 ) + ( R - Src[ 2 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 3 ] = Src[ 3 ] ;

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;

		case DX_GRAPH_BLEND_DODGE :
			{
				do
				{
					i = Width ;
					do
					{
						TempBlendRatio = BlendRatio * Blend[ 3 ] ;

						if( Blend[ 0 ] < 255 )
						{
							B = ( Src[ 0 ] << 8 ) / ( 255 - Blend[ 0 ] ) ;
							if( B > 255 ) B = 255 ;
						}
						else
						{
							B = 255 ;
						}

						if( Blend[ 1 ] < 255 )
						{
							G = ( Src[ 1 ] << 8 ) / ( 255 - Blend[ 1 ] ) ;
							if( G > 255 ) G = 255 ;
						}
						else
						{
							G = 255 ;
						}

						if( Blend[ 2 ] < 255 )
						{
							R = ( Src[ 2 ] << 8 ) / ( 255 - Blend[ 2 ] ) ;
							if( R > 255 ) R = 255 ;
						}
						else
						{
							R = 255 ;
						}

						Dest[ 0 ] = ( BYTE )( ( ( Src[ 0 ] << 16 ) + ( B - Src[ 0 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 1 ] = ( BYTE )( ( ( Src[ 1 ] << 16 ) + ( G - Src[ 1 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 2 ] = ( BYTE )( ( ( Src[ 2 ] << 16 ) + ( R - Src[ 2 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 3 ] = Src[ 3 ] ;

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;

		case DX_GRAPH_BLEND_BURN :
			{
				do
				{
					i = Width ;
					do
					{
						TempBlendRatio = BlendRatio * Blend[ 3 ] ;

						B = 255 - ( ( 255 - Src[ 0 ] ) << 8 ) / ( Blend[ 0 ] + 1 ) ;
						if( B < 0 ) B = 0 ;

						G = 255 - ( ( 255 - Src[ 1 ] ) << 8 ) / ( Blend[ 1 ] + 1 ) ;
						if( G < 0 ) G = 0 ;

						R = 255 - ( ( 255 - Src[ 2 ] ) << 8 ) / ( Blend[ 2 ] + 1 ) ;
						if( R < 0 ) R = 0 ;

						Dest[ 0 ] = ( BYTE )( ( ( Src[ 0 ] << 16 ) + ( B - Src[ 0 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 1 ] = ( BYTE )( ( ( Src[ 1 ] << 16 ) + ( G - Src[ 1 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 2 ] = ( BYTE )( ( ( Src[ 2 ] << 16 ) + ( R - Src[ 2 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 3 ] = Src[ 3 ] ;

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;

		case DX_GRAPH_BLEND_DARKEN :
			{
				do
				{
					i = Width ;
					do
					{
						TempBlendRatio = BlendRatio * Blend[ 3 ] ;

						B = Src[ 0 ] < Blend[ 0 ] ? Src[ 0 ] : Blend[ 0 ] ;
						G = Src[ 1 ] < Blend[ 1 ] ? Src[ 1 ] : Blend[ 1 ] ;
						R = Src[ 2 ] < Blend[ 2 ] ? Src[ 2 ] : Blend[ 2 ] ;

						Dest[ 0 ] = ( BYTE )( ( ( Src[ 0 ] << 16 ) + ( B - Src[ 0 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 1 ] = ( BYTE )( ( ( Src[ 1 ] << 16 ) + ( G - Src[ 1 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 2 ] = ( BYTE )( ( ( Src[ 2 ] << 16 ) + ( R - Src[ 2 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 3 ] = Src[ 3 ] ;

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;

		case DX_GRAPH_BLEND_LIGHTEN :
			{
				do
				{
					i = Width ;
					do
					{
						TempBlendRatio = BlendRatio * Blend[ 3 ] ;

						B = Src[ 0 ] > Blend[ 0 ] ? Src[ 0 ] : Blend[ 0 ] ;
						G = Src[ 1 ] > Blend[ 1 ] ? Src[ 1 ] : Blend[ 1 ] ;
						R = Src[ 2 ] > Blend[ 2 ] ? Src[ 2 ] : Blend[ 2 ] ;

						Dest[ 0 ] = ( BYTE )( ( ( Src[ 0 ] << 16 ) + ( B - Src[ 0 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 1 ] = ( BYTE )( ( ( Src[ 1 ] << 16 ) + ( G - Src[ 1 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 2 ] = ( BYTE )( ( ( Src[ 2 ] << 16 ) + ( R - Src[ 2 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 3 ] = Src[ 3 ] ;

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;

		case DX_GRAPH_BLEND_SOFTLIGHT :
			{
				do
				{
					i = Width ;
					do
					{
						TempBlendRatio = BlendRatio * Blend[ 3 ] ;

						if( Blend[ 0 ] < 128 )
						{
							fRGB[ 0 ] = _POW( Src[ 0 ] / 255.0f, ( 1.0f - Blend[ 0 ] / 255.0f ) * 2.0f ) ;
						}
						else
						{
							fRGB[ 0 ] = _POW( Src[ 0 ] / 255.0f, 0.5f / ( Blend[ 0 ] / 255.0f ) ) ;
						}

						if( Blend[ 1 ] < 128 )
						{
							fRGB[ 1 ] = _POW( Src[ 1 ] / 255.0f, ( 1.0f - Blend[ 1 ] / 255.0f ) * 2.0f ) ;
						}
						else
						{
							fRGB[ 1 ] = _POW( Src[ 1 ] / 255.0f, 0.5f / ( Blend[ 1 ] / 255.0f ) ) ;
						}

						if( Blend[ 2 ] < 128 )
						{
							fRGB[ 2 ] = _POW( Src[ 2 ] / 255.0f, ( 1.0f - Blend[ 2 ] / 255.0f ) * 2.0f ) ;
						}
						else
						{
							fRGB[ 2 ] = _POW( Src[ 2 ] / 255.0f, 0.5f / ( Blend[ 2 ] / 255.0f ) ) ;
						}

						fRGB[ 0 ] *= 255.0f ;
						fRGB[ 1 ] *= 255.0f ;
						fRGB[ 2 ] *= 255.0f ;
						_FTOL4( fRGB, iRGB ) ;

						B = iRGB[ 0 ] < 0 ? 0 : ( iRGB[ 0 ] > 255 ? 255 : iRGB[ 0 ] ) ;
						G = iRGB[ 1 ] < 0 ? 0 : ( iRGB[ 1 ] > 255 ? 255 : iRGB[ 1 ] ) ;
						R = iRGB[ 2 ] < 0 ? 0 : ( iRGB[ 2 ] > 255 ? 255 : iRGB[ 2 ] ) ;

						Dest[ 0 ] = ( BYTE )( ( ( Src[ 0 ] << 16 ) + ( B - Src[ 0 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 1 ] = ( BYTE )( ( ( Src[ 1 ] << 16 ) + ( G - Src[ 1 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 2 ] = ( BYTE )( ( ( Src[ 2 ] << 16 ) + ( R - Src[ 2 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 3 ] = Src[ 3 ] ;

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;

		case DX_GRAPH_BLEND_HARDLIGHT :
			{
				do
				{
					i = Width ;
					do
					{
						TempBlendRatio = BlendRatio * Blend[ 3 ] ;

						if( Blend[ 0 ] < 128 )
						{
							B = ( Src[ 0 ] * Blend[ 0 ] * 2 ) >> 8 ;
						}
						else
						{
							B = ( ( 2 * ( ( ( Src[ 0 ] + Blend[ 0 ] ) << 8 ) - ( Src[ 0 ] * Blend[ 0 ] ) ) ) >> 8 ) - 255 ;
						}
						if( B > 255 ) B = 255 ;

						if( Blend[ 1 ] < 128 )
						{
							G = ( Src[ 1 ] * Blend[ 1 ] * 2 ) >> 8 ;
						}
						else
						{
							G = ( ( 2 * ( ( ( Src[ 1 ] + Blend[ 1 ] ) << 8 ) - ( Src[ 1 ] * Blend[ 1 ] ) ) ) >> 8 ) - 255 ;
						}
						if( G > 255 ) G = 255 ;

						if( Blend[ 2 ] < 128 )
						{
							R = ( Src[ 2 ] * Blend[ 2 ] * 2 ) >> 8 ;
						}
						else
						{
							R = ( ( 2 * ( ( ( Src[ 2 ] + Blend[ 2 ] ) << 8 ) - ( Src[ 2 ] * Blend[ 2 ] ) ) ) >> 8 ) - 255 ;
						}
						if( R > 255 ) R = 255 ;

						Dest[ 0 ] = ( BYTE )( ( ( Src[ 0 ] << 16 ) + ( B - Src[ 0 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 1 ] = ( BYTE )( ( ( Src[ 1 ] << 16 ) + ( G - Src[ 1 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 2 ] = ( BYTE )( ( ( Src[ 2 ] << 16 ) + ( R - Src[ 2 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 3 ] = Src[ 3 ] ;

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;

		case DX_GRAPH_BLEND_EXCLUSION :
			{
				do
				{
					i = Width ;
					do
					{
						TempBlendRatio = BlendRatio * Blend[ 3 ] ;

						B = ( ( ( Src[ 0 ] + Blend[ 0 ] ) << 8 ) - 2 * ( Src[ 0 ] * Blend[ 0 ] ) ) >> 8 ;
						if( B > 255 ) B = 255 ;

						G = ( ( ( Src[ 1 ] + Blend[ 1 ] ) << 8 ) - 2 * ( Src[ 1 ] * Blend[ 1 ] ) ) >> 8 ;
						if( G > 255 ) G = 255 ;

						R = ( ( ( Src[ 2 ] + Blend[ 2 ] ) << 8 ) - 2 * ( Src[ 2 ] * Blend[ 2 ] ) ) >> 8 ;
						if( R > 255 ) R = 255 ;

						Dest[ 0 ] = ( BYTE )( ( ( Src[ 0 ] << 16 ) + ( B - Src[ 0 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 1 ] = ( BYTE )( ( ( Src[ 1 ] << 16 ) + ( G - Src[ 1 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 2 ] = ( BYTE )( ( ( Src[ 2 ] << 16 ) + ( R - Src[ 2 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 3 ] = Src[ 3 ] ;

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;

		case DX_GRAPH_BLEND_NORMAL_ALPHACH :
			{
				DWORD TempAlpha ;
				DWORD ReverseBlendAlpha ;
				DWORD BlendAlpha ;

				do
				{
					i = Width ;
					do
					{
						BlendAlpha = ( Blend[ 3 ] * BlendRatio ) >> 8 ;

						ReverseBlendAlpha = 256 - BlendAlpha ;
						TempAlpha = ReverseBlendAlpha * Src[ 3 ] + ( BlendAlpha << 8 ) ;
						if( TempAlpha != 0 )
						{
							Dest[ 0 ] = ( BYTE )( ( ReverseBlendAlpha * Src[ 3 ] * Src[ 0 ] + ( ( BlendAlpha * Blend[ 0 ] ) << 8 ) ) / TempAlpha ) ;
							Dest[ 1 ] = ( BYTE )( ( ReverseBlendAlpha * Src[ 3 ] * Src[ 1 ] + ( ( BlendAlpha * Blend[ 1 ] ) << 8 ) ) / TempAlpha ) ;
							Dest[ 2 ] = ( BYTE )( ( ReverseBlendAlpha * Src[ 3 ] * Src[ 2 ] + ( ( BlendAlpha * Blend[ 2 ] ) << 8 ) ) / TempAlpha ) ;
							Dest[ 3 ] = ( BYTE )( TempAlpha >> 8 ) ;
						}

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;

		case DX_GRAPH_BLEND_ADD_ALPHACH :
			{
				DWORD TempAlpha ;
				DWORD TempC ;
				DWORD BlendAlpha ;

				do
				{
					i = Width ;
					do
					{
						BlendAlpha = ( Blend[ 3 ] * BlendRatio ) >> 8 ;
						TempAlpha = ( ( 256 - BlendAlpha ) * Src[ 3 ] + ( BlendAlpha << 8 ) ) >> 8 ;
						if( TempAlpha != 0 )
						{
							TempC = ( Src[ 3 ] * Src[ 0 ] + BlendAlpha * Blend[ 0 ] ) / TempAlpha ;
							Dest[ 0 ] = TempC > 255 ? 255 : ( BYTE )TempC ;

							TempC = ( Src[ 3 ] * Src[ 1 ] + BlendAlpha * Blend[ 1 ] ) / TempAlpha ;
							Dest[ 1 ] = TempC > 255 ? 255 : ( BYTE )TempC ;

							TempC = ( Src[ 3 ] * Src[ 2 ] + BlendAlpha * Blend[ 2 ] ) / TempAlpha ;
							Dest[ 2 ] = TempC > 255 ? 255 : ( BYTE )TempC ;

							Dest[ 3 ] = ( BYTE )( TempAlpha ) ;
						}

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;

		case DX_GRAPH_BLEND_MULTIPLE_A_ONLY :
			{
				TempBlendRatio = BlendRatio * 255 ;
				do
				{
					i = Width ;
					do
					{
						A = ( Src[ 3 ] * Blend[ 3 ] ) >> 8 ;
						Dest[ 0 ] = Src[ 0 ] ;
						Dest[ 1 ] = Src[ 1 ] ;
						Dest[ 2 ] = Src[ 2 ] ;
						Dest[ 3 ] = ( BYTE )( ( ( Src[ 3 ] << 16 ) + ( A - Src[ 3 ] ) * TempBlendRatio ) >> 16 ) ;

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;
		}

		GraphFilter_SoftImageTerminate( Info ) ;
	}

	// I
	return 0 ;
}

static int	GraphBlend_RGBA_Select_Mix( GRAPHFILTER_INFO *Info, int SelectR, int SelectG, int SelectB, int SelectA )
{
	// VF[_[g邩ǂŏ𕪊
	if( GRH.UseShader == TRUE )
	{
		static const char *PsoFileName[ 1 ] =
		{
			"RGBAMix_Base.pso",
		} ;
		static const char *CharTable[ 4 ] =
		{
			"R", "G", "B", "A"
		};
		int *PixelShaderHandle ;
		LIBSHADER_DRAWPARAMTEMP DrawParamTemp ;
		FLOAT4 ParamF4[ 2 ] ;
		char FileName[ 64 ] ;
		int SrcBlendReverse = FALSE ;
		int HandleTemp ;
		int SrcOnlyFlag = FALSE ;

		NS_SetDrawMode( DX_DRAWMODE_NEAREST ) ;

		// gpVF[_[̃ZbgAbv
		if( SelectR >= DX_RGBA_SELECT_SRC_R && SelectR <= DX_RGBA_SELECT_SRC_A &&
			SelectG >= DX_RGBA_SELECT_SRC_R && SelectG <= DX_RGBA_SELECT_SRC_A &&
			SelectB >= DX_RGBA_SELECT_SRC_R && SelectB <= DX_RGBA_SELECT_SRC_A &&
			SelectA >= DX_RGBA_SELECT_SRC_R && SelectA <= DX_RGBA_SELECT_SRC_A )
		{
			SrcOnlyFlag = TRUE ;
		}
		else
		if( SelectR >= DX_RGBA_SELECT_BLEND_R && SelectR <= DX_RGBA_SELECT_BLEND_A &&
			SelectG >= DX_RGBA_SELECT_BLEND_R && SelectG <= DX_RGBA_SELECT_BLEND_A &&
			SelectB >= DX_RGBA_SELECT_BLEND_R && SelectB <= DX_RGBA_SELECT_BLEND_A &&
			SelectA >= DX_RGBA_SELECT_BLEND_R && SelectA <= DX_RGBA_SELECT_BLEND_A )
		{
			SelectR -= DX_RGBA_SELECT_BLEND_R ;
			SelectG -= DX_RGBA_SELECT_BLEND_R ;
			SelectB -= DX_RGBA_SELECT_BLEND_R ;
			SelectA -= DX_RGBA_SELECT_BLEND_R ;

			SrcOnlyFlag = TRUE ;
			SrcBlendReverse = TRUE ;

			HandleTemp = Info->BlendGrHandle ;
			Info->BlendGrHandle = Info->SrcGrHandle ;
			Info->SrcGrHandle = HandleTemp ;
		}

		if( SrcOnlyFlag )
		{
			PixelShaderHandle = &GRH.ShaderCode.RgbaMixS[ SelectR ][ SelectG ][ SelectB ][ SelectA ] ;
			if( *PixelShaderHandle < 0 )
			{
				if( GRA2.RGBAMixS_ShaderPackImage != NULL )
				{
					*PixelShaderHandle = NS_LoadPixelShaderFromMem( GRA2.RGBAMixS_ShaderAddress[ SelectR ][ SelectG ][ SelectB ][ SelectA ], GRA2.RGBAMixS_ShaderSize[ SelectR ][ SelectG ][ SelectB ][ SelectA ] ) ;
					if( *PixelShaderHandle < 0 )
					{
						DXST_ERRORLOGFMT_ADD(( _T( "RGBAMixS tB^[pVF[_[̍쐬Ɏs܂" ) )) ;
						return -1 ;
					}
					NS_SetDeleteHandleFlag( *PixelShaderHandle, PixelShaderHandle ) ;
				}
			}
		}
		else
		if( SelectR == SelectG && SelectR == SelectB && SelectR != DX_RGBA_SELECT_BLEND_A && SelectR != DX_RGBA_SELECT_SRC_A )
		{
			if( SelectR >= DX_RGBA_SELECT_BLEND_R && SelectR <= DX_RGBA_SELECT_BLEND_A )
			{
				SelectR -= DX_RGBA_SELECT_BLEND_R ;
				SelectG -= DX_RGBA_SELECT_BLEND_R ;
				SelectB -= DX_RGBA_SELECT_BLEND_R ;
				SelectA += DX_RGBA_SELECT_BLEND_R ;

				SrcBlendReverse = TRUE ;

				HandleTemp = Info->BlendGrHandle ;
				Info->BlendGrHandle = Info->SrcGrHandle ;
				Info->SrcGrHandle = HandleTemp ;
			}

			PixelShaderHandle = &GRH.ShaderCode.RgbaMixSRRRB[ SelectR ][ SelectA - DX_RGBA_SELECT_BLEND_R ] ;
			if( *PixelShaderHandle < 0 )
			{
				_SPRINTF( FileName, "RGBAMix_S%sS%sS%sB%s.pso", CharTable[ SelectR ], CharTable[ SelectG ], CharTable[ SelectB ], CharTable[ SelectA - DX_RGBA_SELECT_BLEND_R ] ) ;
				*PixelShaderHandle = MemLoadShaderCode( FileName, false ) ;
				if( *PixelShaderHandle < 0 )
				{
					DXST_ERRORLOGFMT_ADD(( _T( "RGBAMixS tB^[pVF[_[̍쐬Ɏs܂ %s" ), FileName )) ;
					return -1 ;
				}
				NS_SetDeleteHandleFlag( *PixelShaderHandle, PixelShaderHandle ) ;
			}
		}
		else
		if( ( SelectR == DX_RGBA_SELECT_SRC_R   && SelectG == DX_RGBA_SELECT_SRC_G   && SelectB == DX_RGBA_SELECT_SRC_B   ) ||
			( SelectR == DX_RGBA_SELECT_BLEND_R && SelectG == DX_RGBA_SELECT_BLEND_G && SelectB == DX_RGBA_SELECT_BLEND_B ) )
		{
			if( SelectR == DX_RGBA_SELECT_BLEND_R )
			{
				SelectR -= DX_RGBA_SELECT_BLEND_R ;
				SelectG -= DX_RGBA_SELECT_BLEND_R ;
				SelectB -= DX_RGBA_SELECT_BLEND_R ;
				SelectA += DX_RGBA_SELECT_BLEND_R ;

				SrcBlendReverse = TRUE ;

				HandleTemp = Info->BlendGrHandle ;
				Info->BlendGrHandle = Info->SrcGrHandle ;
				Info->SrcGrHandle = HandleTemp ;
			}

			PixelShaderHandle = &GRH.ShaderCode.RgbaMixSRGBB[ SelectA - DX_RGBA_SELECT_BLEND_R ] ;
			if( *PixelShaderHandle < 0 )
			{
				_SPRINTF( FileName, "RGBAMix_S%sS%sS%sB%s.pso", CharTable[ SelectR ], CharTable[ SelectG ], CharTable[ SelectB ], CharTable[ SelectA - DX_RGBA_SELECT_BLEND_R ] ) ;
				*PixelShaderHandle = MemLoadShaderCode( FileName, false ) ;
				if( *PixelShaderHandle < 0 )
				{
					DXST_ERRORLOGFMT_ADD(( _T( "RGBAMixS tB^[pVF[_[̍쐬Ɏs܂ %s" ), FileName )) ;
					return -1 ;
				}
				NS_SetDeleteHandleFlag( *PixelShaderHandle, PixelShaderHandle ) ;
			}
		}
		else
		{
			PixelShaderHandle = &GRH.ShaderCode.RgbaMixBasePS ;
			if( *PixelShaderHandle < 0 )
			{
				*PixelShaderHandle = MemLoadShaderCode( PsoFileName[ 0 ], false ) ;
				if( *PixelShaderHandle < 0 )
				{
					DXST_ERRORLOGFMT_ADD(( _T( "tB^[pVF[_[̍쐬Ɏs܂ %s" ), PsoFileName[ 0 ] )) ;
					return -1 ;
				}
				NS_SetDeleteHandleFlag( *PixelShaderHandle, PixelShaderHandle ) ;
			}
		}

		LibShader_PushShaderParam( &DrawParamTemp, 2 ) ;

		ParamF4[ 0 ].x = Info->BlendRatio ;
		ParamF4[ 0 ].y = Info->BlendRatio ;
		ParamF4[ 0 ].z = Info->BlendRatio ;
		ParamF4[ 0 ].w = Info->BlendRatio ;
		ParamF4[ 1 ].x = ( float )SelectR + 0.5f ;
		ParamF4[ 1 ].y = ( float )SelectG + 0.5f ;
		ParamF4[ 1 ].z = ( float )SelectB + 0.5f ;
		ParamF4[ 1 ].w = ( float )SelectA + 0.5f ;
		SetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, ParamF4, 2, FALSE ) ;

		NS_SetUsePixelShader( *PixelShaderHandle ) ;

		GraphFilter_BasePolygonDraw( Info ) ;

		LibShader_PopShaderParam( &DrawParamTemp ) ;

		if( SrcBlendReverse )
		{
			HandleTemp = Info->BlendGrHandle ;
			Info->BlendGrHandle = Info->SrcGrHandle ;
			Info->SrcGrHandle = HandleTemp ;
		}

		ResetShaderConstantSet( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTTYPE_PS_FLOAT, DX_SHADERCONSTANTSET_LIB_SUB, 0, 2 ) ;
	}
	else
	{
		// VF[_[gȂꍇ

		BYTE *Src ;
		BYTE *Blend ;
		BYTE *Dest ;
		DWORD i ;
		DWORD Width ;
		DWORD Height ;
		DWORD SrcAddPitch ;
		DWORD BlendAddPitch ;
		DWORD DestAddPitch ;

		if( GraphFilter_SoftImageSetup( Info ) < 0 )
			return -1 ;

		Src = ( BYTE * )Info->SrcImage.GraphData ;
		Blend = ( BYTE * )Info->BlendImage.GraphData ;
		Dest = ( BYTE * )Info->DestImage.GraphData ;

		Width  = Info->SrcX2 - Info->SrcX1 ;
		Height = Info->SrcY2 - Info->SrcY1 ;

		SrcAddPitch   = Info->SrcImage.Pitch   - Width * 4 ;
		BlendAddPitch = Info->BlendImage.Pitch - Width * 4 ;
		DestAddPitch  = Info->DestImage.Pitch  - Width * 4 ;

		do
		{
			i = Width ;
			do
			{
				switch( SelectB )
				{
				case DX_RGBA_SELECT_SRC_R :   Dest[ 0 ] = Src[ 2 ] ;   break ;
				case DX_RGBA_SELECT_SRC_G :   Dest[ 0 ] = Src[ 1 ] ;   break ;
				case DX_RGBA_SELECT_SRC_B :   Dest[ 0 ] = Src[ 0 ] ;   break ;
				case DX_RGBA_SELECT_SRC_A :   Dest[ 0 ] = Src[ 3 ] ;   break ;
				case DX_RGBA_SELECT_BLEND_R : Dest[ 0 ] = Blend[ 2 ] ; break ;
				case DX_RGBA_SELECT_BLEND_G : Dest[ 0 ] = Blend[ 1 ] ; break ;
				case DX_RGBA_SELECT_BLEND_B : Dest[ 0 ] = Blend[ 0 ] ; break ;
				case DX_RGBA_SELECT_BLEND_A : Dest[ 0 ] = Blend[ 3 ] ; break ;
				}

				switch( SelectG )
				{
				case DX_RGBA_SELECT_SRC_R :   Dest[ 1 ] = Src[ 2 ] ;   break ;
				case DX_RGBA_SELECT_SRC_G :   Dest[ 1 ] = Src[ 1 ] ;   break ;
				case DX_RGBA_SELECT_SRC_B :   Dest[ 1 ] = Src[ 0 ] ;   break ;
				case DX_RGBA_SELECT_SRC_A :   Dest[ 1 ] = Src[ 3 ] ;   break ;
				case DX_RGBA_SELECT_BLEND_R : Dest[ 1 ] = Blend[ 2 ] ; break ;
				case DX_RGBA_SELECT_BLEND_G : Dest[ 1 ] = Blend[ 1 ] ; break ;
				case DX_RGBA_SELECT_BLEND_B : Dest[ 1 ] = Blend[ 0 ] ; break ;
				case DX_RGBA_SELECT_BLEND_A : Dest[ 1 ] = Blend[ 3 ] ; break ;
				}

				switch( SelectR )
				{
				case DX_RGBA_SELECT_SRC_R :   Dest[ 2 ] = Src[ 2 ] ;   break ;
				case DX_RGBA_SELECT_SRC_G :   Dest[ 2 ] = Src[ 1 ] ;   break ;
				case DX_RGBA_SELECT_SRC_B :   Dest[ 2 ] = Src[ 0 ] ;   break ;
				case DX_RGBA_SELECT_SRC_A :   Dest[ 2 ] = Src[ 3 ] ;   break ;
				case DX_RGBA_SELECT_BLEND_R : Dest[ 2 ] = Blend[ 2 ] ; break ;
				case DX_RGBA_SELECT_BLEND_G : Dest[ 2 ] = Blend[ 1 ] ; break ;
				case DX_RGBA_SELECT_BLEND_B : Dest[ 2 ] = Blend[ 0 ] ; break ;
				case DX_RGBA_SELECT_BLEND_A : Dest[ 2 ] = Blend[ 3 ] ; break ;
				}

				switch( SelectA )
				{
				case DX_RGBA_SELECT_SRC_R :   Dest[ 3 ] = Src[ 2 ] ;   break ;
				case DX_RGBA_SELECT_SRC_G :   Dest[ 3 ] = Src[ 1 ] ;   break ;
				case DX_RGBA_SELECT_SRC_B :   Dest[ 3 ] = Src[ 0 ] ;   break ;
				case DX_RGBA_SELECT_SRC_A :   Dest[ 3 ] = Src[ 3 ] ;   break ;
				case DX_RGBA_SELECT_BLEND_R : Dest[ 3 ] = Blend[ 2 ] ; break ;
				case DX_RGBA_SELECT_BLEND_G : Dest[ 3 ] = Blend[ 1 ] ; break ;
				case DX_RGBA_SELECT_BLEND_B : Dest[ 3 ] = Blend[ 0 ] ; break ;
				case DX_RGBA_SELECT_BLEND_A : Dest[ 3 ] = Blend[ 3 ] ; break ;
				}

				Src   += 4 ;
				Blend += 4 ;
				Dest  += 4 ;
			}while( -- i ) ;

			Src   += SrcAddPitch ;
			Blend += SrcAddPitch ;
			Dest  += DestAddPitch ;
		}while( -- Height ) ;

		GraphFilter_SoftImageTerminate( Info ) ;
	}

	// I
	return 0 ;
}

// Opӂ̃VF[_[p
static void LibShader_PushBaseDrawParam( LIBSHADER_DRAWPARAMTEMP *DrawParamTemp )
{
	int i ;

	for( i = 0 ; i < GRH.RenderTargetNum ; i ++ )
	{
		DrawParamTemp->TargetSurface[ i ] = GRH.TargetSurface[ i ] ;
	}
	for( i = 1 ; i < GRH.RenderTargetNum ; i ++ )
	{
		if( GRH.TargetSurface[ i ] != NULL )
		{
			SetRenderTargetHardware( NULL, i ) ;
		}
	}

	DrawParamTemp->UseZBufferFlag3D = GBASE.EnableZBufferFlag3D ;
	DrawParamTemp->BlendMode = GBASE.BlendMode ;
	DrawParamTemp->BlendParam = GBASE.BlendParam ;
	DrawParamTemp->DrawMode = GBASE.DrawMode ;
	DrawParamTemp->AlphaTestMode = GBASE.AlphaTestMode ;
	DrawParamTemp->AlphaTestParam = GBASE.AlphaTestParam ;
	DrawParamTemp->FogEnable = GBASE.FogEnable ;
	DrawParamTemp->LightEnable = GBASE.Light.ProcessDisable ? FALSE : TRUE ;
	
	NS_SetUseZBuffer3D( FALSE ) ;
	NS_SetDrawBlendMode( DX_BLENDMODE_SRCCOLOR, 255 ) ;
	NS_SetDrawMode( DX_DRAWMODE_BILINEAR ) ;
	NS_SetDrawAlphaTest( DX_CMP_ALWAYS, 0 ) ;
	NS_SetFogEnable( FALSE ) ;
	NS_SetUseLighting( FALSE ) ;
	if( GraphicsDevice_IsValid() != 0 )
	{
		GraphicsDevice_GetDepthStencilSurface( &DrawParamTemp->DepthStencilSurfaece ) ;
		GraphicsDevice_SetDepthStencilSurface( NULL ) ;
	}
}

static void LibShader_PopBaseDrawParam( LIBSHADER_DRAWPARAMTEMP *DrawParamTemp )
{
	int i ;

	if( GraphicsDevice_IsValid() != 0 )
	{
		GraphicsDevice_SetDepthStencilSurface( DrawParamTemp->DepthStencilSurfaece ) ;
		Graphics_ObjectRelease( DrawParamTemp->DepthStencilSurfaece ) ;
		DrawParamTemp->DepthStencilSurfaece = NULL ;
	}
	for( i = 0 ; i < GRH.RenderTargetNum ; i ++ )
	{
		if( DrawParamTemp->TargetSurface[ i ] != NULL )
		{
			SetRenderTargetHardware( DrawParamTemp->TargetSurface[ i ], i ) ;
		}
	}

	GRH.InitializeFlag = TRUE ;
	SetViewportHardwareEasy( GBASE.DrawArea.left, GBASE.DrawArea.top, GBASE.DrawArea.right, GBASE.DrawArea.bottom ) ;
	GRH.InitializeFlag = FALSE ;

	NS_SetUseLighting( DrawParamTemp->LightEnable ) ;
	NS_SetFogEnable( DrawParamTemp->FogEnable ) ;
	NS_SetDrawAlphaTest( DrawParamTemp->AlphaTestMode, DrawParamTemp->AlphaTestParam ) ;
	NS_SetDrawMode( DrawParamTemp->DrawMode ) ;
	NS_SetDrawBlendMode( DrawParamTemp->BlendMode, DrawParamTemp->BlendParam ) ;
	NS_SetUseZBuffer3D( DrawParamTemp->UseZBufferFlag3D ) ;
}

static void LibShader_PushShaderParam( LIBSHADER_DRAWPARAMTEMP *DrawParamTemp, int TextureNum )
{
	DrawParamTemp->UserSetVertexShaderHandle = GRH.UserShaderRenderInfo.SetVertexShaderHandle ;
	DrawParamTemp->UserSetPixelShaderHandle = GRH.UserShaderRenderInfo.SetPixelShaderHandle ;
	SetUseShaderContantInfoState( &GRH.ShaderConstantInfo, DX_SHADERCONSTANTSET_MASK_LIB | DX_SHADERCONSTANTSET_MASK_LIB_SUB ) ;
	if( TextureNum != 0 )
	{
		_MEMCPY( DrawParamTemp->UserSetTextureGraphHandle, GRH.UserShaderRenderInfo.SetTextureGraphHandle, sizeof( int ) * TextureNum ) ;
	}
	DrawParamTemp->TextureNum = TextureNum ;
}

static void LibShader_PopShaderParam( LIBSHADER_DRAWPARAMTEMP *DrawParamTemp )
{
	int i ;

	for( i = 0 ; i < DrawParamTemp->TextureNum ; i ++ )
	{
		NS_SetUseTextureToShader( i, DrawParamTemp->UserSetTextureGraphHandle[ i ] == 0 ? -1 : DrawParamTemp->UserSetTextureGraphHandle[ i ] ) ;
	}
	NS_SetUseVertexShader( DrawParamTemp->UserSetVertexShaderHandle ) ;
	NS_SetUsePixelShader( DrawParamTemp->UserSetPixelShaderHandle ) ;
}

#endif // DX_NON_FILTER










// `ݒ֌W֐

// `惂[hZbg
extern	int NS_SetDrawMode( int DrawMode )
{
	if( GBASE.NotDrawFlag || DrawMode == GBASE.DrawMode )
		return 0 ;

	// `惂[h̕ۑ
	GBASE.DrawMode = DrawMode ;
	GRH.DrawPrepAlwaysFlag = TRUE ;

	// Direct3D ɐݒ𔽉f
	if( GRA2.ValidHardWare )
	{
		SetDrawModeHardware( DrawMode ) ;
	}

	// I
	return 0 ;
}

// őٕ̒lZbg
extern int NS_SetMaxAnisotropy( int MaxAnisotropy )
{
	if( GBASE.NotDrawFlag || MaxAnisotropy == GBASE.MaxAnisotropy )
		return 0 ;

	// őٕ̕ۑ
	GBASE.MaxAnisotropy = MaxAnisotropy ;
	GRH.DrawPrepAlwaysFlag = TRUE ;

	// Direct3D ɐݒ𔽉f
	if( GRA2.ValidHardWare )
	{
		SetMaxAnisotropyHardware( MaxAnisotropy ) ;
	}

	// I
	return 0 ;
}

// `uh[hZbg
extern	int NS_SetDrawBlendMode( int BlendMode, int BlendParam )
{
	if( GBASE.NotDrawFlag || ( GBASE.BlendMode == BlendMode && GBASE.BlendParam == BlendParam ) )
		return 0 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// uh[h̕ۑ
	if( GBASE.BlendMode != BlendMode )
	{
		GBASE.BlendMode = BlendMode ;
		GRH.DrawPrepAlwaysFlag = TRUE ;
	}

	if( BlendParam > 255 ) BlendParam = 255 ;
	if( BlendParam < 0	 ) BlendParam = 0 ;
	GBASE.BlendParam = BlendParam ;
	SetMemImgDrawBlendMode( GBASE.BlendMode, GBASE.BlendParam ) ;

	// Direct3D ̐ݒɔf
	if( GRA2.ValidHardWare )
	{
		// fBt[YJ[̍XV
		GRH.DiffuseColor = GetDiffuseColor() ;
	}

	// I
	return 0 ;
}

// `掞̃At@eXg̐ݒs( TestMode:DX_CMP_GREATER( -1:ftHgɖ߂ )  TestParam:`At@lƂ̔rɎgpl )
extern	int	NS_SetDrawAlphaTest( int TestMode, int TestParam )
{
	if( GBASE.NotDrawFlag || ( GBASE.AlphaTestMode == TestMode && GBASE.AlphaTestParam == TestParam ) )
		return 0 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// At@eXgp[^ۑ
	GBASE.AlphaTestMode = TestMode ;
	if( TestParam > 255 ) TestParam = 255 ;
	if( TestParam < 0	 ) TestParam = 0 ;
	GBASE.AlphaTestParam = TestParam ;
	GRH.DrawPrepAlwaysFlag = TRUE ;

	// Direct3D ̐ݒɔf
	if( GRA2.ValidHardWare )
	{
		// fBt[YJ[̍XV
		GRH.DiffuseColor = GetDiffuseColor() ;
	}

	// I
	return 0 ;
}

// `揈ɕ`悷摜ƃuh郿`lt摜Zbg
extern	int NS_SetBlendGraph( int BlendGraph, int BorderParam, int BorderRange )
{
	return NS_SetBlendGraphParam( BlendGraph, DX_BLENDGRAPHTYPE_WIPE, BorderParam, BorderRange ) ;
/*
	IMAGEDATA2 *Image2 ;

	if( GBASE.NotDrawFlag || ( GBASE.BlendGraphBorderRange == BorderRange && GBASE.BlendGraph == BlendGraph && GBASE.BlendGraphBorderParam == BorderParam ) )
		return 0 ;

	// uh摜 -1 uh摜~߂Ƃ
	if( BlendGraph == -1 )
	{
		Image2 = NULL ;
		GBASE.BlendGraph = -1 ;
	}
	else
	{
		// G[
		if( GRAPHCHK( BlendGraph, Image2 ) )
			return -1 ;
		GBASE.BlendGraph = BlendGraph ;
	}

	CheckActiveState() ;

	if( BorderRange > 255 ) BorderRange = 255 ;
	else
	if( BorderRange < 0   ) BorderRange = 0   ;

	if( BorderParam > 255 ) BorderParam = 255 ;
	else
	if( BorderParam < 0	  ) BorderParam = 0   ;

	GBASE.BlendGraphBorderParam = BorderParam ;
	GBASE.BlendGraphBorderRange = BorderRange ;

	// Direct3D gpĂ邩ǂŏ𕪊
	if( GRA2.ValidHardWare )
	{
		// Direct3D gpĂꍇ

		if( GraphicsDevice_IsValid() == 0 ) return -1 ;

		// uh摜 NULL uh摜̉
		if( Image2 == NULL )
		{
			SetBlendTextureHardware( NULL, BorderParam, BorderRange ) ;
		}
		else
		{
			// eNX`摜ł͂ȂI
			if( Image2->Orig->FormatDesc.TextureFlag == FALSE ) 
				return -1 ;

			// uheNX`Zbg
			SetBlendTextureHardware( Image2->Orig->Hard.Tex[ 0 ].Texture, BorderParam, BorderRange ) ;

			// eNX`̕ƍۑ
			GRH.InvBlendTextureWidth  = 1.0F / ( GRH.BlendTextureWidth  = (float)Image2->Orig->Hard.Tex[ 0 ].TexWidth )  ;
			GRH.InvBlendTextureHeight = 1.0F / ( GRH.BlendTextureHeight = (float)Image2->Orig->Hard.Tex[ 0 ].TexHeight ) ;
		}
	}
	else
	{
		// Direct3D gpĂȂꍇ̏

		// uhOtBbÑAhXݒ
		GRS.BlendMemImg = GBASE.BlendGraph == -1 ? NULL : &Image2->Orig->Soft.MemImg ;

		// MEMIMG VXeւ̐ݒ
		SetBlendGraphParamMemImg( BorderParam, BorderRange ) ;
	}

	// I
	return 0 ;
*/
}

// uh摜̋N_WZbg
extern	int NS_SetBlendGraphPosition( int x, int y )
{
	// ܂łƒlꍇ͉I
	if( GBASE.BlendGraphX == x && GBASE.BlendGraphY == y ) return 0 ;

	// Wۑ
	GBASE.BlendGraphX = x ;
	GBASE.BlendGraphY = y ;

	// I
	return 0 ;
}

// `揈ɕ`悷摜ƃuh摜̃uhݒs
extern	int NS_SetBlendGraphParam( int BlendGraph, int BlendType, ... )
{
	int Result ;
	va_list VaList ;

	va_start( VaList, BlendType ) ;

	Result = SetBlendGraphParamBase(  BlendGraph,  BlendType, VaList ) ;

	va_end( VaList ) ;

	return Result ;
}

// SetBlendGraphParam ̉ϒp[^t
extern int SetBlendGraphParamBase( int BlendGraph, int BlendType, va_list ParamList )
{
	IMAGEDATA2 *Image2 ;
	int Param[ 16 ] ;

	// uh摜 -1 uh摜~߂Ƃ
	if( BlendGraph <= 0 )
	{
		Image2 = NULL ;
		GBASE.BlendGraph = -1 ;
	}
	else
	{
		// G[
		if( GRAPHCHK( BlendGraph, Image2 ) )
			return -1 ;
		GBASE.BlendGraph = BlendGraph ;
	}

	CheckActiveState() ;

	if( Image2 != NULL )
	{
		switch( BlendType )
		{
		case DX_BLENDGRAPHTYPE_NORMAL :
			int FadeRatio ;

			FadeRatio = va_arg( ParamList, int ) ;

			if( FadeRatio > 255 ) FadeRatio = 255 ;
			else
			if( FadeRatio < 0   ) FadeRatio = 0   ;

			Param[ 0 ] = FadeRatio ;
			break ;

		case DX_BLENDGRAPHTYPE_WIPE :
			int BorderRange ;
			int BorderParam ;

			BorderParam = va_arg( ParamList, int ) ;
			BorderRange = va_arg( ParamList, int ) ;

			if( BorderRange > 255 ) BorderRange = 255 ;
			else
			if( BorderRange < 0   ) BorderRange = 0   ;

			if( BorderParam > 255 ) BorderParam = 255 ;
			else
			if( BorderParam < 0	  ) BorderParam = 0   ;
			
			Param[ 0 ] = GBASE.BlendGraphBorderParam = BorderParam ;
			Param[ 1 ] = GBASE.BlendGraphBorderRange = BorderRange ;

			// Direct3D gpĂȂꍇ̂ݏ𕪊
			if( GRA2.ValidHardWare == FALSE )
			{
				// MEMIMG VXeւ̐ݒ
				SetBlendGraphParamMemImg( BorderParam, BorderRange ) ;
			}
			break ;

		case DX_BLENDGRAPHTYPE_ALPHA :
			break ;
		}
	}

	// Direct3D gpĂ邩ǂŏ𕪊
	if( GRA2.ValidHardWare )
	{
		// Direct3D gpĂꍇ

		if( GraphicsDevice_IsValid() == 0 ) return -1 ;
		
		// uh摜 NULL ̓eNX`ł͂Ȃuh摜̉
		if( Image2 == NULL || Image2->Orig->FormatDesc.TextureFlag == FALSE )
		{
			GBASE.BlendGraph = -1 ;
			SetBlendTextureHardware( NULL ) ;
		}
		else
		{
			// uhp[^Zbg
			SetBlendTextureHardware( Image2->Hard.Draw[ 0 ].Tex[ 0 ].Texture, Image2->Hard.Draw[ 0 ].Tex[ 0 ].TexWidth, Image2->Hard.Draw[ 0 ].Tex[ 0 ].TexHeight ) ;
			SetBlendTextureParamHardware( BlendType, Param ) ;
		}
	}
	else
	{
		// Direct3D gpĂȂꍇ̏

		// uhOtBbÑAhXݒ
		GRS.BlendMemImg = GBASE.BlendGraph <= 0 ? NULL : &Image2->Orig->Soft.MemImg ;
	}

	// I
	return 0 ;
}

// `PxZbg
extern	int NS_SetDrawBright( int RedBright, int GreenBright, int BlueBright )
{
	bool OldWhiteFlag ;
	bool NewWhiteFlag ;

	if( GBASE.DrawBright.Red   == RedBright  &&
		GBASE.DrawBright.Green == GreenBright &&
		GBASE.DrawBright.Blue  == BlueBright )
	{
		return 0 ;
	}

	if( (unsigned int)RedBright   > 255 )
	{
		     if( RedBright   > 255 ) RedBright   = 255 ;
		else if( RedBright   < 0   ) RedBright   = 0   ;
	}
	if( (unsigned int)GreenBright > 255 )
	{
		     if( GreenBright > 255 ) GreenBright = 255 ;
		else if( GreenBright < 0   ) GreenBright = 0   ;
	}
	if( (unsigned int)BlueBright  > 255 )
	{
		     if( BlueBright  > 255 ) BlueBright  = 255 ;
		else if( BlueBright  < 0   ) BlueBright  = 0   ;
	}

	// Pxۑ
	OldWhiteFlag = ( GBASE.bDrawBright & 0xffffff ) == 0xffffff ;
	GBASE.DrawBright.Red   = ( BYTE )RedBright   ;
	GBASE.DrawBright.Blue  = ( BYTE )BlueBright  ;
	GBASE.DrawBright.Green = ( BYTE )GreenBright ;
	NewWhiteFlag = ( GBASE.bDrawBright & 0xffffff ) == 0xffffff ;
	SetMemImgDrawBright( GBASE.bDrawBright ) ;

	if( OldWhiteFlag != NewWhiteFlag )
	{
		GRH.DrawPrepAlwaysFlag = TRUE ;
	}

	// Direct3D ɐݒ𔽉f
	if( GRA2.ValidHardWare )
	{
		// fBt[YJ[̍XV
		GRH.DiffuseColor = GetDiffuseColor() ;
	}

	// I
	return 0 ;
}

// `悷摜̐F𖳎邩ǂw肷( EnableFlag:̋@\gǂ( TRUE:g  FALSE:gȂ ) )
extern int NS_SetIgnoreDrawGraphColor( int EnableFlag )
{
	if( GBASE.IgnoreGraphColorFlag == EnableFlag )
		return 0 ;

	// ݒۑ
	GBASE.IgnoreGraphColorFlag = EnableFlag ;
	GRH.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// `ʂ̃Zbg
extern	int NS_SetDrawScreen( int DrawScreen )
{
	int OldScreen ;
	int OldScreenSurface ;
#ifndef DX_NON_MASK
	int Flag ;
#endif
//	int Result ;
	IMAGEDATA2 *Image2 ;
	IMAGEDATA2 *OldImage2 ;
	
	if( GRA2.InitializeFlag == FALSE ) return -1 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// OtBbN`悪܂łƓꍇI
//	if( DrawScreen == GBASE.TargetScreen[ 0 ] && GBASE.TargetScreenSurface == 0 ) return 0 ;

	// 摜̎擾
	if( GRAPHCHKFULL( DrawScreen, Image2 ) )
	{
		Image2 = NULL ;
	}
	else
	{
		// 摜ꍇ͕`\ł͖ꍇ̓G[
		if( Image2->Orig->FormatDesc.DrawValidFlag == FALSE )
			return -1 ;
	}

	// ܂ł̕`̉摜̎擾
	if( GRAPHCHKFULL( GBASE.TargetScreen[ 0 ], OldImage2 ) )
	{
		OldImage2 = NULL ;
	}

	// w肵XN[牽I
	if( DrawScreen != DX_SCREEN_FRONT && DrawScreen != DX_SCREEN_BACK &&
		DrawScreen != DX_SCREEN_WORK  && DrawScreen != DX_SCREEN_TEMPFRONT &&
		( ( DrawScreen & DX_HANDLEERROR_MASK ) != 0                   ||
		  ( DrawScreen & DX_HANDLETYPE_MASK  ) != DX_HANDLETYPE_MASK_GRAPH || 
		  GetHandleInfo( DrawScreen ) == NULL ) )
	{
		return -1 ;
	}

#ifndef DX_NON_MASK
	// }XNgpI葱
	Flag = MASKD.MaskUseFlag ;
	NS_SetUseMaskScreenFlag( FALSE ) ;

	// `̃TCYŃ}XNʂ쐬Ȃ
	if( MASKD.CreateMaskFlag )
	{
		int w, h ;
		NS_GetGraphSize( DrawScreen, &w, &h ) ;
		CreateMaskScreenFunction( TRUE, w, h ) ;
	}
#endif

	// `ۑ
	OldScreen = GBASE.TargetScreen[ 0 ] ;
	OldScreenSurface = GBASE.TargetScreenSurface[ 0 ] ;
	GBASE.TargetScreen[ 0 ] = DrawScreen ;
	GBASE.TargetScreenSurface[ 0 ] = 0 ;

	// `\TCY̎擾
	NS_GetGraphSize( DrawScreen, &GBASE.DrawSizeX, &GBASE.DrawSizeY ) ;

	// `ɐlނǂ̃tOXV
	RefreshAlphaChDrawMode() ;

	// Rc`֌W̕`Zbg
	if( GRA2.ValidHardWare )
	{
		if( GraphicsDevice_IsValid() != 0 )
		{
			// `揈IĂ
			RenderVertexHardware() ;
			EndScene() ;

			// ZbgĂeNX`[O
			SetTextureHardware( NULL ) ;

			// ܂ł̕`悪_O^[QbgT[tFXꍇ̓_O^[QbgeNX`ɓ]
			if( OldImage2 != NULL && OldImage2->Hard.Draw[ 0 ].Tex->RenderTargetSurface )
			{
				UpdateDrawTexture( OldImage2->Hard.Draw[ 0 ].Tex, OldScreenSurface ) ;
			}

			// `̕ύX

			// }XNT[tFX݂ĂĊLȏꍇ̓}XNT[tFX`Ώ̂ɂ
#ifndef DX_NON_MASK
			if( MASKD.MaskValidFlag && MASKD.MaskScreenSurface )
			{
				SetRenderTargetHardware( MASKD.MaskScreenSurface ) ;
			}
			else
#endif
			// `\摜Lȏꍇ͕`\摜`Ώۂɂ
			if( Image2 )
			{
				if( Image2->Hard.Draw[ 0 ].Tex->RenderTargetSurface )
				{
					SetRenderTargetHardware( Image2->Hard.Draw[ 0 ].Tex->RenderTargetSurface ) ;
				}
				else
				{
					SetRenderTargetHardware( Image2->Hard.Draw[ 0 ].Tex->Surface[ GBASE.TargetScreenSurface[ 0 ] ] ) ;
				}
			}
			else
			{
				// ȊȌꍇ̓TuobNobt@Lȏꍇ̓TuobNobt@`Ώ̂ɂ
				SetRenderTargetHardware( GRH.SubBackBufferSurface ? GRH.SubBackBufferSurface : GRH.BackBufferSurface ) ;
			}

			// gpyobt@̃ZbgAbv
			SetupUseZBuffer() ;
		}
	}
	else
	{
		// \tgEGA_Ȍꍇ̏

		// `̌
#ifndef DX_NON_MASK
		if( MASKD.MaskValidFlag )
		{
			// }XNLȏꍇ̓}XN`ɂ
			GRS.TargetMemImg = &MASKD.MaskDrawMemImg ;
		}
		else
#endif
		{
			// 摜`Ώۂǂŏ𕪊
			if( Image2 != NULL )
			{
				// At@`lt̉摜̏ꍇ͕`ΏۂɂłȂ
				if( Image2->Soft.MemImg.Base->UseAlpha == TRUE )
					return -1 ;

				// `\摜`
				GRS.TargetMemImg = &Image2->Soft.MemImg ;
			}
			else
			{
				// Cobt@`
				GRS.TargetMemImg = &GRS.MainBufferMemImg ;
			}
		}
	}

	// `悪\ʂIɉʃRs[s
	GraphicsDevice_SetupTimerPresent( DrawScreen == DX_SCREEN_FRONT ) ;

	// ύXɐ`̈̍XVs
	{
		// `̈XV
		{
//			RECT SrcRect, ClippuRect ;
			RECT SrcRect ;
			int NewWidth, NewHeight, OldWidth, OldHeight ;

			NS_GetGraphSize( DrawScreen, &NewWidth, &NewHeight ) ;
			NS_GetGraphSize( OldScreen, &OldWidth, &OldHeight ) ;

			SrcRect = GBASE.DrawArea ;

//			SETRECT( ClippuRect, 0, 0, NewWidth, NewHeight ) ;
//			RectClipping( &SrcRect, &ClippuRect ) ;

//			if( NewWidth != GBASE.DrawArea.right || NewHeight != GBASE.DrawArea.bottom )
			if( ( NewWidth != OldWidth ) || ( NewHeight != OldHeight ) )
			{
				NS_SetDrawArea( 0, 0, NewWidth, NewHeight ) ;
			}
			else
			{
				NS_SetDrawArea( SrcRect.left, SrcRect.top, SrcRect.right, SrcRect.bottom ) ;
			}
		}
		
		// Rc`揈p̍sݒ̏s
		{
			MATRIX mat ;
			float D ;

			// hbgAXyNgPDOɖ߂
			NS_SetCameraDotAspect( 1.0f ) ;
	
			// [hϊs͒Pʍs
			CreateIdentityMatrix( &mat ) ;
			NS_SetTransformToWorld( &mat ) ;

			// r[|[gs̃Zbg( `̈̒SWE̒SWɂ
			CreateViewportMatrix( &mat, ( float )GBASE.DrawSizeX / 2,	( float )GBASE.DrawSizeY / 2,
										( float )GBASE.DrawSizeX,		( float )GBASE.DrawSizeY ) ;
			GBASE.Direct3DViewportMatrix = mat ;
			CreateInverseMatrix( &GBASE.Direct3DViewportMatrixAnti, &mat ) ;

			// CuǗ̃r[|[gsXV
			GBASE.CameraScreenCenterX = ( float )GBASE.DrawSizeX / 2.0f ;
			GBASE.CameraScreenCenterY = ( float )GBASE.DrawSizeY / 2.0f ;
			NS_SetCameraScreenCenter( GBASE.CameraScreenCenterX, GBASE.CameraScreenCenterY ) ;

			// r[s z = 0.0 ̎ɒxXN[ŜʂʒuƕJ
			{
				VECTOR up, at, eye ;

				D = (float)( ( GBASE.DrawSizeY / 2 ) / DEFAULT_TAN_FOV_HALF ) ;

				eye.x = (float)GBASE.DrawSizeX / 2 ;
				eye.y = (float)GBASE.DrawSizeY / 2 ;
				eye.z = -D;
				
				at.x = eye.x ;
				at.y = eye.y ;
				at.z = eye.z + 1.0F ;
				
				up.x = 0.0f ;
				up.y = 1.0F ;
				up.z = 0.0f ;
				
				NS_SetCameraPositionAndTargetAndUpVec( eye, at, up ) ;
//				CreateLookAtMatrix( &mat, &eye, &at, &up ) ;
//				NS_SetTransformToView( &mat ) ;
			}

			// vWFNVs͕ʂ
			NS_SetupCamera_Perspective( DEFAULT_FOV ) ;
			NS_SetCameraNearFar( D * 0.1f + DEFAULT_NEAR, D + DEFAULT_FAR ) ;
		}

#ifndef DX_NON_MASK
		// }XNgp葱
		NS_SetUseMaskScreenFlag( Flag ) ;
#endif
	}

	// I
	return 0 ;
}

// `yobt@̃Zbg
extern	int	NS_SetDrawZBuffer( int DrawScreen )
{
	IMAGEDATA2 *Image2 ;
	
	if( GRA2.InitializeFlag == FALSE ) return -1 ;

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
	CheckActiveState() ;

	// 摜̎擾
	if( GRAPHCHKFULL( DrawScreen, Image2 ) )
	{
		Image2 = NULL ;
	}
	else
	{
		// 摜ꍇ͕`\ł͖ꍇyobt@ĂȂ摜̏ꍇ̓G[
		if( Image2->Orig->FormatDesc.DrawValidFlag == FALSE ||
			Image2->Hard.Draw[ 0 ].Tex->ZBuffer == NULL )
			return -1 ;
	}

	// `yobt@̃nhۑ
	GBASE.TargetZBuffer = DrawScreen ;

	// `yobt@XV
	SetupUseZBuffer() ;

	// I
	return 0 ;
}

// `\̈̃Zbg
extern	int NS_SetDrawArea( int x1, int y1, int x2, int y2 )
{
	const char *HandleString = NULL ;
	int Buf, SizeX, SizeY ;
	IMAGEDATA2 *Image2 ;

	if( GBASE.NotDrawFlag ) return 0 ;

	// tXN[}XNsĂꍇ̓}XN`̌ʂ𔽉f
	MASK_FULLSCREEN_MASKUPDATE

	// \tgANeBȕꍇ̓ANeBuɂȂ܂ő҂
//	CheckActiveState() ;

	// IWi̕`GAۑ
	GRA2.OriginalDrawRect.left   = x1 ;
	GRA2.OriginalDrawRect.top    = y1 ;
	GRA2.OriginalDrawRect.right  = x2 ;
	GRA2.OriginalDrawRect.bottom = y2 ;
	
	// `̕`\TCY擾
	switch( GBASE.TargetScreen[ 0 ] )
	{
	case DX_SCREEN_BACK :
	case DX_SCREEN_FRONT :
		HandleString = GBASE.TargetScreen[ 0 ] == DX_SCREEN_BACK ? "Back Buffer" : "Front Buffer" ;
		SizeX = GRA2.MainScreenSizeX ;
		SizeY = GRA2.MainScreenSizeY ;
		break ;

	default :
		HandleString = "Image Buffer" ;
		// G[
		if( GRAPHCHK( GBASE.TargetScreen[ 0 ], Image2 ) )
			return -1 ;

		SizeX = Image2->Width ;
		SizeY = Image2->Height ;
		break ;
	}

	// Et␳Ƃ͂ݏo␳
	if( x1 > x2 ){ Buf = x1 ; x1 = x2 ; x2 = Buf ; }
	if( y1 > y2 ){ Buf = y1 ; y1 = y2 ; y2 = Buf ; }

	if( x1 < 0 )		x1 = 0 ;
	if( x1 > SizeX )	x1 = SizeX ; 
	if( x2 < 0 )		x2 = 0 ;
	if( x2 > SizeX )	x2 = SizeX ;

	if( y1 < 0 )		y1 = 0 ;
	if( y1 > SizeY )	y1 = SizeY ; 
	if( y2 < 0 )		y2 = 0 ;
	if( y2 > SizeY )	y2 = SizeY ;

	// `\`Zbg
	GBASE.DrawAreaF.left   = ( float )( GBASE.DrawArea.left   = x1 ) ;
	GBASE.DrawAreaF.top    = ( float )( GBASE.DrawArea.top    = y1 ) ;
	GBASE.DrawAreaF.right  = ( float )( GBASE.DrawArea.right  = x2 ) ;
	GBASE.DrawAreaF.bottom = ( float )( GBASE.DrawArea.bottom = y2 ) ;
	SetMemImgDrawArea( &GBASE.DrawArea ) ;

	// `\tOZbg
	GBASE.NotDrawFlagInSetDrawArea = x1 == x2 || y1 == y2 ;
	if( GBASE.NotDrawFlagInSetDrawArea == FALSE )
	{
		// cRc̕``̃Zbg
		if( GRA2.ValidHardWare )
		{
			D_D3DVIEWPORT9 Viewport ;
			MATRIX TempMatrix ;

			if( GraphicsDevice_IsValid() == 0 )	return -1 ;

			if( GBASE.DrawArea.right  - GBASE.DrawArea.left == 0 ||
				GBASE.DrawArea.bottom - GBASE.DrawArea.top  == 0 )
				return -1 ;

			// r[|[g̃ZbeBO
			_MEMSET( &Viewport, 0, sizeof( Viewport ) ) ;
			Viewport.X		= GBASE.DrawArea.left ;
			Viewport.Y		= GBASE.DrawArea.top ;
			Viewport.Width	= GBASE.DrawArea.right  - GBASE.DrawArea.left ;
			Viewport.Height	= GBASE.DrawArea.bottom - GBASE.DrawArea.top  ;
			Viewport.MinZ	= 0.0f ;
			Viewport.MaxZ	= 1.0f ;

			// Zbg
			SetViewportHardware( &Viewport ) ;
			SetScissorRectHardware( &GBASE.DrawArea ) ;

			// Direct3D ̃r[|[gs̍XV
			CreateViewportMatrix(
				&GBASE.Direct3DViewportMatrix,
				( float )( GBASE.DrawArea.right  - GBASE.DrawArea.left ) / 2.0f + GBASE.DrawArea.left,
				( float )( GBASE.DrawArea.bottom - GBASE.DrawArea.top  ) / 2.0f + GBASE.DrawArea.top,
				( float )( GBASE.DrawArea.right  - GBASE.DrawArea.left ),
				( float )( GBASE.DrawArea.bottom - GBASE.DrawArea.top  ) ) ;
			CreateInverseMatrix( &GBASE.Direct3DViewportMatrixAnti, &GBASE.Direct3DViewportMatrix ) ;

			// ˉesƃr[|[gs̋tsẐZbg
			CreateMultiplyMatrix( &TempMatrix, &GBASE.ProjectionMatrix, &GBASE.ViewportMatrix ) ;
			CreateMultiplyMatrix( &TempMatrix, &TempMatrix,             &GBASE.Direct3DViewportMatrixAnti ) ;
			SetTransformToProjectionHardware( &TempMatrix ) ;
			GBASE.MatchHardwareProjectionMatrix = TRUE ;
		}
	}

	// I
	return 0 ;
}

// n[hEGA̒_Z@\gp邩ǂݒ肷
extern	int NS_SetUseHardwareVertexProcessing( int Flag )
{
	// ÔݗL
	if( DxSysData.DxLib_InitializeFlag == TRUE ) return -1 ;

	GRH.NonUseVertexHardwareProcess = !Flag ;

	// I
	return 0 ;
}

// GPU ̃vO}uVF[_[f3.0gpłł̓VF[_[f3.0悤邩ǂݒ肷( TRUE:gp( ftHg )  FALSE:gpȂ )
extern int NS_SetUseGPUShaderModel3( int Flag )
{
	GRH.UseShaderModel3 = Flag ;

	// I
	return 0 ;
}

// SetRestoreGraphCallback ̋
extern int NS_SetRestoreShredPoint( void (* ShredPoint )( void ) )
{
	return NS_SetRestoreGraphCallback( ShredPoint ) ;
}

// OtBbNnh֐̓o^
extern	int NS_SetRestoreGraphCallback( void (* Callback )( void ) )
{
	// OtBbNXbhAhX̓o^
	if( Callback == NULL )
	{
		GBASE.GraphRestoreShred = DefaultRestoreGraphFunction ;
	}
	else
	{
		GBASE.GraphRestoreShred = Callback ;
	}

	// I
	return 0 ;
}

// OtBbN֐̎s
extern	int NS_RunRestoreShred( void )
{
#ifndef DX_NON_ASYNCLOAD
	// 񓯊ǂݍ݂͈ꎞIɖɂ
	int UseASyncThread = GetASyncLoadFlag() ;
	NS_SetUseASyncLoadFlag( FALSE ) ;
#endif

	// OtBbNXbh̎s
	if( GBASE.GraphRestoreShred == NULL )
	{
		DefaultRestoreGraphFunction() ;
	}
	else
	{
		GBASE.GraphRestoreShred() ;
	}

#ifndef DX_NON_MODEL
	// f̃eNX`ēǂݍ
	MV1ReloadTexture() ;
#endif

#ifndef DX_NON_FONT
	// tHgnhLbV
	InitCacheFontToHandle() ;
#endif

#ifndef DX_NON_ASYNCLOAD
	// 񓯊ǂݍ݂̐ݒɖ߂
	NS_SetUseASyncLoadFlag( UseASyncThread ) ;
#endif

	// I
	return 0 ;
}

// OtBbNXfoCXXg畜AۂɌĂ΂R[obN֐ݒ肷
extern int NS_SetGraphicsDeviceRestoreCallbackFunction( void (* Callback )( void *Data ), void *CallbackData )
{
	GRH.DeviceRestoreCallbackFunction = Callback ;
	GRH.DeviceRestoreCallbackData = CallbackData ;

	// I
	return 0 ;
}

// OtBbNXfoCXXg畜AOɌĂ΂R[obN֐ݒ肷
extern int NS_SetGraphicsDeviceLostCallbackFunction( void (* Callback )( void *Data ), void *CallbackData )
{
	GRH.DeviceLostCallbackFunction = Callback ;
	GRH.DeviceLostCallbackData = CallbackData ;

	// I
	return 0 ;
}

// [hϊpsZbg
extern	int NS_SetTransformToWorld( const MATRIX *Matrix )
{
	// _`
	RenderVertexHardware() ;

	// f[^ۑ
	GBASE.WorldMatrix = *Matrix ;
	GBASE.ValidBlendMatrix = FALSE ;

	// SĂ̍s|킹sXV
	RefreshBlendTransformMatrix() ;

	// Direct3D ɐݒ
	if( GRA2.ValidHardWare )
	{
		SetTransformToWorldHardware( Matrix ) ;
		GBASE.MatchHardwareWorldMatrix = TRUE ;
	}

	// I
	return 0 ;
}

// r[ϊpsZbg
extern	int NS_SetTransformToView( const MATRIX *Matrix )
{
	// _`
	RenderVertexHardware() ;

	// f[^ۑ
	GBASE.ViewMatrix = *Matrix ;
	GBASE.ValidBlendMatrix = FALSE ;

	// SĂ̍s|킹sXV
	RefreshBlendTransformMatrix() ;

	// Direct3D ɐݒ
	if( GRA2.ValidHardWare )
	{
		SetTransformToViewHardware( Matrix ) ;
		GBASE.MatchHardwareViewMatrix = TRUE ;
	}

	// I
	return 0 ;
}

// eϊpsZbg
extern	int _SetTransformToProjection( const MATRIX *Matrix )
{
	// _`
	RenderVertexHardware() ;

	// f[^ۑ
	GBASE.ProjectionMatrix = *Matrix ;
	GBASE.ValidBlendMatrix = FALSE ;

	// SĂ̍s|킹sXV
	RefreshBlendTransformMatrix() ;

	// Direct3D ɐݒ
	if( GRA2.ValidHardWare )
	{
		MATRIX TempMatrix ;

		CreateMultiplyMatrix( &TempMatrix, &GBASE.ProjectionMatrix, &GBASE.ViewportMatrix ) ;
		CreateMultiplyMatrix( &TempMatrix, &TempMatrix,             &GBASE.Direct3DViewportMatrixAnti ) ;
		SetTransformToProjectionHardware( &TempMatrix ) ;
		GBASE.MatchHardwareProjectionMatrix = TRUE ;
	}

	// I
	return 0 ;
}

// r[|[gsZbg
extern	int NS_SetTransformToViewport( const MATRIX *Matrix )
{
	// _`
	RenderVertexHardware() ;

	// f[^ۑ
	GBASE.ViewportMatrix = *Matrix ;
	GBASE.ValidBlendMatrix = FALSE ;

	// SĂ̍s|킹sXV
	RefreshBlendTransformMatrix() ;

	// Direct3D ɐݒ
	if( GRA2.ValidHardWare )
	{
		MATRIX TempMatrix ;

		CreateMultiplyMatrix( &TempMatrix, &GBASE.ProjectionMatrix, &GBASE.ViewportMatrix ) ;
		CreateMultiplyMatrix( &TempMatrix, &TempMatrix,             &GBASE.Direct3DViewportMatrixAnti ) ;
		SetTransformToProjectionHardware( &TempMatrix ) ;
		GBASE.MatchHardwareProjectionMatrix = TRUE ;
	}

	// I
	return 0 ;
}

// |SJO̗LAZbg
extern int NS_SetUseBackCulling( int Flag )
{
	return NS_SetUseCullingFlag( Flag ) ;
}

// |SJO̗LAZbg
extern int NS_SetUseCullingFlag( int Flag )
{
	if( GBASE.CullMode == Flag ) return 0 ;

	// JO[h̃tOۑ
	GBASE.CullMode = Flag ;
	GRH.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// eNX`AhX[hݒ肷
extern	int NS_SetTextureAddressMode( int Mode /* DX_TEXADDRESS_WRAP  */, int Stage )
{
	if( Stage == -1 )
	{
		if( GBASE.TexAddressModeU[ 0 ] == Mode && GBASE.TexAddressModeV[ 0 ] == Mode &&
			GBASE.TexAddressModeU[ 1 ] == Mode && GBASE.TexAddressModeV[ 1 ] == Mode &&
			GBASE.TexAddressModeU[ 2 ] == Mode && GBASE.TexAddressModeV[ 2 ] == Mode &&
			GBASE.TexAddressModeU[ 3 ] == Mode && GBASE.TexAddressModeV[ 3 ] == Mode &&
			GBASE.TexAddressModeU[ 4 ] == Mode && GBASE.TexAddressModeV[ 4 ] == Mode &&
			GBASE.TexAddressModeU[ 5 ] == Mode && GBASE.TexAddressModeV[ 5 ] == Mode &&
			GBASE.TexAddressModeU[ 6 ] == Mode && GBASE.TexAddressModeV[ 6 ] == Mode &&
			GBASE.TexAddressModeU[ 7 ] == Mode && GBASE.TexAddressModeV[ 7 ] == Mode ) return 0;

		// _`
		RenderVertexHardware() ;

		GBASE.TexAddressModeU[ 0 ] = Mode ;
		GBASE.TexAddressModeU[ 1 ] = Mode ;
		GBASE.TexAddressModeU[ 2 ] = Mode ;
		GBASE.TexAddressModeU[ 3 ] = Mode ;
		GBASE.TexAddressModeU[ 4 ] = Mode ;
		GBASE.TexAddressModeU[ 5 ] = Mode ;
		GBASE.TexAddressModeU[ 6 ] = Mode ;
		GBASE.TexAddressModeU[ 7 ] = Mode ;

		GBASE.TexAddressModeV[ 0 ] = Mode ;
		GBASE.TexAddressModeV[ 1 ] = Mode ;
		GBASE.TexAddressModeV[ 2 ] = Mode ;
		GBASE.TexAddressModeV[ 3 ] = Mode ;
		GBASE.TexAddressModeV[ 4 ] = Mode ;
		GBASE.TexAddressModeV[ 5 ] = Mode ;
		GBASE.TexAddressModeV[ 6 ] = Mode ;
		GBASE.TexAddressModeV[ 7 ] = Mode ;

		GRH.DrawPrepAlwaysFlag = TRUE ;
	}
	else
	{
		if( Stage < 0 || Stage >= USE_TEXTURESTAGE_NUM ) return 0 ;
		if( GBASE.TexAddressModeU[ Stage ] == Mode &&
			GBASE.TexAddressModeV[ Stage ] == Mode ) return 0;

		// _`
		RenderVertexHardware() ;

		GBASE.TexAddressModeU[ Stage ] = Mode ;
		GBASE.TexAddressModeV[ Stage ] = Mode ;
		GRH.DrawPrepAlwaysFlag = TRUE ;
	}

	// Direct3D ɐݒ
	if( GRA2.ValidHardWare )
	{
		SetTextureAddressHardware( Mode, Stage ) ;
	}

	// I
	return 0 ;
}


// eNX`AhX[hݒ肷
extern	int NS_SetTextureAddressModeUV( int ModeU, int ModeV, int Stage )
{
	if( Stage == -1 )
	{
		if( GBASE.TexAddressModeU[ 0 ] == ModeU && GBASE.TexAddressModeV[ 0 ] == ModeV &&
			GBASE.TexAddressModeU[ 1 ] == ModeU && GBASE.TexAddressModeV[ 1 ] == ModeV &&
			GBASE.TexAddressModeU[ 2 ] == ModeU && GBASE.TexAddressModeV[ 2 ] == ModeV &&
			GBASE.TexAddressModeU[ 3 ] == ModeU && GBASE.TexAddressModeV[ 3 ] == ModeV &&
			GBASE.TexAddressModeU[ 4 ] == ModeU && GBASE.TexAddressModeV[ 4 ] == ModeV &&
			GBASE.TexAddressModeU[ 5 ] == ModeU && GBASE.TexAddressModeV[ 5 ] == ModeV &&
			GBASE.TexAddressModeU[ 6 ] == ModeU && GBASE.TexAddressModeV[ 6 ] == ModeV &&
			GBASE.TexAddressModeU[ 7 ] == ModeU && GBASE.TexAddressModeV[ 7 ] == ModeV ) return 0;

		// _`
		RenderVertexHardware() ;

		GBASE.TexAddressModeU[ 0 ] = ModeU ;
		GBASE.TexAddressModeU[ 1 ] = ModeU ;
		GBASE.TexAddressModeU[ 2 ] = ModeU ;
		GBASE.TexAddressModeU[ 3 ] = ModeU ;
		GBASE.TexAddressModeU[ 4 ] = ModeU ;
		GBASE.TexAddressModeU[ 5 ] = ModeU ;
		GBASE.TexAddressModeU[ 6 ] = ModeU ;
		GBASE.TexAddressModeU[ 7 ] = ModeU ;

		GBASE.TexAddressModeV[ 0 ] = ModeV ;
		GBASE.TexAddressModeV[ 1 ] = ModeV ;
		GBASE.TexAddressModeV[ 2 ] = ModeV ;
		GBASE.TexAddressModeV[ 3 ] = ModeV ;
		GBASE.TexAddressModeV[ 4 ] = ModeV ;
		GBASE.TexAddressModeV[ 5 ] = ModeV ;
		GBASE.TexAddressModeV[ 6 ] = ModeV ;
		GBASE.TexAddressModeV[ 7 ] = ModeV ;

		GRH.DrawPrepAlwaysFlag = TRUE ;
	}
	else
	{
		if( Stage < 0 || Stage >= USE_TEXTURESTAGE_NUM ) return 0 ;
		if( GBASE.TexAddressModeU[ Stage ] == ModeU &&
			GBASE.TexAddressModeV[ Stage ] == ModeV ) return 0;

		// _`
		RenderVertexHardware() ;

		GBASE.TexAddressModeU[ Stage ] = ModeU ;
		GBASE.TexAddressModeV[ Stage ] = ModeV ;
		GRH.DrawPrepAlwaysFlag = TRUE ;
	}

	// Direct3D ɐݒ
	if( GRA2.ValidHardWare )
	{
		SetTextureAddressUHardware( ModeU, Stage ) ;
		SetTextureAddressVHardware( ModeV, Stage ) ;
	}

	// I
	return 0 ;
}

// eNX`Wϊp[^Zbg
extern int NS_SetTextureAddressTransform( float TransU, float TransV, float ScaleU, float ScaleV, float RotCenterU, float RotCenterV, float Rotate )
{
	MATRIX Transform, Temp1, Temp2, Temp3 ;
	int UseFlag ;

	UseFlag = FALSE ;

	if( Rotate != 0.0f )
	{
		CreateTranslationMatrix( &Temp1, -RotCenterU, -RotCenterV, 0.0f ) ; 
		CreateRotationZMatrix( &Temp2, Rotate ) ;
		CreateTranslationMatrix( &Temp3,  RotCenterU,  RotCenterV, 0.0f ) ; 
		CreateMultiplyMatrix( &Transform, &Temp1, &Temp2 ) ;
		CreateMultiplyMatrix( &Transform, &Transform, &Temp3 ) ;
		UseFlag = TRUE ;
	}
	else
	{
		CreateIdentityMatrix( &Transform ) ;
	}

	if( TransU != 0.0f || TransV != 0.0f )
	{
		CreateTranslationMatrix( &Temp1, TransU, TransV, 0.0f ) ;
		CreateMultiplyMatrix( &Transform, &Transform, &Temp1 ) ;
		UseFlag = TRUE ;
	}

	if( ScaleU != 1.0f || ScaleV != 1.0f )
	{
		CreateScalingMatrix( &Temp1, ScaleU, ScaleV, 1.0f ) ;
		CreateMultiplyMatrix( &Transform, &Transform, &Temp1 ) ;
		UseFlag = TRUE ;
	}

	// gpȂꍇ͉Ȃ
	if( GBASE.TextureTransformUse == UseFlag && UseFlag == FALSE )
		return 0 ;

	// ݒۑ
	GBASE.TextureTransformUse = UseFlag ;
	GBASE.TextureTransformMatrix = Transform ;
	GBASE.TextureMatrixValid = FALSE ;

	// Direct3D ɐݒ
	if( GRA2.ValidHardWare )
	{
		SetTextureAddressTransformMatrixHardware( UseFlag, &Transform ) ;
	}

	// I
	return 0 ;
}

// eNX`WϊsZbg
extern int NS_SetTextureAddressTransformMatrix( MATRIX Matrix )
{
	// ݒۑ
	GBASE.TextureTransformUse = TRUE ;
	GBASE.TextureMatrixValid = TRUE ;
	GBASE.TextureMatrix = Matrix ;
	GBASE.TextureTransformMatrix = Matrix ;

	// Direct3D ɐݒ
	if( GRA2.ValidHardWare )
	{
		SetTextureAddressTransformMatrixHardware( TRUE, &Matrix ) ;
	}

	// I
	return 0 ;
}

// eNX`Wϊp[^Zbg
extern int NS_ResetTextureAddressTransform( void )
{
	return NS_SetTextureAddressTransform( 0.0f, 0.0f, 1.0f, 1.0f, 0.0f, 0.0f, 0.0f ) ;
}

// tHOLɂ邩ǂݒ肷( TRUE:L  FALSE: )
extern int NS_SetFogEnable( int Flag )
{
	if( GBASE.FogEnable == Flag && GRH.InitializeFlag == FALSE &&
		( GRA2.ValidHardWare == FALSE || ( GRA2.ValidHardWare && GRH.FogEnable == Flag ) ) ) return 0;

	// _`
	RenderVertexHardware() ;

	GBASE.FogEnable = Flag ;
	GRH.DrawPrepAlwaysFlag = TRUE ;

	// Direct3D ɐݒ
	if( GRA2.ValidHardWare )
	{
		SetFogEnableHardware( Flag ) ;
	}

	// I
	return 0 ;
}

// tHO[hݒ肷
extern	int NS_SetFogMode( int Mode /* DX_FOGMODE_NONE  */ )
{
	if( GBASE.FogMode == Mode && GRH.InitializeFlag == FALSE &&
		( GRA2.ValidHardWare == FALSE || ( GRA2.ValidHardWare && GRH.FogMode == Mode ) ) ) return 0;

	// _`
	RenderVertexHardware() ;

	GBASE.FogMode = Mode ;

	// Direct3D ɐݒ
	if( GRA2.ValidHardWare )
	{
		SetFogModeHardware( Mode ) ;
	}

	// I
	return 0 ;
}

// tHOJ[ύX
extern	int NS_SetFogColor( int r, int g, int b )
{
	DWORD color = ( ( 0xff ) << 24 ) | ( ( r & 0xff ) << 16 ) | ( ( g & 0xff ) << 8 ) | ( b & 0xff ) ;

	if( GBASE.FogColor == color && GRH.InitializeFlag == FALSE &&
		( GRA2.ValidHardWare == FALSE || ( GRA2.ValidHardWare && GRH.FogColor == color ) ) ) return 0;

	// _`
	RenderVertexHardware() ;

	GBASE.FogColor = color ;

	// Direct3D ɐݒ
	if( GRA2.ValidHardWare )
	{
		SetFogColorHardware( color ) ;
	}

	// I
	return 0 ;
}

// tHOn܂鋗ƏI鋗ݒ肷( 0.0f ` 1.0f )
extern	int	NS_SetFogStartEnd( float start, float end )
{
	if( GBASE.FogStart == start && GBASE.FogEnd == end && GRH.InitializeFlag == FALSE &&
		( GRA2.ValidHardWare == FALSE || ( GRA2.ValidHardWare && GRH.FogStart == start && GRH.FogEnd == end ) ) ) return 0 ;

	// _`
	RenderVertexHardware() ;

	GBASE.FogStart = start ;
	GBASE.FogEnd = end ;

	// Direct3D ɐݒ
	if( GRA2.ValidHardWare )
	{
		SetFogStartEndHardware( start, end ) ;
	}

	// I
	return 0 ;
}

// tHO̖xݒ肷( 0.0f ` 1.0f )
extern	int	NS_SetFogDensity( float density )
{
	if( GBASE.FogDensity == density && GRH.InitializeFlag == FALSE &&
		( GRA2.ValidHardWare == FALSE || ( GRA2.ValidHardWare && GRH.FogDensity == density ) ) ) return 0;

	// _`
	RenderVertexHardware() ;

	GBASE.FogDensity = density ;

	// Direct3D ɐݒ
	if( GRA2.ValidHardWare )
	{
		SetFogDensityHardware( density ) ;
	}

	// I
	return 0 ;
}

// VXeɃOtBbN쐬邩ǂ̃tOZbg( TRUE:VXeɍ쐬  FALSE:uq`lɍ쐬 )
extern	int NS_SetUseSystemMemGraphCreateFlag( int Flag )
{
	// tOۑ
	GBASE.SystemMemImageCreateFlag = Flag ;

	// I
	return 0 ;
}

// uq`lgp邩̃tOZbg
extern	int NS_SetUseVramFlag( int Flag )
{
	return NS_SetUseSystemMemGraphCreateFlag( Flag == TRUE ? FALSE : TRUE ) ;
}

// DirectX ̃IuWFNg
extern void ReleaseDirectXObject( void )
{
	if( DxSysData.NotDrawFlag == FALSE )
	{
		// n[hEGȀꍇ݈̂ȉ̏s
		if( GRA2.ValidHardWare == TRUE )
		{
#ifndef DX_NON_MASK
			// }XNT[tFXꎞ폜
			ReleaseMaskSurface() ;
#endif
			// OtBbNnh DirectX IuWFNg̉
			ReleaseOrigDirectXObjectAll() ;
		}

		// VXe DirectX IuWFNg̉
		TerminateDirectX() ;
	}
}

// OtBbNXVXe̕AA͕ύXt̍ăZbgAbvs
static int RestoreOrChangeSetupGraphSystem( int Change, int ScreenSizeX = -1, int ScreenSizeY = -1, int ColorBitDepth = -1, int RefreshRate = -1 )
{
	int i ;

#ifndef DX_NON_ASYNCLOAD
	// 񓯊ǂݍ݂̓ȑꍇ́A񓯊ǂݍ݂I܂ő҂
	while( NS_GetASyncLoadNum() > 0 )
	{
		ProcessASyncLoadRequestMainThread() ;
		if( WinData.ProcessorNum <= 1 )
		{
			Thread_Sleep( 2 ) ;
		}
		else
		{
			Thread_Sleep( 0 ) ;
		}
	}
#endif // DX_NON_ASYNCLOAD

	// OtBbNXfoCX̃Xg畜AOɌĂԊ֐o^Ăs
	if( GRH.DeviceLostCallbackFunction )
	{
		GRH.DeviceLostCallbackFunction( GRH.DeviceLostCallbackData ) ;
	}

	// DirectX ̃IuWFNg
	ReleaseDirectXObject() ;

	if( Change == TRUE )
	{
		// ʃ[h̃Zbg
		SetMainScreenSize( ScreenSizeX, ScreenSizeY ) ;
		GRA2.MainScreenColorBitDepth = ColorBitDepth ;
		GRA2.MainScreenRefreshRate   = RefreshRate ;
		SetMemImgDefaultColorType( ColorBitDepth == 32 ? 1 : 0 ) ;
	}
	else
	{
		// DirectInput IuWFNg̍ăZbgAbv
#ifndef DX_NON_INPUT
		TerminateDirectInput() ;
		InitializeDirectInput() ;
#endif // DX_NON_INPUT
	}

	if( DxSysData.NotDrawFlag == FALSE )
	{
		// DirectX IuWFNg̍č쐬
		InitializeDirectX() ;

		// n[hEGȀꍇ݈̂ȉ̏s
		if( GRA2.ValidHardWare == TRUE )
		{
			MATRIX ViewMatrix, ProjectionMatrix, ViewportMatrix ;

			// OtBbNnh DirectX IuWFNg̍Ď擾
			AllocOrigDirectXObjectAll() ;

#ifndef DX_NON_MASK
			// }XNT[tFX̍č쐬
			ReCreateMaskSurface() ;
#endif
			// ANeBuOtBbÑAhXēxݒ
			if( Change == FALSE )
			{
				ViewMatrix       = GBASE.ViewMatrix ;
				ProjectionMatrix = GBASE.ProjectionMatrix ;
				ViewportMatrix   = GBASE.ViewportMatrix ;
			}
			NS_SetRenderTargetToShader( 0, GBASE.TargetScreen[ 0 ], GBASE.TargetScreenSurface[ 0 ] ) ;

			// OtBbN֌W̐ݒ
			ReInitializeHardware() ;

			// ʂ̏
			NS_ClearDrawScreen() ;
			NS_ScreenFlip() ;
			NS_ClearDrawScreen() ;
			NS_ScreenFlip() ;

			// foCXXgɍ폜tOĂOtBbN폜
			DeleteDeviceLostDeleteGraph() ;

			// OtBbN̕
/*
			if( Change == TRUE )
			{
				// OtBbN̕
				DefaultRestoreGraphFunction() ;

#ifndef DX_NON_MODEL
				// f̃eNX`ēǂݍ
				MV1ReloadTexture() ;
#endif
				// tHgnhLbV
				InitCacheFontToHandle() ;
			}
			else
*/			{
				NS_RunRestoreShred() ;
			}

			// OtBbNXfoCX̃Xg畜AƂɌĂԊ֐o^Ăs
			if( GRH.DeviceRestoreCallbackFunction )
			{
				GRH.DeviceRestoreCallbackFunction( GRH.DeviceRestoreCallbackData ) ;
			}

			// n[hEGA̐ݒtbV
			RefreshRenderStateHardware() ;

#ifndef DX_NON_MODEL
			// _obt@̃ZbgAbv
			MV1SetupVertexBufferAll() ;
#endif

			// Cg̐ݒ Direct3D ɍĔf悤ɃtOZbg
			GBASE.Light.D3DRefresh = TRUE ;

			// ̑̍Đݒ
			if( Change == FALSE )
			{
				NS_SetDrawArea( GRA2.OriginalDrawRect.left, GRA2.OriginalDrawRect.top, GRA2.OriginalDrawRect.right, GRA2.OriginalDrawRect.bottom ) ;
				NS_SetTransformToWorld( &GBASE.WorldMatrix );
				NS_SetTransformToView( &ViewMatrix );
				NS_SetTransformToProjection( &ProjectionMatrix );
				NS_SetTransformToViewport( &ViewportMatrix );
			}

			// OȊÕ^[Qbg̃ZbgAbv
			for( i = 1 ; i < GRH.RenderTargetNum ; i ++ )
			{
				NS_SetRenderTargetToShader( i, GBASE.TargetScreen[ i ], GBASE.TargetScreenSurface[ i ] ) ;
			}
		}

#ifndef DX_NON_MOVIE
		// [r[OtBbN̍Đ
		RestoreMovieAll() ;
#endif
	}

	// I
	return 0 ;
}

// cwCũOtBbN֘A̕As
extern	int NS_RestoreGraphSystem( void )
{
	RestoreOrChangeSetupGraphSystem( FALSE ) ;

	// I
	return 0 ;
}

// Vistaȍ~ Windows Aero 𖳌ɂ邩ǂZbgATRUE:ɂ  FALSE:Lɂ( DxLib_Init ̑OɌĂԕKv܂ )
extern int NS_SetAeroDisableFlag( int Flag )
{
	// ÔݗL
	if( DxSysData.DxLib_InitializeFlag == TRUE ) return -1 ;

	if( Flag )
	{
		GRH.DisableAeroFlag = 2 ;
	}
	else
	{
		GRH.DisableAeroFlag = 1 ;
	}

	// I
	return 0 ;
}

// Vistaȍ~̊ Direct3D9Ex gp邩ǂݒ肷( TRUE:gp( ftHg )  FALSE:gpȂ )
extern int NS_SetUseDirect3D9Ex( int Flag )
{
	// ÔݗL
	if( DxSysData.DxLib_InitializeFlag == TRUE ) return -1 ;

	// tOۑ
	GRH.NotUseDirect3D9Ex = Flag ? FALSE : TRUE ;

	// I
	return 0 ;
}


// F擾֌W

extern COLOR_F NS_GetColorF( float Red, float Green, float Blue, float Alpha )
{
	COLOR_F Ret = { Red,  Green,  Blue,  Alpha } ;
	return Ret ;
}

extern COLOR_U8 NS_GetColorU8( int Red, int Green, int Blue, int Alpha )
{
	COLOR_U8 Ret = { ( BYTE )Blue, ( BYTE )Green, ( BYTE )Red, ( BYTE )Alpha } ;
	return Ret ;
}

// RFl猻݂̉ʃ[hɑΉFf[^l𓾂
extern	DWORD	NS_GetColor( int Red, int Green, int Blue )
{
	COLORDATA *ColorData ;

	// FԂ
	if( GRA2.ValidHardWare == TRUE )
		ColorData = GetD3DFormatColorData( GRA2.MainScreenColorBitDepth == 16 ? D_D3DFMT_R5G6B5 : D_D3DFMT_X8R8G8B8 ) ;
	else
		ColorData = GetMemImgColorData(    GRA2.MainScreenColorBitDepth == 16 ?               0 :                 1, FALSE, FALSE ) ;
	
	return ColorData->NoneMask +
				( ( ( BYTE )Red   >> ( 8 - ColorData->RedWidth   ) ) << ColorData->RedLoc   ) +
				( ( ( BYTE )Green >> ( 8 - ColorData->GreenWidth ) ) << ColorData->GreenLoc ) +
				( ( ( BYTE )Blue  >> ( 8 - ColorData->BlueWidth  ) ) << ColorData->BlueLoc  ) ;
}

// ʃ[hɑΉFf[^lX̂RFf[^𔲂o
extern	int		NS_GetColor2( int Color, int *Red, int *Green, int *Blue )
{
	COLORDATA *ColorData ;
	int MaxRed, MaxGreen, MaxBlue ;

	// FԂ
	if( GRA2.ValidHardWare == TRUE )
		ColorData = GetD3DFormatColorData( GRA2.MainScreenColorBitDepth == 16 ? D_D3DFMT_R5G6B5 : D_D3DFMT_X8R8G8B8 ) ;
	else
		ColorData = GetMemImgColorData(    GRA2.MainScreenColorBitDepth == 16 ?               0 :                 1, FALSE, FALSE ) ;

	MaxRed		= ( 1 << ColorData->RedWidth   ) - 1 ; 
	MaxGreen	= ( 1 << ColorData->GreenWidth ) - 1 ;
	MaxBlue		= ( 1 << ColorData->BlueWidth  ) - 1 ; 

	// Fi[
	*Red	= ( ( Color & ColorData->RedMask   ) >> ColorData->RedLoc   ) * 255 / MaxRed   ;
	*Green	= ( ( Color & ColorData->GreenMask ) >> ColorData->GreenLoc ) * 255 / MaxGreen ;
	*Blue	= ( ( Color & ColorData->BlueMask  ) >> ColorData->BlueLoc  ) * 255 / MaxBlue  ;

	// I
	return 0 ;
}



// OtBbNnhLǂ𒲂ׂ( TRUE:L  FALSE: )
extern	int IsValidGraphHandle( int GrHandle )
{
	IMAGEDATA2 *Image2 ;

	// G[
	if( GRAPHCHKFULL( GrHandle, Image2 ) )
		return FALSE ;

	// I
	return TRUE ;
}

// `obt@AbN
extern int UnlockDrawScreenBuffer( void )
{
	// bNĂȂ牽ɏI
	if( GRH.DrawScreenBufferLockFlag == FALSE ) return 0 ;

	// n[hEGAgpĂ邩ǂŏ𕪊
	if( GRA2.ValidHardWare )
	{
		// ꎞIɎgpĂT[tFXbNǂŏ𕪊
		if( GRH.DrawScreenBufferLockSMSurface != NULL )
		{
			// bN̉
			GraphicsSurface_UnlockRect( GRH.DrawScreenBufferLockSMSurface ) ;

			// ꎞIɍ쐬T[tFX̉
			Graphics_ObjectRelease( GRH.DrawScreenBufferLockSMSurface ) ;

			// |C^𖳌
			GRH.DrawScreenBufferLockSMSurface = NULL ;
		}
		else
		{
			// `Ώۂ̃T[tFX̃bN
			GraphicsSurface_UnlockRect( GRH.DrawScreenBufferLockSurface ) ;
			GRH.DrawScreenBufferLockSurface = NULL ;
		}
	}
	else
	{
	}

	// bNtO|
	GRH.DrawScreenBufferLockFlag = FALSE ;

	return 0 ;
}


// VF[_[萔̏
extern int InitializeShaderConstantInfoSet( SHADERCONSTANTINFOSET *ConstInfoSet )
{
	int i ;

	// Ƃ肠돉
	_MEMSET( ConstInfoSet, 0, sizeof( *ConstInfoSet ) ) ;

	// VF[_[萔̎gp̈
	for( i = 0 ; i < DX_SHADERCONSTANTSET_NUM ; i ++ )
	{
		InitializeShaderConstantUseArea( &ConstInfoSet->Info[ DX_SHADERCONSTANTTYPE_VS_FLOAT ][ i ].UseArea, 256 ) ;
		ConstInfoSet->Info[ DX_SHADERCONSTANTTYPE_VS_FLOAT ][ i ].UnitSize = sizeof( FLOAT4 ) ;

		InitializeShaderConstantUseArea( &ConstInfoSet->Info[ DX_SHADERCONSTANTTYPE_VS_INT   ][ i ].UseArea,  16 ) ;
		ConstInfoSet->Info[ DX_SHADERCONSTANTTYPE_VS_INT ][ i ].UnitSize = sizeof( INT4 ) ;

		InitializeShaderConstantUseArea( &ConstInfoSet->Info[ DX_SHADERCONSTANTTYPE_VS_BOOL  ][ i ].UseArea,  16 ) ;
		ConstInfoSet->Info[ DX_SHADERCONSTANTTYPE_VS_BOOL ][ i ].UnitSize = sizeof( BOOL ) ;

		InitializeShaderConstantUseArea( &ConstInfoSet->Info[ DX_SHADERCONSTANTTYPE_PS_FLOAT ][ i ].UseArea, 224 ) ;
		ConstInfoSet->Info[ DX_SHADERCONSTANTTYPE_PS_FLOAT ][ i ].UnitSize = sizeof( FLOAT4 ) ;

		InitializeShaderConstantUseArea( &ConstInfoSet->Info[ DX_SHADERCONSTANTTYPE_PS_INT   ][ i ].UseArea,  16 ) ;
		ConstInfoSet->Info[ DX_SHADERCONSTANTTYPE_PS_INT ][ i ].UnitSize = sizeof( INT4 ) ;

		InitializeShaderConstantUseArea( &ConstInfoSet->Info[ DX_SHADERCONSTANTTYPE_PS_BOOL  ][ i ].UseArea,  16 ) ;
		ConstInfoSet->Info[ DX_SHADERCONSTANTTYPE_PS_BOOL ][ i ].UnitSize = sizeof( BOOL ) ;
	}

	// I
	return 0 ;
}

// w̃VF[_[萔ZbgKp邩ǂݒ肷
extern int SetUseShaderContantInfoState( SHADERCONSTANTINFOSET *ConstInfoSet, int ApplyMask )
{
	BYTE *BeforeMap ;
	BYTE AfterMap[ DX_SHADERCONSTANTTYPE_NUM ][ 256 ] ;
	BYTE ChangeInfo[ DX_SHADERCONSTANTTYPE_NUM ][ 256 ][ 2 ] ;
	int ChangeInfoNum[ DX_SHADERCONSTANTTYPE_NUM ] ;
	SHADERCONSTANTINFO *Info ;
	BYTE *Map ;
	FLOAT4 FloatConst[ 256 ] ;
	INT4 IntConst[ 16 ] ;
	BOOL BoolConst[ 16 ] ;
	int i, j, k, Size ;
	BYTE Start, End ;

	// w̒萔Zbg̏Ԃɕωꍇ͉Ȃ
	if( ConstInfoSet->ApplyMask == ApplyMask )
		return 0 ;

	// }XNۑ
	ConstInfoSet->ApplyMask = ApplyMask ;

	// }XNtO}bv쐬
	for( i = 0 ; i < DX_SHADERCONSTANTSET_NUM ; i ++ )
	{
		ConstInfoSet->IsApply[ i ] = ( ApplyMask & ( 1 << i ) ) != 0 ? TRUE : FALSE ;
	}

	// ω̎gp}bv̍쐬
	_MEMSET( AfterMap, 0xff, sizeof( AfterMap ) ) ;
	for( i = 0 ; i < DX_SHADERCONSTANTSET_NUM ; i ++ )
	{
		if( ConstInfoSet->IsApply[ i ] )
		{
			for( j = 0 ; j < DX_SHADERCONSTANTTYPE_NUM ; j ++ )
			{
				CreateUseAreaMap( &ConstInfoSet->Info[ j ][ i ].UseArea, AfterMap[ j ], ( BYTE )i ) ;
			}
		}
	}

	// ωӏ̏\z
	for( i = 0 ; i < DX_SHADERCONSTANTTYPE_NUM ; i ++ )
	{
		BeforeMap = ConstInfoSet->SetMap[ i ] ;
		ChangeInfoNum[ i ] = 0 ;
		Size = ConstInfoSet->Info[ i ][ 0 ].UseArea.TotalSize ;
		j = 0;
		for(;;)
		{
			for( ; j < Size && ( AfterMap[ i ][ j ] == 0xff || BeforeMap[ j ] == AfterMap[ i ][ j ] ) ; j ++ ){}
			if( j == Size ) break ;

			ChangeInfo[ i ][ ChangeInfoNum[ i ] ][ 0 ] = ( BYTE )j ;

			for( ; j < Size && AfterMap[ i ][ j ] != 0xff && BeforeMap[ j ] != AfterMap[ i ][ j ] ; j ++ ){}

			ChangeInfo[ i ][ ChangeInfoNum[ i ] ][ 1 ] = ( BYTE )j ;

			ChangeInfoNum[ i ] ++ ;
		}
	}

	// ω̎gp^Cv}bvۑ
	_MEMCPY( ConstInfoSet->SetMap, AfterMap, sizeof( AfterMap ) ) ;


	// ω̂ӏ̒萔 Direct3DDevice9 ɓKp

	for( j = 0 ; j < ChangeInfoNum[ DX_SHADERCONSTANTTYPE_VS_FLOAT ] ; j ++ )
	{
		Start = ChangeInfo[ DX_SHADERCONSTANTTYPE_VS_FLOAT ][ j ][ 0 ] ;
		End   = ChangeInfo[ DX_SHADERCONSTANTTYPE_VS_FLOAT ][ j ][ 1 ] ;
		Map = AfterMap[ DX_SHADERCONSTANTTYPE_VS_FLOAT ] ;
		Info = ConstInfoSet->Info[ DX_SHADERCONSTANTTYPE_VS_FLOAT ] ;
		for( k = Start ; k < End ; k ++ )
		{
			FloatConst[ k ] = Info[ Map[ k ] ].Float4[ k ] ;
		}
		GraphicsDevice_SetVertexShaderConstantF( Start, ( float * )&FloatConst[ Start ], End - Start ) ;
		_MEMCPY( &ConstInfoSet->FixInfo[ DX_SHADERCONSTANTTYPE_VS_FLOAT ].Float4[ Start ], ( float * )&FloatConst[ Start ], sizeof( FLOAT4 ) * ( End - Start ) ) ;
	}

	for( j = 0 ; j < ChangeInfoNum[ DX_SHADERCONSTANTTYPE_VS_INT ] ; j ++ )
	{
		Start = ChangeInfo[ DX_SHADERCONSTANTTYPE_VS_INT ][ j ][ 0 ] ;
		End   = ChangeInfo[ DX_SHADERCONSTANTTYPE_VS_INT ][ j ][ 1 ] ;
		Map = AfterMap[ DX_SHADERCONSTANTTYPE_VS_INT ] ;
		Info = ConstInfoSet->Info[ DX_SHADERCONSTANTTYPE_VS_INT ] ;
		for( k = Start ; k < End ; k ++ )
		{
			IntConst[ k ] = Info[ Map[ k ] ].Int4[ k ] ;
		}
		GraphicsDevice_SetVertexShaderConstantI( Start, ( int * )&IntConst[ Start ], End - Start ) ;
		_MEMCPY( &ConstInfoSet->FixInfo[ DX_SHADERCONSTANTTYPE_VS_INT ].Int4[ Start ], ( int * )&IntConst[ Start ], sizeof( INT4 ) * ( End - Start ) ) ;
	}

	for( j = 0 ; j < ChangeInfoNum[ DX_SHADERCONSTANTTYPE_VS_BOOL ] ; j ++ )
	{
		Start = ChangeInfo[ DX_SHADERCONSTANTTYPE_VS_BOOL ][ j ][ 0 ] ;
		End   = ChangeInfo[ DX_SHADERCONSTANTTYPE_VS_BOOL ][ j ][ 1 ] ;
		Map = AfterMap[ DX_SHADERCONSTANTTYPE_VS_BOOL ] ;
		Info = ConstInfoSet->Info[ DX_SHADERCONSTANTTYPE_VS_BOOL ] ;
		for( k = Start ; k < End ; k ++ )
		{
			BoolConst[ k ] = Info[ Map[ k ] ].Bool[ k ] ;
		}
		GraphicsDevice_SetVertexShaderConstantB( Start, ( BOOL * )&BoolConst[ Start ], End - Start ) ;
		_MEMCPY( &ConstInfoSet->FixInfo[ DX_SHADERCONSTANTTYPE_VS_BOOL ].Bool[ Start ], ( BOOL * )&BoolConst[ Start ], sizeof( BOOL ) * ( End - Start ) ) ;
	}



	for( j = 0 ; j < ChangeInfoNum[ DX_SHADERCONSTANTTYPE_PS_FLOAT ] ; j ++ )
	{
		Start = ChangeInfo[ DX_SHADERCONSTANTTYPE_PS_FLOAT ][ j ][ 0 ] ;
		End   = ChangeInfo[ DX_SHADERCONSTANTTYPE_PS_FLOAT ][ j ][ 1 ] ;
		Map = AfterMap[ DX_SHADERCONSTANTTYPE_PS_FLOAT ] ;
		Info = ConstInfoSet->Info[ DX_SHADERCONSTANTTYPE_PS_FLOAT ] ;
		for( k = Start ; k < End ; k ++ )
		{
			FloatConst[ k ] = Info[ Map[ k ] ].Float4[ k ] ;
		}
		GraphicsDevice_SetPixelShaderConstantF( Start, ( float * )&FloatConst[ Start ], End - Start ) ;
		_MEMCPY( &ConstInfoSet->FixInfo[ DX_SHADERCONSTANTTYPE_PS_FLOAT ].Float4[ Start ], ( float * )&FloatConst[ Start ], sizeof( FLOAT4 ) * ( End - Start ) ) ;
	}

	for( j = 0 ; j < ChangeInfoNum[ DX_SHADERCONSTANTTYPE_PS_INT ] ; j ++ )
	{
		Start = ChangeInfo[ DX_SHADERCONSTANTTYPE_PS_INT ][ j ][ 0 ] ;
		End   = ChangeInfo[ DX_SHADERCONSTANTTYPE_PS_INT ][ j ][ 1 ] ;
		Map = AfterMap[ DX_SHADERCONSTANTTYPE_PS_INT ] ;
		Info = ConstInfoSet->Info[ DX_SHADERCONSTANTTYPE_PS_INT ] ;
		for( k = Start ; k < End ; k ++ )
		{
			IntConst[ k ] = Info[ Map[ k ] ].Int4[ k ] ;
		}
		GraphicsDevice_SetPixelShaderConstantI( Start, ( int * )&IntConst[ Start ], End - Start ) ;
		_MEMCPY( &ConstInfoSet->FixInfo[ DX_SHADERCONSTANTTYPE_PS_INT ].Int4[ Start ], ( int * )&IntConst[ Start ], sizeof( INT4 ) * ( End - Start ) ) ;
	}

	for( j = 0 ; j < ChangeInfoNum[ DX_SHADERCONSTANTTYPE_PS_BOOL ] ; j ++ )
	{
		Start = ChangeInfo[ DX_SHADERCONSTANTTYPE_PS_BOOL ][ j ][ 0 ] ;
		End   = ChangeInfo[ DX_SHADERCONSTANTTYPE_PS_BOOL ][ j ][ 1 ] ;
		Map = AfterMap[ DX_SHADERCONSTANTTYPE_PS_BOOL ] ;
		Info = ConstInfoSet->Info[ DX_SHADERCONSTANTTYPE_PS_BOOL ] ;
		for( k = Start ; k < End ; k ++ )
		{
			BoolConst[ k ] = Info[ Map[ k ] ].Bool[ k ] ;
		}
		GraphicsDevice_SetPixelShaderConstantB( Start, ( BOOL * )&BoolConst[ Start ], End - Start ) ;
		_MEMCPY( &ConstInfoSet->FixInfo[ DX_SHADERCONSTANTTYPE_PS_BOOL ].Bool[ Start ], ( BOOL * )&BoolConst[ Start ], sizeof( BOOL ) * ( End - Start ) ) ;
	}

	// I
	return 0 ;
}

// VF[_[萔foCXɐݒ肷
static int SetShaderConstantDeviceSet( SHADERCONSTANTINFOSET *ConstInfoSet, int TypeIndex, int ConstantIndex, const void *Param, int ParamNum )
{
	union
	{
		FLOAT4 TempArrayF[ 256 ] ;
		INT4 TempArrayI[ 16 ] ;
		BOOL TempArrayB[ 16 ] ;
	} ;

	// f[^ꍇ̓}bvQƂ
	if( Param == NULL )
	{
		SHADERCONSTANTINFO *Info ;
		BYTE *Map ;
		int Start, End ;
		int i ;

		Start = ConstantIndex ;
		End = Start + ParamNum ;
		Map = ConstInfoSet->SetMap[ TypeIndex ] ;

		Info = ConstInfoSet->Info[ TypeIndex ] ;
		switch( TypeIndex )
		{
		case DX_SHADERCONSTANTTYPE_VS_FLOAT :
		case DX_SHADERCONSTANTTYPE_PS_FLOAT :
			for( i = Start ; i < End ; i ++ )
			{
				TempArrayF[ i ] = Info[ Map[ i ] ].Float4[ i ] ;
			}
			Param = &TempArrayF[ Start ] ;
			break ;

		case DX_SHADERCONSTANTTYPE_VS_INT :
		case DX_SHADERCONSTANTTYPE_PS_INT :
			for( i = Start ; i < End ; i ++ )
			{
				TempArrayI[ i ] = Info[ Map[ i ] ].Int4[ i ] ;
			}
			Param = &TempArrayI[ Start ] ;
			break ;

		case DX_SHADERCONSTANTTYPE_VS_BOOL :
		case DX_SHADERCONSTANTTYPE_PS_BOOL :
			for( i = Start ; i < End ; i ++ )
			{
				TempArrayB[ i ] = Info[ Map[ i ] ].Bool[ i ] ;
			}
			Param = &TempArrayB[ Start ] ;
			break ;
		}
	}

	// foCXɃZbgƃp[^ۑ
	switch( TypeIndex )
	{
	case DX_SHADERCONSTANTTYPE_VS_FLOAT :
		if( GRH.UseShader == TRUE ) 
		{
			GraphicsDevice_SetVertexShaderConstantF( ConstantIndex, ( float * )Param, ParamNum ) ;
		}
		_MEMCPY( &ConstInfoSet->FixInfo[ DX_SHADERCONSTANTTYPE_VS_FLOAT ].Float4[ ConstantIndex ], Param, sizeof( FLOAT4 ) * ParamNum ) ;
		break ;

	case DX_SHADERCONSTANTTYPE_VS_INT :
		if( GRH.UseShader == TRUE ) 
		{
			GraphicsDevice_SetVertexShaderConstantI( ConstantIndex, ( int * )Param, ParamNum ) ;
		}
		_MEMCPY( &ConstInfoSet->FixInfo[ DX_SHADERCONSTANTTYPE_VS_INT ].Int4[ ConstantIndex ], Param, sizeof( INT4 ) * ParamNum ) ;
		break ;

	case DX_SHADERCONSTANTTYPE_VS_BOOL :
		if( GRH.UseShader == TRUE ) 
		{
			GraphicsDevice_SetVertexShaderConstantB( ConstantIndex, ( BOOL * )Param, ParamNum ) ;
		}
		_MEMCPY( &ConstInfoSet->FixInfo[ DX_SHADERCONSTANTTYPE_VS_BOOL ].Bool[ ConstantIndex ], Param, sizeof( BOOL ) * ParamNum ) ;
		break ;

	case DX_SHADERCONSTANTTYPE_PS_FLOAT :
		if( GRH.UseShader == TRUE ) 
		{
			GraphicsDevice_SetPixelShaderConstantF( ConstantIndex, ( float * )Param, ParamNum ) ;
		}
		_MEMCPY( &ConstInfoSet->FixInfo[ DX_SHADERCONSTANTTYPE_PS_FLOAT ].Float4[ ConstantIndex ], Param, sizeof( FLOAT4 ) * ParamNum ) ;
		break ;

	case DX_SHADERCONSTANTTYPE_PS_INT :
		if( GRH.UseShader == TRUE ) 
		{
			GraphicsDevice_SetPixelShaderConstantI( ConstantIndex, ( int * )Param, ParamNum ) ;
		}
		_MEMCPY( &ConstInfoSet->FixInfo[ DX_SHADERCONSTANTTYPE_PS_INT ].Int4[ ConstantIndex ], Param, sizeof( INT4 ) * ParamNum ) ;
		break ;

	case DX_SHADERCONSTANTTYPE_PS_BOOL :
		if( GRH.UseShader == TRUE ) 
		{
			GraphicsDevice_SetPixelShaderConstantB( ConstantIndex, ( BOOL * )Param, ParamNum ) ;
		}
		_MEMCPY( &ConstInfoSet->FixInfo[ DX_SHADERCONSTANTTYPE_PS_BOOL ].Bool[ ConstantIndex ], Param, sizeof( BOOL ) * ParamNum ) ;
		break ;
	}

	// I
	return 0 ;
}

// VF[_[萔ݒ肷
extern int SetShaderConstantSet( SHADERCONSTANTINFOSET *ConstInfoSet, int TypeIndex, int SetIndex, int ConstantIndex, const void *Param, int ParamNum, int UpdateUseArea )
{
	int Start, End ;
	int i ;
	bool bMaskHit ;
	BYTE *Map ;
	BYTE *UseMap ;
	SHADERCONSTANTINFO *Info ;

	Info = &ConstInfoSet->Info[ TypeIndex ][ SetIndex ] ;

	// P̂̎gp͈͂̍XV
	if( UpdateUseArea )
	{
		SetShaderConstantUseArea( &Info->UseArea, TRUE, ConstantIndex, ParamNum ) ;
	}

	// zɃf[^Zbg
	_MEMCPY( &Info->Data[ ConstantIndex * Info->UnitSize ], Param, ParamNum * Info->UnitSize ) ;

	// ͈͂̃Zbg
	Start = ConstantIndex ;
	End = Start + ParamNum ;

	// Ŝ̎gp̈̍XV
	bMaskHit = false ;
	Map = ConstInfoSet->SetMap[ TypeIndex ] ;
	UseMap = ConstInfoSet->UseMap[ TypeIndex ][ SetIndex ] ;
	for( i = Start; i < End; i++ )
	{
		UseMap[ i ] = TRUE ;

		if( ConstInfoSet->IsApply[ SetIndex ] )
		{
			if( Map[ i ] == 0xff || Map[ i ] <= SetIndex )
			{
				Map[ i ] = ( BYTE )SetIndex ;
			}
			else
			{
				bMaskHit = true ;
			}
		}
	}

	// foCXɃZbg
	if( ConstInfoSet->IsApply[ SetIndex ] )
	{
		SetShaderConstantDeviceSet( ConstInfoSet, TypeIndex, ConstantIndex, bMaskHit == false ? Param : NULL, ParamNum ) ;
	}

	// I
	return 0 ;
}

// ẅ̃VF[_[萔Zbg
extern int ResetShaderConstantSet( SHADERCONSTANTINFOSET *ConstInfoSet, int TypeIndex, int SetIndex, int ConstantIndex, int ParamNum )
{
	int Start, End ;
	int i, j ;
	bool bMaskHit ;
	BYTE *Map ;
	BYTE ( *UseMap )[ 256 ] ;
	SHADERCONSTANTINFO *Info ;

	// gp͈͂̍XV
	Info = &ConstInfoSet->Info[ TypeIndex ][ SetIndex ] ;
	SetShaderConstantUseArea( &Info->UseArea, FALSE, ConstantIndex, ParamNum ) ;

	// ͈͂̃Zbg
	Start = ConstantIndex ;
	End = Start + ParamNum ;

	// gp̈̍XV
	Map = ConstInfoSet->SetMap[ TypeIndex ] ;
	UseMap = ConstInfoSet->UseMap[ TypeIndex ] ;
	bMaskHit = false ;
	for( i = Start; i < End; i++ )
	{
		UseMap[ SetIndex ][ i ] = FALSE ;

		if( Map[ i ] == SetIndex )
		{
			for( j = SetIndex; j >= 0 && UseMap[ j ][ i ] == FALSE; j-- ){}
			if( j == -1 )
			{
				Map[ i ] = 0xff ;
			}
			else
			{
				Map[ i ] = ( BYTE )j ;
				bMaskHit = true ;
			}
		}
	}

	// gp̈悪ω邱Ƃō܂Ŗ萔LɂȂꍇ͒萔̍XV
	if( bMaskHit )
	{
		SetShaderConstantDeviceSet( ConstInfoSet, TypeIndex, ConstantIndex, NULL, ParamNum ) ;
	}

	// I
	return 0 ;
}

// `obt@bN
extern int LockDrawScreenBuffer( RECT *LockRect, BASEIMAGE *BaseImage, int TargetScreen, int TargetScreenSurface, int ReadOnly, int TargetScreenTextureNo )
{
	IMAGEDATA2 *TargImage2 ;
	int Width, Height ;
	RECT DestRect ;
	HRESULT hr ;

	// `揈Ă
	RenderVertexHardware() ;
	EndScene() ;

	// `̉摜f[^AhX擾
	if( TargetScreen == -1 )
	{
		TargetScreen = GBASE.TargetScreen[ 0 ] ;
		TargetScreenSurface = GBASE.TargetScreenSurface[ 0 ] ;
	}
	else
	{
		if( TargetScreenSurface == -1 )
		{
			TargetScreenSurface = 0 ;
		}
	}
	if( GRAPHCHKFULL( TargetScreen, TargImage2 ) )
		TargImage2 = NULL ;

	// `̃f[^sꍇG[
	if( LockRect->left < 0 || LockRect->left >= LockRect->right  ||
		LockRect->top  < 0 || LockRect->top  >= LockRect->bottom ||
		LockRect->right  > GBASE.DrawSizeX ||
		LockRect->bottom > GBASE.DrawSizeY ) return -1 ;

	Width  = LockRect->right  - LockRect->left ;
	Height = LockRect->bottom - LockRect->top ;

	// n[hEGAgpĂ邩ǂŏ𕪊
	if( GRA2.ValidHardWare )
	{
		// eNX`̏ꍇ
		DX_DIRECT3DSURFACE9 *TargetSurface ;
		D_D3DFORMAT TargetFormat ;
		COLORDATA *TargetColorData ;
		D_D3DLOCKED_RECT SrcLockRect ;

		// 荞݌ƂȂT[tFX̌

		// `\摜Ώۂ̏ꍇ
		if( TargImage2 )
		{
			TargetSurface = TargImage2->Orig->Hard.Tex[ TargetScreenTextureNo ].RenderTargetSurface ?
							TargImage2->Orig->Hard.Tex[ TargetScreenTextureNo ].RenderTargetSurface :
							TargImage2->Orig->Hard.Tex[ TargetScreenTextureNo ].Surface[ TargetScreenSurface ] ;
			TargetFormat = GRH.TextureFormat[ TargImage2->Orig->ColorFormat ] ;
		}
		else
		// ȊȌꍇ̓TuobNobt@L炻ꂪΏ
		{
			TargetSurface = GRH.SubBackBufferSurface ? GRH.SubBackBufferSurface : GRH.BackBufferSurface ;
			TargetFormat = GRH.ScreenFormat ;
		}
		TargetColorData = GetD3DFormatColorData( TargetFormat ) ;

		// bNłꍇ͂Ȃ胍bN
		if( GRH.UseRenderTargetLock == TRUE && 
			GraphicsSurface_LockRect( TargetSurface, &SrcLockRect, LockRect, ReadOnly ? D_D3DLOCK_READONLY : 0 ) == D_D3D_OK )
		{
			// bNT[tFX̃|C^ۑ
			GRH.DrawScreenBufferLockSurface = TargetSurface ;

			// ꎞIɎgpĂT[tFX̃|C^Zbg
			GRH.DrawScreenBufferLockSMSurface = NULL ;
		}
		else
		// ʖڂꍇ͈xɎ荞ł烍bN
		{
			DX_DIRECT3DSURFACE9 *RTSurface ;
			DX_DIRECT3DSURFACE9 *SMSurface ;

			// 荞݃TCYƓ傫̕`\T[tFX̍쐬
			RTSurface = NULL ;
			if( GraphicsDevice_CreateRenderTarget(
					Width, Height, TargetFormat, D_D3DMULTISAMPLE_NONE, 0, FALSE, &RTSurface, NULL ) != D_D3D_OK )
			{
				DXST_ERRORLOG_ADD( _T( "obNobt@bNp`\T[tFX̍쐬Ɏs܂\n" ) ) ;
				return -1 ;
			}

			// 荞݃TCYƓ傫̃VXẽItXN[T[tFX̍쐬
			SMSurface = NULL ;
			if( GraphicsDevice_CreateOffscreenPlainSurface(
					Width, Height, TargetFormat, D_D3DPOOL_SYSTEMMEM, &SMSurface, NULL ) != D_D3D_OK )
			{
				DXST_ERRORLOG_ADD( _T( "obNobt@bNpVXeT[tFX̍쐬Ɏs܂\n" ) ) ;
				Graphics_ObjectRelease( RTSurface ) ;
				return -1 ;
			}

			// ܂`\T[tFXɓe]
			DestRect.left   = 0 ;
			DestRect.top    = 0 ;
			DestRect.right  = Width ;
			DestRect.bottom = Height ;
			hr = GraphicsDevice_StretchRect(
				TargetSurface, LockRect,
				RTSurface, &DestRect, D_D3DTEXF_NONE ) ;

			// ̌VXeT[tFXɓe]
			hr = GraphicsDevice_GetRenderTargetData(
				RTSurface, SMSurface ) ;

			// VXeT[tFXbN
			hr = GraphicsSurface_LockRect( SMSurface, &SrcLockRect, NULL, ReadOnly ? D_D3DLOCK_READONLY : 0 ) ;

			// ꎞIɎgpĂT[tFX̃|C^ۑ
			GRH.DrawScreenBufferLockSMSurface = SMSurface ;

			// ꎞIɍ쐬T[tFX̉
			Graphics_ObjectRelease( RTSurface ) ;
		}

		// {C[W\̂̃f[^ɃZbg
		BaseImage->ColorData = *TargetColorData ;
		BaseImage->Width = Width ;
		BaseImage->Height = Height ;
		BaseImage->Pitch = SrcLockRect.Pitch ;
		BaseImage->GraphData = SrcLockRect.pBits ;
		BaseImage->MipMapCount = 0 ;
		BaseImage->GraphDataCount = 0 ;
	}
	else
	{
		// \tgEGA_Ȍꍇ

		// f[^Zbg
		if( TargImage2 )
		{
			BaseImage->ColorData = *TargImage2->Soft.MemImg.Base->ColorDataP ;
			BaseImage->Pitch = TargImage2->Soft.MemImg.Base->Pitch ;
			BaseImage->GraphData = ( BYTE * )TargImage2->Soft.MemImg.UseImage + BaseImage->ColorData.PixelByte * LockRect->left + BaseImage->Pitch * LockRect->top ;
		}
		else
		{
			BaseImage->ColorData = *GRS.MainBufferMemImg.Base->ColorDataP ;
			BaseImage->Pitch = GRS.MainBufferMemImg.Base->Pitch ;
			BaseImage->GraphData = ( BYTE * )GRS.MainBufferMemImg.UseImage + BaseImage->ColorData.PixelByte * LockRect->left + BaseImage->Pitch * LockRect->top ;
		}
		BaseImage->Width = Width ;
		BaseImage->Height = Height ;
		BaseImage->MipMapCount = 0 ;
		BaseImage->GraphDataCount = 0 ;
	}

	// bNtO𗧂Ă
	GRH.DrawScreenBufferLockFlag = TRUE ;

	// I
	return 0 ;
}

// `Ώۂ̉ʂẅ̃OtBbN{C[Wf[^ɓ]
extern int NS_GetDrawScreenBaseImage( int x1, int y1, int x2, int y2, BASEIMAGE *BaseImage )
{
	RECT SrcRect ;
	BASEIMAGE BufferImage ;

	// `obt@bN
	SrcRect.left   = x1 ;
	SrcRect.right  = x2 ;
	SrcRect.top    = y1 ;
	SrcRect.bottom = y2 ;
	if( LockDrawScreenBuffer( &SrcRect, &BufferImage, -1, -1, TRUE, 0 ) < 0 )
		return -1 ;

	// 荞݃TCYƉ摜TCYႤꍇ̓G[
	if( BaseImage->Width != BufferImage.Width || BaseImage->Height != BufferImage.Height ) return -1 ;

	// f[^]
	NS_BltBaseImage( 0, 0, &BufferImage, BaseImage ) ;

	// `obt@AbN
	UnlockDrawScreenBuffer() ;

	// I
	return 0 ;
}

// `\摜obNobt@ẅ̃OtBbN擾
extern	int GetDrawScreenGraphBase( int TargetScreen, int TargetScreenSurface, int x1, int y1, int x2, int y2, int destX, int destY, int GrHandle )
{
	IMAGEDATA2 *Image2, *TargImage2 ;
//	IMAGEDATA2_HARD_DRAW *DrawTex ;
	int Width, Height ;
//	int i ;
	RECT Rect, SrcRect, DestRect, DestBaseRect ;
//	HRESULT hr ;

	// G[
	if( GRAPHCHK( GrHandle, Image2 ) )
		return -1 ;

	// `揈Ă
	RenderVertexHardware() ;
	EndScene() ;

	// `̉摜f[^AhX擾
	if( GRAPHCHKFULL( TargetScreen, TargImage2 ) )
		TargImage2 = NULL ;

	// `̃f[^sꍇG[
	if( x1 < 0 || x1 >= x2 ||
		y1 < 0 || y1 >= y2 ||
		x2 > GBASE.DrawSizeX ||
		y2 > GBASE.DrawSizeY ) return -1 ;

	// 荞ݐ悪摜͂ݏoĂG[
	Width  = x2 - x1 ;
	Height = y2 - y1 ;
	if( Image2->Width < Width + destX || Image2->Height < Height + destY ) return -1 ;
	DestBaseRect.left = destX ;
	DestBaseRect.top = destY ;
	DestBaseRect.right = destX + Width ;
	DestBaseRect.bottom = destY + Height ;

	// eNX`ǂŏ𕪊
	if( Image2->Orig->FormatDesc.TextureFlag )
	{
		// eNX`̏ꍇ
		DX_DIRECT3DSURFACE9 *TargetSurface ;
		D_D3DFORMAT TargetFormat ;
//		COLORDATA *DestColorData ;
		COLORDATA *TargetColorData ;

		// 荞݌ƂȂT[tFX̌

		// `\摜Ώۂ̏ꍇ
		if( TargImage2 )
		{
			TargetSurface = TargImage2->Orig->Hard.Tex[ 0 ].RenderTargetSurface ?
							TargImage2->Orig->Hard.Tex[ 0 ].RenderTargetSurface :
							TargImage2->Orig->Hard.Tex[ 0 ].Surface[ TargetScreenSurface ] ;
			TargetFormat = GRH.TextureFormat[ TargImage2->Orig->ColorFormat ] ;
		}
		else
		// ȊȌꍇ̓TuobNobt@L炻ꂪΏ
		{
			TargetSurface = GRH.SubBackBufferSurface ? GRH.SubBackBufferSurface : GRH.BackBufferSurface ;
			TargetFormat = GRH.ScreenFormat ;
		}
		TargetColorData = GetD3DFormatColorData( TargetFormat ) ;

		// ]ƂȂT[tFX`\eNX`ꍇ͒Pɓ]
		if( Image2->Orig->FormatDesc.DrawValidFlag )
		{
			SrcRect.left = x1 ;
			SrcRect.top = y1 ;
			SrcRect.right = x2 ;
			SrcRect.bottom = y2 ;

			DestRect.left = destX ;
			DestRect.top = destY ;
			DestRect.right = destX + Width ;
			DestRect.bottom = destY + Height ;
			GraphicsDevice_StretchRect(
				TargetSurface,                            &SrcRect,
				Image2->Orig->Hard.Tex[ 0 ].Surface[ 0 ], &DestRect, D_D3DTEXF_NONE ) ;
		}
		else
		// ʏ̃eNX`ꍇ͍ŏɃbNAʖڂxɎ荞ł]
		{
//			D_D3DLOCKED_RECT DestLockRect ;
//			POINT DestPoint ;

			// `obt@bN
			BASEIMAGE LockImage ;
//			DX_DIRECT3DTEXTURE9 *UseTex ;
			SrcRect.left = x1 ;
			SrcRect.top = y1 ;
			SrcRect.right = x2 ;
			SrcRect.bottom = y2 ;
			if( LockDrawScreenBuffer( &SrcRect, &LockImage, TargetScreen, TargetScreenSurface, TRUE, 0 ) < 0 )
				return -1 ;

			// eNX`ɓ]
			Rect.left = 0 ;
			Rect.top = 0 ;
			Rect.right = LockImage.Width ;
			Rect.bottom = LockImage.Height ;
			BltBmpOrBaseImageToGraph3(
				NULL,
				NULL, NULL,
				&Rect,
				destX, destY,
				GrHandle,
				FALSE,
				&LockImage, NULL,
				FALSE,
				FALSE,
				FALSE
			) ;

			// `obt@̃AbN
			UnlockDrawScreenBuffer() ;
		}
	}
	else
	{
		// \tgEGA_Ȍꍇ

		// `Ώۂ]
		Rect.left = x1 ;
		Rect.top = y1 ;
		Rect.right = x2 ;
		Rect.bottom = y2 ;
		BltMemImg( &Image2->Soft.MemImg, TargImage2 ? &TargImage2->Soft.MemImg : &GRS.MainBufferMemImg, &Rect, destX, destY ) ;
	}

	// I
	return 0 ;
}

// ANeBuɂȂĂʂẅ̃OtBbN擾
extern	int NS_GetDrawScreenGraph( int x1, int y1, int x2, int y2, int GrHandle, int /*UseClientFlag*/ )
{
	IMAGEDATA2 *Image2 ;

	// G[
	if( GRAPHCHK( GrHandle, Image2 ) )
		return -1 ;

	// 荞݃TCYƉ摜TCYႤꍇ̓G[
	if( Image2->Width != x2 - x1 || Image2->Height != y2 - y1 ) return -1 ;

	return GetDrawScreenGraphBase( GBASE.TargetScreen[ 0 ], GBASE.TargetScreenSurface[ 0 ], x1, y1, x2, y2, 0, 0, GrHandle ) ;
}

// `\摜ẅ̃OtBbN擾
extern int NS_BltDrawValidGraph( int TargetDrawValidGrHandle, int x1, int y1, int x2, int y2, int DestX, int DestY, int DestGrHandle )
{
	IMAGEDATA2 *Image2 ;

	// G[
	if( GRAPHCHK( TargetDrawValidGrHandle, Image2 ) )
		return -1 ;

	return GetDrawScreenGraphBase( TargetDrawValidGrHandle, 0, x1, y1, x2, y2, DestX, DestY, DestGrHandle ) ;
}

// w̉摜̂`qfaW̃tJ[C[W擾
extern const DWORD *NS_GetFullColorImage( int GrHandle )
{
	IMAGEDATA2 *Image2 ;

	if( GBASE.NotDrawFlag ) return 0 ;

	// G[
	if( GRAPHCHK( GrHandle, Image2 ) )
		return NULL ;

	// tJ[C[Wi[郁̈܂mۂĂȂꍇ͊mۂ
	if( Image2->FullColorImage == NULL )
	{
		Image2->FullColorImage = ( DWORD * )DXALLOC( Image2->Width * 4 * Image2->Height ) ;
		if( Image2->FullColorImage == NULL )
		{
			DXST_ERRORLOG_ADD( _T( "tJ[̉摜C[Wf[^i[郁̈mۏo܂łB\n" ) ) ;
			return NULL;
		}
	}

#ifndef DX_NON_MOVIE

	// [r[̏ꍇ͏𕪊
	if( Image2->MovieHandle >= 0 )
	{
		MOVIEGRAPH * Movie ;
		Movie = GetMovieData( Image2->MovieHandle ) ;
		if( Movie == NULL ) return NULL ;
		static BASEIMAGE Src, Dest ;

		// T[tFX[hI[o[C̏ꍇ͖
		if( Movie->SurfaceMode == DX_MOVIESURFACE_OVERLAY ) return NULL ;

		// ȊȌꍇ̓[r[璼ڃf[^擾

		// [r[̃t[XV
		if( NS_GetMovieStateToGraph( GrHandle ) == FALSE )
		{
			int Time ;

			Time = NS_TellMovieToGraph( GrHandle ) ;
			NS_PlayMovieToGraph( GrHandle ) ;
			UpdateMovie( Image2->MovieHandle, TRUE ) ;
			NS_PauseMovieToGraph( GrHandle ) ;
			NS_SeekMovieToGraph( GrHandle, Time ) ;
		}
		else
		{
//			UpdateMovieToGraph( GrHandle ) ;
		}

		// ]{C[Wf[^̏
		CreateARGB8ColorData( &Dest.ColorData ) ;
		Dest.Width     = Image2->Width ;
		Dest.Height    = Image2->Height ;
		Dest.GraphData = Image2->FullColorImage ;
		Dest.Pitch     = Image2->Width * 4 ;

		// ]
		BltBaseImage( 0, 0, Image2->Width, Image2->Height, 0, 0, &Movie->NowImage, &Dest ) ;
	}
	else
#endif
	{
	}

	// C[W̃|C^Ԃ
	return (DWORD *)Image2->FullColorImage ;
}


// OtBbN̈̃bN
extern int NS_GraphLock( int GrHandle, int *PitchBuf, void **DataPointBuf, COLORDATA **ColorDataPP )
{
	IMAGEDATA2 *Image2 ;
	IMAGEDATA2_HARD_DRAW *DrawTex ;
	int i ;
	RECT Rect ;
	COLORDATA *ColorData ;
	BYTE *Dest, *Src ;
	DWORD WidthByte ;
	HRESULT hr ;

	// 摜ǂŏ𕪊
	if( GrHandle == DX_SCREEN_BACK || GrHandle == DX_SCREEN_FRONT )
	{
		// n[hEGAgpĂ邩ǂŏ𕪊
		if( GRA2.ValidHardWare )
		{
			// n[hEGAł̃bN͑ΉĂȂ
			return -1 ;
		}
		else
		{
			// \tgEGȀꍇ͉ʃC[W̏Ԃ
			if( ColorDataPP  ) *ColorDataPP  = GRS.MainBufferMemImg.Base->ColorDataP ;
			if( PitchBuf     ) *PitchBuf     = GRS.MainBufferMemImg.Base->Pitch ;
			if( DataPointBuf ) *DataPointBuf = GRS.MainBufferMemImg.UseImage ;
		}
	}
	else
	{
		// G[
		if( GRAPHCHK( GrHandle, Image2 ) )
			return -1 ;

		// ɃbNĂG[
		if( Image2->LockFlag == TRUE ) return -1 ;

		// bNtO𗧂Ă
		Image2->LockFlag = TRUE ;

		// eNX`ǂŏ𕪊
		if( Image2->Orig->FormatDesc.TextureFlag )
		{
			// eNX`̏ꍇ
			D_D3DLOCKED_RECT LockRect ;
			DX_DIRECT3DSURFACE9 *SMSurface ;

			// `IĂ
			RenderVertexHardware() ;
			EndScene() ;

			// eNX`̃tH[}bg擾
			ColorData = GetD3DFormatColorData( GRH.TextureFormat[ Image2->Orig->ColorFormat ] ) ;

			// bÑe|C[Wi[邽߂̃m
			Image2->LockImagePitch = Image2->Width * ColorData->PixelByte ;
			Image2->LockImage = ( BYTE * )DXALLOC( Image2->Height * Image2->LockImagePitch ) ;
			if( Image2->LockImage == NULL )
			{
				DXST_ERRORLOG_ADD( _T( "bNpe|C[Wi[p̊mۂɎs܂\n" ) ) ;
				return -1 ;
			}

			// `̐JԂ
			DrawTex = Image2->Hard.Draw ;
			SMSurface = NULL ;
			for( i = 0 ; i < Image2->Hard.DrawNum ; i ++, DrawTex ++ )
			{
				// Direct3D9Ex gpĂ邩A`\eNX`̏ꍇ͈xVXeT[tFXɃf[^]Ă烍bN
				if( Graphics_IsExObject() || Image2->Orig->FormatDesc.DrawValidFlag )
				{
					DX_DIRECT3DSURFACE9 *RTSurface ;
					RECT DestRect ;

					// 荞݃TCYƓ傫̕`\T[tFX̍쐬
					RTSurface = NULL ;
					if( GraphicsDevice_CreateRenderTarget(
							DrawTex->Width,
							DrawTex->Height,
							GRH.TextureFormat[ Image2->Orig->ColorFormat ],
							D_D3DMULTISAMPLE_NONE,
							0,
							FALSE,
							&RTSurface,
							NULL
						) != D_D3D_OK )
					{
						DXST_ERRORLOG_ADD( _T( "bNp`\T[tFX̍쐬Ɏs܂\n" ) ) ;
						return -1 ;
					}

					// 荞݃TCYƓ傫̃VXẽItXN[T[tFX̍쐬
					if( GraphicsDevice_CreateOffscreenPlainSurface(
							DrawTex->Width,
							DrawTex->Height,
							GRH.TextureFormat[ Image2->Orig->ColorFormat ],
							D_D3DPOOL_SYSTEMMEM,
							&SMSurface,
							NULL
						) != D_D3D_OK )
					{
						DXST_ERRORLOG_ADD( _T( "bNpVXeT[tFX̍쐬Ɏs܂\n" ) ) ;
						Graphics_ObjectRelease( RTSurface ) ;
						return -1 ;
					}

					// ܂`\T[tFXɓe]
					Rect.left       = DrawTex->UsePosX ;
					Rect.top        = DrawTex->UsePosY ;
					Rect.right      = DrawTex->UsePosX + DrawTex->Width ;
					Rect.bottom     = DrawTex->UsePosY + DrawTex->Height ;
					DestRect.left   = 0 ;
					DestRect.top    = 0 ;
					DestRect.right  = DrawTex->Width ;
					DestRect.bottom = DrawTex->Height ;
					hr = GraphicsDevice_StretchRect(
						DrawTex->Tex->Surface[ 0 ], &Rect,
						RTSurface, &DestRect, D_D3DTEXF_NONE ) ;

					// ̌VXeT[tFXɓe]
					hr = GraphicsDevice_GetRenderTargetData( RTSurface, SMSurface ) ;

					// ꎞIɍ쐬T[tFX̉
					Graphics_ObjectRelease( RTSurface ) ;

					// VXe[tFXbN
					Rect.left   = 0 ;
					Rect.top    = 0 ;
					Rect.right  = DrawTex->Width ;
					Rect.bottom = DrawTex->Height ;
					hr = GraphicsSurface_LockRect( SMSurface, &LockRect, &Rect, D_D3DLOCK_READONLY ) ;
				}
				else
				{
					// ȊȌꍇ͂Ȃ胍bN
					Rect.left   = DrawTex->UsePosX ;
					Rect.top    = DrawTex->UsePosY ;
					Rect.right  = DrawTex->UsePosX + DrawTex->Width ;
					Rect.bottom = DrawTex->UsePosY + DrawTex->Height ;
					hr = GraphicsSurface_LockRect( DrawTex->Tex->Surface[ 0 ], &LockRect, &Rect, D_D3DLOCK_READONLY ) ;
				}

				// ]
				Src = ( BYTE * )LockRect.pBits ;
				Dest = Image2->LockImage + DrawTex->DrawPosX * ColorData->PixelByte + DrawTex->DrawPosY * Image2->LockImagePitch ;
				WidthByte = DrawTex->Width * ColorData->PixelByte ;
				for( i = 0 ; i < DrawTex->Height ; i ++, Dest += Image2->LockImagePitch, Src += LockRect.Pitch )
				{
					_MEMCPY( Dest, Src, WidthByte ) ;
				}

				// bN̉
				if( SMSurface )
				{
					GraphicsSurface_UnlockRect( SMSurface ) ;
					Graphics_ObjectRelease( SMSurface ) ;
				}
				else
				{
					GraphicsSurface_UnlockRect( DrawTex->Tex->Surface[ 0 ] ) ;
				}
			}

			// ̊i[
			if( PitchBuf     ) *PitchBuf = Image2->LockImagePitch ;
			if( DataPointBuf ) *DataPointBuf = ( void * )Image2->LockImage ;
			if( ColorDataPP  ) *ColorDataPP = ColorData ;
		}
		else
		{
			// eNX`ł͂Ȃꍇ
			if( PitchBuf     ) *PitchBuf     = Image2->Soft.MemImg.Base->Pitch ;
			if( DataPointBuf ) *DataPointBuf = Image2->Soft.MemImg.UseImage ;
			if( ColorDataPP  ) *ColorDataPP  = Image2->Soft.MemImg.Base->ColorDataP ;
		}
	}

	// I
	return 0 ;
}

// OtBbN̈̃bN
extern	int NS_GraphUnLock( int GrHandle )
{
	IMAGEDATA2 *Image2 ;
	IMAGEDATA2_HARD_DRAW *DrawTex ;
	int i, j ;
	RECT Rect, SrcRect ;
	COLORDATA *ColorData ;
	BYTE *Dest, *Src ;
	DWORD WidthByte ;
	POINT DestPoint ;
	HRESULT hr ;

	// G[
	if( GRAPHCHK( GrHandle, Image2 ) )
		return -1 ;

	// bNĂȂG[
	if( Image2->LockFlag == FALSE ) return -1 ;

	// bNtO|
	Image2->LockFlag = FALSE ;

	// eNX`ǂŏ𕪊
	if( Image2->Orig->FormatDesc.TextureFlag )
	{
		// eNX`̏ꍇ
		D_D3DLOCKED_RECT LockRect ;
		DX_DIRECT3DSURFACE9 *SMSurface ;

		// `IĂ
		RenderVertexHardware() ;
		EndScene() ;

		// eNX`̃tH[}bg擾
		ColorData = GetD3DFormatColorData( GRH.TextureFormat[ Image2->Orig->ColorFormat ] ) ;

		// `̐JԂ
		DrawTex = Image2->Hard.Draw ;
		SMSurface = NULL ;
		for( i = 0 ; i < Image2->Hard.DrawNum ; i ++, DrawTex ++ )
		{
			// Direct3D9Ex gpĂ邩A͕`\eNX`ǂŏ𕪊
			if( Graphics_IsExObject() || Image2->Orig->FormatDesc.DrawValidFlag )
			{
				// Direct3D9Ex gpĂ邩A͕`\eNX`̏ꍇ͈xVXeT[tFXɃf[^]ĂXV
				if( GraphicsDevice_CreateOffscreenPlainSurface( DrawTex->Width, DrawTex->Height, GRH.TextureFormat[ Image2->Orig->ColorFormat ], D_D3DPOOL_SYSTEMMEM, &SMSurface, NULL ) != D_D3D_OK )
				{
					DXST_ERRORLOG_ADD( _T( "bNpe|̃VXezuT[tFX̍쐬Ɏs܂\n" ) ) ;
					return -1 ;
				}

				// 쐬eNX`bN
				hr = GraphicsSurface_LockRect( SMSurface, &LockRect, NULL, 0 ) ;

				// f[^]
				Src = Image2->LockImage + ColorData->PixelByte * DrawTex->DrawPosX + Image2->LockImagePitch * DrawTex->DrawPosY ;
				Dest = ( BYTE * )LockRect.pBits ;
				WidthByte = Image2->Width * ColorData->PixelByte ;
				for( j = 0 ; j < DrawTex->Height ; j ++, Src += Image2->LockImagePitch, Dest += LockRect.Pitch )
				{
					_MEMCPY( Dest, Src, WidthByte ) ;
				}

				// bN
				GraphicsSurface_UnlockRect( SMSurface ) ;

				// VXeT[tFX`\eNX`ɓ]
				SrcRect.left = 0 ;
				SrcRect.top = 0 ;
				SrcRect.right = DrawTex->Width ;
				SrcRect.bottom = DrawTex->Height ;
				DestPoint.x = DrawTex->UsePosX ;
				DestPoint.y = DrawTex->UsePosY ;
				hr = GraphicsDevice_UpdateSurface(
					SMSurface,                  &SrcRect,
					DrawTex->Tex->Surface[ 0 ], &DestPoint ) ;

				// VXeT[tFX
				if( SMSurface )
				{
					Graphics_ObjectRelease( SMSurface ) ;
					SMSurface = NULL ;
				}
			}
			else
			{
				// ʏ̃eNX`̏ꍇ̓bNē]

				// bN
				Rect.left = DrawTex->UsePosX ;
				Rect.top = DrawTex->UsePosY ;
				Rect.right = DrawTex->UsePosX + DrawTex->Width ;
				Rect.bottom = DrawTex->UsePosY + DrawTex->Height ;
				hr = GraphicsSurface_LockRect( DrawTex->Tex->Surface[ 0 ], &LockRect, &Rect, 0 ) ;

				// ]
				Src = Image2->LockImage + DrawTex->DrawPosX * ColorData->PixelByte + DrawTex->DrawPosY * Image2->LockImagePitch ;
				Dest = ( BYTE * )LockRect.pBits ;
				WidthByte = DrawTex->Width * ColorData->PixelByte ;
				for( i = 0 ; i < DrawTex->Height ; i ++, Src += Image2->LockImagePitch, Dest += LockRect.Pitch )
				{
					_MEMCPY( Dest, Src, WidthByte ) ;
				}

				// bN̉
				GraphicsSurface_UnlockRect( DrawTex->Tex->Surface[ 0 ] ) ;
			}
		}

		// bNC[W̉
		DXFREE( Image2->LockImage ) ;
		Image2->LockImage = NULL ;
	}
	else
	{
		// eNX`ł͂Ȃꍇ
	}

	// I
	return 0 ;
}

// OtBbNɂyobt@gp邩ǂݒ肷
extern	int NS_SetUseGraphZBuffer( int GrHandle, int UseFlag, int BitDepth )
{
	IMAGEDATA2 *Image2 ;
	int DepthIndex ;

	// G[
	if( GRAPHCHK( GrHandle, Image2 ) )
		return -1 ;

	// eNX`ł͂Ȃꍇ͉Ȃ
	if( Image2->Orig->FormatDesc.TextureFlag == FALSE )
		return -1 ;

	// `\ł͂ȂꍇȂ
	if( Image2->Orig->FormatDesc.DrawValidFlag == FALSE )
		return -1 ;

	// rbg[x̃Zbg
	if( Image2->Orig->ZBufferFlag == TRUE && BitDepth < 0 )
	{
		DepthIndex = Image2->Orig->ZBufferBitDepthIndex ;
	}
	else
	{
		switch( BitDepth )
		{
		default :
		case 16 : DepthIndex = ZBUFFER_FORMAT_16BIT ; break ;
		case 24 : DepthIndex = ZBUFFER_FORMAT_24BIT ; break ;
		case 32 : DepthIndex = ZBUFFER_FORMAT_32BIT ; break ;
		}
	}

	// yobt@gtOƃrbg[x牽Ȃ
	if( Image2->Orig->ZBufferFlag == UseFlag && Image2->Orig->ZBufferBitDepthIndex == DepthIndex )
		return 0 ;

	// tOۑ
	Image2->Orig->ZBufferFlag = UseFlag ;

	// rbg[xCfbNXۑ
	Image2->Orig->ZBufferBitDepthIndex = DepthIndex ;

	// eNX`̍蒼
	CreateOrigTexture( Image2->Orig ) ;

	// I
	return 0 ;
}

// OtBbN̂yobt@̏Ԃʂ̃OtBbN̂yobt@ɃRs[( DestGrHandle  SrcGrHandle yobt@Ă`\摜ŁAA`GCAX摜ł͂ȂƂ )
extern int NS_CopyGraphZBufferImage( int DestGrHandle, int SrcGrHandle )
{
	IMAGEDATA2 *SrcImage2 ;
	IMAGEDATA2 *DestImage2 ;

	// G[
	if( GRAPHCHK( SrcGrHandle, SrcImage2 ) )
		return -1 ;

	if( GRAPHCHK( DestGrHandle, DestImage2 ) )
		return -1 ;

	// eNX`ł͂Ȃꍇ͉Ȃ
	if( SrcImage2->Orig->FormatDesc.TextureFlag == FALSE ||
		DestImage2->Orig->FormatDesc.TextureFlag == FALSE )
		return -1 ;

	// `\ł͂ȂꍇȂ
	if( SrcImage2->Orig->FormatDesc.DrawValidFlag == FALSE ||
		DestImage2->Orig->FormatDesc.DrawValidFlag == FALSE )
		return -1 ;

	// A`GCAX_O^[Qbg̏ꍇȂ
	if( SrcImage2->Orig->FormatDesc.MSSamples != D_D3DMULTISAMPLE_NONE ||
		DestImage2->Orig->FormatDesc.MSSamples != D_D3DMULTISAMPLE_NONE )
		return -1 ;

	// yobt@ꍇȂ
	if( SrcImage2->Orig->Hard.Tex[ 0 ].ZBuffer == NULL ||
		DestImage2->Orig->Hard.Tex[ 0 ].ZBuffer == NULL )
		return -1 ;

	// TCYႤꍇȂ
	if( SrcImage2->Orig->Hard.Tex[ 0 ].TexWidth != DestImage2->Orig->Hard.Tex[ 0 ].TexWidth ||
		SrcImage2->Orig->Hard.Tex[ 0 ].TexHeight != DestImage2->Orig->Hard.Tex[ 0 ].TexHeight )
		return -1 ;

	// `I点Ă
	RenderVertexHardware() ;
	EndScene() ;

	// ]
	if( GraphicsDevice_StretchRect( SrcImage2->Orig->Hard.Tex[ 0 ].ZBuffer, NULL, DestImage2->Orig->Hard.Tex[ 0 ].ZBuffer, NULL, D_D3DTEXF_NONE ) != D_D3D_OK )
	{
		DXST_ERRORLOG_ADD( _T( "Zobt@[C[W̓]Ɏs܂\n" ) ) ;
		return -1 ;
	}

	// I
	return 0 ;
}

// OtBbNXfoCX̃foCXXgɎw̃OtBbNnh폜邩ǂݒ肷( TRUE:foCXXgɍ폜  FALSE:foCXXgĂ폜Ȃ )
extern int NS_SetDeviceLostDeleteGraphFlag(	int GrHandle, int DeleteFlag )
{
	IMAGEDATA2 *Image2 ;

	if( GRAPHCHK_ASYNC( GrHandle, Image2 ) )
		return -1 ;

	Image2->DeviceLostDeleteFlag = DeleteFlag ? TRUE : FALSE ;

	return 0 ;
}

// OtBbÑTCY𓾂
extern	int NS_GetGraphSize( int GrHandle, int *SizeXBuf, int *SizeYBuf )
{
	IMAGEDATA2 *Image2 ;

	switch( GrHandle )
	{
	case DX_SCREEN_BACK	 :
	case DX_SCREEN_FRONT :
		if( SizeXBuf ) *SizeXBuf = GRA2.MainScreenSizeX ;
		if( SizeYBuf ) *SizeYBuf = GRA2.MainScreenSizeY ;
		break ;

	default :
		// G[
		if( GRAPHCHK_ASYNC( GrHandle, Image2 ) )
			return -1 ;

		if( SizeXBuf ) *SizeXBuf = Image2->Width ;
		if( SizeYBuf ) *SizeYBuf = Image2->Height ;
		break ;
	}

	return 0 ;
}

// OtBbNɎgpĂeNX`[̃TCY𓾂
extern int NS_GetGraphTextureSize( int GrHandle, int *SizeXBuf, int *SizeYBuf )
{
	IMAGEDATA2 *Image2 ;

	// G[
	if( GRAPHCHK( GrHandle, Image2 ) )
		return -1 ;

	// eNX`ǂŏ𕪊
	if( Image2->Orig->FormatDesc.TextureFlag )
	{
		if( SizeXBuf ) *SizeXBuf = Image2->Orig->Hard.Tex[ 0 ].TexWidth ;
		if( SizeYBuf ) *SizeYBuf = Image2->Orig->Hard.Tex[ 0 ].TexHeight ;
	}
	else
	{
		if( SizeXBuf ) *SizeXBuf = Image2->Width ;
		if( SizeYBuf ) *SizeYBuf = Image2->Height ;
	}

	// I
	return 0 ;
}

// OtBbN~bv}bvx̐擾
extern int NS_GetGraphMipmapCount( int GrHandle )
{
	IMAGEDATA2 *Image2 ;

	// G[
	if( GRAPHCHK( GrHandle, Image2 ) )
		return -1 ;

	// n[hEFAgpĂȂꍇ͂P
	if( Image2->Orig->FormatDesc.TextureFlag == FALSE )
		return 1 ;

	// ~bv}bv̐Ԃ
	return Image2->Orig->Hard.MipMapCount ;
}

// OtBbNnh摜t@Cǂݍ܂ĂꍇẢ摜̃t@CpX擾
extern int NS_GetGraphFilePath( int GrHandle, TCHAR *FilePathBuffer )
{
	IMAGEDATA2 *Image2 ;

	// G[
	if( GRAPHCHK( GrHandle, Image2 ) )
		return -1 ;

	// 摜t@CpXꍇ̓G[
	if( Image2->ReadBase->FileName == NULL )
		return -1 ;

	// 摜t@CpXRs[
	if( FilePathBuffer != NULL )
	{
		_TSTRCPY( FilePathBuffer, Image2->ReadBase->FileName ) ;
	}

	// Ȉꍇ͕TCYԂ
	return _TSTRLEN( Image2->ReadBase->FileName ) ;
}

// OtBbNɎgpőeNX`TCY擾
extern int NS_GetMaxGraphTextureSize( int *SizeX, int *SizeY )
{
	if( SizeX != NULL ) *SizeX = GRH.DeviceCaps.MaxTextureWidth ;
	if( SizeY != NULL ) *SizeY = GRH.DeviceCaps.MaxTextureHeight ;

	// I
	return 0 ;
}

// ݂̉ʂ̑傫ƃJ[rbg𓾂 
extern	int NS_GetScreenState( int *SizeX, int *SizeY, int *ColorBitDepth )
{
	if( GBASE.Emulation320x240Flag || GRH.FullScreenEmulation320x240 )
	{
		if( SizeX ) *SizeX = 320 ;
		if( SizeY ) *SizeY = 240 ;
	}
	else
	{
		if( SizeX ) *SizeX = GRA2.MainScreenSizeX ;
		if( SizeY ) *SizeY = GRA2.MainScreenSizeY ;
	}

	if( ColorBitDepth ) *ColorBitDepth = GRA2.MainScreenColorBitDepth ;

	// I
	return 0 ;
}

// `ɂRc@\gtO擾
extern	int NS_GetUse3DFlag( void )
{
	// I
	return !GRA2.NotUseHardWare ;
}


// QcOtBbNT[tFX쐬ɃVXe[gp邩̃tO擾
extern	int NS_GetUseVramFlag( void )
{
	return NS_GetUseSystemMemGraphCreateFlag() == TRUE ? FALSE : TRUE ;
}

// ɕ`sƂłʂ̐擾
extern int NS_GetMultiDrawScreenNum( void )
{
	return GRH.RenderTargetNum ;
}




// ⏕֌W
// ꂩVɃOtBbN쐬ꍇɎgpJ[擾
extern	int NS_GetCreateGraphColorData( COLORDATA * /*ColorData*/, IMAGEFORMATDESC * /*Format*/ )
{
	// I
	return 0 ;
}

// 摜쐬p֌W

// 摜̌f[^̏ۑ
extern int SetGraphBaseInfo(
	int GrHandle,
	const TCHAR *FileName,
	const COLORDATA *BmpColorData,
	HBITMAP RgbBmp,
	HBITMAP AlphaBmp,
	const void *MemImage,
	int MemImageSize,
	const void *AlphaMemImage,
	int AlphaMemImageSize,
	const BASEIMAGE *Image,
	const BASEIMAGE *AlphaImage,
	int ReverseFlag,
	int UnionGrHandle,
	int ASyncThread
)
{
	SETGRAPHBASEINFO_GPARAM GParam ;

	InitSetGraphBaseInfoGParam( &GParam ) ;

	return SetGraphBaseInfo_UseGParam( &GParam, GrHandle, FileName, BmpColorData, RgbBmp, AlphaBmp, MemImage, MemImageSize,
										AlphaMemImage, AlphaMemImageSize, Image, AlphaImage, ReverseFlag, UnionGrHandle, ASyncThread ) ;
}

// SetGraphBaseInfo ̃O[oϐɃANZXȂo[W
extern int SetGraphBaseInfo_UseGParam(
	SETGRAPHBASEINFO_GPARAM *GParam,
	int GrHandle,
	const TCHAR *FileName,
	const COLORDATA *BmpColorData,
	HBITMAP RgbBmp,
	HBITMAP AlphaBmp,
	const void *MemImage,
	int MemImageSize,
	const void *AlphaMemImage,
	int AlphaMemImageSize,
	const BASEIMAGE *Image,
	const BASEIMAGE *AlphaImage,
	int ReverseFlag,
	int UnionGrHandle,
	int ASyncThread
)
{
	IMAGEDATA2 *Image2, *SrcImage2 = NULL ;
	TCHAR Path[ 1024 ] ;
	int Len ;
	BASEIMAGE BmpImage, AlphaBmpImage ;

	if( ASyncThread )
	{
		if( GRAPHCHK_ASYNC( GrHandle, Image2 ) )
			return -1 ;
		GRAPHCHKFULL_ASYNC( UnionGrHandle, SrcImage2 ) ;
	}
	else
	{
		if( GRAPHCHK( GrHandle, Image2 ) )
			return -1 ;
		GRAPHCHKFULL( UnionGrHandle, SrcImage2 ) ;
	}

	// Ƀt@CpXp̃mۂĂ
	if( Image2->ReadBase )
	{
		Image2->ReadBase->RefCount -- ;
		if( Image2->ReadBase->RefCount == 0 )
		{
			DXFREE( Image2->ReadBase ) ;
			Image2->ReadBase = NULL ;
		}
	}

	// rbg}bvLȏꍇ BASEIMAGE \̂\z
	if( RgbBmp )
	{
#ifdef __WINDOWS__
		BITMAP BitmapInfo ;
		BITMAP AlphaBitmapInfo ;

		GetObject( RgbBmp, sizeof( BITMAP ), ( void * )&BitmapInfo ) ;
		_MEMSET( &BmpImage, 0, sizeof( BASEIMAGE ) ) ;
		BmpImage.GraphData = BitmapInfo.bmBits ;
		BmpImage.Width = BitmapInfo.bmWidth ;
		BmpImage.Height = BitmapInfo.bmHeight ;
		BmpImage.Pitch = ( BmpImage.Pitch + 3 ) / 4 * 4 ;
		_MEMCPY( &BmpImage.ColorData, BmpColorData, sizeof( COLORDATA ) ) ; 
		Image = &BmpImage ;

		if( AlphaBmp )
		{
			GetObject( AlphaBmp, sizeof( BITMAP ), ( void * )&AlphaBitmapInfo ) ;
			_MEMSET( &AlphaBmpImage, 0, sizeof( BASEIMAGE ) ) ;
			AlphaBmpImage.GraphData = AlphaBitmapInfo.bmBits ;
			AlphaBmpImage.Width = AlphaBitmapInfo.bmWidth ;
			AlphaBmpImage.Height = AlphaBitmapInfo.bmHeight ;
			AlphaBmpImage.Pitch = ( AlphaBmpImage.Pitch + 3 ) / 4 * 4 ;
			_MEMCPY( &AlphaBmpImage.ColorData, BmpColorData, sizeof( COLORDATA ) ) ; 
			AlphaImage = &AlphaBmpImage ;
		}
#else // __WINDOWS__
		return -1 ;
#endif // __WINDOWS__
	}

	// f[^̏񂪈؂ȂAobNAbvۂtOĂꍇ̓obNAbvȂ
	if( GParam->NotGraphBaseDataBackupFlag || ( FileName == NULL && MemImage == NULL && Image == NULL && SrcImage2 == NULL ) )
	{
		Image2->ReadBase = NULL ;
	}
	else
	{
		// Lnh̎w肪ꍇ͋LZbg
		if( SrcImage2 != NULL )
		{
			// t@C̃AhXႤ
			Image2->ReadBase = SrcImage2->ReadBase ;

			// QƐ𑝂₷
			if( SrcImage2->ReadBase )
			{
				SrcImage2->ReadBase->RefCount ++ ;
			}
		}
		else
		{
			// t@CLȏꍇ̓t@Cۑ
			if( FileName )
			{
				// tpX擾
				ConvertFullPathT_( FileName, Path ) ;

				// t@Cۑp̃m
				Len = _TSTRLEN( Path ) ;
				Image2->ReadBase = ( IMAGEDATA_READBASE * )DXCALLOC( sizeof( IMAGEDATA_READBASE ) + ( Len + 1 ) * sizeof( TCHAR ) ) ;
				if( Image2->ReadBase == NULL )
				{
					DXST_ERRORLOG_ADD( _T( "]摜t@C̃t@Cۑ郁̈̊mۂɎs܂\n" ) ) ;
					return -1 ;
				}
				Image2->ReadBase->FileName = ( TCHAR * )( Image2->ReadBase + 1 ) ;

				// t@CpXۑ
				_MEMCPY( Image2->ReadBase->FileName, Path, ( Len + 1 ) * sizeof( TCHAR ) ) ;
			}
			else
			// C[WLȏꍇ̓C[Wۑ
			if( MemImage )
			{
				// C[Wۑp̃m
				Image2->ReadBase = ( IMAGEDATA_READBASE * )DXALLOC( sizeof( IMAGEDATA_READBASE ) + MemImageSize + AlphaMemImageSize ) ;
				if( Image2->ReadBase == NULL )
				{
					DXST_ERRORLOG_ADD( _T( "]摜f[^ۑ郁̈̊mۂɎs܂\n" ) ) ;
					return -1 ;
				}
				_MEMSET( Image2->ReadBase, 0, sizeof( IMAGEDATA_READBASE ) ) ;

				// C[Wۑ
				Image2->ReadBase->MemImage = Image2->ReadBase + 1 ;
				Image2->ReadBase->MemImageSize = MemImageSize ;
				_MEMCPY( Image2->ReadBase->MemImage, MemImage, MemImageSize ) ;

				if( AlphaMemImage )
				{
					Image2->ReadBase->AlphaMemImage = ( BYTE * )Image2->ReadBase->MemImage + MemImageSize ;
					Image2->ReadBase->AlphaMemImageSize = AlphaMemImageSize ;
					_MEMCPY( Image2->ReadBase->AlphaMemImage, AlphaMemImage, AlphaMemImageSize ) ;
				}
			}
			else
			// {C[Wf[^Lȏꍇ͊{C[Wf[^ۑ
			if( Image )
			{
				int ImageSize, AlphaImageSize = 0 ;
				int AllocSize ;

				ImageSize =  NS_GetBaseImageGraphDataSize( Image ) ;
				AllocSize = ImageSize + sizeof( BASEIMAGE ) ;
				if( AlphaImage )
				{
					AlphaImageSize = NS_GetBaseImageGraphDataSize( AlphaImage ) ;
					AllocSize += AlphaImageSize + sizeof( BASEIMAGE ) ;
				}

				// {C[Wۑp̃m
				Image2->ReadBase = ( IMAGEDATA_READBASE * )DXALLOC( sizeof( IMAGEDATA_READBASE ) + AllocSize ) ;
				if( Image2->ReadBase == NULL )
				{
					DXST_ERRORLOG_ADD( _T( "]{C[Wۑ郁̈̊mۂɎs܂\n" ) ) ;
					return -1 ;
				}
				_MEMSET( Image2->ReadBase, 0, sizeof( IMAGEDATA_READBASE ) ) ;

				// {C[Wɕۑ
				Image2->ReadBase->BaseImage = ( BASEIMAGE * )( Image2->ReadBase + 1 ) ;
				_MEMCPY( Image2->ReadBase->BaseImage, Image, sizeof( BASEIMAGE ) ) ;
				Image2->ReadBase->BaseImage->GraphData = Image2->ReadBase->BaseImage + 1 ;
				_MEMCPY( Image2->ReadBase->BaseImage->GraphData, Image->GraphData, ImageSize ) ;

				if( AlphaImage )
				{
					Image2->ReadBase->AlphaBaseImage = ( BASEIMAGE * )( ( BYTE * )Image2->ReadBase->BaseImage->GraphData + ImageSize ) ;
					_MEMCPY( Image2->ReadBase->AlphaBaseImage, AlphaImage, sizeof( BASEIMAGE ) ) ;
					Image2->ReadBase->AlphaBaseImage->GraphData = Image2->ReadBase->AlphaBaseImage + 1 ;
					_MEMCPY( Image2->ReadBase->AlphaBaseImage->GraphData, AlphaImage->GraphData, AlphaImageSize ) ;
				}
			}

			// ]tOۑ
			Image2->ReadBase->ReverseFlag = ReverseFlag ;

			// QƐPɂ
			Image2->ReadBase->RefCount = 1 ;
		}
	}

	// I
	return 0 ;
}

// SetGraphName ̃O[oϐɃANZXȂo[W
extern int SetGraphName_UseGParam( SETGRAPHBASEINFO_GPARAM *GParam, int GrHandle, const TCHAR *GraphName, int ReverseFlag, int UnionGrHandle, int ASyncThread )
{
	return SetGraphBaseInfo_UseGParam( GParam, GrHandle, GraphName, NULL, NULL, NULL, NULL, 0, NULL, 0, NULL, NULL, ReverseFlag, UnionGrHandle, ASyncThread ) ;
}

// ̃t@C摜ǂݍ񂾏ꍇ̃t@CpXZbg
extern int SetGraphName( int GrHandle, const TCHAR *GraphName, int ReverseFlag, int UnionGrHandle, int ASyncThread )
{
	return SetGraphBaseInfo( GrHandle, GraphName, NULL, NULL, NULL, NULL, 0, NULL, 0, NULL, NULL, ReverseFlag, UnionGrHandle, ASyncThread ) ;
}

// GraphImage f[^TCYoAɍOtBbNnh쐬
extern int CreateDXGraph_UseGParam(
	SETUP_GRAPHHANDLE_GPARAM *GParam,
	int GrHandle,
	const BASEIMAGE *RgbImage,
	const BASEIMAGE *AlphaImage,
	int TextureFlag,
	int ASyncThread
)
{
	if( GRA2.InitializeFlag == FALSE ) return -1 ;

	if( ASyncThread == FALSE )
	{
		CheckActiveState() ;
	}

	// ̃OtBbÑTCYꍇ̓G[
	if( AlphaImage != NULL && ( RgbImage->Width != AlphaImage->Width || RgbImage->Height != AlphaImage->Height ) )
		return -1 ;

	// L[u}bveNX`쐬邩ǂZbg
	GParam->CubeMapTextureCreateFlag = RgbImage->GraphDataCount == CUBEMAP_SURFACE_NUM ? TRUE : FALSE ;

	// nh̏
	if( SetupGraphHandle_UseGParam(
			GParam,
			GrHandle,
			RgbImage->Width, RgbImage->Height, TextureFlag,
			RgbImage->ColorData.AlphaWidth != 0 || AlphaImage != NULL,
			RgbImage->ColorData.PixelByte == 1 && 
			RgbImage->ColorData.AlphaWidth == 0 &&
			AlphaImage == NULL,
			RgbImage->ColorData.Format,
			RgbImage->MipMapCount == 0 ? -1 : RgbImage->MipMapCount,
			ASyncThread ) == -1 )
		return -1 ;

	// I
	return 0 ;
}

/*
// GraphImage f[^ɍTCY̕OtBbNnh쐬
extern int NS_CreateDXDivGraph( BASEIMAGE *RgbImage, BASEIMAGE *AlphaImage, int AllNum, int XNum, int YNum, int SizeX, int SizeY, int *HandleBuf, int TextureFlag )
{
	// I
	return 0 ;
}
*/

// OtBbNnh쐬Ȃ DerivationGraph
extern int DerivationGraphBase( int GrHandle, int SrcX, int SrcY, int Width, int Height, int SrcGraphHandle, int ASyncThread )
{
	IMAGEDATA2 *Image2 ;

	if( GBASE.NotDrawFlag == TRUE ) return 0 ;

	// G[
	if( ASyncThread )
	{
		if( GRAPHCHK_ASYNC( SrcGraphHandle, Image2 ) )
			return -1 ;
	}
	else
	{
		if( GRAPHCHK( SrcGraphHandle, Image2 ) )
			return -1 ;
	}

	// ␳
	if( SrcX < 0 || SrcY < 0 || SrcX >= Image2->Width || SrcY >= Image2->Height ) return -1 ;
	if( SrcX + Width  > Image2->Width  ) Width  = Image2->Width  - SrcX ;
	if( SrcY + Height > Image2->Height ) Height = Image2->Height - SrcY ;

	// oOtBbN̏
	if( InitializeDerivationGraphHandle( GrHandle, SrcX, SrcY, Width, Height, SrcGraphHandle, ASyncThread ) == -1 )
		return -1 ;

	// I
	return 0 ;
}

// DerivationGraph ̃O[oϐɃANZXȂo[W
extern int DerivationGraph_UseGParam(
	int SrcX,
	int SrcY,
	int Width,
	int Height,
	int SrcGraphHandle,
	int ASyncThread
)
{
	int NewGraphHandle ;

	// VȃOtBbNf[^̒ǉ
	NewGraphHandle = AddGraphHandle() ;
	if( NewGraphHandle == -1 ) return -1 ;

	if( DerivationGraphBase( NewGraphHandle, SrcX, SrcY, Width, Height, SrcGraphHandle, ASyncThread ) < 0 )
	{
		NS_DeleteGraph( NewGraphHandle ) ;
		return -1 ;
	}

	// nhԂ
	return NewGraphHandle ;
}

// w̃OtBbN̎w蕔𔲂oĐVȃOtBbNnh쐬
extern int NS_DerivationGraph( int SrcX, int SrcY, int Width, int Height, int SrcGraphHandle )
{
	return DerivationGraph_UseGParam( SrcX, SrcY, Width, Height, SrcGraphHandle, FALSE ) ;
}





// ݒ֌W֐

// ȗuhsۂ̃tOZbg
extern	int		NS_SetBasicBlendFlag( int /*Flag*/ )
{
	// I
	return 0 ;
}

// ʏ`ɃvO}uVF[_[gp邩ǂݒ肷( TRUE:gp( ftHg )  FALSE:gpȂ )
extern	int		NS_SetUseNormalDrawShader( int Flag )
{
	Flag = Flag ? FALSE : TRUE ;

	// tOꍇ͉Ȃ
	if( Flag == GRH.NormalDraw_NotUseShader )
		return 0 ;

	// tOۑ
	GRH.NormalDraw_NotUseShader = Flag ;
	GRH.DrawPrepAlwaysFlag = TRUE ;

	// ݒtbV
	RefreshRenderStateHardware() ;

	// I
	return 0 ;
}

// \tgEGA_O[hgp邩ǂZbg
extern int NS_SetUseSoftwareRenderModeFlag( int Flag )
{
	return NS_SetScreenMemToVramFlag( Flag == TRUE ? FALSE : TRUE ) ;
}

// ʃf[^uq`lɒuAtO
extern	int		NS_SetScreenMemToVramFlag( int Flag )
{
	// Ôݎgp\
	if( DxSysData.DxLib_InitializeFlag == TRUE ) return -1 ;

	GRA2.NotUseHardWare = !Flag ;

	// I
	return 0 ;
}

// Rc@\gÃtOZbg
extern	int NS_SetUse3DFlag( int Flag )
{
	// ÔݗL
	if( DxSysData.DxLib_InitializeFlag == TRUE ) return -1 ;

	GRA2.NotUseHardWare = !Flag ;

	// I
	return 0 ;
}

// Rc@\gȂtÕZbg
extern	int		NS_SetNotUse3DFlag( int Flag )
{
	// Ôݎgp\
	if( DxSysData.DxLib_InitializeFlag == TRUE ) return -1 ;

	GRA2.NotUseHardWare = Flag ;

	// I
	return 0 ;
}

// tXN[̉ʂ̃tbV[gύX(Windows2000ȍ~̂ݗL)
extern	int		NS_SetDisplayRefreshRate( int /*RefreshRate*/ )
{
	// I
	return 0 ;
}

// DirectDraw  Direct3D ̋x}`XbhΉɂ邩ǂZbg
extern	int		NS_SetMultiThreadFlag( int Flag )
{
	if( GRH.InitializeFlag == TRUE )
		return -1 ;

	GRH.UseMultiThread = Flag ;

	// I
	return 0 ;
}

// gp DirectDraw foCX̃CfbNXݒ肷
extern int NS_SetUseDirectDrawDeviceIndex( int Index )
{
	// lۑ
	GRH.ValidAdapterNumber = TRUE ;
	GRH.UseAdapterNumber = Index ;

	// I
	return 0 ;
}







// Cʂ̃TCYlύX
extern void SetMainScreenSize( int SizeX, int SizeY )
{
	GRA2.MainScreenSizeX = SizeX ;
	GRA2.MainScreenSizeY = SizeY ;

	if( ( GBASE.Emulation320x240Flag || GRH.FullScreenEmulation320x240 ) && GRA2.MainScreenSizeX == 640 && GRA2.MainScreenSizeY == 480 )
	{
		GRA2.MainScreenSizeX_Result = 320 ;
		GRA2.MainScreenSizeY_Result = 240 ;
	}
	else
	{
		GRA2.MainScreenSizeX_Result = GRA2.MainScreenSizeX == 0 ? DEFAULT_SCREEN_SIZE_X : GRA2.MainScreenSizeX ;
		GRA2.MainScreenSizeY_Result = GRA2.MainScreenSizeY == 0 ? DEFAULT_SCREEN_SIZE_Y : GRA2.MainScreenSizeY ;
	}

	SetMathScreenSize( GRA2.MainScreenSizeX_Result, GRA2.MainScreenSizeY_Result ) ;
}

// `TCY擾
extern int NS_GetDrawScreenSize( int *XBuf, int *YBuf )
{
	if( XBuf ) *XBuf = GRA2.MainScreenSizeX_Result == 0 ? DEFAULT_SCREEN_SIZE_X : GRA2.MainScreenSizeX_Result ;
	if( YBuf ) *YBuf = GRA2.MainScreenSizeY_Result == 0 ? DEFAULT_SCREEN_SIZE_Y : GRA2.MainScreenSizeY_Result ; ;

	// I
	return 0 ;
}

// gpFrbgԂ
extern int NS_GetScreenBitDepth( void )
{
	// I
	return NS_GetColorBitDepth() ;
}

// ʂ̐Frbg[x𓾂
extern int NS_GetColorBitDepth( void )
{
	// I
	return GRA2.MainScreenColorBitDepth == 0 ? DEFAULT_COLOR_BITDEPTH : GRA2.MainScreenColorBitDepth ;
}

// ʃ[hύXĂ邩ǂ̃tO擾
extern	int						NS_GetChangeDisplayFlag( void )
{
#ifdef __WINDOWS__
	// I
	return NS_GetWindowModeFlag() == FALSE ;
#else // __WINDOWS__
	return FALSE ;
#endif // __WINDOWS__
}


// ʃOtBbNf[^VXeɑ݂邩tO̎擾
extern	int						NS_GetScreenMemToSystemMemFlag( void )
{
	// I
	return GRA2.ValidHardWare == FALSE ;
}




// rfI̗eʂ𓾂
extern	int						NS_GetVideoMemorySize( int *AllSize, int *FreeSize )
{
	return OldGraphicsInterface_GetVideoMemorySize( AllSize, FreeSize ) ;
}


// ύX\ȃfBXvC[h̐擾
extern int NS_GetDisplayModeNum( void )
{
	// fBXvC[h̃ZbgAbvsĂȂꍇ̓ZbgAbv
	if( GRH.DisplayMode == NULL )
	{
		SetupDisplayModeData( &GRH.DisplayModeNum, &GRH.DisplayMode ) ;
	}

	return GRH.DisplayModeNum ;
}

// ύX\ȃfBXvC[h̏擾( ModeIndex  0 ` GetDisplayModeNum ̖߂l-1 )
extern DISPLAYMODEDATA NS_GetDisplayMode( int ModeIndex )
{
	// fBXvC[h̃ZbgAbvsĂȂꍇ̓ZbgAbv
	if( GRH.DisplayMode == NULL )
	{
		SetupDisplayModeData( &GRH.DisplayModeNum, &GRH.DisplayMode ) ;
	}

	if( GRH.DisplayModeNum <= ModeIndex || ModeIndex < 0 )
	{
		DISPLAYMODEDATA ErrorResult = { -1, -1, -1, -1 } ;
		return ErrorResult ;
	}

	return GRH.DisplayMode[ ModeIndex ] ;
}

// fBXv[̃J[f[^|C^𓾂
extern	const COLORDATA *NS_GetDispColorData( void )
{
	if( GRA2.ValidHardWare )
	{
		return GetD3DFormatColorData( GRH.ScreenFormat ) ;
	}
	else
	{
		return GRS.MainBufferMemImg.Base->ColorDataP ;
	}
}

// L Direct3D foCXA_v^̐擾
extern int NS_GetDirect3DAdapterNum( void )
{
	int Result = -1 ;

	// 
	if( DxSysData.DxLib_InitializeFlag == FALSE || DxLib_GetEndRequest() )
	{
		// Direct3D9.DLL ̓ǂݍ
		if( Graphics_LoadDLL() < 0 )
			return -1 ;

		// Direct3D9 ̍쐬
		if( Graphics_Create() == 0 )
		{
			// A_v^̎擾
			Result = Graphics_GetAdapterCount() ;

			// Direct3D9 ̉
			Graphics_Release() ;
		}

		// d3d9.dll ̉
		Graphics_FreeDLL() ;

		return Result ;
	}
	else
	{
		return Graphics_GetAdapterCount() ;
	}
}



// pbg֌W֐

// ɓǂݍ񂾉摜̃pbg擾(tJ[摜̏ꍇ͖)
extern	int		NS_GetGraphPalette( int GrHandle, int ColorIndex, int *Red, int *Green, int *Blue )
{
	MEMIMG *MemImg ;
	int Color;

	// G[`FbN
	if( ColorIndex < 0 || ColorIndex > 255 ) return -1 ;
	PALETTEIMAGECHK( GrHandle, MemImg );
	
	// pbg擾
	switch( MemImg->Base->ColorType )
	{
	case 0: Color = ((WORD  *)MemImg->Base->Palette)[ ColorIndex ]; break;
	case 1: Color = ((DWORD *)MemImg->Base->Palette)[ ColorIndex ]; break;
	default : return -1 ;
	}
	NS_GetColor5( MemImg->Base->ColorDataP, Color, Red, Green, Blue ) ;
	
	// I
	return 0 ;
}

// ɓǂݍ񂾉摜 SetGraphPalette ŕύXÕpbg擾
extern  int		NS_GetGraphOriginalPalette( int GrHandle, int ColorIndex, int *Red, int *Green, int *Blue )
{
	MEMIMG *MemImg ;
	int Color ;
	
	// G[`FbN
	if( ColorIndex < 0 || ColorIndex > 255 ) return -1 ;
	PALETTEIMAGECHK( GrHandle, MemImg );

	// pbg擾
	switch( MemImg->Base->ColorType )
	{
	case 0: Color = ((WORD  *)MemImg->Base->OriginalPalette)[ColorIndex]; break;
	case 1: Color = ((DWORD *)MemImg->Base->OriginalPalette)[ColorIndex]; break;
	default : return -1 ;
	}
	NS_GetColor5( MemImg->Base->ColorDataP, Color, Red, Green, Blue ) ;
	
	// I
	return 0 ;
}

// ɓǂݍ񂾉摜̃pbgύX(tJ[摜̏ꍇ͖)
extern	int		NS_SetGraphPalette( int GrHandle, int ColorIndex, int Color )
{
	MEMIMG *MemImg ;
	int Red, Green, Blue ;
	COLORDATA *ColorData ;

	// G[`FbN
	if( ColorIndex < 0 || ColorIndex > 255 ) return -1 ;
	PALETTEIMAGECHK( GrHandle, MemImg );

	// FR[hZbg
	NS_GetColor2( Color, &Red, &Green, &Blue ) ;
	ColorData = MemImg->Base->ColorDataP ;
	Color = ColorData->NoneMask +
				( ( ( BYTE )Red   >> ( 8 - ColorData->RedWidth   ) ) << ColorData->RedLoc   ) +
				( ( ( BYTE )Green >> ( 8 - ColorData->GreenWidth ) ) << ColorData->GreenLoc ) +
				( ( ( BYTE )Blue  >> ( 8 - ColorData->BlueWidth  ) ) << ColorData->BlueLoc  ) ;
	switch( MemImg->Base->ColorType )
	{
	case 0: ((WORD  *)MemImg->Base->Palette)[ColorIndex] = (WORD)Color;  break;
	case 1: ((DWORD *)MemImg->Base->Palette)[ColorIndex] = (DWORD)Color; break;
	}
	
	// I
	return 0 ;
}

// SetGraphPalette ŕύXpbgSČɖ߂
extern int NS_ResetGraphPalette( int GrHandle )
{
	MEMIMG *MemImg ;
	int Size;
	
	// G[`FbN
	PALETTEIMAGECHK( GrHandle, MemImg );

	// ̃pbgRs[
	switch( MemImg->Base->ColorType )
	{
	case 0 : Size = 1 ; break ;
	case 1 : Size = 2 ; break ;
	default : return -1 ;
	}
	_MEMCPY( MemImg->Base->Palette, MemImg->Base->OriginalPalette, MemImg->Base->ColorNum << Size ) ;
	
	// I
	return 0 ;
}


// ȈՃOtBbN֌W֐

// wW̐F擾
extern int NS_GetPixel( int x, int y )
{
	RECT SrcRect ;
	BASEIMAGE BufferImage ;
	COLORDATA *DestColorData ;
	IMAGEDATA2 *Image2 ;
	int Ret = -1 ;

	// `W`FbN
	if( x < 0 || y < 0 || x >= GBASE.DrawSizeX || y >= GBASE.DrawSizeY ) return -1 ;

	// n[hEGA@\gp邩ǂŏ𕪊
	if( GRA2.ValidHardWare )
	{
		// gĂꍇ
		RenderVertexHardware() ;
		EndScene();

		// `obt@bN
		SrcRect.left   = x ;
		SrcRect.right  = x + 1 ;
		SrcRect.top    = y ;
		SrcRect.bottom = y + 1 ;
		if( LockDrawScreenBuffer( &SrcRect, &BufferImage, -1, -1, TRUE, 0 ) < 0 )
			return -1 ;

		DestColorData = GetD3DFormatColorData( GRH.ScreenFormat ) ;
		switch( BufferImage.ColorData.ColorBitDepth )
		{
		case 16 : Ret = NS_GetColor4( DestColorData, &BufferImage.ColorData, ( int )*( ( WORD  * )BufferImage.GraphData ) ) & ~DestColorData->NoneMask ; break ;
		case 32 : Ret = NS_GetColor4( DestColorData, &BufferImage.ColorData, ( int )*( ( DWORD * )BufferImage.GraphData ) ) & ~DestColorData->NoneMask ; break ;
		}

		// `obt@AbN
		UnlockDrawScreenBuffer() ;
	}
	else
	{
		MEMIMG *Img ;

		// n[hEFAgpȂꍇ

		// G[
		if( GRAPHCHKFULL( GBASE.TargetScreen[ 0 ], Image2 ) )
			Image2 = NULL ;

		// `ɂď𕪊
		if( Image2 )
		{
			Img = &Image2->Soft.MemImg ;
		}
		else
		{
			Img = &GRS.MainBufferMemImg ;
		}

		switch( GRA2.MainScreenColorBitDepth )
		{
		case 16 : Ret = *( (  WORD * )( ( char * )Img->UseImage + 2 * x + Img->Base->Pitch * y ) ) ; break ;
		case 32 : Ret = *( ( DWORD * )( ( char * )Img->UseImage + 4 * x + Img->Base->Pitch * y ) ) ; break ;
		}
	}

	// I
	return Ret ;
}

// w_狫EFƂ܂œhԂ
extern int NS_Paint( int x, int y, int FillColor, int BoundaryColor )
{
	IMAGEDATA2 *Image2 ;

	// G[
	if( GRAPHCHKFULL( GBASE.TargetScreen[ 0 ], Image2 ) )
		Image2 = NULL ;

	// n[hEFAgpĂ邩ǂŏ𕪊
	if( GRA2.ValidHardWare )
	{
		// n[hEGA̋@\gpĂꍇ
		D_D3DFORMAT TargetFormat ;
		DX_DIRECT3DSURFACE9 *TargetSurface, *SMSurface ;
		int Width, Height ;
		MEMIMG MemImg ;

		if( GraphicsDevice_IsValid() == 0 ) return -1 ;

		// `IĂ
		RenderVertexHardware() ;
		EndScene() ;

		// `ɂď𕪊
		if( Image2 )
		{
			// `悪`\T[tFX̏ꍇ
			TargetSurface = Image2->Orig->Hard.Tex[ 0 ].Surface[ GBASE.TargetScreenSurface[ 0 ] ] ;
			TargetFormat = GRH.TextureFormat[ Image2->Orig->ColorFormat ] ;
			Width = Image2->Orig->Hard.Tex[ 0 ].TexWidth ;
			Height = Image2->Orig->Hard.Tex[ 0 ].TexHeight ;
		}
		else
		{
			// `悪TuobNobt@̓obNobt@̏ꍇ
			TargetSurface = GRH.SubBackBufferSurface ? GRH.SubBackBufferSurface : GRH.BackBufferSurface ; 
			TargetFormat = GRH.ScreenFormat ;
			Width = GRA2.MainScreenSizeX ;
			Height = GRA2.MainScreenSizeY ;
		}

		// tXN[A`GCAXgpĂ邩ǂŏ𕪊
		//if( GRH.FSAAMultiSampleType != D_D3DMULTISAMPLE_NONE )
		if( true )
		{
			BASEIMAGE ScreenImage ;
			int DrawMode ;
			int DrawBlendMode ;
			int DrawBlendParam ;
			RGBCOLOR DrawBright ;
			RECT DrawArea ;

			// ʂ̃C[W擾
			NS_CreateXRGB8ColorBaseImage( GBASE.DrawSizeX, GBASE.DrawSizeY, &ScreenImage ) ;
			NS_GetDrawScreenBaseImage( 0, 0, GBASE.DrawSizeX, GBASE.DrawSizeY, &ScreenImage ) ;

			// Paint p MEMIMG ZbgAbv
			_MEMSET( &MemImg, 0, sizeof( MEMIMG ) ) ;
			InitializeMemImg(
				&MemImg,
				GBASE.DrawSizeX,
				GBASE.DrawSizeY,
				ScreenImage.Pitch,
				0,
				1,
				FALSE, FALSE, FALSE, ScreenImage.GraphData ) ;

			// Paint s
			PaintMemImg( &MemImg, x, y, FillColor, BoundaryColor ) ;

			// MEMIMG ̌n
			TerminateMemImg( &MemImg ) ;

			// ʂɃyCg̉摜`
			DrawBlendMode = GBASE.BlendMode ;
			DrawBlendParam = GBASE.BlendParam ;
			DrawMode = GBASE.DrawMode ;
			DrawBright = GBASE.DrawBright ;
			DrawArea = GBASE.DrawArea ;

			NS_SetDrawBlendMode( DX_BLENDMODE_SRCCOLOR, 255 ) ;
			NS_SetDrawMode( DX_DRAWMODE_NEAREST ) ;
			NS_SetDrawBright( 255, 255, 255 ) ;
			NS_SetDrawArea( 0, 0, GBASE.DrawSizeX, GBASE.DrawSizeY ) ;

			NS_DrawBaseImage( 0, 0, &ScreenImage ) ;

			NS_SetDrawBlendMode( DrawBlendMode, DrawBlendParam ) ;
			NS_SetDrawMode( DrawMode ) ;
			NS_SetDrawBright( DrawBright.Red, DrawBright.Green, DrawBright.Blue ) ;
			NS_SetDrawArea( DrawArea.left, DrawArea.top, DrawArea.right, DrawArea.bottom ) ;

			NS_ReleaseBaseImage( &ScreenImage ) ;
		}
		else
		{
			D_D3DLOCKED_RECT LockRect ;
			COLORDATA *ColorData ;

			ColorData = GetD3DFormatColorData( TargetFormat ) ;

			// `̃Rs[擾VXeT[tFX쐬
			if( GraphicsDevice_CreateOffscreenPlainSurface(
					Width, Height, TargetFormat, D_D3DPOOL_SYSTEMMEM, &SMSurface, NULL ) != D_D3D_OK )
			{
				DXST_ERRORLOG_ADD( _T( "Paint pVXeT[tFX̍쐬Ɏs܂\n" ) ) ;
				return -1 ;
			}

			// VXeT[tFXɕ`̓e]
			GraphicsDevice_GetRenderTargetData(
				TargetSurface, SMSurface ) ;

			// VXeT[tFXbN
			GraphicsSurface_LockRect( SMSurface, &LockRect, NULL, D_D3DLOCK_READONLY ) ; 

			// Paint p MEMIMG ZbgAbv
			_MEMSET( &MemImg, 0, sizeof( MEMIMG ) ) ;
			InitializeMemImg(
				&MemImg,
				GBASE.DrawSizeX,
				GBASE.DrawSizeY,
				LockRect.Pitch,
				0,
				ColorData->ColorBitDepth == 16 ? 0 : 1,
				FALSE, FALSE, FALSE, LockRect.pBits ) ;

			// Paint s
			PaintMemImg( &MemImg, x, y, FillColor, BoundaryColor ) ;

			// MEMIMG ̌n
			TerminateMemImg( &MemImg ) ;

			// VXeT[tFX̃bN
			GraphicsSurface_UnlockRect( SMSurface ) ;

			// VXeT[tFX̓e`ɓ]
			GraphicsDevice_UpdateSurface(
				SMSurface,     NULL,
				TargetSurface, NULL ) ;

			// VXeT[tFX̉
			Graphics_ObjectRelease( SMSurface ) ;
		}
	}
	else
	{
		MEMIMG *Img ;

		// n[hEGA̋@\gpĂȂꍇ

		if( Image2 )
		{
			Img = &Image2->Soft.MemImg ;
		}
		else
		{
			Img = &GRS.MainBufferMemImg ;
		}

		PaintMemImg( Img, x, y, FillColor, BoundaryColor ) ;
	}
	
	// I
	return 0 ;
}


// EGCg֌W֐

// M҂
extern	int		NS_WaitVSync( int SyncNum )
{
	return GraphicsDevice_WaitVSync( SyncNum ) ;
}

// ʑ֌W֐

#if 0
#define LOGMAX		5000000
int LogNum;
short Log[LOGMAX];
int time ;
LONGLONG Time ;
#endif

// ʂƕ\ʂ
// \ʂʂ̃XP[Ȍꍇ́ACopyRect ̓Rs[` )
extern int ScreenFlipBase( RECT *CopyRect )
{
	static int EndFlag = FALSE ;

	GBASE.ScreenFlipFlag = TRUE ;

	// tOĂȂɂI
	if( EndFlag )
		goto END ;

	// 
	if( DxSysData.DxLib_InitializeFlag == FALSE || DxLib_GetEndRequest() )
		goto ERR ;

	// tXN[}XNsĂꍇ̓}XN`̌ʂ𔽉f
	MASK_FULLSCREEN_MASKUPDATE

#if !defined( DX_NON_LOG ) && !defined( DX_NON_PRINTF_DX )
	// Oo͂sݒ̏ꍇ̂݃Oo͂s
	if( NS_GetLogDrawFlag() )
	{
		int BlendMode, BlendParam, RedBright, GreenBright, BlueBright ;
		RECT DrawRect ;

		BlendMode   = GBASE.BlendMode ;
		BlendParam  = GBASE.BlendParam ;
		DrawRect    = GBASE.DrawArea ;
		RedBright   = GBASE.DrawBright.Red ;
		GreenBright = GBASE.DrawBright.Green ;
		BlueBright  = GBASE.DrawBright.Blue ;

		NS_SetDrawArea( 0, 0, GRA2.MainScreenSizeX, GRA2.MainScreenSizeY ) ;

		// `惂[hm[uhɃZbg
		NS_SetDrawBlendMode( DX_BLENDMODE_NOBLEND, 0 ) ;

		// PxPOOɃZbg
		NS_SetDrawBright( 255,255,255 ) ;

		// tOĂ
		EndFlag = TRUE ;

		// O`
		DrawLog() ;

		// tO|
		EndFlag = FALSE ;

		// ݒɖ߂
		NS_SetDrawArea( DrawRect.left, DrawRect.top, DrawRect.right, DrawRect.bottom ) ; 
		NS_SetDrawBlendMode( BlendMode, BlendParam ) ;
		NS_SetDrawBright( RedBright, GreenBright, BlueBright ) ;
	}
#endif

	// ʂ̓e\ʂɔf
	GraphicsDevice_Present( CopyRect ) ;


END:
	GBASE.ScreenFlipFlag = FALSE ;

	// I
	return 0 ;


ERR:
	GBASE.ScreenFlipFlag = FALSE ;

	// G[I
	return -1;
}

// ʂƕ\ʂ
extern int NS_ScreenFlip( void )
{
	return ScreenFlipBase( NULL ) ;
}

// ʂ̓e\ʂɕ`悷
extern int NS_ScreenCopy( void )
{
	// TuobNobt@̃ZbgAbv
	if( 
#ifdef __WINDOWS__
		NS_GetWindowModeFlag() == FALSE && 
#endif // __WINDOWS__
		GRA2.ValidHardWare == TRUE )
		SetupSubBackBuffer() ;

	// tbv
	return ScreenFlipBase( NULL ) ;
}

#ifdef __WINDOWS__

// ʂ̓ew̃EChEɓ]
extern int NS_BltBackScreenToWindow( HWND Window, int ClientX, int ClientY )
{
	RECT SrcRect, DestRect, WinRect ;

	GetClientRect( Window, &WinRect ) ;

	SrcRect.left   = 0 ;
	SrcRect.top    = 0 ;
	SrcRect.right  = GRA2.MainScreenSizeX ;
	SrcRect.bottom = GRA2.MainScreenSizeY ;

	DestRect.left   = WinRect.left + ClientX ;
	DestRect.top    = WinRect.top  + ClientY ;
	DestRect.right  = WinRect.left + ClientX + GRA2.MainScreenSizeX ;
	DestRect.bottom = WinRect.top  + ClientY + GRA2.MainScreenSizeY ;

	if( DestRect.left < WinRect.left )
	{
		SrcRect.left += WinRect.left - DestRect.left ;
		DestRect.left = WinRect.left ;
	}

	if( DestRect.top < WinRect.top )
	{
		SrcRect.top += WinRect.top - DestRect.top ;
		DestRect.top = WinRect.top ;
	}

	if( DestRect.right > WinRect.right )
	{
		SrcRect.right -= DestRect.right - WinRect.right ;
		DestRect.right = WinRect.right ;
	}

	if( DestRect.bottom > WinRect.bottom )
	{
		SrcRect.bottom -= DestRect.bottom - WinRect.bottom ;
		DestRect.bottom = WinRect.bottom ;
	}

	return NS_BltRectBackScreenToWindow( Window, SrcRect, DestRect ) ;
}

// ʂ̎ẅ̗EChẼNCAg̈̎ẅ̗ɓ]
extern int NS_BltRectBackScreenToWindow( HWND Window, RECT BackScreenRect, RECT WindowClientRect )
{
	// 
	if( DxSysData.DxLib_InitializeFlag == FALSE || DxLib_GetEndRequest() ) return -1 ;

	// tXN[[hł͎gpłȂ
	if( NS_GetWindowModeFlag() == FALSE ) return -1 ;

	// s
	return GraphicsDevice_BltRectBackScreenToWindow( Window, BackScreenRect, WindowClientRect ) ;
}

#endif // __WINDOWS__

// ʃ[h̃Zbg
extern int NS_SetGraphMode( int ScreenSizeX, int ScreenSizeY, int ColorBitDepth, int RefreshRate )
{
	int Width, Height, CDepth, RRate ;

	// G[`FbN
	if( ScreenSizeX <= 0 || ScreenSizeY <= 0 ||
		( ColorBitDepth != 8 && ColorBitDepth != 16 && ColorBitDepth != 32 ) )
		return DX_CHANGESCREEN_RETURN ;

	// Ȍꍇ͐ݒlۑ
	if( DxSysData.DxLib_InitializeFlag == FALSE )
	{
		SetMainScreenSize( ScreenSizeX, ScreenSizeY ) ;
		GRA2.MainScreenColorBitDepth = ColorBitDepth ;
		GRA2.MainScreenRefreshRate = RefreshRate ;
		SetMemImgDefaultColorType( ColorBitDepth == 32 ? 1 : 0 ) ;
		return 0 ;
	}

	// ̒lĂ
	Width	= GRA2.MainScreenSizeX ;
	Height	= GRA2.MainScreenSizeX ;
	CDepth	= GRA2.MainScreenColorBitDepth ;
	RRate	= GRA2.MainScreenRefreshRate ;

	// ʃ[hύX
	ChangeGraphMode( ScreenSizeX, ScreenSizeY, ColorBitDepth, FALSE, RefreshRate ) ;

	// ߂l̃Zbg
	if( ScreenSizeX		== GRA2.MainScreenSizeX &&
		ScreenSizeY		== GRA2.MainScreenSizeY 
#ifdef __WINDOWS__
		&&
		(
		  NS_GetWindowModeFlag() == FALSE ||
		  (
		    NS_GetWindowModeFlag() == TRUE &&
		    ColorBitDepth	== GRA2.MainScreenColorBitDepth &&
		    RefreshRate		== GRA2.MainScreenRefreshRate
		  )
		)
#endif // __WINDOWS__
	  )
	{
		return DX_CHANGESCREEN_OK ;
	}
	else
	{
		if( Width	== GRA2.MainScreenSizeX &&
			Height	== GRA2.MainScreenSizeY &&
			CDepth	== GRA2.MainScreenColorBitDepth &&
			RRate	== GRA2.MainScreenRefreshRate )
		{
			return DX_CHANGESCREEN_RETURN ;
		}
		else
		{
			if( GRA2.MainScreenSizeX == DEFAULT_SCREEN_SIZE_X && 
				GRA2.MainScreenSizeY == DEFAULT_SCREEN_SIZE_Y 
#ifdef __WINDOWS__
				&& 
				(
				  NS_GetWindowModeFlag() == FALSE ||
				  (
					NS_GetWindowModeFlag() == TRUE &&
				    GRA2.MainScreenColorBitDepth == DEFAULT_COLOR_BITDEPTH &&
				    GRA2.MainScreenRefreshRate   == 0
				  )
				)
#endif // __WINDOWS__
			  )
			{
				return DX_CHANGESCREEN_DEFAULT ;
			}
			else
			{
				return -1 ;
			}
		}
	}
}

// Cʂ̂yobt@̐ݒύX
extern int SetZBufferMode( int ZBufferSizeX, int ZBufferSizeY, int ZBufferBitDepth )
{
	HRESULT hr ;
	DX_DIRECT3DSURFACE9 *SetZBuffer ;
	int UseScreenZBuffer = FALSE ;
	int BitIndex ;

	// l̃`FbNƕۑ
	if( ZBufferSizeX > 0 && ZBufferSizeY > 0 )
	{
		for( GRH.ZBufferSizeX = 1 ; GRH.ZBufferSizeX < ZBufferSizeX ; GRH.ZBufferSizeX <<= 1 ){}
		for( GRH.ZBufferSizeY = 1 ; GRH.ZBufferSizeY < ZBufferSizeY ; GRH.ZBufferSizeY <<= 1 ){}
		GRH.UserZBufferSizeSet = TRUE ;
	}
	if( ZBufferBitDepth > 0 )
	{
		if( ZBufferBitDepth != 16 && ZBufferBitDepth != 24 && ZBufferBitDepth != 32 )
		{
			return -1 ;
		}
		GRH.ZBufferBitDepth = ZBufferBitDepth ;
		GRH.UserZBufferBitDepthSet = TRUE ;
	}

	// Ȍꍇ͒lݒ肵ďI
	if( GraphicsDevice_IsValid() == 0 )
		return 0 ;

	// ݐݒ肳Ăyobt@擾
	GraphicsDevice_GetDepthStencilSurface( &SetZBuffer ) ;

	// ʗpyobt@gpĂꍇ͈UO
	if( SetZBuffer == GRH.ZBufferSurface )
	{
		GraphicsDevice_SetDepthStencilSurface( NULL ) ;
		UseScreenZBuffer = TRUE ;
	}
	Graphics_ObjectRelease( SetZBuffer ) ;
	SetZBuffer = NULL ;

	// Zobt@J
	if( GRH.ZBufferSurface )
	{
		Graphics_ObjectRelease( GRH.ZBufferSurface ) ;
		GRH.ZBufferSurface = NULL ;
	}

	// VȂyobt@̍쐬
	switch( GRH.ZBufferBitDepth )
	{
	default:
	case 16 : BitIndex = 0 ; break ;
	case 24 : BitIndex = 1 ; break ;
	case 32 : BitIndex = 2 ; break ;
	}
	hr = GraphicsDevice_CreateDepthStencilSurface( GRH.ZBufferSizeX, GRH.ZBufferSizeY, GRH.ZBufferFormat[ BitIndex ], GRH.FSAAMultiSampleType, GRH.FSAAMultiSampleQuality, TRUE, &GRH.ZBufferSurface, NULL ) ;
	if( FAILED( hr ) )
	{
		DXST_ERRORLOG_ADD( _T( "yobt@̍쐬Ɏs܂\n" ) ) ;
		return -1 ;
	}

	// ʗpyobt@gpĂꍇ͍ăZbg
	if( UseScreenZBuffer )
	{
		GraphicsDevice_SetDepthStencilSurface( GRH.ZBufferSurface ) ;

		// NA
		GraphicsDevice_Clear( 0, NULL, D_D3DCLEAR_ZBUFFER, 0, 1.0f, 0 ) ;
	}

	// I
	return 0 ;
}

// ʗp̂yobt@̃TCYݒ肷
extern int NS_SetZBufferSize( int ZBufferSizeX, int ZBufferSizeY )
{
	return SetZBufferMode( ZBufferSizeX, ZBufferSizeY, -1 ) ;
}

// ʗp̂yobt@̃rbg[xݒ肷( 16 or 24 or 32 )
extern int NS_SetZBufferBitDepth( int BitDepth )
{
	return SetZBufferMode( -1, -1, BitDepth ) ;
}

// ʂ̃tXN[A`GCAX[h̐ݒ
extern int NS_SetFullSceneAntiAliasingMode( int Samples, int Quality )
{
	// ݒł̂͏Ô
	if( DxSysData.DxLib_InitializeFlag == TRUE )
		return 0 ;

	GRH.FSAAMultiSampleType = ( D_D3DMULTISAMPLE_TYPE )Samples ;
	GRH.FSAAMultiSampleQuality = Quality ;

	// I
	return 0 ;
}

// ScreenFlip ɕ\ʑŜɓ]闠ʂ̗̈ݒ肷( DxLib_Init ̑Oł̂ݎgp\ )
extern int NS_SetGraphDisplayArea( int x1, int y1, int x2, int y2 )
{
	// ̏ꍇ͉I
	if( DxSysData.DxLib_InitializeFlag == TRUE )
		return -1 ;

	// p[^`FbN
	if( x1 >= x2 || y1 >= y2 )
	{
		GRA2.ValidGraphDisplayArea = FALSE ;
		return -1 ;
	}

	// p[^ۑ
	GRA2.GraphDisplayArea.left = x1 ;
	GRA2.GraphDisplayArea.right = x2 ;
	GRA2.GraphDisplayArea.top = y1 ;
	GRA2.GraphDisplayArea.bottom = y2 ;

	GRA2.ValidGraphDisplayArea = TRUE ;

	// I
	return 0 ;
}

// ʃ[hύX( ƃEChE[hύX )ɃOtBbNXVXe̐ݒOtBbNnhZbg邩ǂݒ肷( TRUE:Zbg  FALSE:ZbgȂ )
extern int NS_SetChangeScreenModeGraphicsSystemResetFlag( int Flag )
{
	GRA2.ChangeScreenModeNotGraphicsSystemFlag = Flag ? FALSE : TRUE ;

	return 0 ;
}

// w̉𑜓xΉĂ邩ǂ𒲂ׂ֐
static int CheckDisplaySetting( int ScreenSizeX, int ScreenSizeY, int ColorBitDepth )
{
	int Num, i ;
	DISPLAYMODEDATA Mode ;

	Num = NS_GetDisplayModeNum() ;
	for( i = 0 ; i < Num ; i ++ )
	{
		Mode = NS_GetDisplayMode( i ) ;
		if( Mode.Width == ScreenSizeX && Mode.Height == ScreenSizeY && Mode.ColorBitDepth == ColorBitDepth )
			return TRUE ;
	}

	return FALSE ;
}

// ʃ[h̕ύXQ
extern int ChangeGraphMode( int ScreenSizeX, int ScreenSizeY, int ColorBitDepth, int ChangeWindowFlag, int RefreshRate )
{
	int BackScSizeX, BackScSizeY, BackScColorBitDepth, BackRefreshRate ;
	int Ret = DX_CHANGESCREEN_OK ;
	int InitFlag ;
#ifndef DX_NON_FONT
	TCHAR FontName[64] ;
	int FontSize = 0, FontThick = 0 ;
	int FontUse = 0 ;
#endif // DX_NON_FONT
	int Result ;
	int i ;

	// ChangeGraphModestO𗧂Ă
	GRA2.ChangeGraphModeFlag = TRUE ;

	// _|Ă
	RenderVertexHardware() ;

	// ɏς݂ǂ擾Ă
	InitFlag = GRA2.InitializeFlag ;

#ifdef __WINDOWS__
	// tXN[[h 320x240 w̏ꍇ̓G~[V[hɂ
	if( NS_GetWindowModeFlag() == FALSE && ScreenSizeX == 320 && ScreenSizeY == 240 )
	{
		GRH.FullScreenEmulation320x240 = TRUE ;
		ScreenSizeX = 640 ;
		ScreenSizeY = 480 ;
	}
	else
	{
		if( NS_GetWindowModeFlag() == TRUE &&
			ChangeWindowFlag == TRUE &&
			GRH.FullScreenEmulation320x240 == TRUE &&
			GRA2.MainScreenSizeX == 640 &&
			GRA2.MainScreenSizeY == 480 )
		{
			ScreenSizeX = 320 ;
			ScreenSizeY = 240 ;
		}

		if( NS_GetWindowModeFlag() == TRUE ||
			GRA2.MainScreenSizeX != 640 ||
			GRA2.MainScreenSizeY != 480 )
		{
			GRH.FullScreenEmulation320x240 = FALSE ;
		}
	}
#endif // __WINDOWS__

	// -1 ͊̒lőp
	if( ScreenSizeX		== -1 ) ScreenSizeX   = GRA2.MainScreenSizeX ;
	if( ScreenSizeY		== -1 ) ScreenSizeY   = GRA2.MainScreenSizeY ;
	if( ColorBitDepth	== -1 ) ColorBitDepth = GRA2.MainScreenColorBitDepth ;
	if( RefreshRate		== -1 ) RefreshRate   = GRA2.MainScreenRefreshRate ;

	// ȑOƉʃ[hSꍇ͉I
	if( ScreenSizeX      == GRA2.MainScreenSizeX &&
		ScreenSizeY      == GRA2.MainScreenSizeY &&
		ColorBitDepth    == GRA2.MainScreenColorBitDepth &&
		ChangeWindowFlag == FALSE &&
		RefreshRate      == GRA2.MainScreenRefreshRate )
	{
		goto END ;
	}

	DXST_ERRORLOG_ADD( _T( "ʃ[hύXJn܂\n" ) ) ;
	DXST_ERRORLOG_TABADD ;

#ifndef DX_NON_FONT

	// ɏĂtHg̏ƂĂ
	if( InitFlag && NS_CheckFontHandleValid( NS_GetDefaultFontHandle() ) )
	{
		NS_GetFontStateToHandle( FontName, &FontSize, &FontThick, NS_GetDefaultFontHandle() ) ;
		FontUse = TRUE ;
	}

#endif // DX_NON_FONT

	// ̉ʃ[h̃p[^ƂĂ
	BackScSizeX			= GRA2.MainScreenSizeX ; 
	BackScSizeY			= GRA2.MainScreenSizeY ;
	BackScColorBitDepth	= GRA2.MainScreenColorBitDepth ;
	BackRefreshRate		= GRA2.MainScreenRefreshRate ;

	// cwCȕO͎słȂ
	if( DxSysData.DxLib_RunInitializeFlag == FALSE && DxSysData.DxLib_InitializeFlag == FALSE )
		goto END ;

#ifdef __WINDOWS__
	// tXN[[hőΉĂȂʃ[hꍇ͂ŏI
	if( NS_GetWindowModeFlag() == FALSE && CheckDisplaySetting( ScreenSizeX, ScreenSizeY, ColorBitDepth ) == FALSE )
		goto END ;
#endif // __WINDOWS__

	// ʃ[hύXɃOtBbNXVXeZbg邩ǂŏ𕪊
	if( GRA2.ChangeScreenModeNotGraphicsSystemFlag )
	{
		// ZbgȂꍇ

		// w̉ʃ[hɕύXł邩ǂ𒲂ׂ
#ifdef __WINDOWS__
		if( NS_GetWindowModeFlag() == FALSE )
		{
			// tXN[̏ꍇ͎w̉𑜓xΉĂ邩ǂ𒲂ׂ
			if( CheckDisplaySetting( ScreenSizeX, ScreenSizeY, ColorBitDepth ) == FALSE )
			{
				// ΉĂȂʃ[h͕ύXȂ
				goto END ;
			}
		}
		else
		{
			int DesktopW, DesktopH ;

			// EChE[h̏ꍇ͎w̉𑜓xfXNgbṽTCY𒴂ĂȂǂ𒲂ׂ
			NS_GetDefaultState( &DesktopW, &DesktopH, NULL ) ;
			if( DesktopW < ScreenSizeX || DesktopH < ScreenSizeY )
				goto END ;
		}
#endif // __WINDOWS__

		// `FW
		RestoreOrChangeSetupGraphSystem( TRUE, ScreenSizeX, ScreenSizeY, ColorBitDepth, RefreshRate ) ;

#ifdef __WINDOWS__
		// EChEX^CZbg
		if( NS_GetWindowModeFlag() == TRUE /*|| GRA2.ValidHardWare == FALSE*/ )
		{
			SetWindowStyle() ;
		}
#endif // __WINDOWS__

		DXST_ERRORLOG_TABSUB ;
		DXST_ERRORLOG_ADD( _T( "ʃ[hύX͐ɏI܂\n" ) ) ;
	}
	else
	{
		// Zbgꍇ

		// OtBNXVXȅI
		if( GRA2.InitializeFlag )
		{
			TerminateGraphics2() ;
		}

		// ʃ[h̃Zbg
		SetMainScreenSize( ScreenSizeX, ScreenSizeY ) ;
		GRA2.MainScreenColorBitDepth = ColorBitDepth ;
		GRA2.MainScreenRefreshRate   = RefreshRate ;
		SetMemImgDefaultColorType( ColorBitDepth == 32 ? 1 : 0 ) ;

		// OtBbNVXe̍ď
		Result = InitializeGraphics2() ;

		// sꍇ̏
		if( Result == -1 )
		{
			// G[ꍇŉʃ[h 320x240 ꍇ
			// [ 320x240 [hŎ
			if( GRA2.MainScreenSizeX == 320 && GRA2.MainScreenSizeY == 240 )
			{
				SetMainScreenSize( 640, 480 ) ;
				NS_SetEmulation320x240( TRUE ) ;
				Result = InitializeGraphics2() ;
			}

			// G[ꍇ͌̉ʃ[hɖ߂
			if( Result == -1 )
			{
				SetMainScreenSize( BackScSizeX, BackScSizeY ) ;
				GRA2.MainScreenColorBitDepth = BackScColorBitDepth ;
				GRA2.MainScreenRefreshRate   = BackRefreshRate ;
				SetMemImgDefaultColorType( BackScColorBitDepth == 32 ? 1 : 0 ) ;
				if( InitializeGraphics2() == -1 )
				{
					// łʖڂꍇ͂cwCũftHg̉ʃ[hɕύX
					SetMainScreenSize( DEFAULT_SCREEN_SIZE_X, DEFAULT_SCREEN_SIZE_Y ) ;
					GRA2.MainScreenColorBitDepth = DEFAULT_COLOR_BITDEPTH ;
					GRA2.MainScreenRefreshRate   = 0 ;
					SetMemImgDefaultColorType( 0 ) ;
					if( InitializeGraphics2() == -1 )
					{
						// łʖڂꍇ640x480 32bit 
						SetMainScreenSize( DEFAULT_SCREEN_SIZE_X, DEFAULT_SCREEN_SIZE_Y ) ;
						GRA2.MainScreenColorBitDepth = 32 ;
						GRA2.MainScreenRefreshRate   = 0 ;
						SetMemImgDefaultColorType( 0 ) ;
						if( InitializeGraphics2() == -1 )
						{
							Ret = -1 ;
							DxLib_Error( DXSTRING( _T( "\ʉʃ[hύXs\ۂN܂2\n" ) ) ) ;
							goto END ;
						}
					}
				}
			}
		}

#ifdef __WINDOWS__
		// EChEX^CZbg
		if( NS_GetWindowModeFlag() == TRUE /*|| GRA2.ValidHardWare == FALSE*/ )
		{
			SetWindowStyle() ;
		}
#endif // __WINDOWS__

#ifndef DX_NON_FONT
		// tHg̏
		if( FontUse == TRUE )
		{
			NS_SetDefaultFontState( FontName, FontSize, FontThick ) ;
		}
#endif // DX_NON_FONT

		DXST_ERRORLOG_TABSUB ;
		DXST_ERRORLOG_ADD( _T( "ʃ[hύX͐ɏI܂\n" ) ) ;

		// bZ[W
		NS_ProcessMessage() ;

		// `̐ݒ肵Ȃ
		NS_SetRenderTargetToShader( 0, GBASE.TargetScreen[ 0 ], GBASE.TargetScreenSurface[ 0 ] ) ;
		for( i = 1 ; i < GRH.RenderTargetNum ; i ++ )
		{
			NS_SetRenderTargetToShader( i, -1 ) ;
		}
	}

#ifdef __WINDOWS__
	// hbOhbv̐ݒ
	RefreshDragFileValidFlag() ;
#endif // __WINDOWS__

END:
	// ChangeGraphMode stO|
	GRA2.ChangeGraphModeFlag = FALSE ;

	// I
	return Ret ;
}

extern	int		SetD3DDialogBoxMode( int Flag )
{
	HRESULT hr ;

	if( GraphicsDevice_IsValid() == 0 ) return 0 ;
	EndScene() ;
	hr = GraphicsDevice_SetDialogBoxMode( Flag ) ;

	return 0 ;
}

#ifndef DX_NON_MODEL

// w̃VF[_[ZbgAbv( TRUE:  FALSE:s )
extern int SetupShader( int VertexShaderIndex, int VertexShaderIndex_SM3, int PixelShaderIndex, int PixelShaderIndex_SM3 )
{
	int ValidSM3 ;
//	int Time = NS_GetNowCount() ;

	if( 0 )
//	if( Time % 1000 < 500 )
	{
		GRH.UseShader = FALSE ;
		GRH.ValidTexTempRegFlag = FALSE ;
		return FALSE ;
	}
/*	else
	{
		GRH.UseShader = TRUE ;
	}
*/

	// VF[_gȂꍇ͎s
	if( GRH.UseShader == FALSE )
		return FALSE ;

	ValidSM3 = GRH.ValidVertexShader_SM3 &&
		VS_GET_TOONOUTLINE( VertexShaderIndex ) == 0 &&
		VS_GET_LIGHTUSE( VertexShaderIndex ) != 0 &&
		( ( void ** )GRA2.DefaultVertexShaderAddress_SM3 )[ VertexShaderIndex_SM3 ] != NULL &&

		GRH.ValidPixelShader_SM3 &&
		PS_GET_LIGHTUSE( PixelShaderIndex ) != 0 &&
		( ( void ** )GRA2.DefaultPixelShaderAddress_SM3 )[ PixelShaderIndex_SM3 ] != NULL ;

	if( ( GRH.UseOnlyShaderModel3Code || GRH.UseShaderModel3 ) && ValidSM3 )
	{
SHADER_MODEL_3:

		if( VertexShaderIndex >= 0 )
		{
			// VF[_[邩ǂ𒲂ׂ
			if( ( ( DX_DIRECT3DVERTEXSHADER9 ** )GRH.DefaultVertexShader_SM3 )[ VertexShaderIndex_SM3 ] == NULL )
			{
				// VF[_[̍쐬݂
				if( GraphicsDevice_CreateVertexShader( ( ( DWORD ** )GRA2.DefaultVertexShaderAddress_SM3 )[ VertexShaderIndex_SM3 ], &( ( DX_DIRECT3DVERTEXSHADER9 ** )GRH.DefaultVertexShader_SM3 )[ VertexShaderIndex_SM3 ] ) != D_D3D_OK )
					return FALSE ;
			}

			// o[ebNXVF[_[̃ZbgAbv
			if( GRH.SetVS != ( ( DX_DIRECT3DVERTEXSHADER9 ** )GRH.DefaultVertexShader_SM3 )[ VertexShaderIndex_SM3 ] )
			{
				GRH.SetVS = ( ( DX_DIRECT3DVERTEXSHADER9 ** )GRH.DefaultVertexShader_SM3 )[ VertexShaderIndex_SM3 ] ;
				GraphicsDevice_SetVertexShader( GRH.SetVS ) ;
				GRH.DrawPrepAlwaysFlag = TRUE ;
			}
		}

		if( PixelShaderIndex >= 0 )
		{
			// VF[_[邩ǂ𒲂ׂ
			if( ( ( DX_DIRECT3DPIXELSHADER9 ** )GRH.DefaultPixelShader_SM3 )[ PixelShaderIndex_SM3 ] == NULL )
			{
				// VF[_[̍쐬݂
				if( GraphicsDevice_CreatePixelShader( ( ( DWORD ** )GRA2.DefaultPixelShaderAddress_SM3 )[ PixelShaderIndex_SM3 ], &( ( DX_DIRECT3DPIXELSHADER9 ** )GRH.DefaultPixelShader_SM3 )[ PixelShaderIndex_SM3 ] ) != D_D3D_OK )
					return FALSE ;
			}

			// sNZVF[_[̃ZbgAbv
			if( GRH.SetPS != ( ( DX_DIRECT3DPIXELSHADER9 ** )GRH.DefaultPixelShader_SM3 )[ PixelShaderIndex_SM3 ] )
			{
				GRH.SetPS = ( ( DX_DIRECT3DPIXELSHADER9 ** )GRH.DefaultPixelShader_SM3 )[ PixelShaderIndex_SM3 ] ;
				GraphicsDevice_SetPixelShader( GRH.SetPS ) ;
				GRH.NormalPS = FALSE ;
				GRH.DrawPrepAlwaysFlag = TRUE ;
			}
		}
	}
	else
	{
		if( VertexShaderIndex >= 0 )
		{
			// VF[_[邩ǂ𒲂ׂ
			if( ( ( DX_DIRECT3DVERTEXSHADER9 ** )GRH.DefaultVertexShader )[ VertexShaderIndex ] == NULL )
			{
				// VF[_[̍쐬݂
				if( ( ( void ** )GRA2.DefaultVertexShaderAddress )[ VertexShaderIndex ] == NULL ||
					GraphicsDevice_CreateVertexShader( ( ( DWORD ** )GRA2.DefaultVertexShaderAddress )[ VertexShaderIndex ], &( ( DX_DIRECT3DVERTEXSHADER9 ** )GRH.DefaultVertexShader )[ VertexShaderIndex ] ) != D_D3D_OK )
				{
					if( ValidSM3 )
					{
						goto SHADER_MODEL_3 ;
					}
					return FALSE ;
				}
			}

			// o[ebNXVF[_[̃ZbgAbv
		#ifdef DXLIB_DEBUG
			GraphicsDevice_SetVertexShader( MV1Man.VS_Test ) ;
			GRH.SetVS = MV1Man.VS_Test ;

			if( GRH.SetVD != MV1Man.VertexDeclaration[ 1 ][ 0 ][ 1 ] )
			{
				GRH.SetVD = MV1Man.VertexDeclaration[ 1 ][ 0 ][ 1 ] ;
				GraphicsDevice_SetVertexDeclaration( GRH.SetVD ) ;
			}
		#else
			if( GRH.SetVS != ( ( DX_DIRECT3DVERTEXSHADER9 ** )GRH.DefaultVertexShader )[ VertexShaderIndex ] )
			{
				GRH.SetVS = ( ( DX_DIRECT3DVERTEXSHADER9 ** )GRH.DefaultVertexShader )[ VertexShaderIndex ] ;
				GraphicsDevice_SetVertexShader( GRH.SetVS ) ;
				GRH.DrawPrepAlwaysFlag = TRUE ;
			}
		#endif
		}

		if( PixelShaderIndex >= 0 )
		{
			// VF[_[邩ǂ𒲂ׂ
			if( ( ( DX_DIRECT3DPIXELSHADER9 ** )GRH.DefaultPixelShader )[ PixelShaderIndex ] == NULL )
			{
				// VF[_[̍쐬݂
				if( ( ( void ** )GRA2.DefaultPixelShaderAddress )[ PixelShaderIndex ] == NULL ||
					GraphicsDevice_CreatePixelShader( ( ( DWORD ** )GRA2.DefaultPixelShaderAddress )[ PixelShaderIndex ], &( ( DX_DIRECT3DPIXELSHADER9 ** )GRH.DefaultPixelShader )[ PixelShaderIndex ] ) != D_D3D_OK )
				{
					if( ValidSM3 )
					{
						goto SHADER_MODEL_3 ;
					}

					return FALSE ;
				}
			}

			// sNZVF[_[̃ZbgAbv
		#ifdef DXLIB_DEBUG
			GraphicsDevice_SetPixelShader( MV1Man.PS_Test ) ;
			GRH.SetPS = MV1Man.PS_Test ;
		#else
			if( GRH.SetPS != ( ( DX_DIRECT3DPIXELSHADER9 ** )GRH.DefaultPixelShader )[ PixelShaderIndex ] )
			{
				GRH.SetPS = ( ( DX_DIRECT3DPIXELSHADER9 ** )GRH.DefaultPixelShader )[ PixelShaderIndex ] ;
				GraphicsDevice_SetPixelShader( GRH.SetPS ) ;
				GRH.NormalPS = FALSE ;
				GRH.DrawPrepAlwaysFlag = TRUE ;
			}
		#endif
		}
	}

	// I
	return TRUE ;
}

// w̒_f[^`ZbgAbv
extern	int		SetupVertexDeclaration( int BumpMap, int SkinMesh, int UVNum )
{
	if( GRH.SetVD != GRH.DefaultVertexDeclaration[ BumpMap ][ SkinMesh ][ UVNum ] )
	{
		GRH.SetVD = GRH.DefaultVertexDeclaration[ BumpMap ][ SkinMesh ][ UVNum ] ;
		GraphicsDevice_SetVertexDeclaration( GRH.SetVD ) ;
		GRH.SetFVF = 0 ;
	}

	// I
	return 0 ;
}

#endif // DX_NON_MODEL

// w̒_VF[_[foCXɃZbg
extern int SetDeviceVertexShaderToHandle( int ShaderHandle )
{
	SHADERHANDLEDATA *VertexShader ;

	// nh`FbN
	if( SHADERCHK( ShaderHandle, VertexShader ) )
		return -1 ;
	if( VertexShader->IsVertexShader == FALSE )
		return -1 ;

	// VF[_[̃Zbg
	if( GRH.SetVS != VertexShader->VertexShader && GRH.InitializeFlag == FALSE )
	{
		GRH.SetVS = VertexShader->VertexShader ;
		GraphicsDevice_SetVertexShader( GRH.SetVS ) ;
		GRH.DrawPrepAlwaysFlag = TRUE ;
	}

	// I
	return 0 ;
}

// w̃sNZVF[_[foCXɃZbg
extern int SetDevicePixelShaderToHandle( int ShaderHandle )
{
	SHADERHANDLEDATA *PixelShader ;

	// nh`FbN
	if( SHADERCHK( ShaderHandle, PixelShader ) )
		return -1 ;
	if( PixelShader->IsVertexShader != FALSE )
		return -1 ;

	// VF[_[̃Zbg
	if( GRH.SetPS != PixelShader->PixelShader && GRH.InitializeFlag == FALSE )
	{
		GRH.SetPS = PixelShader->PixelShader ;
		GraphicsDevice_SetPixelShader( GRH.SetPS ) ;
		GRH.NormalPS = FALSE ;
		GRH.DrawPrepAlwaysFlag = TRUE ;
	}

	// I
	return 0 ;
}


// (⏕֐)C[W`ɂȂĂXN[ɏo͂A摜ƃXN[̑傫͓łȂ΂ȂȂ
extern	int		MemImgScreenOut( MEMIMG * /*MemImg*/ )
{
	// I
	return 0 ;
}

// ʉ摜ۑ֐

#ifndef DX_NON_SAVEFUNCTION

// ݕ`ΏۂɂȂĂʂalo`ŕۑ
extern int NS_SaveDrawScreenToBMP( int x1, int y1, int x2, int y2, const TCHAR *FileName )
{
	return NS_SaveDrawScreen( x1, y1, x2, y2, FileName, DX_IMAGESAVETYPE_BMP );
}

// ݕ`ΏۂɂȂĂʂiodf`ŕۑ Quality = 掿Al傫قǒሳk掿,0`100 
extern int NS_SaveDrawScreenToJPEG( int x1, int y1, int x2, int y2, const TCHAR *FileName, int Quality, int Sample2x1 )
{
	return NS_SaveDrawScreen( x1, y1, x2, y2, FileName, DX_IMAGESAVETYPE_JPEG, Quality, Sample2x1 );
}

// ݕ`ΏۂɂȂĂʂomf`ŕۑ CompressionLevel = kAl傫قǍkׁAO͖k,0`9
extern int NS_SaveDrawScreenToPNG( int x1, int y1, int x2, int y2, const TCHAR *FileName, int CompressionLevel )
{
	return NS_SaveDrawScreen( x1, y1, x2, y2, FileName, DX_IMAGESAVETYPE_PNG, 80, CompressionLevel );
}

// Jpeg_Quality         = 0:掿`100:掿
// Png_CompressionLevel = 0:k`  9:ōk
// ݕ`ΏۂɂȂĂʂۑ
extern int NS_SaveDrawScreen( int x1, int y1, int x2, int y2, const TCHAR *FileName, int SaveType, int Jpeg_Quality, int Jpeg_Sample2x1, int Png_CompressionLevel )
{
	IMAGEDATA2 *Image2 ;
	BASEIMAGE BaseImage;
	DX_DIRECT3DSURFACE9 *TargetSurface, *SMSurface = NULL, *VMSurface ;
	D_D3DFORMAT TargetFormat ;
	D_D3DLOCKED_RECT LockRect ;
	int Width, Height ;

	// G[
	if( GRAPHCHKFULL( GBASE.TargetScreen[ 0 ], Image2 ) )
		Image2 = NULL ;

	// [
	_MEMSET( &BaseImage, 0, sizeof( BASEIMAGE ) ) ;

	// TCYsȏꍇ͉ɏI
	if( x1 >= x2 || y1 >= y2 || x1 < 0 || y1 < 0 || x2 > GBASE.DrawSizeX || y2 > GBASE.DrawSizeY ) return -1 ;

	// TCỸZbg
	BaseImage.Width = x2 - x1 ;
	BaseImage.Height = y2 - y1 ;
	BaseImage.MipMapCount = 0 ;
	BaseImage.GraphDataCount = 0 ;

	// n[hEFAgpĂ邩ǂŏ𕪊
	if( GRA2.ValidHardWare )
	{
		// n[hEGA̋@\gpĂꍇ

		if( GraphicsDevice_IsValid() == 0 ) return -1 ;

		// `IĂ
		RenderVertexHardware() ;
		EndScene() ;

		// `ɂď𕪊
		if( Image2 )
		{
			// `悪`\T[tFX̏ꍇ
			TargetSurface = Image2->Orig->Hard.Tex[ 0 ].RenderTargetSurface ?
							Image2->Orig->Hard.Tex[ 0 ].RenderTargetSurface :
			Image2->Orig->Hard.Tex[ 0 ].Surface[ GBASE.TargetScreenSurface[ 0 ] ] ;
			TargetFormat = GRH.TextureFormat[ Image2->Orig->ColorFormat ] ;
			Width = Image2->Orig->Hard.Tex[ 0 ].TexWidth ;
			Height = Image2->Orig->Hard.Tex[ 0 ].TexHeight ;
		}
		else
		{
			// `悪TuobNobt@̓obNobt@̏ꍇ
			TargetSurface = GRH.SubBackBufferSurface ? GRH.SubBackBufferSurface : GRH.BackBufferSurface ; 
			TargetFormat = GRH.ScreenFormat ;
			Width = GRA2.MainScreenSizeX ;
			Height = GRA2.MainScreenSizeY ;
		}
		BaseImage.ColorData = *GetD3DFormatColorData( TargetFormat ) ;

		// `̃Rs[擾VXeT[tFX쐬
		if( GraphicsDevice_CreateOffscreenPlainSurface(
				Width, Height, TargetFormat, D_D3DPOOL_SYSTEMMEM, &SMSurface, NULL ) != D_D3D_OK )
		{
			DXST_ERRORLOG_ADD( _T( "SaveDrawScreen pVXeT[tFX̍쐬Ɏs܂\n" ) ) ;
			return -1 ;
		}

		// VXeT[tFXɕ`̓e]
		if( GraphicsDevice_GetRenderTargetData(	TargetSurface, SMSurface ) != D_D3D_OK )
		{
			// ڃVXeւ̓]Ɏsꍇ̓ItXN[T[tFXăVXeT[tFXɓ]
			GraphicsDevice_CreateRenderTarget_ASync( Width, Height, TargetFormat, D_D3DMULTISAMPLE_NONE, 0, FALSE, &VMSurface, NULL, FALSE ) ;
			if( VMSurface != NULL )
			{
				GraphicsDevice_StretchRect( TargetSurface, NULL, VMSurface, NULL, D_D3DTEXF_NONE ) ;
				GraphicsDevice_GetRenderTargetData(	VMSurface, SMSurface ) ;
				Graphics_ObjectRelease( VMSurface ) ;
				VMSurface = NULL ;
			}
		}

		// VXeT[tFXbN
		GraphicsSurface_LockRect( SMSurface, &LockRect, NULL, D_D3DLOCK_READONLY ) ; 

		// AhXƃsb`̃Zbg
		BaseImage.GraphData = ( BYTE * )LockRect.pBits + LockRect.Pitch * y1 + x1 * BaseImage.ColorData.PixelByte ;
		BaseImage.Pitch = LockRect.Pitch ;
	}
	else
	{
		MEMIMG *Img ;

		// n[hEGA̋@\gpĂȂꍇ

		// `ɂď𕪊
		if( Image2 )
		{
			Img = &Image2->Soft.MemImg ;
		}
		else
		{
			Img = &GRS.MainBufferMemImg ;
		}

		BaseImage.ColorData = *Img->Base->ColorDataP ;
		BaseImage.Pitch = Img->Base->Pitch ;
		BaseImage.GraphData = ( char * )Img->UseImage + Img->Base->Pitch * y1 + Img->Base->ColorDataP->PixelByte * x1 ;
	}

	// ۑ`ɂďύX
	switch( SaveType )
	{
	case DX_IMAGESAVETYPE_JPEG:
#ifndef DX_NON_JPEGREAD
		NS_SaveBaseImageToJpeg( FileName, &BaseImage, Jpeg_Quality, Jpeg_Sample2x1 );
#endif
		break;

	case DX_IMAGESAVETYPE_PNG:
#ifndef DX_NON_PNGREAD
		NS_SaveBaseImageToPng( FileName, &BaseImage, Png_CompressionLevel );
#endif
		break;

	case DX_IMAGESAVETYPE_BMP:	// Bitmap 
		NS_SaveBaseImageToBmp( FileName, &BaseImage ) ;
		break ;
	}

	// n

	// n[hEGA@\gpĂ邩ǂŏ𕪊
	if( GRA2.ValidHardWare )
	{
		// n[hEGA̋@\gpĂꍇ

		// VXeT[tFX̃bN
		GraphicsSurface_UnlockRect( SMSurface ) ;

		// VXeT[tFX̉
		Graphics_ObjectRelease( SMSurface ) ;
	}
	else
	{
		// n[hEGA̋@\gpĂȂꍇ
	}

	// I
	return 0 ;
}

#endif // DX_NON_SAVEFUNCTION

























// ݒ֌W

// gp̂cRccXIuWFNg𓾂
extern	const DX_DIRECT3DDEVICE9* NS_GetUseDirect3DDevice9( void )
{
	return ( DX_DIRECT3DDEVICE9* )GraphicsDevice_GetObject() ;
}

// gp̃obNobt@Direct3DSurface9IuWFNg擾
extern const DX_DIRECT3DSURFACE9* NS_GetUseDirect3D9BackBufferSurface( void )
{
	return GRH.BackBufferSurface ;
}

// cwCûcRcݒȂ
extern int NS_RefreshDxLibDirect3DSetting( void )
{
	RefreshRenderStateHardware() ;

	// tO𗧂Ă
	GRH.InitializeFlag = TRUE ;

	SetDrawBlendModeHardware( GRH.BlendMode, GRH.AlphaTestValidFlag, GRH.AlphaChannelValidFlag ) ;

	// tO|
	GRH.InitializeFlag = FALSE ;

	// I
	return 0 ;
}


// _obt@ɗ܂_f[^fo
extern int NS_RenderVertex( void )
{
	return RenderVertexHardware() ;
}

// KvȂOtBbN̕sAtÕZbg
extern	int		NS_SetUseDivGraphFlag( int Flag ) 
{
	GRH.NotUseDivFlag = !Flag ;

	// I
	return 0 ;
}

// gpeNX`[̍őTCYZbg(0ŃftHg)
extern	int		NS_SetUseMaxTextureSize( int Size )
{
	int i ;

	if( Size == 0 )
	{
		GRH.UserMaxTextureSize = 0 ;
		return 0 ;
	}
	
	// w̃TCY܂ŏ̂Q̂̃TCY߂
	for( i = MIN_TEXTURE_SIZE ; i < Size ; i <<= 1 ){}

	// őTCY傫␳
	if( Size > GRH.MaxTextureSize ) Size = GRH.MaxTextureSize ; 
	
	// lZbg
	GRH.UserMaxTextureSize = i ;
	
	// I
	return 0 ;
}

// Direct3DDevice9->DrawIndexedPrimitive ̃bsO֐
extern int D_DrawIndexedPrimitive( void *VertexBuffer9, DWORD VertexStride, DWORD FVFFlag, void *IndexBuffer9, int PrimitiveType, int BaseVertexIndex, DWORD MinIndex, DWORD NumVertices, DWORD StartIndex, DWORD PrimitiveCount )
{
	if( GraphicsDevice_IsValid() == 0 ) return 0 ;

	GraphicsDevice_SetStreamSource( 0, ( DX_DIRECT3DVERTEXBUFFER9 * )VertexBuffer9, 0, VertexStride ) ;
	GraphicsDevice_SetIndices( ( DX_DIRECT3DINDEXBUFFER9 * )IndexBuffer9 ) ;
	SETFVF( FVFFlag )
	GraphicsDevice_DrawIndexedPrimitive( ( D_D3DPRIMITIVETYPE )PrimitiveType, BaseVertexIndex, MinIndex, NumVertices, StartIndex, PrimitiveCount ) ;

	// I
	return 0 ;
}

// Direct3DDevice9->DrawIndexedPrimitiveUP ̃bsO֐
extern int D_DrawIndexedPrimitiveUP( DWORD FVFFlag, int PrimitiveType, DWORD MinVertexIndex, DWORD NumVertexIndices, DWORD PrimitiveCount, void *pIndexData, D_D3DFORMAT IndexDataFormat, void *pVertexStreamZeroData, DWORD VertexStreamZeroStride )
{
	if( GraphicsDevice_IsValid() == 0 ) return 0 ;

	SETFVF( FVFFlag )
	GraphicsDevice_DrawIndexedPrimitiveUP( ( D_D3DPRIMITIVETYPE )PrimitiveType, MinVertexIndex, NumVertexIndices, PrimitiveCount, pIndexData, IndexDataFormat, pVertexStreamZeroData, VertexStreamZeroStride ) ;

	// I
	return 0 ;
}

// {f[^ɐݒ肳Ăsn[hEGAɔf
extern void ApplyLibMatrixToHardware()
{
	if( GBASE.MatchHardwareMatrix == TRUE ) return ;

	if( GBASE.MatchHardwareWorldMatrix == FALSE )
	{
		SetTransformToWorldHardware( &GBASE.WorldMatrix ) ;
		GBASE.MatchHardwareWorldMatrix = TRUE ;
	}

	if( GBASE.MatchHardwareViewMatrix == FALSE )
	{
		SetTransformToViewHardware( &GBASE.ViewMatrix ) ;
		GBASE.MatchHardwareViewMatrix = TRUE ;
	}

	if( GBASE.MatchHardwareProjectionMatrix == FALSE )
	{
		SetTransformToProjectionHardware( &GBASE.ProjectionMatrix ) ;
		GBASE.MatchHardwareProjectionMatrix = TRUE ;
	}

	GBASE.MatchHardwareMatrix = TRUE ;
}

// {f[^ɐݒ肳ĂtHOn[hEGAɔf
extern void ApplyLigFogToHardware( void )
{
	if( GRH.FogEnable != GBASE.FogEnable ) SetFogEnableHardware( GBASE.FogEnable ) ;
}

// `揀s( ParamFlag  DRAWPREP_TRANS  )
extern	void	_DrawPreparation( int GrHandle, int ParamFlag )
{
	IMAGEDATA2 *Image2 ;

	if( GrHandle == DX_NONE_GRAPH )
	{
		DRAWPREP_NOTEX( ParamFlag );
	}
	else
	{
		if( GRAPHCHK( GrHandle, Image2 ) )
			return;

		// eNX`ł͂ȂG[
		if( Image2->Orig->FormatDesc.TextureFlag == FALSE ) return ;

		// eNX`Zbg
		DRAWPREP_TEX( Image2->Orig, Image2->Hard.Draw[ 0 ].Tex->Texture, ParamFlag )
	}
}


// ȑO DrawModiGraph ֐̃R[hgp邩ǂ̃tOZbg
extern int NS_SetUseOldDrawModiGraphCodeFlag( int Flag )
{
	GRH.UseOldDrawModiGraphCodeFlag = Flag ;
	
	// I
	return 0 ;
}

// suh̐ݒ肷( DrawGraph ȂǂĂԑO 0 ɂČĂяoȂƂ̌̕`悪ɍsȂȂ܂ )
extern int D_SetVertexBlend( int WeightNum )
{
	if( GraphicsDevice_IsValid() == 0 ) return 0 ;

	// obt@ɂ܂_o
	RenderVertexHardware() ;

	// ݒ̕ύX
	GraphicsDevice_SetRenderState( D_D3DRS_VERTEXBLEND, ( D_D3DVERTEXBLENDFLAGS )WeightNum ) ;

	// I
	return 0 ;
}




// CgLɂ邩ǂZbg
extern int D_SetLightEnable( int Flag )
{
	return SetUseLightFlagHardware( Flag ) ;
}

// Cg̃p[^Zbg
extern int D_SetLightParam( int No, int EnableFlag, LIGHTPARAM *Param )
{
	if( GraphicsDevice_IsValid() == 0 ) return 0 ;

	// ݒ̕ύX
	if( EnableFlag == TRUE )
	{
		SetLightHardware( No, ( LIGHT * )Param ) ;
	}
	SetLightEnableHardware( No, EnableFlag ) ;

	// I
	return 0 ;
}

// ArGgCgݒ肷
extern int D_SetAmbientLight( int r, int g, int b )
{
	return SetAmbientColorHardware( D_RGBA_MAKE( r, g, b, 0 ) ) ;
}

// XyLgp邩ǂݒ肷
extern int D_SetUseSpecular( int UseFlag )
{
	return SetUseSpecularHardware( UseFlag ) ;
}

// }eAp[^Zbg
extern int D_SetMaterial( MATERIALPARAM *Param )
{
	return SetMaterialHardware( ( MATERIAL * )Param ) ;
}

// _fBt[YJ[}eÃfBt[YJ[ƂĎgp邩ǂݒ肷
extern int D_SetMaterialUseVertexDiffuseColor( int UseFlag )
{
	return SetMaterialUseVertexDiffuseColorHardware( UseFlag ) ;
}

// _XyLJ[}eÃXyLJ[ƂĎgp邩ǂݒ肷
extern int D_SetMaterialUseVertexSpecularColor( int UseFlag )
{
	return SetMaterialUseVertexSpecularColorHardware( UseFlag ) ;
}

// VF[h[hZbg
extern int D_SetShadeMode( int ShadeMode )
{
	return SetShadeModeHardware( ShadeMode ) ;
}

// VF[h[h擾
extern int D_GetShadeMode( void )
{
	return GRH.ShadeMode ;
}

// eNX`tB^O[hݒ肷
extern int D_SetSampleFilterMode( int TexStage, int SetTarget, DX_D3DTEXFILTER_TYPE FilterType )
{
	if( GraphicsDevice_IsValid() == 0 ) return 0 ;
	if( TexStage < 0 || TexStage >= 8 ) return 0 ;

	GRH.DrawMode = DX_DRAWMODE_OTHER ;
	GRH.DrawPrepAlwaysFlag = TRUE ;
	switch( SetTarget )
	{
	case DX_D3DSAMP_MAGFILTER :
		if( GRH.MagFilter[ TexStage ] != FilterType )
		{
			GraphicsDevice_SetSamplerState( TexStage, D_D3DSAMP_MAGFILTER, FilterType ) ;
			GRH.MagFilter[ TexStage ] = FilterType ;
		}
		break ;

	case DX_D3DSAMP_MINFILTER :
		if( GRH.MinFilter[ TexStage ] != FilterType )
		{
			GraphicsDevice_SetSamplerState( TexStage, D_D3DSAMP_MINFILTER, FilterType ) ;
			GRH.MinFilter[ TexStage ] = FilterType ;
		}
		break ;

	case DX_D3DSAMP_MIPFILTER :
		if( GRH.MipFilter[ TexStage ] != FilterType )
		{
			GraphicsDevice_SetSamplerState( TexStage, D_D3DSAMP_MIPFILTER, FilterType ) ;
			GRH.MipFilter[ TexStage ] = FilterType ;
		}
		break ;
	}

	// I
	return 0 ;
}

// őٕZbg
extern int D_SetMaxAnisotropy( int TexStage, int MaxAnisotropy )
{
	if( GraphicsDevice_IsValid() == 0 ) return 0 ;
	if( TexStage < 0 || TexStage >= 8 ) return 0 ;

	if( GRH.MaxAnisotropyDim[ TexStage ] != MaxAnisotropy )
	{
		GraphicsDevice_SetSamplerState( TexStage, D_D3DSAMP_MAXANISOTROPY, MaxAnisotropy ) ;
		GRH.MaxAnisotropyDim[ TexStage ] = MaxAnisotropy ;
	}
	GRH.MaxAnisotropy = -1 ;
	GRH.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// eNX`tB^O[h擾
extern	DX_D3DTEXFILTER_TYPE D_GetSampleFilterMode( int TexStage, int SetTarget )
{
	if( GraphicsDevice_IsValid() == 0 ) return ( DX_D3DTEXFILTER_TYPE )0 ;
	if( TexStage < 0 || TexStage >= 8 ) return ( DX_D3DTEXFILTER_TYPE )0 ;

	switch( SetTarget )
	{
	case DX_D3DSAMP_MAGFILTER : return GRH.MagFilter[ TexStage ] ;
	case DX_D3DSAMP_MINFILTER : return GRH.MinFilter[ TexStage ] ;
	case DX_D3DSAMP_MIPFILTER : return GRH.MipFilter[ TexStage ] ;
	}

	// I
	return ( DX_D3DTEXFILTER_TYPE )0 ;
}

// |SJO̗LAZbg
extern	int D_SetUseCullingFlag( int Flag )
{
	return SetUseCullingHardware( Flag ) ;
}

// _J[gp邩ǂ̐ݒn[hɔf
extern	int D_SetupUseVertColor( void )
{
	// _J[}eÃJ[ƂĎgp邩ǂZbg
	if( ( GBASE.Light.MaterialNotUseVertexDiffuseColor ? FALSE : TRUE ) != GRH.MaterialUseVertexDiffuseColor )
		SetMaterialUseVertexDiffuseColorHardware( GBASE.Light.MaterialNotUseVertexDiffuseColor ? FALSE : TRUE ) ;
	if( ( GBASE.Light.MaterialNotUseVertexSpecularColor ? FALSE : TRUE ) != GRH.MaterialUseVertexSpecularColor )
		SetMaterialUseVertexSpecularColorHardware( GBASE.Light.MaterialNotUseVertexSpecularColor ? FALSE : TRUE ) ;

	// I
	return 0 ;
}

// Rc`p̂yobt@ݒn[hɔf
extern	int D_SetupZBuffer3D( void )
{
	if( GBASE.EnableZBufferFlag3D )
	{
		if( GRH.EnableZBufferFlag != GBASE.EnableZBufferFlag3D ) SetUseZBufferHardware(     GBASE.EnableZBufferFlag3D ) ;
		if( GRH.WriteZBufferFlag  != GBASE.WriteZBufferFlag3D  ) SetWriteZBufferHardware(   GBASE.WriteZBufferFlag3D  ) ;
		if( GRH.ZBufferCmpType    != GBASE.ZBufferCmpType3D    ) SetZBufferCmpTypeHardware( GBASE.ZBufferCmpType3D    ) ;
		if( GRH.ZBias             != GBASE.ZBias3D             ) SetZBiasHardware(          GBASE.ZBias3D             ) ;
	}
	else
	{
		if( GRH.EnableZBufferFlag ) SetUseZBufferHardware( FALSE ) ;
	}

	// I
	return 0 ;
}

// yobt@Lɂ邩AtOZbg
extern	int D_SetUseZBufferFlag( int Flag )
{
	return SetUseZBufferHardware( Flag ) ;
}

// yobt@ɏ݂sAtOZbg
extern	int D_SetWriteZBufferFlag( int Flag )
{
	return SetWriteZBufferHardware( Flag ) ;
}

// `掞̃At@eXg̃[hZbg
extern	int D_SetDrawAlphaTest( int TestMode, int TestParam )
{
	return SetDrawAlphaTestHardware( TestMode, TestParam ) ;
}

// yl̔r[hZbg
extern	int D_SetZBufferCmpType( int CmpType /* DX_CMP_NEVER  */ )
{
	return SetZBufferCmpTypeHardware( CmpType ) ;
}

// yoCAXZbg
extern	int	D_SetZBias( int Bias )
{
	return SetZBiasHardware( Bias ) ;
}

// tB[hZbg
extern	int	D_SetFillMode( int FillMode )
{
	return SetFillModeHardware( FillMode ) ;
}

// eNX`AhX[hݒ肷
extern int D_SetTextureAddressMode( int Mode /* DX_TEXADDRESS_WRAP  */, int Stage )
{
	return SetTextureAddressHardware( Mode, Stage ) ;
}

// eNX`AhX[hݒ肷
extern int D_SetTextureAddressModeUVW( int ModeU, int ModeV, int ModeW, int Stage )
{
	SetTextureAddressUHardware( ModeU, Stage ) ;
	SetTextureAddressVHardware( ModeV, Stage ) ;
	return SetTextureAddressWHardware( ModeW, Stage ) ;
}

// eNX`WϊsZbg
extern int D_SetTextureAddressTransformMatrix( int Use, MATRIX *Matrix, int Stage )
{
	GRH.TextureTransformMatrixDirectChange = TRUE ;
	GRH.DrawPrepAlwaysFlag = TRUE ;
	return SetTextureAddressTransformMatrixHardware( Use, Matrix, Stage ) ;
}

// [J[hsύX
extern int D_SetTransformToWorld( MATRIX *Matrix )
{
	SetTransformToWorldHardware( Matrix ) ;
	GBASE.MatchHardwareWorldMatrix = FALSE ;
	GBASE.MatchHardwareMatrix = FALSE ;

	// I
	return 0 ;
}

// r[ϊpsZbg
extern int D_SetTransformToView( MATRIX *Matrix )
{
	SetTransformToViewHardware( Matrix ) ;
	GBASE.MatchHardwareViewMatrix = FALSE ;
	GBASE.MatchHardwareMatrix = FALSE ;

	// I
	return 0 ;
}

// eϊpsZbg
extern int D_SetTransformToProjection( const MATRIX *Matrix )
{
	SetTransformToProjectionHardware( Matrix ) ;
	GBASE.MatchHardwareProjectionMatrix = FALSE ;
	GBASE.MatchHardwareMatrix = FALSE ;

	// I
	return 0 ;
}

// [U[̃uhCtHK
extern int D_SetUserBlendInfo( DIRECT3DBLENDINFO *BlendInfo, int TextureStageIsTextureAndTextureCoordOnlyFlag, int TextureIsGraphHandleFlag )
{
	RenderVertexHardware() ;

	RefreshBlendStateHardware( BlendInfo, TextureStageIsTextureAndTextureCoordOnlyFlag, TextureIsGraphHandleFlag ) ;
	GRH.ChangeBlendParamFlag = TRUE ;
	GRH.ChangeTextureFlag = TRUE ;
	GRH.DrawPrepAlwaysFlag = TRUE ;

	// I
	return 0 ;
}

// eXe[WgpeNX`AhXXe[WԍƓɂ
extern int D_ResetTextureCoord( void )
{
	int i ;
	DIRECT3DTEXTURESTAGEINFO *Stage ;

	Stage = GRH.BlendInfo.TextureStageInfo ;
	for( i = 0 ; i < USE_TEXTURESTAGE_NUM ; i ++, Stage ++ )
	{
		if( Stage->TextureCoordIndex != i || GRH.InitializeFlag )
		{
			GraphicsDevice_SetTextureStageState( i, D_D3DTSS_TEXCOORDINDEX, i ) ;
			Stage->TextureCoordIndex = i ;
		}
	}

	// I
	return 0 ;
}


// ̑⏕֐

// J[f[^𓾂
extern const COLORDATA * NS_GetTexColorData( int AlphaCh, int AlphaTest, int ColorBitDepth, int DrawValid )
{
	IMAGEFORMATDESC Format ;
	
	Format.DrawValidFlag = ( unsigned char )DrawValid ;
	Format.AlphaChFlag = ( unsigned char )AlphaCh ;
	Format.AlphaTestFlag = ( unsigned char )AlphaTest ;
	Format.ColorBitDepth = ColorBitDepth == TEX_BITDEPTH_16 ? 16 : 32 ;
	Format.ChannelNum = 0 ;
	Format.ChannelBitDepth = 0 ;
	Format.FloatTypeFlag = FALSE ;
	Format.BaseFormat = DX_BASEIMAGE_FORMAT_NORMAL ;
	return NS_GetTexColorData( &Format ) ;
}

// tH[}bgɊÂJ[f[^𓾂
extern const COLORDATA * NS_GetTexColorData( const IMAGEFORMATDESC *Format )
{
	const COLORDATA * Result ;

	Result = NS_GetTexColorData( NS_GetTexFormatIndex( Format ) ) ;

	return Result ;
}

// w̃tH[}bgCfbNX̃J[f[^𓾂
extern const COLORDATA * NS_GetTexColorData( int FormatIndex )
{
	static int Initialize = FALSE ;
	static COLORDATA ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_NUM ] ;

	// l͈͊OG[
	if( FormatIndex >= DX_GRAPHICSIMAGE_FORMAT_3D_NUM ) return NULL ;

	// ŏɗƂɏ
	if( Initialize == FALSE )
	{
		Initialize = TRUE ;

		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_RGB16                 ],  16, 0x0000f800, 0x000007e0, 0x0000001f, 0x00000000 ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_RGB32                 ],  32, 0x00ff0000, 0x0000ff00, 0x000000ff, 0x00000000 ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHA_RGB16           ],  16, 0x00000f00, 0x000000f0, 0x0000000f, 0x0000f000 ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHA_RGB32           ],  32, 0x00ff0000, 0x0000ff00, 0x000000ff, 0xff000000 ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHATEST_RGB16       ],  16, 0x00007c00, 0x000003e0, 0x0000001f, 0x00008000 ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_ALPHATEST_RGB32       ],  32, 0x00ff0000, 0x0000ff00, 0x000000ff, 0xff000000 ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT1                  ],  32, 0x00ff0000, 0x0000ff00, 0x000000ff, 0xff000000 ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT2                  ],  32, 0x00ff0000, 0x0000ff00, 0x000000ff, 0xff000000 ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT3                  ],  32, 0x00ff0000, 0x0000ff00, 0x000000ff, 0xff000000 ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT4                  ],  32, 0x00ff0000, 0x0000ff00, 0x000000ff, 0xff000000 ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT5                  ],  32, 0x00ff0000, 0x0000ff00, 0x000000ff, 0xff000000 ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_RGB16       ],  16, 0x0000f800, 0x000007e0, 0x0000001f, 0x00000000 ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_RGB32       ],  32, 0x00ff0000, 0x0000ff00, 0x000000ff, 0x00000000 ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ALPHA_RGB32 ],  32, 0x00ff0000, 0x0000ff00, 0x000000ff, 0xff000000 ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_I16    ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 4, 16, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_F16    ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 4, 16, TRUE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ABGR_F16    ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 4, 32, TRUE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I8      ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1,  8, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_I16     ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1, 16, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F16     ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1, 16, TRUE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_ONE_F32     ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 1, 32, TRUE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I8      ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 2,  8, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_I16     ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 2, 16, FALSE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F16     ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 2, 16, TRUE ) ;
		NS_CreateColorData( &ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DRAWVALID_TWO_F32     ],   0, 0x00000000, 0x00000000, 0x00000000, 0x00000000, 2, 32, TRUE ) ;

		ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT1 ].Format = DX_BASEIMAGE_FORMAT_DXT1 ; ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT1 ].ColorBitDepth = 4 ;
		ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT2 ].Format = DX_BASEIMAGE_FORMAT_DXT2 ; ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT2 ].ColorBitDepth = 8 ;
		ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT3 ].Format = DX_BASEIMAGE_FORMAT_DXT3 ; ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT3 ].ColorBitDepth = 8 ;
		ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT4 ].Format = DX_BASEIMAGE_FORMAT_DXT4 ; ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT4 ].ColorBitDepth = 8 ;
		ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT5 ].Format = DX_BASEIMAGE_FORMAT_DXT5 ; ColorData[ DX_GRAPHICSIMAGE_FORMAT_3D_DXT5 ].ColorBitDepth = 8 ;
	}

	// J[tH[}bgԂ
	return &ColorData[ FormatIndex ] ;
}

#ifndef DX_NON_MOVIE

// [r[OtBbN֌W֐
// t@C̍Đ
extern	int		NS_PlayMovie( const TCHAR *FileName, int ExRate, int PlayType )
{
	int MovieHandle ;
	LOADGRAPH_GPARAM GParam ;
	int x1, y1, x2, y2, w, h ;
	int DrawScreen ;
	int DrawScreenSurface ;
#ifndef DX_NON_INPUT
	int KeyOffFlag ;
	int State ;
#endif // DX_NON_INPUT
	int ScreenW, ScreenH ;

	InitLoadGraphGParam( &GParam ) ;

	MovieHandle = LoadBmpToGraph_UseGParam( &GParam, FALSE, -1, FileName, FALSE, FALSE, DX_MOVIESURFACE_NORMAL, FALSE ) ;
	if( MovieHandle < 0 )
		return -1 ;

#ifndef DX_NON_INPUT
	KeyOffFlag = NS_CheckHitKeyAll() ;
#endif // DX_NON_INPUT
	if( MovieHandle != -1 )
	{
		NS_PlayMovieToGraph( MovieHandle ) ;

		NS_GetDrawScreenSize( &ScreenW, &ScreenH ) ;
		NS_GetGraphSize( MovieHandle, &w, &h ) ;
		x1 = ( ScreenW - w * ExRate ) >> 1 ;
		y1 = ( ScreenH - h * ExRate ) >> 1 ;

		x2 = x1 + w * ExRate ;
		y2 = y1 + h * ExRate ;

		DrawScreen = GBASE.TargetScreen[ 0 ] ;
		DrawScreenSurface = GBASE.TargetScreenSurface[ 0 ] ;

		NS_SetDrawScreen( DX_SCREEN_BACK ) ;
		NS_ClearDrawScreen() ;

		while( NS_GetMovieStateToGraph( MovieHandle ) == 1 )
		{
//			NS_DrawBox( 0,0,32,32, GetColor( 255,255,255 ), TRUE ) ;
			NS_DrawExtendGraph( x1, y1, x2, y2, MovieHandle, FALSE ) ;

			NS_ScreenFlip() ;

#ifndef DX_NON_INPUT
			State = NS_CheckHitKeyAll() ;
			if( State == FALSE ) 
			{
				KeyOffFlag = FALSE ;
			}
#endif // DX_NON_INPUT

			if( ProcessMessage() != 0 
#ifndef DX_NON_INPUT
				|| ( PlayType == DX_MOVIEPLAYTYPE_BCANCEL && GetActiveFlag() && State && KeyOffFlag == FALSE )
#endif // DX_NON_INPUT
				) break ;
		}
		NS_DeleteGraph( MovieHandle ) ;

		NS_SetRenderTargetToShader( 0, DrawScreen, DrawScreenSurface ) ;
	}

	// I
	return 0;
}

// [r[J
extern	int		NS_OpenMovieToGraph( const TCHAR *FileName, int FullColor )
{
	return NS_LoadBmpToGraph( FileName, FALSE, FALSE, FullColor ? DX_MOVIESURFACE_FULLCOLOR : DX_MOVIESURFACE_NORMAL );
}

// [r[OtBbNɊ܂܂郀[r[̍ĐJn
extern 	int		NS_PlayMovieToGraph( int GraphHandle, int PlayType, int SysPlay  )
{
	IMAGEDATA2 *Image2 ;

	if( GRAPHCHK( GraphHandle, Image2 ) )
		return -1 ;

	if( Image2->MovieHandle < 0 ) return  0 ;

	return PlayMovie_( Image2->MovieHandle, PlayType, SysPlay ) ;
}

// [r[OtBbNɊ܂܂郀[r[̍ĐXgbv
extern 	int		NS_PauseMovieToGraph( int GraphHandle, int SysPause  )
{
	IMAGEDATA2 *Image2 ;

	if( GRAPHCHK( GraphHandle, Image2 ) )
		return -1 ;

	if( Image2->MovieHandle < 0 ) return  0 ;

	return PauseMovie( Image2->MovieHandle, SysPause ) ;
}

// [r[̃t[i߂A߂Ƃ͏oȂ( [r[~ԂŁA Ogg Theora ̂ݗL )
extern	int		NS_AddMovieFrameToGraph( int GraphHandle, unsigned int FrameNum )
{
	IMAGEDATA2 *Image2 ;

	if( GRAPHCHK( GraphHandle, Image2 ) )
		return -1 ;

	if( Image2->MovieHandle < 0 ) return 0 ;

	return AddMovieFrame( Image2->MovieHandle, FrameNum ) ;
}

// [r[̍Đʒuݒ肷(~bP)
extern	int		NS_SeekMovieToGraph( int GraphHandle, int Time )
{
	IMAGEDATA2 *Image2 ;

	if( GRAPHCHK( GraphHandle, Image2 ) )
		return -1 ;

	if( Image2->MovieHandle < 0 ) return 0 ;

	return SeekMovie( Image2->MovieHandle, Time ) ;
}

// [r[̍ĐԂ𓾂
extern 	int		NS_GetMovieStateToGraph( int GraphHandle )
{
	IMAGEDATA2 *Image2 ;

	if( GRAPHCHK( GraphHandle, Image2 ) )
		return -1 ;

	if( Image2->MovieHandle < 0 ) return 0 ;

	return GetMovieState( Image2->MovieHandle ) ;
}

// [r[̃{[Zbg(0`10000)
extern	int		NS_SetMovieVolumeToGraph( int Volume, int GraphHandle )	
{
	IMAGEDATA2 *Image2 ;

	if( GRAPHCHK( GraphHandle, Image2 ) )
		return -1 ;

	if( Image2->MovieHandle < 0 ) return 0 ;

	return SetMovieVolume( Volume, Image2->MovieHandle ) ;
}

// [r[̃{[Zbg(0`255)
extern	int		NS_ChangeMovieVolumeToGraph( int Volume, int GraphHandle )
{
	IMAGEDATA2 *Image2 ;
	int temp ;

	if( GRAPHCHK( GraphHandle, Image2 ) )
		return -1 ;

	if( Image2->MovieHandle < 0 ) return 0 ;

	if( Volume < 0 )
	{
		Volume = 0 ;
	}
	else
	if( Volume > 255 )
	{
		Volume = 255 ;
	}

	if( Volume == 0 )
	{
		temp = 0 ;
	}
	else
	{
		if( DX_DirectSoundData.OldVolumeTypeFlag )
		{
			temp = _DTOL( _LOG10( Volume / 255.0f ) * 10.0 * 100.0 ) + 10000;
		}
		else
		{
			temp = _DTOL( _LOG10( Volume / 255.0f ) * 50.0 * 100.0 ) + 10000;
		}
	}

	return SetMovieVolume( temp, Image2->MovieHandle ) ;
}

// [r[̊{C[Wf[^擾
extern	const BASEIMAGE *NS_GetMovieBaseImageToGraph( int GraphHandle, int *ImageUpdateFlag )
{
	IMAGEDATA2 *Image2 ;

	if( GRAPHCHK( GraphHandle, Image2 ) )
		return NULL ;

	if( Image2->MovieHandle < 0 ) return  NULL ;

	return GetMovieBaseImage( Image2->MovieHandle, ImageUpdateFlag ) ;
}

// [r[̑t[𓾂( Ogg Theora ł̂ݗL )
extern	int		NS_GetMovieTotalFrameToGraph( int GraphHandle )
{
	IMAGEDATA2 *Image2 ;

	if( GRAPHCHK( GraphHandle, Image2 ) )
		return -1 ;

	if( Image2->MovieHandle < 0 ) return 0 ;

	return GetMovieTotalFrame( Image2->MovieHandle ) ;
}

// [r[̍Đʒu擾(~bP)
extern	int		NS_TellMovieToGraph( int GraphHandle )
{
	IMAGEDATA2 *Image2 ;

	if( GRAPHCHK( GraphHandle, Image2 ) )
		return -1 ;

	if( Image2->MovieHandle < 0 ) return  0 ;

	return TellMovie( Image2->MovieHandle ) ;
}

// [r[̍Đʒu擾(t[P)
extern	int		NS_TellMovieToGraphToFrame( int GraphHandle )
{
	IMAGEDATA2 *Image2 ;

	if( GRAPHCHK( GraphHandle, Image2 ) )
		return -1 ;

	if( Image2->MovieHandle < 0 ) return  0 ;

	return TellMovieToFrame( Image2->MovieHandle ) ;
}

// [r[̍Đʒuݒ肷(t[P)
extern	int		NS_SeekMovieToGraphToFrame( int GraphHandle, int Frame )
{
	IMAGEDATA2 *Image2 ;

	if( GRAPHCHK( GraphHandle, Image2 ) )
		return -1 ;

	if( Image2->MovieHandle < 0 ) return  0 ;

	return SeekMovieToFrame( Image2->MovieHandle, Frame ) ;
}

// [r[̂Pt[̎Ԃ𓾂
extern	LONGLONG NS_GetOneFrameTimeMovieToGraph( int GraphHandle )
{
	IMAGEDATA2 *Image2 ;

	if( GRAPHCHK( GraphHandle, Image2 ) )
		return -1 ;

	if( Image2->MovieHandle < 0 ) return  0 ;

	return GetOneFrameTimeMovie( Image2->MovieHandle ) ;
}

// [r[̃C[WŌɍXVԂ𓾂(~bP)
extern int NS_GetLastUpdateTimeMovieToGraph( int GraphHandle )
{
	IMAGEDATA2 *Image2 ;
	MOVIEGRAPH *Movie ;

	if( GRAPHCHK( GraphHandle, Image2 ) )
		return -1 ;

	if( Image2->MovieHandle < 0 ) return  -1 ;

	Movie = GetMovieData( Image2->MovieHandle ) ;
	if( Movie == NULL ) return -1 ;

	return Movie->RefreshTime ;
}


#endif


}


